/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AMDGPU target                          *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 132;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(6),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s64,
  GILLT_p1s64,
  GILLT_p2s32,
  GILLT_p3s32,
  GILLT_p4s64,
  GILLT_p5s32,
  GILLT_p6s32,
  GILLT_s1,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v3s32,
  GILLT_v3s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v5s32,
  GILLT_v6s32,
  GILLT_v7s32,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v9s32,
  GILLT_v10s32,
  GILLT_v11s32,
  GILLT_v12s32,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v16s64,
  GILLT_v32s16,
  GILLT_v32s32,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 64),
  LLT::pointer(1, 64),
  LLT::pointer(2, 32),
  LLT::pointer(3, 32),
  LLT::pointer(4, 64),
  LLT::pointer(5, 32),
  LLT::pointer(6, 32),
  LLT::scalar(1),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(3), 32),
  LLT::vector(ElementCount::getFixed(3), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(5), 32),
  LLT::vector(ElementCount::getFixed(6), 32),
  LLT::vector(ElementCount::getFixed(7), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(9), 32),
  LLT::vector(ElementCount::getFixed(10), 32),
  LLT::vector(ElementCount::getFixed(11), 32),
  LLT::vector(ElementCount::getFixed(12), 32),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(16), 64),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(32), 32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_FalsePredicateBit = 117,
  Feature_isGFX6Bit = 50,
  Feature_isGFX6GFX7Bit = 8,
  Feature_isGFX6GFX7GFX10Bit = 115,
  Feature_isGFX7OnlyBit = 88,
  Feature_isGFX7GFX8GFX9Bit = 45,
  Feature_isGFX6GFX7GFX8GFX9Bit = 67,
  Feature_isGFX6GFX7GFX8GFX9GFX10Bit = 128,
  Feature_isNotGFX12PlusBit = 19,
  Feature_isGFX8GFX9GFX10GFX11Bit = 21,
  Feature_isGFX7PlusBit = 13,
  Feature_isGFX8PlusBit = 4,
  Feature_isGFX8OnlyBit = 22,
  Feature_isGFX9PlusBit = 0,
  Feature_isNotGFX9PlusBit = 56,
  Feature_isGFX90APlusBit = 38,
  Feature_isNotGFX90APlusBit = 23,
  Feature_isGFX908orGFX90ABit = 39,
  Feature_isGFX940PlusBit = 40,
  Feature_isNotGFX940PlusBit = 51,
  Feature_HasGFX950InstsBit = 28,
  Feature_isGFX8GFX9Bit = 15,
  Feature_isGFX10OnlyBit = 63,
  Feature_isGFX10PlusBit = 5,
  Feature_isGFX9GFX10Bit = 57,
  Feature_isGFX11OnlyBit = 64,
  Feature_isGFX11PlusBit = 1,
  Feature_isGFX12OnlyBit = 65,
  Feature_isGFX12PlusBit = 3,
  Feature_HasMinimum3Maximum3F32Bit = 20,
  Feature_HasMinimum3Maximum3F16Bit = 25,
  Feature_HasMinimum3Maximum3PKF16Bit = 83,
  Feature_HasFlatAddressSpaceBit = 90,
  Feature_HasFlatBufferGlobalAtomicFaddF64InstBit = 106,
  Feature_HasAtomicFMinFMaxF32GlobalInstsBit = 100,
  Feature_HasAtomicFMinFMaxF64GlobalInstsBit = 105,
  Feature_HasAtomicFMinFMaxF32FlatInstsBit = 96,
  Feature_HasAtomicFMinFMaxF64FlatInstsBit = 97,
  Feature_HasLdsAtomicAddF64Bit = 131,
  Feature_HasFlatGlobalInstsBit = 91,
  Feature_HasFlatScratchInstsBit = 94,
  Feature_HasD16LoadStoreBit = 99,
  Feature_HasFlatScratchSVSModeBit = 95,
  Feature_HasGFX10_BEncodingBit = 49,
  Feature_HasUnpackedD16VMemBit = 111,
  Feature_HasPackedD16VMemBit = 112,
  Feature_HasUnrestrictedSOffsetBit = 110,
  Feature_D16PreservesUnusedBitsBit = 92,
  Feature_LDSRequiresM0InitBit = 124,
  Feature_NotLDSRequiresM0InitBit = 125,
  Feature_HasExportInstsBit = 7,
  Feature_HasLDSFPAtomicAddF32Bit = 130,
  Feature_HasAddNoCarryInstsBit = 66,
  Feature_NotHasAddNoCarryInstsBit = 122,
  Feature_HasXNACKEnabledBit = 87,
  Feature_Has16BitInstsBit = 9,
  Feature_HasTrue16BitInstsBit = 58,
  Feature_NotHasTrue16BitInstsBit = 10,
  Feature_UseRealTrue16InstsBit = 11,
  Feature_UseFakeTrue16InstsBit = 12,
  Feature_HasBF16ConversionInstsBit = 78,
  Feature_HasVOP3PInstsBit = 80,
  Feature_HasMed3_16Bit = 123,
  Feature_HasMinMaxDenormModesBit = 116,
  Feature_NotHasMinMaxDenormModesBit = 118,
  Feature_HasSDWABit = 62,
  Feature_HasPackedFP32OpsBit = 43,
  Feature_HasImageInstsBit = 6,
  Feature_HasIntClampBit = 73,
  Feature_HasMadMixInstsBit = 81,
  Feature_HasScalarStoresBit = 46,
  Feature_has16BankLDSBit = 52,
  Feature_has32BankLDSBit = 24,
  Feature_HasFmaMixInstsBit = 84,
  Feature_HasDLInstsBit = 16,
  Feature_HasFmacF64InstBit = 121,
  Feature_HasDot1InstsBit = 35,
  Feature_HasDot2InstsBit = 32,
  Feature_HasDot3InstsBit = 72,
  Feature_HasDot4InstsBit = 71,
  Feature_HasDot5InstsBit = 68,
  Feature_HasDot6InstsBit = 70,
  Feature_HasDot7InstsBit = 34,
  Feature_HasDot8InstsBit = 85,
  Feature_HasDot9InstsBit = 29,
  Feature_HasDot10InstsBit = 33,
  Feature_HasDot11InstsBit = 86,
  Feature_HasDot12InstsBit = 36,
  Feature_HasDot13InstsBit = 69,
  Feature_HasGetWaveIdInstBit = 48,
  Feature_HasMAIInstsBit = 37,
  Feature_HasSMemRealTimeBit = 47,
  Feature_HasSMemTimeInstBit = 44,
  Feature_HasShaderCyclesRegisterBit = 89,
  Feature_HasShaderCyclesHiLoRegistersBit = 55,
  Feature_HasFP8InstsBit = 42,
  Feature_HasFP8ConversionInstsBit = 60,
  Feature_HasMadMacF32InstsBit = 17,
  Feature_HasFmaLegacy32Bit = 18,
  Feature_HasAtomicDsPkAdd16InstsBit = 129,
  Feature_HasAtomicFlatPkAdd16InstsBit = 108,
  Feature_HasAtomicFaddRtnInstsBit = 103,
  Feature_HasAtomicFaddNoRtnInstsBit = 101,
  Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit = 102,
  Feature_HasAtomicBufferGlobalPkAddF16InstsBit = 104,
  Feature_HasAtomicGlobalPkAddBF16InstBit = 109,
  Feature_HasAtomicBufferPkAddBF16InstBit = 113,
  Feature_HasFlatAtomicFaddF32InstBit = 107,
  Feature_EnableFlatScratchBit = 93,
  Feature_DisableFlatScratchBit = 114,
  Feature_HasUnalignedAccessModeBit = 126,
  Feature_HasMADIntraFwdBugBit = 75,
  Feature_HasNotMADIntraFwdBugBit = 74,
  Feature_HasSALUFloatInstsBit = 2,
  Feature_HasPseudoScalarTransBit = 30,
  Feature_HasBitOp3InstsBit = 77,
  Feature_HasPrngInstBit = 14,
  Feature_HasFP6BF6ConversionScaleInstsBit = 26,
  Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit = 27,
  Feature_HasCvtPkF16F32InstBit = 76,
  Feature_HasF32ToF16BF16ConversionSRInstsBit = 79,
  Feature_HasGDSBit = 127,
  Feature_HasCvtFP8VOP1BugBit = 59,
  Feature_HasNoCvtFP8VOP1BugBit = 61,
  Feature_HasAtomicCSubNoRtnInstsBit = 98,
  Feature_HasXF32InstsBit = 41,
  Feature_HasAshrPkInstsBit = 31,
  Feature_FP16DenormalsBit = 120,
  Feature_FP64DenormalsBit = 119,
  Feature_NoFP32DenormalsBit = 82,
  Feature_isWave32Bit = 53,
  Feature_isWave64Bit = 54,
};

PredicateBitset AMDGPUInstructionSelector::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (false)
    Features.set(Feature_FalsePredicateBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS)
    Features.set(Feature_isGFX6Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX6GFX7Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7OnlyBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX6GFX7GFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::SOUTHERN_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::SEA_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX6GFX7GFX8GFX9GFX10Bit);
  if (Subtarget->getGeneration() <= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isNotGFX12PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX8GFX9GFX10GFX11Bit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::SEA_ISLANDS)
    Features.set(Feature_isGFX7PlusBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8PlusBit);
  if (Subtarget->getGeneration() ==AMDGPUSubtarget::VOLCANIC_ISLANDS)
    Features.set(Feature_isGFX8OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX9PlusBit);
  if (Subtarget->getGeneration() < AMDGPUSubtarget::GFX9)
    Features.set(Feature_isNotGFX9PlusBit);
  if (Subtarget->hasGFX90AInsts())
    Features.set(Feature_isGFX90APlusBit);
  if (!Subtarget->hasGFX90AInsts())
    Features.set(Feature_isNotGFX90APlusBit);
  if (Subtarget->hasMAIInsts() && !Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX908orGFX90ABit);
  if (Subtarget->hasGFX940Insts())
    Features.set(Feature_isGFX940PlusBit);
  if (!Subtarget->hasGFX940Insts())
    Features.set(Feature_isNotGFX940PlusBit);
  if (Subtarget->hasGFX950Insts())
    Features.set(Feature_HasGFX950InstsBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::VOLCANIC_ISLANDS ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX9)
    Features.set(Feature_isGFX8GFX9Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX10PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX9 ||Subtarget->getGeneration() == AMDGPUSubtarget::GFX10)
    Features.set(Feature_isGFX9GFX10Bit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX11)
    Features.set(Feature_isGFX11PlusBit);
  if (Subtarget->getGeneration() == AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12OnlyBit);
  if (Subtarget->getGeneration() >= AMDGPUSubtarget::GFX12)
    Features.set(Feature_isGFX12PlusBit);
  if (Subtarget->hasMinimum3Maximum3F32())
    Features.set(Feature_HasMinimum3Maximum3F32Bit);
  if (Subtarget->hasMinimum3Maximum3F16())
    Features.set(Feature_HasMinimum3Maximum3F16Bit);
  if (Subtarget->hasMinimum3Maximum3PKF16())
    Features.set(Feature_HasMinimum3Maximum3PKF16Bit);
  if (Subtarget->hasFlatAddressSpace())
    Features.set(Feature_HasFlatAddressSpaceBit);
  if (Subtarget->hasFlatBufferGlobalAtomicFaddF64Inst())
    Features.set(Feature_HasFlatBufferGlobalAtomicFaddF64InstBit);
  if (Subtarget->hasAtomicFMinFMaxF32GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64GlobalInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64GlobalInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF32FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF32FlatInstsBit);
  if (Subtarget->hasAtomicFMinFMaxF64FlatInsts())
    Features.set(Feature_HasAtomicFMinFMaxF64FlatInstsBit);
  if (Subtarget->hasLdsAtomicAddF64())
    Features.set(Feature_HasLdsAtomicAddF64Bit);
  if (Subtarget->hasFlatGlobalInsts())
    Features.set(Feature_HasFlatGlobalInstsBit);
  if (Subtarget->hasFlatScratchInsts())
    Features.set(Feature_HasFlatScratchInstsBit);
  if (Subtarget->hasD16LoadStore())
    Features.set(Feature_HasD16LoadStoreBit);
  if (Subtarget->hasFlatScratchSVSMode())
    Features.set(Feature_HasFlatScratchSVSModeBit);
  if (Subtarget->hasGFX10_BEncoding())
    Features.set(Feature_HasGFX10_BEncodingBit);
  if (Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasUnpackedD16VMemBit);
  if (!Subtarget->hasUnpackedD16VMem())
    Features.set(Feature_HasPackedD16VMemBit);
  if (!Subtarget->hasRestrictedSOffset())
    Features.set(Feature_HasUnrestrictedSOffsetBit);
  if (Subtarget->d16PreservesUnusedBits())
    Features.set(Feature_D16PreservesUnusedBitsBit);
  if (Subtarget->ldsRequiresM0Init())
    Features.set(Feature_LDSRequiresM0InitBit);
  if (!Subtarget->ldsRequiresM0Init())
    Features.set(Feature_NotLDSRequiresM0InitBit);
  if (Subtarget->hasExportInsts())
    Features.set(Feature_HasExportInstsBit);
  if (Subtarget->hasLDSFPAtomicAddF32())
    Features.set(Feature_HasLDSFPAtomicAddF32Bit);
  if (Subtarget->hasAddNoCarry())
    Features.set(Feature_HasAddNoCarryInstsBit);
  if (!Subtarget->hasAddNoCarry())
    Features.set(Feature_NotHasAddNoCarryInstsBit);
  if (Subtarget->isXNACKEnabled())
    Features.set(Feature_HasXNACKEnabledBit);
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (Subtarget->hasTrue16BitInsts())
    Features.set(Feature_HasTrue16BitInstsBit);
  if (!Subtarget->hasTrue16BitInsts())
    Features.set(Feature_NotHasTrue16BitInstsBit);
  if (Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseRealTrue16InstsBit);
  if (Subtarget->hasTrue16BitInsts() && !Subtarget->useRealTrue16Insts())
    Features.set(Feature_UseFakeTrue16InstsBit);
  if (Subtarget->hasBF16ConversionInsts())
    Features.set(Feature_HasBF16ConversionInstsBit);
  if (Subtarget->hasVOP3PInsts())
    Features.set(Feature_HasVOP3PInstsBit);
  if (Subtarget->hasMed3_16())
    Features.set(Feature_HasMed3_16Bit);
  if (Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_HasMinMaxDenormModesBit);
  if (!Subtarget->supportsMinMaxDenormModes())
    Features.set(Feature_NotHasMinMaxDenormModesBit);
  if (Subtarget->hasSDWA())
    Features.set(Feature_HasSDWABit);
  if (Subtarget->hasPackedFP32Ops())
    Features.set(Feature_HasPackedFP32OpsBit);
  if (Subtarget->hasImageInsts())
    Features.set(Feature_HasImageInstsBit);
  if (Subtarget->hasIntClamp())
    Features.set(Feature_HasIntClampBit);
  if (Subtarget->hasMadMixInsts())
    Features.set(Feature_HasMadMixInstsBit);
  if (Subtarget->hasScalarStores())
    Features.set(Feature_HasScalarStoresBit);
  if (Subtarget->getLDSBankCount() == 16)
    Features.set(Feature_has16BankLDSBit);
  if (Subtarget->getLDSBankCount() == 32)
    Features.set(Feature_has32BankLDSBit);
  if (Subtarget->hasFmaMixInsts())
    Features.set(Feature_HasFmaMixInstsBit);
  if (Subtarget->hasDLInsts())
    Features.set(Feature_HasDLInstsBit);
  if (Subtarget->hasFmacF64Inst())
    Features.set(Feature_HasFmacF64InstBit);
  if (Subtarget->hasDot1Insts())
    Features.set(Feature_HasDot1InstsBit);
  if (Subtarget->hasDot2Insts())
    Features.set(Feature_HasDot2InstsBit);
  if (Subtarget->hasDot3Insts())
    Features.set(Feature_HasDot3InstsBit);
  if (Subtarget->hasDot4Insts())
    Features.set(Feature_HasDot4InstsBit);
  if (Subtarget->hasDot5Insts())
    Features.set(Feature_HasDot5InstsBit);
  if (Subtarget->hasDot6Insts())
    Features.set(Feature_HasDot6InstsBit);
  if (Subtarget->hasDot7Insts())
    Features.set(Feature_HasDot7InstsBit);
  if (Subtarget->hasDot8Insts())
    Features.set(Feature_HasDot8InstsBit);
  if (Subtarget->hasDot9Insts())
    Features.set(Feature_HasDot9InstsBit);
  if (Subtarget->hasDot10Insts())
    Features.set(Feature_HasDot10InstsBit);
  if (Subtarget->hasDot11Insts())
    Features.set(Feature_HasDot11InstsBit);
  if (Subtarget->hasDot12Insts())
    Features.set(Feature_HasDot12InstsBit);
  if (Subtarget->hasDot13Insts())
    Features.set(Feature_HasDot13InstsBit);
  if (Subtarget->hasGetWaveIdInst())
    Features.set(Feature_HasGetWaveIdInstBit);
  if (Subtarget->hasMAIInsts())
    Features.set(Feature_HasMAIInstsBit);
  if (Subtarget->hasSMemRealTime())
    Features.set(Feature_HasSMemRealTimeBit);
  if (Subtarget->hasSMemTimeInst())
    Features.set(Feature_HasSMemTimeInstBit);
  if (Subtarget->hasShaderCyclesRegister())
    Features.set(Feature_HasShaderCyclesRegisterBit);
  if (Subtarget->hasShaderCyclesHiLoRegisters())
    Features.set(Feature_HasShaderCyclesHiLoRegistersBit);
  if (Subtarget->hasFP8Insts())
    Features.set(Feature_HasFP8InstsBit);
  if (Subtarget->hasFP8ConversionInsts())
    Features.set(Feature_HasFP8ConversionInstsBit);
  if (Subtarget->hasMadMacF32Insts())
    Features.set(Feature_HasMadMacF32InstsBit);
  if (Subtarget->hasGFX10_3Insts())
    Features.set(Feature_HasFmaLegacy32Bit);
  if (Subtarget->hasAtomicDsPkAdd16Insts())
    Features.set(Feature_HasAtomicDsPkAdd16InstsBit);
  if (Subtarget->hasAtomicFlatPkAdd16Insts())
    Features.set(Feature_HasAtomicFlatPkAdd16InstsBit);
  if (Subtarget->hasAtomicFaddRtnInsts())
    Features.set(Feature_HasAtomicFaddRtnInstsBit);
  if (Subtarget->hasAtomicFaddNoRtnInsts())
    Features.set(Feature_HasAtomicFaddNoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16NoRtnInsts() || Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit);
  if (Subtarget->hasAtomicBufferGlobalPkAddF16Insts())
    Features.set(Feature_HasAtomicBufferGlobalPkAddF16InstsBit);
  if (Subtarget->hasAtomicGlobalPkAddBF16Inst())
    Features.set(Feature_HasAtomicGlobalPkAddBF16InstBit);
  if (Subtarget->hasAtomicBufferPkAddBF16Inst())
    Features.set(Feature_HasAtomicBufferPkAddBF16InstBit);
  if (Subtarget->hasFlatAtomicFaddF32Inst())
    Features.set(Feature_HasFlatAtomicFaddF32InstBit);
  if (Subtarget->enableFlatScratch())
    Features.set(Feature_EnableFlatScratchBit);
  if (!Subtarget->enableFlatScratch())
    Features.set(Feature_DisableFlatScratchBit);
  if (Subtarget->hasUnalignedAccessMode())
    Features.set(Feature_HasUnalignedAccessModeBit);
  if (Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasMADIntraFwdBugBit);
  if (!Subtarget->hasMADIntraFwdBug())
    Features.set(Feature_HasNotMADIntraFwdBugBit);
  if (Subtarget->hasSALUFloatInsts())
    Features.set(Feature_HasSALUFloatInstsBit);
  if (Subtarget->hasPseudoScalarTrans())
    Features.set(Feature_HasPseudoScalarTransBit);
  if (Subtarget->hasBitOp3Insts())
    Features.set(Feature_HasBitOp3InstsBit);
  if (Subtarget->hasPrngInst())
    Features.set(Feature_HasPrngInstBit);
  if (Subtarget->hasFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasF16BF16ToFP6BF6ConversionScaleInsts())
    Features.set(Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit);
  if (Subtarget->hasCvtPkF16F32Inst())
    Features.set(Feature_HasCvtPkF16F32InstBit);
  if (Subtarget->hasF32ToF16BF16ConversionSRInsts())
    Features.set(Feature_HasF32ToF16BF16ConversionSRInstsBit);
  if (Subtarget->hasGDS())
    Features.set(Feature_HasGDSBit);
  if (Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasCvtFP8VOP1BugBit);
  if (!Subtarget->hasCvtFP8VOP1Bug())
    Features.set(Feature_HasNoCvtFP8VOP1BugBit);
  if (Subtarget->hasAtomicCSubNoRtnInsts())
    Features.set(Feature_HasAtomicCSubNoRtnInstsBit);
  if (Subtarget->hasXF32Insts())
    Features.set(Feature_HasXF32InstsBit);
  if (Subtarget->hasAshrPkInsts())
    Features.set(Feature_HasAshrPkInstsBit);
  if (Subtarget->isWave32())
    Features.set(Feature_isWave32Bit);
  if (Subtarget->isWave64())
    Features.set(Feature_isWave64Bit);
  return Features;
}

void AMDGPUInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUInstructionSelector::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP16DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP64FP16Denormals != DenormalMode::getPreserveSign())
    Features.set(Feature_FP64DenormalsBit);
  if (MF->getInfo<SIMachineFunctionInfo>()->getMode().FP32Denormals == DenormalMode::getPreserveSign())
    Features.set(Feature_NoFP32DenormalsBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_DisableFlatScratch,
  GIFBS_Has16BitInsts,
  GIFBS_HasAddNoCarryInsts,
  GIFBS_HasAshrPkInsts,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts,
  GIFBS_HasAtomicBufferPkAddBF16Inst,
  GIFBS_HasAtomicCSubNoRtnInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts,
  GIFBS_HasAtomicFaddNoRtnInsts,
  GIFBS_HasAtomicFaddRtnInsts,
  GIFBS_HasAtomicFlatPkAdd16Insts,
  GIFBS_HasAtomicGlobalPkAddBF16Inst,
  GIFBS_HasBF16ConversionInsts,
  GIFBS_HasBitOp3Insts,
  GIFBS_HasCvtPkF16F32Inst,
  GIFBS_HasD16LoadStore,
  GIFBS_HasDLInsts,
  GIFBS_HasDot10Insts,
  GIFBS_HasDot12Insts,
  GIFBS_HasDot13Insts,
  GIFBS_HasDot1Insts,
  GIFBS_HasDot2Insts,
  GIFBS_HasDot3Insts,
  GIFBS_HasDot4Insts,
  GIFBS_HasDot5Insts,
  GIFBS_HasDot6Insts,
  GIFBS_HasDot7Insts,
  GIFBS_HasDot8Insts,
  GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts,
  GIFBS_HasF32ToF16BF16ConversionSRInsts,
  GIFBS_HasFP6BF6ConversionScaleInsts,
  GIFBS_HasFP8Insts,
  GIFBS_HasFlatAddressSpace,
  GIFBS_HasFlatAtomicFaddF32Inst,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst,
  GIFBS_HasFlatGlobalInsts,
  GIFBS_HasFmaLegacy32,
  GIFBS_HasFmaMixInsts,
  GIFBS_HasFmacF64Inst,
  GIFBS_HasGDS,
  GIFBS_HasGFX10_BEncoding,
  GIFBS_HasGFX950Insts,
  GIFBS_HasGetWaveIdInst,
  GIFBS_HasIntClamp,
  GIFBS_HasLdsAtomicAddF64,
  GIFBS_HasMAIInsts,
  GIFBS_HasMadMacF32Insts,
  GIFBS_HasMinMaxDenormModes,
  GIFBS_HasMinimum3Maximum3F32,
  GIFBS_HasMinimum3Maximum3PKF16,
  GIFBS_HasPackedD16VMem,
  GIFBS_HasPackedFP32Ops,
  GIFBS_HasPrngInst,
  GIFBS_HasPseudoScalarTrans,
  GIFBS_HasSALUFloatInsts,
  GIFBS_HasSMemRealTime,
  GIFBS_HasSMemTimeInst,
  GIFBS_HasShaderCyclesHiLoRegisters,
  GIFBS_HasShaderCyclesRegister,
  GIFBS_HasTrue16BitInsts,
  GIFBS_HasUnpackedD16VMem,
  GIFBS_HasUnrestrictedSOffset,
  GIFBS_HasVOP3PInsts,
  GIFBS_HasXF32Insts,
  GIFBS_HasXNACKEnabled,
  GIFBS_LDSRequiresM0Init,
  GIFBS_NotHasAddNoCarryInsts,
  GIFBS_NotHasTrue16BitInsts,
  GIFBS_NotLDSRequiresM0Init,
  GIFBS_UseFakeTrue16Insts,
  GIFBS_UseRealTrue16Insts,
  GIFBS_isGFX10Only,
  GIFBS_isGFX10Plus,
  GIFBS_isGFX11Only,
  GIFBS_isGFX11Plus,
  GIFBS_isGFX12Only,
  GIFBS_isGFX12Plus,
  GIFBS_isGFX6,
  GIFBS_isGFX6GFX7,
  GIFBS_isGFX6GFX7GFX8GFX9,
  GIFBS_isGFX7GFX8GFX9,
  GIFBS_isGFX7Only,
  GIFBS_isGFX7Plus,
  GIFBS_isGFX8GFX9,
  GIFBS_isGFX8GFX9GFX10GFX11,
  GIFBS_isGFX8Plus,
  GIFBS_isGFX908orGFX90A,
  GIFBS_isGFX90APlus,
  GIFBS_isGFX940Plus,
  GIFBS_isGFX9GFX10,
  GIFBS_isGFX9Plus,
  GIFBS_isNotGFX12Plus,
  GIFBS_isNotGFX90APlus,
  GIFBS_isNotGFX940Plus,
  GIFBS_isNotGFX9Plus,
  GIFBS_isWave32,
  GIFBS_isWave64,
  GIFBS_DisableFlatScratch_HasD16LoadStore,
  GIFBS_DisableFlatScratch_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts,
  GIFBS_FP16Denormals_NotHasMinMaxDenormModes,
  GIFBS_FalsePredicate_NotHasMinMaxDenormModes,
  GIFBS_Has16BitInsts_HasIntClamp,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_UseFakeTrue16Insts,
  GIFBS_Has16BitInsts_UseRealTrue16Insts,
  GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8GFX9,
  GIFBS_Has16BitInsts_isGFX8Only,
  GIFBS_Has16BitInsts_isNotGFX90APlus,
  GIFBS_HasAddNoCarryInsts_HasIntClamp,
  GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset,
  GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus,
  GIFBS_HasAtomicDsPkAdd16Insts_HasGDS,
  GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init,
  GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts,
  GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset,
  GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts,
  GIFBS_HasDot11Insts_isGFX12Plus,
  GIFBS_HasDot9Insts_NotHasTrue16BitInsts,
  GIFBS_HasDot9Insts_UseFakeTrue16Insts,
  GIFBS_HasDot9Insts_UseRealTrue16Insts,
  GIFBS_HasExportInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_HasSDWA,
  GIFBS_HasFP8ConversionInsts_isGFX12Plus,
  GIFBS_HasFP8ConversionInsts_isGFX940Plus,
  GIFBS_HasFP8ConversionInsts_isGFX9Plus,
  GIFBS_HasFP8Insts_isGFX90APlus,
  GIFBS_HasFlatAddressSpace_isGFX12Plus,
  GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset,
  GIFBS_HasFlatGlobalInsts_isGFX12Plus,
  GIFBS_HasGDS_HasLDSFPAtomicAddF32,
  GIFBS_HasGDS_isGFX11Plus,
  GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_HasGFX950Insts_isGFX90APlus,
  GIFBS_HasImageInsts_isGFX12Plus,
  GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init,
  GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init,
  GIFBS_HasMADIntraFwdBug_isGFX11Only,
  GIFBS_HasMAIInsts_isGFX90APlus,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals,
  GIFBS_HasMadMixInsts_NoFP32Denormals,
  GIFBS_HasMed3_16_NotHasTrue16BitInsts,
  GIFBS_HasMed3_16_UseFakeTrue16Insts,
  GIFBS_HasMinMaxDenormModes_isGFX12Plus,
  GIFBS_HasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_HasNotMADIntraFwdBug_isGFX9Plus,
  GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset,
  GIFBS_HasScalarStores_isGFX8Plus,
  GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init,
  GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init,
  GIFBS_HasXF32Insts_isGFX90APlus,
  GIFBS_HasXNACKEnabled_isGFX7Only,
  GIFBS_HasXNACKEnabled_isGFX9Plus,
  GIFBS_HasXNACKEnabled_isNotGFX9Plus,
  GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_LDSRequiresM0Init_isGFX7Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX8Plus,
  GIFBS_NotHasTrue16BitInsts_isGFX9Plus,
  GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10,
  GIFBS_NotLDSRequiresM0Init_isGFX7Plus,
  GIFBS_UseFakeTrue16Insts_isGFX10Plus,
  GIFBS_UseFakeTrue16Insts_isGFX8Plus,
  GIFBS_UseFakeTrue16Insts_isGFX9Plus,
  GIFBS_UseRealTrue16Insts_isGFX10Plus,
  GIFBS_UseRealTrue16Insts_isGFX9Plus,
  GIFBS_has16BankLDS_isNotGFX90APlus,
  GIFBS_has32BankLDS_isNotGFX90APlus,
  GIFBS_isGFX11Only_isWave32,
  GIFBS_isGFX11Only_isWave64,
  GIFBS_isGFX12Plus_isWave32,
  GIFBS_isGFX12Plus_isWave64,
  GIFBS_isGFX90APlus_isGFX908orGFX90A,
  GIFBS_isGFX90APlus_isGFX940Plus,
  GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts,
  GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus,
  GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_HasTrue16BitInsts,
  GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts,
  GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus,
  GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus,
  GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA,
  GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10,
  GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode,
  GIFBS_FP16Denormals_Has16BitInsts_HasTrue16BitInsts_NotHasMinMaxDenormModes,
  GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_DisableFlatScratchBit, },
  {Feature_Has16BitInstsBit, },
  {Feature_HasAddNoCarryInstsBit, },
  {Feature_HasAshrPkInstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, },
  {Feature_HasAtomicBufferPkAddBF16InstBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, },
  {Feature_HasAtomicFaddRtnInstsBit, },
  {Feature_HasAtomicFlatPkAdd16InstsBit, },
  {Feature_HasAtomicGlobalPkAddBF16InstBit, },
  {Feature_HasBF16ConversionInstsBit, },
  {Feature_HasBitOp3InstsBit, },
  {Feature_HasCvtPkF16F32InstBit, },
  {Feature_HasD16LoadStoreBit, },
  {Feature_HasDLInstsBit, },
  {Feature_HasDot10InstsBit, },
  {Feature_HasDot12InstsBit, },
  {Feature_HasDot13InstsBit, },
  {Feature_HasDot1InstsBit, },
  {Feature_HasDot2InstsBit, },
  {Feature_HasDot3InstsBit, },
  {Feature_HasDot4InstsBit, },
  {Feature_HasDot5InstsBit, },
  {Feature_HasDot6InstsBit, },
  {Feature_HasDot7InstsBit, },
  {Feature_HasDot8InstsBit, },
  {Feature_HasF16BF16ToFP6BF6ConversionScaleInstsBit, },
  {Feature_HasF32ToF16BF16ConversionSRInstsBit, },
  {Feature_HasFP6BF6ConversionScaleInstsBit, },
  {Feature_HasFP8InstsBit, },
  {Feature_HasFlatAddressSpaceBit, },
  {Feature_HasFlatAtomicFaddF32InstBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, },
  {Feature_HasFlatGlobalInstsBit, },
  {Feature_HasFmaLegacy32Bit, },
  {Feature_HasFmaMixInstsBit, },
  {Feature_HasFmacF64InstBit, },
  {Feature_HasGDSBit, },
  {Feature_HasGFX10_BEncodingBit, },
  {Feature_HasGFX950InstsBit, },
  {Feature_HasGetWaveIdInstBit, },
  {Feature_HasIntClampBit, },
  {Feature_HasLdsAtomicAddF64Bit, },
  {Feature_HasMAIInstsBit, },
  {Feature_HasMadMacF32InstsBit, },
  {Feature_HasMinMaxDenormModesBit, },
  {Feature_HasMinimum3Maximum3F32Bit, },
  {Feature_HasMinimum3Maximum3PKF16Bit, },
  {Feature_HasPackedD16VMemBit, },
  {Feature_HasPackedFP32OpsBit, },
  {Feature_HasPrngInstBit, },
  {Feature_HasPseudoScalarTransBit, },
  {Feature_HasSALUFloatInstsBit, },
  {Feature_HasSMemRealTimeBit, },
  {Feature_HasSMemTimeInstBit, },
  {Feature_HasShaderCyclesHiLoRegistersBit, },
  {Feature_HasShaderCyclesRegisterBit, },
  {Feature_HasTrue16BitInstsBit, },
  {Feature_HasUnpackedD16VMemBit, },
  {Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasVOP3PInstsBit, },
  {Feature_HasXF32InstsBit, },
  {Feature_HasXNACKEnabledBit, },
  {Feature_LDSRequiresM0InitBit, },
  {Feature_NotHasAddNoCarryInstsBit, },
  {Feature_NotHasTrue16BitInstsBit, },
  {Feature_NotLDSRequiresM0InitBit, },
  {Feature_UseFakeTrue16InstsBit, },
  {Feature_UseRealTrue16InstsBit, },
  {Feature_isGFX10OnlyBit, },
  {Feature_isGFX10PlusBit, },
  {Feature_isGFX11OnlyBit, },
  {Feature_isGFX11PlusBit, },
  {Feature_isGFX12OnlyBit, },
  {Feature_isGFX12PlusBit, },
  {Feature_isGFX6Bit, },
  {Feature_isGFX6GFX7Bit, },
  {Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_isGFX7GFX8GFX9Bit, },
  {Feature_isGFX7OnlyBit, },
  {Feature_isGFX7PlusBit, },
  {Feature_isGFX8GFX9Bit, },
  {Feature_isGFX8GFX9GFX10GFX11Bit, },
  {Feature_isGFX8PlusBit, },
  {Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, },
  {Feature_isGFX940PlusBit, },
  {Feature_isGFX9GFX10Bit, },
  {Feature_isGFX9PlusBit, },
  {Feature_isNotGFX12PlusBit, },
  {Feature_isNotGFX90APlusBit, },
  {Feature_isNotGFX940PlusBit, },
  {Feature_isNotGFX9PlusBit, },
  {Feature_isWave32Bit, },
  {Feature_isWave64Bit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, },
  {Feature_DisableFlatScratchBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, },
  {Feature_FP16DenormalsBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_FalsePredicateBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_Has16BitInstsBit, Feature_HasIntClampBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_Has16BitInstsBit, Feature_isGFX6GFX7GFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8GFX9Bit, },
  {Feature_Has16BitInstsBit, Feature_isGFX8OnlyBit, },
  {Feature_Has16BitInstsBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasAddNoCarryInstsBit, Feature_HasIntClampBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16InstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicBufferGlobalPkAddF16NoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicBufferPkAddBF16InstBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicCSubNoRtnInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_HasGDSBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasAtomicDsPkAdd16InstsBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF32FlatInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF32GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFMinFMaxF64FlatInstsBit, Feature_HasFlatAddressSpaceBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasFlatGlobalInstsBit, },
  {Feature_HasAtomicFMinFMaxF64GlobalInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddNoRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasAtomicFaddRtnInstsBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasCvtFP8VOP1BugBit, Feature_HasFP8ConversionInstsBit, },
  {Feature_HasDot11InstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasDot9InstsBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasDot9InstsBit, Feature_UseRealTrue16InstsBit, },
  {Feature_HasExportInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasSDWABit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX940PlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_isGFX9PlusBit, },
  {Feature_HasFP8InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasFlatAddressSpaceBit, Feature_isGFX12PlusBit, },
  {Feature_HasFlatBufferGlobalAtomicFaddF64InstBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasFlatGlobalInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasGDSBit, Feature_HasLDSFPAtomicAddF32Bit, },
  {Feature_HasGDSBit, Feature_isGFX11PlusBit, },
  {Feature_HasGDSBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_HasGFX950InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasImageInstsBit, Feature_isGFX12PlusBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasLDSFPAtomicAddF32Bit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasMADIntraFwdBugBit, Feature_isGFX11OnlyBit, },
  {Feature_HasMAIInstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMadMixInstsBit, Feature_NoFP32DenormalsBit, },
  {Feature_HasMed3_16Bit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_HasMed3_16Bit, Feature_UseFakeTrue16InstsBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_HasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_HasNotMADIntraFwdBugBit, Feature_isGFX9PlusBit, },
  {Feature_HasPackedD16VMemBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_HasScalarStoresBit, Feature_isGFX8PlusBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_LDSRequiresM0InitBit, },
  {Feature_HasUnalignedAccessModeBit, Feature_NotLDSRequiresM0InitBit, },
  {Feature_HasXF32InstsBit, Feature_isGFX90APlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX7OnlyBit, },
  {Feature_HasXNACKEnabledBit, Feature_isGFX9PlusBit, },
  {Feature_HasXNACKEnabledBit, Feature_isNotGFX9PlusBit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_LDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX8PlusBit, },
  {Feature_NotHasTrue16BitInstsBit, Feature_isGFX9PlusBit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX6GFX7GFX8GFX9GFX10Bit, },
  {Feature_NotLDSRequiresM0InitBit, Feature_isGFX7PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX8PlusBit, },
  {Feature_UseFakeTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX10PlusBit, },
  {Feature_UseRealTrue16InstsBit, Feature_isGFX9PlusBit, },
  {Feature_has16BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_isGFX11OnlyBit, Feature_isWave32Bit, },
  {Feature_isGFX11OnlyBit, Feature_isWave64Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave32Bit, },
  {Feature_isGFX12PlusBit, Feature_isWave64Bit, },
  {Feature_isGFX90APlusBit, Feature_isGFX908orGFX90ABit, },
  {Feature_isGFX90APlusBit, Feature_isGFX940PlusBit, },
  {Feature_DisableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasUnrestrictedSOffsetBit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, },
  {Feature_EnableFlatScratchBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isGFX12PlusBit, },
  {Feature_FP64DenormalsBit, Feature_NotHasMinMaxDenormModesBit, Feature_isNotGFX12PlusBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_HasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_HasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasTrue16BitInstsBit, Feature_isGFX10PlusBit, },
  {Feature_Has16BitInstsBit, Feature_has32BankLDSBit, Feature_isNotGFX90APlusBit, },
  {Feature_HasFP8ConversionInstsBit, Feature_HasNoCvtFP8VOP1BugBit, Feature_HasSDWABit, },
  {Feature_HasMadMacF32InstsBit, Feature_NoFP32DenormalsBit, Feature_isGFX6GFX7GFX10Bit, },
  {Feature_EnableFlatScratchBit, Feature_HasD16LoadStoreBit, Feature_HasFlatScratchInstsBit, Feature_HasFlatScratchSVSModeBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_HasTrue16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, },
  {Feature_FP16DenormalsBit, Feature_Has16BitInstsBit, Feature_NotHasMinMaxDenormModesBit, Feature_NotHasTrue16BitInstsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_buf_soffset,
  GICP_gi_ds_128bit_8byte_aligned,
  GICP_gi_ds_1addr_1offset,
  GICP_gi_ds_64bit_4byte_aligned,
  GICP_gi_flat_offset,
  GICP_gi_flat_scratch_offset,
  GICP_gi_flat_scratch_saddr,
  GICP_gi_flat_scratch_svaddr,
  GICP_gi_global_offset,
  GICP_gi_global_saddr,
  GICP_gi_mubuf_addr64,
  GICP_gi_mubuf_offset,
  GICP_gi_mubuf_scratch_offen,
  GICP_gi_mubuf_scratch_offset,
  GICP_gi_smrd_buffer_imm,
  GICP_gi_smrd_buffer_imm32,
  GICP_gi_smrd_buffer_sgpr_imm,
  GICP_gi_smrd_imm,
  GICP_gi_smrd_imm32,
  GICP_gi_smrd_sgpr,
  GICP_gi_smrd_sgpr_imm,
  GICP_gi_swmmacindex16,
  GICP_gi_swmmacindex8,
  GICP_gi_vcsrc,
  GICP_gi_vinterpmods,
  GICP_gi_vinterpmods_hi,
  GICP_gi_vop3_mad_mix_mods,
  GICP_gi_vop3_mad_mix_mods_ext,
  GICP_gi_vop3_no_mods,
  GICP_gi_vop3mods,
  GICP_gi_vop3mods0,
  GICP_gi_vop3modsnoncanonicalizing,
  GICP_gi_vop3omods,
  GICP_gi_vop3opsel,
  GICP_gi_vop3opselmods,
  GICP_gi_vop3pmods,
  GICP_gi_vop3pmodsdot,
  GICP_gi_vop3pmodsneg,
  GICP_gi_vsrc0,
  GICP_gi_wmmamods,
  GICP_gi_wmmamodsf16Neg,
  GICP_gi_wmmamodsf16NegAbs,
  GICP_gi_wmmaopselvop3pmods,
  GICP_gi_wmmavisrc,
};
// See constructor for table contents

AMDGPUInstructionSelector::ComplexMatcherMemFn
AMDGPUInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AMDGPUInstructionSelector::selectBUFSOffset, // gi_buf_soffset
  &AMDGPUInstructionSelector::selectDS128Bit8ByteAligned, // gi_ds_128bit_8byte_aligned
  &AMDGPUInstructionSelector::selectDS1Addr1Offset, // gi_ds_1addr_1offset
  &AMDGPUInstructionSelector::selectDS64Bit4ByteAligned, // gi_ds_64bit_4byte_aligned
  &AMDGPUInstructionSelector::selectFlatOffset, // gi_flat_offset
  &AMDGPUInstructionSelector::selectScratchOffset, // gi_flat_scratch_offset
  &AMDGPUInstructionSelector::selectScratchSAddr, // gi_flat_scratch_saddr
  &AMDGPUInstructionSelector::selectScratchSVAddr, // gi_flat_scratch_svaddr
  &AMDGPUInstructionSelector::selectGlobalOffset, // gi_global_offset
  &AMDGPUInstructionSelector::selectGlobalSAddr, // gi_global_saddr
  &AMDGPUInstructionSelector::selectMUBUFAddr64, // gi_mubuf_addr64
  &AMDGPUInstructionSelector::selectMUBUFOffset, // gi_mubuf_offset
  &AMDGPUInstructionSelector::selectMUBUFScratchOffen, // gi_mubuf_scratch_offen
  &AMDGPUInstructionSelector::selectMUBUFScratchOffset, // gi_mubuf_scratch_offset
  &AMDGPUInstructionSelector::selectSMRDBufferImm, // gi_smrd_buffer_imm
  &AMDGPUInstructionSelector::selectSMRDBufferImm32, // gi_smrd_buffer_imm32
  &AMDGPUInstructionSelector::selectSMRDBufferSgprImm, // gi_smrd_buffer_sgpr_imm
  &AMDGPUInstructionSelector::selectSmrdImm, // gi_smrd_imm
  &AMDGPUInstructionSelector::selectSmrdImm32, // gi_smrd_imm32
  &AMDGPUInstructionSelector::selectSmrdSgpr, // gi_smrd_sgpr
  &AMDGPUInstructionSelector::selectSmrdSgprImm, // gi_smrd_sgpr_imm
  &AMDGPUInstructionSelector::selectSWMMACIndex16, // gi_swmmacindex16
  &AMDGPUInstructionSelector::selectSWMMACIndex8, // gi_swmmacindex8
  &AMDGPUInstructionSelector::selectVCSRC, // gi_vcsrc
  &AMDGPUInstructionSelector::selectVINTERPMods, // gi_vinterpmods
  &AMDGPUInstructionSelector::selectVINTERPModsHi, // gi_vinterpmods_hi
  &AMDGPUInstructionSelector::selectVOP3PMadMixMods, // gi_vop3_mad_mix_mods
  &AMDGPUInstructionSelector::selectVOP3PMadMixModsExt, // gi_vop3_mad_mix_mods_ext
  &AMDGPUInstructionSelector::selectVOP3NoMods, // gi_vop3_no_mods
  &AMDGPUInstructionSelector::selectVOP3Mods, // gi_vop3mods
  &AMDGPUInstructionSelector::selectVOP3Mods0, // gi_vop3mods0
  &AMDGPUInstructionSelector::selectVOP3ModsNonCanonicalizing, // gi_vop3modsnoncanonicalizing
  &AMDGPUInstructionSelector::selectVOP3OMods, // gi_vop3omods
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opsel
  &AMDGPUInstructionSelector::selectVOP3OpSelMods, // gi_vop3opselmods
  &AMDGPUInstructionSelector::selectVOP3PMods, // gi_vop3pmods
  &AMDGPUInstructionSelector::selectVOP3PModsDOT, // gi_vop3pmodsdot
  &AMDGPUInstructionSelector::selectVOP3PModsNeg, // gi_vop3pmodsneg
  &AMDGPUInstructionSelector::selectVSRC0, // gi_vsrc0
  &AMDGPUInstructionSelector::selectWMMAModsF32NegAbs, // gi_wmmamods
  &AMDGPUInstructionSelector::selectWMMAModsF16Neg, // gi_wmmamodsf16Neg
  &AMDGPUInstructionSelector::selectWMMAModsF16NegAbs, // gi_wmmamodsf16NegAbs
  &AMDGPUInstructionSelector::selectWMMAOpSelVOP3PMods, // gi_wmmaopselvop3pmods
  &AMDGPUInstructionSelector::selectWMMAVISrc, // gi_wmmavisrc
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_aligned_smrd_load = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_anonymous_13360,
  GICXXPred_MI_Predicate_anonymous_13363,
  GICXXPred_MI_Predicate_anonymous_13364,
  GICXXPred_MI_Predicate_anonymous_13365,
  GICXXPred_MI_Predicate_anonymous_13366,
  GICXXPred_MI_Predicate_anonymous_13367,
  GICXXPred_MI_Predicate_anonymous_13370,
  GICXXPred_MI_Predicate_anonymous_13371,
  GICXXPred_MI_Predicate_anonymous_13372,
  GICXXPred_MI_Predicate_anonymous_13373,
  GICXXPred_MI_Predicate_anonymous_13374,
  GICXXPred_MI_Predicate_anonymous_13375,
  GICXXPred_MI_Predicate_anonymous_13376,
  GICXXPred_MI_Predicate_anonymous_13377,
  GICXXPred_MI_Predicate_anonymous_13378,
  GICXXPred_MI_Predicate_anonymous_13379,
  GICXXPred_MI_Predicate_anonymous_13380,
  GICXXPred_MI_Predicate_anonymous_13381,
  GICXXPred_MI_Predicate_anonymous_13382,
  GICXXPred_MI_Predicate_anonymous_13383,
  GICXXPred_MI_Predicate_anonymous_13384,
  GICXXPred_MI_Predicate_anonymous_13385,
  GICXXPred_MI_Predicate_anonymous_13386,
  GICXXPred_MI_Predicate_anonymous_13387,
  GICXXPred_MI_Predicate_anonymous_13388,
  GICXXPred_MI_Predicate_anonymous_13389,
  GICXXPred_MI_Predicate_anonymous_13390,
  GICXXPred_MI_Predicate_anonymous_13391,
  GICXXPred_MI_Predicate_anonymous_13392,
  GICXXPred_MI_Predicate_anonymous_13393,
  GICXXPred_MI_Predicate_anonymous_13394,
  GICXXPred_MI_Predicate_anonymous_13395,
  GICXXPred_MI_Predicate_anonymous_13396,
  GICXXPred_MI_Predicate_anonymous_13397,
  GICXXPred_MI_Predicate_anonymous_13398,
  GICXXPred_MI_Predicate_anonymous_13399,
  GICXXPred_MI_Predicate_anonymous_13400,
  GICXXPred_MI_Predicate_anonymous_13401,
  GICXXPred_MI_Predicate_anonymous_13402,
  GICXXPred_MI_Predicate_anonymous_13403,
  GICXXPred_MI_Predicate_anonymous_13404,
  GICXXPred_MI_Predicate_anonymous_13405,
  GICXXPred_MI_Predicate_anonymous_13406,
  GICXXPred_MI_Predicate_anonymous_13407,
  GICXXPred_MI_Predicate_anonymous_13408,
  GICXXPred_MI_Predicate_anonymous_13409,
  GICXXPred_MI_Predicate_anonymous_13410,
  GICXXPred_MI_Predicate_anonymous_13411,
  GICXXPred_MI_Predicate_anonymous_13418,
  GICXXPred_MI_Predicate_anonymous_13430,
  GICXXPred_MI_Predicate_anonymous_17755,
  GICXXPred_MI_Predicate_anonymous_18673,
  GICXXPred_MI_Predicate_anonymous_18675,
  GICXXPred_MI_Predicate_anonymous_19059,
  GICXXPred_MI_Predicate_anonymous_19061,
  GICXXPred_MI_Predicate_anonymous_19063,
  GICXXPred_MI_Predicate_anonymous_19065,
  GICXXPred_MI_Predicate_anonymous_19067,
  GICXXPred_MI_Predicate_anonymous_19071,
  GICXXPred_MI_Predicate_anonymous_19073,
  GICXXPred_MI_Predicate_anonymous_19075,
  GICXXPred_MI_Predicate_anonymous_19077,
  GICXXPred_MI_Predicate_anonymous_19079,
  GICXXPred_MI_Predicate_anonymous_19334,
  GICXXPred_MI_Predicate_anonymous_19336,
  GICXXPred_MI_Predicate_anonymous_19574,
  GICXXPred_MI_Predicate_anonymous_19584,
  GICXXPred_MI_Predicate_anonymous_19587,
  GICXXPred_MI_Predicate_anonymous_19675,
  GICXXPred_MI_Predicate_anonymous_20097,
  GICXXPred_MI_Predicate_anonymous_20100,
  GICXXPred_MI_Predicate_anonymous_20103,
  GICXXPred_MI_Predicate_anonymous_20105,
  GICXXPred_MI_Predicate_anonymous_20108,
  GICXXPred_MI_Predicate_anonymous_20110,
  GICXXPred_MI_Predicate_anonymous_20113,
  GICXXPred_MI_Predicate_anonymous_20116,
  GICXXPred_MI_Predicate_anonymous_20120,
  GICXXPred_MI_Predicate_anonymous_20132,
  GICXXPred_MI_Predicate_anonymous_20563,
  GICXXPred_MI_Predicate_anonymous_20833,
  GICXXPred_MI_Predicate_anonymous_20836,
  GICXXPred_MI_Predicate_anonymous_20838,
  GICXXPred_MI_Predicate_anonymous_20840,
  GICXXPred_MI_Predicate_anonymous_20842,
  GICXXPred_MI_Predicate_anonymous_20844,
  GICXXPred_MI_Predicate_anonymous_20846,
  GICXXPred_MI_Predicate_anonymous_22537,
  GICXXPred_MI_Predicate_anonymous_22539,
  GICXXPred_MI_Predicate_anonymous_22543,
  GICXXPred_MI_Predicate_anonymous_22545,
  GICXXPred_MI_Predicate_anonymous_22547,
  GICXXPred_MI_Predicate_anonymous_22549,
  GICXXPred_MI_Predicate_anonymous_22553,
  GICXXPred_MI_Predicate_anonymous_22555,
  GICXXPred_MI_Predicate_anonymous_22557,
  GICXXPred_MI_Predicate_anonymous_22559,
  GICXXPred_MI_Predicate_anonymous_22561,
  GICXXPred_MI_Predicate_anonymous_22563,
  GICXXPred_MI_Predicate_anonymous_22565,
  GICXXPred_MI_Predicate_anonymous_22567,
  GICXXPred_MI_Predicate_anonymous_22571,
  GICXXPred_MI_Predicate_anonymous_22573,
  GICXXPred_MI_Predicate_anonymous_22575,
  GICXXPred_MI_Predicate_anonymous_22577,
  GICXXPred_MI_Predicate_anonymous_22581,
  GICXXPred_MI_Predicate_anonymous_22583,
  GICXXPred_MI_Predicate_anonymous_22587,
  GICXXPred_MI_Predicate_anonymous_22589,
  GICXXPred_MI_Predicate_anonymous_22591,
  GICXXPred_MI_Predicate_anonymous_22593,
  GICXXPred_MI_Predicate_anonymous_22597,
  GICXXPred_MI_Predicate_anonymous_22599,
  GICXXPred_MI_Predicate_anonymous_22601,
  GICXXPred_MI_Predicate_anonymous_22603,
  GICXXPred_MI_Predicate_anonymous_22605,
  GICXXPred_MI_Predicate_anonymous_22607,
  GICXXPred_MI_Predicate_anonymous_22609,
  GICXXPred_MI_Predicate_anonymous_22611,
  GICXXPred_MI_Predicate_anonymous_22615,
  GICXXPred_MI_Predicate_anonymous_22617,
  GICXXPred_MI_Predicate_anonymous_22619,
  GICXXPred_MI_Predicate_anonymous_22621,
  GICXXPred_MI_Predicate_anonymous_22625,
  GICXXPred_MI_Predicate_anonymous_22627,
  GICXXPred_MI_Predicate_anonymous_22629,
  GICXXPred_MI_Predicate_anonymous_22631,
  GICXXPred_MI_Predicate_anonymous_22633,
  GICXXPred_MI_Predicate_anonymous_22635,
  GICXXPred_MI_Predicate_anonymous_22639,
  GICXXPred_MI_Predicate_anonymous_22641,
  GICXXPred_MI_Predicate_anonymous_22643,
  GICXXPred_MI_Predicate_anonymous_22645,
  GICXXPred_MI_Predicate_anonymous_22647,
  GICXXPred_MI_Predicate_anonymous_22649,
  GICXXPred_MI_Predicate_anonymous_22653,
  GICXXPred_MI_Predicate_anonymous_22655,
  GICXXPred_MI_Predicate_anonymous_22659,
  GICXXPred_MI_Predicate_anonymous_22661,
  GICXXPred_MI_Predicate_anonymous_22663,
  GICXXPred_MI_Predicate_anonymous_22665,
  GICXXPred_MI_Predicate_anonymous_22685,
  GICXXPred_MI_Predicate_anonymous_22687,
  GICXXPred_MI_Predicate_anonymous_22721,
  GICXXPred_MI_Predicate_anonymous_22723,
  GICXXPred_MI_Predicate_anonymous_22743,
  GICXXPred_MI_Predicate_anonymous_22745,
  GICXXPred_MI_Predicate_anonymous_22783,
  GICXXPred_MI_Predicate_anonymous_22785,
  GICXXPred_MI_Predicate_anonymous_22789,
  GICXXPred_MI_Predicate_anonymous_22791,
  GICXXPred_MI_Predicate_anonymous_22793,
  GICXXPred_MI_Predicate_anonymous_22795,
  GICXXPred_MI_Predicate_anonymous_22797,
  GICXXPred_MI_Predicate_anonymous_22799,
  GICXXPred_MI_Predicate_anonymous_22801,
  GICXXPred_MI_Predicate_anonymous_22803,
  GICXXPred_MI_Predicate_anonymous_22807,
  GICXXPred_MI_Predicate_anonymous_22809,
  GICXXPred_MI_Predicate_anonymous_22811,
  GICXXPred_MI_Predicate_anonymous_22813,
  GICXXPred_MI_Predicate_anonymous_22817,
  GICXXPred_MI_Predicate_anonymous_22819,
  GICXXPred_MI_Predicate_anonymous_22821,
  GICXXPred_MI_Predicate_anonymous_22823,
  GICXXPred_MI_Predicate_anonymous_22825,
  GICXXPred_MI_Predicate_anonymous_22827,
  GICXXPred_MI_Predicate_anonymous_22831,
  GICXXPred_MI_Predicate_anonymous_22833,
  GICXXPred_MI_Predicate_anonymous_22835,
  GICXXPred_MI_Predicate_anonymous_22837,
  GICXXPred_MI_Predicate_anonymous_22839,
  GICXXPred_MI_Predicate_anonymous_22841,
  GICXXPred_MI_Predicate_anonymous_22843,
  GICXXPred_MI_Predicate_anonymous_22845,
  GICXXPred_MI_Predicate_anonymous_22847,
  GICXXPred_MI_Predicate_anonymous_22849,
  GICXXPred_MI_Predicate_anonymous_22853,
  GICXXPred_MI_Predicate_anonymous_22855,
  GICXXPred_MI_Predicate_anonymous_22857,
  GICXXPred_MI_Predicate_anonymous_22859,
  GICXXPred_MI_Predicate_anonymous_22861,
  GICXXPred_MI_Predicate_anonymous_22863,
  GICXXPred_MI_Predicate_anonymous_22865,
  GICXXPred_MI_Predicate_anonymous_22867,
  GICXXPred_MI_Predicate_anonymous_33421,
  GICXXPred_MI_Predicate_anonymous_33728,
  GICXXPred_MI_Predicate_anonymous_33730,
  GICXXPred_MI_Predicate_anonymous_33776,
  GICXXPred_MI_Predicate_anonymous_33789,
  GICXXPred_MI_Predicate_anonymous_33790,
  GICXXPred_MI_Predicate_anonymous_33793,
  GICXXPred_MI_Predicate_anonymous_33796,
  GICXXPred_MI_Predicate_anonymous_33799,
  GICXXPred_MI_Predicate_anonymous_33803,
  GICXXPred_MI_Predicate_anonymous_33806,
  GICXXPred_MI_Predicate_anonymous_33809,
  GICXXPred_MI_Predicate_anonymous_33811,
  GICXXPred_MI_Predicate_anonymous_33818,
  GICXXPred_MI_Predicate_anonymous_33821,
  GICXXPred_MI_Predicate_anonymous_33823,
  GICXXPred_MI_Predicate_anonymous_33831,
  GICXXPred_MI_Predicate_anonymous_33836,
  GICXXPred_MI_Predicate_anonymous_33840,
  GICXXPred_MI_Predicate_anonymous_33844,
  GICXXPred_MI_Predicate_anonymous_33992,
  GICXXPred_MI_Predicate_anonymous_33995,
  GICXXPred_MI_Predicate_anonymous_34000,
  GICXXPred_MI_Predicate_anonymous_34004,
  GICXXPred_MI_Predicate_anonymous_34050,
  GICXXPred_MI_Predicate_anonymous_34052,
  GICXXPred_MI_Predicate_anonymous_34090,
  GICXXPred_MI_Predicate_anonymous_34117,
  GICXXPred_MI_Predicate_anonymous_34119,
  GICXXPred_MI_Predicate_anonymous_34145,
  GICXXPred_MI_Predicate_anonymous_34147,
  GICXXPred_MI_Predicate_anonymous_34149,
  GICXXPred_MI_Predicate_anonymous_34151,
  GICXXPred_MI_Predicate_anonymous_34153,
  GICXXPred_MI_Predicate_bf16_fpround,
  GICXXPred_MI_Predicate_csh_mask_16,
  GICXXPred_MI_Predicate_csh_mask_32,
  GICXXPred_MI_Predicate_csh_mask_64,
  GICXXPred_MI_Predicate_fmaxnum_like_nnan,
  GICXXPred_MI_Predicate_fminnum_like_nnan,
  GICXXPred_MI_Predicate_is_canonicalized,
  GICXXPred_MI_Predicate_load_align_less_than_4_local,
  GICXXPred_MI_Predicate_load_align_less_than_4_local_m0,
  GICXXPred_MI_Predicate_shl1_add,
  GICXXPred_MI_Predicate_shl2_add,
  GICXXPred_MI_Predicate_shl3_add,
  GICXXPred_MI_Predicate_shl4_add,
  GICXXPred_MI_Predicate_shl_0_to_4,
  GICXXPred_MI_Predicate_smrd_extloadi8,
  GICXXPred_MI_Predicate_smrd_extloadi16,
  GICXXPred_MI_Predicate_smrd_load,
  GICXXPred_MI_Predicate_smrd_prefetch,
  GICXXPred_MI_Predicate_smrd_sextloadi8,
  GICXXPred_MI_Predicate_smrd_sextloadi16,
  GICXXPred_MI_Predicate_smrd_zextloadi8,
  GICXXPred_MI_Predicate_smrd_zextloadi16,
  GICXXPred_MI_Predicate_store_align_less_than_4_local,
  GICXXPred_MI_Predicate_store_align_less_than_4_local_m0,
};
bool AMDGPUInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_aligned_smrd_load: {
    
      auto &Ld = cast<GLoad>(MI);
      TypeSize Size = Ld.getMMO().getSize().getValue();
      return Size <= 4 || Ld.getMMO().getAlign().value() >= Size;
      
    llvm_unreachable("aligned_smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_13360: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13363: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13364: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13365: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13366: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13367: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13370: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13371: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13372: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13373: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13374: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13375: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13376: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13377: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13378: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13379: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13380: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13381: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13382: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13383: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13384: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13385: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13386: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13387: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13388: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13389: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13390: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13391: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13392: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13393: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13394: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13395: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13396: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13397: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13398: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13399: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13400: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13401: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13402: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13403: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13404: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13405: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13406: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13407: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13408: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13409: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13410: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13411: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13418: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_13430: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_17755: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_18673: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_18675: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19059: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19061: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19063: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19065: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19067: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19071: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19073: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19075: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19077: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19079: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19334: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19336: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19574: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19584: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19587: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_19675: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20097: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20097 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20100: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20100 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20103: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20103 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20105: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20105 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20108: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20108 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20110: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20110 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20113: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20113 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20116: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20116 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20120: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20120 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20132: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20132 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20563: {
    
        const int ConstantBusLimit = Subtarget->getConstantBusLimit(AMDGPU::V_ADD3_U32_e64);
        int ConstantBusUses = 0;
        for (unsigned i = 0; i < 3; ++i) {
          const RegisterBank *RegBank = RBI.getRegBank(Operands[i]->getReg(), MRI, TRI);
          if (RegBank->getID() == AMDGPU::SGPRRegBankID) {
            if (++ConstantBusUses > ConstantBusLimit)
              return false;
          }
        }
        return true;
      
    llvm_unreachable("anonymous_20563 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_20833: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20836: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20838: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20840: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20842: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20844: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_20846: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_22537: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22539: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22543: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22545: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22547: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22549: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22553: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22555: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22557: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22559: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22561: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22563: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22565: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22567: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22571: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22573: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22575: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22577: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22581: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22583: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22587: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22589: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22591: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22593: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22597: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22599: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22601: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22603: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22605: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22607: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22609: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22611: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22615: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22617: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22619: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22621: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22625: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22627: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22629: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22631: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22633: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22635: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22639: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22641: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22643: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22645: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22647: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22649: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22653: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22655: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22659: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22661: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22663: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22665: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22685: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22687: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22721: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22723: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22743: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22745: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22783: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22785: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22789: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22791: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22793: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22795: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22797: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22799: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22801: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22803: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22807: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22809: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22811: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22813: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22817: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22819: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22821: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22823: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22825: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22827: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22831: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22833: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22835: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22837: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22839: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22841: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22843: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22845: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22847: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22849: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22853: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22855: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22857: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22859: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22861: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22863: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22865: {
    
      return MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_22867: {
    
      return !MF.getInfo<SIMachineFunctionInfo>()->mayNeedAGPRs();
    
  }
  case GICXXPred_MI_Predicate_anonymous_33421: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33728: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33730: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33776: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33789: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33790: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33793: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33796: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33799: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33803: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33806: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33809: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33811: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33818: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33821: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33823: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33831: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33836: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33840: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33844: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33992: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_33995: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34000: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34004: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34050: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34052: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34090: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF) &&
          TLI->isCanonicalized(MI.getOperand(2).getReg(), MF);
      
    llvm_unreachable("anonymous_34090 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_34117: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34119: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34145: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
          MF.getSubtarget().getTargetLowering());
    
        return TLI->isCanonicalized(MI.getOperand(1).getReg(), MF);
      
    llvm_unreachable("anonymous_34145 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_34147: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34149: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34151: {
    return true;
  }
  case GICXXPred_MI_Predicate_anonymous_34153: {
    return true;
  }
  case GICXXPred_MI_Predicate_bf16_fpround: {
    return false;
  }
  case GICXXPred_MI_Predicate_csh_mask_16: {
     return isUnneededShiftMask(MI, 4); 
  }
  case GICXXPred_MI_Predicate_csh_mask_32: {
     return isUnneededShiftMask(MI, 5); 
  }
  case GICXXPred_MI_Predicate_csh_mask_64: {
     return isUnneededShiftMask(MI, 6); 
  }
  case GICXXPred_MI_Predicate_fmaxnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_fminnum_like_nnan: {
    
        return isKnownNeverNaN(MI.getOperand(0).getReg(), MRI);
      
  }
  case GICXXPred_MI_Predicate_is_canonicalized: {
    
        const SITargetLowering *TLI = static_cast<const SITargetLowering *>(
            MF.getSubtarget().getTargetLowering());
        const MachineOperand &Dst = MI.getOperand(0);
        assert(Dst.isDef());
        return TLI->isCanonicalized(Dst.getReg(), MF);
       
    llvm_unreachable("is_canonicalized should have returned");
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_load_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_shl1_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl2_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl3_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl4_add: {
    return true;
  }
  case GICXXPred_MI_Predicate_shl_0_to_4: {
    
        int64_t Imm = 0;
        if (!mi_match(MI.getOperand(2).getReg(), MRI, m_ICst(Imm)) &&
            !mi_match(MI.getOperand(2).getReg(), MRI, m_Copy(m_ICst(Imm))))
          return false;
        return (uint64_t)Imm <= 4;
      
    llvm_unreachable("shl_0_to_4 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_extloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_extloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_load: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_load should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_prefetch: {
    
        return isInstrUniform(MI);
      
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_sextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_sextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi8: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi8 should have returned");
  }
  case GICXXPred_MI_Predicate_smrd_zextloadi16: {
    
        if (!MI.hasOneMemOperand())
          return false;
        if (!isInstrUniform(MI))
          return false;
    
        // FIXME: We should probably be caching this.
        SmallVector<GEPInfo, 4> AddrInfo;
        getAddrModeInfo(MI, MRI, AddrInfo);
    
        if (hasVgprParts(AddrInfo))
          return false;
        return true;
      
    llvm_unreachable("smrd_zextloadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  case GICXXPred_MI_Predicate_store_align_less_than_4_local_m0: {
    return (*MI.memoperands_begin())->getAlign() < 4;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_MFMALdScaleModifierOp,
  GICXXPred_I64_Predicate_NegSubInlineConst32,
  GICXXPred_I64_Predicate_NegSubInlineIntConst16,
  GICXXPred_I64_Predicate_SIMM16bit,
  GICXXPred_I64_Predicate_ShiftAmt32Imm,
  GICXXPred_I64_Predicate_SupportedRoundMode,
  GICXXPred_I64_Predicate_i32imm_one,
  GICXXPred_I64_Predicate_i32imm_zero,
  GICXXPred_I64_Predicate_i64imm_32bit,
};
bool AMDGPUInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask: {
    
      return isMask_32(Imm);
    
  }
  case GICXXPred_I64_Predicate_MFMALdScaleModifierOp: {
    
      return isUInt<2>(Imm);
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineConst32: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_NegSubInlineIntConst16: {
    
      return Imm < -16 && Imm >= -64;
    
  }
  case GICXXPred_I64_Predicate_SIMM16bit: {
    return isInt<16>(Imm) || isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_ShiftAmt32Imm: {
    
      return Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_SupportedRoundMode: {
    
      return Imm == (int)RoundingMode::TowardZero ||
             Imm == (int)RoundingMode::NearestTiesToEven ||
             Imm == (int)RoundingMode::TowardPositive ||
             Imm == (int)RoundingMode::TowardNegative;
    
  }
  case GICXXPred_I64_Predicate_i32imm_one: {
    
      return Imm == 1;
    
  }
  case GICXXPred_I64_Predicate_i32imm_zero: {
    
      return Imm == 0;
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_InlineImmFP32 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_InlineImmFP64,
  GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64,
  GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64,
};
bool AMDGPUInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_InlineImmFP32: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_InlineImmFP64: {
    
      return isInlineImmediate(Imm);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64: {
    
        if (!Imm.isNegative())
          return false;
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_neg_pow2_prefer_ldexp_f64 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64: {
    
        if (Imm.isNegative())
          return false;
    
        int Exp = Imm.getExactLog2Abs();
        // Prefer leaving the FP inline immediates as they are.
        // 0.5, 1.0, 2.0, 4.0
    
        // For f64 ldexp is always better than materializing a 64-bit
        // constant.
        return Exp != INT_MIN && (Exp < -1 || Exp > 2);
      
    llvm_unreachable("fpimm_pos_pow2_prefer_ldexp_f64 should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_InlineImm64 = GICXXPred_Invalid + 1,
};
bool AMDGPUInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_InlineImm64: {
    
      return isInlineImmediate(Imm);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderBitcastFPImm32,
  GICR_renderBitcastFPImm64,
  GICR_renderDstSelToOpSel3XFormXForm,
  GICR_renderDstSelToOpSelXForm,
  GICR_renderExtractCPol,
  GICR_renderExtractCpolSetGLC,
  GICR_renderExtractSWZ,
  GICR_renderFPPow2ToExponent,
  GICR_renderFrameIndex,
  GICR_renderNegateImm,
  GICR_renderOpSelTImm,
  GICR_renderPopcntImm,
  GICR_renderRoundMode,
  GICR_renderScaledMAIIntrinsicOperand,
  GICR_renderSrcAndDstSelToOpSelXForm_0_0,
  GICR_renderSrcAndDstSelToOpSelXForm_0_1,
  GICR_renderSrcAndDstSelToOpSelXForm_1_0,
  GICR_renderSrcAndDstSelToOpSelXForm_1_1,
  GICR_renderSrcAndDstSelToOpSelXForm_2_0,
  GICR_renderSrcSelToOpSelXForm,
  GICR_renderTruncTImm,
  GICR_renderZextBoolTImm,
};
AMDGPUInstructionSelector::CustomRendererFn
AMDGPUInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AMDGPUInstructionSelector::renderBitcastFPImm32,
  &AMDGPUInstructionSelector::renderBitcastFPImm64,
  &AMDGPUInstructionSelector::renderDstSelToOpSel3XFormXForm,
  &AMDGPUInstructionSelector::renderDstSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderExtractCPol,
  &AMDGPUInstructionSelector::renderExtractCpolSetGLC,
  &AMDGPUInstructionSelector::renderExtractSWZ,
  &AMDGPUInstructionSelector::renderFPPow2ToExponent,
  &AMDGPUInstructionSelector::renderFrameIndex,
  &AMDGPUInstructionSelector::renderNegateImm,
  &AMDGPUInstructionSelector::renderOpSelTImm,
  &AMDGPUInstructionSelector::renderPopcntImm,
  &AMDGPUInstructionSelector::renderRoundMode,
  &AMDGPUInstructionSelector::renderScaledMAIIntrinsicOperand,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_0_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_0,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_1_1,
  &AMDGPUInstructionSelector::renderSrcAndDstSelToOpSelXForm_2_0,
  &AMDGPUInstructionSelector::renderSrcSelToOpSelXForm,
  &AMDGPUInstructionSelector::renderTruncTImm,
  &AMDGPUInstructionSelector::renderZextBoolTImm,
};

bool AMDGPUInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AMDGPUInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AMDGPUInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(3709), /*)*//*default:*//*Label 167*/ GIMT_Encode4(702377),
    /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(14634),
    /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37700),
    /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(38323), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(38669),
    /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(40044),
    /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(55626), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FRAME_INDEX*//*Label 6*/ GIMT_Encode4(60292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BUILD_VECTOR*//*Label 7*/ GIMT_Encode4(60348), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BITCAST*//*Label 8*/ GIMT_Encode4(63618), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC_FPTRUNC_ROUND*//*Label 9*/ GIMT_Encode4(72091),
    /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(72183), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 11*/ GIMT_Encode4(72511),
    /*TargetOpcode::G_READCYCLECOUNTER*//*Label 12*/ GIMT_Encode4(72839),
    /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 13*/ GIMT_Encode4(72979),
    /*TargetOpcode::G_LOAD*//*Label 14*/ GIMT_Encode4(73037),
    /*TargetOpcode::G_SEXTLOAD*//*Label 15*/ GIMT_Encode4(148426),
    /*TargetOpcode::G_ZEXTLOAD*//*Label 16*/ GIMT_Encode4(154199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STORE*//*Label 17*/ GIMT_Encode4(160021), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 18*/ GIMT_Encode4(195927),
    /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 19*/ GIMT_Encode4(197053),
    /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 20*/ GIMT_Encode4(199265),
    /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 21*/ GIMT_Encode4(201777),
    /*TargetOpcode::G_ATOMICRMW_AND*//*Label 22*/ GIMT_Encode4(204289), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMICRMW_OR*//*Label 23*/ GIMT_Encode4(206801),
    /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 24*/ GIMT_Encode4(209313),
    /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 25*/ GIMT_Encode4(211825),
    /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 26*/ GIMT_Encode4(214337),
    /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 27*/ GIMT_Encode4(216849),
    /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 28*/ GIMT_Encode4(219361),
    /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 29*/ GIMT_Encode4(221873), GIMT_Encode4(0),
    /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 30*/ GIMT_Encode4(224732),
    /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 31*/ GIMT_Encode4(227378),
    /*TargetOpcode::G_ATOMICRMW_UINC_WRAP*//*Label 32*/ GIMT_Encode4(230024),
    /*TargetOpcode::G_ATOMICRMW_UDEC_WRAP*//*Label 33*/ GIMT_Encode4(232536), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(235048),
    /*TargetOpcode::G_PREFETCH*//*Label 35*/ GIMT_Encode4(235067), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_INTRINSIC*//*Label 36*/ GIMT_Encode4(235503),
    /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 37*/ GIMT_Encode4(253699),
    /*TargetOpcode::G_INTRINSIC_CONVERGENT*//*Label 38*/ GIMT_Encode4(258410),
    /*TargetOpcode::G_INTRINSIC_CONVERGENT_W_SIDE_EFFECTS*//*Label 39*/ GIMT_Encode4(284324),
    /*TargetOpcode::G_ANYEXT*//*Label 40*/ GIMT_Encode4(285880),
    /*TargetOpcode::G_TRUNC*//*Label 41*/ GIMT_Encode4(286443),
    /*TargetOpcode::G_CONSTANT*//*Label 42*/ GIMT_Encode4(286683),
    /*TargetOpcode::G_FCONSTANT*//*Label 43*/ GIMT_Encode4(287409), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SEXT*//*Label 44*/ GIMT_Encode4(287787), GIMT_Encode4(0),
    /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(288590),
    /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(291636),
    /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(293172),
    /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(294334), GIMT_Encode4(0),
    /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(295496),
    /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(295541), GIMT_Encode4(0),
    /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(295573),
    /*TargetOpcode::G_FCMP*//*Label 52*/ GIMT_Encode4(296835), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_SELECT*//*Label 53*/ GIMT_Encode4(300956), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_UMULH*//*Label 54*/ GIMT_Encode4(301160),
    /*TargetOpcode::G_SMULH*//*Label 55*/ GIMT_Encode4(301269),
    /*TargetOpcode::G_UADDSAT*//*Label 56*/ GIMT_Encode4(301378),
    /*TargetOpcode::G_SADDSAT*//*Label 57*/ GIMT_Encode4(301766),
    /*TargetOpcode::G_USUBSAT*//*Label 58*/ GIMT_Encode4(302092),
    /*TargetOpcode::G_SSUBSAT*//*Label 59*/ GIMT_Encode4(302480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FADD*//*Label 60*/ GIMT_Encode4(302806),
    /*TargetOpcode::G_FSUB*//*Label 61*/ GIMT_Encode4(304164),
    /*TargetOpcode::G_FMUL*//*Label 62*/ GIMT_Encode4(304528),
    /*TargetOpcode::G_FMA*//*Label 63*/ GIMT_Encode4(305914),
    /*TargetOpcode::G_FMAD*//*Label 64*/ GIMT_Encode4(307552), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FPOW*//*Label 65*/ GIMT_Encode4(308498), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FEXP2*//*Label 66*/ GIMT_Encode4(308616), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FLOG2*//*Label 67*/ GIMT_Encode4(308839), GIMT_Encode4(0),
    /*TargetOpcode::G_FLDEXP*//*Label 68*/ GIMT_Encode4(309062), GIMT_Encode4(0),
    /*TargetOpcode::G_FNEG*//*Label 69*/ GIMT_Encode4(309425),
    /*TargetOpcode::G_FPEXT*//*Label 70*/ GIMT_Encode4(311764),
    /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(312164),
    /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(313531),
    /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(314199),
    /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(314867),
    /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(315600), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(316333),
    /*TargetOpcode::G_FCOPYSIGN*//*Label 77*/ GIMT_Encode4(317338),
    /*TargetOpcode::G_IS_FPCLASS*//*Label 78*/ GIMT_Encode4(317895),
    /*TargetOpcode::G_FCANONICALIZE*//*Label 79*/ GIMT_Encode4(318167),
    /*TargetOpcode::G_FMINNUM*//*Label 80*/ GIMT_Encode4(319367),
    /*TargetOpcode::G_FMAXNUM*//*Label 81*/ GIMT_Encode4(372986),
    /*TargetOpcode::G_FMINNUM_IEEE*//*Label 82*/ GIMT_Encode4(426605),
    /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 83*/ GIMT_Encode4(480224),
    /*TargetOpcode::G_FMINIMUM*//*Label 84*/ GIMT_Encode4(533843),
    /*TargetOpcode::G_FMAXIMUM*//*Label 85*/ GIMT_Encode4(535462), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_GET_FPMODE*//*Label 86*/ GIMT_Encode4(537081), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_PTR_ADD*//*Label 87*/ GIMT_Encode4(537205), GIMT_Encode4(0),
    /*TargetOpcode::G_SMIN*//*Label 88*/ GIMT_Encode4(537282),
    /*TargetOpcode::G_SMAX*//*Label 89*/ GIMT_Encode4(540510),
    /*TargetOpcode::G_UMIN*//*Label 90*/ GIMT_Encode4(543900),
    /*TargetOpcode::G_UMAX*//*Label 91*/ GIMT_Encode4(547128),
    /*TargetOpcode::G_ABS*//*Label 92*/ GIMT_Encode4(550356), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_BR*//*Label 93*/ GIMT_Encode4(550493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 94*/ GIMT_Encode4(550527), GIMT_Encode4(0),
    /*TargetOpcode::G_CTLZ_ZERO_UNDEF*//*Label 95*/ GIMT_Encode4(550626),
    /*TargetOpcode::G_CTPOP*//*Label 96*/ GIMT_Encode4(550728),
    /*TargetOpcode::G_BSWAP*//*Label 97*/ GIMT_Encode4(550943),
    /*TargetOpcode::G_BITREVERSE*//*Label 98*/ GIMT_Encode4(551890),
    /*TargetOpcode::G_FCEIL*//*Label 99*/ GIMT_Encode4(552138), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_FSQRT*//*Label 100*/ GIMT_Encode4(552466),
    /*TargetOpcode::G_FFLOOR*//*Label 101*/ GIMT_Encode4(552758), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FADD*//*Label 102*/ GIMT_Encode4(553272),
    /*TargetOpcode::G_STRICT_FSUB*//*Label 103*/ GIMT_Encode4(554234),
    /*TargetOpcode::G_STRICT_FMUL*//*Label 104*/ GIMT_Encode4(554598), GIMT_Encode4(0), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(555866), GIMT_Encode4(0),
    /*TargetOpcode::G_STRICT_FLDEXP*//*Label 106*/ GIMT_Encode4(556754), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*AMDGPU::G_AMDGPU_ATOMIC_CMPXCHG*//*Label 107*/ GIMT_Encode4(557117),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_ADD*//*Label 108*/ GIMT_Encode4(559421),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_AND*//*Label 109*/ GIMT_Encode4(561805),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_CMPSWAP*//*Label 110*/ GIMT_Encode4(564189),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_COND_SUB_U32*//*Label 111*/ GIMT_Encode4(568483),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_DEC*//*Label 112*/ GIMT_Encode4(569100),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FADD*//*Label 113*/ GIMT_Encode4(571484),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMAX*//*Label 114*/ GIMT_Encode4(576310),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_FMIN*//*Label 115*/ GIMT_Encode4(579926),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_INC*//*Label 116*/ GIMT_Encode4(583542),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_OR*//*Label 117*/ GIMT_Encode4(585926),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMAX*//*Label 118*/ GIMT_Encode4(588310),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SMIN*//*Label 119*/ GIMT_Encode4(590694),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SUB*//*Label 120*/ GIMT_Encode4(593078),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_SWAP*//*Label 121*/ GIMT_Encode4(595462),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMAX*//*Label 122*/ GIMT_Encode4(599006),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_UMIN*//*Label 123*/ GIMT_Encode4(601390),
    /*AMDGPU::G_AMDGPU_BUFFER_ATOMIC_XOR*//*Label 124*/ GIMT_Encode4(603774),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD*//*Label 125*/ GIMT_Encode4(606158),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT*//*Label 126*/ GIMT_Encode4(623318),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_D16*//*Label 127*/ GIMT_Encode4(628226),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_FORMAT_TFE*//*Label 128*/ GIMT_Encode4(635971),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE*//*Label 129*/ GIMT_Encode4(638491),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SBYTE_TFE*//*Label 130*/ GIMT_Encode4(639097),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT*//*Label 131*/ GIMT_Encode4(639703),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_SSHORT_TFE*//*Label 132*/ GIMT_Encode4(640309),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_TFE*//*Label 133*/ GIMT_Encode4(640915),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE*//*Label 134*/ GIMT_Encode4(643435),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_UBYTE_TFE*//*Label 135*/ GIMT_Encode4(644041),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT*//*Label 136*/ GIMT_Encode4(644647),
    /*AMDGPU::G_AMDGPU_BUFFER_LOAD_USHORT_TFE*//*Label 137*/ GIMT_Encode4(645253),
    /*AMDGPU::G_AMDGPU_BUFFER_STORE*//*Label 138*/ GIMT_Encode4(645859),
    /*AMDGPU::G_AMDGPU_BUFFER_STORE_BYTE*//*Label 139*/ GIMT_Encode4(662955),
    /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT*//*Label 140*/ GIMT_Encode4(663557),
    /*AMDGPU::G_AMDGPU_BUFFER_STORE_FORMAT_D16*//*Label 141*/ GIMT_Encode4(669045),
    /*AMDGPU::G_AMDGPU_BUFFER_STORE_SHORT*//*Label 142*/ GIMT_Encode4(675310),
    /*AMDGPU::G_AMDGPU_CLAMP*//*Label 143*/ GIMT_Encode4(675912),
    /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 144*/ GIMT_Encode4(676851),
    /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 145*/ GIMT_Encode4(676896),
    /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 146*/ GIMT_Encode4(676941),
    /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 147*/ GIMT_Encode4(676986),
    /*AMDGPU::G_AMDGPU_CVT_PK_I16_I32*//*Label 148*/ GIMT_Encode4(677031),
    /*AMDGPU::G_AMDGPU_FFBH_U32*//*Label 149*/ GIMT_Encode4(677061),
    /*AMDGPU::G_AMDGPU_FFBL_B32*//*Label 150*/ GIMT_Encode4(677163),
    /*AMDGPU::G_AMDGPU_FMAX_LEGACY*//*Label 151*/ GIMT_Encode4(677262),
    /*AMDGPU::G_AMDGPU_FMED3*//*Label 152*/ GIMT_Encode4(677335),
    /*AMDGPU::G_AMDGPU_FMIN_LEGACY*//*Label 153*/ GIMT_Encode4(677695), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*AMDGPU::G_AMDGPU_RCP_IFLAG*//*Label 154*/ GIMT_Encode4(677768),
    /*AMDGPU::G_AMDGPU_SMED3*//*Label 155*/ GIMT_Encode4(677818),
    /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD*//*Label 156*/ GIMT_Encode4(678124),
    /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SBYTE*//*Label 157*/ GIMT_Encode4(680426),
    /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_SSHORT*//*Label 158*/ GIMT_Encode4(680564),
    /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_UBYTE*//*Label 159*/ GIMT_Encode4(680702),
    /*AMDGPU::G_AMDGPU_S_BUFFER_LOAD_USHORT*//*Label 160*/ GIMT_Encode4(680840),
    /*AMDGPU::G_AMDGPU_S_BUFFER_PREFETCH*//*Label 161*/ GIMT_Encode4(680978), GIMT_Encode4(0), GIMT_Encode4(0),
    /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT*//*Label 162*/ GIMT_Encode4(681085),
    /*AMDGPU::G_AMDGPU_TBUFFER_LOAD_FORMAT_D16*//*Label 163*/ GIMT_Encode4(686569),
    /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT*//*Label 164*/ GIMT_Encode4(691998),
    /*AMDGPU::G_AMDGPU_TBUFFER_STORE_FORMAT_D16*//*Label 165*/ GIMT_Encode4(697466),
    /*AMDGPU::G_AMDGPU_UMED3*//*Label 166*/ GIMT_Encode4(702071),
    // Label 0: @14634
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 173*/ GIMT_Encode4(37699),
    /*GILLT_s1*//*Label 168*/ GIMT_Encode4(14665),
    /*GILLT_s16*//*Label 169*/ GIMT_Encode4(14784),
    /*GILLT_s32*//*Label 170*/ GIMT_Encode4(15599),
    /*GILLT_s64*//*Label 171*/ GIMT_Encode4(36958),
    /*GILLT_v2s16*//*Label 172*/ GIMT_Encode4(37429),
    // Label 168: @14665
    GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(14783),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
      GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(14704), // Rule ID 7574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7574,
        GIR_EraseRootFromParent_Done,
      // Label 175: @14704
      GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(14732), // Rule ID 7581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7581,
        GIR_EraseRootFromParent_Done,
      // Label 176: @14732
      GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(14757), // Rule ID 7572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7572,
        GIR_Done,
      // Label 177: @14757
      GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(14782), // Rule ID 7579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (add:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7579,
        GIR_Done,
      // Label 178: @14782
      GIM_Reject,
    // Label 174: @14783
    GIM_Reject,
    // Label 169: @14784
    GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(15598),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(14847), // Rule ID 7070 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33421),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i16] } (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_33421>>), i16:{ *:[i16] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7070,
        GIR_EraseRootFromParent_Done,
      // Label 180: @14847
      GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(14899), // Rule ID 11246 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33421),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$val, (trunc:{ *:[i16] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_33421>>))  =>  (V_BCNT_U32_B32_e64:{ *:[i16] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i16] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // popcnt
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11246,
        GIR_EraseRootFromParent_Done,
      // Label 181: @14899
      GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(14942), // Rule ID 2439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2439,
        GIR_EraseRootFromParent_Done,
      // Label 182: @14942
      GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(14994), // Rule ID 2583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2583,
        GIR_EraseRootFromParent_Done,
      // Label 183: @14994
      GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(15046), // Rule ID 2588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1)  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1), 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2588,
        GIR_EraseRootFromParent_Done,
      // Label 184: @15046
      GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(15096), // Rule ID 2477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2477,
        GIR_EraseRootFromParent_Done,
      // Label 185: @15096
      GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(15158), // Rule ID 2478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2478,
        GIR_EraseRootFromParent_Done,
      // Label 186: @15158
      GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(15220), // Rule ID 2479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2)  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2479,
        GIR_EraseRootFromParent_Done,
      // Label 187: @15220
      GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(15270), // Rule ID 8583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX6GFX7GFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8583,
        GIR_EraseRootFromParent_Done,
      // Label 188: @15270
      GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(15332), // Rule ID 8584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8584,
        GIR_EraseRootFromParent_Done,
      // Label 189: @15332
      GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(15394), // Rule ID 8585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAD_U16_gfx9_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i16] }:$src1, 0:{ *:[i32] }, ?:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_gfx9_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8585,
        GIR_EraseRootFromParent_Done,
      // Label 190: @15394
      GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(15453), // Rule ID 1060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1060,
        GIR_EraseRootFromParent_Done,
      // Label 191: @15453
      GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(15512), // Rule ID 1061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1061,
        GIR_EraseRootFromParent_Done,
      // Label 192: @15512
      GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(15571), // Rule ID 1062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (add:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1062,
        GIR_EraseRootFromParent_Done,
      // Label 193: @15571
      GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(15597), // Rule ID 910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 910,
        GIR_EraseRootFromParent_Done,
      // Label 194: @15597
      GIM_Reject,
    // Label 179: @15598
    GIM_Reject,
    // Label 170: @15599
    GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(36957),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(16109), // Rule ID 8691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src1
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/16,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8691,
        GIR_EraseRootFromParent_Done,
      // Label 196: @16109
      GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(16608), // Rule ID 8690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/12, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src1
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/16,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/19, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8690,
        GIR_EraseRootFromParent_Done,
      // Label 197: @16608
      GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(17107), // Rule ID 8689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8689,
        GIR_EraseRootFromParent_Done,
      // Label 198: @17107
      GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(17606), // Rule ID 8688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8688,
        GIR_EraseRootFromParent_Done,
      // Label 199: @17606
      GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(18105), // Rule ID 8687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src1
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8687,
        GIR_EraseRootFromParent_Done,
      // Label 200: @18105
      GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(18604), // Rule ID 8686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src1
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/14, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8686,
        GIR_EraseRootFromParent_Done,
      // Label 201: @18604
      GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(19103), // Rule ID 8685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src0
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8685,
        GIR_EraseRootFromParent_Done,
      // Label 202: @19103
      GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(19602), // Rule ID 8684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src0
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/18, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8684,
        GIR_EraseRootFromParent_Done,
      // Label 203: @19602
      GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(20101), // Rule ID 8683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src1
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/13,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/14,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src0
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8683,
        GIR_EraseRootFromParent_Done,
      // Label 204: @20101
      GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(20600), // Rule ID 8682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/9, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src1
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/13,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/14,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src0
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/16, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8682,
        GIR_EraseRootFromParent_Done,
      // Label 205: @20600
      GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(21099), // Rule ID 8681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8681,
        GIR_EraseRootFromParent_Done,
      // Label 206: @21099
      GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(21598), // Rule ID 8680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8680,
        GIR_EraseRootFromParent_Done,
      // Label 207: @21598
      GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(22097), // Rule ID 8679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8679,
        GIR_EraseRootFromParent_Done,
      // Label 208: @22097
      GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(22596), // Rule ID 8678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/11, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8678,
        GIR_EraseRootFromParent_Done,
      // Label 209: @22596
      GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(23095), // Rule ID 8677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src0
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8677,
        GIR_EraseRootFromParent_Done,
      // Label 210: @23095
      GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(23594), // Rule ID 2673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src0
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/8, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
        GIM_CheckConstantInt, /*MI*/10, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/13, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        GIM_CheckConstantInt, /*MI*/15, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 255:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), 255:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), 255:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_U32_U8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2673,
        GIR_EraseRootFromParent_Done,
      // Label 211: @23594
      GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(24069), // Rule ID 9971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
        // MIs[12] Operand 2
        GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src1
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/16,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[19] Operand 2
        GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9971,
        GIR_EraseRootFromParent_Done,
      // Label 212: @24069
      GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(24544), // Rule ID 9970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/11, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/11, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/12, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/1, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/13, /*Op*/2, 8,
        // MIs[12] Operand 2
        GIM_CheckLiteralInt, /*MI*/12, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/11, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/14, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/1, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[15] src1
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/15, /*Op*/2, 8,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/10, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/16,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[19] Operand 2
        GIM_CheckLiteralInt, /*MI*/19, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/16, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9970,
        GIR_EraseRootFromParent_Done,
      // Label 213: @24544
      GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(25019), // Rule ID 9969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9969,
        GIR_EraseRootFromParent_Done,
      // Label 214: @25019
      GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(25494), // Rule ID 9968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src0
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/5, /*OpIdx*/3, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 16,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/4, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/10, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 8,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 8,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9968,
        GIR_EraseRootFromParent_Done,
      // Label 215: @25494
      GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(25969), // Rule ID 9967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
        // MIs[7] Operand 2
        GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src1
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9967,
        GIR_EraseRootFromParent_Done,
      // Label 216: @25969
      GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(26444), // Rule ID 9966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/6, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/6, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/8, /*Op*/2, 8,
        // MIs[7] Operand 2
        GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/6, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src1
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/5, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/11,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[13] src0
        GIM_CheckIsSameOperand, /*MI*/13, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/12, /*OpIdx*/3, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[14] Operand 2
        GIM_CheckLiteralInt, /*MI*/14, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/11, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9966,
        GIR_EraseRootFromParent_Done,
      // Label 217: @26444
      GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(26919), // Rule ID 9965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src0
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9965,
        GIR_EraseRootFromParent_Done,
      // Label 218: @26919
      GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(27394), // Rule ID 9964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/6,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[8] src0
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/7, /*OpIdx*/3, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[9] src1
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/5, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/10, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/10, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/10, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/10,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/2, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src0
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/10, /*OpIdx*/3, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src1
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/4, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/15, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/15, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/15, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/15, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/15,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/2, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/16, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/16, /*OpIdx*/1, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[17] src0
        GIM_CheckIsSameOperand, /*MI*/17, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/17, /*Op*/2, 16,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/15, /*OpIdx*/3, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/18, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/18, /*OpIdx*/1, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 16,
        // MIs[18] Operand 2
        GIM_CheckLiteralInt, /*MI*/18, /*Op*/2, GIMT_Encode8(8),
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9964,
        GIR_EraseRootFromParent_Done,
      // Label 219: @27394
      GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(27869), // Rule ID 9963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src1
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/13,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/14,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[15] src0
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9963,
        GIR_EraseRootFromParent_Done,
      // Label 220: @27869
      GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(28344), // Rule ID 9962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/8, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/8, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/9, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/1, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/10, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/10, /*Op*/2, 8,
        // MIs[9] Operand 2
        GIM_CheckLiteralInt, /*MI*/9, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/8, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/11, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/11, /*OpIdx*/1, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[12] src1
        GIM_CheckIsSameOperand, /*MI*/12, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/12, /*Op*/2, 8,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/7, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/13, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/13,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/2, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/14, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/14, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/14, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/14,
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/14, /*OpIdx*/2, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[15] src0
        GIM_CheckIsSameOperand, /*MI*/15, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/14, /*OpIdx*/3, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        // MIs[16] Operand 2
        GIM_CheckLiteralInt, /*MI*/16, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/13, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9962,
        GIR_EraseRootFromParent_Done,
      // Label 221: @28344
      GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(28819), // Rule ID 9961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9961,
        GIR_EraseRootFromParent_Done,
      // Label 222: @28819
      GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(29294), // Rule ID 9960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/1, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/7, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 8,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 8,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9960,
        GIR_EraseRootFromParent_Done,
      // Label 223: @29294
      GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(29769), // Rule ID 9959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        // MIs[4] Operand 2
        GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9959,
        GIR_EraseRootFromParent_Done,
      // Label 224: @29769
      GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(30244), // Rule ID 9958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/3, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/3, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        // MIs[4] Operand 2
        GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 8,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/8, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/8,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/2, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/9, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/9, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/9, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/9,
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/9, /*OpIdx*/2, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[10] src0
        GIM_CheckIsSameOperand, /*MI*/10, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/9, /*OpIdx*/3, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        // MIs[11] Operand 2
        GIM_CheckLiteralInt, /*MI*/11, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/7, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9958,
        GIR_EraseRootFromParent_Done,
      // Label 225: @30244
      GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(30719), // Rule ID 9957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src0
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9957,
        GIR_EraseRootFromParent_Done,
      // Label 226: @30719
      GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(31194), // Rule ID 2689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/4, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/4, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[5] Operand 2
        GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/3, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/2, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/7, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/7, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/7,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/2, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/9, /*MI*/8, /*OpIdx*/1, // MIs[9]
        GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/9, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[9] src0
        GIM_CheckIsSameOperand, /*MI*/9, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/9, /*Op*/2, 8,
        // MIs[8] Operand 2
        GIM_CheckLiteralInt, /*MI*/8, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/10, /*MI*/7, /*OpIdx*/3, // MIs[10]
        GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/10, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/11, /*MI*/10, /*OpIdx*/1, // MIs[11]
        GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/11, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[11] src1
        GIM_CheckIsSameOperand, /*MI*/11, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/11, /*Op*/2, 8,
        // MIs[10] Operand 2
        GIM_CheckLiteralInt, /*MI*/10, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/12, /*MI*/1, /*OpIdx*/2, // MIs[12]
        GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/12, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/12, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/12, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/12, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/12,
        GIM_RecordInsn, /*DefineMI*/13, /*MI*/12, /*OpIdx*/2, // MIs[13]
        GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/13, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/14, /*MI*/13, /*OpIdx*/1, // MIs[14]
        GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/14, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[14] src0
        GIM_CheckIsSameOperand, /*MI*/14, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/14, /*Op*/2, 16,
        // MIs[13] Operand 2
        GIM_CheckLiteralInt, /*MI*/13, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/15, /*MI*/12, /*OpIdx*/3, // MIs[15]
        GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/15, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/16, /*MI*/15, /*OpIdx*/1, // MIs[16]
        GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/16, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[16] src1
        GIM_CheckIsSameOperand, /*MI*/16, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/16, /*Op*/2, 16,
        // MIs[15] Operand 2
        GIM_CheckLiteralInt, /*MI*/15, /*Op*/2, GIMT_Encode8(8),
        GIM_RecordInsn, /*DefineMI*/17, /*MI*/0, /*OpIdx*/2, // MIs[17]
        GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/17, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/17, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/17, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/17, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/17,
        GIM_RecordInsn, /*DefineMI*/18, /*MI*/17, /*OpIdx*/2, // MIs[18]
        GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/18, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[18] src0
        GIM_CheckIsSameOperand, /*MI*/18, /*OpIdx*/1, /*OtherMI*/5, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/18, /*Op*/2, 24,
        GIM_RecordInsn, /*DefineMI*/19, /*MI*/17, /*OpIdx*/3, // MIs[19]
        GIM_CheckOpcode, /*MI*/19, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/19, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[19] src1
        GIM_CheckIsSameOperand, /*MI*/19, /*OpIdx*/1, /*OtherMI*/6, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/19, /*Op*/2, 24,
        GIM_CheckIsSafeToFold, /*NumInsns*/19,
        // (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 8:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 8:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), i8:{ *:[Other] }), (sext_inreg:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }), i8:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 24:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 24:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>  =>  (V_DOT4_I32_I8:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2689,
        GIR_EraseRootFromParent_Done,
      // Label 227: @31194
      GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(31417), // Rule ID 8614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8614,
        GIR_EraseRootFromParent_Done,
      // Label 228: @31417
      GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(31640), // Rule ID 8615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8615,
        GIR_EraseRootFromParent_Done,
      // Label 229: @31640
      GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(31863), // Rule ID 2665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2665,
        GIR_EraseRootFromParent_Done,
      // Label 230: @31863
      GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(32086), // Rule ID 8613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/2, GIMT_Encode8(65535),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        GIM_CheckConstantInt, /*MI*/7, /*Op*/2, GIMT_Encode8(65535),
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, 65535:{ *:[i32] }), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, 65535:{ *:[i32] }))<<P:Predicate_AMDGPUmul_u24_oneuse>>)  =>  (V_DOT2_U32_U16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8613,
        GIR_EraseRootFromParent_Done,
      // Label 231: @32086
      GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(32301), // Rule ID 8646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8646,
        GIR_EraseRootFromParent_Done,
      // Label 232: @32301
      GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(32516), // Rule ID 8647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[2] Operand 2
        GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[3] Operand 2
        GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, 16,
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8647,
        GIR_EraseRootFromParent_Done,
      // Label 233: @32516
      GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(32731), // Rule ID 2669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[7] Operand 2
        GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2669,
        GIR_EraseRootFromParent_Done,
      // Label 234: @32731
      GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(32946), // Rule ID 8645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/5, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/5, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/5,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[6] src0
        GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
        // MIs[6] Operand 2
        GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(16),
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/5, /*OpIdx*/3, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
        // MIs[7] src1
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
        // MIs[7] Operand 2
        GIM_CheckLiteralInt, /*MI*/7, /*Op*/2, GIMT_Encode8(16),
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, 16:{ *:[i32] }), (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, 16:{ *:[i32] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)<<P:Predicate_add_oneuse>>, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src0, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$src1, i16:{ *:[Other] }))<<P:Predicate_AMDGPUmul_i24_oneuse>>)  =>  (V_DOT2_I32_I16:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[i32] }:$src0, 8:{ *:[i32] }, ?:{ *:[i32] }:$src1, 8:{ *:[i32] }, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8645,
        GIR_EraseRootFromParent_Done,
      // Label 235: @32946
      GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(32999), // Rule ID 7710 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13381),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_13381>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7710,
        GIR_EraseRootFromParent_Done,
      // Label 236: @32999
      GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(33052), // Rule ID 7712 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] })<<P:Predicate_anonymous_19065>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7712,
        GIR_EraseRootFromParent_Done,
      // Label 237: @33052
      GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(33162), // Rule ID 7537 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[2] Operand 1
        GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
        // MIs[4] src1
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
        // MIs[4] src0
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[i32] } (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7537,
        GIR_EraseRootFromParent_Done,
      // Label 238: @33162
      GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(33272), // Rule ID 11287 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        // MIs[2] Operand 1
        GIM_CheckCmpPredicate, /*MI*/2, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/3,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/3, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SUB),
        // MIs[4] src1
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/3,
        // MIs[4] src0
        GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (select:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] }), (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (sub:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_select_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11287,
        GIR_EraseRootFromParent_Done,
      // Label 239: @33272
      GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(33365), // Rule ID 2495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20097),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20098>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20097>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2495,
        GIR_EraseRootFromParent_Done,
      // Label 240: @33365
      GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(33458), // Rule ID 8587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20097),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:1:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20098>>)<<P:1:Predicate_anonymous_20097>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8587,
        GIR_EraseRootFromParent_Done,
      // Label 241: @33458
      GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(33513), // Rule ID 7484 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7484,
        GIR_EraseRootFromParent_Done,
      // Label 242: @33513
      GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(33568), // Rule ID 7486 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2)  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7486,
        GIR_EraseRootFromParent_Done,
      // Label 243: @33568
      GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(33633), // Rule ID 82 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 82,
        GIR_EraseRootFromParent_Done,
      // Label 244: @33633
      GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(33698), // Rule ID 83 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 83,
        GIR_EraseRootFromParent_Done,
      // Label 245: @33698
      GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(33763), // Rule ID 84 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 84,
        GIR_EraseRootFromParent_Done,
      // Label 246: @33763
      GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(33828), // Rule ID 85 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 85,
        GIR_EraseRootFromParent_Done,
      // Label 247: @33828
      GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(33911), // Rule ID 7536 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7536,
        GIR_EraseRootFromParent_Done,
      // Label 248: @33911
      GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(33994), // Rule ID 11280 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11280,
        GIR_EraseRootFromParent_Done,
      // Label 249: @33994
      GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(34077), // Rule ID 11281 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11281,
        GIR_EraseRootFromParent_Done,
      // Label 250: @34077
      GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(34160), // Rule ID 11282 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11282,
        GIR_EraseRootFromParent_Done,
      // Label 251: @34160
      GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(34225), // Rule ID 8503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl1_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 1:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl1_add>>  =>  (S_LSHL1_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL1_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8503,
        GIR_EraseRootFromParent_Done,
      // Label 252: @34225
      GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(34290), // Rule ID 8504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl2_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 2:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl2_add>>  =>  (S_LSHL2_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL2_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8504,
        GIR_EraseRootFromParent_Done,
      // Label 253: @34290
      GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(34355), // Rule ID 8505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl3_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 3:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl3_add>>  =>  (S_LSHL3_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL3_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8505,
        GIR_EraseRootFromParent_Done,
      // Label 254: @34355
      GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(34420), // Rule ID 8506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 4,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl4_add),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, 4:{ *:[i32] })<<P:Predicate_shl_oneuse>>)<<P:Predicate_shl4_add>>  =>  (S_LSHL4_ADD_U32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL4_ADD_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8506,
        GIR_EraseRootFromParent_Done,
      // Label 255: @34420
      GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(34475), // Rule ID 11247 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_I32_I24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_I32_I24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11247,
        GIR_EraseRootFromParent_Done,
      // Label 256: @34475
      GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(34530), // Rule ID 11249 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U32_U24_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U32_U24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11249,
        GIR_EraseRootFromParent_Done,
      // Label 257: @34530
      GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(34613), // Rule ID 11283 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11283,
        GIR_EraseRootFromParent_Done,
      // Label 258: @34613
      GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(34696), // Rule ID 11284 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11284,
        GIR_EraseRootFromParent_Done,
      // Label 259: @34696
      GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(34779), // Rule ID 11285 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11285,
        GIR_EraseRootFromParent_Done,
      // Label 260: @34779
      GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(34862), // Rule ID 11286 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, (sub:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))<<P:Predicate_sub_oneuse>>)  =>  (V_SAD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11286,
        GIR_EraseRootFromParent_Done,
      // Label 261: @34862
      GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(35027), // Rule ID 8597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:11:z
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:11:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20133>>)<<P:11:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8597,
        GIR_EraseRootFromParent_Done,
      // Label 262: @35027
      GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(35192), // Rule ID 8601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:14:z
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } VGPR_32:{ *:[i32] }:$src2:$pred:14:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20133>>)<<P:14:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8601,
        GIR_EraseRootFromParent_Done,
      // Label 263: @35192
      GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(35257), // Rule ID 2498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:3:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20103),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20101>>, i32:{ *:[i32] }:$src2:$pred:3:z)<<P:3:Predicate_anonymous_20103>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2498,
        GIR_EraseRootFromParent_Done,
      // Label 264: @35257
      GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(35422), // Rule ID 2517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:11:z
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:11:x, i32:{ *:[i32] }:$src1:$pred:11:y)<<P:Predicate_anonymous_20133>>, VGPR_32:{ *:[i32] }:$src2:$pred:11:z)<<P:11:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 2517,
        GIR_EraseRootFromParent_Done,
      // Label 265: @35422
      GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(35587), // Rule ID 2522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:14:z
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:14:x, i32:{ *:[i32] }:$src1:$pred:14:y)<<P:Predicate_anonymous_20133>>, VGPR_32:{ *:[i32] }:$src2:$pred:14:z)<<P:14:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 2522,
        GIR_EraseRootFromParent_Done,
      // Label 266: @35587
      GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(35748), // Rule ID 2516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:10:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20133>>, i32:{ *:[i32] }:$src2:$pred:10:z)<<P:10:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 2516,
        GIR_EraseRootFromParent_Done,
      // Label 267: @35748
      GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(35909), // Rule ID 2521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:13:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20133>>, i32:{ *:[i32] }:$src2:$pred:13:z)<<P:13:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 2521,
        GIR_EraseRootFromParent_Done,
      // Label 268: @35909
      GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(35974), // Rule ID 2494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:1:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20097),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20098>>, i32:{ *:[i32] }:$src2:$pred:1:z)<<P:1:Predicate_anonymous_20097>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2494,
        GIR_EraseRootFromParent_Done,
      // Label 269: @35974
      GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(36039), // Rule ID 2504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:8:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20116),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20117>>, i32:{ *:[i32] }:$src2:$pred:8:z)<<P:8:Predicate_anonymous_20116>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2504,
        GIR_EraseRootFromParent_Done,
      // Label 270: @36039
      GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(36079), // Rule ID 7068 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33421),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_33421>>, i32:{ *:[i32] }:$val)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
        GIR_RootToRootCopy, /*OpIdx*/2, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7068,
        GIR_EraseRootFromParent_Done,
      // Label 271: @36079
      GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(36144), // Rule ID 8588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:3:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20103),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:3:z, (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:3:x, i32:{ *:[i32] }:$src1:$pred:3:y)<<P:Predicate_anonymous_20101>>)<<P:3:Predicate_anonymous_20103>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8588,
        GIR_EraseRootFromParent_Done,
      // Label 272: @36144
      GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(36305), // Rule ID 8596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:10:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:10:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:10:x, i32:{ *:[i32] }:$src1:$pred:10:y)<<P:Predicate_anonymous_20133>>)<<P:10:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8596,
        GIR_EraseRootFromParent_Done,
      // Label 273: @36305
      GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(36466), // Rule ID 8600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:13:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20132),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:13:z, (mul:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:13:x, i32:{ *:[i32] }:$src1:$pred:13:y)<<P:Predicate_anonymous_20133>>)<<P:13:Predicate_anonymous_20132>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src2, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i1] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8600,
        GIR_EraseRootFromParent_Done,
      // Label 274: @36466
      GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(36531), // Rule ID 8586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:1:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20097),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:1:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:1:x, i32:{ *:[i32] }:$src1:$pred:1:y)<<P:Predicate_anonymous_20098>>)<<P:1:Predicate_anonymous_20097>>  =>  (V_LSHL_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8586,
        GIR_EraseRootFromParent_Done,
      // Label 275: @36531
      GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(36596), // Rule ID 8593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:8:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20116),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:8:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:8:x, i32:{ *:[i32] }:$src1:$pred:8:y)<<P:Predicate_anonymous_20117>>)<<P:8:Predicate_anonymous_20116>>  =>  (V_XAD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XAD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8593,
        GIR_EraseRootFromParent_Done,
      // Label 276: @36596
      GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(36636), // Rule ID 11245 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33421),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$val, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_33421>>)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$popcnt, ?:{ *:[i32] }:$val)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // popcnt
        GIR_RootToRootCopy, /*OpIdx*/1, // val
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11245,
        GIR_EraseRootFromParent_Done,
      // Label 277: @36636
      GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(36680), // Rule ID 7705 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13381),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_13381>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i1 i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7705,
        GIR_EraseRootFromParent_Done,
      // Label 278: @36680
      GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(36727), // Rule ID 7706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19065>>  =>  (V_SUB_U32_e64:{ *:[i32] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7706,
        GIR_EraseRootFromParent_Done,
      // Label 279: @36727
      GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(36782), // Rule ID 7707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasAddNoCarryInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineConst32),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>><<X:NegateImm>>:$src1)<<P:Predicate_anonymous_19065>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VS_32:{ *:[i32] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i32] })<<P:Predicate_NegSubInlineConst32>>:$src1))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7707,
        GIR_EraseRootFromParent_Done,
      // Label 280: @36782
      GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(36816), // Rule ID 43 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13381),
        // (add:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13381>>  =>  (S_ADD_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 43,
        GIR_Done,
      // Label 281: @36816
      GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(36846), // Rule ID 2402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19065>>  =>  (V_ADD_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2402,
        GIR_EraseRootFromParent_Done,
      // Label 282: @36846
      GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(36884), // Rule ID 2404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19065>>  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2404,
        GIR_EraseRootFromParent_Done,
      // Label 283: @36884
      GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(36920), // Rule ID 818 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 818,
        GIR_EraseRootFromParent_Done,
      // Label 284: @36920
      GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(36956), // Rule ID 8518 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CTPOP),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src1, (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8518,
        GIR_EraseRootFromParent_Done,
      // Label 285: @36956
      GIM_Reject,
    // Label 195: @36957
    GIM_Reject,
    // Label 171: @36958
    GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(37428),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(37035), // Rule ID 2519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2519,
        GIR_EraseRootFromParent_Done,
      // Label 287: @37035
      GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(37101), // Rule ID 2524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i64:{ *:[i64] }:$src2)  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2524,
        GIR_EraseRootFromParent_Done,
      // Label 288: @37101
      GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(37167), // Rule ID 8598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNotMADIntraFwdBug_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8598,
        GIR_EraseRootFromParent_Done,
      // Label 289: @37167
      GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(37233), // Rule ID 8602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMADIntraFwdBug_isGFX11Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, (intrinsic_wo_chain:{ *:[i64] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MAD_U64_U32_gfx11_e64:{ *:[i64] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U64_U32_gfx11_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8602,
        GIR_EraseRootFromParent_Done,
      // Label 290: @37233
      GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(37302), // Rule ID 2506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:9:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20120),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20121>>, i64:{ *:[i64] }:$src2:$pred:9:z)<<P:9:Predicate_anonymous_20120>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2506,
        GIR_EraseRootFromParent_Done,
      // Label 291: @37302
      GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(37371), // Rule ID 8594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:9:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_shl_0_to_4),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20120),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (add:{ *:[i64] } i64:{ *:[i64] }:$src2:$pred:9:z, (shl:{ *:[i64] } i64:{ *:[i64] }:$src0:$pred:9:x, i32:{ *:[i32] }:$src1:$pred:9:y)<<P:Predicate_shl_0_to_4>><<P:Predicate_anonymous_20121>>)<<P:9:Predicate_anonymous_20120>>  =>  (V_LSHL_ADD_U64_e64:{ *:[i64] } VSrc_b64:{ *:[i64] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b64:{ *:[i64] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_ADD_U64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8594,
        GIR_EraseRootFromParent_Done,
      // Label 292: @37371
      GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(37401), // Rule ID 1340 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19065),
        // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19065>>  =>  (V_ADD_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U64_PSEUDO),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1340,
        GIR_Done,
      // Label 293: @37401
      GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(37427), // Rule ID 1342 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13381),
        // (add:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13381>>  =>  (S_ADD_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_U64_PSEUDO),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1342,
        GIR_Done,
      // Label 294: @37427
      GIM_Reject,
    // Label 286: @37428
    GIM_Reject,
    // Label 172: @37429
    GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(37698),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(37540), // Rule ID 8570 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8570,
        GIR_EraseRootFromParent_Done,
      // Label 296: @37540
      GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(37636), // Rule ID 1084 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (add:{ *:[v2i16] } (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers)), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_MAD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2i16:{ *:[v2i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAD_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1084,
        GIR_EraseRootFromParent_Done,
      // Label 297: @37636
      GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(37697), // Rule ID 1095 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (add:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1095,
        GIR_EraseRootFromParent_Done,
      // Label 298: @37697
      GIM_Reject,
    // Label 295: @37698
    GIM_Reject,
    // Label 173: @37699
    GIM_Reject,
    // Label 1: @37700
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 304*/ GIMT_Encode4(38322),
    /*GILLT_s1*//*Label 299*/ GIMT_Encode4(37731),
    /*GILLT_s16*//*Label 300*/ GIMT_Encode4(37850),
    /*GILLT_s32*//*Label 301*/ GIMT_Encode4(38066),
    /*GILLT_s64*//*Label 302*/ GIMT_Encode4(38181),
    /*GILLT_v2s16*//*Label 303*/ GIMT_Encode4(38250),
    // Label 299: @37731
    GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(37849),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
      GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(37770), // Rule ID 7575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7575,
        GIR_EraseRootFromParent_Done,
      // Label 306: @37770
      GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(37798), // Rule ID 7582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, -1:{ *:[i1] })  =>  (S_NOT_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7582,
        GIR_EraseRootFromParent_Done,
      // Label 307: @37798
      GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(37823), // Rule ID 7573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7573,
        GIR_Done,
      // Label 308: @37823
      GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(37848), // Rule ID 7580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (sub:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7580,
        GIR_Done,
      // Label 309: @37848
      GIM_Reject,
    // Label 305: @37849
    GIM_Reject,
    // Label 300: @37850
    GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(38065),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(37920), // Rule ID 1063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1063,
        GIR_EraseRootFromParent_Done,
      // Label 311: @37920
      GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(37979), // Rule ID 1064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1064,
        GIR_EraseRootFromParent_Done,
      // Label 312: @37979
      GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(38038), // Rule ID 1065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (sub:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1065,
        GIR_EraseRootFromParent_Done,
      // Label 313: @38038
      GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(38064), // Rule ID 911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 911,
        GIR_EraseRootFromParent_Done,
      // Label 314: @38064
      GIM_Reject,
    // Label 310: @38065
    GIM_Reject,
    // Label 301: @38066
    GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(38180),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(38111), // Rule ID 44 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13382),
        // (sub:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13382>>  =>  (S_SUB_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 44,
        GIR_Done,
      // Label 316: @38111
      GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(38141), // Rule ID 2403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19067),
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19067>>  =>  (V_SUB_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2403,
        GIR_EraseRootFromParent_Done,
      // Label 317: @38141
      GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(38179), // Rule ID 2405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7GFX8GFX9),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19067),
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19067>>  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, 0:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2405,
        GIR_EraseRootFromParent_Done,
      // Label 318: @38179
      GIM_Reject,
    // Label 315: @38180
    GIM_Reject,
    // Label 302: @38181
    GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(38249),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(38222), // Rule ID 1341 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19067),
        // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_19067>>  =>  (V_SUB_U64_PSEUDO:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U64_PSEUDO),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::VCC), GIMT_Encode2(RegState::Dead),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1341,
        GIR_Done,
      // Label 320: @38222
      GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(38248), // Rule ID 1343 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13382),
        // (sub:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13382>>  =>  (S_SUB_U64_PSEUDO:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_U64_PSEUDO),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1343,
        GIR_Done,
      // Label 321: @38248
      GIM_Reject,
    // Label 319: @38249
    GIM_Reject,
    // Label 303: @38250
    GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(38321), // Rule ID 1103 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (sub:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1103,
      GIR_EraseRootFromParent_Done,
    // Label 322: @38321
    GIM_Reject,
    // Label 304: @38322
    GIM_Reject,
    // Label 2: @38323
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 327*/ GIMT_Encode4(38668),
    /*GILLT_s16*//*Label 323*/ GIMT_Encode4(38350),
    /*GILLT_s32*//*Label 324*/ GIMT_Encode4(38465),
    /*GILLT_s64*//*Label 325*/ GIMT_Encode4(38566),
    /*GILLT_v2s16*//*Label 326*/ GIMT_Encode4(38596),
    // Label 323: @38350
    GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(38464),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(38417), // Rule ID 878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (mul:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LO_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 878,
        GIR_EraseRootFromParent_Done,
      // Label 329: @38417
      GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(38440), // Rule ID 877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 877,
        GIR_Done,
      // Label 330: @38440
      GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(38463), // Rule ID 879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MUL_LO_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 879,
        GIR_Done,
      // Label 331: @38463
      GIM_Reject,
    // Label 328: @38464
    GIM_Reject,
    // Label 324: @38465
    GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(38565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(38496), // Rule ID 81 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13389),
        // (mul:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13389>>  =>  (S_MUL_I32:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_I32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 81,
        GIR_Done,
      // Label 333: @38496
      GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(38530), // Rule ID 939 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19574),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (mul:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19574>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 939,
        GIR_EraseRootFromParent_Done,
      // Label 334: @38530
      GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(38564), // Rule ID 8558 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19574),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (mul:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_19574>>  =>  (V_MUL_LO_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8558,
        GIR_EraseRootFromParent_Done,
      // Label 335: @38564
      GIM_Reject,
    // Label 332: @38565
    GIM_Reject,
    // Label 325: @38566
    GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(38595), // Rule ID 51 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13389),
      // (mul:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13389>>  =>  (S_MUL_U64:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_U64),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 51,
      GIR_Done,
    // Label 336: @38595
    GIM_Reject,
    // Label 326: @38596
    GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(38667), // Rule ID 1096 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (mul:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_LO_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_LO_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1096,
      GIR_EraseRootFromParent_Done,
    // Label 337: @38667
    GIM_Reject,
    // Label 327: @38668
    GIM_Reject,
    // Label 3: @38669
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 345*/ GIMT_Encode4(40043),
    /*GILLT_s1*//*Label 338*/ GIMT_Encode4(38720),
    /*GILLT_s16*//*Label 339*/ GIMT_Encode4(38783),
    /*GILLT_s32*//*Label 340*/ GIMT_Encode4(38997),
    /*GILLT_s64*//*Label 341*/ GIMT_Encode4(39521),
    /*GILLT_v2s16*//*Label 342*/ GIMT_Encode4(39646),
    /*GILLT_v2s32*//*Label 343*/ GIMT_Encode4(39797), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 344*/ GIMT_Encode4(39920),
    // Label 338: @38720
    GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(38782),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
      GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(38756), // Rule ID 7569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7569,
        GIR_Done,
      // Label 347: @38756
      GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(38781), // Rule ID 7576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (and:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7576,
        GIR_Done,
      // Label 348: @38781
      GIM_Reject,
    // Label 346: @38782
    GIM_Reject,
    // Label 339: @38783
    GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(38996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(38845), // Rule ID 8572 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8572,
        GIR_EraseRootFromParent_Done,
      // Label 350: @38845
      GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(38896), // Rule ID 1883 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1883,
        GIR_EraseRootFromParent_Done,
      // Label 351: @38896
      GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(38916), // Rule ID 2433 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2433,
        GIR_Done,
      // Label 352: @38916
      GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(38972), // Rule ID 904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_AND_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 904,
        GIR_EraseRootFromParent_Done,
      // Label 353: @38972
      GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(38995), // Rule ID 905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_AND_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 905,
        GIR_Done,
      // Label 354: @38995
      GIM_Reject,
    // Label 349: @38996
    GIM_Reject,
    // Label 340: @38997
    GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(39520),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(39083), // Rule ID 11288 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19075),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19075>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11288,
        GIR_EraseRootFromParent_Done,
      // Label 356: @39083
      GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(39158), // Rule ID 11289 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19075),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>, i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19075>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11289,
        GIR_EraseRootFromParent_Done,
      // Label 357: @39158
      GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(39233), // Rule ID 7714 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19075),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_add_oneuse>>)<<P:Predicate_anonymous_19075>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7714,
        GIR_EraseRootFromParent_Done,
      // Label 358: @39233
      GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(39308), // Rule ID 7715 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19075),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, i32:{ *:[i32] }:$width)<<P:Predicate_shl_oneuse>>, -1:{ *:[i32] })<<P:Predicate_xor_oneuse>>)<<P:Predicate_anonymous_19075>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, 0:{ *:[i32] }, ?:{ *:[i32] }:$width)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // width
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7715,
        GIR_EraseRootFromParent_Done,
      // Label 359: @39308
      GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(39359), // Rule ID 8499 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8499,
        GIR_EraseRootFromParent_Done,
      // Label 360: @39359
      GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(39410), // Rule ID 64 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 64,
        GIR_EraseRootFromParent_Done,
      // Label 361: @39410
      GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(39473), // Rule ID 7713 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_IMMZeroBasedBitfieldMask),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19075),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[i32] } (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$rshift), (imm:{ *:[i32] })<<P:Predicate_IMMZeroBasedBitfieldMask>>:$mask)<<P:Predicate_anonymous_19075>>  =>  (V_BFE_U32_e64:{ *:[i32] } ?:{ *:[i32] }:$src, ?:{ *:[i32] }:$rshift, (IMMPopCount:{ *:[i32] } ?:{ *:[i32] }:$mask))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rshift
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderPopcntImm), // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7713,
        GIR_EraseRootFromParent_Done,
      // Label 362: @39473
      GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(39499), // Rule ID 52 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13390>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 52,
        GIR_Done,
      // Label 363: @39499
      GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(39519), // Rule ID 815 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_AND_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 815,
        GIR_Done,
      // Label 364: @39519
      GIM_Reject,
    // Label 355: @39520
    GIM_Reject,
    // Label 341: @39521
    GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(39645),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(39583), // Rule ID 8500 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8500,
        GIR_EraseRootFromParent_Done,
      // Label 366: @39583
      GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(39626), // Rule ID 65 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 65,
        GIR_EraseRootFromParent_Done,
      // Label 367: @39626
      GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(39644), // Rule ID 53 //
        // (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13390>>  =>  (S_AND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 53,
        GIR_Done,
      // Label 368: @39644
      GIM_Reject,
    // Label 365: @39645
    GIM_Reject,
    // Label 342: @39646
    GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(39796),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(39716), // Rule ID 8573 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8573,
        GIR_EraseRootFromParent_Done,
      // Label 370: @39716
      GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(39775), // Rule ID 1884 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1884,
        GIR_EraseRootFromParent_Done,
      // Label 371: @39775
      GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(39795), // Rule ID 2436 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (and:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_AND_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2436,
        GIR_Done,
      // Label 372: @39795
      GIM_Reject,
    // Label 369: @39796
    GIM_Reject,
    // Label 343: @39797
    GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(39919),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(39867), // Rule ID 8575 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8575,
        GIR_EraseRootFromParent_Done,
      // Label 374: @39867
      GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(39918), // Rule ID 1886 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1886,
        GIR_EraseRootFromParent_Done,
      // Label 375: @39918
      GIM_Reject,
    // Label 373: @39919
    GIM_Reject,
    // Label 344: @39920
    GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(40042),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13390),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(39990), // Rule ID 8574 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8574,
        GIR_EraseRootFromParent_Done,
      // Label 377: @39990
      GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(40041), // Rule ID 1885 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (and:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13390>>  =>  (S_ANDN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ANDN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1885,
        GIR_EraseRootFromParent_Done,
      // Label 378: @40041
      GIM_Reject,
    // Label 376: @40042
    GIM_Reject,
    // Label 345: @40043
    GIM_Reject,
    // Label 4: @40044
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(17), /*)*//*default:*//*Label 386*/ GIMT_Encode4(55625),
    /*GILLT_s1*//*Label 379*/ GIMT_Encode4(40095),
    /*GILLT_s16*//*Label 380*/ GIMT_Encode4(40158),
    /*GILLT_s32*//*Label 381*/ GIMT_Encode4(41166),
    /*GILLT_s64*//*Label 382*/ GIMT_Encode4(46039),
    /*GILLT_v2s16*//*Label 383*/ GIMT_Encode4(55228),
    /*GILLT_v2s32*//*Label 384*/ GIMT_Encode4(55379), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 385*/ GIMT_Encode4(55502),
    // Label 379: @40095
    GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(40157),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
      GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(40131), // Rule ID 7570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7570,
        GIR_Done,
      // Label 388: @40131
      GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(40156), // Rule ID 7577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (or:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_OR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7577,
        GIR_Done,
      // Label 389: @40156
      GIM_Reject,
    // Label 387: @40157
    GIM_Reject,
    // Label 380: @40158
    GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(41165),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(40374), // Rule ID 8605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-128),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/3, 127,
        GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[8] src2
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, uint8_t(-128),
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/3, 127,
        GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/8,
        // (or:{ *:[i16] } (and:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] })), 255:{ *:[i16] }), (shl:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] })), 8:{ *:[i16] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8605,
        GIR_EraseRootFromParent_Done,
      // Label 391: @40374
      GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(40579), // Rule ID 2620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-128),
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/3, 127,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/7, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/8, /*MI*/7, /*OpIdx*/1, // MIs[8]
        GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/8, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[8] src2
        GIM_CheckIsSameOperand, /*MI*/8, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/2, uint8_t(-128),
        GIM_CheckConstantInt8, /*MI*/7, /*Op*/3, 127,
        GIM_CheckConstantInt, /*MI*/5, /*Op*/2, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/8,
        // (or:{ *:[i16] } (shl:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] })), 8:{ *:[i16] }), (and:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), -128:{ *:[i32] }, 127:{ *:[i32] })), 255:{ *:[i16] }))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/8, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2620,
        GIR_EraseRootFromParent_Done,
      // Label 392: @40579
      GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(40771), // Rule ID 2621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
        GIM_CheckConstantInt, /*MI*/3, /*Op*/3, GIMT_Encode8(255),
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[7] src2
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 0,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/3, GIMT_Encode8(255),
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (or:{ *:[i16] } (shl:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] })), 8:{ *:[i16] }), (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] })))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2621,
        GIR_EraseRootFromParent_Done,
      // Label 393: @40771
      GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(40963), // Rule ID 8606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
        GIM_CheckConstantInt, /*MI*/2, /*Op*/3, GIMT_Encode8(255),
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
        GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(AMDGPU::G_AMDGPU_SMED3),
        GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/6, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/7, /*MI*/6, /*OpIdx*/1, // MIs[7]
        GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_ASHR),
        GIM_CheckType, /*MI*/7, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[7] src2
        GIM_CheckIsSameOperand, /*MI*/7, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 0,
        GIM_CheckConstantInt, /*MI*/6, /*Op*/3, GIMT_Encode8(255),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
        GIM_CheckIsSafeToFold, /*NumInsns*/7,
        // (or:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] })), (shl:{ *:[i16] } (trunc:{ *:[i16] } (AMDGPUsmed3:{ *:[i32] } (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2), 0:{ *:[i32] }, 255:{ *:[i32] })), 8:{ *:[i16] }))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src0, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src2, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/7, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8606,
        GIR_EraseRootFromParent_Done,
      // Label 394: @40963
      GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(41014), // Rule ID 8576 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i16] } (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }), i16:{ *:[i16] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8576,
        GIR_EraseRootFromParent_Done,
      // Label 395: @41014
      GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(41065), // Rule ID 1887 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, (xor:{ *:[i16] } i16:{ *:[i16] }:$src1, -1:{ *:[i16] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[i16] }:{ *:[i1] } SSrc_b32:{ *:[i16] }:$src0, SSrc_b32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1887,
        GIR_EraseRootFromParent_Done,
      // Label 396: @41065
      GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(41085), // Rule ID 2434 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2434,
        GIR_Done,
      // Label 397: @41085
      GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(41141), // Rule ID 906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (or:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_OR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 906,
        GIR_EraseRootFromParent_Done,
      // Label 398: @41141
      GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(41164), // Rule ID 907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_OR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 907,
        GIR_Done,
      // Label 399: @41164
      GIM_Reject,
    // Label 390: @41165
    GIM_Reject,
    // Label 381: @41166
    GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(46038),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(41324), // Rule ID 11257 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11257,
        GIR_EraseRootFromParent_Done,
      // Label 401: @41324
      GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(41471), // Rule ID 11256 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11256,
        GIR_EraseRootFromParent_Done,
      // Label 402: @41471
      GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(41618), // Rule ID 11255 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11255,
        GIR_EraseRootFromParent_Done,
      // Label 403: @41618
      GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(41765), // Rule ID 11254 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })), (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11254,
        GIR_EraseRootFromParent_Done,
      // Label 404: @41765
      GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(41912), // Rule ID 11251 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11251,
        GIR_EraseRootFromParent_Done,
      // Label 405: @41912
      GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(42059), // Rule ID 11253 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] }), i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11253,
        GIR_EraseRootFromParent_Done,
      // Label 406: @42059
      GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(42206), // Rule ID 7488 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7488,
        GIR_EraseRootFromParent_Done,
      // Label 407: @42206
      GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(42353), // Rule ID 11252 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, (xor:{ *:[i32] } i32:{ *:[i32] }:$x, -1:{ *:[i32] })))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11252,
        GIR_EraseRootFromParent_Done,
      // Label 408: @42353
      GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(42446), // Rule ID 2501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20108),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20098>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20108>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2501,
        GIR_EraseRootFromParent_Done,
      // Label 409: @42446
      GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(42539), // Rule ID 8590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20108),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, (and:{ *:[i32] } i32:{ *:[i32] }:$src1:$pred:5:y, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_20098>>)<<P:5:Predicate_anonymous_20108>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8590,
        GIR_EraseRootFromParent_Done,
      // Label 410: @42539
      GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(42724), // Rule ID 11302 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11302,
        GIR_EraseRootFromParent_Done,
      // Label 411: @42724
      GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(42909), // Rule ID 11303 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11303,
        GIR_EraseRootFromParent_Done,
      // Label 412: @42909
      GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(43094), // Rule ID 11304 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11304,
        GIR_EraseRootFromParent_Done,
      // Label 413: @43094
      GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(43279), // Rule ID 11305 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11305,
        GIR_EraseRootFromParent_Done,
      // Label 414: @43279
      GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(43464), // Rule ID 11298 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11298,
        GIR_EraseRootFromParent_Done,
      // Label 415: @43464
      GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(43649), // Rule ID 11299 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11299,
        GIR_EraseRootFromParent_Done,
      // Label 416: @43649
      GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(43834), // Rule ID 11300 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11300,
        GIR_EraseRootFromParent_Done,
      // Label 417: @43834
      GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(44019), // Rule ID 11301 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)), (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11301,
        GIR_EraseRootFromParent_Done,
      // Label 418: @44019
      GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(44204), // Rule ID 11292 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11292,
        GIR_EraseRootFromParent_Done,
      // Label 419: @44204
      GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(44389), // Rule ID 11293 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11293,
        GIR_EraseRootFromParent_Done,
      // Label 420: @44389
      GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(44574), // Rule ID 11296 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11296,
        GIR_EraseRootFromParent_Done,
      // Label 421: @44574
      GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(44759), // Rule ID 11297 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$y))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11297,
        GIR_EraseRootFromParent_Done,
      // Label 422: @44759
      GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(44944), // Rule ID 7717 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7717,
        GIR_EraseRootFromParent_Done,
      // Label 423: @44944
      GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(45129), // Rule ID 11291 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11291,
        GIR_EraseRootFromParent_Done,
      // Label 424: @45129
      GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(45314), // Rule ID 11294 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$x, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11294,
        GIR_EraseRootFromParent_Done,
      // Label 425: @45314
      GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(45499), // Rule ID 11295 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x), (and:{ *:[i32] } i32:{ *:[i32] }:$y, (or:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$x)))<<P:Predicate_anonymous_19077>>  =>  (V_BFI_B32_e64:{ *:[i32] } (V_XOR_B32_e64:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] })), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11295,
        GIR_EraseRootFromParent_Done,
      // Label 426: @45499
      GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(45550), // Rule ID 8501 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }), i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8501,
        GIR_EraseRootFromParent_Done,
      // Label 427: @45550
      GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(45601), // Rule ID 66 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, -1:{ *:[i32] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 66,
        GIR_EraseRootFromParent_Done,
      // Label 428: @45601
      GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(45666), // Rule ID 2502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:6:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20110),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20111>>, i32:{ *:[i32] }:$src2:$pred:6:z)<<P:6:Predicate_anonymous_20110>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2502,
        GIR_EraseRootFromParent_Done,
      // Label 429: @45666
      GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(45731), // Rule ID 2503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:7:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20113),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20114>>, i32:{ *:[i32] }:$src2:$pred:7:z)<<P:7:Predicate_anonymous_20113>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2503,
        GIR_EraseRootFromParent_Done,
      // Label 430: @45731
      GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(45796), // Rule ID 2500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:5:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20108),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20098>>, i32:{ *:[i32] }:$src2:$pred:5:z)<<P:5:Predicate_anonymous_20108>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2500,
        GIR_EraseRootFromParent_Done,
      // Label 431: @45796
      GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(45861), // Rule ID 8591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:6:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20110),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:6:z, (and:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:6:x, i32:{ *:[i32] }:$src1:$pred:6:y)<<P:Predicate_anonymous_20111>>)<<P:6:Predicate_anonymous_20110>>  =>  (V_AND_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8591,
        GIR_EraseRootFromParent_Done,
      // Label 432: @45861
      GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(45926), // Rule ID 8592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:7:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20113),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:7:z, (or:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:7:x, i32:{ *:[i32] }:$src1:$pred:7:y)<<P:Predicate_anonymous_20114>>)<<P:7:Predicate_anonymous_20113>>  =>  (V_OR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR3_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8592,
        GIR_EraseRootFromParent_Done,
      // Label 433: @45926
      GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(45991), // Rule ID 8589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:5:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20108),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:5:z, (shl:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:5:x, i32:{ *:[i32] }:$src1:$pred:5:y)<<P:Predicate_anonymous_20098>>)<<P:5:Predicate_anonymous_20108>>  =>  (V_LSHL_OR_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8589,
        GIR_EraseRootFromParent_Done,
      // Label 434: @45991
      GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(46017), // Rule ID 54 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13391>>  =>  (S_OR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 54,
        GIR_Done,
      // Label 435: @46017
      GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(46037), // Rule ID 816 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_OR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 816,
        GIR_Done,
      // Label 436: @46037
      GIM_Reject,
    // Label 400: @46038
    GIM_Reject,
    // Label 382: @46039
    GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(55227),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(46365), // Rule ID 11265 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11265,
        GIR_EraseRootFromParent_Done,
      // Label 438: @46365
      GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(46680), // Rule ID 11264 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11264,
        GIR_EraseRootFromParent_Done,
      // Label 439: @46680
      GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(46995), // Rule ID 11263 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11263,
        GIR_EraseRootFromParent_Done,
      // Label 440: @46995
      GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(47310), // Rule ID 11262 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })), (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11262,
        GIR_EraseRootFromParent_Done,
      // Label 441: @47310
      GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(47625), // Rule ID 11259 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11259,
        GIR_EraseRootFromParent_Done,
      // Label 442: @47625
      GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(47940), // Rule ID 11261 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] }), i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11261,
        GIR_EraseRootFromParent_Done,
      // Label 443: @47940
      GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(48255), // Rule ID 7490 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7490,
        GIR_EraseRootFromParent_Done,
      // Label 444: @48255
      GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(48570), // Rule ID 11260 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, (xor:{ *:[i64] } i64:{ *:[i64] }:$x, -1:{ *:[i64] })))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11260,
        GIR_EraseRootFromParent_Done,
      // Label 445: @48570
      GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(48978), // Rule ID 11317 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11317,
        GIR_EraseRootFromParent_Done,
      // Label 446: @48978
      GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(49386), // Rule ID 11318 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11318,
        GIR_EraseRootFromParent_Done,
      // Label 447: @49386
      GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(49794), // Rule ID 11319 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11319,
        GIR_EraseRootFromParent_Done,
      // Label 448: @49794
      GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(50202), // Rule ID 11320 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11320,
        GIR_EraseRootFromParent_Done,
      // Label 449: @50202
      GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(50610), // Rule ID 11313 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11313,
        GIR_EraseRootFromParent_Done,
      // Label 450: @50610
      GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(51018), // Rule ID 11314 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11314,
        GIR_EraseRootFromParent_Done,
      // Label 451: @51018
      GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(51426), // Rule ID 11315 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11315,
        GIR_EraseRootFromParent_Done,
      // Label 452: @51426
      GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(51834), // Rule ID 11316 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)), (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11316,
        GIR_EraseRootFromParent_Done,
      // Label 453: @51834
      GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(52242), // Rule ID 11307 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11307,
        GIR_EraseRootFromParent_Done,
      // Label 454: @52242
      GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(52650), // Rule ID 11308 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11308,
        GIR_EraseRootFromParent_Done,
      // Label 455: @52650
      GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(53058), // Rule ID 11311 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11311,
        GIR_EraseRootFromParent_Done,
      // Label 456: @53058
      GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(53466), // Rule ID 11312 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$y))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11312,
        GIR_EraseRootFromParent_Done,
      // Label 457: @53466
      GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(53874), // Rule ID 7718 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7718,
        GIR_EraseRootFromParent_Done,
      // Label 458: @53874
      GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(54282), // Rule ID 11306 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11306,
        GIR_EraseRootFromParent_Done,
      // Label 459: @54282
      GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(54690), // Rule ID 11309 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$x, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11309,
        GIR_EraseRootFromParent_Done,
      // Label 460: @54690
      GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(55098), // Rule ID 11310 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
        // MIs[3] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] x
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19077),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (or:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x), (and:{ *:[i64] } i64:{ *:[i64] }:$y, (or:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$x)))<<P:Predicate_anonymous_19077>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (V_XOR_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/11, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/11, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/10, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
        GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/9,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/11,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11310,
        GIR_EraseRootFromParent_Done,
      // Label 461: @55098
      GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(55149), // Rule ID 8502 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }), i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8502,
        GIR_EraseRootFromParent_Done,
      // Label 462: @55149
      GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(55200), // Rule ID 67 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, (xor:{ *:[i64] } i64:{ *:[i64] }:$src1, -1:{ *:[i64] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 67,
        GIR_EraseRootFromParent_Done,
      // Label 463: @55200
      GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(55226), // Rule ID 55 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        // (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13391>>  =>  (S_OR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 55,
        GIR_Done,
      // Label 464: @55226
      GIM_Reject,
    // Label 437: @55227
    GIM_Reject,
    // Label 383: @55228
    GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(55378),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(55298), // Rule ID 8577 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i16] } (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }), v2i16:{ *:[v2i16] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8577,
        GIR_EraseRootFromParent_Done,
      // Label 466: @55298
      GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(55357), // Rule ID 1888 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, immAllOnesV:{ *:[v2i16] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B32:{ *:[v2i16] }:{ *:[i1] } SSrc_b32:{ *:[v2i16] }:$src0, SSrc_b32:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1888,
        GIR_EraseRootFromParent_Done,
      // Label 467: @55357
      GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(55377), // Rule ID 2437 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (or:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_OR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2437,
        GIR_Done,
      // Label 468: @55377
      GIM_Reject,
    // Label 465: @55378
    GIM_Reject,
    // Label 384: @55379
    GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(55501),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(55449), // Rule ID 8579 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }), v2i32:{ *:[v2i32] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8579,
        GIR_EraseRootFromParent_Done,
      // Label 470: @55449
      GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(55500), // Rule ID 1890 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src0, (xor:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src1, immAllOnesV:{ *:[v2i32] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[v2i32] }:{ *:[i1] } SSrc_b64:{ *:[v2i32] }:$src0, SSrc_b64:{ *:[v2i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1890,
        GIR_EraseRootFromParent_Done,
      // Label 471: @55500
      GIM_Reject,
    // Label 469: @55501
    GIM_Reject,
    // Label 385: @55502
    GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(55624),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13391),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(55572), // Rule ID 8578 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }), v4i16:{ *:[v4i16] }:$src0)<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8578,
        GIR_EraseRootFromParent_Done,
      // Label 473: @55572
      GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(55623), // Rule ID 1889 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
        GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (or:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src0, (xor:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src1, immAllOnesV:{ *:[v4i16] }))<<P:Predicate_anonymous_13391>>  =>  (S_ORN2_B64:{ *:[v4i16] }:{ *:[i1] } SSrc_b64:{ *:[v4i16] }:$src0, SSrc_b64:{ *:[v4i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ORN2_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1889,
        GIR_EraseRootFromParent_Done,
      // Label 474: @55623
      GIM_Reject,
    // Label 472: @55624
    GIM_Reject,
    // Label 386: @55625
    GIM_Reject,
    // Label 5: @55626
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 480*/ GIMT_Encode4(60291),
    /*GILLT_s1*//*Label 475*/ GIMT_Encode4(55657),
    /*GILLT_s16*//*Label 476*/ GIMT_Encode4(55720),
    /*GILLT_s32*//*Label 477*/ GIMT_Encode4(55832),
    /*GILLT_s64*//*Label 478*/ GIMT_Encode4(57631),
    /*GILLT_v2s16*//*Label 479*/ GIMT_Encode4(60264),
    // Label 475: @55657
    GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(55719),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
      GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(55693), // Rule ID 7571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7571,
        GIR_Done,
      // Label 482: @55693
      GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(55718), // Rule ID 7578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (xor:{ *:[i1] } i1:{ *:[i1] }:$src0, i1:{ *:[i1] }:$src1)  =>  (S_XOR_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i1] }:$src0, ?:{ *:[i1] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7578,
        GIR_Done,
      // Label 483: @55718
      GIM_Reject,
    // Label 481: @55719
    GIM_Reject,
    // Label 476: @55720
    GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(55831),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(55751), // Rule ID 2435 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i16] }:$src0, VSrc_b32:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2435,
        GIR_Done,
      // Label 485: @55751
      GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(55807), // Rule ID 908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (xor:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_XOR_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 908,
        GIR_EraseRootFromParent_Done,
      // Label 486: @55807
      GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(55830), // Rule ID 909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_XOR_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 909,
        GIR_Done,
      // Label 487: @55830
      GIM_Reject,
    // Label 484: @55831
    GIM_Reject,
    // Label 477: @55832
    GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(57630),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(55898), // Rule ID 60 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13360>>  =>  (S_NAND_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 60,
        GIR_EraseRootFromParent_Done,
      // Label 489: @55898
      GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(55956), // Rule ID 62 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13360>>  =>  (S_NOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 62,
        GIR_EraseRootFromParent_Done,
      // Label 490: @55956
      GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(56014), // Rule ID 58 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_13360>>  =>  (S_XNOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 58,
        GIR_EraseRootFromParent_Done,
      // Label 491: @56014
      GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(56072), // Rule ID 2421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19334),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i32] })<<P:Predicate_anonymous_19334>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2421,
        GIR_EraseRootFromParent_Done,
      // Label 492: @56072
      GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(56128), // Rule ID 2422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19336),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19336>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2422,
        GIR_EraseRootFromParent_Done,
      // Label 493: @56128
      GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(56184), // Rule ID 8580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/0,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19336),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))<<P:Predicate_xor_oneuse>><<P:Predicate_anonymous_19336>>  =>  (V_XNOR_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8580,
        GIR_EraseRootFromParent_Done,
      // Label 494: @56184
      GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(56315), // Rule ID 11271 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11271,
        GIR_EraseRootFromParent_Done,
      // Label 495: @56315
      GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(56446), // Rule ID 11272 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11272,
        GIR_EraseRootFromParent_Done,
      // Label 496: @56446
      GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(56577), // Rule ID 11269 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11269,
        GIR_EraseRootFromParent_Done,
      // Label 497: @56577
      GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(56708), // Rule ID 11270 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)), i32:{ *:[i32] }:$z)<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11270,
        GIR_EraseRootFromParent_Done,
      // Label 498: @56708
      GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(56838), // Rule ID 11268 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11268,
        GIR_EraseRootFromParent_Done,
      // Label 499: @56838
      GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(56968), // Rule ID 11267 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z), i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11267,
        GIR_EraseRootFromParent_Done,
      // Label 500: @56968
      GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(57098), // Rule ID 11266 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$z, i32:{ *:[i32] }:$y)))<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11266,
        GIR_EraseRootFromParent_Done,
      // Label 501: @57098
      GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(57228), // Rule ID 7491 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$z, (and:{ *:[i32] } i32:{ *:[i32] }:$x, (xor:{ *:[i32] } i32:{ *:[i32] }:$y, i32:{ *:[i32] }:$z)))<<P:Predicate_anonymous_19079>>  =>  (V_BFI_B32_e64:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$x, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$y, VGPR_32:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i16] } VSrc_b32:{ *:[i32] }:$z, VGPR_32:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // z
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // y
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // x
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7491,
        GIR_EraseRootFromParent_Done,
      // Label 502: @57228
      GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(57260), // Rule ID 0 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_13360>>  =>  (S_NOT_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 0,
        GIR_EraseRootFromParent_Done,
      // Label 503: @57260
      GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(57289), // Rule ID 7583 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] })<<P:Predicate_anonymous_19079>>  =>  (V_NOT_B32_e32:{ *:[i32] } ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_NOT_B32_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7583,
        GIR_EraseRootFromParent_Done,
      // Label 504: @57289
      GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(57357), // Rule ID 2562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:16:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20563),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20117>>, i32:{ *:[i32] }:$src2:$pred:16:z)<<P:16:Predicate_anonymous_20563>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2562,
        GIR_EraseRootFromParent_Done,
      // Label 505: @57357
      GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(57425), // Rule ID 8604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/2, // Name : pred:16:z
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20563),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:16:z, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:16:x, i32:{ *:[i32] }:$src1:$pred:16:y)<<P:Predicate_anonymous_20117>>)<<P:16:Predicate_anonymous_20563>>  =>  (V_XOR3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR3_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8604,
        GIR_EraseRootFromParent_Done,
      // Label 506: @57425
      GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(57454), // Rule ID 56 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13392),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13392>>  =>  (S_XOR_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 56,
        GIR_Done,
      // Label 507: @57454
      GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(57504), // Rule ID 8535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }), i32:{ *:[i32] }:$src1)  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8535,
        GIR_EraseRootFromParent_Done,
      // Label 508: @57504
      GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(57556), // Rule ID 912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), -1:{ *:[i32] })  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 912,
        GIR_EraseRootFromParent_Done,
      // Label 509: @57556
      GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(57606), // Rule ID 8536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src1, (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, -1:{ *:[i32] }))  =>  (V_XNOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XNOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8536,
        GIR_EraseRootFromParent_Done,
      // Label 510: @57606
      GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(57629), // Rule ID 817 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_XOR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 817,
        GIR_Done,
      // Label 511: @57629
      GIM_Reject,
    // Label 488: @57630
    GIM_Reject,
    // Label 478: @57631
    GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(60263),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(57697), // Rule ID 61 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_and_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13360>>  =>  (S_NAND_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NAND_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 61,
        GIR_EraseRootFromParent_Done,
      // Label 513: @57697
      GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(57755), // Rule ID 63 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_or_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13360>>  =>  (S_NOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOR_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 63,
        GIR_EraseRootFromParent_Done,
      // Label 514: @57755
      GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(57813), // Rule ID 59 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_xor_oneuse>>, -1:{ *:[i64] })<<P:Predicate_anonymous_13360>>  =>  (S_XNOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XNOR_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 59,
        GIR_EraseRootFromParent_Done,
      // Label 515: @57813
      GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(58112), // Rule ID 11278 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11278,
        GIR_EraseRootFromParent_Done,
      // Label 516: @58112
      GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(58411), // Rule ID 11279 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11279,
        GIR_EraseRootFromParent_Done,
      // Label 517: @58411
      GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(58710), // Rule ID 11276 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11276,
        GIR_EraseRootFromParent_Done,
      // Label 518: @58710
      GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(59009), // Rule ID 11277 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[0] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)), i64:{ *:[i64] }:$z)<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11277,
        GIR_EraseRootFromParent_Done,
      // Label 519: @59009
      GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(59307), // Rule ID 11275 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11275,
        GIR_EraseRootFromParent_Done,
      // Label 520: @59307
      GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(59605), // Rule ID 11274 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z), i64:{ *:[i64] }:$x))<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11274,
        GIR_EraseRootFromParent_Done,
      // Label 521: @59605
      GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(59903), // Rule ID 11273 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$z, i64:{ *:[i64] }:$y)))<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 11273,
        GIR_EraseRootFromParent_Done,
      // Label 522: @59903
      GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(60201), // Rule ID 7492 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        // MIs[2] z
        GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19079),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$z, (and:{ *:[i64] } i64:{ *:[i64] }:$x, (xor:{ *:[i64] } i64:{ *:[i64] }:$y, i64:{ *:[i64] }:$z)))<<P:Predicate_anonymous_19079>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub0:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$x, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$y, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$z, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // z
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // y
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // x
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/7,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // z
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // y
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // x
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7492,
        GIR_EraseRootFromParent_Done,
      // Label 523: @60201
      GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(60233), // Rule ID 1 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13360),
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, -1:{ *:[i64] })<<P:Predicate_anonymous_13360>>  =>  (S_NOT_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOT_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1,
        GIR_EraseRootFromParent_Done,
      // Label 524: @60233
      GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(60262), // Rule ID 57 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13392),
        // (xor:{ *:[i64] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)<<P:Predicate_anonymous_13392>>  =>  (S_XOR_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 57,
        GIR_Done,
      // Label 525: @60262
      GIM_Reject,
    // Label 512: @60263
    GIM_Reject,
    // Label 479: @60264
    GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(60290), // Rule ID 2438 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (xor:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1)  =>  (V_XOR_B32_e64:{ *:[v2i16] } VSrc_b32:{ *:[v2i16] }:$src0, VSrc_b32:{ *:[v2i16] }:$src1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2438,
      GIR_Done,
    // Label 526: @60290
    GIM_Reject,
    // Label 480: @60291
    GIM_Reject,
    // Label 6: @60292
    GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(60347),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
      GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(60325), // Rule ID 7439 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33803),
        // (frameindex:{ *:[i32] })<<P:Predicate_anonymous_33803>>:$fi  =>  (V_MOV_B32_e32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7439,
        GIR_EraseRootFromParent_Done,
      // Label 528: @60325
      GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(60346), // Rule ID 7440 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // MIs[0] fi
        // No operand predicates
        // (frameindex:{ *:[i32] }):$fi  =>  (S_MOV_B32:{ *:[i32] } (frameindex_to_targetframeindex:{ *:[i32] } ?:{ *:[i32] }:$fi))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7440,
        GIR_EraseRootFromParent_Done,
      // Label 529: @60346
      GIM_Reject,
    // Label 527: @60347
    GIM_Reject,
    // Label 7: @60348
    GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(63617),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(60843),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(60497), // Rule ID 2653 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2653,
          GIR_EraseRootFromParent_Done,
        // Label 532: @60497
        GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(60620), // Rule ID 2642 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_CLAMP),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (AMDGPUclamp:{ *:[f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 1:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
          GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2642,
          GIR_EraseRootFromParent_Done,
        // Label 533: @60620
        GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(60731), // Rule ID 2652 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMA),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2652,
          GIR_EraseRootFromParent_Done,
        // Label 534: @60731
        GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(60842), // Rule ID 2641 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAD),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2641,
          GIR_EraseRootFromParent_Done,
        // Label 535: @60842
        GIM_Reject,
      // Label 531: @60843
      GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(61157),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(61006), // Rule ID 7679 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
          GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
          GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/6,
          // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7679,
          GIR_EraseRootFromParent_Done,
        // Label 537: @61006
        GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(61156), // Rule ID 7685 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
          GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
          GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/6, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/6, /*Op*/2, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/6,
          // (build_vector:{ *:[v2bf16] } (bitconvert:{ *:[bf16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), (bitconvert:{ *:[bf16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // b
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7685,
          GIR_EraseRootFromParent_Done,
        // Label 538: @61156
        GIM_Reject,
      // Label 536: @61157
      GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(61250), // Rule ID 2605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16ConversionInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (build_vector:{ *:[v2bf16] } (fpround:{ *:[bf16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))<<P:Predicate_bf16_fpround>>, (fpround:{ *:[bf16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_bf16_fpround>>)  =>  (V_CVT_PK_BF16_F32_e64:{ *:[v2bf16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2605,
        GIR_EraseRootFromParent_Done,
      // Label 539: @61250
      GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(61361), // Rule ID 7667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/4,
        GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/4,
        // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34050>>  =>  (S_PACK_HH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HH_B32_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7667,
        GIR_EraseRootFromParent_Done,
      // Label 540: @61361
      GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(61485),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34090),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(61429), // Rule ID 7686 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34090>>  =>  (V_PACK_B32_F16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7686,
          GIR_EraseRootFromParent_Done,
        // Label 542: @61429
        GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(61484), // Rule ID 7687 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (build_vector:{ *:[v2f16] } (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } VGPR_32:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_anonymous_34090>>  =>  (V_PACK_B32_F16_fake16_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, VGPR_32:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, VGPR_32:{ *:[f16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PACK_B32_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7687,
          GIR_EraseRootFromParent_Done,
        // Label 543: @61484
        GIM_Reject,
      // Label 541: @61485
      GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(61768),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(61575), // Rule ID 2528 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers)), (fpround:{ *:[f16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2528,
          GIR_EraseRootFromParent_Done,
        // Label 545: @61575
        GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(61671), // Rule ID 2645 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2645,
          GIR_EraseRootFromParent_Done,
        // Label 546: @61671
        GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(61767), // Rule ID 2656 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckIsSafeToFold, /*NumInsns*/2,
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
          // (build_vector:{ *:[v2f16] } f16:{ *:[f16] }:$elt0, (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, VGPR_32:{ *:[f16] }:$elt0)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // elt0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2656,
          GIR_EraseRootFromParent_Done,
        // Label 547: @61767
        GIM_Reject,
      // Label 544: @61768
      GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(62272),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(61907), // Rule ID 7673 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
          GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/4,
          // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$b, VGPR_32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 117834498:{ *:[i32] }))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(117834498),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // b
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7673,
          GIR_EraseRootFromParent_Done,
        // Label 549: @61907
        GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(61986), // Rule ID 7678 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (build_vector:{ *:[v2f16] } (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // b
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
          GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7678,
          GIR_EraseRootFromParent_Done,
        // Label 550: @61986
        GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(62065), // Rule ID 7684 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (build_vector:{ *:[v2bf16] } (bitconvert:{ *:[bf16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] }))), VGPR_32:{ *:[bf16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // b
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // a
          GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7684,
          GIR_EraseRootFromParent_Done,
        // Label 551: @62065
        GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(62168), // Rule ID 7677 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, (bitconvert:{ *:[f16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34052>>  =>  (V_BFI_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[i32] }:$b)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // a
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // b
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7677,
          GIR_EraseRootFromParent_Done,
        // Label 552: @62168
        GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(62271), // Rule ID 7683 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
          GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
          GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
          GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
          GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
          GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
          GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
          GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
          GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
          GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
          GIM_CheckIsSafeToFold, /*NumInsns*/3,
          // (build_vector:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$a, (bitconvert:{ *:[bf16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] }))))<<P:Predicate_anonymous_34052>>  =>  (V_BFI_B32_e64:{ *:[v2bf16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$a, VGPR_32:{ *:[i32] }:$b)
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // a
          GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // b
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7683,
          GIR_EraseRootFromParent_Done,
        // Label 553: @62271
        GIM_Reject,
      // Label 548: @62272
      GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(62346), // Rule ID 7666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src1, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>))<<P:Predicate_anonymous_34050>>  =>  (S_PACK_LH_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LH_B32_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7666,
        GIR_EraseRootFromParent_Done,
      // Label 554: @62346
      GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(62421), // Rule ID 7672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })), VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_ALIGNBIT_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i32] }:$a, 16:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // a
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7672,
        GIR_EraseRootFromParent_Done,
      // Label 555: @62421
      GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(62491), // Rule ID 7688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (build_vector:{ *:[v2i16] } (trunc:{ *:[i16] } (srl:{ *:[i32] } SReg_32:{ *:[i32] }:$src0, 16:{ *:[i32] })<<P:Predicate_srl_oneuse>>), SReg_32:{ *:[i16] }:$src1)  =>  (S_PACK_HL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0, SReg_32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_HL_B32_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7688,
        GIR_EraseRootFromParent_Done,
      // Label 556: @62491
      GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(62590), // Rule ID 7671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, (trunc:{ *:[i16] } (srl:{ *:[i32] } VGPR_32:{ *:[i32] }:$b, 16:{ *:[i32] })))<<P:Predicate_anonymous_34052>>  =>  (V_BFI_B32_e64:{ *:[v2i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i32] }:$b)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // a
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7671,
        GIR_EraseRootFromParent_Done,
      // Label 557: @62590
      GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(62626), // Rule ID 7647 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i16] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7647,
        GIR_EraseRootFromParent_Done,
      // Label 558: @62626
      GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(62659), // Rule ID 7648 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        // (build_vector:{ *:[v2i16] } 0:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34052>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i16] }, VGPR_32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7648,
        GIR_EraseRootFromParent_Done,
      // Label 559: @62659
      GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(62719), // Rule ID 7649 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34050>>  =>  (S_AND_B32:{ *:[v2i16] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), SReg_32:{ *:[i16] }:$src1)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7649,
        GIR_EraseRootFromParent_Done,
      // Label 560: @62719
      GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(62776), // Rule ID 7650 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src1, 0:{ *:[i16] })<<P:Predicate_anonymous_34052>>  =>  (V_AND_B32_e64:{ *:[v2i16] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), VGPR_32:{ *:[i16] }:$src1)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7650,
        GIR_EraseRootFromParent_Done,
      // Label 561: @62776
      GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(62818), // Rule ID 7655 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_LSHL_B32:{ *:[v2i16] }:{ *:[i1] } SReg_32:{ *:[i16] }:$src1, 16:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7655,
        GIR_EraseRootFromParent_Done,
      // Label 562: @62818
      GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(62857), // Rule ID 7656 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2i16] } (undef:{ *:[i16] }), VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34052>>  =>  (V_LSHLREV_B32_e64:{ *:[v2i16] } 16:{ *:[i32] }, VGPR_32:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7656,
        GIR_EraseRootFromParent_Done,
      // Label 563: @62857
      GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(62899), // Rule ID 7659 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_LSHL_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src1, 16:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7659,
        GIR_EraseRootFromParent_Done,
      // Label 564: @62899
      GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(62938), // Rule ID 7660 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2f16] } (undef:{ *:[f16] }), VGPR_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34052>>  =>  (V_LSHLREV_B32_e64:{ *:[v2f16] } 16:{ *:[i32] }, VGPR_32:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7660,
        GIR_EraseRootFromParent_Done,
      // Label 565: @62938
      GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(62980), // Rule ID 7663 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2bf16] } (undef:{ *:[bf16] }), SReg_32:{ *:[bf16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_LSHL_B32:{ *:[v2bf16] }:{ *:[i1] } SReg_32:{ *:[bf16] }:$src1, 16:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7663,
        GIR_EraseRootFromParent_Done,
      // Label 566: @62980
      GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(63019), // Rule ID 7664 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2bf16] } (undef:{ *:[bf16] }), VGPR_32:{ *:[bf16] }:$src1)<<P:Predicate_anonymous_34052>>  =>  (V_LSHLREV_B32_e64:{ *:[v2bf16] } 16:{ *:[i32] }, VGPR_32:{ *:[bf16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7664,
        GIR_EraseRootFromParent_Done,
      // Label 567: @63019
      GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(63059), // Rule ID 7653 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34050>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7653,
        GIR_EraseRootFromParent_Done,
      // Label 568: @63059
      GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(63099), // Rule ID 7654 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, (undef:{ *:[i16] }))<<P:Predicate_anonymous_34052>>  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7654,
        GIR_EraseRootFromParent_Done,
      // Label 569: @63099
      GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(63139), // Rule ID 7657 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34050>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7657,
        GIR_EraseRootFromParent_Done,
      // Label 570: @63139
      GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(63179), // Rule ID 7658 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, (undef:{ *:[f16] }))<<P:Predicate_anonymous_34052>>  =>  (COPY_TO_REGCLASS:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$src0, VGPR_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7658,
        GIR_EraseRootFromParent_Done,
      // Label 571: @63179
      GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(63219), // Rule ID 7661 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (build_vector:{ *:[v2bf16] } SReg_32:{ *:[bf16] }:$src0, (undef:{ *:[bf16] }))<<P:Predicate_anonymous_34050>>  =>  (COPY_TO_REGCLASS:{ *:[v2bf16] } SReg_32:{ *:[bf16] }:$src0, SReg_32:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7661,
        GIR_EraseRootFromParent_Done,
      // Label 572: @63219
      GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(63337),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(63264), // Rule ID 7662 //
          GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
          GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
          GIM_CheckIsSafeToFold, /*NumInsns*/1,
          // (build_vector:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$src0, (undef:{ *:[bf16] }))<<P:Predicate_anonymous_34052>>  =>  (COPY_TO_REGCLASS:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$src0, VGPR_32:{ *:[i32] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
          GIR_RootToRootCopy, /*OpIdx*/1, // src0
          GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          // GIR_Coverage, 7662,
          GIR_EraseRootFromParent_Done,
        // Label 574: @63264
        GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(63336), // Rule ID 7665 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
          GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$src0, VGPR_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34052>>  =>  (V_LSHL_OR_B32_e64:{ *:[v2i16] } ?:{ *:[i16] }:$src1, 16:{ *:[i32] }, (V_AND_B32_e64:{ *:[i32] } (V_MOV_B32_e32:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src0))
          GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
          GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
          GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
          GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src0
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_OR_B32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src1
          GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 7665,
          GIR_EraseRootFromParent_Done,
        // Label 575: @63336
        GIM_Reject,
      // Label 573: @63337
      GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(63368), // Rule ID 7668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        // (build_vector:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_PACK_LL_B32_B16:{ *:[v2i16] } SReg_32:{ *:[i16] }:$src0, SReg_32:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7668,
        GIR_Done,
      // Label 576: @63368
      GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(63430), // Rule ID 7669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        // (build_vector:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$a, VGPR_32:{ *:[i16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2i16] } VGPR_32:{ *:[i16] }:$b, VGPR_32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootToRootCopy, /*OpIdx*/1, // a
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7669,
        GIR_EraseRootFromParent_Done,
      // Label 577: @63430
      GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(63461), // Rule ID 7674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        // (build_vector:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_PACK_LL_B32_B16:{ *:[v2f16] } SReg_32:{ *:[f16] }:$src0, SReg_32:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7674,
        GIR_Done,
      // Label 578: @63461
      GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(63523), // Rule ID 7675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        // (build_vector:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$a, VGPR_32:{ *:[f16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2f16] } VGPR_32:{ *:[f16] }:$b, VGPR_32:{ *:[f16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootToRootCopy, /*OpIdx*/1, // a
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7675,
        GIR_EraseRootFromParent_Done,
      // Label 579: @63523
      GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(63554), // Rule ID 7680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34050),
        // (build_vector:{ *:[v2bf16] } SReg_32:{ *:[bf16] }:$src0, SReg_32:{ *:[bf16] }:$src1)<<P:Predicate_anonymous_34050>>  =>  (S_PACK_LL_B32_B16:{ *:[v2bf16] } SReg_32:{ *:[bf16] }:$src0, SReg_32:{ *:[bf16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_PACK_LL_B32_B16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7680,
        GIR_Done,
      // Label 580: @63554
      GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(63616), // Rule ID 7681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34052),
        // (build_vector:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$a, VGPR_32:{ *:[bf16] }:$b)<<P:Predicate_anonymous_34052>>  =>  (V_PERM_B32_e64:{ *:[v2bf16] } VGPR_32:{ *:[bf16] }:$b, VGPR_32:{ *:[bf16] }:$a, (S_MOV_B32:{ *:[i16] } 84148480:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(84148480),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootToRootCopy, /*OpIdx*/1, // a
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7681,
        GIR_EraseRootFromParent_Done,
      // Label 581: @63616
      GIM_Reject,
    // Label 530: @63617
    GIM_Reject,
    // Label 8: @63618
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(34), /*)*//*default:*//*Label 608*/ GIMT_Encode4(72090),
    /*GILLT_s16*//*Label 582*/ GIMT_Encode4(63733),
    /*GILLT_s32*//*Label 583*/ GIMT_Encode4(64055),
    /*GILLT_s64*//*Label 584*/ GIMT_Encode4(64404),
    /*GILLT_v2s16*//*Label 585*/ GIMT_Encode4(64753),
    /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(65276),
    /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(65654),
    /*GILLT_v3s32*//*Label 588*/ GIMT_Encode4(66061),
    /*GILLT_v3s64*//*Label 589*/ GIMT_Encode4(66115),
    /*GILLT_v4s16*//*Label 590*/ GIMT_Encode4(66290),
    /*GILLT_v4s32*//*Label 591*/ GIMT_Encode4(66813),
    /*GILLT_v4s64*//*Label 592*/ GIMT_Encode4(67220),
    /*GILLT_v5s32*//*Label 593*/ GIMT_Encode4(67569),
    /*GILLT_v6s32*//*Label 594*/ GIMT_Encode4(67683),
    /*GILLT_v7s32*//*Label 595*/ GIMT_Encode4(67916),
    /*GILLT_v8s16*//*Label 596*/ GIMT_Encode4(68030),
    /*GILLT_v8s32*//*Label 597*/ GIMT_Encode4(68843),
    /*GILLT_v8s64*//*Label 598*/ GIMT_Encode4(69250),
    /*GILLT_v9s32*//*Label 599*/ GIMT_Encode4(69541),
    /*GILLT_v10s32*//*Label 600*/ GIMT_Encode4(69655),
    /*GILLT_v11s32*//*Label 601*/ GIMT_Encode4(69769),
    /*GILLT_v12s32*//*Label 602*/ GIMT_Encode4(69883),
    /*GILLT_v16s16*//*Label 603*/ GIMT_Encode4(69997),
    /*GILLT_v16s32*//*Label 604*/ GIMT_Encode4(70694),
    /*GILLT_v16s64*//*Label 605*/ GIMT_Encode4(71101),
    /*GILLT_v32s16*//*Label 606*/ GIMT_Encode4(71276),
    /*GILLT_v32s32*//*Label 607*/ GIMT_Encode4(71915),
    // Label 582: @63733
    GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(64054),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(63767), // Rule ID 7076 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[i16] } VGPR_32:{ *:[f16] }:$src0)  =>  VGPR_32:{ *:[i16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7076,
        GIR_EraseRootFromParent_Done,
      // Label 610: @63767
      GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(63793), // Rule ID 7077 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[f16] } VGPR_32:{ *:[i16] }:$src0)  =>  VGPR_32:{ *:[f16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7077,
        GIR_EraseRootFromParent_Done,
      // Label 611: @63793
      GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(63819), // Rule ID 7078 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[f16] } VGPR_32:{ *:[bf16] }:$src0)  =>  VGPR_32:{ *:[f16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7078,
        GIR_EraseRootFromParent_Done,
      // Label 612: @63819
      GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(63845), // Rule ID 7079 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[bf16] } VGPR_32:{ *:[f16] }:$src0)  =>  VGPR_32:{ *:[bf16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7079,
        GIR_EraseRootFromParent_Done,
      // Label 613: @63845
      GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(63871), // Rule ID 7080 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[i16] } SReg_32:{ *:[f16] }:$src0)  =>  SReg_32:{ *:[i16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7080,
        GIR_EraseRootFromParent_Done,
      // Label 614: @63871
      GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(63897), // Rule ID 7081 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[f16] } SReg_32:{ *:[i16] }:$src0)  =>  SReg_32:{ *:[f16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7081,
        GIR_EraseRootFromParent_Done,
      // Label 615: @63897
      GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(63923), // Rule ID 7082 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[f16] } SReg_32:{ *:[bf16] }:$src0)  =>  SReg_32:{ *:[f16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7082,
        GIR_EraseRootFromParent_Done,
      // Label 616: @63923
      GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(63949), // Rule ID 7083 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[bf16] } SReg_32:{ *:[f16] }:$src0)  =>  SReg_32:{ *:[bf16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7083,
        GIR_EraseRootFromParent_Done,
      // Label 617: @63949
      GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(63975), // Rule ID 7084 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[i16] } VGPR_32:{ *:[bf16] }:$src0)  =>  VGPR_32:{ *:[i16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7084,
        GIR_EraseRootFromParent_Done,
      // Label 618: @63975
      GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(64001), // Rule ID 7085 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (bitconvert:{ *:[bf16] } VGPR_32:{ *:[i16] }:$src0)  =>  VGPR_32:{ *:[bf16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7085,
        GIR_EraseRootFromParent_Done,
      // Label 619: @64001
      GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(64027), // Rule ID 7086 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[i16] } SReg_32:{ *:[bf16] }:$src0)  =>  SReg_32:{ *:[i16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7086,
        GIR_EraseRootFromParent_Done,
      // Label 620: @64027
      GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(64053), // Rule ID 7087 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (bitconvert:{ *:[bf16] } SReg_32:{ *:[i16] }:$src0)  =>  SReg_32:{ *:[bf16] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // GIR_Coverage, 7087,
        GIR_EraseRootFromParent_Done,
      // Label 621: @64053
      GIM_Reject,
    // Label 609: @64054
    GIM_Reject,
    // Label 583: @64055
    GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(64084), // Rule ID 7088 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[i32] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7088,
      GIR_EraseRootFromParent_Done,
    // Label 622: @64084
    GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(64113), // Rule ID 7089 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[f32] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7089,
      GIR_EraseRootFromParent_Done,
    // Label 623: @64113
    GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(64142), // Rule ID 7090 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[i32] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7090,
      GIR_EraseRootFromParent_Done,
    // Label 624: @64142
    GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(64171), // Rule ID 7091 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[f32] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7091,
      GIR_EraseRootFromParent_Done,
    // Label 625: @64171
    GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(64200), // Rule ID 7093 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7093,
      GIR_EraseRootFromParent_Done,
    // Label 626: @64200
    GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(64229), // Rule ID 7095 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7095,
      GIR_EraseRootFromParent_Done,
    // Label 627: @64229
    GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(64258), // Rule ID 7099 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7099,
      GIR_EraseRootFromParent_Done,
    // Label 628: @64258
    GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(64287), // Rule ID 7101 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7101,
      GIR_EraseRootFromParent_Done,
    // Label 629: @64287
    GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(64316), // Rule ID 7103 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[i32] } SReg_32:{ *:[v2bf16] }:$src0)  =>  SReg_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7103,
      GIR_EraseRootFromParent_Done,
    // Label 630: @64316
    GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(64345), // Rule ID 7105 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[i32] } VGPR_32:{ *:[v2bf16] }:$src0)  =>  VGPR_32:{ *:[i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7105,
      GIR_EraseRootFromParent_Done,
    // Label 631: @64345
    GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(64374), // Rule ID 7114 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[f32] } VGPR_32:{ *:[v2bf16] }:$src0)  =>  VGPR_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7114,
      GIR_EraseRootFromParent_Done,
    // Label 632: @64374
    GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(64403), // Rule ID 7116 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[f32] } SReg_32:{ *:[v2bf16] }:$src0)  =>  SReg_32:{ *:[f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7116,
      GIR_EraseRootFromParent_Done,
    // Label 633: @64403
    GIM_Reject,
    // Label 584: @64404
    GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(64433), // Rule ID 7118 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7118,
      GIR_EraseRootFromParent_Done,
    // Label 634: @64433
    GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(64462), // Rule ID 7119 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7119,
      GIR_EraseRootFromParent_Done,
    // Label 635: @64462
    GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(64491), // Rule ID 7122 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7122,
      GIR_EraseRootFromParent_Done,
    // Label 636: @64491
    GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(64520), // Rule ID 7124 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7124,
      GIR_EraseRootFromParent_Done,
    // Label 637: @64520
    GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(64549), // Rule ID 7126 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7126,
      GIR_EraseRootFromParent_Done,
    // Label 638: @64549
    GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(64578), // Rule ID 7128 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7128,
      GIR_EraseRootFromParent_Done,
    // Label 639: @64578
    GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(64607), // Rule ID 7135 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7135,
      GIR_EraseRootFromParent_Done,
    // Label 640: @64607
    GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(64636), // Rule ID 7143 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7143,
      GIR_EraseRootFromParent_Done,
    // Label 641: @64636
    GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(64665), // Rule ID 7155 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7155,
      GIR_EraseRootFromParent_Done,
    // Label 642: @64665
    GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(64694), // Rule ID 7156 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[f64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7156,
      GIR_EraseRootFromParent_Done,
    // Label 643: @64694
    GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(64723), // Rule ID 7159 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7159,
      GIR_EraseRootFromParent_Done,
    // Label 644: @64723
    GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(64752), // Rule ID 7160 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[i64] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7160,
      GIR_EraseRootFromParent_Done,
    // Label 645: @64752
    GIM_Reject,
    // Label 585: @64753
    GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(64782), // Rule ID 7092 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7092,
      GIR_EraseRootFromParent_Done,
    // Label 646: @64782
    GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(64811), // Rule ID 7094 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7094,
      GIR_EraseRootFromParent_Done,
    // Label 647: @64811
    GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(64840), // Rule ID 7096 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7096,
      GIR_EraseRootFromParent_Done,
    // Label 648: @64840
    GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(64869), // Rule ID 7097 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7097,
      GIR_EraseRootFromParent_Done,
    // Label 649: @64869
    GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(64898), // Rule ID 7098 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7098,
      GIR_EraseRootFromParent_Done,
    // Label 650: @64898
    GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(64927), // Rule ID 7100 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7100,
      GIR_EraseRootFromParent_Done,
    // Label 651: @64927
    GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(64956), // Rule ID 7102 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } SReg_32:{ *:[i32] }:$src0)  =>  SReg_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7102,
      GIR_EraseRootFromParent_Done,
    // Label 652: @64956
    GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(64985), // Rule ID 7104 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$src0)  =>  VGPR_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7104,
      GIR_EraseRootFromParent_Done,
    // Label 653: @64985
    GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(65014), // Rule ID 7106 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } SReg_32:{ *:[v2i16] }:$src0)  =>  SReg_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7106,
      GIR_EraseRootFromParent_Done,
    // Label 654: @65014
    GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(65043), // Rule ID 7107 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2i16] } SReg_32:{ *:[v2bf16] }:$src0)  =>  SReg_32:{ *:[v2i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7107,
      GIR_EraseRootFromParent_Done,
    // Label 655: @65043
    GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(65072), // Rule ID 7108 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } VGPR_32:{ *:[v2i16] }:$src0)  =>  VGPR_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7108,
      GIR_EraseRootFromParent_Done,
    // Label 656: @65072
    GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(65101), // Rule ID 7109 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2i16] } VGPR_32:{ *:[v2bf16] }:$src0)  =>  VGPR_32:{ *:[v2i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7109,
      GIR_EraseRootFromParent_Done,
    // Label 657: @65101
    GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(65130), // Rule ID 7110 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } SReg_32:{ *:[v2f16] }:$src0)  =>  SReg_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7110,
      GIR_EraseRootFromParent_Done,
    // Label 658: @65130
    GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(65159), // Rule ID 7111 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2f16] } SReg_32:{ *:[v2bf16] }:$src0)  =>  SReg_32:{ *:[v2f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7111,
      GIR_EraseRootFromParent_Done,
    // Label 659: @65159
    GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(65188), // Rule ID 7112 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } VGPR_32:{ *:[v2f16] }:$src0)  =>  VGPR_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7112,
      GIR_EraseRootFromParent_Done,
    // Label 660: @65188
    GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(65217), // Rule ID 7113 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2f16] } VGPR_32:{ *:[v2bf16] }:$src0)  =>  VGPR_32:{ *:[v2f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7113,
      GIR_EraseRootFromParent_Done,
    // Label 661: @65217
    GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(65246), // Rule ID 7115 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } VGPR_32:{ *:[f32] }:$src0)  =>  VGPR_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7115,
      GIR_EraseRootFromParent_Done,
    // Label 662: @65246
    GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(65275), // Rule ID 7117 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // (bitconvert:{ *:[v2bf16] } SReg_32:{ *:[f32] }:$src0)  =>  SReg_32:{ *:[v2bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // GIR_Coverage, 7117,
      GIR_EraseRootFromParent_Done,
    // Label 663: @65275
    GIM_Reject,
    // Label 586: @65276
    GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(65305), // Rule ID 7120 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7120,
      GIR_EraseRootFromParent_Done,
    // Label 664: @65305
    GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(65334), // Rule ID 7121 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7121,
      GIR_EraseRootFromParent_Done,
    // Label 665: @65334
    GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(65363), // Rule ID 7123 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7123,
      GIR_EraseRootFromParent_Done,
    // Label 666: @65363
    GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(65392), // Rule ID 7125 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7125,
      GIR_EraseRootFromParent_Done,
    // Label 667: @65392
    GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(65421), // Rule ID 7127 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7127,
      GIR_EraseRootFromParent_Done,
    // Label 668: @65421
    GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(65450), // Rule ID 7129 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7129,
      GIR_EraseRootFromParent_Done,
    // Label 669: @65450
    GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(65479), // Rule ID 7133 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7133,
      GIR_EraseRootFromParent_Done,
    // Label 670: @65479
    GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(65508), // Rule ID 7141 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7141,
      GIR_EraseRootFromParent_Done,
    // Label 671: @65508
    GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(65537), // Rule ID 7144 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7144,
      GIR_EraseRootFromParent_Done,
    // Label 672: @65537
    GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(65566), // Rule ID 7146 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7146,
      GIR_EraseRootFromParent_Done,
    // Label 673: @65566
    GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(65595), // Rule ID 7147 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2i32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7147,
      GIR_EraseRootFromParent_Done,
    // Label 674: @65595
    GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(65624), // Rule ID 7149 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7149,
      GIR_EraseRootFromParent_Done,
    // Label 675: @65624
    GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(65653), // Rule ID 7151 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v2f32] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v2f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7151,
      GIR_EraseRootFromParent_Done,
    // Label 676: @65653
    GIM_Reject,
    // Label 587: @65654
    GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(65683), // Rule ID 7165 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7165,
      GIR_EraseRootFromParent_Done,
    // Label 677: @65683
    GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(65712), // Rule ID 7167 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7167,
      GIR_EraseRootFromParent_Done,
    // Label 678: @65712
    GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(65741), // Rule ID 7168 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7168,
      GIR_EraseRootFromParent_Done,
    // Label 679: @65741
    GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(65770), // Rule ID 7171 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7171,
      GIR_EraseRootFromParent_Done,
    // Label 680: @65770
    GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(65799), // Rule ID 7172 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7172,
      GIR_EraseRootFromParent_Done,
    // Label 681: @65799
    GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(65828), // Rule ID 7174 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7174,
      GIR_EraseRootFromParent_Done,
    // Label 682: @65828
    GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(65857), // Rule ID 7191 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7191,
      GIR_EraseRootFromParent_Done,
    // Label 683: @65857
    GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(65886), // Rule ID 7192 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7192,
      GIR_EraseRootFromParent_Done,
    // Label 684: @65886
    GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(65915), // Rule ID 7193 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7193,
      GIR_EraseRootFromParent_Done,
    // Label 685: @65915
    GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(65944), // Rule ID 7194 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7194,
      GIR_EraseRootFromParent_Done,
    // Label 686: @65944
    GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(65973), // Rule ID 7211 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7211,
      GIR_EraseRootFromParent_Done,
    // Label 687: @65973
    GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(66002), // Rule ID 7213 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2f64] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v2f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7213,
      GIR_EraseRootFromParent_Done,
    // Label 688: @66002
    GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(66031), // Rule ID 7215 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7215,
      GIR_EraseRootFromParent_Done,
    // Label 689: @66031
    GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(66060), // Rule ID 7217 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v2i64] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v2i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7217,
      GIR_EraseRootFromParent_Done,
    // Label 690: @66060
    GIM_Reject,
    // Label 588: @66061
    GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(66114),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(66095), // Rule ID 7163 //
        // (bitconvert:{ *:[v3i32] } SGPR_96:{ *:[v3f32] }:$src0)  =>  SGPR_96:{ *:[v3i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
        // GIR_Coverage, 7163,
        GIR_EraseRootFromParent_Done,
      // Label 692: @66095
      GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(66113), // Rule ID 7164 //
        // (bitconvert:{ *:[v3f32] } SGPR_96:{ *:[v3i32] }:$src0)  =>  SGPR_96:{ *:[v3f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_96RegClassID),
        // GIR_Coverage, 7164,
        GIR_EraseRootFromParent_Done,
      // Label 693: @66113
      GIM_Reject,
    // Label 691: @66114
    GIM_Reject,
    // Label 589: @66115
    GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(66144), // Rule ID 7227 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7227,
      GIR_EraseRootFromParent_Done,
    // Label 694: @66144
    GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(66173), // Rule ID 7228 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7228,
      GIR_EraseRootFromParent_Done,
    // Label 695: @66173
    GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(66202), // Rule ID 7229 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7229,
      GIR_EraseRootFromParent_Done,
    // Label 696: @66202
    GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(66231), // Rule ID 7230 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3i64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7230,
      GIR_EraseRootFromParent_Done,
    // Label 697: @66231
    GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(66260), // Rule ID 7231 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7231,
      GIR_EraseRootFromParent_Done,
    // Label 698: @66260
    GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(66289), // Rule ID 7232 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v3f64] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v3f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7232,
      GIR_EraseRootFromParent_Done,
    // Label 699: @66289
    GIM_Reject,
    // Label 590: @66290
    GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(66319), // Rule ID 7130 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7130,
      GIR_EraseRootFromParent_Done,
    // Label 700: @66319
    GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(66348), // Rule ID 7131 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7131,
      GIR_EraseRootFromParent_Done,
    // Label 701: @66348
    GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(66377), // Rule ID 7132 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7132,
      GIR_EraseRootFromParent_Done,
    // Label 702: @66377
    GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(66406), // Rule ID 7134 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7134,
      GIR_EraseRootFromParent_Done,
    // Label 703: @66406
    GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(66435), // Rule ID 7136 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[v4i16] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7136,
      GIR_EraseRootFromParent_Done,
    // Label 704: @66435
    GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(66464), // Rule ID 7137 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7137,
      GIR_EraseRootFromParent_Done,
    // Label 705: @66464
    GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(66493), // Rule ID 7138 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[v4f16] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7138,
      GIR_EraseRootFromParent_Done,
    // Label 706: @66493
    GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(66522), // Rule ID 7139 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v4bf16] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7139,
      GIR_EraseRootFromParent_Done,
    // Label 707: @66522
    GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(66551), // Rule ID 7140 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7140,
      GIR_EraseRootFromParent_Done,
    // Label 708: @66551
    GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(66580), // Rule ID 7142 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4bf16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7142,
      GIR_EraseRootFromParent_Done,
    // Label 709: @66580
    GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(66609), // Rule ID 7145 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7145,
      GIR_EraseRootFromParent_Done,
    // Label 710: @66609
    GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(66638), // Rule ID 7148 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2i32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7148,
      GIR_EraseRootFromParent_Done,
    // Label 711: @66638
    GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(66667), // Rule ID 7150 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7150,
      GIR_EraseRootFromParent_Done,
    // Label 712: @66667
    GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(66696), // Rule ID 7152 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[v2f32] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7152,
      GIR_EraseRootFromParent_Done,
    // Label 713: @66696
    GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(66725), // Rule ID 7153 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7153,
      GIR_EraseRootFromParent_Done,
    // Label 714: @66725
    GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(66754), // Rule ID 7154 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[f64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7154,
      GIR_EraseRootFromParent_Done,
    // Label 715: @66754
    GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(66783), // Rule ID 7157 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4i16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7157,
      GIR_EraseRootFromParent_Done,
    // Label 716: @66783
    GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(66812), // Rule ID 7158 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (bitconvert:{ *:[v4f16] } VReg_64:{ *:[i64] }:$src0)  =>  VReg_64:{ *:[v4f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // GIR_Coverage, 7158,
      GIR_EraseRootFromParent_Done,
    // Label 717: @66812
    GIM_Reject,
    // Label 591: @66813
    GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(66842), // Rule ID 7161 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7161,
      GIR_EraseRootFromParent_Done,
    // Label 718: @66842
    GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(66871), // Rule ID 7162 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7162,
      GIR_EraseRootFromParent_Done,
    // Label 719: @66871
    GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(66900), // Rule ID 7166 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7166,
      GIR_EraseRootFromParent_Done,
    // Label 720: @66900
    GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(66929), // Rule ID 7169 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7169,
      GIR_EraseRootFromParent_Done,
    // Label 721: @66929
    GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(66958), // Rule ID 7170 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7170,
      GIR_EraseRootFromParent_Done,
    // Label 722: @66958
    GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(66987), // Rule ID 7173 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7173,
      GIR_EraseRootFromParent_Done,
    // Label 723: @66987
    GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(67016), // Rule ID 7176 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7176,
      GIR_EraseRootFromParent_Done,
    // Label 724: @67016
    GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(67045), // Rule ID 7179 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7179,
      GIR_EraseRootFromParent_Done,
    // Label 725: @67045
    GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(67074), // Rule ID 7180 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7180,
      GIR_EraseRootFromParent_Done,
    // Label 726: @67074
    GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(67103), // Rule ID 7183 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7183,
      GIR_EraseRootFromParent_Done,
    // Label 727: @67103
    GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(67132), // Rule ID 7195 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7195,
      GIR_EraseRootFromParent_Done,
    // Label 728: @67132
    GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(67161), // Rule ID 7197 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4i32] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v4i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7197,
      GIR_EraseRootFromParent_Done,
    // Label 729: @67161
    GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(67190), // Rule ID 7199 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7199,
      GIR_EraseRootFromParent_Done,
    // Label 730: @67190
    GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(67219), // Rule ID 7201 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v4f32] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v4f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7201,
      GIR_EraseRootFromParent_Done,
    // Label 731: @67219
    GIM_Reject,
    // Label 592: @67220
    GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(67249), // Rule ID 7245 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7245,
      GIR_EraseRootFromParent_Done,
    // Label 732: @67249
    GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(67278), // Rule ID 7246 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7246,
      GIR_EraseRootFromParent_Done,
    // Label 733: @67278
    GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(67307), // Rule ID 7247 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7247,
      GIR_EraseRootFromParent_Done,
    // Label 734: @67307
    GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(67336), // Rule ID 7248 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7248,
      GIR_EraseRootFromParent_Done,
    // Label 735: @67336
    GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(67365), // Rule ID 7249 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7249,
      GIR_EraseRootFromParent_Done,
    // Label 736: @67365
    GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(67394), // Rule ID 7250 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7250,
      GIR_EraseRootFromParent_Done,
    // Label 737: @67394
    GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(67423), // Rule ID 7271 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7271,
      GIR_EraseRootFromParent_Done,
    // Label 738: @67423
    GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(67452), // Rule ID 7272 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7272,
      GIR_EraseRootFromParent_Done,
    // Label 739: @67452
    GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(67481), // Rule ID 7273 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7273,
      GIR_EraseRootFromParent_Done,
    // Label 740: @67481
    GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(67510), // Rule ID 7274 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7274,
      GIR_EraseRootFromParent_Done,
    // Label 741: @67510
    GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(67539), // Rule ID 7279 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4i64] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v4i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7279,
      GIR_EraseRootFromParent_Done,
    // Label 742: @67539
    GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(67568), // Rule ID 7281 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v4f64] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v4f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7281,
      GIR_EraseRootFromParent_Done,
    // Label 743: @67568
    GIM_Reject,
    // Label 593: @67569
    GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(67682),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v5s32,
      GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(67603), // Rule ID 7219 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        // (bitconvert:{ *:[v5i32] } SReg_160:{ *:[v5f32] }:$src0)  =>  SReg_160:{ *:[v5i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        // GIR_Coverage, 7219,
        GIR_EraseRootFromParent_Done,
      // Label 745: @67603
      GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(67629), // Rule ID 7220 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        // (bitconvert:{ *:[v5f32] } SReg_160:{ *:[v5i32] }:$src0)  =>  SReg_160:{ *:[v5f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_160RegClassID),
        // GIR_Coverage, 7220,
        GIR_EraseRootFromParent_Done,
      // Label 746: @67629
      GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(67655), // Rule ID 7221 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        // (bitconvert:{ *:[v5i32] } VReg_160:{ *:[v5f32] }:$src0)  =>  VReg_160:{ *:[v5i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        // GIR_Coverage, 7221,
        GIR_EraseRootFromParent_Done,
      // Label 747: @67655
      GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(67681), // Rule ID 7222 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        // (bitconvert:{ *:[v5f32] } VReg_160:{ *:[v5i32] }:$src0)  =>  VReg_160:{ *:[v5f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_160RegClassID),
        // GIR_Coverage, 7222,
        GIR_EraseRootFromParent_Done,
      // Label 748: @67681
      GIM_Reject,
    // Label 744: @67682
    GIM_Reject,
    // Label 594: @67683
    GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(67712), // Rule ID 7223 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      // (bitconvert:{ *:[v6i32] } SReg_192:{ *:[v6f32] }:$src0)  =>  SReg_192:{ *:[v6i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      // GIR_Coverage, 7223,
      GIR_EraseRootFromParent_Done,
    // Label 749: @67712
    GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(67741), // Rule ID 7224 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      // (bitconvert:{ *:[v6f32] } SReg_192:{ *:[v6i32] }:$src0)  =>  SReg_192:{ *:[v6f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_192RegClassID),
      // GIR_Coverage, 7224,
      GIR_EraseRootFromParent_Done,
    // Label 750: @67741
    GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(67770), // Rule ID 7225 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v6f32] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7225,
      GIR_EraseRootFromParent_Done,
    // Label 751: @67770
    GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(67799), // Rule ID 7226 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v6s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v6i32] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7226,
      GIR_EraseRootFromParent_Done,
    // Label 752: @67799
    GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(67828), // Rule ID 7233 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7233,
      GIR_EraseRootFromParent_Done,
    // Label 753: @67828
    GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(67857), // Rule ID 7234 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3i64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7234,
      GIR_EraseRootFromParent_Done,
    // Label 754: @67857
    GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(67886), // Rule ID 7235 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6i32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7235,
      GIR_EraseRootFromParent_Done,
    // Label 755: @67886
    GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(67915), // Rule ID 7236 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v3s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // (bitconvert:{ *:[v6f32] } VReg_192:{ *:[v3f64] }:$src0)  =>  VReg_192:{ *:[v6f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_192RegClassID),
      // GIR_Coverage, 7236,
      GIR_EraseRootFromParent_Done,
    // Label 756: @67915
    GIM_Reject,
    // Label 595: @67916
    GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(68029),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v7s32,
      GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(67950), // Rule ID 7237 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        // (bitconvert:{ *:[v7i32] } SReg_224:{ *:[v7f32] }:$src0)  =>  SReg_224:{ *:[v7i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        // GIR_Coverage, 7237,
        GIR_EraseRootFromParent_Done,
      // Label 758: @67950
      GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(67976), // Rule ID 7238 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        // (bitconvert:{ *:[v7f32] } SReg_224:{ *:[v7i32] }:$src0)  =>  SReg_224:{ *:[v7f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_224RegClassID),
        // GIR_Coverage, 7238,
        GIR_EraseRootFromParent_Done,
      // Label 759: @67976
      GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(68002), // Rule ID 7239 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        // (bitconvert:{ *:[v7i32] } VReg_224:{ *:[v7f32] }:$src0)  =>  VReg_224:{ *:[v7i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        // GIR_Coverage, 7239,
        GIR_EraseRootFromParent_Done,
      // Label 760: @68002
      GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(68028), // Rule ID 7240 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        // (bitconvert:{ *:[v7f32] } VReg_224:{ *:[v7i32] }:$src0)  =>  VReg_224:{ *:[v7f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_224RegClassID),
        // GIR_Coverage, 7240,
        GIR_EraseRootFromParent_Done,
      // Label 761: @68028
      GIM_Reject,
    // Label 757: @68029
    GIM_Reject,
    // Label 596: @68030
    GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(68059), // Rule ID 7175 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7175,
      GIR_EraseRootFromParent_Done,
    // Label 762: @68059
    GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(68088), // Rule ID 7177 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7177,
      GIR_EraseRootFromParent_Done,
    // Label 763: @68088
    GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(68117), // Rule ID 7178 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7178,
      GIR_EraseRootFromParent_Done,
    // Label 764: @68117
    GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(68146), // Rule ID 7181 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7181,
      GIR_EraseRootFromParent_Done,
    // Label 765: @68146
    GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(68175), // Rule ID 7182 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7182,
      GIR_EraseRootFromParent_Done,
    // Label 766: @68175
    GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(68204), // Rule ID 7184 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7184,
      GIR_EraseRootFromParent_Done,
    // Label 767: @68204
    GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(68233), // Rule ID 7185 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7185,
      GIR_EraseRootFromParent_Done,
    // Label 768: @68233
    GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(68262), // Rule ID 7186 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7186,
      GIR_EraseRootFromParent_Done,
    // Label 769: @68262
    GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(68291), // Rule ID 7187 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7187,
      GIR_EraseRootFromParent_Done,
    // Label 770: @68291
    GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(68320), // Rule ID 7188 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7188,
      GIR_EraseRootFromParent_Done,
    // Label 771: @68320
    GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(68349), // Rule ID 7189 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7189,
      GIR_EraseRootFromParent_Done,
    // Label 772: @68349
    GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(68378), // Rule ID 7190 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7190,
      GIR_EraseRootFromParent_Done,
    // Label 773: @68378
    GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(68407), // Rule ID 7196 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v4i32] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7196,
      GIR_EraseRootFromParent_Done,
    // Label 774: @68407
    GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(68436), // Rule ID 7198 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v4i32] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7198,
      GIR_EraseRootFromParent_Done,
    // Label 775: @68436
    GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(68465), // Rule ID 7200 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v4f32] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7200,
      GIR_EraseRootFromParent_Done,
    // Label 776: @68465
    GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(68494), // Rule ID 7202 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v4f32] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7202,
      GIR_EraseRootFromParent_Done,
    // Label 777: @68494
    GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(68523), // Rule ID 7203 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7203,
      GIR_EraseRootFromParent_Done,
    // Label 778: @68523
    GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(68552), // Rule ID 7204 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v8i16] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7204,
      GIR_EraseRootFromParent_Done,
    // Label 779: @68552
    GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(68581), // Rule ID 7205 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8i16] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v8i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7205,
      GIR_EraseRootFromParent_Done,
    // Label 780: @68581
    GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(68610), // Rule ID 7206 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v8i16] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7206,
      GIR_EraseRootFromParent_Done,
    // Label 781: @68610
    GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(68639), // Rule ID 7207 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } SReg_128:{ *:[v8bf16] }:$src0)  =>  SReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7207,
      GIR_EraseRootFromParent_Done,
    // Label 782: @68639
    GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(68668), // Rule ID 7208 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v8f16] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7208,
      GIR_EraseRootFromParent_Done,
    // Label 783: @68668
    GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(68697), // Rule ID 7209 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8f16] } VReg_128:{ *:[v8bf16] }:$src0)  =>  VReg_128:{ *:[v8f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7209,
      GIR_EraseRootFromParent_Done,
    // Label 784: @68697
    GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(68726), // Rule ID 7210 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v8f16] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7210,
      GIR_EraseRootFromParent_Done,
    // Label 785: @68726
    GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(68755), // Rule ID 7212 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v2f64] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7212,
      GIR_EraseRootFromParent_Done,
    // Label 786: @68755
    GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(68784), // Rule ID 7214 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v2f64] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7214,
      GIR_EraseRootFromParent_Done,
    // Label 787: @68784
    GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(68813), // Rule ID 7216 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } SReg_128:{ *:[v2i64] }:$src0)  =>  SReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // GIR_Coverage, 7216,
      GIR_EraseRootFromParent_Done,
    // Label 788: @68813
    GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(68842), // Rule ID 7218 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // (bitconvert:{ *:[v8bf16] } VReg_128:{ *:[v2i64] }:$src0)  =>  VReg_128:{ *:[v8bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      // GIR_Coverage, 7218,
      GIR_EraseRootFromParent_Done,
    // Label 789: @68842
    GIM_Reject,
    // Label 597: @68843
    GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(68872), // Rule ID 7241 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } SReg_256:{ *:[v8f32] }:$src0)  =>  SReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7241,
      GIR_EraseRootFromParent_Done,
    // Label 790: @68872
    GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(68901), // Rule ID 7242 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } SReg_256:{ *:[v8i32] }:$src0)  =>  SReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7242,
      GIR_EraseRootFromParent_Done,
    // Label 791: @68901
    GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(68930), // Rule ID 7243 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7243,
      GIR_EraseRootFromParent_Done,
    // Label 792: @68930
    GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(68959), // Rule ID 7244 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7244,
      GIR_EraseRootFromParent_Done,
    // Label 793: @68959
    GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(68988), // Rule ID 7251 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7251,
      GIR_EraseRootFromParent_Done,
    // Label 794: @68988
    GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(69017), // Rule ID 7252 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7252,
      GIR_EraseRootFromParent_Done,
    // Label 795: @69017
    GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(69046), // Rule ID 7253 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7253,
      GIR_EraseRootFromParent_Done,
    // Label 796: @69046
    GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(69075), // Rule ID 7254 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7254,
      GIR_EraseRootFromParent_Done,
    // Label 797: @69075
    GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(69104), // Rule ID 7263 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7263,
      GIR_EraseRootFromParent_Done,
    // Label 798: @69104
    GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(69133), // Rule ID 7264 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7264,
      GIR_EraseRootFromParent_Done,
    // Label 799: @69133
    GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(69162), // Rule ID 7265 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7265,
      GIR_EraseRootFromParent_Done,
    // Label 800: @69162
    GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(69191), // Rule ID 7266 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7266,
      GIR_EraseRootFromParent_Done,
    // Label 801: @69191
    GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(69220), // Rule ID 7275 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8i32] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v8i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7275,
      GIR_EraseRootFromParent_Done,
    // Label 802: @69220
    GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(69249), // Rule ID 7277 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v8f32] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v8f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7277,
      GIR_EraseRootFromParent_Done,
    // Label 803: @69249
    GIM_Reject,
    // Label 598: @69250
    GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(69279), // Rule ID 7319 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7319,
      GIR_EraseRootFromParent_Done,
    // Label 804: @69279
    GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(69308), // Rule ID 7320 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7320,
      GIR_EraseRootFromParent_Done,
    // Label 805: @69308
    GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(69337), // Rule ID 7321 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7321,
      GIR_EraseRootFromParent_Done,
    // Label 806: @69337
    GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(69366), // Rule ID 7322 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7322,
      GIR_EraseRootFromParent_Done,
    // Label 807: @69366
    GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(69395), // Rule ID 7325 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7325,
      GIR_EraseRootFromParent_Done,
    // Label 808: @69395
    GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(69424), // Rule ID 7326 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7326,
      GIR_EraseRootFromParent_Done,
    // Label 809: @69424
    GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(69453), // Rule ID 7346 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8f64] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v8f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7346,
      GIR_EraseRootFromParent_Done,
    // Label 810: @69453
    GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(69482), // Rule ID 7348 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v8f64] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v8f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7348,
      GIR_EraseRootFromParent_Done,
    // Label 811: @69482
    GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(69511), // Rule ID 7350 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v8i64] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v8i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7350,
      GIR_EraseRootFromParent_Done,
    // Label 812: @69511
    GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(69540), // Rule ID 7352 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v8i64] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v8i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7352,
      GIR_EraseRootFromParent_Done,
    // Label 813: @69540
    GIM_Reject,
    // Label 599: @69541
    GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(69654),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v9s32,
      GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(69575), // Rule ID 7291 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        // (bitconvert:{ *:[v9i32] } SReg_288:{ *:[v9f32] }:$src0)  =>  SReg_288:{ *:[v9i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        // GIR_Coverage, 7291,
        GIR_EraseRootFromParent_Done,
      // Label 815: @69575
      GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(69601), // Rule ID 7292 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        // (bitconvert:{ *:[v9f32] } SReg_288:{ *:[v9i32] }:$src0)  =>  SReg_288:{ *:[v9f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_288RegClassID),
        // GIR_Coverage, 7292,
        GIR_EraseRootFromParent_Done,
      // Label 816: @69601
      GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(69627), // Rule ID 7293 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        // (bitconvert:{ *:[v9i32] } VReg_288:{ *:[v9f32] }:$src0)  =>  VReg_288:{ *:[v9i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        // GIR_Coverage, 7293,
        GIR_EraseRootFromParent_Done,
      // Label 817: @69627
      GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(69653), // Rule ID 7294 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        // (bitconvert:{ *:[v9f32] } VReg_288:{ *:[v9i32] }:$src0)  =>  VReg_288:{ *:[v9f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_288RegClassID),
        // GIR_Coverage, 7294,
        GIR_EraseRootFromParent_Done,
      // Label 818: @69653
      GIM_Reject,
    // Label 814: @69654
    GIM_Reject,
    // Label 600: @69655
    GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(69768),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v10s32,
      GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(69689), // Rule ID 7295 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        // (bitconvert:{ *:[v10i32] } SReg_320:{ *:[v10f32] }:$src0)  =>  SReg_320:{ *:[v10i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        // GIR_Coverage, 7295,
        GIR_EraseRootFromParent_Done,
      // Label 820: @69689
      GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(69715), // Rule ID 7296 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        // (bitconvert:{ *:[v10f32] } SReg_320:{ *:[v10i32] }:$src0)  =>  SReg_320:{ *:[v10f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_320RegClassID),
        // GIR_Coverage, 7296,
        GIR_EraseRootFromParent_Done,
      // Label 821: @69715
      GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(69741), // Rule ID 7297 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        // (bitconvert:{ *:[v10i32] } VReg_320:{ *:[v10f32] }:$src0)  =>  VReg_320:{ *:[v10i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        // GIR_Coverage, 7297,
        GIR_EraseRootFromParent_Done,
      // Label 822: @69741
      GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(69767), // Rule ID 7298 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        // (bitconvert:{ *:[v10f32] } VReg_320:{ *:[v10i32] }:$src0)  =>  VReg_320:{ *:[v10f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_320RegClassID),
        // GIR_Coverage, 7298,
        GIR_EraseRootFromParent_Done,
      // Label 823: @69767
      GIM_Reject,
    // Label 819: @69768
    GIM_Reject,
    // Label 601: @69769
    GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(69882),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v11s32,
      GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(69803), // Rule ID 7299 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        // (bitconvert:{ *:[v11i32] } SReg_352:{ *:[v11f32] }:$src0)  =>  SReg_352:{ *:[v11i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        // GIR_Coverage, 7299,
        GIR_EraseRootFromParent_Done,
      // Label 825: @69803
      GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(69829), // Rule ID 7300 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        // (bitconvert:{ *:[v11f32] } SReg_352:{ *:[v11i32] }:$src0)  =>  SReg_352:{ *:[v11f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_352RegClassID),
        // GIR_Coverage, 7300,
        GIR_EraseRootFromParent_Done,
      // Label 826: @69829
      GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(69855), // Rule ID 7301 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        // (bitconvert:{ *:[v11i32] } VReg_352:{ *:[v11f32] }:$src0)  =>  VReg_352:{ *:[v11i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        // GIR_Coverage, 7301,
        GIR_EraseRootFromParent_Done,
      // Label 827: @69855
      GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(69881), // Rule ID 7302 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        // (bitconvert:{ *:[v11f32] } VReg_352:{ *:[v11i32] }:$src0)  =>  VReg_352:{ *:[v11f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_352RegClassID),
        // GIR_Coverage, 7302,
        GIR_EraseRootFromParent_Done,
      // Label 828: @69881
      GIM_Reject,
    // Label 824: @69882
    GIM_Reject,
    // Label 602: @69883
    GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(69996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v12s32,
      GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(69917), // Rule ID 7303 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        // (bitconvert:{ *:[v12i32] } SReg_384:{ *:[v12f32] }:$src0)  =>  SReg_384:{ *:[v12i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        // GIR_Coverage, 7303,
        GIR_EraseRootFromParent_Done,
      // Label 830: @69917
      GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(69943), // Rule ID 7304 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        // (bitconvert:{ *:[v12f32] } SReg_384:{ *:[v12i32] }:$src0)  =>  SReg_384:{ *:[v12f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_384RegClassID),
        // GIR_Coverage, 7304,
        GIR_EraseRootFromParent_Done,
      // Label 831: @69943
      GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(69969), // Rule ID 7305 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        // (bitconvert:{ *:[v12i32] } VReg_384:{ *:[v12f32] }:$src0)  =>  VReg_384:{ *:[v12i32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        // GIR_Coverage, 7305,
        GIR_EraseRootFromParent_Done,
      // Label 832: @69969
      GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(69995), // Rule ID 7306 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        // (bitconvert:{ *:[v12f32] } VReg_384:{ *:[v12i32] }:$src0)  =>  VReg_384:{ *:[v12f32] }:$src0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // dst
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_384RegClassID),
        // GIR_Coverage, 7306,
        GIR_EraseRootFromParent_Done,
      // Label 833: @69995
      GIM_Reject,
    // Label 829: @69996
    GIM_Reject,
    // Label 603: @69997
    GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(70026), // Rule ID 7255 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7255,
      GIR_EraseRootFromParent_Done,
    // Label 834: @70026
    GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(70055), // Rule ID 7256 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7256,
      GIR_EraseRootFromParent_Done,
    // Label 835: @70055
    GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(70084), // Rule ID 7257 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7257,
      GIR_EraseRootFromParent_Done,
    // Label 836: @70084
    GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(70113), // Rule ID 7258 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7258,
      GIR_EraseRootFromParent_Done,
    // Label 837: @70113
    GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(70142), // Rule ID 7259 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7259,
      GIR_EraseRootFromParent_Done,
    // Label 838: @70142
    GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(70171), // Rule ID 7260 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7260,
      GIR_EraseRootFromParent_Done,
    // Label 839: @70171
    GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(70200), // Rule ID 7261 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7261,
      GIR_EraseRootFromParent_Done,
    // Label 840: @70200
    GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(70229), // Rule ID 7262 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7262,
      GIR_EraseRootFromParent_Done,
    // Label 841: @70229
    GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(70258), // Rule ID 7267 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7267,
      GIR_EraseRootFromParent_Done,
    // Label 842: @70258
    GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(70287), // Rule ID 7268 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7268,
      GIR_EraseRootFromParent_Done,
    // Label 843: @70287
    GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(70316), // Rule ID 7269 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7269,
      GIR_EraseRootFromParent_Done,
    // Label 844: @70316
    GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(70345), // Rule ID 7270 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7270,
      GIR_EraseRootFromParent_Done,
    // Label 845: @70345
    GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(70374), // Rule ID 7276 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v8i32] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7276,
      GIR_EraseRootFromParent_Done,
    // Label 846: @70374
    GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(70403), // Rule ID 7278 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v8f32] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7278,
      GIR_EraseRootFromParent_Done,
    // Label 847: @70403
    GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(70432), // Rule ID 7280 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v4i64] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7280,
      GIR_EraseRootFromParent_Done,
    // Label 848: @70432
    GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(70461), // Rule ID 7282 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v4f64] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7282,
      GIR_EraseRootFromParent_Done,
    // Label 849: @70461
    GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(70490), // Rule ID 7283 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } SReg_256:{ *:[v16bf16] }:$src0)  =>  SReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7283,
      GIR_EraseRootFromParent_Done,
    // Label 850: @70490
    GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(70519), // Rule ID 7284 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } SReg_256:{ *:[v16i16] }:$src0)  =>  SReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7284,
      GIR_EraseRootFromParent_Done,
    // Label 851: @70519
    GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(70548), // Rule ID 7285 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16i16] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v16i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7285,
      GIR_EraseRootFromParent_Done,
    // Label 852: @70548
    GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(70577), // Rule ID 7286 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v16i16] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7286,
      GIR_EraseRootFromParent_Done,
    // Label 853: @70577
    GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(70606), // Rule ID 7287 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } SReg_256:{ *:[v16bf16] }:$src0)  =>  SReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7287,
      GIR_EraseRootFromParent_Done,
    // Label 854: @70606
    GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(70635), // Rule ID 7288 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } SReg_256:{ *:[v16f16] }:$src0)  =>  SReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      // GIR_Coverage, 7288,
      GIR_EraseRootFromParent_Done,
    // Label 855: @70635
    GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(70664), // Rule ID 7289 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16f16] } VReg_256:{ *:[v16bf16] }:$src0)  =>  VReg_256:{ *:[v16f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7289,
      GIR_EraseRootFromParent_Done,
    // Label 856: @70664
    GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(70693), // Rule ID 7290 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // (bitconvert:{ *:[v16bf16] } VReg_256:{ *:[v16f16] }:$src0)  =>  VReg_256:{ *:[v16bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_256RegClassID),
      // GIR_Coverage, 7290,
      GIR_EraseRootFromParent_Done,
    // Label 857: @70693
    GIM_Reject,
    // Label 604: @70694
    GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(70723), // Rule ID 7311 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7311,
      GIR_EraseRootFromParent_Done,
    // Label 858: @70723
    GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(70752), // Rule ID 7312 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7312,
      GIR_EraseRootFromParent_Done,
    // Label 859: @70752
    GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(70781), // Rule ID 7315 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7315,
      GIR_EraseRootFromParent_Done,
    // Label 860: @70781
    GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(70810), // Rule ID 7316 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7316,
      GIR_EraseRootFromParent_Done,
    // Label 861: @70810
    GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(70839), // Rule ID 7317 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7317,
      GIR_EraseRootFromParent_Done,
    // Label 862: @70839
    GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(70868), // Rule ID 7318 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7318,
      GIR_EraseRootFromParent_Done,
    // Label 863: @70868
    GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(70897), // Rule ID 7323 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7323,
      GIR_EraseRootFromParent_Done,
    // Label 864: @70897
    GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(70926), // Rule ID 7324 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7324,
      GIR_EraseRootFromParent_Done,
    // Label 865: @70926
    GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(70955), // Rule ID 7327 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7327,
      GIR_EraseRootFromParent_Done,
    // Label 866: @70955
    GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(70984), // Rule ID 7328 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7328,
      GIR_EraseRootFromParent_Done,
    // Label 867: @70984
    GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(71013), // Rule ID 7338 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7338,
      GIR_EraseRootFromParent_Done,
    // Label 868: @71013
    GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(71042), // Rule ID 7340 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v16i32] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v16i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7340,
      GIR_EraseRootFromParent_Done,
    // Label 869: @71042
    GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(71071), // Rule ID 7342 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7342,
      GIR_EraseRootFromParent_Done,
    // Label 870: @71071
    GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(71100), // Rule ID 7344 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v16f32] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v16f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7344,
      GIR_EraseRootFromParent_Done,
    // Label 871: @71100
    GIM_Reject,
    // Label 605: @71101
    GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(71130), // Rule ID 7355 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7355,
      GIR_EraseRootFromParent_Done,
    // Label 872: @71130
    GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(71159), // Rule ID 7356 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7356,
      GIR_EraseRootFromParent_Done,
    // Label 873: @71159
    GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(71188), // Rule ID 7357 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7357,
      GIR_EraseRootFromParent_Done,
    // Label 874: @71188
    GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(71217), // Rule ID 7359 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7359,
      GIR_EraseRootFromParent_Done,
    // Label 875: @71217
    GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(71246), // Rule ID 7361 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16i64] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v16i64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7361,
      GIR_EraseRootFromParent_Done,
    // Label 876: @71246
    GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(71275), // Rule ID 7363 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v16f64] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v16f64] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7363,
      GIR_EraseRootFromParent_Done,
    // Label 877: @71275
    GIM_Reject,
    // Label 606: @71276
    GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(71305), // Rule ID 7307 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7307,
      GIR_EraseRootFromParent_Done,
    // Label 878: @71305
    GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(71334), // Rule ID 7308 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7308,
      GIR_EraseRootFromParent_Done,
    // Label 879: @71334
    GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(71363), // Rule ID 7309 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7309,
      GIR_EraseRootFromParent_Done,
    // Label 880: @71363
    GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(71392), // Rule ID 7310 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7310,
      GIR_EraseRootFromParent_Done,
    // Label 881: @71392
    GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(71421), // Rule ID 7313 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7313,
      GIR_EraseRootFromParent_Done,
    // Label 882: @71421
    GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(71450), // Rule ID 7314 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7314,
      GIR_EraseRootFromParent_Done,
    // Label 883: @71450
    GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(71479), // Rule ID 7329 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v32i16] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7329,
      GIR_EraseRootFromParent_Done,
    // Label 884: @71479
    GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(71508), // Rule ID 7330 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32i16] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v32i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7330,
      GIR_EraseRootFromParent_Done,
    // Label 885: @71508
    GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(71537), // Rule ID 7331 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v32i16] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7331,
      GIR_EraseRootFromParent_Done,
    // Label 886: @71537
    GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(71566), // Rule ID 7332 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32i16] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v32i16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7332,
      GIR_EraseRootFromParent_Done,
    // Label 887: @71566
    GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(71595), // Rule ID 7333 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v32f16] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7333,
      GIR_EraseRootFromParent_Done,
    // Label 888: @71595
    GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(71624), // Rule ID 7334 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32f16] } VReg_512:{ *:[v32bf16] }:$src0)  =>  VReg_512:{ *:[v32f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7334,
      GIR_EraseRootFromParent_Done,
    // Label 889: @71624
    GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(71653), // Rule ID 7335 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v32f16] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7335,
      GIR_EraseRootFromParent_Done,
    // Label 890: @71653
    GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(71682), // Rule ID 7336 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32f16] } SReg_512:{ *:[v32bf16] }:$src0)  =>  SReg_512:{ *:[v32f16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7336,
      GIR_EraseRootFromParent_Done,
    // Label 891: @71682
    GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(71711), // Rule ID 7337 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v16i32] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7337,
      GIR_EraseRootFromParent_Done,
    // Label 892: @71711
    GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(71740), // Rule ID 7339 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v16i32] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7339,
      GIR_EraseRootFromParent_Done,
    // Label 893: @71740
    GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(71769), // Rule ID 7341 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v16f32] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7341,
      GIR_EraseRootFromParent_Done,
    // Label 894: @71769
    GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(71798), // Rule ID 7343 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v16f32] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7343,
      GIR_EraseRootFromParent_Done,
    // Label 895: @71798
    GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(71827), // Rule ID 7345 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v8f64] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7345,
      GIR_EraseRootFromParent_Done,
    // Label 896: @71827
    GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(71856), // Rule ID 7347 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v8f64] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7347,
      GIR_EraseRootFromParent_Done,
    // Label 897: @71856
    GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(71885), // Rule ID 7349 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } VReg_512:{ *:[v8i64] }:$src0)  =>  VReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_512RegClassID),
      // GIR_Coverage, 7349,
      GIR_EraseRootFromParent_Done,
    // Label 898: @71885
    GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(71914), // Rule ID 7351 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // (bitconvert:{ *:[v32bf16] } SReg_512:{ *:[v8i64] }:$src0)  =>  SReg_512:{ *:[v32bf16] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      // GIR_Coverage, 7351,
      GIR_EraseRootFromParent_Done,
    // Label 899: @71914
    GIM_Reject,
    // Label 607: @71915
    GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(71944), // Rule ID 7353 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v32f32] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7353,
      GIR_EraseRootFromParent_Done,
    // Label 900: @71944
    GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(71973), // Rule ID 7354 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v32i32] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7354,
      GIR_EraseRootFromParent_Done,
    // Label 901: @71973
    GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(72002), // Rule ID 7358 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7358,
      GIR_EraseRootFromParent_Done,
    // Label 902: @72002
    GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(72031), // Rule ID 7360 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7360,
      GIR_EraseRootFromParent_Done,
    // Label 903: @72031
    GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(72060), // Rule ID 7362 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32i32] } VReg_1024:{ *:[v16f64] }:$src0)  =>  VReg_1024:{ *:[v32i32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7362,
      GIR_EraseRootFromParent_Done,
    // Label 904: @72060
    GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(72089), // Rule ID 7364 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // (bitconvert:{ *:[v32f32] } VReg_1024:{ *:[v16i64] }:$src0)  =>  VReg_1024:{ *:[v32f32] }:$src0
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_RootToRootCopy, /*OpIdx*/0, // dst
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
      // GIR_Coverage, 7364,
      GIR_EraseRootFromParent_Done,
    // Label 905: @72089
    GIM_Reject,
    // Label 608: @72090
    GIM_Reject,
    // Label 9: @72091
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 908*/ GIMT_Encode4(72182),
    /*GILLT_s16*//*Label 906*/ GIMT_Encode4(72110),
    /*GILLT_s32*//*Label 907*/ GIMT_Encode4(72146),
    // Label 906: @72110
    GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(72145), // Rule ID 6990 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] round
      GIM_CheckIsImm, /*MI*/0, /*Op*/2,
      GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
      // (fptrunc_round:{ *:[f16] } f32:{ *:[f32] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F16_F32_PSEUDO:{ *:[f16] } ?:{ *:[f32] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F16_F32_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6990,
      GIR_EraseRootFromParent_Done,
    // Label 909: @72145
    GIM_Reject,
    // Label 907: @72146
    GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(72181), // Rule ID 6991 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] round
      GIM_CheckIsImm, /*MI*/0, /*Op*/2,
      GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SupportedRoundMode),
      // (fptrunc_round:{ *:[f32] } f64:{ *:[f64] }:$src0, (timm:{ *:[i32] })<<P:Predicate_SupportedRoundMode>>:$round)  =>  (FPTRUNC_ROUND_F32_F64_PSEUDO:{ *:[f32] } ?:{ *:[f64] }:$src0, (as_hw_round_mode:{ *:[i32] } ?:{ *:[i32] }:$round))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FPTRUNC_ROUND_F32_F64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderRoundMode), // round
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6991,
      GIR_EraseRootFromParent_Done,
    // Label 910: @72181
    GIM_Reject,
    // Label 908: @72182
    GIM_Reject,
    // Label 10: @72183
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 914*/ GIMT_Encode4(72510),
    /*GILLT_s16*//*Label 911*/ GIMT_Encode4(72206),
    /*GILLT_s32*//*Label 912*/ GIMT_Encode4(72380),
    /*GILLT_s64*//*Label 913*/ GIMT_Encode4(72460),
    // Label 911: @72206
    GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(72379),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(72241), // Rule ID 39 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13378),
        // (ftrunc:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13378>>  =>  (S_TRUNC_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 39,
        GIR_Done,
      // Label 916: @72241
      GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(72287), // Rule ID 772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 772,
        GIR_EraseRootFromParent_Done,
      // Label 917: @72287
      GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(72333), // Rule ID 774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ftrunc:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 774,
        GIR_EraseRootFromParent_Done,
      // Label 918: @72333
      GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(72378), // Rule ID 773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (ftrunc:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_TRUNC_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 773,
        GIR_EraseRootFromParent_Done,
      // Label 919: @72378
      GIM_Reject,
    // Label 915: @72379
    GIM_Reject,
    // Label 912: @72380
    GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(72459),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(72415), // Rule ID 34 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13378),
        // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13378>>  =>  (S_TRUNC_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_TRUNC_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 34,
        GIR_Done,
      // Label 921: @72415
      GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(72458), // Rule ID 658 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ftrunc:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 658,
        GIR_EraseRootFromParent_Done,
      // Label 922: @72458
      GIM_Reject,
    // Label 920: @72459
    GIM_Reject,
    // Label 913: @72460
    GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(72509), // Rule ID 702 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (ftrunc:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_TRUNC_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRUNC_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 702,
      GIR_EraseRootFromParent_Done,
    // Label 923: @72509
    GIM_Reject,
    // Label 914: @72510
    GIM_Reject,
    // Label 11: @72511
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 927*/ GIMT_Encode4(72838),
    /*GILLT_s16*//*Label 924*/ GIMT_Encode4(72534),
    /*GILLT_s32*//*Label 925*/ GIMT_Encode4(72708),
    /*GILLT_s64*//*Label 926*/ GIMT_Encode4(72788),
    // Label 924: @72534
    GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(72707),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(72569), // Rule ID 40 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13379),
        // (froundeven:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13379>>  =>  (S_RNDNE_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 40,
        GIR_Done,
      // Label 929: @72569
      GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(72615), // Rule ID 775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 775,
        GIR_EraseRootFromParent_Done,
      // Label 930: @72615
      GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(72661), // Rule ID 777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (froundeven:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 777,
        GIR_EraseRootFromParent_Done,
      // Label 931: @72661
      GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(72706), // Rule ID 776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (froundeven:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RNDNE_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 776,
        GIR_EraseRootFromParent_Done,
      // Label 932: @72706
      GIM_Reject,
    // Label 928: @72707
    GIM_Reject,
    // Label 925: @72708
    GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(72787),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(72743), // Rule ID 35 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13379),
        // (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13379>>  =>  (S_RNDNE_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_RNDNE_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 35,
        GIR_Done,
      // Label 934: @72743
      GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(72786), // Rule ID 660 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (froundeven:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 660,
        GIR_EraseRootFromParent_Done,
      // Label 935: @72786
      GIM_Reject,
    // Label 933: @72787
    GIM_Reject,
    // Label 926: @72788
    GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(72837), // Rule ID 704 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (froundeven:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RNDNE_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RNDNE_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 704,
      GIR_EraseRootFromParent_Done,
    // Label 936: @72837
    GIM_Reject,
    // Label 927: @72838
    GIM_Reject,
    // Label 12: @72839
    GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(72978),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(72872), // Rule ID 1344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesHiLoRegisters),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (readcyclecounter:{ *:[i64] })  =>  (GET_SHADERCYCLESHILO:{ *:[i64] }:{ *:[i1] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::GET_SHADERCYCLESHILO),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1344,
        GIR_Done,
      // Label 938: @72872
      GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(72891), // Rule ID 3515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // (readcyclecounter:{ *:[i64] })  =>  (S_MEMTIME:{ *:[i64] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3515,
        GIR_Done,
      // Label 939: @72891
      GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(72977), // Rule ID 3516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShaderCyclesRegister),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (readcyclecounter:{ *:[i64] })  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 38941:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(38941),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        // GIR_Coverage, 3516,
        GIR_EraseRootFromParent_Done,
      // Label 940: @72977
      GIM_Reject,
    // Label 937: @72978
    GIM_Reject,
    // Label 13: @72979
    GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(73036),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(73006), // Rule ID 3517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // (readsteadycounter:{ *:[i64] })  =>  (S_MEMREALTIME:{ *:[i64] })
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3517,
        GIR_Done,
      // Label 942: @73006
      GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(73035), // Rule ID 3518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (readsteadycounter:{ *:[i64] })  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } 131:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3518,
        GIR_EraseRootFromParent_Done,
      // Label 943: @73035
      GIM_Reject,
    // Label 941: @73036
    GIM_Reject,
    // Label 14: @73037
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(33), /*)*//*default:*//*Label 968*/ GIMT_Encode4(148425),
    /*GILLT_p0s64*//*Label 944*/ GIMT_Encode4(73180),
    /*GILLT_p1s64*//*Label 945*/ GIMT_Encode4(75174),
    /*GILLT_p2s32*//*Label 946*/ GIMT_Encode4(77168),
    /*GILLT_p3s32*//*Label 947*/ GIMT_Encode4(78870),
    /*GILLT_p4s64*//*Label 948*/ GIMT_Encode4(80572),
    /*GILLT_p5s32*//*Label 949*/ GIMT_Encode4(82566),
    /*GILLT_p6s32*//*Label 950*/ GIMT_Encode4(84268),
    /*GILLT_s1*//*Label 951*/ GIMT_Encode4(85970),
    /*GILLT_s16*//*Label 952*/ GIMT_Encode4(86603),
    /*GILLT_s32*//*Label 953*/ GIMT_Encode4(89838),
    /*GILLT_s64*//*Label 954*/ GIMT_Encode4(97866),
    /*GILLT_v2s16*//*Label 955*/ GIMT_Encode4(103256),
    /*GILLT_v2s32*//*Label 956*/ GIMT_Encode4(108360),
    /*GILLT_v2s64*//*Label 957*/ GIMT_Encode4(112609),
    /*GILLT_v3s32*//*Label 958*/ GIMT_Encode4(116596), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 959*/ GIMT_Encode4(119974),
    /*GILLT_v4s32*//*Label 960*/ GIMT_Encode4(125954),
    /*GILLT_v4s64*//*Label 961*/ GIMT_Encode4(130203), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 962*/ GIMT_Encode4(131954),
    /*GILLT_v8s32*//*Label 963*/ GIMT_Encode4(137934),
    /*GILLT_v8s64*//*Label 964*/ GIMT_Encode4(139685), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v16s16*//*Label 965*/ GIMT_Encode4(141436),
    /*GILLT_v16s32*//*Label 966*/ GIMT_Encode4(144055), GIMT_Encode4(0),
    /*GILLT_v32s16*//*Label 967*/ GIMT_Encode4(145806),
    // Label 944: @73180
    GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(73247), // Rule ID 8452 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8452,
      GIR_EraseRootFromParent_Done,
    // Label 969: @73247
    GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(73310), // Rule ID 8457 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8457,
      GIR_EraseRootFromParent_Done,
    // Label 970: @73310
    GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(73373), // Rule ID 8463 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8463,
      GIR_EraseRootFromParent_Done,
    // Label 971: @73373
    GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(73435), // Rule ID 8448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8448,
      GIR_EraseRootFromParent_Done,
    // Label 972: @73435
    GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(73497), // Rule ID 8449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8449,
      GIR_EraseRootFromParent_Done,
    // Label 973: @73497
    GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(73559), // Rule ID 8450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8450,
      GIR_EraseRootFromParent_Done,
    // Label 974: @73559
    GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(73624), // Rule ID 8451 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8451,
      GIR_EraseRootFromParent_Done,
    // Label 975: @73624
    GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(73682), // Rule ID 8454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8454,
      GIR_EraseRootFromParent_Done,
    // Label 976: @73682
    GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(73740), // Rule ID 8455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8455,
      GIR_EraseRootFromParent_Done,
    // Label 977: @73740
    GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(73801), // Rule ID 8456 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8456,
      GIR_EraseRootFromParent_Done,
    // Label 978: @73801
    GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(73869), // Rule ID 8164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8164,
      GIR_EraseRootFromParent_Done,
    // Label 979: @73869
    GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(73932), // Rule ID 8088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8088,
      GIR_EraseRootFromParent_Done,
    // Label 980: @73932
    GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(73987), // Rule ID 8459 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8459,
      GIR_EraseRootFromParent_Done,
    // Label 981: @73987
    GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(74045), // Rule ID 8460 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8460,
      GIR_EraseRootFromParent_Done,
    // Label 982: @74045
    GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(74103), // Rule ID 8461 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8461,
      GIR_EraseRootFromParent_Done,
    // Label 983: @74103
    GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(74164), // Rule ID 8462 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8462,
      GIR_EraseRootFromParent_Done,
    // Label 984: @74164
    GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(74228), // Rule ID 8165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8165,
      GIR_EraseRootFromParent_Done,
    // Label 985: @74228
    GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(74287), // Rule ID 8089 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8089,
      GIR_EraseRootFromParent_Done,
    // Label 986: @74287
    GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(74341), // Rule ID 8453 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8453,
      GIR_EraseRootFromParent_Done,
    // Label 987: @74341
    GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(74391), // Rule ID 8458 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8458,
      GIR_EraseRootFromParent_Done,
    // Label 988: @74391
    GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(74438), // Rule ID 8464 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8464,
      GIR_EraseRootFromParent_Done,
    // Label 989: @74438
    GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(74498), // Rule ID 4277 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4277,
      GIR_EraseRootFromParent_Done,
    // Label 990: @74498
    GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(74553), // Rule ID 4276 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4276,
      GIR_EraseRootFromParent_Done,
    // Label 991: @74553
    GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(74608), // Rule ID 4275 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4275,
      GIR_EraseRootFromParent_Done,
    // Label 992: @74608
    GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(74678), // Rule ID 4519 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4519,
      GIR_EraseRootFromParent_Done,
    // Label 993: @74678
    GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(74745), // Rule ID 4521 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4521,
      GIR_EraseRootFromParent_Done,
    // Label 994: @74745
    GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(74809), // Rule ID 8024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8024,
      GIR_EraseRootFromParent_Done,
    // Label 995: @74809
    GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(74874), // Rule ID 4518 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4518,
      GIR_EraseRootFromParent_Done,
    // Label 996: @74874
    GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(74936), // Rule ID 4520 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4520,
      GIR_EraseRootFromParent_Done,
    // Label 997: @74936
    GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(74996), // Rule ID 8026 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8026,
      GIR_EraseRootFromParent_Done,
    // Label 998: @74996
    GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(75058), // Rule ID 3878 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3878,
      GIR_EraseRootFromParent_Done,
    // Label 999: @75058
    GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(75115), // Rule ID 3877 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3877,
      GIR_EraseRootFromParent_Done,
    // Label 1000: @75115
    GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(75173), // Rule ID 3611 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3611,
      GIR_EraseRootFromParent_Done,
    // Label 1001: @75173
    GIM_Reject,
    // Label 945: @75174
    GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(75241), // Rule ID 8469 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8469,
      GIR_EraseRootFromParent_Done,
    // Label 1002: @75241
    GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(75304), // Rule ID 8474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8474,
      GIR_EraseRootFromParent_Done,
    // Label 1003: @75304
    GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(75367), // Rule ID 8480 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8480,
      GIR_EraseRootFromParent_Done,
    // Label 1004: @75367
    GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(75429), // Rule ID 8465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8465,
      GIR_EraseRootFromParent_Done,
    // Label 1005: @75429
    GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(75491), // Rule ID 8466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8466,
      GIR_EraseRootFromParent_Done,
    // Label 1006: @75491
    GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(75553), // Rule ID 8467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8467,
      GIR_EraseRootFromParent_Done,
    // Label 1007: @75553
    GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(75618), // Rule ID 8468 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8468,
      GIR_EraseRootFromParent_Done,
    // Label 1008: @75618
    GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(75676), // Rule ID 8471 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8471,
      GIR_EraseRootFromParent_Done,
    // Label 1009: @75676
    GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(75734), // Rule ID 8472 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8472,
      GIR_EraseRootFromParent_Done,
    // Label 1010: @75734
    GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(75795), // Rule ID 8473 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8473,
      GIR_EraseRootFromParent_Done,
    // Label 1011: @75795
    GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(75863), // Rule ID 8168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8168,
      GIR_EraseRootFromParent_Done,
    // Label 1012: @75863
    GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(75926), // Rule ID 8092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8092,
      GIR_EraseRootFromParent_Done,
    // Label 1013: @75926
    GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(75981), // Rule ID 8476 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8476,
      GIR_EraseRootFromParent_Done,
    // Label 1014: @75981
    GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(76039), // Rule ID 8477 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8477,
      GIR_EraseRootFromParent_Done,
    // Label 1015: @76039
    GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(76097), // Rule ID 8478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8478,
      GIR_EraseRootFromParent_Done,
    // Label 1016: @76097
    GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(76158), // Rule ID 8479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8479,
      GIR_EraseRootFromParent_Done,
    // Label 1017: @76158
    GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(76222), // Rule ID 8169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8169,
      GIR_EraseRootFromParent_Done,
    // Label 1018: @76222
    GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(76281), // Rule ID 8093 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8093,
      GIR_EraseRootFromParent_Done,
    // Label 1019: @76281
    GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(76335), // Rule ID 8470 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8470,
      GIR_EraseRootFromParent_Done,
    // Label 1020: @76335
    GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(76385), // Rule ID 8475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8475,
      GIR_EraseRootFromParent_Done,
    // Label 1021: @76385
    GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(76432), // Rule ID 8481 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8481,
      GIR_EraseRootFromParent_Done,
    // Label 1022: @76432
    GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(76492), // Rule ID 4283 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4283,
      GIR_EraseRootFromParent_Done,
    // Label 1023: @76492
    GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(76547), // Rule ID 4282 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4282,
      GIR_EraseRootFromParent_Done,
    // Label 1024: @76547
    GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(76602), // Rule ID 4281 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4281,
      GIR_EraseRootFromParent_Done,
    // Label 1025: @76602
    GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(76672), // Rule ID 4523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4523,
      GIR_EraseRootFromParent_Done,
    // Label 1026: @76672
    GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(76739), // Rule ID 4525 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4525,
      GIR_EraseRootFromParent_Done,
    // Label 1027: @76739
    GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(76803), // Rule ID 8028 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8028,
      GIR_EraseRootFromParent_Done,
    // Label 1028: @76803
    GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(76868), // Rule ID 4522 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4522,
      GIR_EraseRootFromParent_Done,
    // Label 1029: @76868
    GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(76930), // Rule ID 4524 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4524,
      GIR_EraseRootFromParent_Done,
    // Label 1030: @76930
    GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(76990), // Rule ID 8030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8030,
      GIR_EraseRootFromParent_Done,
    // Label 1031: @76990
    GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(77052), // Rule ID 3882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3882,
      GIR_EraseRootFromParent_Done,
    // Label 1032: @77052
    GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(77109), // Rule ID 3881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3881,
      GIR_EraseRootFromParent_Done,
    // Label 1033: @77109
    GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(77167), // Rule ID 3613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3613,
      GIR_EraseRootFromParent_Done,
    // Label 1034: @77167
    GIM_Reject,
    // Label 946: @77168
    GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(77235), // Rule ID 2900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2900,
      GIR_EraseRootFromParent_Done,
    // Label 1035: @77235
    GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(77298), // Rule ID 2906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2906,
      GIR_EraseRootFromParent_Done,
    // Label 1036: @77298
    GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(77360), // Rule ID 2896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2896,
      GIR_EraseRootFromParent_Done,
    // Label 1037: @77360
    GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(77422), // Rule ID 2897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2897,
      GIR_EraseRootFromParent_Done,
    // Label 1038: @77422
    GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(77484), // Rule ID 2898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2898,
      GIR_EraseRootFromParent_Done,
    // Label 1039: @77484
    GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(77549), // Rule ID 2899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2899,
      GIR_EraseRootFromParent_Done,
    // Label 1040: @77549
    GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(77604), // Rule ID 2902 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2902,
      GIR_EraseRootFromParent_Done,
    // Label 1041: @77604
    GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(77662), // Rule ID 2903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2903,
      GIR_EraseRootFromParent_Done,
    // Label 1042: @77662
    GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(77720), // Rule ID 2904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2904,
      GIR_EraseRootFromParent_Done,
    // Label 1043: @77720
    GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(77781), // Rule ID 2905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2905,
      GIR_EraseRootFromParent_Done,
    // Label 1044: @77781
    GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(77835), // Rule ID 2901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2901,
      GIR_EraseRootFromParent_Done,
    // Label 1045: @77835
    GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(77882), // Rule ID 2907 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2907,
      GIR_EraseRootFromParent_Done,
    // Label 1046: @77882
    GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(77945), // Rule ID 6547 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6547,
      GIR_EraseRootFromParent_Done,
    // Label 1047: @77945
    GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(78008), // Rule ID 6549 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6549,
      GIR_EraseRootFromParent_Done,
    // Label 1048: @78008
    GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(78068), // Rule ID 4211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4211,
      GIR_EraseRootFromParent_Done,
    // Label 1049: @78068
    GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(78123), // Rule ID 4210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4210,
      GIR_EraseRootFromParent_Done,
    // Label 1050: @78123
    GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(78178), // Rule ID 4209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4209,
      GIR_EraseRootFromParent_Done,
    // Label 1051: @78178
    GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(78248), // Rule ID 4475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4475,
      GIR_EraseRootFromParent_Done,
    // Label 1052: @78248
    GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(78315), // Rule ID 4477 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4477,
      GIR_EraseRootFromParent_Done,
    // Label 1053: @78315
    GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(78383), // Rule ID 6546 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6546,
      GIR_EraseRootFromParent_Done,
    // Label 1054: @78383
    GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(78451), // Rule ID 6548 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6548,
      GIR_EraseRootFromParent_Done,
    // Label 1055: @78451
    GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(78516), // Rule ID 4474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4474,
      GIR_EraseRootFromParent_Done,
    // Label 1056: @78516
    GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(78578), // Rule ID 4476 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4476,
      GIR_EraseRootFromParent_Done,
    // Label 1057: @78578
    GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(78637), // Rule ID 7908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7908,
      GIR_EraseRootFromParent_Done,
    // Label 1058: @78637
    GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(78692), // Rule ID 7909 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7909,
      GIR_EraseRootFromParent_Done,
    // Label 1059: @78692
    GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(78754), // Rule ID 3834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3834,
      GIR_EraseRootFromParent_Done,
    // Label 1060: @78754
    GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(78811), // Rule ID 3833 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3833,
      GIR_EraseRootFromParent_Done,
    // Label 1061: @78811
    GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(78869), // Rule ID 3588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3588,
      GIR_EraseRootFromParent_Done,
    // Label 1062: @78869
    GIM_Reject,
    // Label 947: @78870
    GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(78937), // Rule ID 2912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2912,
      GIR_EraseRootFromParent_Done,
    // Label 1063: @78937
    GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(79000), // Rule ID 2918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2918,
      GIR_EraseRootFromParent_Done,
    // Label 1064: @79000
    GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(79062), // Rule ID 2908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2908,
      GIR_EraseRootFromParent_Done,
    // Label 1065: @79062
    GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(79124), // Rule ID 2909 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2909,
      GIR_EraseRootFromParent_Done,
    // Label 1066: @79124
    GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(79186), // Rule ID 2910 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2910,
      GIR_EraseRootFromParent_Done,
    // Label 1067: @79186
    GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(79251), // Rule ID 2911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2911,
      GIR_EraseRootFromParent_Done,
    // Label 1068: @79251
    GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(79306), // Rule ID 2914 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2914,
      GIR_EraseRootFromParent_Done,
    // Label 1069: @79306
    GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(79364), // Rule ID 2915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2915,
      GIR_EraseRootFromParent_Done,
    // Label 1070: @79364
    GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(79422), // Rule ID 2916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2916,
      GIR_EraseRootFromParent_Done,
    // Label 1071: @79422
    GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(79483), // Rule ID 2917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2917,
      GIR_EraseRootFromParent_Done,
    // Label 1072: @79483
    GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(79537), // Rule ID 2913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2913,
      GIR_EraseRootFromParent_Done,
    // Label 1073: @79537
    GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(79584), // Rule ID 2919 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2919,
      GIR_EraseRootFromParent_Done,
    // Label 1074: @79584
    GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(79647), // Rule ID 6551 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6551,
      GIR_EraseRootFromParent_Done,
    // Label 1075: @79647
    GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(79710), // Rule ID 6553 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6553,
      GIR_EraseRootFromParent_Done,
    // Label 1076: @79710
    GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(79770), // Rule ID 4217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4217,
      GIR_EraseRootFromParent_Done,
    // Label 1077: @79770
    GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(79825), // Rule ID 4216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4216,
      GIR_EraseRootFromParent_Done,
    // Label 1078: @79825
    GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(79880), // Rule ID 4215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4215,
      GIR_EraseRootFromParent_Done,
    // Label 1079: @79880
    GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(79950), // Rule ID 4479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4479,
      GIR_EraseRootFromParent_Done,
    // Label 1080: @79950
    GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(80017), // Rule ID 4481 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4481,
      GIR_EraseRootFromParent_Done,
    // Label 1081: @80017
    GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(80085), // Rule ID 6550 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6550,
      GIR_EraseRootFromParent_Done,
    // Label 1082: @80085
    GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(80153), // Rule ID 6552 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6552,
      GIR_EraseRootFromParent_Done,
    // Label 1083: @80153
    GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(80218), // Rule ID 4478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4478,
      GIR_EraseRootFromParent_Done,
    // Label 1084: @80218
    GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(80280), // Rule ID 4480 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4480,
      GIR_EraseRootFromParent_Done,
    // Label 1085: @80280
    GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(80339), // Rule ID 7910 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7910,
      GIR_EraseRootFromParent_Done,
    // Label 1086: @80339
    GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(80394), // Rule ID 7911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7911,
      GIR_EraseRootFromParent_Done,
    // Label 1087: @80394
    GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(80456), // Rule ID 3838 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3838,
      GIR_EraseRootFromParent_Done,
    // Label 1088: @80456
    GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(80513), // Rule ID 3837 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3837,
      GIR_EraseRootFromParent_Done,
    // Label 1089: @80513
    GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(80571), // Rule ID 3590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3590,
      GIR_EraseRootFromParent_Done,
    // Label 1090: @80571
    GIM_Reject,
    // Label 948: @80572
    GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(80639), // Rule ID 8486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8486,
      GIR_EraseRootFromParent_Done,
    // Label 1091: @80639
    GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(80702), // Rule ID 8491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8491,
      GIR_EraseRootFromParent_Done,
    // Label 1092: @80702
    GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(80765), // Rule ID 8497 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8497,
      GIR_EraseRootFromParent_Done,
    // Label 1093: @80765
    GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(80827), // Rule ID 8482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8482,
      GIR_EraseRootFromParent_Done,
    // Label 1094: @80827
    GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(80889), // Rule ID 8483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8483,
      GIR_EraseRootFromParent_Done,
    // Label 1095: @80889
    GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(80951), // Rule ID 8484 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8484,
      GIR_EraseRootFromParent_Done,
    // Label 1096: @80951
    GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(81016), // Rule ID 8485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8485,
      GIR_EraseRootFromParent_Done,
    // Label 1097: @81016
    GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(81074), // Rule ID 8488 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8488,
      GIR_EraseRootFromParent_Done,
    // Label 1098: @81074
    GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(81132), // Rule ID 8489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8489,
      GIR_EraseRootFromParent_Done,
    // Label 1099: @81132
    GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(81193), // Rule ID 8490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8490,
      GIR_EraseRootFromParent_Done,
    // Label 1100: @81193
    GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(81261), // Rule ID 8172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8172,
      GIR_EraseRootFromParent_Done,
    // Label 1101: @81261
    GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(81324), // Rule ID 8096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8096,
      GIR_EraseRootFromParent_Done,
    // Label 1102: @81324
    GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(81379), // Rule ID 8493 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8493,
      GIR_EraseRootFromParent_Done,
    // Label 1103: @81379
    GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(81437), // Rule ID 8494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8494,
      GIR_EraseRootFromParent_Done,
    // Label 1104: @81437
    GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(81495), // Rule ID 8495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8495,
      GIR_EraseRootFromParent_Done,
    // Label 1105: @81495
    GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(81556), // Rule ID 8496 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8496,
      GIR_EraseRootFromParent_Done,
    // Label 1106: @81556
    GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(81620), // Rule ID 8173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8173,
      GIR_EraseRootFromParent_Done,
    // Label 1107: @81620
    GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(81679), // Rule ID 8097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8097,
      GIR_EraseRootFromParent_Done,
    // Label 1108: @81679
    GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(81733), // Rule ID 8487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8487,
      GIR_EraseRootFromParent_Done,
    // Label 1109: @81733
    GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(81783), // Rule ID 8492 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8492,
      GIR_EraseRootFromParent_Done,
    // Label 1110: @81783
    GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(81830), // Rule ID 8498 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8498,
      GIR_EraseRootFromParent_Done,
    // Label 1111: @81830
    GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(81890), // Rule ID 4289 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4289,
      GIR_EraseRootFromParent_Done,
    // Label 1112: @81890
    GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(81945), // Rule ID 4288 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4288,
      GIR_EraseRootFromParent_Done,
    // Label 1113: @81945
    GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(82000), // Rule ID 4287 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4287,
      GIR_EraseRootFromParent_Done,
    // Label 1114: @82000
    GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(82070), // Rule ID 4527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4527,
      GIR_EraseRootFromParent_Done,
    // Label 1115: @82070
    GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(82137), // Rule ID 4529 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4529,
      GIR_EraseRootFromParent_Done,
    // Label 1116: @82137
    GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(82201), // Rule ID 8032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8032,
      GIR_EraseRootFromParent_Done,
    // Label 1117: @82201
    GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(82266), // Rule ID 4526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4526,
      GIR_EraseRootFromParent_Done,
    // Label 1118: @82266
    GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(82328), // Rule ID 4528 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4528,
      GIR_EraseRootFromParent_Done,
    // Label 1119: @82328
    GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(82388), // Rule ID 8034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8034,
      GIR_EraseRootFromParent_Done,
    // Label 1120: @82388
    GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(82450), // Rule ID 3886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3886,
      GIR_EraseRootFromParent_Done,
    // Label 1121: @82450
    GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(82507), // Rule ID 3885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3885,
      GIR_EraseRootFromParent_Done,
    // Label 1122: @82507
    GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(82565), // Rule ID 3615 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3615,
      GIR_EraseRootFromParent_Done,
    // Label 1123: @82565
    GIM_Reject,
    // Label 949: @82566
    GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(82633), // Rule ID 2924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2924,
      GIR_EraseRootFromParent_Done,
    // Label 1124: @82633
    GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(82696), // Rule ID 2930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2930,
      GIR_EraseRootFromParent_Done,
    // Label 1125: @82696
    GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(82758), // Rule ID 2920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2920,
      GIR_EraseRootFromParent_Done,
    // Label 1126: @82758
    GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(82820), // Rule ID 2921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2921,
      GIR_EraseRootFromParent_Done,
    // Label 1127: @82820
    GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(82882), // Rule ID 2922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2922,
      GIR_EraseRootFromParent_Done,
    // Label 1128: @82882
    GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(82947), // Rule ID 2923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2923,
      GIR_EraseRootFromParent_Done,
    // Label 1129: @82947
    GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(83002), // Rule ID 2926 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2926,
      GIR_EraseRootFromParent_Done,
    // Label 1130: @83002
    GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(83060), // Rule ID 2927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2927,
      GIR_EraseRootFromParent_Done,
    // Label 1131: @83060
    GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(83118), // Rule ID 2928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2928,
      GIR_EraseRootFromParent_Done,
    // Label 1132: @83118
    GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(83179), // Rule ID 2929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2929,
      GIR_EraseRootFromParent_Done,
    // Label 1133: @83179
    GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(83233), // Rule ID 2925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2925,
      GIR_EraseRootFromParent_Done,
    // Label 1134: @83233
    GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(83280), // Rule ID 2931 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2931,
      GIR_EraseRootFromParent_Done,
    // Label 1135: @83280
    GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(83343), // Rule ID 6555 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6555,
      GIR_EraseRootFromParent_Done,
    // Label 1136: @83343
    GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(83406), // Rule ID 6557 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6557,
      GIR_EraseRootFromParent_Done,
    // Label 1137: @83406
    GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(83466), // Rule ID 4223 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4223,
      GIR_EraseRootFromParent_Done,
    // Label 1138: @83466
    GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(83521), // Rule ID 4222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4222,
      GIR_EraseRootFromParent_Done,
    // Label 1139: @83521
    GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(83576), // Rule ID 4221 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4221,
      GIR_EraseRootFromParent_Done,
    // Label 1140: @83576
    GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(83646), // Rule ID 4483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4483,
      GIR_EraseRootFromParent_Done,
    // Label 1141: @83646
    GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(83713), // Rule ID 4485 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4485,
      GIR_EraseRootFromParent_Done,
    // Label 1142: @83713
    GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(83781), // Rule ID 6554 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6554,
      GIR_EraseRootFromParent_Done,
    // Label 1143: @83781
    GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(83849), // Rule ID 6556 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6556,
      GIR_EraseRootFromParent_Done,
    // Label 1144: @83849
    GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(83914), // Rule ID 4482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4482,
      GIR_EraseRootFromParent_Done,
    // Label 1145: @83914
    GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(83976), // Rule ID 4484 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4484,
      GIR_EraseRootFromParent_Done,
    // Label 1146: @83976
    GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(84035), // Rule ID 7912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7912,
      GIR_EraseRootFromParent_Done,
    // Label 1147: @84035
    GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(84090), // Rule ID 7913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7913,
      GIR_EraseRootFromParent_Done,
    // Label 1148: @84090
    GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(84152), // Rule ID 3842 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3842,
      GIR_EraseRootFromParent_Done,
    // Label 1149: @84152
    GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(84209), // Rule ID 3841 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3841,
      GIR_EraseRootFromParent_Done,
    // Label 1150: @84209
    GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(84267), // Rule ID 3592 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3592,
      GIR_EraseRootFromParent_Done,
    // Label 1151: @84267
    GIM_Reject,
    // Label 950: @84268
    GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(84335), // Rule ID 2936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2936,
      GIR_EraseRootFromParent_Done,
    // Label 1152: @84335
    GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(84398), // Rule ID 2942 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2942,
      GIR_EraseRootFromParent_Done,
    // Label 1153: @84398
    GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(84460), // Rule ID 2932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2932,
      GIR_EraseRootFromParent_Done,
    // Label 1154: @84460
    GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(84522), // Rule ID 2933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2933,
      GIR_EraseRootFromParent_Done,
    // Label 1155: @84522
    GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(84584), // Rule ID 2934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2934,
      GIR_EraseRootFromParent_Done,
    // Label 1156: @84584
    GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(84649), // Rule ID 2935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2935,
      GIR_EraseRootFromParent_Done,
    // Label 1157: @84649
    GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(84704), // Rule ID 2938 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2938,
      GIR_EraseRootFromParent_Done,
    // Label 1158: @84704
    GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(84762), // Rule ID 2939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2939,
      GIR_EraseRootFromParent_Done,
    // Label 1159: @84762
    GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(84820), // Rule ID 2940 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2940,
      GIR_EraseRootFromParent_Done,
    // Label 1160: @84820
    GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(84881), // Rule ID 2941 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2941,
      GIR_EraseRootFromParent_Done,
    // Label 1161: @84881
    GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(84935), // Rule ID 2937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2937,
      GIR_EraseRootFromParent_Done,
    // Label 1162: @84935
    GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(84982), // Rule ID 2943 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2943,
      GIR_EraseRootFromParent_Done,
    // Label 1163: @84982
    GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(85045), // Rule ID 6559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6559,
      GIR_EraseRootFromParent_Done,
    // Label 1164: @85045
    GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(85108), // Rule ID 6561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6561,
      GIR_EraseRootFromParent_Done,
    // Label 1165: @85108
    GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(85168), // Rule ID 4229 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4229,
      GIR_EraseRootFromParent_Done,
    // Label 1166: @85168
    GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(85223), // Rule ID 4228 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4228,
      GIR_EraseRootFromParent_Done,
    // Label 1167: @85223
    GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(85278), // Rule ID 4227 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4227,
      GIR_EraseRootFromParent_Done,
    // Label 1168: @85278
    GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(85348), // Rule ID 4487 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4487,
      GIR_EraseRootFromParent_Done,
    // Label 1169: @85348
    GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(85415), // Rule ID 4489 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4489,
      GIR_EraseRootFromParent_Done,
    // Label 1170: @85415
    GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(85483), // Rule ID 6558 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6558,
      GIR_EraseRootFromParent_Done,
    // Label 1171: @85483
    GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(85551), // Rule ID 6560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6560,
      GIR_EraseRootFromParent_Done,
    // Label 1172: @85551
    GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(85616), // Rule ID 4486 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4486,
      GIR_EraseRootFromParent_Done,
    // Label 1173: @85616
    GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(85678), // Rule ID 4488 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4488,
      GIR_EraseRootFromParent_Done,
    // Label 1174: @85678
    GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(85737), // Rule ID 7914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7914,
      GIR_EraseRootFromParent_Done,
    // Label 1175: @85737
    GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(85792), // Rule ID 7915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7915,
      GIR_EraseRootFromParent_Done,
    // Label 1176: @85792
    GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(85854), // Rule ID 3846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3846,
      GIR_EraseRootFromParent_Done,
    // Label 1177: @85854
    GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(85911), // Rule ID 3845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3845,
      GIR_EraseRootFromParent_Done,
    // Label 1178: @85911
    GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(85969), // Rule ID 3594 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3594,
      GIR_EraseRootFromParent_Done,
    // Label 1179: @85969
    GIM_Reject,
    // Label 951: @85970
    GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(86602),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(86042), // Rule ID 3016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3016,
        GIR_EraseRootFromParent_Done,
      // Label 1181: @86042
      GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(86097), // Rule ID 3022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[i1] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3022,
        GIR_EraseRootFromParent_Done,
      // Label 1182: @86097
      GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(86151), // Rule ID 3012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3012,
        GIR_EraseRootFromParent_Done,
      // Label 1183: @86151
      GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(86205), // Rule ID 3013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3013,
        GIR_EraseRootFromParent_Done,
      // Label 1184: @86205
      GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(86259), // Rule ID 3014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3014,
        GIR_EraseRootFromParent_Done,
      // Label 1185: @86259
      GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(86316), // Rule ID 3015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3015,
        GIR_EraseRootFromParent_Done,
      // Label 1186: @86316
      GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(86363), // Rule ID 3018 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[i1] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3018,
        GIR_EraseRootFromParent_Done,
      // Label 1187: @86363
      GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(86413), // Rule ID 3019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[i1] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3019,
        GIR_EraseRootFromParent_Done,
      // Label 1188: @86413
      GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(86463), // Rule ID 3020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3020,
        GIR_EraseRootFromParent_Done,
      // Label 1189: @86463
      GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(86516), // Rule ID 3021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[i1] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i1] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3021,
        GIR_EraseRootFromParent_Done,
      // Label 1190: @86516
      GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(86562), // Rule ID 3017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3017,
        GIR_EraseRootFromParent_Done,
      // Label 1191: @86562
      GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(86601), // Rule ID 3023 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[i1] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i1] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3023,
        GIR_EraseRootFromParent_Done,
      // Label 1192: @86601
      GIM_Reject,
    // Label 1180: @86602
    GIM_Reject,
    // Label 952: @86603
    GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(86677), // Rule ID 6503 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6503,
      GIR_EraseRootFromParent_Done,
    // Label 1193: @86677
    GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(86751), // Rule ID 6505 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6505,
      GIR_EraseRootFromParent_Done,
    // Label 1194: @86751
    GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(86814), // Rule ID 6523 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6523,
      GIR_EraseRootFromParent_Done,
    // Label 1195: @86814
    GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(86877), // Rule ID 6525 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6525,
      GIR_EraseRootFromParent_Done,
    // Label 1196: @86877
    GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(86948), // Rule ID 4163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4163,
      GIR_EraseRootFromParent_Done,
    // Label 1197: @86948
    GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(87008), // Rule ID 4181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4181,
      GIR_EraseRootFromParent_Done,
    // Label 1198: @87008
    GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(87074), // Rule ID 4162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4162,
      GIR_EraseRootFromParent_Done,
    // Label 1199: @87074
    GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(87129), // Rule ID 4180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4180,
      GIR_EraseRootFromParent_Done,
    // Label 1200: @87129
    GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(87195), // Rule ID 4161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4161,
      GIR_EraseRootFromParent_Done,
    // Label 1201: @87195
    GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(87250), // Rule ID 4179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4179,
      GIR_EraseRootFromParent_Done,
    // Label 1202: @87250
    GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(87327), // Rule ID 4411 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4411,
      GIR_EraseRootFromParent_Done,
    // Label 1203: @87327
    GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(87401), // Rule ID 4413 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4413,
      GIR_EraseRootFromParent_Done,
    // Label 1204: @87401
    GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(87478), // Rule ID 4415 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4415,
      GIR_EraseRootFromParent_Done,
    // Label 1205: @87478
    GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(87552), // Rule ID 4417 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4417,
      GIR_EraseRootFromParent_Done,
    // Label 1206: @87552
    GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(87631), // Rule ID 6502 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6502,
      GIR_EraseRootFromParent_Done,
    // Label 1207: @87631
    GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(87710), // Rule ID 6504 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6504,
      GIR_EraseRootFromParent_Done,
    // Label 1208: @87710
    GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(87778), // Rule ID 6522 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6522,
      GIR_EraseRootFromParent_Done,
    // Label 1209: @87778
    GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(87846), // Rule ID 6524 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6524,
      GIR_EraseRootFromParent_Done,
    // Label 1210: @87846
    GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(87918), // Rule ID 4410 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4410,
      GIR_EraseRootFromParent_Done,
    // Label 1211: @87918
    GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(87987), // Rule ID 4412 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4412,
      GIR_EraseRootFromParent_Done,
    // Label 1212: @87987
    GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(88059), // Rule ID 4414 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4414,
      GIR_EraseRootFromParent_Done,
    // Label 1213: @88059
    GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(88128), // Rule ID 4416 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4416,
      GIR_EraseRootFromParent_Done,
    // Label 1214: @88128
    GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(88203), // Rule ID 6472 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6472,
      GIR_EraseRootFromParent_Done,
    // Label 1215: @88203
    GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(88278), // Rule ID 6473 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6473,
      GIR_EraseRootFromParent_Done,
    // Label 1216: @88278
    GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(88354), // Rule ID 6478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6478,
      GIR_EraseRootFromParent_Done,
    // Label 1217: @88354
    GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(88430), // Rule ID 6479 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6479,
      GIR_EraseRootFromParent_Done,
    // Label 1218: @88430
    GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(88495), // Rule ID 6482 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6482,
      GIR_EraseRootFromParent_Done,
    // Label 1219: @88495
    GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(88560), // Rule ID 6483 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6483,
      GIR_EraseRootFromParent_Done,
    // Label 1220: @88560
    GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(88622), // Rule ID 7916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7916,
      GIR_EraseRootFromParent_Done,
    // Label 1221: @88622
    GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(88684), // Rule ID 7917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7917,
      GIR_EraseRootFromParent_Done,
    // Label 1222: @88684
    GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(88746), // Rule ID 7928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7928,
      GIR_EraseRootFromParent_Done,
    // Label 1223: @88746
    GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(88808), // Rule ID 7929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7929,
      GIR_EraseRootFromParent_Done,
    // Label 1224: @88808
    GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(88874), // Rule ID 7884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7884,
      GIR_EraseRootFromParent_Done,
    // Label 1225: @88874
    GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(88940), // Rule ID 7885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7885,
      GIR_EraseRootFromParent_Done,
    // Label 1226: @88940
    GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(88999), // Rule ID 7896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_U16:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7896,
      GIR_EraseRootFromParent_Done,
    // Label 1227: @88999
    GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(89054), // Rule ID 7897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_U16_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7897,
      GIR_EraseRootFromParent_Done,
    // Label 1228: @89054
    GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(89123), // Rule ID 3774 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3774,
      GIR_EraseRootFromParent_Done,
    // Label 1229: @89123
    GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(89192), // Rule ID 3782 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3782,
      GIR_EraseRootFromParent_Done,
    // Label 1230: @89192
    GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(89265), // Rule ID 3798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3798,
      GIR_EraseRootFromParent_Done,
    // Label 1231: @89265
    GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(89327), // Rule ID 3814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3814,
      GIR_EraseRootFromParent_Done,
    // Label 1232: @89327
    GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(89391), // Rule ID 3773 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3773,
      GIR_EraseRootFromParent_Done,
    // Label 1233: @89391
    GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(89455), // Rule ID 3781 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3781,
      GIR_EraseRootFromParent_Done,
    // Label 1234: @89455
    GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(89523), // Rule ID 3797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3797,
      GIR_EraseRootFromParent_Done,
    // Label 1235: @89523
    GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(89580), // Rule ID 3813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3813,
      GIR_EraseRootFromParent_Done,
    // Label 1236: @89580
    GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(89645), // Rule ID 3553 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3553,
      GIR_EraseRootFromParent_Done,
    // Label 1237: @89645
    GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(89710), // Rule ID 3557 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3557,
      GIR_EraseRootFromParent_Done,
    // Label 1238: @89710
    GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(89779), // Rule ID 3565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3565,
      GIR_EraseRootFromParent_Done,
    // Label 1239: @89779
    GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(89837), // Rule ID 3570 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3570,
      GIR_EraseRootFromParent_Done,
    // Label 1240: @89837
    GIM_Reject,
    // Label 953: @89838
    GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(89905), // Rule ID 2799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2799,
      GIR_EraseRootFromParent_Done,
    // Label 1241: @89905
    GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(89972), // Rule ID 2852 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2852,
      GIR_EraseRootFromParent_Done,
    // Label 1242: @89972
    GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(90042), // Rule ID 2808 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2808,
      GIR_EraseRootFromParent_Done,
    // Label 1243: @90042
    GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(90112), // Rule ID 2823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2823,
      GIR_EraseRootFromParent_Done,
    // Label 1244: @90112
    GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(90175), // Rule ID 2846 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2846,
      GIR_EraseRootFromParent_Done,
    // Label 1245: @90175
    GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(90238), // Rule ID 2858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2858,
      GIR_EraseRootFromParent_Done,
    // Label 1246: @90238
    GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(90300), // Rule ID 2795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2795,
      GIR_EraseRootFromParent_Done,
    // Label 1247: @90300
    GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(90362), // Rule ID 2796 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2796,
      GIR_EraseRootFromParent_Done,
    // Label 1248: @90362
    GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(90424), // Rule ID 2797 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2797,
      GIR_EraseRootFromParent_Done,
    // Label 1249: @90424
    GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(90489), // Rule ID 2798 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2798,
      GIR_EraseRootFromParent_Done,
    // Label 1250: @90489
    GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(90551), // Rule ID 2848 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2848,
      GIR_EraseRootFromParent_Done,
    // Label 1251: @90551
    GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(90613), // Rule ID 2849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2849,
      GIR_EraseRootFromParent_Done,
    // Label 1252: @90613
    GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(90675), // Rule ID 2850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2850,
      GIR_EraseRootFromParent_Done,
    // Label 1253: @90675
    GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(90740), // Rule ID 2851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2851,
      GIR_EraseRootFromParent_Done,
    // Label 1254: @90740
    GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(90805), // Rule ID 2806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2806,
      GIR_EraseRootFromParent_Done,
    // Label 1255: @90805
    GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(90873), // Rule ID 2807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2807,
      GIR_EraseRootFromParent_Done,
    // Label 1256: @90873
    GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(90938), // Rule ID 2821 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2821,
      GIR_EraseRootFromParent_Done,
    // Label 1257: @90938
    GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(91006), // Rule ID 2822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2822,
      GIR_EraseRootFromParent_Done,
    // Label 1258: @91006
    GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(91061), // Rule ID 2842 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2842,
      GIR_EraseRootFromParent_Done,
    // Label 1259: @91061
    GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(91119), // Rule ID 2843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2843,
      GIR_EraseRootFromParent_Done,
    // Label 1260: @91119
    GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(91177), // Rule ID 2844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2844,
      GIR_EraseRootFromParent_Done,
    // Label 1261: @91177
    GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(91238), // Rule ID 2845 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2845,
      GIR_EraseRootFromParent_Done,
    // Label 1262: @91238
    GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(91293), // Rule ID 2854 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2854,
      GIR_EraseRootFromParent_Done,
    // Label 1263: @91293
    GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(91351), // Rule ID 2855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2855,
      GIR_EraseRootFromParent_Done,
    // Label 1264: @91351
    GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(91409), // Rule ID 2856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2856,
      GIR_EraseRootFromParent_Done,
    // Label 1265: @91409
    GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(91470), // Rule ID 2857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2857,
      GIR_EraseRootFromParent_Done,
    // Label 1266: @91470
    GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(91524), // Rule ID 2800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2800,
      GIR_EraseRootFromParent_Done,
    // Label 1267: @91524
    GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(91578), // Rule ID 2853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2853,
      GIR_EraseRootFromParent_Done,
    // Label 1268: @91578
    GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(91635), // Rule ID 2809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi8),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_smrd_extloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2809,
      GIR_EraseRootFromParent_Done,
    // Label 1269: @91635
    GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(91692), // Rule ID 2824 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_extloadi16),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_smrd_extloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2824,
      GIR_EraseRootFromParent_Done,
    // Label 1270: @91692
    GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(91739), // Rule ID 2847 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2847,
      GIR_EraseRootFromParent_Done,
    // Label 1271: @91739
    GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(91786), // Rule ID 2859 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2859,
      GIR_EraseRootFromParent_Done,
    // Label 1272: @91786
    GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(91860), // Rule ID 6491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6491,
      GIR_EraseRootFromParent_Done,
    // Label 1273: @91860
    GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(91934), // Rule ID 6493 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6493,
      GIR_EraseRootFromParent_Done,
    // Label 1274: @91934
    GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(92008), // Rule ID 6515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6515,
      GIR_EraseRootFromParent_Done,
    // Label 1275: @92008
    GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(92082), // Rule ID 6517 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6517,
      GIR_EraseRootFromParent_Done,
    // Label 1276: @92082
    GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(92145), // Rule ID 6527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6527,
      GIR_EraseRootFromParent_Done,
    // Label 1277: @92145
    GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(92208), // Rule ID 6529 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6529,
      GIR_EraseRootFromParent_Done,
    // Label 1278: @92208
    GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(92271), // Rule ID 6531 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6531,
      GIR_EraseRootFromParent_Done,
    // Label 1279: @92271
    GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(92334), // Rule ID 6533 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[f32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6533,
      GIR_EraseRootFromParent_Done,
    // Label 1280: @92334
    GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(92405), // Rule ID 3545 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3545,
      GIR_EraseRootFromParent_Done,
    // Label 1281: @92405
    GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(92476), // Rule ID 4172 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4172,
      GIR_EraseRootFromParent_Done,
    // Label 1282: @92476
    GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(92536), // Rule ID 4184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4184,
      GIR_EraseRootFromParent_Done,
    // Label 1283: @92536
    GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(92596), // Rule ID 4187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4187,
      GIR_EraseRootFromParent_Done,
    // Label 1284: @92596
    GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(92662), // Rule ID 3544 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3544,
      GIR_EraseRootFromParent_Done,
    // Label 1285: @92662
    GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(92728), // Rule ID 4171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4171,
      GIR_EraseRootFromParent_Done,
    // Label 1286: @92728
    GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(92783), // Rule ID 4183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4183,
      GIR_EraseRootFromParent_Done,
    // Label 1287: @92783
    GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(92838), // Rule ID 4186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4186,
      GIR_EraseRootFromParent_Done,
    // Label 1288: @92838
    GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(92904), // Rule ID 3543 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3543,
      GIR_EraseRootFromParent_Done,
    // Label 1289: @92904
    GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(92970), // Rule ID 4170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4170,
      GIR_EraseRootFromParent_Done,
    // Label 1290: @92970
    GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(93025), // Rule ID 4182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4182,
      GIR_EraseRootFromParent_Done,
    // Label 1291: @93025
    GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(93080), // Rule ID 4185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4185,
      GIR_EraseRootFromParent_Done,
    // Label 1292: @93080
    GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(93157), // Rule ID 4393 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4393,
      GIR_EraseRootFromParent_Done,
    // Label 1293: @93157
    GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(93231), // Rule ID 4397 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4397,
      GIR_EraseRootFromParent_Done,
    // Label 1294: @93231
    GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(93308), // Rule ID 4403 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4403,
      GIR_EraseRootFromParent_Done,
    // Label 1295: @93308
    GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(93382), // Rule ID 4405 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4405,
      GIR_EraseRootFromParent_Done,
    // Label 1296: @93382
    GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(93459), // Rule ID 6460 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6460,
      GIR_EraseRootFromParent_Done,
    // Label 1297: @93459
    GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(93540), // Rule ID 4419 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4419,
      GIR_EraseRootFromParent_Done,
    // Label 1298: @93540
    GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(93618), // Rule ID 4421 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4421,
      GIR_EraseRootFromParent_Done,
    // Label 1299: @93618
    GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(93699), // Rule ID 4439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4439,
      GIR_EraseRootFromParent_Done,
    // Label 1300: @93699
    GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(93777), // Rule ID 4441 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4441,
      GIR_EraseRootFromParent_Done,
    // Label 1301: @93777
    GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(93857), // Rule ID 6463 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6463,
      GIR_EraseRootFromParent_Done,
    // Label 1302: @93857
    GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(93937), // Rule ID 6466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6466,
      GIR_EraseRootFromParent_Done,
    // Label 1303: @93937
    GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(94016), // Rule ID 6490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6490,
      GIR_EraseRootFromParent_Done,
    // Label 1304: @94016
    GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(94095), // Rule ID 6492 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6492,
      GIR_EraseRootFromParent_Done,
    // Label 1305: @94095
    GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(94174), // Rule ID 6514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6514,
      GIR_EraseRootFromParent_Done,
    // Label 1306: @94174
    GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(94253), // Rule ID 6516 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6516,
      GIR_EraseRootFromParent_Done,
    // Label 1307: @94253
    GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(94323), // Rule ID 4455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4455,
      GIR_EraseRootFromParent_Done,
    // Label 1308: @94323
    GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(94390), // Rule ID 4457 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4457,
      GIR_EraseRootFromParent_Done,
    // Label 1309: @94390
    GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(94460), // Rule ID 4459 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4459,
      GIR_EraseRootFromParent_Done,
    // Label 1310: @94460
    GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(94527), // Rule ID 4461 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4461,
      GIR_EraseRootFromParent_Done,
    // Label 1311: @94527
    GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(94595), // Rule ID 6526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6526,
      GIR_EraseRootFromParent_Done,
    // Label 1312: @94595
    GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(94663), // Rule ID 6528 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6528,
      GIR_EraseRootFromParent_Done,
    // Label 1313: @94663
    GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(94731), // Rule ID 6530 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6530,
      GIR_EraseRootFromParent_Done,
    // Label 1314: @94731
    GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(94799), // Rule ID 6532 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[f32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6532,
      GIR_EraseRootFromParent_Done,
    // Label 1315: @94799
    GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(94871), // Rule ID 4392 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4392,
      GIR_EraseRootFromParent_Done,
    // Label 1316: @94871
    GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(94940), // Rule ID 4396 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4396,
      GIR_EraseRootFromParent_Done,
    // Label 1317: @94940
    GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(95012), // Rule ID 4402 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4402,
      GIR_EraseRootFromParent_Done,
    // Label 1318: @95012
    GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(95081), // Rule ID 4404 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4404,
      GIR_EraseRootFromParent_Done,
    // Label 1319: @95081
    GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(95157), // Rule ID 4418 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4418,
      GIR_EraseRootFromParent_Done,
    // Label 1320: @95157
    GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(95230), // Rule ID 4420 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4420,
      GIR_EraseRootFromParent_Done,
    // Label 1321: @95230
    GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(95306), // Rule ID 4438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4438,
      GIR_EraseRootFromParent_Done,
    // Label 1322: @95306
    GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(95379), // Rule ID 4440 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4440,
      GIR_EraseRootFromParent_Done,
    // Label 1323: @95379
    GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(95444), // Rule ID 4454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4454,
      GIR_EraseRootFromParent_Done,
    // Label 1324: @95444
    GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(95506), // Rule ID 4456 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4456,
      GIR_EraseRootFromParent_Done,
    // Label 1325: @95506
    GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(95571), // Rule ID 4458 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4458,
      GIR_EraseRootFromParent_Done,
    // Label 1326: @95571
    GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(95633), // Rule ID 4460 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4460,
      GIR_EraseRootFromParent_Done,
    // Label 1327: @95633
    GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(95695), // Rule ID 7918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8_glue>><<P:Predicate_atomic_load_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7918,
      GIR_EraseRootFromParent_Done,
    // Label 1328: @95695
    GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(95757), // Rule ID 7919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7919,
      GIR_EraseRootFromParent_Done,
    // Label 1329: @95757
    GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(95819), // Rule ID 7930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16_glue>><<P:Predicate_atomic_load_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7930,
      GIR_EraseRootFromParent_Done,
    // Label 1330: @95819
    GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(95881), // Rule ID 7931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7931,
      GIR_EraseRootFromParent_Done,
    // Label 1331: @95881
    GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(95943), // Rule ID 7936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32_glue>><<P:Predicate_atomic_load_32_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7936,
      GIR_EraseRootFromParent_Done,
    // Label 1332: @95943
    GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(96005), // Rule ID 7937 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7937,
      GIR_EraseRootFromParent_Done,
    // Label 1333: @96005
    GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(96071), // Rule ID 7880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi8_glue>><<P:Predicate_extloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7880,
      GIR_EraseRootFromParent_Done,
    // Label 1334: @96071
    GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(96137), // Rule ID 7881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7881,
      GIR_EraseRootFromParent_Done,
    // Label 1335: @96137
    GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(96203), // Rule ID 7892 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_extload_glue>><<P:Predicate_extloadi16_glue>><<P:Predicate_extloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7892,
      GIR_EraseRootFromParent_Done,
    // Label 1336: @96203
    GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(96269), // Rule ID 7893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7893,
      GIR_EraseRootFromParent_Done,
    // Label 1337: @96269
    GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(96328), // Rule ID 7898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7898,
      GIR_EraseRootFromParent_Done,
    // Label 1338: @96328
    GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(96387), // Rule ID 7900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7900,
      GIR_EraseRootFromParent_Done,
    // Label 1339: @96387
    GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(96442), // Rule ID 7899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7899,
      GIR_EraseRootFromParent_Done,
    // Label 1340: @96442
    GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(96497), // Rule ID 7901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7901,
      GIR_EraseRootFromParent_Done,
    // Label 1341: @96497
    GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(96566), // Rule ID 3534 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3534,
      GIR_EraseRootFromParent_Done,
    // Label 1342: @96566
    GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(96635), // Rule ID 3780 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3780,
      GIR_EraseRootFromParent_Done,
    // Label 1343: @96635
    GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(96704), // Rule ID 3920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3920,
      GIR_EraseRootFromParent_Done,
    // Label 1344: @96704
    GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(96777), // Rule ID 3792 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3792,
      GIR_EraseRootFromParent_Done,
    // Label 1345: @96777
    GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(96850), // Rule ID 3804 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3804,
      GIR_EraseRootFromParent_Done,
    // Label 1346: @96850
    GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(96912), // Rule ID 3816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3816,
      GIR_EraseRootFromParent_Done,
    // Label 1347: @96912
    GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(96974), // Rule ID 3818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3818,
      GIR_EraseRootFromParent_Done,
    // Label 1348: @96974
    GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(97038), // Rule ID 3533 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3533,
      GIR_EraseRootFromParent_Done,
    // Label 1349: @97038
    GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(97102), // Rule ID 3779 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3779,
      GIR_EraseRootFromParent_Done,
    // Label 1350: @97102
    GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(97166), // Rule ID 3919 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3919,
      GIR_EraseRootFromParent_Done,
    // Label 1351: @97166
    GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(97234), // Rule ID 3791 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3791,
      GIR_EraseRootFromParent_Done,
    // Label 1352: @97234
    GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(97302), // Rule ID 3803 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3803,
      GIR_EraseRootFromParent_Done,
    // Label 1353: @97302
    GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(97359), // Rule ID 3815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3815,
      GIR_EraseRootFromParent_Done,
    // Label 1354: @97359
    GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(97416), // Rule ID 3817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3817,
      GIR_EraseRootFromParent_Done,
    // Label 1355: @97416
    GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(97481), // Rule ID 3552 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_atomic_load_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3552,
      GIR_EraseRootFromParent_Done,
    // Label 1356: @97481
    GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(97546), // Rule ID 3556 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_atomic_load_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3556,
      GIR_EraseRootFromParent_Done,
    // Label 1357: @97546
    GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(97611), // Rule ID 3574 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_atomic_load_32_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3574,
      GIR_EraseRootFromParent_Done,
    // Label 1358: @97611
    GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(97680), // Rule ID 3560 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>><<P:Predicate_extloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3560,
      GIR_EraseRootFromParent_Done,
    // Label 1359: @97680
    GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(97749), // Rule ID 3568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>><<P:Predicate_extloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3568,
      GIR_EraseRootFromParent_Done,
    // Label 1360: @97749
    GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(97807), // Rule ID 3578 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3578,
      GIR_EraseRootFromParent_Done,
    // Label 1361: @97807
    GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(97865), // Rule ID 3580 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3580,
      GIR_EraseRootFromParent_Done,
    // Label 1362: @97865
    GIM_Reject,
    // Label 954: @97866
    GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(97933), // Rule ID 2965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2965,
      GIR_EraseRootFromParent_Done,
    // Label 1363: @97933
    GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(98000), // Rule ID 2999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2999,
      GIR_EraseRootFromParent_Done,
    // Label 1364: @98000
    GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(98067), // Rule ID 8435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8435,
      GIR_EraseRootFromParent_Done,
    // Label 1365: @98067
    GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(98130), // Rule ID 2970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2970,
      GIR_EraseRootFromParent_Done,
    // Label 1366: @98130
    GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(98193), // Rule ID 3004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3004,
      GIR_EraseRootFromParent_Done,
    // Label 1367: @98193
    GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(98256), // Rule ID 8440 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8440,
      GIR_EraseRootFromParent_Done,
    // Label 1368: @98256
    GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(98319), // Rule ID 2976 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2976,
      GIR_EraseRootFromParent_Done,
    // Label 1369: @98319
    GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(98382), // Rule ID 3010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3010,
      GIR_EraseRootFromParent_Done,
    // Label 1370: @98382
    GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(98445), // Rule ID 8446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8446,
      GIR_EraseRootFromParent_Done,
    // Label 1371: @98445
    GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(98507), // Rule ID 2961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2961,
      GIR_EraseRootFromParent_Done,
    // Label 1372: @98507
    GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(98569), // Rule ID 2962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2962,
      GIR_EraseRootFromParent_Done,
    // Label 1373: @98569
    GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(98631), // Rule ID 2963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2963,
      GIR_EraseRootFromParent_Done,
    // Label 1374: @98631
    GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(98696), // Rule ID 2964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2964,
      GIR_EraseRootFromParent_Done,
    // Label 1375: @98696
    GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(98758), // Rule ID 2995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2995,
      GIR_EraseRootFromParent_Done,
    // Label 1376: @98758
    GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(98820), // Rule ID 2996 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2996,
      GIR_EraseRootFromParent_Done,
    // Label 1377: @98820
    GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(98882), // Rule ID 2997 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2997,
      GIR_EraseRootFromParent_Done,
    // Label 1378: @98882
    GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(98947), // Rule ID 2998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2998,
      GIR_EraseRootFromParent_Done,
    // Label 1379: @98947
    GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(99009), // Rule ID 8431 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8431,
      GIR_EraseRootFromParent_Done,
    // Label 1380: @99009
    GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(99071), // Rule ID 8432 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8432,
      GIR_EraseRootFromParent_Done,
    // Label 1381: @99071
    GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(99133), // Rule ID 8433 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8433,
      GIR_EraseRootFromParent_Done,
    // Label 1382: @99133
    GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(99198), // Rule ID 8434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8434,
      GIR_EraseRootFromParent_Done,
    // Label 1383: @99198
    GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(99256), // Rule ID 2967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2967,
      GIR_EraseRootFromParent_Done,
    // Label 1384: @99256
    GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(99314), // Rule ID 2968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2968,
      GIR_EraseRootFromParent_Done,
    // Label 1385: @99314
    GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(99375), // Rule ID 2969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2969,
      GIR_EraseRootFromParent_Done,
    // Label 1386: @99375
    GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(99433), // Rule ID 3001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3001,
      GIR_EraseRootFromParent_Done,
    // Label 1387: @99433
    GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(99491), // Rule ID 3002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3002,
      GIR_EraseRootFromParent_Done,
    // Label 1388: @99491
    GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(99552), // Rule ID 3003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3003,
      GIR_EraseRootFromParent_Done,
    // Label 1389: @99552
    GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(99610), // Rule ID 8437 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8437,
      GIR_EraseRootFromParent_Done,
    // Label 1390: @99610
    GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(99668), // Rule ID 8438 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8438,
      GIR_EraseRootFromParent_Done,
    // Label 1391: @99668
    GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(99729), // Rule ID 8439 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8439,
      GIR_EraseRootFromParent_Done,
    // Label 1392: @99729
    GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(99797), // Rule ID 8136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8136,
      GIR_EraseRootFromParent_Done,
    // Label 1393: @99797
    GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(99865), // Rule ID 8140 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8140,
      GIR_EraseRootFromParent_Done,
    // Label 1394: @99865
    GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(99928), // Rule ID 8060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8060,
      GIR_EraseRootFromParent_Done,
    // Label 1395: @99928
    GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(99991), // Rule ID 8064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8064,
      GIR_EraseRootFromParent_Done,
    // Label 1396: @99991
    GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(100046), // Rule ID 2972 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2972,
      GIR_EraseRootFromParent_Done,
    // Label 1397: @100046
    GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(100104), // Rule ID 2973 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2973,
      GIR_EraseRootFromParent_Done,
    // Label 1398: @100104
    GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(100162), // Rule ID 2974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2974,
      GIR_EraseRootFromParent_Done,
    // Label 1399: @100162
    GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(100223), // Rule ID 2975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2975,
      GIR_EraseRootFromParent_Done,
    // Label 1400: @100223
    GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(100278), // Rule ID 3006 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3006,
      GIR_EraseRootFromParent_Done,
    // Label 1401: @100278
    GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(100336), // Rule ID 3007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3007,
      GIR_EraseRootFromParent_Done,
    // Label 1402: @100336
    GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(100394), // Rule ID 3008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3008,
      GIR_EraseRootFromParent_Done,
    // Label 1403: @100394
    GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(100455), // Rule ID 3009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3009,
      GIR_EraseRootFromParent_Done,
    // Label 1404: @100455
    GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(100510), // Rule ID 8442 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8442,
      GIR_EraseRootFromParent_Done,
    // Label 1405: @100510
    GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(100568), // Rule ID 8443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8443,
      GIR_EraseRootFromParent_Done,
    // Label 1406: @100568
    GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(100626), // Rule ID 8444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8444,
      GIR_EraseRootFromParent_Done,
    // Label 1407: @100626
    GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(100687), // Rule ID 8445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8445,
      GIR_EraseRootFromParent_Done,
    // Label 1408: @100687
    GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(100751), // Rule ID 8137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8137,
      GIR_EraseRootFromParent_Done,
    // Label 1409: @100751
    GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(100815), // Rule ID 8141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8141,
      GIR_EraseRootFromParent_Done,
    // Label 1410: @100815
    GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(100874), // Rule ID 8061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8061,
      GIR_EraseRootFromParent_Done,
    // Label 1411: @100874
    GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(100933), // Rule ID 8065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8065,
      GIR_EraseRootFromParent_Done,
    // Label 1412: @100933
    GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(100987), // Rule ID 2966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2966,
      GIR_EraseRootFromParent_Done,
    // Label 1413: @100987
    GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(101041), // Rule ID 3000 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3000,
      GIR_EraseRootFromParent_Done,
    // Label 1414: @101041
    GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(101095), // Rule ID 8436 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8436,
      GIR_EraseRootFromParent_Done,
    // Label 1415: @101095
    GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(101145), // Rule ID 2971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2971,
      GIR_EraseRootFromParent_Done,
    // Label 1416: @101145
    GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(101195), // Rule ID 3005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3005,
      GIR_EraseRootFromParent_Done,
    // Label 1417: @101195
    GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(101245), // Rule ID 8441 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8441,
      GIR_EraseRootFromParent_Done,
    // Label 1418: @101245
    GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(101292), // Rule ID 2977 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2977,
      GIR_EraseRootFromParent_Done,
    // Label 1419: @101292
    GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(101339), // Rule ID 3011 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3011,
      GIR_EraseRootFromParent_Done,
    // Label 1420: @101339
    GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(101386), // Rule ID 8447 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8447,
      GIR_EraseRootFromParent_Done,
    // Label 1421: @101386
    GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(101446), // Rule ID 4235 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4235,
      GIR_EraseRootFromParent_Done,
    // Label 1422: @101446
    GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(101506), // Rule ID 4241 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4241,
      GIR_EraseRootFromParent_Done,
    // Label 1423: @101506
    GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(101561), // Rule ID 4234 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4234,
      GIR_EraseRootFromParent_Done,
    // Label 1424: @101561
    GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(101616), // Rule ID 4240 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4240,
      GIR_EraseRootFromParent_Done,
    // Label 1425: @101616
    GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(101671), // Rule ID 4233 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4233,
      GIR_EraseRootFromParent_Done,
    // Label 1426: @101671
    GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(101726), // Rule ID 4239 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4239,
      GIR_EraseRootFromParent_Done,
    // Label 1427: @101726
    GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(101803), // Rule ID 6468 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6468,
      GIR_EraseRootFromParent_Done,
    // Label 1428: @101803
    GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(101873), // Rule ID 4491 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4491,
      GIR_EraseRootFromParent_Done,
    // Label 1429: @101873
    GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(101940), // Rule ID 4493 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4493,
      GIR_EraseRootFromParent_Done,
    // Label 1430: @101940
    GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(102010), // Rule ID 4495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4495,
      GIR_EraseRootFromParent_Done,
    // Label 1431: @102010
    GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(102077), // Rule ID 4497 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4497,
      GIR_EraseRootFromParent_Done,
    // Label 1432: @102077
    GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(102141), // Rule ID 7992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7992,
      GIR_EraseRootFromParent_Done,
    // Label 1433: @102141
    GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(102205), // Rule ID 8000 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8000,
      GIR_EraseRootFromParent_Done,
    // Label 1434: @102205
    GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(102270), // Rule ID 4490 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4490,
      GIR_EraseRootFromParent_Done,
    // Label 1435: @102270
    GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(102332), // Rule ID 4492 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4492,
      GIR_EraseRootFromParent_Done,
    // Label 1436: @102332
    GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(102397), // Rule ID 4494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4494,
      GIR_EraseRootFromParent_Done,
    // Label 1437: @102397
    GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(102459), // Rule ID 4496 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4496,
      GIR_EraseRootFromParent_Done,
    // Label 1438: @102459
    GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(102519), // Rule ID 7994 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[i64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7994,
      GIR_EraseRootFromParent_Done,
    // Label 1439: @102519
    GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(102579), // Rule ID 8002 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[f64] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8002,
      GIR_EraseRootFromParent_Done,
    // Label 1440: @102579
    GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(102641), // Rule ID 7938 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64_glue>><<P:Predicate_atomic_load_64_local_m0>>  =>  (DS_READ_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7938,
      GIR_EraseRootFromParent_Done,
    // Label 1441: @102641
    GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(102703), // Rule ID 7939 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_local>>  =>  (DS_READ_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7939,
      GIR_EraseRootFromParent_Done,
    // Label 1442: @102703
    GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(102772), // Rule ID 3922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3922,
      GIR_EraseRootFromParent_Done,
    // Label 1443: @102772
    GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(102834), // Rule ID 3850 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3850,
      GIR_EraseRootFromParent_Done,
    // Label 1444: @102834
    GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(102896), // Rule ID 3854 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3854,
      GIR_EraseRootFromParent_Done,
    // Label 1445: @102896
    GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(102960), // Rule ID 3921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3921,
      GIR_EraseRootFromParent_Done,
    // Label 1446: @102960
    GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(103017), // Rule ID 3849 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3849,
      GIR_EraseRootFromParent_Done,
    // Label 1447: @103017
    GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(103074), // Rule ID 3853 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3853,
      GIR_EraseRootFromParent_Done,
    // Label 1448: @103074
    GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(103139), // Rule ID 3575 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_atomic_load_64_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3575,
      GIR_EraseRootFromParent_Done,
    // Label 1449: @103139
    GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(103197), // Rule ID 3597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3597,
      GIR_EraseRootFromParent_Done,
    // Label 1450: @103197
    GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(103255), // Rule ID 3599 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3599,
      GIR_EraseRootFromParent_Done,
    // Label 1451: @103255
    GIM_Reject,
    // Label 955: @103256
    GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(103323), // Rule ID 2864 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2864,
      GIR_EraseRootFromParent_Done,
    // Label 1452: @103323
    GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(103390), // Rule ID 2876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2876,
      GIR_EraseRootFromParent_Done,
    // Label 1453: @103390
    GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(103457), // Rule ID 2888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2888,
      GIR_EraseRootFromParent_Done,
    // Label 1454: @103457
    GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(103520), // Rule ID 2870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2870,
      GIR_EraseRootFromParent_Done,
    // Label 1455: @103520
    GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(103583), // Rule ID 2882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2882,
      GIR_EraseRootFromParent_Done,
    // Label 1456: @103583
    GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(103646), // Rule ID 2894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2894,
      GIR_EraseRootFromParent_Done,
    // Label 1457: @103646
    GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(103708), // Rule ID 2860 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2860,
      GIR_EraseRootFromParent_Done,
    // Label 1458: @103708
    GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(103770), // Rule ID 2861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2861,
      GIR_EraseRootFromParent_Done,
    // Label 1459: @103770
    GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(103832), // Rule ID 2862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2862,
      GIR_EraseRootFromParent_Done,
    // Label 1460: @103832
    GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(103897), // Rule ID 2863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2863,
      GIR_EraseRootFromParent_Done,
    // Label 1461: @103897
    GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(103959), // Rule ID 2872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2872,
      GIR_EraseRootFromParent_Done,
    // Label 1462: @103959
    GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(104021), // Rule ID 2873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2873,
      GIR_EraseRootFromParent_Done,
    // Label 1463: @104021
    GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(104083), // Rule ID 2874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2874,
      GIR_EraseRootFromParent_Done,
    // Label 1464: @104083
    GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(104148), // Rule ID 2875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2875,
      GIR_EraseRootFromParent_Done,
    // Label 1465: @104148
    GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(104210), // Rule ID 2884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2884,
      GIR_EraseRootFromParent_Done,
    // Label 1466: @104210
    GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(104272), // Rule ID 2885 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2885,
      GIR_EraseRootFromParent_Done,
    // Label 1467: @104272
    GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(104334), // Rule ID 2886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2886,
      GIR_EraseRootFromParent_Done,
    // Label 1468: @104334
    GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(104399), // Rule ID 2887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2887,
      GIR_EraseRootFromParent_Done,
    // Label 1469: @104399
    GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(104454), // Rule ID 2866 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2866,
      GIR_EraseRootFromParent_Done,
    // Label 1470: @104454
    GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(104512), // Rule ID 2867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2867,
      GIR_EraseRootFromParent_Done,
    // Label 1471: @104512
    GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(104570), // Rule ID 2868 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2868,
      GIR_EraseRootFromParent_Done,
    // Label 1472: @104570
    GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(104631), // Rule ID 2869 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2869,
      GIR_EraseRootFromParent_Done,
    // Label 1473: @104631
    GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(104686), // Rule ID 2878 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2878,
      GIR_EraseRootFromParent_Done,
    // Label 1474: @104686
    GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(104744), // Rule ID 2879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2879,
      GIR_EraseRootFromParent_Done,
    // Label 1475: @104744
    GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(104802), // Rule ID 2880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2880,
      GIR_EraseRootFromParent_Done,
    // Label 1476: @104802
    GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(104863), // Rule ID 2881 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2881,
      GIR_EraseRootFromParent_Done,
    // Label 1477: @104863
    GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(104918), // Rule ID 2890 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2890,
      GIR_EraseRootFromParent_Done,
    // Label 1478: @104918
    GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(104976), // Rule ID 2891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM_ci:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2891,
      GIR_EraseRootFromParent_Done,
    // Label 1479: @104976
    GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(105034), // Rule ID 2892 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2892,
      GIR_EraseRootFromParent_Done,
    // Label 1480: @105034
    GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(105095), // Rule ID 2893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_SGPR_IMM:{ *:[v2bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2893,
      GIR_EraseRootFromParent_Done,
    // Label 1481: @105095
    GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(105149), // Rule ID 2865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2865,
      GIR_EraseRootFromParent_Done,
    // Label 1482: @105149
    GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(105203), // Rule ID 2877 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2877,
      GIR_EraseRootFromParent_Done,
    // Label 1483: @105203
    GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(105257), // Rule ID 2889 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2889,
      GIR_EraseRootFromParent_Done,
    // Label 1484: @105257
    GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(105304), // Rule ID 2871 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2871,
      GIR_EraseRootFromParent_Done,
    // Label 1485: @105304
    GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(105351), // Rule ID 2883 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2883,
      GIR_EraseRootFromParent_Done,
    // Label 1486: @105351
    GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(105398), // Rule ID 2895 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORD_IMM:{ *:[v2bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORD_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2895,
      GIR_EraseRootFromParent_Done,
    // Label 1487: @105398
    GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(105461), // Rule ID 6535 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6535,
      GIR_EraseRootFromParent_Done,
    // Label 1488: @105461
    GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(105524), // Rule ID 6537 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6537,
      GIR_EraseRootFromParent_Done,
    // Label 1489: @105524
    GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(105587), // Rule ID 6539 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6539,
      GIR_EraseRootFromParent_Done,
    // Label 1490: @105587
    GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(105650), // Rule ID 6541 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2f16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6541,
      GIR_EraseRootFromParent_Done,
    // Label 1491: @105650
    GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(105713), // Rule ID 6543 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2bf16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2bf16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6543,
      GIR_EraseRootFromParent_Done,
    // Label 1492: @105713
    GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(105776), // Rule ID 6545 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2bf16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2bf16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6545,
      GIR_EraseRootFromParent_Done,
    // Label 1493: @105776
    GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(105836), // Rule ID 4193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4193,
      GIR_EraseRootFromParent_Done,
    // Label 1494: @105836
    GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(105896), // Rule ID 4199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4199,
      GIR_EraseRootFromParent_Done,
    // Label 1495: @105896
    GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(105956), // Rule ID 4205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2bf16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SVS:{ *:[v2bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4205,
      GIR_EraseRootFromParent_Done,
    // Label 1496: @105956
    GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(106011), // Rule ID 4192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4192,
      GIR_EraseRootFromParent_Done,
    // Label 1497: @106011
    GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(106066), // Rule ID 4198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4198,
      GIR_EraseRootFromParent_Done,
    // Label 1498: @106066
    GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(106121), // Rule ID 4204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2bf16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD_SADDR:{ *:[v2bf16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4204,
      GIR_EraseRootFromParent_Done,
    // Label 1499: @106121
    GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(106176), // Rule ID 4191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4191,
      GIR_EraseRootFromParent_Done,
    // Label 1500: @106176
    GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(106231), // Rule ID 4197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4197,
      GIR_EraseRootFromParent_Done,
    // Label 1501: @106231
    GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(106286), // Rule ID 4203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2bf16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORD:{ *:[v2bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4203,
      GIR_EraseRootFromParent_Done,
    // Label 1502: @106286
    GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(106356), // Rule ID 4463 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4463,
      GIR_EraseRootFromParent_Done,
    // Label 1503: @106356
    GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(106423), // Rule ID 4465 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4465,
      GIR_EraseRootFromParent_Done,
    // Label 1504: @106423
    GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(106493), // Rule ID 4467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4467,
      GIR_EraseRootFromParent_Done,
    // Label 1505: @106493
    GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(106560), // Rule ID 4469 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4469,
      GIR_EraseRootFromParent_Done,
    // Label 1506: @106560
    GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(106630), // Rule ID 4471 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_ADDR64:{ *:[v2bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4471,
      GIR_EraseRootFromParent_Done,
    // Label 1507: @106630
    GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(106697), // Rule ID 4473 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_ADDR64:{ *:[v2bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4473,
      GIR_EraseRootFromParent_Done,
    // Label 1508: @106697
    GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(106765), // Rule ID 6534 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6534,
      GIR_EraseRootFromParent_Done,
    // Label 1509: @106765
    GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(106833), // Rule ID 6536 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6536,
      GIR_EraseRootFromParent_Done,
    // Label 1510: @106833
    GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(106901), // Rule ID 6538 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6538,
      GIR_EraseRootFromParent_Done,
    // Label 1511: @106901
    GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(106969), // Rule ID 6540 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2f16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6540,
      GIR_EraseRootFromParent_Done,
    // Label 1512: @106969
    GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(107037), // Rule ID 6542 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2bf16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6542,
      GIR_EraseRootFromParent_Done,
    // Label 1513: @107037
    GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(107105), // Rule ID 6544 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2bf16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6544,
      GIR_EraseRootFromParent_Done,
    // Label 1514: @107105
    GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(107170), // Rule ID 4462 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4462,
      GIR_EraseRootFromParent_Done,
    // Label 1515: @107170
    GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(107232), // Rule ID 4464 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4464,
      GIR_EraseRootFromParent_Done,
    // Label 1516: @107232
    GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(107297), // Rule ID 4466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4466,
      GIR_EraseRootFromParent_Done,
    // Label 1517: @107297
    GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(107359), // Rule ID 4468 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4468,
      GIR_EraseRootFromParent_Done,
    // Label 1518: @107359
    GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(107424), // Rule ID 4470 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4470,
      GIR_EraseRootFromParent_Done,
    // Label 1519: @107424
    GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(107486), // Rule ID 4472 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4472,
      GIR_EraseRootFromParent_Done,
    // Label 1520: @107486
    GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(107545), // Rule ID 7902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7902,
      GIR_EraseRootFromParent_Done,
    // Label 1521: @107545
    GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(107604), // Rule ID 7904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7904,
      GIR_EraseRootFromParent_Done,
    // Label 1522: @107604
    GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(107663), // Rule ID 7906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B32:{ *:[v2bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7906,
      GIR_EraseRootFromParent_Done,
    // Label 1523: @107663
    GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(107718), // Rule ID 7903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7903,
      GIR_EraseRootFromParent_Done,
    // Label 1524: @107718
    GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(107773), // Rule ID 7905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7905,
      GIR_EraseRootFromParent_Done,
    // Label 1525: @107773
    GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(107828), // Rule ID 7907 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B32_gfx9:{ *:[v2bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7907,
      GIR_EraseRootFromParent_Done,
    // Label 1526: @107828
    GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(107890), // Rule ID 3822 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3822,
      GIR_EraseRootFromParent_Done,
    // Label 1527: @107890
    GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(107952), // Rule ID 3826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3826,
      GIR_EraseRootFromParent_Done,
    // Label 1528: @107952
    GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(108014), // Rule ID 3830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2bf16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD_SADDR:{ *:[v2bf16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3830,
      GIR_EraseRootFromParent_Done,
    // Label 1529: @108014
    GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(108071), // Rule ID 3821 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3821,
      GIR_EraseRootFromParent_Done,
    // Label 1530: @108071
    GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(108128), // Rule ID 3825 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3825,
      GIR_EraseRootFromParent_Done,
    // Label 1531: @108128
    GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(108185), // Rule ID 3829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2bf16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORD:{ *:[v2bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3829,
      GIR_EraseRootFromParent_Done,
    // Label 1532: @108185
    GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(108243), // Rule ID 3582 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3582,
      GIR_EraseRootFromParent_Done,
    // Label 1533: @108243
    GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(108301), // Rule ID 3584 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3584,
      GIR_EraseRootFromParent_Done,
    // Label 1534: @108301
    GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(108359), // Rule ID 3586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2bf16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORD:{ *:[v2bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3586,
      GIR_EraseRootFromParent_Done,
    // Label 1535: @108359
    GIM_Reject,
    // Label 956: @108360
    GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(108427), // Rule ID 2948 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2948,
      GIR_EraseRootFromParent_Done,
    // Label 1536: @108427
    GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(108494), // Rule ID 2982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2982,
      GIR_EraseRootFromParent_Done,
    // Label 1537: @108494
    GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(108557), // Rule ID 2953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2953,
      GIR_EraseRootFromParent_Done,
    // Label 1538: @108557
    GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(108620), // Rule ID 2987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2987,
      GIR_EraseRootFromParent_Done,
    // Label 1539: @108620
    GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(108683), // Rule ID 2959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2959,
      GIR_EraseRootFromParent_Done,
    // Label 1540: @108683
    GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(108746), // Rule ID 2993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2993,
      GIR_EraseRootFromParent_Done,
    // Label 1541: @108746
    GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(108808), // Rule ID 2944 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2944,
      GIR_EraseRootFromParent_Done,
    // Label 1542: @108808
    GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(108870), // Rule ID 2945 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2945,
      GIR_EraseRootFromParent_Done,
    // Label 1543: @108870
    GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(108932), // Rule ID 2946 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2946,
      GIR_EraseRootFromParent_Done,
    // Label 1544: @108932
    GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(108997), // Rule ID 2947 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2947,
      GIR_EraseRootFromParent_Done,
    // Label 1545: @108997
    GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(109059), // Rule ID 2978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2978,
      GIR_EraseRootFromParent_Done,
    // Label 1546: @109059
    GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(109121), // Rule ID 2979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2979,
      GIR_EraseRootFromParent_Done,
    // Label 1547: @109121
    GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(109183), // Rule ID 2980 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2980,
      GIR_EraseRootFromParent_Done,
    // Label 1548: @109183
    GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(109248), // Rule ID 2981 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2981,
      GIR_EraseRootFromParent_Done,
    // Label 1549: @109248
    GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(109306), // Rule ID 2950 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2950,
      GIR_EraseRootFromParent_Done,
    // Label 1550: @109306
    GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(109364), // Rule ID 2951 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2951,
      GIR_EraseRootFromParent_Done,
    // Label 1551: @109364
    GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(109425), // Rule ID 2952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2952,
      GIR_EraseRootFromParent_Done,
    // Label 1552: @109425
    GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(109483), // Rule ID 2984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2984,
      GIR_EraseRootFromParent_Done,
    // Label 1553: @109483
    GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(109541), // Rule ID 2985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2985,
      GIR_EraseRootFromParent_Done,
    // Label 1554: @109541
    GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(109602), // Rule ID 2986 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2986,
      GIR_EraseRootFromParent_Done,
    // Label 1555: @109602
    GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(109670), // Rule ID 8144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8144,
      GIR_EraseRootFromParent_Done,
    // Label 1556: @109670
    GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(109738), // Rule ID 8148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8148,
      GIR_EraseRootFromParent_Done,
    // Label 1557: @109738
    GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(109801), // Rule ID 8068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8068,
      GIR_EraseRootFromParent_Done,
    // Label 1558: @109801
    GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(109864), // Rule ID 8072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8072,
      GIR_EraseRootFromParent_Done,
    // Label 1559: @109864
    GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(109919), // Rule ID 2955 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2955,
      GIR_EraseRootFromParent_Done,
    // Label 1560: @109919
    GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(109977), // Rule ID 2956 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2956,
      GIR_EraseRootFromParent_Done,
    // Label 1561: @109977
    GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(110035), // Rule ID 2957 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2957,
      GIR_EraseRootFromParent_Done,
    // Label 1562: @110035
    GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(110096), // Rule ID 2958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2958,
      GIR_EraseRootFromParent_Done,
    // Label 1563: @110096
    GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(110151), // Rule ID 2989 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2989,
      GIR_EraseRootFromParent_Done,
    // Label 1564: @110151
    GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(110209), // Rule ID 2990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2990,
      GIR_EraseRootFromParent_Done,
    // Label 1565: @110209
    GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(110267), // Rule ID 2991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2991,
      GIR_EraseRootFromParent_Done,
    // Label 1566: @110267
    GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(110328), // Rule ID 2992 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2992,
      GIR_EraseRootFromParent_Done,
    // Label 1567: @110328
    GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(110392), // Rule ID 8145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8145,
      GIR_EraseRootFromParent_Done,
    // Label 1568: @110392
    GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(110456), // Rule ID 8149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8149,
      GIR_EraseRootFromParent_Done,
    // Label 1569: @110456
    GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(110515), // Rule ID 8069 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8069,
      GIR_EraseRootFromParent_Done,
    // Label 1570: @110515
    GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(110574), // Rule ID 8073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8073,
      GIR_EraseRootFromParent_Done,
    // Label 1571: @110574
    GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(110628), // Rule ID 2949 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2949,
      GIR_EraseRootFromParent_Done,
    // Label 1572: @110628
    GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(110682), // Rule ID 2983 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2983,
      GIR_EraseRootFromParent_Done,
    // Label 1573: @110682
    GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(110732), // Rule ID 2954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2954,
      GIR_EraseRootFromParent_Done,
    // Label 1574: @110732
    GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(110782), // Rule ID 2988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2988,
      GIR_EraseRootFromParent_Done,
    // Label 1575: @110782
    GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(110829), // Rule ID 2960 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2960,
      GIR_EraseRootFromParent_Done,
    // Label 1576: @110829
    GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(110876), // Rule ID 2994 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v2f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2994,
      GIR_EraseRootFromParent_Done,
    // Label 1577: @110876
    GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(110939), // Rule ID 6563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6563,
      GIR_EraseRootFromParent_Done,
    // Label 1578: @110939
    GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(111002), // Rule ID 6565 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v2i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6565,
      GIR_EraseRootFromParent_Done,
    // Label 1579: @111002
    GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(111062), // Rule ID 4247 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4247,
      GIR_EraseRootFromParent_Done,
    // Label 1580: @111062
    GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(111122), // Rule ID 4253 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4253,
      GIR_EraseRootFromParent_Done,
    // Label 1581: @111122
    GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(111177), // Rule ID 4246 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4246,
      GIR_EraseRootFromParent_Done,
    // Label 1582: @111177
    GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(111232), // Rule ID 4252 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4252,
      GIR_EraseRootFromParent_Done,
    // Label 1583: @111232
    GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(111287), // Rule ID 4245 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4245,
      GIR_EraseRootFromParent_Done,
    // Label 1584: @111287
    GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(111342), // Rule ID 4251 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4251,
      GIR_EraseRootFromParent_Done,
    // Label 1585: @111342
    GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(111412), // Rule ID 4499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4499,
      GIR_EraseRootFromParent_Done,
    // Label 1586: @111412
    GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(111479), // Rule ID 4501 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4501,
      GIR_EraseRootFromParent_Done,
    // Label 1587: @111479
    GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(111549), // Rule ID 4503 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4503,
      GIR_EraseRootFromParent_Done,
    // Label 1588: @111549
    GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(111616), // Rule ID 4505 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v2f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4505,
      GIR_EraseRootFromParent_Done,
    // Label 1589: @111616
    GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(111684), // Rule ID 6562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6562,
      GIR_EraseRootFromParent_Done,
    // Label 1590: @111684
    GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(111752), // Rule ID 6564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v2i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6564,
      GIR_EraseRootFromParent_Done,
    // Label 1591: @111752
    GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(111816), // Rule ID 8004 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8004,
      GIR_EraseRootFromParent_Done,
    // Label 1592: @111816
    GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(111880), // Rule ID 8008 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8008,
      GIR_EraseRootFromParent_Done,
    // Label 1593: @111880
    GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(111945), // Rule ID 4498 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4498,
      GIR_EraseRootFromParent_Done,
    // Label 1594: @111945
    GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(112007), // Rule ID 4500 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4500,
      GIR_EraseRootFromParent_Done,
    // Label 1595: @112007
    GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(112072), // Rule ID 4502 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4502,
      GIR_EraseRootFromParent_Done,
    // Label 1596: @112072
    GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(112134), // Rule ID 4504 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4504,
      GIR_EraseRootFromParent_Done,
    // Label 1597: @112134
    GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(112194), // Rule ID 8006 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[v2i32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8006,
      GIR_EraseRootFromParent_Done,
    // Label 1598: @112194
    GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(112254), // Rule ID 8010 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[v2f32] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v2f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8010,
      GIR_EraseRootFromParent_Done,
    // Label 1599: @112254
    GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(112316), // Rule ID 3858 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3858,
      GIR_EraseRootFromParent_Done,
    // Label 1600: @112316
    GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(112378), // Rule ID 3862 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v2f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3862,
      GIR_EraseRootFromParent_Done,
    // Label 1601: @112378
    GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(112435), // Rule ID 3857 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3857,
      GIR_EraseRootFromParent_Done,
    // Label 1602: @112435
    GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(112492), // Rule ID 3861 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3861,
      GIR_EraseRootFromParent_Done,
    // Label 1603: @112492
    GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(112550), // Rule ID 3601 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3601,
      GIR_EraseRootFromParent_Done,
    // Label 1604: @112550
    GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(112608), // Rule ID 3603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v2f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3603,
      GIR_EraseRootFromParent_Done,
    // Label 1605: @112608
    GIM_Reject,
    // Label 957: @112609
    GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(112676), // Rule ID 3143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3143,
      GIR_EraseRootFromParent_Done,
    // Label 1606: @112676
    GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(112743), // Rule ID 3160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3160,
      GIR_EraseRootFromParent_Done,
    // Label 1607: @112743
    GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(112806), // Rule ID 3148 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3148,
      GIR_EraseRootFromParent_Done,
    // Label 1608: @112806
    GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(112869), // Rule ID 3165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3165,
      GIR_EraseRootFromParent_Done,
    // Label 1609: @112869
    GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(112932), // Rule ID 3154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3154,
      GIR_EraseRootFromParent_Done,
    // Label 1610: @112932
    GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(112995), // Rule ID 3171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v2f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3171,
      GIR_EraseRootFromParent_Done,
    // Label 1611: @112995
    GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(113057), // Rule ID 3139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3139,
      GIR_EraseRootFromParent_Done,
    // Label 1612: @113057
    GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(113119), // Rule ID 3140 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3140,
      GIR_EraseRootFromParent_Done,
    // Label 1613: @113119
    GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(113181), // Rule ID 3141 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3141,
      GIR_EraseRootFromParent_Done,
    // Label 1614: @113181
    GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(113246), // Rule ID 3142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3142,
      GIR_EraseRootFromParent_Done,
    // Label 1615: @113246
    GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(113308), // Rule ID 3156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3156,
      GIR_EraseRootFromParent_Done,
    // Label 1616: @113308
    GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(113370), // Rule ID 3157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3157,
      GIR_EraseRootFromParent_Done,
    // Label 1617: @113370
    GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(113432), // Rule ID 3158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3158,
      GIR_EraseRootFromParent_Done,
    // Label 1618: @113432
    GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(113497), // Rule ID 3159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3159,
      GIR_EraseRootFromParent_Done,
    // Label 1619: @113497
    GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(113555), // Rule ID 3145 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3145,
      GIR_EraseRootFromParent_Done,
    // Label 1620: @113555
    GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(113613), // Rule ID 3146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3146,
      GIR_EraseRootFromParent_Done,
    // Label 1621: @113613
    GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(113674), // Rule ID 3147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3147,
      GIR_EraseRootFromParent_Done,
    // Label 1622: @113674
    GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(113732), // Rule ID 3162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3162,
      GIR_EraseRootFromParent_Done,
    // Label 1623: @113732
    GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(113790), // Rule ID 3163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3163,
      GIR_EraseRootFromParent_Done,
    // Label 1624: @113790
    GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(113851), // Rule ID 3164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3164,
      GIR_EraseRootFromParent_Done,
    // Label 1625: @113851
    GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(113919), // Rule ID 8192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8192,
      GIR_EraseRootFromParent_Done,
    // Label 1626: @113919
    GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(113987), // Rule ID 8196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8196,
      GIR_EraseRootFromParent_Done,
    // Label 1627: @113987
    GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(114050), // Rule ID 8116 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8116,
      GIR_EraseRootFromParent_Done,
    // Label 1628: @114050
    GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(114113), // Rule ID 8120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8120,
      GIR_EraseRootFromParent_Done,
    // Label 1629: @114113
    GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(114168), // Rule ID 3150 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3150,
      GIR_EraseRootFromParent_Done,
    // Label 1630: @114168
    GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(114226), // Rule ID 3151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3151,
      GIR_EraseRootFromParent_Done,
    // Label 1631: @114226
    GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(114284), // Rule ID 3152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3152,
      GIR_EraseRootFromParent_Done,
    // Label 1632: @114284
    GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(114345), // Rule ID 3153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3153,
      GIR_EraseRootFromParent_Done,
    // Label 1633: @114345
    GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(114400), // Rule ID 3167 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v2f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3167,
      GIR_EraseRootFromParent_Done,
    // Label 1634: @114400
    GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(114458), // Rule ID 3168 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v2f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3168,
      GIR_EraseRootFromParent_Done,
    // Label 1635: @114458
    GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(114516), // Rule ID 3169 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3169,
      GIR_EraseRootFromParent_Done,
    // Label 1636: @114516
    GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(114577), // Rule ID 3170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v2f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v2f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3170,
      GIR_EraseRootFromParent_Done,
    // Label 1637: @114577
    GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(114641), // Rule ID 8193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8193,
      GIR_EraseRootFromParent_Done,
    // Label 1638: @114641
    GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(114705), // Rule ID 8197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8197,
      GIR_EraseRootFromParent_Done,
    // Label 1639: @114705
    GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(114764), // Rule ID 8117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8117,
      GIR_EraseRootFromParent_Done,
    // Label 1640: @114764
    GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(114823), // Rule ID 8121 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v2f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8121,
      GIR_EraseRootFromParent_Done,
    // Label 1641: @114823
    GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(114877), // Rule ID 3144 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3144,
      GIR_EraseRootFromParent_Done,
    // Label 1642: @114877
    GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(114931), // Rule ID 3161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3161,
      GIR_EraseRootFromParent_Done,
    // Label 1643: @114931
    GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(114981), // Rule ID 3149 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3149,
      GIR_EraseRootFromParent_Done,
    // Label 1644: @114981
    GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(115031), // Rule ID 3166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3166,
      GIR_EraseRootFromParent_Done,
    // Label 1645: @115031
    GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(115078), // Rule ID 3155 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3155,
      GIR_EraseRootFromParent_Done,
    // Label 1646: @115078
    GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(115125), // Rule ID 3172 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v2f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v2f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3172,
      GIR_EraseRootFromParent_Done,
    // Label 1647: @115125
    GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(115185), // Rule ID 4310 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2i64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4310,
      GIR_EraseRootFromParent_Done,
    // Label 1648: @115185
    GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(115245), // Rule ID 4316 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v2f64] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4316,
      GIR_EraseRootFromParent_Done,
    // Label 1649: @115245
    GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(115300), // Rule ID 4309 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2i64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4309,
      GIR_EraseRootFromParent_Done,
    // Label 1650: @115300
    GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(115355), // Rule ID 4315 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v2f64] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4315,
      GIR_EraseRootFromParent_Done,
    // Label 1651: @115355
    GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(115410), // Rule ID 4308 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2i64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4308,
      GIR_EraseRootFromParent_Done,
    // Label 1652: @115410
    GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(115465), // Rule ID 4314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v2f64] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4314,
      GIR_EraseRootFromParent_Done,
    // Label 1653: @115465
    GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(115535), // Rule ID 4547 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4547,
      GIR_EraseRootFromParent_Done,
    // Label 1654: @115535
    GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(115602), // Rule ID 4549 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2i64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4549,
      GIR_EraseRootFromParent_Done,
    // Label 1655: @115602
    GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(115672), // Rule ID 4551 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4551,
      GIR_EraseRootFromParent_Done,
    // Label 1656: @115672
    GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(115739), // Rule ID 4553 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v2f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v2f64] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4553,
      GIR_EraseRootFromParent_Done,
    // Label 1657: @115739
    GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(115803), // Rule ID 8040 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8040,
      GIR_EraseRootFromParent_Done,
    // Label 1658: @115803
    GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(115867), // Rule ID 8044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8044,
      GIR_EraseRootFromParent_Done,
    // Label 1659: @115867
    GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(115932), // Rule ID 4546 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4546,
      GIR_EraseRootFromParent_Done,
    // Label 1660: @115932
    GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(115994), // Rule ID 4548 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4548,
      GIR_EraseRootFromParent_Done,
    // Label 1661: @115994
    GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(116059), // Rule ID 4550 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4550,
      GIR_EraseRootFromParent_Done,
    // Label 1662: @116059
    GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(116121), // Rule ID 4552 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v2f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4552,
      GIR_EraseRootFromParent_Done,
    // Label 1663: @116121
    GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(116181), // Rule ID 8042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v2i64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2i64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8042,
      GIR_EraseRootFromParent_Done,
    // Label 1664: @116181
    GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(116241), // Rule ID 8046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v2f64] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v2f64] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8046,
      GIR_EraseRootFromParent_Done,
    // Label 1665: @116241
    GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(116303), // Rule ID 3900 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2i64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3900,
      GIR_EraseRootFromParent_Done,
    // Label 1666: @116303
    GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(116365), // Rule ID 3904 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v2f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v2f64] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3904,
      GIR_EraseRootFromParent_Done,
    // Label 1667: @116365
    GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(116422), // Rule ID 3899 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2i64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3899,
      GIR_EraseRootFromParent_Done,
    // Label 1668: @116422
    GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(116479), // Rule ID 3903 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v2f64] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3903,
      GIR_EraseRootFromParent_Done,
    // Label 1669: @116479
    GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(116537), // Rule ID 3621 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2i64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3621,
      GIR_EraseRootFromParent_Done,
    // Label 1670: @116537
    GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(116595), // Rule ID 3623 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v2f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v2f64] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3623,
      GIR_EraseRootFromParent_Done,
    // Label 1671: @116595
    GIM_Reject,
    // Label 958: @116596
    GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(116663), // Rule ID 3078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3078,
      GIR_EraseRootFromParent_Done,
    // Label 1672: @116663
    GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(116730), // Rule ID 3093 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3093,
      GIR_EraseRootFromParent_Done,
    // Label 1673: @116730
    GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(116793), // Rule ID 3083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3083,
      GIR_EraseRootFromParent_Done,
    // Label 1674: @116793
    GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(116856), // Rule ID 3098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3098,
      GIR_EraseRootFromParent_Done,
    // Label 1675: @116856
    GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(116919), // Rule ID 3088 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3088,
      GIR_EraseRootFromParent_Done,
    // Label 1676: @116919
    GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(116982), // Rule ID 3103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v3f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3103,
      GIR_EraseRootFromParent_Done,
    // Label 1677: @116982
    GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(117044), // Rule ID 3075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3075,
      GIR_EraseRootFromParent_Done,
    // Label 1678: @117044
    GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(117106), // Rule ID 3076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3076,
      GIR_EraseRootFromParent_Done,
    // Label 1679: @117106
    GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(117171), // Rule ID 3077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3077,
      GIR_EraseRootFromParent_Done,
    // Label 1680: @117171
    GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(117233), // Rule ID 3090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3090,
      GIR_EraseRootFromParent_Done,
    // Label 1681: @117233
    GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(117295), // Rule ID 3091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3091,
      GIR_EraseRootFromParent_Done,
    // Label 1682: @117295
    GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(117360), // Rule ID 3092 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3092,
      GIR_EraseRootFromParent_Done,
    // Label 1683: @117360
    GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(117418), // Rule ID 3080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3080,
      GIR_EraseRootFromParent_Done,
    // Label 1684: @117418
    GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(117476), // Rule ID 3081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3081,
      GIR_EraseRootFromParent_Done,
    // Label 1685: @117476
    GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(117537), // Rule ID 3082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3082,
      GIR_EraseRootFromParent_Done,
    // Label 1686: @117537
    GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(117595), // Rule ID 3095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3095,
      GIR_EraseRootFromParent_Done,
    // Label 1687: @117595
    GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(117653), // Rule ID 3096 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3096,
      GIR_EraseRootFromParent_Done,
    // Label 1688: @117653
    GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(117714), // Rule ID 3097 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM_ec:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3097,
      GIR_EraseRootFromParent_Done,
    // Label 1689: @117714
    GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(117773), // Rule ID 8176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8176,
      GIR_EraseRootFromParent_Done,
    // Label 1690: @117773
    GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(117832), // Rule ID 8180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8180,
      GIR_EraseRootFromParent_Done,
    // Label 1691: @117832
    GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(117895), // Rule ID 8100 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8100,
      GIR_EraseRootFromParent_Done,
    // Label 1692: @117895
    GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(117958), // Rule ID 8104 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B96:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8104,
      GIR_EraseRootFromParent_Done,
    // Label 1693: @117958
    GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(118013), // Rule ID 3085 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3085,
      GIR_EraseRootFromParent_Done,
    // Label 1694: @118013
    GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(118071), // Rule ID 3086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3086,
      GIR_EraseRootFromParent_Done,
    // Label 1695: @118071
    GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(118132), // Rule ID 3087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3087,
      GIR_EraseRootFromParent_Done,
    // Label 1696: @118132
    GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(118187), // Rule ID 3100 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v3f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3100,
      GIR_EraseRootFromParent_Done,
    // Label 1697: @118187
    GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(118245), // Rule ID 3101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3101,
      GIR_EraseRootFromParent_Done,
    // Label 1698: @118245
    GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(118306), // Rule ID 3102 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v3f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3102,
      GIR_EraseRootFromParent_Done,
    // Label 1699: @118306
    GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(118361), // Rule ID 8177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8177,
      GIR_EraseRootFromParent_Done,
    // Label 1700: @118361
    GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(118416), // Rule ID 8181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8181,
      GIR_EraseRootFromParent_Done,
    // Label 1701: @118416
    GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(118475), // Rule ID 8101 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v3i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8101,
      GIR_EraseRootFromParent_Done,
    // Label 1702: @118475
    GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(118534), // Rule ID 8105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v3f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B96_gfx9:{ *:[v3f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8105,
      GIR_EraseRootFromParent_Done,
    // Label 1703: @118534
    GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(118588), // Rule ID 3079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3079,
      GIR_EraseRootFromParent_Done,
    // Label 1704: @118588
    GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(118642), // Rule ID 3094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3094,
      GIR_EraseRootFromParent_Done,
    // Label 1705: @118642
    GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(118692), // Rule ID 3084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3084,
      GIR_EraseRootFromParent_Done,
    // Label 1706: @118692
    GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(118742), // Rule ID 3099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM_ec:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3099,
      GIR_EraseRootFromParent_Done,
    // Label 1707: @118742
    GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(118789), // Rule ID 3089 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v3i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3089,
      GIR_EraseRootFromParent_Done,
    // Label 1708: @118789
    GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(118836), // Rule ID 3104 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v3f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX3_IMM:{ *:[v3f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX3_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3104,
      GIR_EraseRootFromParent_Done,
    // Label 1709: @118836
    GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(118899), // Rule ID 6567 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6567,
      GIR_EraseRootFromParent_Done,
    // Label 1710: @118899
    GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(118962), // Rule ID 6569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v3i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6569,
      GIR_EraseRootFromParent_Done,
    // Label 1711: @118962
    GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(119022), // Rule ID 4295 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v3i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SVS:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4295,
      GIR_EraseRootFromParent_Done,
    // Label 1712: @119022
    GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(119077), // Rule ID 4294 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v3i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4294,
      GIR_EraseRootFromParent_Done,
    // Label 1713: @119077
    GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(119132), // Rule ID 4293 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v3i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX3),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4293,
      GIR_EraseRootFromParent_Done,
    // Label 1714: @119132
    GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(119202), // Rule ID 4531 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4531,
      GIR_EraseRootFromParent_Done,
    // Label 1715: @119202
    GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(119269), // Rule ID 4533 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v3i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4533,
      GIR_EraseRootFromParent_Done,
    // Label 1716: @119269
    GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(119339), // Rule ID 4535 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4535,
      GIR_EraseRootFromParent_Done,
    // Label 1717: @119339
    GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(119406), // Rule ID 4537 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v3f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64:{ *:[v3f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4537,
      GIR_EraseRootFromParent_Done,
    // Label 1718: @119406
    GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(119474), // Rule ID 6566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6566,
      GIR_EraseRootFromParent_Done,
    // Label 1719: @119474
    GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(119542), // Rule ID 6568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v3i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6568,
      GIR_EraseRootFromParent_Done,
    // Label 1720: @119542
    GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(119607), // Rule ID 4530 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4530,
      GIR_EraseRootFromParent_Done,
    // Label 1721: @119607
    GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(119669), // Rule ID 4532 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v3i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4532,
      GIR_EraseRootFromParent_Done,
    // Label 1722: @119669
    GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(119734), // Rule ID 4534 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4534,
      GIR_EraseRootFromParent_Done,
    // Label 1723: @119734
    GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(119796), // Rule ID 4536 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v3f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4536,
      GIR_EraseRootFromParent_Done,
    // Label 1724: @119796
    GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(119858), // Rule ID 3890 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v3i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3_SADDR:{ *:[v3i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3890,
      GIR_EraseRootFromParent_Done,
    // Label 1725: @119858
    GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(119915), // Rule ID 3889 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v3i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX3),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3889,
      GIR_EraseRootFromParent_Done,
    // Label 1726: @119915
    GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(119973), // Rule ID 3573 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v3i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX3:{ *:[v3i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX3),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3573,
      GIR_EraseRootFromParent_Done,
    // Label 1727: @119973
    GIM_Reject,
    // Label 959: @119974
    GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(120041), // Rule ID 3028 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3028,
      GIR_EraseRootFromParent_Done,
    // Label 1728: @120041
    GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(120108), // Rule ID 3045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3045,
      GIR_EraseRootFromParent_Done,
    // Label 1729: @120108
    GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(120175), // Rule ID 3062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3062,
      GIR_EraseRootFromParent_Done,
    // Label 1730: @120175
    GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(120238), // Rule ID 3033 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3033,
      GIR_EraseRootFromParent_Done,
    // Label 1731: @120238
    GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(120301), // Rule ID 3050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3050,
      GIR_EraseRootFromParent_Done,
    // Label 1732: @120301
    GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(120364), // Rule ID 3067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3067,
      GIR_EraseRootFromParent_Done,
    // Label 1733: @120364
    GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(120427), // Rule ID 3039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3039,
      GIR_EraseRootFromParent_Done,
    // Label 1734: @120427
    GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(120490), // Rule ID 3056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3056,
      GIR_EraseRootFromParent_Done,
    // Label 1735: @120490
    GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(120553), // Rule ID 3073 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3073,
      GIR_EraseRootFromParent_Done,
    // Label 1736: @120553
    GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(120615), // Rule ID 3024 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3024,
      GIR_EraseRootFromParent_Done,
    // Label 1737: @120615
    GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(120677), // Rule ID 3025 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3025,
      GIR_EraseRootFromParent_Done,
    // Label 1738: @120677
    GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(120739), // Rule ID 3026 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3026,
      GIR_EraseRootFromParent_Done,
    // Label 1739: @120739
    GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(120804), // Rule ID 3027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3027,
      GIR_EraseRootFromParent_Done,
    // Label 1740: @120804
    GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(120866), // Rule ID 3041 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3041,
      GIR_EraseRootFromParent_Done,
    // Label 1741: @120866
    GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(120928), // Rule ID 3042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3042,
      GIR_EraseRootFromParent_Done,
    // Label 1742: @120928
    GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(120990), // Rule ID 3043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3043,
      GIR_EraseRootFromParent_Done,
    // Label 1743: @120990
    GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(121055), // Rule ID 3044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3044,
      GIR_EraseRootFromParent_Done,
    // Label 1744: @121055
    GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(121117), // Rule ID 3058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3058,
      GIR_EraseRootFromParent_Done,
    // Label 1745: @121117
    GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(121179), // Rule ID 3059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3059,
      GIR_EraseRootFromParent_Done,
    // Label 1746: @121179
    GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(121241), // Rule ID 3060 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3060,
      GIR_EraseRootFromParent_Done,
    // Label 1747: @121241
    GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(121306), // Rule ID 3061 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3061,
      GIR_EraseRootFromParent_Done,
    // Label 1748: @121306
    GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(121364), // Rule ID 3030 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3030,
      GIR_EraseRootFromParent_Done,
    // Label 1749: @121364
    GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(121422), // Rule ID 3031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3031,
      GIR_EraseRootFromParent_Done,
    // Label 1750: @121422
    GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(121483), // Rule ID 3032 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3032,
      GIR_EraseRootFromParent_Done,
    // Label 1751: @121483
    GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(121541), // Rule ID 3047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3047,
      GIR_EraseRootFromParent_Done,
    // Label 1752: @121541
    GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(121599), // Rule ID 3048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3048,
      GIR_EraseRootFromParent_Done,
    // Label 1753: @121599
    GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(121660), // Rule ID 3049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3049,
      GIR_EraseRootFromParent_Done,
    // Label 1754: @121660
    GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(121718), // Rule ID 3064 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3064,
      GIR_EraseRootFromParent_Done,
    // Label 1755: @121718
    GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(121776), // Rule ID 3065 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_ec:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3065,
      GIR_EraseRootFromParent_Done,
    // Label 1756: @121776
    GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(121837), // Rule ID 3066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM_ec:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3066,
      GIR_EraseRootFromParent_Done,
    // Label 1757: @121837
    GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(121905), // Rule ID 8152 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8152,
      GIR_EraseRootFromParent_Done,
    // Label 1758: @121905
    GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(121973), // Rule ID 8156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8156,
      GIR_EraseRootFromParent_Done,
    // Label 1759: @121973
    GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(122041), // Rule ID 8160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8160,
      GIR_EraseRootFromParent_Done,
    // Label 1760: @122041
    GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(122104), // Rule ID 8076 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8076,
      GIR_EraseRootFromParent_Done,
    // Label 1761: @122104
    GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(122167), // Rule ID 8080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8080,
      GIR_EraseRootFromParent_Done,
    // Label 1762: @122167
    GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(122230), // Rule ID 8084 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align8_local_m0>>  =>  (DS_READ_B64:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8084,
      GIR_EraseRootFromParent_Done,
    // Label 1763: @122230
    GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(122285), // Rule ID 3035 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3035,
      GIR_EraseRootFromParent_Done,
    // Label 1764: @122285
    GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(122343), // Rule ID 3036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3036,
      GIR_EraseRootFromParent_Done,
    // Label 1765: @122343
    GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(122401), // Rule ID 3037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3037,
      GIR_EraseRootFromParent_Done,
    // Label 1766: @122401
    GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(122462), // Rule ID 3038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3038,
      GIR_EraseRootFromParent_Done,
    // Label 1767: @122462
    GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(122517), // Rule ID 3052 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3052,
      GIR_EraseRootFromParent_Done,
    // Label 1768: @122517
    GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(122575), // Rule ID 3053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3053,
      GIR_EraseRootFromParent_Done,
    // Label 1769: @122575
    GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(122633), // Rule ID 3054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3054,
      GIR_EraseRootFromParent_Done,
    // Label 1770: @122633
    GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(122694), // Rule ID 3055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3055,
      GIR_EraseRootFromParent_Done,
    // Label 1771: @122694
    GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(122749), // Rule ID 3069 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3069,
      GIR_EraseRootFromParent_Done,
    // Label 1772: @122749
    GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(122807), // Rule ID 3070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ci:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3070,
      GIR_EraseRootFromParent_Done,
    // Label 1773: @122807
    GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(122865), // Rule ID 3071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3071,
      GIR_EraseRootFromParent_Done,
    // Label 1774: @122865
    GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(122926), // Rule ID 3072 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_SGPR_IMM:{ *:[v4bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3072,
      GIR_EraseRootFromParent_Done,
    // Label 1775: @122926
    GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(122990), // Rule ID 8153 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8153,
      GIR_EraseRootFromParent_Done,
    // Label 1776: @122990
    GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(123054), // Rule ID 8157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8157,
      GIR_EraseRootFromParent_Done,
    // Label 1777: @123054
    GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(123118), // Rule ID 8161 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8161,
      GIR_EraseRootFromParent_Done,
    // Label 1778: @123118
    GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(123177), // Rule ID 8077 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8077,
      GIR_EraseRootFromParent_Done,
    // Label 1779: @123177
    GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(123236), // Rule ID 8081 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8081,
      GIR_EraseRootFromParent_Done,
    // Label 1780: @123236
    GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(123295), // Rule ID 8085 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align8_local>>  =>  (DS_READ_B64_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8085,
      GIR_EraseRootFromParent_Done,
    // Label 1781: @123295
    GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(123349), // Rule ID 3029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3029,
      GIR_EraseRootFromParent_Done,
    // Label 1782: @123349
    GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(123403), // Rule ID 3046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3046,
      GIR_EraseRootFromParent_Done,
    // Label 1783: @123403
    GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(123457), // Rule ID 3063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v4bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3063,
      GIR_EraseRootFromParent_Done,
    // Label 1784: @123457
    GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(123507), // Rule ID 3034 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3034,
      GIR_EraseRootFromParent_Done,
    // Label 1785: @123507
    GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(123557), // Rule ID 3051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3051,
      GIR_EraseRootFromParent_Done,
    // Label 1786: @123557
    GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(123607), // Rule ID 3068 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM_ec:{ *:[v4bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3068,
      GIR_EraseRootFromParent_Done,
    // Label 1787: @123607
    GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(123654), // Rule ID 3040 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3040,
      GIR_EraseRootFromParent_Done,
    // Label 1788: @123654
    GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(123701), // Rule ID 3057 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3057,
      GIR_EraseRootFromParent_Done,
    // Label 1789: @123701
    GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(123748), // Rule ID 3074 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX2_IMM:{ *:[v4bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX2_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3074,
      GIR_EraseRootFromParent_Done,
    // Label 1790: @123748
    GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(123808), // Rule ID 4259 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v4f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4259,
      GIR_EraseRootFromParent_Done,
    // Label 1791: @123808
    GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(123868), // Rule ID 4265 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v4bf16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4265,
      GIR_EraseRootFromParent_Done,
    // Label 1792: @123868
    GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(123928), // Rule ID 4271 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v4i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SVS:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4271,
      GIR_EraseRootFromParent_Done,
    // Label 1793: @123928
    GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(123983), // Rule ID 4258 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v4f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4258,
      GIR_EraseRootFromParent_Done,
    // Label 1794: @123983
    GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(124038), // Rule ID 4264 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v4bf16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4bf16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4264,
      GIR_EraseRootFromParent_Done,
    // Label 1795: @124038
    GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(124093), // Rule ID 4270 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v4i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4270,
      GIR_EraseRootFromParent_Done,
    // Label 1796: @124093
    GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(124148), // Rule ID 4257 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v4f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4257,
      GIR_EraseRootFromParent_Done,
    // Label 1797: @124148
    GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(124203), // Rule ID 4263 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v4bf16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4263,
      GIR_EraseRootFromParent_Done,
    // Label 1798: @124203
    GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(124258), // Rule ID 4269 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v4i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4269,
      GIR_EraseRootFromParent_Done,
    // Label 1799: @124258
    GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(124328), // Rule ID 4507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4507,
      GIR_EraseRootFromParent_Done,
    // Label 1800: @124328
    GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(124395), // Rule ID 4509 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4509,
      GIR_EraseRootFromParent_Done,
    // Label 1801: @124395
    GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(124465), // Rule ID 4511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4511,
      GIR_EraseRootFromParent_Done,
    // Label 1802: @124465
    GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(124532), // Rule ID 4513 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4513,
      GIR_EraseRootFromParent_Done,
    // Label 1803: @124532
    GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(124602), // Rule ID 4515 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4515,
      GIR_EraseRootFromParent_Done,
    // Label 1804: @124602
    GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(124669), // Rule ID 4517 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64:{ *:[v4i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4517,
      GIR_EraseRootFromParent_Done,
    // Label 1805: @124669
    GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(124733), // Rule ID 8012 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8012,
      GIR_EraseRootFromParent_Done,
    // Label 1806: @124733
    GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(124797), // Rule ID 8016 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[v4bf16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8016,
      GIR_EraseRootFromParent_Done,
    // Label 1807: @124797
    GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(124861), // Rule ID 8020 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUld_glue:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B32:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8020,
      GIR_EraseRootFromParent_Done,
    // Label 1808: @124861
    GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(124926), // Rule ID 4506 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4506,
      GIR_EraseRootFromParent_Done,
    // Label 1809: @124926
    GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(124988), // Rule ID 4508 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4508,
      GIR_EraseRootFromParent_Done,
    // Label 1810: @124988
    GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(125053), // Rule ID 4510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4510,
      GIR_EraseRootFromParent_Done,
    // Label 1811: @125053
    GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(125115), // Rule ID 4512 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4512,
      GIR_EraseRootFromParent_Done,
    // Label 1812: @125115
    GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(125180), // Rule ID 4514 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4514,
      GIR_EraseRootFromParent_Done,
    // Label 1813: @125180
    GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(125242), // Rule ID 4516 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4516,
      GIR_EraseRootFromParent_Done,
    // Label 1814: @125242
    GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(125302), // Rule ID 8014 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[v4f16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8014,
      GIR_EraseRootFromParent_Done,
    // Label 1815: @125302
    GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(125362), // Rule ID 8018 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[v4bf16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8018,
      GIR_EraseRootFromParent_Done,
    // Label 1816: @125362
    GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(125422), // Rule ID 8022 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (ld:{ *:[v4i16] } (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B32_gfx9:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B32_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8022,
      GIR_EraseRootFromParent_Done,
    // Label 1817: @125422
    GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(125484), // Rule ID 3866 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v4f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3866,
      GIR_EraseRootFromParent_Done,
    // Label 1818: @125484
    GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(125546), // Rule ID 3870 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v4bf16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4bf16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3870,
      GIR_EraseRootFromParent_Done,
    // Label 1819: @125546
    GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(125608), // Rule ID 3874 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v4i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3874,
      GIR_EraseRootFromParent_Done,
    // Label 1820: @125608
    GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(125665), // Rule ID 3865 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v4f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3865,
      GIR_EraseRootFromParent_Done,
    // Label 1821: @125665
    GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(125722), // Rule ID 3869 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v4bf16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3869,
      GIR_EraseRootFromParent_Done,
    // Label 1822: @125722
    GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(125779), // Rule ID 3873 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v4i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3873,
      GIR_EraseRootFromParent_Done,
    // Label 1823: @125779
    GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(125837), // Rule ID 3605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v4f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3605,
      GIR_EraseRootFromParent_Done,
    // Label 1824: @125837
    GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(125895), // Rule ID 3607 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v4bf16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3607,
      GIR_EraseRootFromParent_Done,
    // Label 1825: @125895
    GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(125953), // Rule ID 3609 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v4i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX2:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3609,
      GIR_EraseRootFromParent_Done,
    // Label 1826: @125953
    GIM_Reject,
    // Label 960: @125954
    GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(126021), // Rule ID 3109 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3109,
      GIR_EraseRootFromParent_Done,
    // Label 1827: @126021
    GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(126088), // Rule ID 3126 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3126,
      GIR_EraseRootFromParent_Done,
    // Label 1828: @126088
    GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(126151), // Rule ID 3114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3114,
      GIR_EraseRootFromParent_Done,
    // Label 1829: @126151
    GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(126214), // Rule ID 3131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3131,
      GIR_EraseRootFromParent_Done,
    // Label 1830: @126214
    GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(126277), // Rule ID 3120 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3120,
      GIR_EraseRootFromParent_Done,
    // Label 1831: @126277
    GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(126340), // Rule ID 3137 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v4f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3137,
      GIR_EraseRootFromParent_Done,
    // Label 1832: @126340
    GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(126402), // Rule ID 3105 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3105,
      GIR_EraseRootFromParent_Done,
    // Label 1833: @126402
    GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(126464), // Rule ID 3106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3106,
      GIR_EraseRootFromParent_Done,
    // Label 1834: @126464
    GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(126526), // Rule ID 3107 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3107,
      GIR_EraseRootFromParent_Done,
    // Label 1835: @126526
    GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(126591), // Rule ID 3108 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3108,
      GIR_EraseRootFromParent_Done,
    // Label 1836: @126591
    GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(126653), // Rule ID 3122 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3122,
      GIR_EraseRootFromParent_Done,
    // Label 1837: @126653
    GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(126715), // Rule ID 3123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3123,
      GIR_EraseRootFromParent_Done,
    // Label 1838: @126715
    GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(126777), // Rule ID 3124 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3124,
      GIR_EraseRootFromParent_Done,
    // Label 1839: @126777
    GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(126842), // Rule ID 3125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3125,
      GIR_EraseRootFromParent_Done,
    // Label 1840: @126842
    GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(126900), // Rule ID 3111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3111,
      GIR_EraseRootFromParent_Done,
    // Label 1841: @126900
    GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(126958), // Rule ID 3112 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3112,
      GIR_EraseRootFromParent_Done,
    // Label 1842: @126958
    GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(127019), // Rule ID 3113 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3113,
      GIR_EraseRootFromParent_Done,
    // Label 1843: @127019
    GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(127077), // Rule ID 3128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3128,
      GIR_EraseRootFromParent_Done,
    // Label 1844: @127077
    GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(127135), // Rule ID 3129 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3129,
      GIR_EraseRootFromParent_Done,
    // Label 1845: @127135
    GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(127196), // Rule ID 3130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3130,
      GIR_EraseRootFromParent_Done,
    // Label 1846: @127196
    GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(127264), // Rule ID 8184 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8184,
      GIR_EraseRootFromParent_Done,
    // Label 1847: @127264
    GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(127332), // Rule ID 8188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8188,
      GIR_EraseRootFromParent_Done,
    // Label 1848: @127332
    GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(127395), // Rule ID 8108 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8108,
      GIR_EraseRootFromParent_Done,
    // Label 1849: @127395
    GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(127458), // Rule ID 8112 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8112,
      GIR_EraseRootFromParent_Done,
    // Label 1850: @127458
    GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(127513), // Rule ID 3116 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3116,
      GIR_EraseRootFromParent_Done,
    // Label 1851: @127513
    GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(127571), // Rule ID 3117 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3117,
      GIR_EraseRootFromParent_Done,
    // Label 1852: @127571
    GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(127629), // Rule ID 3118 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3118,
      GIR_EraseRootFromParent_Done,
    // Label 1853: @127629
    GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(127690), // Rule ID 3119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3119,
      GIR_EraseRootFromParent_Done,
    // Label 1854: @127690
    GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(127745), // Rule ID 3133 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v4f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3133,
      GIR_EraseRootFromParent_Done,
    // Label 1855: @127745
    GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(127803), // Rule ID 3134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v4f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3134,
      GIR_EraseRootFromParent_Done,
    // Label 1856: @127803
    GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(127861), // Rule ID 3135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3135,
      GIR_EraseRootFromParent_Done,
    // Label 1857: @127861
    GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(127922), // Rule ID 3136 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v4f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3136,
      GIR_EraseRootFromParent_Done,
    // Label 1858: @127922
    GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(127986), // Rule ID 8185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8185,
      GIR_EraseRootFromParent_Done,
    // Label 1859: @127986
    GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(128050), // Rule ID 8189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8189,
      GIR_EraseRootFromParent_Done,
    // Label 1860: @128050
    GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(128109), // Rule ID 8109 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8109,
      GIR_EraseRootFromParent_Done,
    // Label 1861: @128109
    GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(128168), // Rule ID 8113 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v4f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8113,
      GIR_EraseRootFromParent_Done,
    // Label 1862: @128168
    GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(128222), // Rule ID 3110 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3110,
      GIR_EraseRootFromParent_Done,
    // Label 1863: @128222
    GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(128276), // Rule ID 3127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3127,
      GIR_EraseRootFromParent_Done,
    // Label 1864: @128276
    GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(128326), // Rule ID 3115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3115,
      GIR_EraseRootFromParent_Done,
    // Label 1865: @128326
    GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(128376), // Rule ID 3132 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3132,
      GIR_EraseRootFromParent_Done,
    // Label 1866: @128376
    GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(128423), // Rule ID 3121 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3121,
      GIR_EraseRootFromParent_Done,
    // Label 1867: @128423
    GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(128470), // Rule ID 3138 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v4f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v4f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3138,
      GIR_EraseRootFromParent_Done,
    // Label 1868: @128470
    GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(128533), // Rule ID 6571 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6571,
      GIR_EraseRootFromParent_Done,
    // Label 1869: @128533
    GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(128596), // Rule ID 6573 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[v4i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6573,
      GIR_EraseRootFromParent_Done,
    // Label 1870: @128596
    GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(128656), // Rule ID 4298 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v4i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4298,
      GIR_EraseRootFromParent_Done,
    // Label 1871: @128656
    GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(128716), // Rule ID 4304 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v4f32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4304,
      GIR_EraseRootFromParent_Done,
    // Label 1872: @128716
    GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(128771), // Rule ID 4297 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v4i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4297,
      GIR_EraseRootFromParent_Done,
    // Label 1873: @128771
    GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(128826), // Rule ID 4303 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v4f32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4303,
      GIR_EraseRootFromParent_Done,
    // Label 1874: @128826
    GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(128881), // Rule ID 4296 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v4i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4296,
      GIR_EraseRootFromParent_Done,
    // Label 1875: @128881
    GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(128936), // Rule ID 4302 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v4f32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4302,
      GIR_EraseRootFromParent_Done,
    // Label 1876: @128936
    GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(129006), // Rule ID 4539 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4539,
      GIR_EraseRootFromParent_Done,
    // Label 1877: @129006
    GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(129073), // Rule ID 4541 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4541,
      GIR_EraseRootFromParent_Done,
    // Label 1878: @129073
    GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(129143), // Rule ID 4543 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4543,
      GIR_EraseRootFromParent_Done,
    // Label 1879: @129143
    GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(129210), // Rule ID 4545 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v4f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v4f32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4545,
      GIR_EraseRootFromParent_Done,
    // Label 1880: @129210
    GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(129278), // Rule ID 6570 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6570,
      GIR_EraseRootFromParent_Done,
    // Label 1881: @129278
    GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(129346), // Rule ID 6572 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[v4i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6572,
      GIR_EraseRootFromParent_Done,
    // Label 1882: @129346
    GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(129410), // Rule ID 7996 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7996,
      GIR_EraseRootFromParent_Done,
    // Label 1883: @129410
    GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(129474), // Rule ID 8036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8036,
      GIR_EraseRootFromParent_Done,
    // Label 1884: @129474
    GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(129539), // Rule ID 4538 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4538,
      GIR_EraseRootFromParent_Done,
    // Label 1885: @129539
    GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(129601), // Rule ID 4540 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4540,
      GIR_EraseRootFromParent_Done,
    // Label 1886: @129601
    GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(129666), // Rule ID 4542 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4542,
      GIR_EraseRootFromParent_Done,
    // Label 1887: @129666
    GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(129728), // Rule ID 4544 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v4f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4544,
      GIR_EraseRootFromParent_Done,
    // Label 1888: @129728
    GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(129788), // Rule ID 7998 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v4i32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4i32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7998,
      GIR_EraseRootFromParent_Done,
    // Label 1889: @129788
    GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(129848), // Rule ID 8038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v4f32] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v4f32] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8038,
      GIR_EraseRootFromParent_Done,
    // Label 1890: @129848
    GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(129910), // Rule ID 3892 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v4i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3892,
      GIR_EraseRootFromParent_Done,
    // Label 1891: @129910
    GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(129972), // Rule ID 3896 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v4f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v4f32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3896,
      GIR_EraseRootFromParent_Done,
    // Label 1892: @129972
    GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(130029), // Rule ID 3891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v4i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3891,
      GIR_EraseRootFromParent_Done,
    // Label 1893: @130029
    GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(130086), // Rule ID 3895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v4f32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3895,
      GIR_EraseRootFromParent_Done,
    // Label 1894: @130086
    GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(130144), // Rule ID 3617 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v4i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3617,
      GIR_EraseRootFromParent_Done,
    // Label 1895: @130144
    GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(130202), // Rule ID 3619 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v4f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v4f32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3619,
      GIR_EraseRootFromParent_Done,
    // Label 1896: @130202
    GIM_Reject,
    // Label 961: @130203
    GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(131953),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(130275), // Rule ID 3262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3262,
        GIR_EraseRootFromParent_Done,
      // Label 1898: @130275
      GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(130334), // Rule ID 3279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3279,
        GIR_EraseRootFromParent_Done,
      // Label 1899: @130334
      GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(130389), // Rule ID 3267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3267,
        GIR_EraseRootFromParent_Done,
      // Label 1900: @130389
      GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(130444), // Rule ID 3284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3284,
        GIR_EraseRootFromParent_Done,
      // Label 1901: @130444
      GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(130499), // Rule ID 3273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3273,
        GIR_EraseRootFromParent_Done,
      // Label 1902: @130499
      GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(130554), // Rule ID 3290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v4f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3290,
        GIR_EraseRootFromParent_Done,
      // Label 1903: @130554
      GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(130608), // Rule ID 3258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3258,
        GIR_EraseRootFromParent_Done,
      // Label 1904: @130608
      GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(130662), // Rule ID 3259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3259,
        GIR_EraseRootFromParent_Done,
      // Label 1905: @130662
      GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(130716), // Rule ID 3260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3260,
        GIR_EraseRootFromParent_Done,
      // Label 1906: @130716
      GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(130773), // Rule ID 3261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3261,
        GIR_EraseRootFromParent_Done,
      // Label 1907: @130773
      GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(130827), // Rule ID 3275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3275,
        GIR_EraseRootFromParent_Done,
      // Label 1908: @130827
      GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(130881), // Rule ID 3276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3276,
        GIR_EraseRootFromParent_Done,
      // Label 1909: @130881
      GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(130935), // Rule ID 3277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3277,
        GIR_EraseRootFromParent_Done,
      // Label 1910: @130935
      GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(130992), // Rule ID 3278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3278,
        GIR_EraseRootFromParent_Done,
      // Label 1911: @130992
      GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(131042), // Rule ID 3264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3264,
        GIR_EraseRootFromParent_Done,
      // Label 1912: @131042
      GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(131092), // Rule ID 3265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3265,
        GIR_EraseRootFromParent_Done,
      // Label 1913: @131092
      GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(131145), // Rule ID 3266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3266,
        GIR_EraseRootFromParent_Done,
      // Label 1914: @131145
      GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(131195), // Rule ID 3281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3281,
        GIR_EraseRootFromParent_Done,
      // Label 1915: @131195
      GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(131245), // Rule ID 3282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3282,
        GIR_EraseRootFromParent_Done,
      // Label 1916: @131245
      GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(131298), // Rule ID 3283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3283,
        GIR_EraseRootFromParent_Done,
      // Label 1917: @131298
      GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(131345), // Rule ID 3269 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3269,
        GIR_EraseRootFromParent_Done,
      // Label 1918: @131345
      GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(131395), // Rule ID 3270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v4i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3270,
        GIR_EraseRootFromParent_Done,
      // Label 1919: @131395
      GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(131445), // Rule ID 3271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3271,
        GIR_EraseRootFromParent_Done,
      // Label 1920: @131445
      GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(131498), // Rule ID 3272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3272,
        GIR_EraseRootFromParent_Done,
      // Label 1921: @131498
      GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(131545), // Rule ID 3286 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v4f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3286,
        GIR_EraseRootFromParent_Done,
      // Label 1922: @131545
      GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(131595), // Rule ID 3287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v4f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3287,
        GIR_EraseRootFromParent_Done,
      // Label 1923: @131595
      GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(131645), // Rule ID 3288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3288,
        GIR_EraseRootFromParent_Done,
      // Label 1924: @131645
      GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(131698), // Rule ID 3289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v4f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v4f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3289,
        GIR_EraseRootFromParent_Done,
      // Label 1925: @131698
      GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(131744), // Rule ID 3263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3263,
        GIR_EraseRootFromParent_Done,
      // Label 1926: @131744
      GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(131790), // Rule ID 3280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3280,
        GIR_EraseRootFromParent_Done,
      // Label 1927: @131790
      GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(131832), // Rule ID 3268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3268,
        GIR_EraseRootFromParent_Done,
      // Label 1928: @131832
      GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(131874), // Rule ID 3285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3285,
        GIR_EraseRootFromParent_Done,
      // Label 1929: @131874
      GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(131913), // Rule ID 3274 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v4i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3274,
        GIR_EraseRootFromParent_Done,
      // Label 1930: @131913
      GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(131952), // Rule ID 3291 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v4f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v4f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3291,
        GIR_EraseRootFromParent_Done,
      // Label 1931: @131952
      GIM_Reject,
    // Label 1897: @131953
    GIM_Reject,
    // Label 962: @131954
    GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(132021), // Rule ID 3177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3177,
      GIR_EraseRootFromParent_Done,
    // Label 1932: @132021
    GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(132088), // Rule ID 3194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3194,
      GIR_EraseRootFromParent_Done,
    // Label 1933: @132088
    GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(132155), // Rule ID 3211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3211,
      GIR_EraseRootFromParent_Done,
    // Label 1934: @132155
    GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(132218), // Rule ID 3182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3182,
      GIR_EraseRootFromParent_Done,
    // Label 1935: @132218
    GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(132281), // Rule ID 3199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3199,
      GIR_EraseRootFromParent_Done,
    // Label 1936: @132281
    GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(132344), // Rule ID 3216 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3216,
      GIR_EraseRootFromParent_Done,
    // Label 1937: @132344
    GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(132407), // Rule ID 3188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3188,
      GIR_EraseRootFromParent_Done,
    // Label 1938: @132407
    GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(132470), // Rule ID 3205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3205,
      GIR_EraseRootFromParent_Done,
    // Label 1939: @132470
    GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(132533), // Rule ID 3222 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[v8bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3222,
      GIR_EraseRootFromParent_Done,
    // Label 1940: @132533
    GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(132595), // Rule ID 3173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3173,
      GIR_EraseRootFromParent_Done,
    // Label 1941: @132595
    GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(132657), // Rule ID 3174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3174,
      GIR_EraseRootFromParent_Done,
    // Label 1942: @132657
    GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(132719), // Rule ID 3175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3175,
      GIR_EraseRootFromParent_Done,
    // Label 1943: @132719
    GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(132784), // Rule ID 3176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3176,
      GIR_EraseRootFromParent_Done,
    // Label 1944: @132784
    GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(132846), // Rule ID 3190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3190,
      GIR_EraseRootFromParent_Done,
    // Label 1945: @132846
    GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(132908), // Rule ID 3191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3191,
      GIR_EraseRootFromParent_Done,
    // Label 1946: @132908
    GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(132970), // Rule ID 3192 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3192,
      GIR_EraseRootFromParent_Done,
    // Label 1947: @132970
    GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(133035), // Rule ID 3193 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3193,
      GIR_EraseRootFromParent_Done,
    // Label 1948: @133035
    GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(133097), // Rule ID 3207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3207,
      GIR_EraseRootFromParent_Done,
    // Label 1949: @133097
    GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(133159), // Rule ID 3208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3208,
      GIR_EraseRootFromParent_Done,
    // Label 1950: @133159
    GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(133221), // Rule ID 3209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3209,
      GIR_EraseRootFromParent_Done,
    // Label 1951: @133221
    GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(133286), // Rule ID 3210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3210,
      GIR_EraseRootFromParent_Done,
    // Label 1952: @133286
    GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(133344), // Rule ID 3179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3179,
      GIR_EraseRootFromParent_Done,
    // Label 1953: @133344
    GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(133402), // Rule ID 3180 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3180,
      GIR_EraseRootFromParent_Done,
    // Label 1954: @133402
    GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(133463), // Rule ID 3181 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3181,
      GIR_EraseRootFromParent_Done,
    // Label 1955: @133463
    GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(133521), // Rule ID 3196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3196,
      GIR_EraseRootFromParent_Done,
    // Label 1956: @133521
    GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(133579), // Rule ID 3197 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3197,
      GIR_EraseRootFromParent_Done,
    // Label 1957: @133579
    GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(133640), // Rule ID 3198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3198,
      GIR_EraseRootFromParent_Done,
    // Label 1958: @133640
    GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(133698), // Rule ID 3213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3213,
      GIR_EraseRootFromParent_Done,
    // Label 1959: @133698
    GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(133756), // Rule ID 3214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_ec:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3214,
      GIR_EraseRootFromParent_Done,
    // Label 1960: @133756
    GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(133817), // Rule ID 3215 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM_ec:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3215,
      GIR_EraseRootFromParent_Done,
    // Label 1961: @133817
    GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(133885), // Rule ID 8200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8200,
      GIR_EraseRootFromParent_Done,
    // Label 1962: @133885
    GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(133953), // Rule ID 8204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8204,
      GIR_EraseRootFromParent_Done,
    // Label 1963: @133953
    GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(134021), // Rule ID 8208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align_less_than_4_local_m0>>  =>  (DS_READ_B128:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8208,
      GIR_EraseRootFromParent_Done,
    // Label 1964: @134021
    GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(134084), // Rule ID 8124 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8124,
      GIR_EraseRootFromParent_Done,
    // Label 1965: @134084
    GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(134147), // Rule ID 8128 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8128,
      GIR_EraseRootFromParent_Done,
    // Label 1966: @134147
    GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(134210), // Rule ID 8132 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[v8bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>><<P:Predicate_load_align16_local_m0>>  =>  (DS_READ_B128:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8132,
      GIR_EraseRootFromParent_Done,
    // Label 1967: @134210
    GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(134265), // Rule ID 3184 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3184,
      GIR_EraseRootFromParent_Done,
    // Label 1968: @134265
    GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(134323), // Rule ID 3185 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3185,
      GIR_EraseRootFromParent_Done,
    // Label 1969: @134323
    GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(134381), // Rule ID 3186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3186,
      GIR_EraseRootFromParent_Done,
    // Label 1970: @134381
    GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(134442), // Rule ID 3187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3187,
      GIR_EraseRootFromParent_Done,
    // Label 1971: @134442
    GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(134497), // Rule ID 3201 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3201,
      GIR_EraseRootFromParent_Done,
    // Label 1972: @134497
    GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(134555), // Rule ID 3202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3202,
      GIR_EraseRootFromParent_Done,
    // Label 1973: @134555
    GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(134613), // Rule ID 3203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3203,
      GIR_EraseRootFromParent_Done,
    // Label 1974: @134613
    GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(134674), // Rule ID 3204 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3204,
      GIR_EraseRootFromParent_Done,
    // Label 1975: @134674
    GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(134729), // Rule ID 3218 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[v8bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3218,
      GIR_EraseRootFromParent_Done,
    // Label 1976: @134729
    GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(134787), // Rule ID 3219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
      // (ld:{ *:[v8bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ci:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ci),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3219,
      GIR_EraseRootFromParent_Done,
    // Label 1977: @134787
    GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(134845), // Rule ID 3220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3220,
      GIR_EraseRootFromParent_Done,
    // Label 1978: @134845
    GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(134906), // Rule ID 3221 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[v8bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_SGPR_IMM:{ *:[v8bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3221,
      GIR_EraseRootFromParent_Done,
    // Label 1979: @134906
    GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(134970), // Rule ID 8201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8201,
      GIR_EraseRootFromParent_Done,
    // Label 1980: @134970
    GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(135034), // Rule ID 8205 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8205,
      GIR_EraseRootFromParent_Done,
    // Label 1981: @135034
    GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(135098), // Rule ID 8209 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_load_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align_less_than_4_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8209,
      GIR_EraseRootFromParent_Done,
    // Label 1982: @135098
    GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(135157), // Rule ID 8125 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8125,
      GIR_EraseRootFromParent_Done,
    // Label 1983: @135157
    GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(135216), // Rule ID 8129 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8129,
      GIR_EraseRootFromParent_Done,
    // Label 1984: @135216
    GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(135275), // Rule ID 8133 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[v8bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_local>><<P:Predicate_load_align16_local>>  =>  (DS_READ_B128_gfx9:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B128_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8133,
      GIR_EraseRootFromParent_Done,
    // Label 1985: @135275
    GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(135329), // Rule ID 3178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3178,
      GIR_EraseRootFromParent_Done,
    // Label 1986: @135329
    GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(135383), // Rule ID 3195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3195,
      GIR_EraseRootFromParent_Done,
    // Label 1987: @135383
    GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(135437), // Rule ID 3212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
      // (ld:{ *:[v8bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3212,
      GIR_EraseRootFromParent_Done,
    // Label 1988: @135437
    GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(135487), // Rule ID 3183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3183,
      GIR_EraseRootFromParent_Done,
    // Label 1989: @135487
    GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(135537), // Rule ID 3200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3200,
      GIR_EraseRootFromParent_Done,
    // Label 1990: @135537
    GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(135587), // Rule ID 3217 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM_ec:{ *:[v8bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM_ec),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3217,
      GIR_EraseRootFromParent_Done,
    // Label 1991: @135587
    GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(135634), // Rule ID 3189 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3189,
      GIR_EraseRootFromParent_Done,
    // Label 1992: @135634
    GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(135681), // Rule ID 3206 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3206,
      GIR_EraseRootFromParent_Done,
    // Label 1993: @135681
    GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(135728), // Rule ID 3223 //
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      // (ld:{ *:[v8bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX4_IMM:{ *:[v8bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX4_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3223,
      GIR_EraseRootFromParent_Done,
    // Label 1994: @135728
    GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(135788), // Rule ID 4322 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v8i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4322,
      GIR_EraseRootFromParent_Done,
    // Label 1995: @135788
    GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(135848), // Rule ID 4328 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v8f16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4328,
      GIR_EraseRootFromParent_Done,
    // Label 1996: @135848
    GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(135908), // Rule ID 4334 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[v8bf16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SVS:{ *:[v8bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4334,
      GIR_EraseRootFromParent_Done,
    // Label 1997: @135908
    GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(135963), // Rule ID 4321 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v8i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4321,
      GIR_EraseRootFromParent_Done,
    // Label 1998: @135963
    GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(136018), // Rule ID 4327 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v8f16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4327,
      GIR_EraseRootFromParent_Done,
    // Label 1999: @136018
    GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(136073), // Rule ID 4333 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[v8bf16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4_SADDR:{ *:[v8bf16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4333,
      GIR_EraseRootFromParent_Done,
    // Label 2000: @136073
    GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(136128), // Rule ID 4320 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v8i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4320,
      GIR_EraseRootFromParent_Done,
    // Label 2001: @136128
    GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(136183), // Rule ID 4326 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v8f16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4326,
      GIR_EraseRootFromParent_Done,
    // Label 2002: @136183
    GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(136238), // Rule ID 4332 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[v8bf16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_private>>  =>  (SCRATCH_LOAD_DWORDX4:{ *:[v8bf16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4332,
      GIR_EraseRootFromParent_Done,
    // Label 2003: @136238
    GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(136308), // Rule ID 4555 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4555,
      GIR_EraseRootFromParent_Done,
    // Label 2004: @136308
    GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(136375), // Rule ID 4557 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8i16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8i16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4557,
      GIR_EraseRootFromParent_Done,
    // Label 2005: @136375
    GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(136445), // Rule ID 4559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4559,
      GIR_EraseRootFromParent_Done,
    // Label 2006: @136445
    GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(136512), // Rule ID 4561 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8f16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8f16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4561,
      GIR_EraseRootFromParent_Done,
    // Label 2007: @136512
    GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(136582), // Rule ID 4563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_ADDR64:{ *:[v8bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4563,
      GIR_EraseRootFromParent_Done,
    // Label 2008: @136582
    GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(136649), // Rule ID 4565 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[v8bf16] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64:{ *:[v8bf16] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4565,
      GIR_EraseRootFromParent_Done,
    // Label 2009: @136649
    GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(136713), // Rule ID 8048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8048,
      GIR_EraseRootFromParent_Done,
    // Label 2010: @136713
    GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(136777), // Rule ID 8052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8052,
      GIR_EraseRootFromParent_Done,
    // Label 2011: @136777
    GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(136841), // Rule ID 8056 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUld_glue:{ *:[v8bf16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload_glue>><<P:Predicate_load_glue>><<P:Predicate_load_local_m0>>  =>  (DS_READ2_B64:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8056,
      GIR_EraseRootFromParent_Done,
    // Label 2012: @136841
    GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(136906), // Rule ID 4554 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4554,
      GIR_EraseRootFromParent_Done,
    // Label 2013: @136906
    GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(136968), // Rule ID 4556 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4556,
      GIR_EraseRootFromParent_Done,
    // Label 2014: @136968
    GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(137033), // Rule ID 4558 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4558,
      GIR_EraseRootFromParent_Done,
    // Label 2015: @137033
    GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(137095), // Rule ID 4560 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8f16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4560,
      GIR_EraseRootFromParent_Done,
    // Label 2016: @137095
    GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(137160), // Rule ID 4562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4562,
      GIR_EraseRootFromParent_Done,
    // Label 2017: @137160
    GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(137222), // Rule ID 4564 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[v8bf16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4564,
      GIR_EraseRootFromParent_Done,
    // Label 2018: @137222
    GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(137282), // Rule ID 8050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v8i16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8i16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8050,
      GIR_EraseRootFromParent_Done,
    // Label 2019: @137282
    GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(137342), // Rule ID 8054 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v8f16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8f16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8054,
      GIR_EraseRootFromParent_Done,
    // Label 2020: @137342
    GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(137402), // Rule ID 8058 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (ld:{ *:[v8bf16] } (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedload>><<P:Predicate_load_local>>  =>  (DS_READ2_B64_gfx9:{ *:[v8bf16] } ?:{ *:[i32] }:$ptr, ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ2_B64_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8058,
      GIR_EraseRootFromParent_Done,
    // Label 2021: @137402
    GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(137464), // Rule ID 3908 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v8i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3908,
      GIR_EraseRootFromParent_Done,
    // Label 2022: @137464
    GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(137526), // Rule ID 3912 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v8f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3912,
      GIR_EraseRootFromParent_Done,
    // Label 2023: @137526
    GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(137588), // Rule ID 3916 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[v8bf16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4_SADDR:{ *:[v8bf16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3916,
      GIR_EraseRootFromParent_Done,
    // Label 2024: @137588
    GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(137645), // Rule ID 3907 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v8i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3907,
      GIR_EraseRootFromParent_Done,
    // Label 2025: @137645
    GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(137702), // Rule ID 3911 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v8f16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3911,
      GIR_EraseRootFromParent_Done,
    // Label 2026: @137702
    GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(137759), // Rule ID 3915 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[v8bf16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_global>>  =>  (GLOBAL_LOAD_DWORDX4:{ *:[v8bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3915,
      GIR_EraseRootFromParent_Done,
    // Label 2027: @137759
    GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(137817), // Rule ID 3625 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v8i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3625,
      GIR_EraseRootFromParent_Done,
    // Label 2028: @137817
    GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(137875), // Rule ID 3627 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v8f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3627,
      GIR_EraseRootFromParent_Done,
    // Label 2029: @137875
    GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(137933), // Rule ID 3629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[v8bf16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load_flat>>  =>  (FLAT_LOAD_DWORDX4:{ *:[v8bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3629,
      GIR_EraseRootFromParent_Done,
    // Label 2030: @137933
    GIM_Reject,
    // Label 963: @137934
    GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(139684),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(138006), // Rule ID 3228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3228,
        GIR_EraseRootFromParent_Done,
      // Label 2032: @138006
      GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(138065), // Rule ID 3245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3245,
        GIR_EraseRootFromParent_Done,
      // Label 2033: @138065
      GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(138120), // Rule ID 3233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3233,
        GIR_EraseRootFromParent_Done,
      // Label 2034: @138120
      GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(138175), // Rule ID 3250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3250,
        GIR_EraseRootFromParent_Done,
      // Label 2035: @138175
      GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(138230), // Rule ID 3239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3239,
        GIR_EraseRootFromParent_Done,
      // Label 2036: @138230
      GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(138285), // Rule ID 3256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3256,
        GIR_EraseRootFromParent_Done,
      // Label 2037: @138285
      GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(138339), // Rule ID 3224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3224,
        GIR_EraseRootFromParent_Done,
      // Label 2038: @138339
      GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(138393), // Rule ID 3225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3225,
        GIR_EraseRootFromParent_Done,
      // Label 2039: @138393
      GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(138447), // Rule ID 3226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3226,
        GIR_EraseRootFromParent_Done,
      // Label 2040: @138447
      GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(138504), // Rule ID 3227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3227,
        GIR_EraseRootFromParent_Done,
      // Label 2041: @138504
      GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(138558), // Rule ID 3241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3241,
        GIR_EraseRootFromParent_Done,
      // Label 2042: @138558
      GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(138612), // Rule ID 3242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3242,
        GIR_EraseRootFromParent_Done,
      // Label 2043: @138612
      GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(138666), // Rule ID 3243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3243,
        GIR_EraseRootFromParent_Done,
      // Label 2044: @138666
      GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(138723), // Rule ID 3244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3244,
        GIR_EraseRootFromParent_Done,
      // Label 2045: @138723
      GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(138773), // Rule ID 3230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3230,
        GIR_EraseRootFromParent_Done,
      // Label 2046: @138773
      GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(138823), // Rule ID 3231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3231,
        GIR_EraseRootFromParent_Done,
      // Label 2047: @138823
      GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(138876), // Rule ID 3232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3232,
        GIR_EraseRootFromParent_Done,
      // Label 2048: @138876
      GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(138926), // Rule ID 3247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3247,
        GIR_EraseRootFromParent_Done,
      // Label 2049: @138926
      GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(138976), // Rule ID 3248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3248,
        GIR_EraseRootFromParent_Done,
      // Label 2050: @138976
      GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(139029), // Rule ID 3249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3249,
        GIR_EraseRootFromParent_Done,
      // Label 2051: @139029
      GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(139076), // Rule ID 3235 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3235,
        GIR_EraseRootFromParent_Done,
      // Label 2052: @139076
      GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(139126), // Rule ID 3236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3236,
        GIR_EraseRootFromParent_Done,
      // Label 2053: @139126
      GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(139176), // Rule ID 3237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3237,
        GIR_EraseRootFromParent_Done,
      // Label 2054: @139176
      GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(139229), // Rule ID 3238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3238,
        GIR_EraseRootFromParent_Done,
      // Label 2055: @139229
      GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(139276), // Rule ID 3252 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3252,
        GIR_EraseRootFromParent_Done,
      // Label 2056: @139276
      GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(139326), // Rule ID 3253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3253,
        GIR_EraseRootFromParent_Done,
      // Label 2057: @139326
      GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(139376), // Rule ID 3254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3254,
        GIR_EraseRootFromParent_Done,
      // Label 2058: @139376
      GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(139429), // Rule ID 3255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3255,
        GIR_EraseRootFromParent_Done,
      // Label 2059: @139429
      GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(139475), // Rule ID 3229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3229,
        GIR_EraseRootFromParent_Done,
      // Label 2060: @139475
      GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(139521), // Rule ID 3246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3246,
        GIR_EraseRootFromParent_Done,
      // Label 2061: @139521
      GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(139563), // Rule ID 3234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3234,
        GIR_EraseRootFromParent_Done,
      // Label 2062: @139563
      GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(139605), // Rule ID 3251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3251,
        GIR_EraseRootFromParent_Done,
      // Label 2063: @139605
      GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(139644), // Rule ID 3240 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3240,
        GIR_EraseRootFromParent_Done,
      // Label 2064: @139644
      GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(139683), // Rule ID 3257 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v8f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3257,
        GIR_EraseRootFromParent_Done,
      // Label 2065: @139683
      GIM_Reject,
    // Label 2031: @139684
    GIM_Reject,
    // Label 964: @139685
    GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(141435),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(139757), // Rule ID 3381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3381,
        GIR_EraseRootFromParent_Done,
      // Label 2067: @139757
      GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(139816), // Rule ID 3398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3398,
        GIR_EraseRootFromParent_Done,
      // Label 2068: @139816
      GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(139871), // Rule ID 3386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3386,
        GIR_EraseRootFromParent_Done,
      // Label 2069: @139871
      GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(139926), // Rule ID 3403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3403,
        GIR_EraseRootFromParent_Done,
      // Label 2070: @139926
      GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(139981), // Rule ID 3392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8i64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3392,
        GIR_EraseRootFromParent_Done,
      // Label 2071: @139981
      GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(140036), // Rule ID 3409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v8f64] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3409,
        GIR_EraseRootFromParent_Done,
      // Label 2072: @140036
      GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(140090), // Rule ID 3377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3377,
        GIR_EraseRootFromParent_Done,
      // Label 2073: @140090
      GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(140144), // Rule ID 3378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3378,
        GIR_EraseRootFromParent_Done,
      // Label 2074: @140144
      GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(140198), // Rule ID 3379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3379,
        GIR_EraseRootFromParent_Done,
      // Label 2075: @140198
      GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(140255), // Rule ID 3380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3380,
        GIR_EraseRootFromParent_Done,
      // Label 2076: @140255
      GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(140309), // Rule ID 3394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3394,
        GIR_EraseRootFromParent_Done,
      // Label 2077: @140309
      GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(140363), // Rule ID 3395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3395,
        GIR_EraseRootFromParent_Done,
      // Label 2078: @140363
      GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(140417), // Rule ID 3396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3396,
        GIR_EraseRootFromParent_Done,
      // Label 2079: @140417
      GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(140474), // Rule ID 3397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3397,
        GIR_EraseRootFromParent_Done,
      // Label 2080: @140474
      GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(140524), // Rule ID 3383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3383,
        GIR_EraseRootFromParent_Done,
      // Label 2081: @140524
      GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(140574), // Rule ID 3384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3384,
        GIR_EraseRootFromParent_Done,
      // Label 2082: @140574
      GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(140627), // Rule ID 3385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3385,
        GIR_EraseRootFromParent_Done,
      // Label 2083: @140627
      GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(140677), // Rule ID 3400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3400,
        GIR_EraseRootFromParent_Done,
      // Label 2084: @140677
      GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(140727), // Rule ID 3401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3401,
        GIR_EraseRootFromParent_Done,
      // Label 2085: @140727
      GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(140780), // Rule ID 3402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3402,
        GIR_EraseRootFromParent_Done,
      // Label 2086: @140780
      GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(140827), // Rule ID 3388 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8i64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3388,
        GIR_EraseRootFromParent_Done,
      // Label 2087: @140827
      GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(140877), // Rule ID 3389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8i64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3389,
        GIR_EraseRootFromParent_Done,
      // Label 2088: @140877
      GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(140927), // Rule ID 3390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3390,
        GIR_EraseRootFromParent_Done,
      // Label 2089: @140927
      GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(140980), // Rule ID 3391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8i64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8i64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3391,
        GIR_EraseRootFromParent_Done,
      // Label 2090: @140980
      GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(141027), // Rule ID 3405 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v8f64] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3405,
        GIR_EraseRootFromParent_Done,
      // Label 2091: @141027
      GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(141077), // Rule ID 3406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v8f64] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3406,
        GIR_EraseRootFromParent_Done,
      // Label 2092: @141077
      GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(141127), // Rule ID 3407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3407,
        GIR_EraseRootFromParent_Done,
      // Label 2093: @141127
      GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(141180), // Rule ID 3408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v8f64] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v8f64] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3408,
        GIR_EraseRootFromParent_Done,
      // Label 2094: @141180
      GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(141226), // Rule ID 3382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3382,
        GIR_EraseRootFromParent_Done,
      // Label 2095: @141226
      GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(141272), // Rule ID 3399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3399,
        GIR_EraseRootFromParent_Done,
      // Label 2096: @141272
      GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(141314), // Rule ID 3387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3387,
        GIR_EraseRootFromParent_Done,
      // Label 2097: @141314
      GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(141356), // Rule ID 3404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3404,
        GIR_EraseRootFromParent_Done,
      // Label 2098: @141356
      GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(141395), // Rule ID 3393 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8i64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8i64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3393,
        GIR_EraseRootFromParent_Done,
      // Label 2099: @141395
      GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(141434), // Rule ID 3410 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v8f64] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v8f64] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3410,
        GIR_EraseRootFromParent_Done,
      // Label 2100: @141434
      GIM_Reject,
    // Label 2066: @141435
    GIM_Reject,
    // Label 965: @141436
    GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(144054),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(141508), // Rule ID 3296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3296,
        GIR_EraseRootFromParent_Done,
      // Label 2102: @141508
      GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(141567), // Rule ID 3313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3313,
        GIR_EraseRootFromParent_Done,
      // Label 2103: @141567
      GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(141626), // Rule ID 3330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3330,
        GIR_EraseRootFromParent_Done,
      // Label 2104: @141626
      GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(141681), // Rule ID 3301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3301,
        GIR_EraseRootFromParent_Done,
      // Label 2105: @141681
      GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(141736), // Rule ID 3318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3318,
        GIR_EraseRootFromParent_Done,
      // Label 2106: @141736
      GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(141791), // Rule ID 3335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3335,
        GIR_EraseRootFromParent_Done,
      // Label 2107: @141791
      GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(141846), // Rule ID 3307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3307,
        GIR_EraseRootFromParent_Done,
      // Label 2108: @141846
      GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(141901), // Rule ID 3324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3324,
        GIR_EraseRootFromParent_Done,
      // Label 2109: @141901
      GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(141956), // Rule ID 3341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3341,
        GIR_EraseRootFromParent_Done,
      // Label 2110: @141956
      GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(142010), // Rule ID 3292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3292,
        GIR_EraseRootFromParent_Done,
      // Label 2111: @142010
      GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(142064), // Rule ID 3293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3293,
        GIR_EraseRootFromParent_Done,
      // Label 2112: @142064
      GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(142118), // Rule ID 3294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3294,
        GIR_EraseRootFromParent_Done,
      // Label 2113: @142118
      GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(142175), // Rule ID 3295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3295,
        GIR_EraseRootFromParent_Done,
      // Label 2114: @142175
      GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(142229), // Rule ID 3309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3309,
        GIR_EraseRootFromParent_Done,
      // Label 2115: @142229
      GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(142283), // Rule ID 3310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3310,
        GIR_EraseRootFromParent_Done,
      // Label 2116: @142283
      GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(142337), // Rule ID 3311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3311,
        GIR_EraseRootFromParent_Done,
      // Label 2117: @142337
      GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(142394), // Rule ID 3312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3312,
        GIR_EraseRootFromParent_Done,
      // Label 2118: @142394
      GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(142448), // Rule ID 3326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3326,
        GIR_EraseRootFromParent_Done,
      // Label 2119: @142448
      GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(142502), // Rule ID 3327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3327,
        GIR_EraseRootFromParent_Done,
      // Label 2120: @142502
      GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(142556), // Rule ID 3328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3328,
        GIR_EraseRootFromParent_Done,
      // Label 2121: @142556
      GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(142613), // Rule ID 3329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3329,
        GIR_EraseRootFromParent_Done,
      // Label 2122: @142613
      GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(142663), // Rule ID 3298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3298,
        GIR_EraseRootFromParent_Done,
      // Label 2123: @142663
      GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(142713), // Rule ID 3299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3299,
        GIR_EraseRootFromParent_Done,
      // Label 2124: @142713
      GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(142766), // Rule ID 3300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3300,
        GIR_EraseRootFromParent_Done,
      // Label 2125: @142766
      GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(142816), // Rule ID 3315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3315,
        GIR_EraseRootFromParent_Done,
      // Label 2126: @142816
      GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(142866), // Rule ID 3316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3316,
        GIR_EraseRootFromParent_Done,
      // Label 2127: @142866
      GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(142919), // Rule ID 3317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3317,
        GIR_EraseRootFromParent_Done,
      // Label 2128: @142919
      GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(142969), // Rule ID 3332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3332,
        GIR_EraseRootFromParent_Done,
      // Label 2129: @142969
      GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(143019), // Rule ID 3333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_ec:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3333,
        GIR_EraseRootFromParent_Done,
      // Label 2130: @143019
      GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(143072), // Rule ID 3334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM_ec:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3334,
        GIR_EraseRootFromParent_Done,
      // Label 2131: @143072
      GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(143119), // Rule ID 3303 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3303,
        GIR_EraseRootFromParent_Done,
      // Label 2132: @143119
      GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(143169), // Rule ID 3304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3304,
        GIR_EraseRootFromParent_Done,
      // Label 2133: @143169
      GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(143219), // Rule ID 3305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3305,
        GIR_EraseRootFromParent_Done,
      // Label 2134: @143219
      GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(143272), // Rule ID 3306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3306,
        GIR_EraseRootFromParent_Done,
      // Label 2135: @143272
      GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(143319), // Rule ID 3320 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3320,
        GIR_EraseRootFromParent_Done,
      // Label 2136: @143319
      GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(143369), // Rule ID 3321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3321,
        GIR_EraseRootFromParent_Done,
      // Label 2137: @143369
      GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(143419), // Rule ID 3322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3322,
        GIR_EraseRootFromParent_Done,
      // Label 2138: @143419
      GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(143472), // Rule ID 3323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3323,
        GIR_EraseRootFromParent_Done,
      // Label 2139: @143472
      GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(143519), // Rule ID 3337 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3337,
        GIR_EraseRootFromParent_Done,
      // Label 2140: @143519
      GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(143569), // Rule ID 3338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ci:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3338,
        GIR_EraseRootFromParent_Done,
      // Label 2141: @143569
      GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(143619), // Rule ID 3339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3339,
        GIR_EraseRootFromParent_Done,
      // Label 2142: @143619
      GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(143672), // Rule ID 3340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_SGPR_IMM:{ *:[v16bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3340,
        GIR_EraseRootFromParent_Done,
      // Label 2143: @143672
      GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(143718), // Rule ID 3297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3297,
        GIR_EraseRootFromParent_Done,
      // Label 2144: @143718
      GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(143764), // Rule ID 3314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3314,
        GIR_EraseRootFromParent_Done,
      // Label 2145: @143764
      GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(143810), // Rule ID 3331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v16bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3331,
        GIR_EraseRootFromParent_Done,
      // Label 2146: @143810
      GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(143852), // Rule ID 3302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3302,
        GIR_EraseRootFromParent_Done,
      // Label 2147: @143852
      GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(143894), // Rule ID 3319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3319,
        GIR_EraseRootFromParent_Done,
      // Label 2148: @143894
      GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(143936), // Rule ID 3336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM_ec:{ *:[v16bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3336,
        GIR_EraseRootFromParent_Done,
      // Label 2149: @143936
      GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(143975), // Rule ID 3308 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3308,
        GIR_EraseRootFromParent_Done,
      // Label 2150: @143975
      GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(144014), // Rule ID 3325 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3325,
        GIR_EraseRootFromParent_Done,
      // Label 2151: @144014
      GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(144053), // Rule ID 3342 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX8_IMM:{ *:[v16bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3342,
        GIR_EraseRootFromParent_Done,
      // Label 2152: @144053
      GIM_Reject,
    // Label 2101: @144054
    GIM_Reject,
    // Label 966: @144055
    GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(145805),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(144127), // Rule ID 3347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3347,
        GIR_EraseRootFromParent_Done,
      // Label 2154: @144127
      GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(144186), // Rule ID 3364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3364,
        GIR_EraseRootFromParent_Done,
      // Label 2155: @144186
      GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(144241), // Rule ID 3352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3352,
        GIR_EraseRootFromParent_Done,
      // Label 2156: @144241
      GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(144296), // Rule ID 3369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3369,
        GIR_EraseRootFromParent_Done,
      // Label 2157: @144296
      GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(144351), // Rule ID 3358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3358,
        GIR_EraseRootFromParent_Done,
      // Label 2158: @144351
      GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(144406), // Rule ID 3375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v16f32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3375,
        GIR_EraseRootFromParent_Done,
      // Label 2159: @144406
      GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(144460), // Rule ID 3343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3343,
        GIR_EraseRootFromParent_Done,
      // Label 2160: @144460
      GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(144514), // Rule ID 3344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3344,
        GIR_EraseRootFromParent_Done,
      // Label 2161: @144514
      GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(144568), // Rule ID 3345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3345,
        GIR_EraseRootFromParent_Done,
      // Label 2162: @144568
      GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(144625), // Rule ID 3346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3346,
        GIR_EraseRootFromParent_Done,
      // Label 2163: @144625
      GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(144679), // Rule ID 3360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3360,
        GIR_EraseRootFromParent_Done,
      // Label 2164: @144679
      GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(144733), // Rule ID 3361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3361,
        GIR_EraseRootFromParent_Done,
      // Label 2165: @144733
      GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(144787), // Rule ID 3362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3362,
        GIR_EraseRootFromParent_Done,
      // Label 2166: @144787
      GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(144844), // Rule ID 3363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3363,
        GIR_EraseRootFromParent_Done,
      // Label 2167: @144844
      GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(144894), // Rule ID 3349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3349,
        GIR_EraseRootFromParent_Done,
      // Label 2168: @144894
      GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(144944), // Rule ID 3350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3350,
        GIR_EraseRootFromParent_Done,
      // Label 2169: @144944
      GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(144997), // Rule ID 3351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3351,
        GIR_EraseRootFromParent_Done,
      // Label 2170: @144997
      GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(145047), // Rule ID 3366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3366,
        GIR_EraseRootFromParent_Done,
      // Label 2171: @145047
      GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(145097), // Rule ID 3367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3367,
        GIR_EraseRootFromParent_Done,
      // Label 2172: @145097
      GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(145150), // Rule ID 3368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3368,
        GIR_EraseRootFromParent_Done,
      // Label 2173: @145150
      GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(145197), // Rule ID 3354 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3354,
        GIR_EraseRootFromParent_Done,
      // Label 2174: @145197
      GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(145247), // Rule ID 3355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16i32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3355,
        GIR_EraseRootFromParent_Done,
      // Label 2175: @145247
      GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(145297), // Rule ID 3356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3356,
        GIR_EraseRootFromParent_Done,
      // Label 2176: @145297
      GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(145350), // Rule ID 3357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3357,
        GIR_EraseRootFromParent_Done,
      // Label 2177: @145350
      GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(145397), // Rule ID 3371 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v16f32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3371,
        GIR_EraseRootFromParent_Done,
      // Label 2178: @145397
      GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(145447), // Rule ID 3372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v16f32] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3372,
        GIR_EraseRootFromParent_Done,
      // Label 2179: @145447
      GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(145497), // Rule ID 3373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3373,
        GIR_EraseRootFromParent_Done,
      // Label 2180: @145497
      GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(145550), // Rule ID 3374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v16f32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3374,
        GIR_EraseRootFromParent_Done,
      // Label 2181: @145550
      GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(145596), // Rule ID 3348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3348,
        GIR_EraseRootFromParent_Done,
      // Label 2182: @145596
      GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(145642), // Rule ID 3365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3365,
        GIR_EraseRootFromParent_Done,
      // Label 2183: @145642
      GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(145684), // Rule ID 3353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3353,
        GIR_EraseRootFromParent_Done,
      // Label 2184: @145684
      GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(145726), // Rule ID 3370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3370,
        GIR_EraseRootFromParent_Done,
      // Label 2185: @145726
      GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(145765), // Rule ID 3359 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3359,
        GIR_EraseRootFromParent_Done,
      // Label 2186: @145765
      GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(145804), // Rule ID 3376 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v16f32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v16f32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3376,
        GIR_EraseRootFromParent_Done,
      // Label 2187: @145804
      GIM_Reject,
    // Label 2153: @145805
    GIM_Reject,
    // Label 967: @145806
    GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(148424),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_load),
      GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(145878), // Rule ID 3415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3415,
        GIR_EraseRootFromParent_Done,
      // Label 2189: @145878
      GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(145937), // Rule ID 3432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3432,
        GIR_EraseRootFromParent_Done,
      // Label 2190: @145937
      GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(145996), // Rule ID 3449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3449,
        GIR_EraseRootFromParent_Done,
      // Label 2191: @145996
      GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(146051), // Rule ID 3420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3420,
        GIR_EraseRootFromParent_Done,
      // Label 2192: @146051
      GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(146106), // Rule ID 3437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3437,
        GIR_EraseRootFromParent_Done,
      // Label 2193: @146106
      GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(146161), // Rule ID 3454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3454,
        GIR_EraseRootFromParent_Done,
      // Label 2194: @146161
      GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(146216), // Rule ID 3426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32i16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3426,
        GIR_EraseRootFromParent_Done,
      // Label 2195: @146216
      GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(146271), // Rule ID 3443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32f16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3443,
        GIR_EraseRootFromParent_Done,
      // Label 2196: @146271
      GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(146326), // Rule ID 3460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
        // (ld:{ *:[v32bf16] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3460,
        GIR_EraseRootFromParent_Done,
      // Label 2197: @146326
      GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(146380), // Rule ID 3411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3411,
        GIR_EraseRootFromParent_Done,
      // Label 2198: @146380
      GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(146434), // Rule ID 3412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3412,
        GIR_EraseRootFromParent_Done,
      // Label 2199: @146434
      GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(146488), // Rule ID 3413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3413,
        GIR_EraseRootFromParent_Done,
      // Label 2200: @146488
      GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(146545), // Rule ID 3414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3414,
        GIR_EraseRootFromParent_Done,
      // Label 2201: @146545
      GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(146599), // Rule ID 3428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3428,
        GIR_EraseRootFromParent_Done,
      // Label 2202: @146599
      GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(146653), // Rule ID 3429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3429,
        GIR_EraseRootFromParent_Done,
      // Label 2203: @146653
      GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(146707), // Rule ID 3430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3430,
        GIR_EraseRootFromParent_Done,
      // Label 2204: @146707
      GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(146764), // Rule ID 3431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3431,
        GIR_EraseRootFromParent_Done,
      // Label 2205: @146764
      GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(146818), // Rule ID 3445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3445,
        GIR_EraseRootFromParent_Done,
      // Label 2206: @146818
      GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(146872), // Rule ID 3446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3446,
        GIR_EraseRootFromParent_Done,
      // Label 2207: @146872
      GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(146926), // Rule ID 3447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3447,
        GIR_EraseRootFromParent_Done,
      // Label 2208: @146926
      GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(146983), // Rule ID 3448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3448,
        GIR_EraseRootFromParent_Done,
      // Label 2209: @146983
      GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(147033), // Rule ID 3417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3417,
        GIR_EraseRootFromParent_Done,
      // Label 2210: @147033
      GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(147083), // Rule ID 3418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3418,
        GIR_EraseRootFromParent_Done,
      // Label 2211: @147083
      GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(147136), // Rule ID 3419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3419,
        GIR_EraseRootFromParent_Done,
      // Label 2212: @147136
      GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(147186), // Rule ID 3434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3434,
        GIR_EraseRootFromParent_Done,
      // Label 2213: @147186
      GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(147236), // Rule ID 3435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3435,
        GIR_EraseRootFromParent_Done,
      // Label 2214: @147236
      GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(147289), // Rule ID 3436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3436,
        GIR_EraseRootFromParent_Done,
      // Label 2215: @147289
      GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(147339), // Rule ID 3451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3451,
        GIR_EraseRootFromParent_Done,
      // Label 2216: @147339
      GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(147389), // Rule ID 3452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_ec:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3452,
        GIR_EraseRootFromParent_Done,
      // Label 2217: @147389
      GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(147442), // Rule ID 3453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM_ec:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3453,
        GIR_EraseRootFromParent_Done,
      // Label 2218: @147442
      GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(147489), // Rule ID 3422 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32i16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3422,
        GIR_EraseRootFromParent_Done,
      // Label 2219: @147489
      GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(147539), // Rule ID 3423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32i16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3423,
        GIR_EraseRootFromParent_Done,
      // Label 2220: @147539
      GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(147589), // Rule ID 3424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3424,
        GIR_EraseRootFromParent_Done,
      // Label 2221: @147589
      GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(147642), // Rule ID 3425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32i16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32i16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3425,
        GIR_EraseRootFromParent_Done,
      // Label 2222: @147642
      GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(147689), // Rule ID 3439 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32f16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3439,
        GIR_EraseRootFromParent_Done,
      // Label 2223: @147689
      GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(147739), // Rule ID 3440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32f16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3440,
        GIR_EraseRootFromParent_Done,
      // Label 2224: @147739
      GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(147789), // Rule ID 3441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3441,
        GIR_EraseRootFromParent_Done,
      // Label 2225: @147789
      GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(147842), // Rule ID 3442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32f16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32f16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3442,
        GIR_EraseRootFromParent_Done,
      // Label 2226: @147842
      GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(147889), // Rule ID 3456 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (ld:{ *:[v32bf16] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3456,
        GIR_EraseRootFromParent_Done,
      // Label 2227: @147889
      GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(147939), // Rule ID 3457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm32),
        // (ld:{ *:[v32bf16] } (SMRDImm32:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ci:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3457,
        GIR_EraseRootFromParent_Done,
      // Label 2228: @147939
      GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(147989), // Rule ID 3458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3458,
        GIR_EraseRootFromParent_Done,
      // Label 2229: @147989
      GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(148042), // Rule ID 3459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
        // (ld:{ *:[v32bf16] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_SGPR_IMM:{ *:[v32bf16] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3459,
        GIR_EraseRootFromParent_Done,
      // Label 2230: @148042
      GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(148088), // Rule ID 3416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3416,
        GIR_EraseRootFromParent_Done,
      // Label 2231: @148088
      GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(148134), // Rule ID 3433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3433,
        GIR_EraseRootFromParent_Done,
      // Label 2232: @148134
      GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(148180), // Rule ID 3450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_aligned_smrd_load),
        // (ld:{ *:[v32bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>><<P:Predicate_aligned_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3450,
        GIR_EraseRootFromParent_Done,
      // Label 2233: @148180
      GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(148222), // Rule ID 3421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3421,
        GIR_EraseRootFromParent_Done,
      // Label 2234: @148222
      GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(148264), // Rule ID 3438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3438,
        GIR_EraseRootFromParent_Done,
      // Label 2235: @148264
      GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(148306), // Rule ID 3455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXNACKEnabled),
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM_ec:{ *:[v32bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM_ec),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3455,
        GIR_EraseRootFromParent_Done,
      // Label 2236: @148306
      GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(148345), // Rule ID 3427 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32i16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32i16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3427,
        GIR_EraseRootFromParent_Done,
      // Label 2237: @148345
      GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(148384), // Rule ID 3444 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32f16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32f16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3444,
        GIR_EraseRootFromParent_Done,
      // Label 2238: @148384
      GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(148423), // Rule ID 3461 //
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (ld:{ *:[v32bf16] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_smrd_load>>  =>  (S_LOAD_DWORDX16_IMM:{ *:[v32bf16] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3461,
        GIR_EraseRootFromParent_Done,
      // Label 2239: @148423
      GIM_Reject,
    // Label 2188: @148424
    GIM_Reject,
    // Label 968: @148425
    GIM_Reject,
    // Label 15: @148426
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2242*/ GIMT_Encode4(154198),
    /*GILLT_s16*//*Label 2240*/ GIMT_Encode4(148445),
    /*GILLT_s32*//*Label 2241*/ GIMT_Encode4(149723),
    // Label 2240: @148445
    GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(149722),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(148520), // Rule ID 6499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
        // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6499,
        GIR_EraseRootFromParent_Done,
      // Label 2244: @148520
      GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(148583), // Rule ID 6501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
        // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6501,
        GIR_EraseRootFromParent_Done,
      // Label 2245: @148583
      GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(148643), // Rule ID 4169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
        // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4169,
        GIR_EraseRootFromParent_Done,
      // Label 2246: @148643
      GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(148698), // Rule ID 4168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
        // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4168,
        GIR_EraseRootFromParent_Done,
      // Label 2247: @148698
      GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(148753), // Rule ID 4167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
        // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4167,
        GIR_EraseRootFromParent_Done,
      // Label 2248: @148753
      GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(148821), // Rule ID 6498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
        // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6498,
        GIR_EraseRootFromParent_Done,
      // Label 2249: @148821
      GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(148889), // Rule ID 6500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
        // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6500,
        GIR_EraseRootFromParent_Done,
      // Label 2250: @148889
      GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(148953), // Rule ID 6470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6470,
        GIR_EraseRootFromParent_Done,
      // Label 2251: @148953
      GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(149017), // Rule ID 6471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6471,
        GIR_EraseRootFromParent_Done,
      // Label 2252: @149017
      GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(149082), // Rule ID 6476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6476,
        GIR_EraseRootFromParent_Done,
      // Label 2253: @149082
      GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(149147), // Rule ID 6477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6477,
        GIR_EraseRootFromParent_Done,
      // Label 2254: @149147
      GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(149202), // Rule ID 7878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7878,
        GIR_EraseRootFromParent_Done,
      // Label 2255: @149202
      GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(149257), // Rule ID 7879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7879,
        GIR_EraseRootFromParent_Done,
      // Label 2256: @149257
      GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(149312), // Rule ID 7924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7924,
        GIR_EraseRootFromParent_Done,
      // Label 2257: @149312
      GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(149367), // Rule ID 7925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7925,
        GIR_EraseRootFromParent_Done,
      // Label 2258: @149367
      GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(149429), // Rule ID 3790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3790,
        GIR_EraseRootFromParent_Done,
      // Label 2259: @149429
      GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(149491), // Rule ID 3802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3802,
        GIR_EraseRootFromParent_Done,
      // Label 2260: @149491
      GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(149548), // Rule ID 3789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3789,
        GIR_EraseRootFromParent_Done,
      // Label 2261: @149548
      GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(149605), // Rule ID 3801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3801,
        GIR_EraseRootFromParent_Done,
      // Label 2262: @149605
      GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(149663), // Rule ID 3564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3564,
        GIR_EraseRootFromParent_Done,
      // Label 2263: @149663
      GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(149721), // Rule ID 3567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3567,
        GIR_EraseRootFromParent_Done,
      // Label 2264: @149721
      GIM_Reject,
    // Label 2243: @149722
    GIM_Reject,
    // Label 2241: @149723
    GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(149789), // Rule ID 2819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2819,
      GIR_EraseRootFromParent_Done,
    // Label 2265: @149789
    GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(149855), // Rule ID 2831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2831,
      GIR_EraseRootFromParent_Done,
    // Label 2266: @149855
    GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(149916), // Rule ID 2817 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2817,
      GIR_EraseRootFromParent_Done,
    // Label 2267: @149916
    GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(149980), // Rule ID 2818 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2818,
      GIR_EraseRootFromParent_Done,
    // Label 2268: @149980
    GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(150041), // Rule ID 2829 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2829,
      GIR_EraseRootFromParent_Done,
    // Label 2269: @150041
    GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(150105), // Rule ID 2830 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2830,
      GIR_EraseRootFromParent_Done,
    // Label 2270: @150105
    GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(150158), // Rule ID 2820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi8),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_smrd_sextloadi8>>  =>  (S_LOAD_I8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2820,
      GIR_EraseRootFromParent_Done,
    // Label 2271: @150158
    GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(150211), // Rule ID 2832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_sextloadi16),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_smrd_sextloadi16>>  =>  (S_LOAD_I16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_I16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2832,
      GIR_EraseRootFromParent_Done,
    // Label 2272: @150211
    GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(150281), // Rule ID 6485 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6485,
      GIR_EraseRootFromParent_Done,
    // Label 2273: @150281
    GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(150351), // Rule ID 6489 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6489,
      GIR_EraseRootFromParent_Done,
    // Label 2274: @150351
    GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(150421), // Rule ID 6511 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6511,
      GIR_EraseRootFromParent_Done,
    // Label 2275: @150421
    GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(150491), // Rule ID 6513 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6513,
      GIR_EraseRootFromParent_Done,
    // Label 2276: @150491
    GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(150558), // Rule ID 4160 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4160,
      GIR_EraseRootFromParent_Done,
    // Label 2277: @150558
    GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(150625), // Rule ID 4178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4178,
      GIR_EraseRootFromParent_Done,
    // Label 2278: @150625
    GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(150687), // Rule ID 4159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4159,
      GIR_EraseRootFromParent_Done,
    // Label 2279: @150687
    GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(150749), // Rule ID 4177 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4177,
      GIR_EraseRootFromParent_Done,
    // Label 2280: @150749
    GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(150811), // Rule ID 4158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (SCRATCH_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4158,
      GIR_EraseRootFromParent_Done,
    // Label 2281: @150811
    GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(150873), // Rule ID 4176 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (SCRATCH_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_SSHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4176,
      GIR_EraseRootFromParent_Done,
    // Label 2282: @150873
    GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(150950), // Rule ID 4427 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4427,
      GIR_EraseRootFromParent_Done,
    // Label 2283: @150950
    GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(151024), // Rule ID 4429 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4429,
      GIR_EraseRootFromParent_Done,
    // Label 2284: @151024
    GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(151101), // Rule ID 4431 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4431,
      GIR_EraseRootFromParent_Done,
    // Label 2285: @151101
    GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(151175), // Rule ID 4433 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4433,
      GIR_EraseRootFromParent_Done,
    // Label 2286: @151175
    GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(151252), // Rule ID 4435 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4435,
      GIR_EraseRootFromParent_Done,
    // Label 2287: @151252
    GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(151326), // Rule ID 4437 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4437,
      GIR_EraseRootFromParent_Done,
    // Label 2288: @151326
    GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(151403), // Rule ID 4447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4447,
      GIR_EraseRootFromParent_Done,
    // Label 2289: @151403
    GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(151477), // Rule ID 4449 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4449,
      GIR_EraseRootFromParent_Done,
    // Label 2290: @151477
    GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(151554), // Rule ID 4451 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4451,
      GIR_EraseRootFromParent_Done,
    // Label 2291: @151554
    GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(151628), // Rule ID 4453 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4453,
      GIR_EraseRootFromParent_Done,
    // Label 2292: @151628
    GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(151704), // Rule ID 6462 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_constant>>  =>  (BUFFER_LOAD_SBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6462,
      GIR_EraseRootFromParent_Done,
    // Label 2293: @151704
    GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(151780), // Rule ID 6465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_constant>>  =>  (BUFFER_LOAD_SSHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6465,
      GIR_EraseRootFromParent_Done,
    // Label 2294: @151780
    GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(151855), // Rule ID 6484 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6484,
      GIR_EraseRootFromParent_Done,
    // Label 2295: @151855
    GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(151930), // Rule ID 6488 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_private>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6488,
      GIR_EraseRootFromParent_Done,
    // Label 2296: @151930
    GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(152005), // Rule ID 6510 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6510,
      GIR_EraseRootFromParent_Done,
    // Label 2297: @152005
    GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(152080), // Rule ID 6512 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_private>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6512,
      GIR_EraseRootFromParent_Done,
    // Label 2298: @152080
    GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(152152), // Rule ID 4426 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4426,
      GIR_EraseRootFromParent_Done,
    // Label 2299: @152152
    GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(152221), // Rule ID 4428 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4428,
      GIR_EraseRootFromParent_Done,
    // Label 2300: @152221
    GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(152293), // Rule ID 4430 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4430,
      GIR_EraseRootFromParent_Done,
    // Label 2301: @152293
    GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(152362), // Rule ID 4432 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4432,
      GIR_EraseRootFromParent_Done,
    // Label 2302: @152362
    GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(152434), // Rule ID 4434 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4434,
      GIR_EraseRootFromParent_Done,
    // Label 2303: @152434
    GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(152503), // Rule ID 4436 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4436,
      GIR_EraseRootFromParent_Done,
    // Label 2304: @152503
    GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(152575), // Rule ID 4446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4446,
      GIR_EraseRootFromParent_Done,
    // Label 2305: @152575
    GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(152644), // Rule ID 4448 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4448,
      GIR_EraseRootFromParent_Done,
    // Label 2306: @152644
    GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(152716), // Rule ID 4450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4450,
      GIR_EraseRootFromParent_Done,
    // Label 2307: @152716
    GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(152785), // Rule ID 4452 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4452,
      GIR_EraseRootFromParent_Done,
    // Label 2308: @152785
    GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(152847), // Rule ID 7876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi8_glue>><<P:Predicate_sextloadi8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7876,
      GIR_EraseRootFromParent_Done,
    // Label 2309: @152847
    GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(152909), // Rule ID 7877 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7877,
      GIR_EraseRootFromParent_Done,
    // Label 2310: @152909
    GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(152971), // Rule ID 7888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7888,
      GIR_EraseRootFromParent_Done,
    // Label 2311: @152971
    GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(153033), // Rule ID 7889 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7889,
      GIR_EraseRootFromParent_Done,
    // Label 2312: @153033
    GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(153095), // Rule ID 7890 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_sextload_glue>><<P:Predicate_sextloadi16_glue>><<P:Predicate_sextloadi16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7890,
      GIR_EraseRootFromParent_Done,
    // Label 2313: @153095
    GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(153157), // Rule ID 7891 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7891,
      GIR_EraseRootFromParent_Done,
    // Label 2314: @153157
    GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(153219), // Rule ID 7926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_8_glue>><<P:Predicate_atomic_load_sext_8_local_m0>>  =>  (DS_READ_I8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7926,
      GIR_EraseRootFromParent_Done,
    // Label 2315: @153219
    GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(153281), // Rule ID 7927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_local>>  =>  (DS_READ_I8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7927,
      GIR_EraseRootFromParent_Done,
    // Label 2316: @153281
    GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(153343), // Rule ID 7934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext_glue>><<P:Predicate_atomic_load_sext_16_glue>><<P:Predicate_atomic_load_sext_16_local_m0>>  =>  (DS_READ_I16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7934,
      GIR_EraseRootFromParent_Done,
    // Label 2317: @153343
    GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(153405), // Rule ID 7935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_local>>  =>  (DS_READ_I16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_I16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7935,
      GIR_EraseRootFromParent_Done,
    // Label 2318: @153405
    GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(153474), // Rule ID 3788 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3788,
      GIR_EraseRootFromParent_Done,
    // Label 2319: @153474
    GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(153543), // Rule ID 3796 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3796,
      GIR_EraseRootFromParent_Done,
    // Label 2320: @153543
    GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(153612), // Rule ID 3808 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3808,
      GIR_EraseRootFromParent_Done,
    // Label 2321: @153612
    GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(153681), // Rule ID 3810 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3810,
      GIR_EraseRootFromParent_Done,
    // Label 2322: @153681
    GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(153745), // Rule ID 3787 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3787,
      GIR_EraseRootFromParent_Done,
    // Label 2323: @153745
    GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(153809), // Rule ID 3795 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_global>>  =>  (GLOBAL_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3795,
      GIR_EraseRootFromParent_Done,
    // Label 2324: @153809
    GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(153873), // Rule ID 3807 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3807,
      GIR_EraseRootFromParent_Done,
    // Label 2325: @153873
    GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(153937), // Rule ID 3809 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_global>>  =>  (GLOBAL_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_SSHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3809,
      GIR_EraseRootFromParent_Done,
    // Label 2326: @153937
    GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(154002), // Rule ID 3562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>><<P:Predicate_sextloadi8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3562,
      GIR_EraseRootFromParent_Done,
    // Label 2327: @154002
    GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(154067), // Rule ID 3563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_atomic_load_sext_8_flat>>  =>  (FLAT_LOAD_SBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3563,
      GIR_EraseRootFromParent_Done,
    // Label 2328: @154067
    GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(154132), // Rule ID 3571 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>><<P:Predicate_sextloadi16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3571,
      GIR_EraseRootFromParent_Done,
    // Label 2329: @154132
    GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(154197), // Rule ID 3572 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_atomic_load_sext_16_flat>>  =>  (FLAT_LOAD_SSHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_SSHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3572,
      GIR_EraseRootFromParent_Done,
    // Label 2330: @154197
    GIM_Reject,
    // Label 2242: @154198
    GIM_Reject,
    // Label 16: @154199
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 2333*/ GIMT_Encode4(160020),
    /*GILLT_s16*//*Label 2331*/ GIMT_Encode4(154218),
    /*GILLT_s32*//*Label 2332*/ GIMT_Encode4(155828),
    // Label 2331: @154218
    GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(154288), // Rule ID 6507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6507,
      GIR_EraseRootFromParent_Done,
    // Label 2334: @154288
    GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(154358), // Rule ID 6509 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i16] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6509,
      GIR_EraseRootFromParent_Done,
    // Label 2335: @154358
    GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(154425), // Rule ID 4166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i16] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4166,
      GIR_EraseRootFromParent_Done,
    // Label 2336: @154425
    GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(154487), // Rule ID 4165 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i16] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4165,
      GIR_EraseRootFromParent_Done,
    // Label 2337: @154487
    GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(154549), // Rule ID 4164 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i16] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4164,
      GIR_EraseRootFromParent_Done,
    // Label 2338: @154549
    GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(154624), // Rule ID 6506 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6506,
      GIR_EraseRootFromParent_Done,
    // Label 2339: @154624
    GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(154699), // Rule ID 6508 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i16] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i16] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6508,
      GIR_EraseRootFromParent_Done,
    // Label 2340: @154699
    GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(154770), // Rule ID 6474 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6474,
      GIR_EraseRootFromParent_Done,
    // Label 2341: @154770
    GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(154841), // Rule ID 6475 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6475,
      GIR_EraseRootFromParent_Done,
    // Label 2342: @154841
    GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(154913), // Rule ID 6480 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6480,
      GIR_EraseRootFromParent_Done,
    // Label 2343: @154913
    GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(154985), // Rule ID 6481 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i16] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i16] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6481,
      GIR_EraseRootFromParent_Done,
    // Label 2344: @154985
    GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(155047), // Rule ID 7886 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7886,
      GIR_EraseRootFromParent_Done,
    // Label 2345: @155047
    GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(155109), // Rule ID 7887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7887,
      GIR_EraseRootFromParent_Done,
    // Label 2346: @155109
    GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(155171), // Rule ID 7920 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7920,
      GIR_EraseRootFromParent_Done,
    // Label 2347: @155171
    GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(155233), // Rule ID 7921 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7921,
      GIR_EraseRootFromParent_Done,
    // Label 2348: @155233
    GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(155302), // Rule ID 3778 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3778,
      GIR_EraseRootFromParent_Done,
    // Label 2349: @155302
    GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(155371), // Rule ID 3786 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3786,
      GIR_EraseRootFromParent_Done,
    // Label 2350: @155371
    GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(155440), // Rule ID 3800 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3800,
      GIR_EraseRootFromParent_Done,
    // Label 2351: @155440
    GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(155504), // Rule ID 3777 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3777,
      GIR_EraseRootFromParent_Done,
    // Label 2352: @155504
    GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(155568), // Rule ID 3785 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3785,
      GIR_EraseRootFromParent_Done,
    // Label 2353: @155568
    GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(155632), // Rule ID 3799 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i16] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3799,
      GIR_EraseRootFromParent_Done,
    // Label 2354: @155632
    GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(155697), // Rule ID 3555 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3555,
      GIR_EraseRootFromParent_Done,
    // Label 2355: @155697
    GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(155762), // Rule ID 3559 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3559,
      GIR_EraseRootFromParent_Done,
    // Label 2356: @155762
    GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(155827), // Rule ID 3566 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3566,
      GIR_EraseRootFromParent_Done,
    // Label 2357: @155827
    GIM_Reject,
    // Label 2332: @155828
    GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(155894), // Rule ID 2815 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2815,
      GIR_EraseRootFromParent_Done,
    // Label 2358: @155894
    GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(155960), // Rule ID 2827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr_imm),
      // (ld:{ *:[i32] } (SMRDSgprImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2827,
      GIR_EraseRootFromParent_Done,
    // Label 2359: @155960
    GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(156021), // Rule ID 2813 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2813,
      GIR_EraseRootFromParent_Done,
    // Label 2360: @156021
    GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(156085), // Rule ID 2814 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2814,
      GIR_EraseRootFromParent_Done,
    // Label 2361: @156085
    GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(156146), // Rule ID 2825 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
      // (ld:{ *:[i32] } (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2825,
      GIR_EraseRootFromParent_Done,
    // Label 2362: @156146
    GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(156210), // Rule ID 2826 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_sgpr),
      // (ld:{ *:[i32] } (SMRDSgpr:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$soffset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_SGPR_IMM:{ *:[i32] } ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$soffset, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_SGPR_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2826,
      GIR_EraseRootFromParent_Done,
    // Label 2363: @156210
    GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(156263), // Rule ID 2816 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi8),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_smrd_zextloadi8>>  =>  (S_LOAD_U8_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U8_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2816,
      GIR_EraseRootFromParent_Done,
    // Label 2364: @156263
    GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(156316), // Rule ID 2828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      // MIs[0] sbase
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_zextloadi16),
      // (ld:{ *:[i32] } SReg_64:{ *:[i64] }:$sbase)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_smrd_zextloadi16>>  =>  (S_LOAD_U16_IMM:{ *:[i32] } i64:{ *:[i64] }:$sbase, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LOAD_U16_IMM),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // sbase
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2828,
      GIR_EraseRootFromParent_Done,
    // Label 2365: @156316
    GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(156386), // Rule ID 6495 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6495,
      GIR_EraseRootFromParent_Done,
    // Label 2366: @156386
    GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(156456), // Rule ID 6497 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6497,
      GIR_EraseRootFromParent_Done,
    // Label 2367: @156456
    GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(156526), // Rule ID 6519 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6519,
      GIR_EraseRootFromParent_Done,
    // Label 2368: @156526
    GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(156596), // Rule ID 6521 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (ld:{ *:[i32] } (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6521,
      GIR_EraseRootFromParent_Done,
    // Label 2369: @156596
    GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(156663), // Rule ID 4157 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4157,
      GIR_EraseRootFromParent_Done,
    // Label 2370: @156663
    GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(156730), // Rule ID 4175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (ld:{ *:[i32] } (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SVS:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4175,
      GIR_EraseRootFromParent_Done,
    // Label 2371: @156730
    GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(156792), // Rule ID 4156 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4156,
      GIR_EraseRootFromParent_Done,
    // Label 2372: @156792
    GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(156854), // Rule ID 4174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (ld:{ *:[i32] } (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4174,
      GIR_EraseRootFromParent_Done,
    // Label 2373: @156854
    GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(156916), // Rule ID 4155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (SCRATCH_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4155,
      GIR_EraseRootFromParent_Done,
    // Label 2374: @156916
    GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(156978), // Rule ID 4173 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (ld:{ *:[i32] } (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (SCRATCH_LOAD_USHORT:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4173,
      GIR_EraseRootFromParent_Done,
    // Label 2375: @156978
    GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(157055), // Rule ID 4399 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4399,
      GIR_EraseRootFromParent_Done,
    // Label 2376: @157055
    GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(157129), // Rule ID 4401 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4401,
      GIR_EraseRootFromParent_Done,
    // Label 2377: @157129
    GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(157206), // Rule ID 4407 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4407,
      GIR_EraseRootFromParent_Done,
    // Label 2378: @157206
    GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(157280), // Rule ID 4409 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_load:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4409,
      GIR_EraseRootFromParent_Done,
    // Label 2379: @157280
    GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(157357), // Rule ID 4423 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4423,
      GIR_EraseRootFromParent_Done,
    // Label 2380: @157357
    GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(157431), // Rule ID 4425 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4425,
      GIR_EraseRootFromParent_Done,
    // Label 2381: @157431
    GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(157508), // Rule ID 4443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4443,
      GIR_EraseRootFromParent_Done,
    // Label 2382: @157508
    GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(157582), // Rule ID 4445 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_ADDR64:{ *:[i32] } i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4445,
      GIR_EraseRootFromParent_Done,
    // Label 2383: @157582
    GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(157658), // Rule ID 6464 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_constant>>  =>  (BUFFER_LOAD_UBYTE_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6464,
      GIR_EraseRootFromParent_Done,
    // Label 2384: @157658
    GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(157734), // Rule ID 6467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (ld:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_constant>>  =>  (BUFFER_LOAD_USHORT_ADDR64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6467,
      GIR_EraseRootFromParent_Done,
    // Label 2385: @157734
    GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(157809), // Rule ID 6494 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6494,
      GIR_EraseRootFromParent_Done,
    // Label 2386: @157809
    GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(157884), // Rule ID 6496 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_private>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6496,
      GIR_EraseRootFromParent_Done,
    // Label 2387: @157884
    GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(157959), // Rule ID 6518 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6518,
      GIR_EraseRootFromParent_Done,
    // Label 2388: @157959
    GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(158034), // Rule ID 6520 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (ld:{ *:[i32] } (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_private>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6520,
      GIR_EraseRootFromParent_Done,
    // Label 2389: @158034
    GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(158106), // Rule ID 4398 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4398,
      GIR_EraseRootFromParent_Done,
    // Label 2390: @158106
    GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(158175), // Rule ID 4400 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4400,
      GIR_EraseRootFromParent_Done,
    // Label 2391: @158175
    GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(158247), // Rule ID 4406 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4406,
      GIR_EraseRootFromParent_Done,
    // Label 2392: @158247
    GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(158316), // Rule ID 4408 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (atomic_load:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4408,
      GIR_EraseRootFromParent_Done,
    // Label 2393: @158316
    GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(158388), // Rule ID 4422 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4422,
      GIR_EraseRootFromParent_Done,
    // Label 2394: @158388
    GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(158457), // Rule ID 4424 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4424,
      GIR_EraseRootFromParent_Done,
    // Label 2395: @158457
    GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(158529), // Rule ID 4442 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4442,
      GIR_EraseRootFromParent_Done,
    // Label 2396: @158529
    GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(158598), // Rule ID 4444 //
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (ld:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4444,
      GIR_EraseRootFromParent_Done,
    // Label 2397: @158598
    GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(158660), // Rule ID 7882 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi8_glue>><<P:Predicate_zextloadi8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7882,
      GIR_EraseRootFromParent_Done,
    // Label 2398: @158660
    GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(158722), // Rule ID 7883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7883,
      GIR_EraseRootFromParent_Done,
    // Label 2399: @158722
    GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(158784), // Rule ID 7894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload_glue>><<P:Predicate_zextload_glue>><<P:Predicate_zextloadi16_glue>><<P:Predicate_zextloadi16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7894,
      GIR_EraseRootFromParent_Done,
    // Label 2400: @158784
    GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(158846), // Rule ID 7895 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (ld:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7895,
      GIR_EraseRootFromParent_Done,
    // Label 2401: @158846
    GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(158908), // Rule ID 7922 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_8_glue>><<P:Predicate_atomic_load_zext_8_local_m0>>  =>  (DS_READ_U8:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7922,
      GIR_EraseRootFromParent_Done,
    // Label 2402: @158908
    GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(158970), // Rule ID 7923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_local>>  =>  (DS_READ_U8_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U8_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7923,
      GIR_EraseRootFromParent_Done,
    // Label 2403: @158970
    GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(159032), // Rule ID 7932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_ld_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext_glue>><<P:Predicate_atomic_load_zext_16_glue>><<P:Predicate_atomic_load_zext_16_local_m0>>  =>  (DS_READ_U16:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7932,
      GIR_EraseRootFromParent_Done,
    // Label 2404: @159032
    GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(159094), // Rule ID 7933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_load:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_local>>  =>  (DS_READ_U16_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_U16_gfx9),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7933,
      GIR_EraseRootFromParent_Done,
    // Label 2405: @159094
    GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(159163), // Rule ID 3776 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3776,
      GIR_EraseRootFromParent_Done,
    // Label 2406: @159163
    GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(159232), // Rule ID 3784 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3784,
      GIR_EraseRootFromParent_Done,
    // Label 2407: @159232
    GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(159301), // Rule ID 3794 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3794,
      GIR_EraseRootFromParent_Done,
    // Label 2408: @159301
    GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(159370), // Rule ID 3806 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (ld:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3806,
      GIR_EraseRootFromParent_Done,
    // Label 2409: @159370
    GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(159439), // Rule ID 3812 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_load:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3812,
      GIR_EraseRootFromParent_Done,
    // Label 2410: @159439
    GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(159503), // Rule ID 3775 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3775,
      GIR_EraseRootFromParent_Done,
    // Label 2411: @159503
    GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(159567), // Rule ID 3783 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3783,
      GIR_EraseRootFromParent_Done,
    // Label 2412: @159567
    GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(159631), // Rule ID 3793 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_global>>  =>  (GLOBAL_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3793,
      GIR_EraseRootFromParent_Done,
    // Label 2413: @159631
    GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(159695), // Rule ID 3805 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (ld:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3805,
      GIR_EraseRootFromParent_Done,
    // Label 2414: @159695
    GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(159759), // Rule ID 3811 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_load:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_global>>  =>  (GLOBAL_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3811,
      GIR_EraseRootFromParent_Done,
    // Label 2415: @159759
    GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(159824), // Rule ID 3554 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_atomic_load_zext_8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3554,
      GIR_EraseRootFromParent_Done,
    // Label 2416: @159824
    GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(159889), // Rule ID 3558 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_load:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_atomic_load_zext_16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3558,
      GIR_EraseRootFromParent_Done,
    // Label 2417: @159889
    GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(159954), // Rule ID 3561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>><<P:Predicate_zextloadi8_flat>>  =>  (FLAT_LOAD_UBYTE:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_UBYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3561,
      GIR_EraseRootFromParent_Done,
    // Label 2418: @159954
    GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(160019), // Rule ID 3569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (ld:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>><<P:Predicate_zextloadi16_flat>>  =>  (FLAT_LOAD_USHORT:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_LOAD_USHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3569,
      GIR_EraseRootFromParent_Done,
    // Label 2419: @160019
    GIM_Reject,
    // Label 2333: @160020
    GIM_Reject,
    // Label 17: @160021
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 2437*/ GIMT_Encode4(195926),
    /*GILLT_p0s64*//*Label 2420*/ GIMT_Encode4(160124),
    /*GILLT_p1s64*//*Label 2421*/ GIMT_Encode4(161156),
    /*GILLT_p2s32*//*Label 2422*/ GIMT_Encode4(162188),
    /*GILLT_p3s32*//*Label 2423*/ GIMT_Encode4(163098),
    /*GILLT_p4s64*//*Label 2424*/ GIMT_Encode4(164008),
    /*GILLT_p5s32*//*Label 2425*/ GIMT_Encode4(165040),
    /*GILLT_p6s32*//*Label 2426*/ GIMT_Encode4(165950), GIMT_Encode4(0),
    /*GILLT_s16*//*Label 2427*/ GIMT_Encode4(166860),
    /*GILLT_s32*//*Label 2428*/ GIMT_Encode4(169313),
    /*GILLT_s64*//*Label 2429*/ GIMT_Encode4(176415),
    /*GILLT_v2s16*//*Label 2430*/ GIMT_Encode4(178845),
    /*GILLT_v2s32*//*Label 2431*/ GIMT_Encode4(181573),
    /*GILLT_v2s64*//*Label 2432*/ GIMT_Encode4(183882),
    /*GILLT_v3s32*//*Label 2433*/ GIMT_Encode4(185945), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 2434*/ GIMT_Encode4(187429),
    /*GILLT_v4s32*//*Label 2435*/ GIMT_Encode4(190523), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 2436*/ GIMT_Encode4(192832),
    // Label 2420: @160124
    GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(160188), // Rule ID 8166 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8166,
      GIR_EraseRootFromParent_Done,
    // Label 2438: @160188
    GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(160247), // Rule ID 8090 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8090,
      GIR_EraseRootFromParent_Done,
    // Label 2439: @160247
    GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(160307), // Rule ID 8167 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8167,
      GIR_EraseRootFromParent_Done,
    // Label 2440: @160307
    GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(160362), // Rule ID 8091 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p0:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8091,
      GIR_EraseRootFromParent_Done,
    // Label 2441: @160362
    GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(160418), // Rule ID 4280 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p0:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4280,
      GIR_EraseRootFromParent_Done,
    // Label 2442: @160418
    GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(160469), // Rule ID 4279 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p0:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4279,
      GIR_EraseRootFromParent_Done,
    // Label 2443: @160469
    GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(160520), // Rule ID 4278 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p0:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4278,
      GIR_EraseRootFromParent_Done,
    // Label 2444: @160520
    GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(160584), // Rule ID 4637 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4637,
      GIR_EraseRootFromParent_Done,
    // Label 2445: @160584
    GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(160645), // Rule ID 4639 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p0:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p0:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4639,
      GIR_EraseRootFromParent_Done,
    // Label 2446: @160645
    GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(160765), // Rule ID 8025 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8025,
      GIR_EraseRootFromParent_Done,
    // Label 2447: @160765
    GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(160824), // Rule ID 4636 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4636,
      GIR_EraseRootFromParent_Done,
    // Label 2448: @160824
    GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(160880), // Rule ID 4638 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p0:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4638,
      GIR_EraseRootFromParent_Done,
    // Label 2449: @160880
    GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(160996), // Rule ID 8027 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st p0:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8027,
      GIR_EraseRootFromParent_Done,
    // Label 2450: @160996
    GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(161052), // Rule ID 3880 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p0:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3880,
      GIR_EraseRootFromParent_Done,
    // Label 2451: @161052
    GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(161103), // Rule ID 3879 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p0:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3879,
      GIR_EraseRootFromParent_Done,
    // Label 2452: @161103
    GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(161155), // Rule ID 3610 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p0:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3610,
      GIR_EraseRootFromParent_Done,
    // Label 2453: @161155
    GIM_Reject,
    // Label 2421: @161156
    GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(161220), // Rule ID 8170 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8170,
      GIR_EraseRootFromParent_Done,
    // Label 2454: @161220
    GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(161279), // Rule ID 8094 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8094,
      GIR_EraseRootFromParent_Done,
    // Label 2455: @161279
    GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(161339), // Rule ID 8171 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8171,
      GIR_EraseRootFromParent_Done,
    // Label 2456: @161339
    GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(161394), // Rule ID 8095 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p1:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8095,
      GIR_EraseRootFromParent_Done,
    // Label 2457: @161394
    GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(161450), // Rule ID 4286 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p1:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4286,
      GIR_EraseRootFromParent_Done,
    // Label 2458: @161450
    GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(161501), // Rule ID 4285 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p1:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4285,
      GIR_EraseRootFromParent_Done,
    // Label 2459: @161501
    GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(161552), // Rule ID 4284 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p1:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4284,
      GIR_EraseRootFromParent_Done,
    // Label 2460: @161552
    GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(161616), // Rule ID 4641 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4641,
      GIR_EraseRootFromParent_Done,
    // Label 2461: @161616
    GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(161677), // Rule ID 4643 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p1:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p1:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4643,
      GIR_EraseRootFromParent_Done,
    // Label 2462: @161677
    GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(161797), // Rule ID 8029 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8029,
      GIR_EraseRootFromParent_Done,
    // Label 2463: @161797
    GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(161856), // Rule ID 4640 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4640,
      GIR_EraseRootFromParent_Done,
    // Label 2464: @161856
    GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(161912), // Rule ID 4642 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p1:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4642,
      GIR_EraseRootFromParent_Done,
    // Label 2465: @161912
    GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(162028), // Rule ID 8031 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st p1:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8031,
      GIR_EraseRootFromParent_Done,
    // Label 2466: @162028
    GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(162084), // Rule ID 3884 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p1:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3884,
      GIR_EraseRootFromParent_Done,
    // Label 2467: @162084
    GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(162135), // Rule ID 3883 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p1:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3883,
      GIR_EraseRootFromParent_Done,
    // Label 2468: @162135
    GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(162187), // Rule ID 3612 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p1:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3612,
      GIR_EraseRootFromParent_Done,
    // Label 2469: @162187
    GIM_Reject,
    // Label 2422: @162188
    GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(162247), // Rule ID 6673 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6673,
      GIR_EraseRootFromParent_Done,
    // Label 2470: @162247
    GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(162306), // Rule ID 6675 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6675,
      GIR_EraseRootFromParent_Done,
    // Label 2471: @162306
    GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(162362), // Rule ID 4214 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p2:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4214,
      GIR_EraseRootFromParent_Done,
    // Label 2472: @162362
    GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(162413), // Rule ID 4213 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p2:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4213,
      GIR_EraseRootFromParent_Done,
    // Label 2473: @162413
    GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(162464), // Rule ID 4212 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p2:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4212,
      GIR_EraseRootFromParent_Done,
    // Label 2474: @162464
    GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(162528), // Rule ID 4593 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4593,
      GIR_EraseRootFromParent_Done,
    // Label 2475: @162528
    GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(162589), // Rule ID 4595 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p2:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p2:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4595,
      GIR_EraseRootFromParent_Done,
    // Label 2476: @162589
    GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(162653), // Rule ID 6672 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6672,
      GIR_EraseRootFromParent_Done,
    // Label 2477: @162653
    GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(162717), // Rule ID 6674 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p2:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6674,
      GIR_EraseRootFromParent_Done,
    // Label 2478: @162717
    GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(162776), // Rule ID 4592 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4592,
      GIR_EraseRootFromParent_Done,
    // Label 2479: @162776
    GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(162832), // Rule ID 4594 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p2:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4594,
      GIR_EraseRootFromParent_Done,
    // Label 2480: @162832
    GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(162887), // Rule ID 7970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7970,
      GIR_EraseRootFromParent_Done,
    // Label 2481: @162887
    GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(162938), // Rule ID 7971 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p2:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7971,
      GIR_EraseRootFromParent_Done,
    // Label 2482: @162938
    GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(162994), // Rule ID 3836 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p2:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3836,
      GIR_EraseRootFromParent_Done,
    // Label 2483: @162994
    GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(163045), // Rule ID 3835 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p2:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3835,
      GIR_EraseRootFromParent_Done,
    // Label 2484: @163045
    GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(163097), // Rule ID 3589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p2:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3589,
      GIR_EraseRootFromParent_Done,
    // Label 2485: @163097
    GIM_Reject,
    // Label 2423: @163098
    GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(163157), // Rule ID 6677 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6677,
      GIR_EraseRootFromParent_Done,
    // Label 2486: @163157
    GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(163216), // Rule ID 6679 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6679,
      GIR_EraseRootFromParent_Done,
    // Label 2487: @163216
    GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(163272), // Rule ID 4220 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p3:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4220,
      GIR_EraseRootFromParent_Done,
    // Label 2488: @163272
    GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(163323), // Rule ID 4219 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p3:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4219,
      GIR_EraseRootFromParent_Done,
    // Label 2489: @163323
    GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(163374), // Rule ID 4218 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p3:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4218,
      GIR_EraseRootFromParent_Done,
    // Label 2490: @163374
    GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(163438), // Rule ID 4597 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4597,
      GIR_EraseRootFromParent_Done,
    // Label 2491: @163438
    GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(163499), // Rule ID 4599 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p3:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p3:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4599,
      GIR_EraseRootFromParent_Done,
    // Label 2492: @163499
    GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(163563), // Rule ID 6676 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6676,
      GIR_EraseRootFromParent_Done,
    // Label 2493: @163563
    GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(163627), // Rule ID 6678 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p3:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6678,
      GIR_EraseRootFromParent_Done,
    // Label 2494: @163627
    GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(163686), // Rule ID 4596 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4596,
      GIR_EraseRootFromParent_Done,
    // Label 2495: @163686
    GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(163742), // Rule ID 4598 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p3:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4598,
      GIR_EraseRootFromParent_Done,
    // Label 2496: @163742
    GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(163797), // Rule ID 7972 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7972,
      GIR_EraseRootFromParent_Done,
    // Label 2497: @163797
    GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(163848), // Rule ID 7973 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p3:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7973,
      GIR_EraseRootFromParent_Done,
    // Label 2498: @163848
    GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(163904), // Rule ID 3840 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p3:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3840,
      GIR_EraseRootFromParent_Done,
    // Label 2499: @163904
    GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(163955), // Rule ID 3839 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p3:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3839,
      GIR_EraseRootFromParent_Done,
    // Label 2500: @163955
    GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(164007), // Rule ID 3591 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p3:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3591,
      GIR_EraseRootFromParent_Done,
    // Label 2501: @164007
    GIM_Reject,
    // Label 2424: @164008
    GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(164072), // Rule ID 8174 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8174,
      GIR_EraseRootFromParent_Done,
    // Label 2502: @164072
    GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(164131), // Rule ID 8098 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8098,
      GIR_EraseRootFromParent_Done,
    // Label 2503: @164131
    GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(164191), // Rule ID 8175 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8175,
      GIR_EraseRootFromParent_Done,
    // Label 2504: @164191
    GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(164246), // Rule ID 8099 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p4:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8099,
      GIR_EraseRootFromParent_Done,
    // Label 2505: @164246
    GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(164302), // Rule ID 4292 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p4:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4292,
      GIR_EraseRootFromParent_Done,
    // Label 2506: @164302
    GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(164353), // Rule ID 4291 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p4:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4291,
      GIR_EraseRootFromParent_Done,
    // Label 2507: @164353
    GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(164404), // Rule ID 4290 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p4:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4290,
      GIR_EraseRootFromParent_Done,
    // Label 2508: @164404
    GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(164468), // Rule ID 4645 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4645,
      GIR_EraseRootFromParent_Done,
    // Label 2509: @164468
    GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(164529), // Rule ID 4647 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p4:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 p4:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4647,
      GIR_EraseRootFromParent_Done,
    // Label 2510: @164529
    GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(164649), // Rule ID 8033 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8033,
      GIR_EraseRootFromParent_Done,
    // Label 2511: @164649
    GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(164708), // Rule ID 4644 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4644,
      GIR_EraseRootFromParent_Done,
    // Label 2512: @164708
    GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(164764), // Rule ID 4646 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p4:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4646,
      GIR_EraseRootFromParent_Done,
    // Label 2513: @164764
    GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(164880), // Rule ID 8035 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st p4:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8035,
      GIR_EraseRootFromParent_Done,
    // Label 2514: @164880
    GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(164936), // Rule ID 3888 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p4:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3888,
      GIR_EraseRootFromParent_Done,
    // Label 2515: @164936
    GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(164987), // Rule ID 3887 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p4:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3887,
      GIR_EraseRootFromParent_Done,
    // Label 2516: @164987
    GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(165039), // Rule ID 3614 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p4:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3614,
      GIR_EraseRootFromParent_Done,
    // Label 2517: @165039
    GIM_Reject,
    // Label 2425: @165040
    GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(165099), // Rule ID 6681 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6681,
      GIR_EraseRootFromParent_Done,
    // Label 2518: @165099
    GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(165158), // Rule ID 6683 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6683,
      GIR_EraseRootFromParent_Done,
    // Label 2519: @165158
    GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(165214), // Rule ID 4226 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p5:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4226,
      GIR_EraseRootFromParent_Done,
    // Label 2520: @165214
    GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(165265), // Rule ID 4225 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p5:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4225,
      GIR_EraseRootFromParent_Done,
    // Label 2521: @165265
    GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(165316), // Rule ID 4224 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p5:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4224,
      GIR_EraseRootFromParent_Done,
    // Label 2522: @165316
    GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(165380), // Rule ID 4601 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4601,
      GIR_EraseRootFromParent_Done,
    // Label 2523: @165380
    GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(165441), // Rule ID 4603 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p5:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p5:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4603,
      GIR_EraseRootFromParent_Done,
    // Label 2524: @165441
    GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(165505), // Rule ID 6680 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6680,
      GIR_EraseRootFromParent_Done,
    // Label 2525: @165505
    GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(165569), // Rule ID 6682 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p5:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6682,
      GIR_EraseRootFromParent_Done,
    // Label 2526: @165569
    GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(165628), // Rule ID 4600 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4600,
      GIR_EraseRootFromParent_Done,
    // Label 2527: @165628
    GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(165684), // Rule ID 4602 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p5:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4602,
      GIR_EraseRootFromParent_Done,
    // Label 2528: @165684
    GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(165739), // Rule ID 7974 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7974,
      GIR_EraseRootFromParent_Done,
    // Label 2529: @165739
    GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(165790), // Rule ID 7975 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p5:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7975,
      GIR_EraseRootFromParent_Done,
    // Label 2530: @165790
    GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(165846), // Rule ID 3844 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p5:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3844,
      GIR_EraseRootFromParent_Done,
    // Label 2531: @165846
    GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(165897), // Rule ID 3843 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p5:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3843,
      GIR_EraseRootFromParent_Done,
    // Label 2532: @165897
    GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(165949), // Rule ID 3593 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p5:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3593,
      GIR_EraseRootFromParent_Done,
    // Label 2533: @165949
    GIM_Reject,
    // Label 2426: @165950
    GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(166009), // Rule ID 6685 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6685,
      GIR_EraseRootFromParent_Done,
    // Label 2534: @166009
    GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(166068), // Rule ID 6687 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6687,
      GIR_EraseRootFromParent_Done,
    // Label 2535: @166068
    GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(166124), // Rule ID 4232 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st p6:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4232,
      GIR_EraseRootFromParent_Done,
    // Label 2536: @166124
    GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(166175), // Rule ID 4231 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st p6:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4231,
      GIR_EraseRootFromParent_Done,
    // Label 2537: @166175
    GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(166226), // Rule ID 4230 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st p6:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4230,
      GIR_EraseRootFromParent_Done,
    // Label 2538: @166226
    GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(166290), // Rule ID 4605 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4605,
      GIR_EraseRootFromParent_Done,
    // Label 2539: @166290
    GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(166351), // Rule ID 4607 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st p6:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 p6:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4607,
      GIR_EraseRootFromParent_Done,
    // Label 2540: @166351
    GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(166415), // Rule ID 6684 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6684,
      GIR_EraseRootFromParent_Done,
    // Label 2541: @166415
    GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(166479), // Rule ID 6686 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st p6:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6686,
      GIR_EraseRootFromParent_Done,
    // Label 2542: @166479
    GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(166538), // Rule ID 4604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4604,
      GIR_EraseRootFromParent_Done,
    // Label 2543: @166538
    GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(166594), // Rule ID 4606 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st p6:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4606,
      GIR_EraseRootFromParent_Done,
    // Label 2544: @166594
    GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(166649), // Rule ID 7976 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7976,
      GIR_EraseRootFromParent_Done,
    // Label 2545: @166649
    GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(166700), // Rule ID 7977 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st p6:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7977,
      GIR_EraseRootFromParent_Done,
    // Label 2546: @166700
    GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(166756), // Rule ID 3848 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st p6:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3848,
      GIR_EraseRootFromParent_Done,
    // Label 2547: @166756
    GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(166807), // Rule ID 3847 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st p6:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3847,
      GIR_EraseRootFromParent_Done,
    // Label 2548: @166807
    GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(166859), // Rule ID 3595 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st p6:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3595,
      GIR_EraseRootFromParent_Done,
    // Label 2549: @166859
    GIM_Reject,
    // Label 2427: @166860
    GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(166930), // Rule ID 6645 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6645,
      GIR_EraseRootFromParent_Done,
    // Label 2550: @166930
    GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(167000), // Rule ID 6647 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6647,
      GIR_EraseRootFromParent_Done,
    // Label 2551: @167000
    GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167059), // Rule ID 6649 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6649,
      GIR_EraseRootFromParent_Done,
    // Label 2552: @167059
    GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(167118), // Rule ID 6651 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6651,
      GIR_EraseRootFromParent_Done,
    // Label 2553: @167118
    GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(167185), // Rule ID 4343 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4343,
      GIR_EraseRootFromParent_Done,
    // Label 2554: @167185
    GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(167241), // Rule ID 4349 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i16:{ *:[i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4349,
      GIR_EraseRootFromParent_Done,
    // Label 2555: @167241
    GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(167303), // Rule ID 4342 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4342,
      GIR_EraseRootFromParent_Done,
    // Label 2556: @167303
    GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(167354), // Rule ID 4348 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i16:{ *:[i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4348,
      GIR_EraseRootFromParent_Done,
    // Label 2557: @167354
    GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(167416), // Rule ID 4341 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4341,
      GIR_EraseRootFromParent_Done,
    // Label 2558: @167416
    GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(167467), // Rule ID 4347 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i16:{ *:[i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4347,
      GIR_EraseRootFromParent_Done,
    // Label 2559: @167467
    GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(167538), // Rule ID 6622 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6622,
      GIR_EraseRootFromParent_Done,
    // Label 2560: @167538
    GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(167609), // Rule ID 6626 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i16:{ *:[i16] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i16] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6626,
      GIR_EraseRootFromParent_Done,
    // Label 2561: @167609
    GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(167684), // Rule ID 6644 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6644,
      GIR_EraseRootFromParent_Done,
    // Label 2562: @167684
    GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(167759), // Rule ID 6646 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6646,
      GIR_EraseRootFromParent_Done,
    // Label 2563: @167759
    GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(167823), // Rule ID 6648 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6648,
      GIR_EraseRootFromParent_Done,
    // Label 2564: @167823
    GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(167887), // Rule ID 6650 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i16:{ *:[i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6650,
      GIR_EraseRootFromParent_Done,
    // Label 2565: @167887
    GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(167957), // Rule ID 6632 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6632,
      GIR_EraseRootFromParent_Done,
    // Label 2566: @167957
    GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(168024), // Rule ID 6633 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6633,
      GIR_EraseRootFromParent_Done,
    // Label 2567: @168024
    GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(168083), // Rule ID 6634 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6634,
      GIR_EraseRootFromParent_Done,
    // Label 2568: @168083
    GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(168139), // Rule ID 6635 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i16:{ *:[i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET ?:{ *:[i16] }:$vdata, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6635,
      GIR_EraseRootFromParent_Done,
    // Label 2569: @168139
    GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(168197), // Rule ID 7978 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7978,
      GIR_EraseRootFromParent_Done,
    // Label 2570: @168197
    GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(168255), // Rule ID 7979 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7979,
      GIR_EraseRootFromParent_Done,
    // Label 2571: @168255
    GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(168313), // Rule ID 7982 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7982,
      GIR_EraseRootFromParent_Done,
    // Label 2572: @168313
    GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(168371), // Rule ID 7983 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7983,
      GIR_EraseRootFromParent_Done,
    // Label 2573: @168371
    GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(168433), // Rule ID 7956 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7956,
      GIR_EraseRootFromParent_Done,
    // Label 2574: @168433
    GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(168495), // Rule ID 7957 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7957,
      GIR_EraseRootFromParent_Done,
    // Label 2575: @168495
    GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(168550), // Rule ID 7958 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7958,
      GIR_EraseRootFromParent_Done,
    // Label 2576: @168550
    GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(168601), // Rule ID 7959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i16:{ *:[i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7959,
      GIR_EraseRootFromParent_Done,
    // Label 2577: @168601
    GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(168664), // Rule ID 3962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3962,
      GIR_EraseRootFromParent_Done,
    // Label 2578: @168664
    GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(168727), // Rule ID 3966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3966,
      GIR_EraseRootFromParent_Done,
    // Label 2579: @168727
    GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(168794), // Rule ID 3926 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3926,
      GIR_EraseRootFromParent_Done,
    // Label 2580: @168794
    GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(168850), // Rule ID 3930 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i16:{ *:[i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3930,
      GIR_EraseRootFromParent_Done,
    // Label 2581: @168850
    GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(168908), // Rule ID 3961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3961,
      GIR_EraseRootFromParent_Done,
    // Label 2582: @168908
    GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(168966), // Rule ID 3965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3965,
      GIR_EraseRootFromParent_Done,
    // Label 2583: @168966
    GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(169028), // Rule ID 3925 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3925,
      GIR_EraseRootFromParent_Done,
    // Label 2584: @169028
    GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(169079), // Rule ID 3929 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i16:{ *:[i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3929,
      GIR_EraseRootFromParent_Done,
    // Label 2585: @169079
    GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(169138), // Rule ID 3634 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3634,
      GIR_EraseRootFromParent_Done,
    // Label 2586: @169138
    GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(169197), // Rule ID 3636 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3636,
      GIR_EraseRootFromParent_Done,
    // Label 2587: @169197
    GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(169260), // Rule ID 3757 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3757,
      GIR_EraseRootFromParent_Done,
    // Label 2588: @169260
    GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(169312), // Rule ID 3758 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i16:{ *:[i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3758,
      GIR_EraseRootFromParent_Done,
    // Label 2589: @169312
    GIM_Reject,
    // Label 2428: @169313
    GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(169408), // Rule ID 6701 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFSET),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6701,
      GIR_EraseRootFromParent_Done,
    // Label 2590: @169408
    GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(169503), // Rule ID 6703 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFSET),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6703,
      GIR_EraseRootFromParent_Done,
    // Label 2591: @169503
    GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(169598), // Rule ID 6705 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFSET),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6705,
      GIR_EraseRootFromParent_Done,
    // Label 2592: @169598
    GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(169693), // Rule ID 6707 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFSET),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6707,
      GIR_EraseRootFromParent_Done,
    // Label 2593: @169693
    GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(169785), // Rule ID 4355 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SVS),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4355,
      GIR_EraseRootFromParent_Done,
    // Label 2594: @169785
    GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(169877), // Rule ID 4358 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SVS),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4358,
      GIR_EraseRootFromParent_Done,
    // Label 2595: @169877
    GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(169964), // Rule ID 4354 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI_SADDR),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4354,
      GIR_EraseRootFromParent_Done,
    // Label 2596: @169964
    GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(170051), // Rule ID 4357 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI_SADDR),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4357,
      GIR_EraseRootFromParent_Done,
    // Label 2597: @170051
    GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(170138), // Rule ID 4353 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_private>>  =>  (SCRATCH_STORE_SHORT_D16_HI anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_D16_HI),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4353,
      GIR_EraseRootFromParent_Done,
    // Label 2598: @170138
    GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(170225), // Rule ID 4356 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasD16LoadStore_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (SCRATCH_STORE_BYTE_D16_HI anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_D16_HI),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4356,
      GIR_EraseRootFromParent_Done,
    // Label 2599: @170225
    GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(170325), // Rule ID 6700 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_OFFEN),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6700,
      GIR_EraseRootFromParent_Done,
    // Label 2600: @170325
    GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(170425), // Rule ID 6702 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_private>>  =>  (BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_D16_HI_VBUFFER_OFFEN),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6702,
      GIR_EraseRootFromParent_Done,
    // Label 2601: @170425
    GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(170525), // Rule ID 6704 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_OFFEN),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6704,
      GIR_EraseRootFromParent_Done,
    // Label 2602: @170525
    GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(170625), // Rule ID 6706 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_private>>  =>  (BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_D16_HI_VBUFFER_OFFEN),
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6706,
      GIR_EraseRootFromParent_Done,
    // Label 2603: @170625
    GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(170695), // Rule ID 6637 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6637,
      GIR_EraseRootFromParent_Done,
    // Label 2604: @170695
    GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(170765), // Rule ID 6639 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6639,
      GIR_EraseRootFromParent_Done,
    // Label 2605: @170765
    GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(170835), // Rule ID 6641 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6641,
      GIR_EraseRootFromParent_Done,
    // Label 2606: @170835
    GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(170905), // Rule ID 6643 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6643,
      GIR_EraseRootFromParent_Done,
    // Label 2607: @170905
    GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(170964), // Rule ID 6653 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6653,
      GIR_EraseRootFromParent_Done,
    // Label 2608: @170964
    GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(171023), // Rule ID 6655 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6655,
      GIR_EraseRootFromParent_Done,
    // Label 2609: @171023
    GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(171082), // Rule ID 6657 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6657,
      GIR_EraseRootFromParent_Done,
    // Label 2610: @171082
    GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(171141), // Rule ID 6659 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[f32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6659,
      GIR_EraseRootFromParent_Done,
    // Label 2611: @171141
    GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(171208), // Rule ID 4340 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4340,
      GIR_EraseRootFromParent_Done,
    // Label 2612: @171208
    GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(171275), // Rule ID 4346 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4346,
      GIR_EraseRootFromParent_Done,
    // Label 2613: @171275
    GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(171331), // Rule ID 3548 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3548,
      GIR_EraseRootFromParent_Done,
    // Label 2614: @171331
    GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(171387), // Rule ID 4190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st f32:{ *:[f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4190,
      GIR_EraseRootFromParent_Done,
    // Label 2615: @171387
    GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(171449), // Rule ID 4339 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4339,
      GIR_EraseRootFromParent_Done,
    // Label 2616: @171449
    GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(171511), // Rule ID 4345 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4345,
      GIR_EraseRootFromParent_Done,
    // Label 2617: @171511
    GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(171562), // Rule ID 3547 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i32:{ *:[i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3547,
      GIR_EraseRootFromParent_Done,
    // Label 2618: @171562
    GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(171613), // Rule ID 4189 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st f32:{ *:[f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4189,
      GIR_EraseRootFromParent_Done,
    // Label 2619: @171613
    GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(171675), // Rule ID 4338 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (SCRATCH_STORE_BYTE anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_BYTE),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4338,
      GIR_EraseRootFromParent_Done,
    // Label 2620: @171675
    GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(171737), // Rule ID 4344 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (SCRATCH_STORE_SHORT anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_SHORT),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4344,
      GIR_EraseRootFromParent_Done,
    // Label 2621: @171737
    GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(171788), // Rule ID 3546 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i32:{ *:[i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3546,
      GIR_EraseRootFromParent_Done,
    // Label 2622: @171788
    GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(171839), // Rule ID 4188 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st f32:{ *:[f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4188,
      GIR_EraseRootFromParent_Done,
    // Label 2623: @171839
    GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(171926), // Rule ID 7990 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_store_hi16_local>>  =>  (DS_WRITE_B16_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7990,
      GIR_EraseRootFromParent_Done,
    // Label 2624: @171926
    GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(172013), // Rule ID 7991 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$value, 16:{ *:[i32] }), (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_local>>  =>  (DS_WRITE_B8_D16_HI ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7991,
      GIR_EraseRootFromParent_Done,
    // Label 2625: @172013
    GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(172084), // Rule ID 6620 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6620,
      GIR_EraseRootFromParent_Done,
    // Label 2626: @172084
    GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(172155), // Rule ID 6624 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6624,
      GIR_EraseRootFromParent_Done,
    // Label 2627: @172155
    GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(172226), // Rule ID 6628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i32:{ *:[i32] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 ?:{ *:[i32] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6628,
      GIR_EraseRootFromParent_Done,
    // Label 2628: @172226
    GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(172301), // Rule ID 4395 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4395,
      GIR_EraseRootFromParent_Done,
    // Label 2629: @172301
    GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(172373), // Rule ID 4567 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4567,
      GIR_EraseRootFromParent_Done,
    // Label 2630: @172373
    GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(172448), // Rule ID 4569 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4569,
      GIR_EraseRootFromParent_Done,
    // Label 2631: @172448
    GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(172520), // Rule ID 4571 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4571,
      GIR_EraseRootFromParent_Done,
    // Label 2632: @172520
    GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(172595), // Rule ID 6636 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6636,
      GIR_EraseRootFromParent_Done,
    // Label 2633: @172595
    GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(172670), // Rule ID 6638 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_private>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6638,
      GIR_EraseRootFromParent_Done,
    // Label 2634: @172670
    GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(172745), // Rule ID 6640 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6640,
      GIR_EraseRootFromParent_Done,
    // Label 2635: @172745
    GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(172820), // Rule ID 6642 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_private>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6642,
      GIR_EraseRootFromParent_Done,
    // Label 2636: @172820
    GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(172884), // Rule ID 4573 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4573,
      GIR_EraseRootFromParent_Done,
    // Label 2637: @172884
    GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(172945), // Rule ID 4575 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 i32:{ *:[i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4575,
      GIR_EraseRootFromParent_Done,
    // Label 2638: @172945
    GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(173009), // Rule ID 4577 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4577,
      GIR_EraseRootFromParent_Done,
    // Label 2639: @173009
    GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(173070), // Rule ID 4579 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st f32:{ *:[f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 f32:{ *:[f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4579,
      GIR_EraseRootFromParent_Done,
    // Label 2640: @173070
    GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(173134), // Rule ID 6652 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6652,
      GIR_EraseRootFromParent_Done,
    // Label 2641: @173134
    GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(173198), // Rule ID 6654 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st i32:{ *:[i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6654,
      GIR_EraseRootFromParent_Done,
    // Label 2642: @173198
    GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(173262), // Rule ID 6656 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6656,
      GIR_EraseRootFromParent_Done,
    // Label 2643: @173262
    GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(173326), // Rule ID 6658 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st f32:{ *:[f32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[f32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6658,
      GIR_EraseRootFromParent_Done,
    // Label 2644: @173326
    GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(173418), // Rule ID 3934 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3934,
      GIR_EraseRootFromParent_Done,
    // Label 2645: @173418
    GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(173510), // Rule ID 3936 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3936,
      GIR_EraseRootFromParent_Done,
    // Label 2646: @173510
    GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(173580), // Rule ID 4394 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4394,
      GIR_EraseRootFromParent_Done,
    // Label 2647: @173580
    GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(173647), // Rule ID 4566 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4566,
      GIR_EraseRootFromParent_Done,
    // Label 2648: @173647
    GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(173717), // Rule ID 4568 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4568,
      GIR_EraseRootFromParent_Done,
    // Label 2649: @173717
    GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(173784), // Rule ID 4570 //
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4570,
      GIR_EraseRootFromParent_Done,
    // Label 2650: @173784
    GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(173843), // Rule ID 4572 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4572,
      GIR_EraseRootFromParent_Done,
    // Label 2651: @173843
    GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(173899), // Rule ID 4574 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i32:{ *:[i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4574,
      GIR_EraseRootFromParent_Done,
    // Label 2652: @173899
    GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(173958), // Rule ID 4576 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4576,
      GIR_EraseRootFromParent_Done,
    // Label 2653: @173958
    GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(174014), // Rule ID 4578 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st f32:{ *:[f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4578,
      GIR_EraseRootFromParent_Done,
    // Label 2654: @174014
    GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(174101), // Rule ID 3933 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_global>>  =>  (GLOBAL_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3933,
      GIR_EraseRootFromParent_Done,
    // Label 2655: @174101
    GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(174188), // Rule ID 3935 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_global>>  =>  (GLOBAL_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3935,
      GIR_EraseRootFromParent_Done,
    // Label 2656: @174188
    GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(174246), // Rule ID 7980 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8_glue>><<P:Predicate_atomic_store_8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7980,
      GIR_EraseRootFromParent_Done,
    // Label 2657: @174246
    GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(174304), // Rule ID 7981 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7981,
      GIR_EraseRootFromParent_Done,
    // Label 2658: @174304
    GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(174362), // Rule ID 7984 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16_glue>><<P:Predicate_atomic_store_16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7984,
      GIR_EraseRootFromParent_Done,
    // Label 2659: @174362
    GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(174420), // Rule ID 7985 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7985,
      GIR_EraseRootFromParent_Done,
    // Label 2660: @174420
    GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(174478), // Rule ID 7986 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32_glue>><<P:Predicate_atomic_store_32_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7986,
      GIR_EraseRootFromParent_Done,
    // Label 2661: @174478
    GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(174536), // Rule ID 7987 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7987,
      GIR_EraseRootFromParent_Done,
    // Label 2662: @174536
    GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(174598), // Rule ID 7952 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei8_glue>><<P:Predicate_truncstorei8_local_m0>>  =>  (DS_WRITE_B8 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7952,
      GIR_EraseRootFromParent_Done,
    // Label 2663: @174598
    GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(174660), // Rule ID 7953 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_local>>  =>  (DS_WRITE_B8_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B8_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7953,
      GIR_EraseRootFromParent_Done,
    // Label 2664: @174660
    GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(174722), // Rule ID 7954 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_truncstore_glue>><<P:Predicate_truncstorei16_glue>><<P:Predicate_truncstorei16_local_m0>>  =>  (DS_WRITE_B16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7954,
      GIR_EraseRootFromParent_Done,
    // Label 2665: @174722
    GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(174784), // Rule ID 7955 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_local>>  =>  (DS_WRITE_B16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B16_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7955,
      GIR_EraseRootFromParent_Done,
    // Label 2666: @174784
    GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(174839), // Rule ID 7960 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7960,
      GIR_EraseRootFromParent_Done,
    // Label 2667: @174839
    GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(174894), // Rule ID 7962 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7962,
      GIR_EraseRootFromParent_Done,
    // Label 2668: @174894
    GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(174945), // Rule ID 7961 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i32:{ *:[i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7961,
      GIR_EraseRootFromParent_Done,
    // Label 2669: @174945
    GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(174996), // Rule ID 7963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st f32:{ *:[f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7963,
      GIR_EraseRootFromParent_Done,
    // Label 2670: @174996
    GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(175059), // Rule ID 3960 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3960,
      GIR_EraseRootFromParent_Done,
    // Label 2671: @175059
    GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(175122), // Rule ID 3964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3964,
      GIR_EraseRootFromParent_Done,
    // Label 2672: @175122
    GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(175185), // Rule ID 3968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3968,
      GIR_EraseRootFromParent_Done,
    // Label 2673: @175185
    GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(175252), // Rule ID 3924 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3924,
      GIR_EraseRootFromParent_Done,
    // Label 2674: @175252
    GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(175319), // Rule ID 3928 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3928,
      GIR_EraseRootFromParent_Done,
    // Label 2675: @175319
    GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(175375), // Rule ID 3538 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i32:{ *:[i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3538,
      GIR_EraseRootFromParent_Done,
    // Label 2676: @175375
    GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(175431), // Rule ID 3820 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st f32:{ *:[f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3820,
      GIR_EraseRootFromParent_Done,
    // Label 2677: @175431
    GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(175489), // Rule ID 3959 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3959,
      GIR_EraseRootFromParent_Done,
    // Label 2678: @175489
    GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(175547), // Rule ID 3963 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3963,
      GIR_EraseRootFromParent_Done,
    // Label 2679: @175547
    GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(175605), // Rule ID 3967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3967,
      GIR_EraseRootFromParent_Done,
    // Label 2680: @175605
    GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(175667), // Rule ID 3923 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_global>>  =>  (GLOBAL_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3923,
      GIR_EraseRootFromParent_Done,
    // Label 2681: @175667
    GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(175729), // Rule ID 3927 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_global>>  =>  (GLOBAL_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3927,
      GIR_EraseRootFromParent_Done,
    // Label 2682: @175729
    GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(175780), // Rule ID 3537 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i32:{ *:[i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3537,
      GIR_EraseRootFromParent_Done,
    // Label 2683: @175780
    GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(175831), // Rule ID 3819 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st f32:{ *:[f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3819,
      GIR_EraseRootFromParent_Done,
    // Label 2684: @175831
    GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(175919), // Rule ID 3759 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_hi16_flat>>  =>  (FLAT_STORE_SHORT_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3759,
      GIR_EraseRootFromParent_Done,
    // Label 2685: @175919
    GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(176007), // Rule ID 3760 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasD16LoadStore),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st (srl:{ *:[i32] } i32:{ *:[i32] }:$data, 16:{ *:[i32] }), (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_hi16_flat>>  =>  (FLAT_STORE_BYTE_D16_HI ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE_D16_HI),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3760,
      GIR_EraseRootFromParent_Done,
    // Label 2686: @176007
    GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(176066), // Rule ID 3631 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_atomic_store_32_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3631,
      GIR_EraseRootFromParent_Done,
    // Label 2687: @176066
    GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(176125), // Rule ID 3633 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_atomic_store_8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3633,
      GIR_EraseRootFromParent_Done,
    // Label 2688: @176125
    GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(176184), // Rule ID 3635 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_atomic_store_16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3635,
      GIR_EraseRootFromParent_Done,
    // Label 2689: @176184
    GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(176247), // Rule ID 3576 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>><<P:Predicate_truncstorei8_flat>>  =>  (FLAT_STORE_BYTE ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_BYTE),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3576,
      GIR_EraseRootFromParent_Done,
    // Label 2690: @176247
    GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(176310), // Rule ID 3577 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>><<P:Predicate_truncstorei16_flat>>  =>  (FLAT_STORE_SHORT ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_SHORT),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3577,
      GIR_EraseRootFromParent_Done,
    // Label 2691: @176310
    GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(176362), // Rule ID 3579 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i32:{ *:[i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3579,
      GIR_EraseRootFromParent_Done,
    // Label 2692: @176362
    GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(176414), // Rule ID 3581 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st f32:{ *:[f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3581,
      GIR_EraseRootFromParent_Done,
    // Label 2693: @176414
    GIM_Reject,
    // Label 2429: @176415
    GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(176479), // Rule ID 8138 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8138,
      GIR_EraseRootFromParent_Done,
    // Label 2694: @176479
    GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(176543), // Rule ID 8142 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8142,
      GIR_EraseRootFromParent_Done,
    // Label 2695: @176543
    GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(176602), // Rule ID 8062 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8062,
      GIR_EraseRootFromParent_Done,
    // Label 2696: @176602
    GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(176661), // Rule ID 8066 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8066,
      GIR_EraseRootFromParent_Done,
    // Label 2697: @176661
    GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(176721), // Rule ID 8139 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8139,
      GIR_EraseRootFromParent_Done,
    // Label 2698: @176721
    GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(176781), // Rule ID 8143 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8143,
      GIR_EraseRootFromParent_Done,
    // Label 2699: @176781
    GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(176836), // Rule ID 8063 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8063,
      GIR_EraseRootFromParent_Done,
    // Label 2700: @176836
    GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(176891), // Rule ID 8067 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st f64:{ *:[f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8067,
      GIR_EraseRootFromParent_Done,
    // Label 2701: @176891
    GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(176947), // Rule ID 4238 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st i64:{ *:[i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4238,
      GIR_EraseRootFromParent_Done,
    // Label 2702: @176947
    GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(177003), // Rule ID 4244 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st f64:{ *:[f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4244,
      GIR_EraseRootFromParent_Done,
    // Label 2703: @177003
    GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(177054), // Rule ID 4237 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st i64:{ *:[i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4237,
      GIR_EraseRootFromParent_Done,
    // Label 2704: @177054
    GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(177105), // Rule ID 4243 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st f64:{ *:[f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4243,
      GIR_EraseRootFromParent_Done,
    // Label 2705: @177105
    GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(177156), // Rule ID 4236 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st i64:{ *:[i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4236,
      GIR_EraseRootFromParent_Done,
    // Label 2706: @177156
    GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(177207), // Rule ID 4242 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st f64:{ *:[f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4242,
      GIR_EraseRootFromParent_Done,
    // Label 2707: @177207
    GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(177278), // Rule ID 6630 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (atomic_store i64:{ *:[i64] }:$val, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 ?:{ *:[i64] }:$val, ?:{ *:[i64] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // val
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6630,
      GIR_EraseRootFromParent_Done,
    // Label 2708: @177278
    GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(177342), // Rule ID 4609 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4609,
      GIR_EraseRootFromParent_Done,
    // Label 2709: @177342
    GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(177403), // Rule ID 4611 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st i64:{ *:[i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 i64:{ *:[i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4611,
      GIR_EraseRootFromParent_Done,
    // Label 2710: @177403
    GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(177467), // Rule ID 4613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4613,
      GIR_EraseRootFromParent_Done,
    // Label 2711: @177467
    GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(177528), // Rule ID 4615 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st f64:{ *:[f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 f64:{ *:[f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4615,
      GIR_EraseRootFromParent_Done,
    // Label 2712: @177528
    GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(177648), // Rule ID 7993 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7993,
      GIR_EraseRootFromParent_Done,
    // Label 2713: @177648
    GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(177768), // Rule ID 8001 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8001,
      GIR_EraseRootFromParent_Done,
    // Label 2714: @177768
    GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(177827), // Rule ID 4608 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4608,
      GIR_EraseRootFromParent_Done,
    // Label 2715: @177827
    GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(177883), // Rule ID 4610 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st i64:{ *:[i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4610,
      GIR_EraseRootFromParent_Done,
    // Label 2716: @177883
    GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(177942), // Rule ID 4612 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4612,
      GIR_EraseRootFromParent_Done,
    // Label 2717: @177942
    GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(177998), // Rule ID 4614 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st f64:{ *:[f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4614,
      GIR_EraseRootFromParent_Done,
    // Label 2718: @177998
    GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(178114), // Rule ID 7995 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st i64:{ *:[i64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7995,
      GIR_EraseRootFromParent_Done,
    // Label 2719: @178114
    GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(178230), // Rule ID 8003 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st f64:{ *:[f64] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8003,
      GIR_EraseRootFromParent_Done,
    // Label 2720: @178230
    GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(178288), // Rule ID 7988 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUatomic_st_glue i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64_glue>><<P:Predicate_atomic_store_64_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7988,
      GIR_EraseRootFromParent_Done,
    // Label 2721: @178288
    GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(178346), // Rule ID 7989 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (atomic_store i64:{ *:[i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7989,
      GIR_EraseRootFromParent_Done,
    // Label 2722: @178346
    GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(178409), // Rule ID 3970 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (atomic_store i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3970,
      GIR_EraseRootFromParent_Done,
    // Label 2723: @178409
    GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(178465), // Rule ID 3852 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st i64:{ *:[i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3852,
      GIR_EraseRootFromParent_Done,
    // Label 2724: @178465
    GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(178521), // Rule ID 3856 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st f64:{ *:[f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3856,
      GIR_EraseRootFromParent_Done,
    // Label 2725: @178521
    GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(178579), // Rule ID 3969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (atomic_store i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3969,
      GIR_EraseRootFromParent_Done,
    // Label 2726: @178579
    GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(178630), // Rule ID 3851 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st i64:{ *:[i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3851,
      GIR_EraseRootFromParent_Done,
    // Label 2727: @178630
    GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(178681), // Rule ID 3855 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st f64:{ *:[f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3855,
      GIR_EraseRootFromParent_Done,
    // Label 2728: @178681
    GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(178740), // Rule ID 3632 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (atomic_store i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_atomic_store_64_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3632,
      GIR_EraseRootFromParent_Done,
    // Label 2729: @178740
    GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(178792), // Rule ID 3596 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st i64:{ *:[i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3596,
      GIR_EraseRootFromParent_Done,
    // Label 2730: @178792
    GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(178844), // Rule ID 3598 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st f64:{ *:[f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3598,
      GIR_EraseRootFromParent_Done,
    // Label 2731: @178844
    GIM_Reject,
    // Label 2430: @178845
    GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(178904), // Rule ID 6661 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6661,
      GIR_EraseRootFromParent_Done,
    // Label 2732: @178904
    GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(178963), // Rule ID 6663 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6663,
      GIR_EraseRootFromParent_Done,
    // Label 2733: @178963
    GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(179022), // Rule ID 6665 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6665,
      GIR_EraseRootFromParent_Done,
    // Label 2734: @179022
    GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(179081), // Rule ID 6667 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6667,
      GIR_EraseRootFromParent_Done,
    // Label 2735: @179081
    GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(179140), // Rule ID 6669 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2bf16:{ *:[v2bf16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFSET VGPR_32:{ *:[v2bf16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6669,
      GIR_EraseRootFromParent_Done,
    // Label 2736: @179140
    GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(179199), // Rule ID 6671 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2bf16:{ *:[v2bf16] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET VGPR_32:{ *:[v2bf16] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6671,
      GIR_EraseRootFromParent_Done,
    // Label 2737: @179199
    GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(179255), // Rule ID 4196 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2i16:{ *:[v2i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4196,
      GIR_EraseRootFromParent_Done,
    // Label 2738: @179255
    GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(179311), // Rule ID 4202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2f16:{ *:[v2f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4202,
      GIR_EraseRootFromParent_Done,
    // Label 2739: @179311
    GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(179367), // Rule ID 4208 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2bf16:{ *:[v2bf16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SVS anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4208,
      GIR_EraseRootFromParent_Done,
    // Label 2740: @179367
    GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(179418), // Rule ID 4195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2i16:{ *:[v2i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4195,
      GIR_EraseRootFromParent_Done,
    // Label 2741: @179418
    GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(179469), // Rule ID 4201 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2f16:{ *:[v2f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4201,
      GIR_EraseRootFromParent_Done,
    // Label 2742: @179469
    GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(179520), // Rule ID 4207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2bf16:{ *:[v2bf16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD_SADDR anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4207,
      GIR_EraseRootFromParent_Done,
    // Label 2743: @179520
    GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(179571), // Rule ID 4194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2i16:{ *:[v2i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4194,
      GIR_EraseRootFromParent_Done,
    // Label 2744: @179571
    GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(179622), // Rule ID 4200 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2f16:{ *:[v2f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4200,
      GIR_EraseRootFromParent_Done,
    // Label 2745: @179622
    GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(179673), // Rule ID 4206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2bf16:{ *:[v2bf16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORD anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORD),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4206,
      GIR_EraseRootFromParent_Done,
    // Label 2746: @179673
    GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(179737), // Rule ID 4581 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4581,
      GIR_EraseRootFromParent_Done,
    // Label 2747: @179737
    GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(179798), // Rule ID 4583 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2i16:{ *:[v2i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4583,
      GIR_EraseRootFromParent_Done,
    // Label 2748: @179798
    GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(179862), // Rule ID 4585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4585,
      GIR_EraseRootFromParent_Done,
    // Label 2749: @179862
    GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(179923), // Rule ID 4587 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2f16:{ *:[v2f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4587,
      GIR_EraseRootFromParent_Done,
    // Label 2750: @179923
    GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(179987), // Rule ID 4589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2bf16:{ *:[v2bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_ADDR64 v2bf16:{ *:[v2bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4589,
      GIR_EraseRootFromParent_Done,
    // Label 2751: @179987
    GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(180048), // Rule ID 4591 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2bf16:{ *:[v2bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_ADDR64 v2bf16:{ *:[v2bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4591,
      GIR_EraseRootFromParent_Done,
    // Label 2752: @180048
    GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(180112), // Rule ID 6660 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6660,
      GIR_EraseRootFromParent_Done,
    // Label 2753: @180112
    GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(180176), // Rule ID 6662 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2i16:{ *:[v2i16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2i16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6662,
      GIR_EraseRootFromParent_Done,
    // Label 2754: @180176
    GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(180240), // Rule ID 6664 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6664,
      GIR_EraseRootFromParent_Done,
    // Label 2755: @180240
    GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(180304), // Rule ID 6666 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2f16:{ *:[v2f16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2f16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6666,
      GIR_EraseRootFromParent_Done,
    // Label 2756: @180304
    GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(180368), // Rule ID 6668 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2bf16:{ *:[v2bf16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_OFFEN VGPR_32:{ *:[v2bf16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6668,
      GIR_EraseRootFromParent_Done,
    // Label 2757: @180368
    GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(180432), // Rule ID 6670 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2bf16:{ *:[v2bf16] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN VGPR_32:{ *:[v2bf16] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6670,
      GIR_EraseRootFromParent_Done,
    // Label 2758: @180432
    GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(180491), // Rule ID 4580 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4580,
      GIR_EraseRootFromParent_Done,
    // Label 2759: @180491
    GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(180547), // Rule ID 4582 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i16:{ *:[v2i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4582,
      GIR_EraseRootFromParent_Done,
    // Label 2760: @180547
    GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(180606), // Rule ID 4584 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4584,
      GIR_EraseRootFromParent_Done,
    // Label 2761: @180606
    GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(180662), // Rule ID 4586 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f16:{ *:[v2f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4586,
      GIR_EraseRootFromParent_Done,
    // Label 2762: @180662
    GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(180721), // Rule ID 4588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2bf16:{ *:[v2bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_OFFSET v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4588,
      GIR_EraseRootFromParent_Done,
    // Label 2763: @180721
    GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(180777), // Rule ID 4590 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2bf16:{ *:[v2bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4590,
      GIR_EraseRootFromParent_Done,
    // Label 2764: @180777
    GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(180832), // Rule ID 7964 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7964,
      GIR_EraseRootFromParent_Done,
    // Label 2765: @180832
    GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(180887), // Rule ID 7966 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7966,
      GIR_EraseRootFromParent_Done,
    // Label 2766: @180887
    GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(180942), // Rule ID 7968 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2bf16:{ *:[v2bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7968,
      GIR_EraseRootFromParent_Done,
    // Label 2767: @180942
    GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(180993), // Rule ID 7965 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2i16:{ *:[v2i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7965,
      GIR_EraseRootFromParent_Done,
    // Label 2768: @180993
    GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(181044), // Rule ID 7967 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2f16:{ *:[v2f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7967,
      GIR_EraseRootFromParent_Done,
    // Label 2769: @181044
    GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(181095), // Rule ID 7969 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2bf16:{ *:[v2bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7969,
      GIR_EraseRootFromParent_Done,
    // Label 2770: @181095
    GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(181151), // Rule ID 3824 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2i16:{ *:[v2i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3824,
      GIR_EraseRootFromParent_Done,
    // Label 2771: @181151
    GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(181207), // Rule ID 3828 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2f16:{ *:[v2f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3828,
      GIR_EraseRootFromParent_Done,
    // Label 2772: @181207
    GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(181263), // Rule ID 3832 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2bf16:{ *:[v2bf16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3832,
      GIR_EraseRootFromParent_Done,
    // Label 2773: @181263
    GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(181314), // Rule ID 3823 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2i16:{ *:[v2i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3823,
      GIR_EraseRootFromParent_Done,
    // Label 2774: @181314
    GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(181365), // Rule ID 3827 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2f16:{ *:[v2f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3827,
      GIR_EraseRootFromParent_Done,
    // Label 2775: @181365
    GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(181416), // Rule ID 3831 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2bf16:{ *:[v2bf16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3831,
      GIR_EraseRootFromParent_Done,
    // Label 2776: @181416
    GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(181468), // Rule ID 3583 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2i16:{ *:[v2i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3583,
      GIR_EraseRootFromParent_Done,
    // Label 2777: @181468
    GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(181520), // Rule ID 3585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2f16:{ *:[v2f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3585,
      GIR_EraseRootFromParent_Done,
    // Label 2778: @181520
    GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(181572), // Rule ID 3587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2bf16:{ *:[v2bf16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORD ?:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORD),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3587,
      GIR_EraseRootFromParent_Done,
    // Label 2779: @181572
    GIM_Reject,
    // Label 2431: @181573
    GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(181637), // Rule ID 8146 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8146,
      GIR_EraseRootFromParent_Done,
    // Label 2780: @181637
    GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(181701), // Rule ID 8150 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8150,
      GIR_EraseRootFromParent_Done,
    // Label 2781: @181701
    GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(181760), // Rule ID 8070 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8070,
      GIR_EraseRootFromParent_Done,
    // Label 2782: @181760
    GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(181819), // Rule ID 8074 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8074,
      GIR_EraseRootFromParent_Done,
    // Label 2783: @181819
    GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(181879), // Rule ID 8147 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8147,
      GIR_EraseRootFromParent_Done,
    // Label 2784: @181879
    GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(181939), // Rule ID 8151 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8151,
      GIR_EraseRootFromParent_Done,
    // Label 2785: @181939
    GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(181994), // Rule ID 8071 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2i32:{ *:[v2i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8071,
      GIR_EraseRootFromParent_Done,
    // Label 2786: @181994
    GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(182049), // Rule ID 8075 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2f32:{ *:[v2f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v2f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8075,
      GIR_EraseRootFromParent_Done,
    // Label 2787: @182049
    GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(182108), // Rule ID 6689 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6689,
      GIR_EraseRootFromParent_Done,
    // Label 2788: @182108
    GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(182167), // Rule ID 6691 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6691,
      GIR_EraseRootFromParent_Done,
    // Label 2789: @182167
    GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(182223), // Rule ID 4250 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2i32:{ *:[v2i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4250,
      GIR_EraseRootFromParent_Done,
    // Label 2790: @182223
    GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(182279), // Rule ID 4256 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2f32:{ *:[v2f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4256,
      GIR_EraseRootFromParent_Done,
    // Label 2791: @182279
    GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(182330), // Rule ID 4249 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2i32:{ *:[v2i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4249,
      GIR_EraseRootFromParent_Done,
    // Label 2792: @182330
    GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(182381), // Rule ID 4255 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2f32:{ *:[v2f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4255,
      GIR_EraseRootFromParent_Done,
    // Label 2793: @182381
    GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(182432), // Rule ID 4248 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2i32:{ *:[v2i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4248,
      GIR_EraseRootFromParent_Done,
    // Label 2794: @182432
    GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(182483), // Rule ID 4254 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2f32:{ *:[v2f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4254,
      GIR_EraseRootFromParent_Done,
    // Label 2795: @182483
    GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(182547), // Rule ID 4617 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4617,
      GIR_EraseRootFromParent_Done,
    // Label 2796: @182547
    GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(182608), // Rule ID 4619 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2i32:{ *:[v2i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4619,
      GIR_EraseRootFromParent_Done,
    // Label 2797: @182608
    GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(182672), // Rule ID 4621 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4621,
      GIR_EraseRootFromParent_Done,
    // Label 2798: @182672
    GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(182733), // Rule ID 4623 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v2f32:{ *:[v2f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4623,
      GIR_EraseRootFromParent_Done,
    // Label 2799: @182733
    GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(182797), // Rule ID 6688 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6688,
      GIR_EraseRootFromParent_Done,
    // Label 2800: @182797
    GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(182861), // Rule ID 6690 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v2i32:{ *:[v2i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN VReg_64:{ *:[v2i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6690,
      GIR_EraseRootFromParent_Done,
    // Label 2801: @182861
    GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(182981), // Rule ID 8005 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8005,
      GIR_EraseRootFromParent_Done,
    // Label 2802: @182981
    GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(183101), // Rule ID 8009 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8009,
      GIR_EraseRootFromParent_Done,
    // Label 2803: @183101
    GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(183160), // Rule ID 4616 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4616,
      GIR_EraseRootFromParent_Done,
    // Label 2804: @183160
    GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(183216), // Rule ID 4618 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i32:{ *:[v2i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4618,
      GIR_EraseRootFromParent_Done,
    // Label 2805: @183216
    GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(183275), // Rule ID 4620 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4620,
      GIR_EraseRootFromParent_Done,
    // Label 2806: @183275
    GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(183331), // Rule ID 4622 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f32:{ *:[v2f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4622,
      GIR_EraseRootFromParent_Done,
    // Label 2807: @183331
    GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(183447), // Rule ID 8007 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st v2i32:{ *:[v2i32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2i32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8007,
      GIR_EraseRootFromParent_Done,
    // Label 2808: @183447
    GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(183563), // Rule ID 8011 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st v2f32:{ *:[v2f32] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v2f32] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8011,
      GIR_EraseRootFromParent_Done,
    // Label 2809: @183563
    GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(183619), // Rule ID 3860 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2i32:{ *:[v2i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3860,
      GIR_EraseRootFromParent_Done,
    // Label 2810: @183619
    GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(183675), // Rule ID 3864 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2f32:{ *:[v2f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3864,
      GIR_EraseRootFromParent_Done,
    // Label 2811: @183675
    GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(183726), // Rule ID 3859 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2i32:{ *:[v2i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3859,
      GIR_EraseRootFromParent_Done,
    // Label 2812: @183726
    GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(183777), // Rule ID 3863 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2f32:{ *:[v2f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3863,
      GIR_EraseRootFromParent_Done,
    // Label 2813: @183777
    GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(183829), // Rule ID 3600 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2i32:{ *:[v2i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3600,
      GIR_EraseRootFromParent_Done,
    // Label 2814: @183829
    GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(183881), // Rule ID 3602 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2f32:{ *:[v2f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3602,
      GIR_EraseRootFromParent_Done,
    // Label 2815: @183881
    GIM_Reject,
    // Label 2432: @183882
    GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(183946), // Rule ID 8194 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8194,
      GIR_EraseRootFromParent_Done,
    // Label 2816: @183946
    GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(184010), // Rule ID 8198 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8198,
      GIR_EraseRootFromParent_Done,
    // Label 2817: @184010
    GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(184069), // Rule ID 8118 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8118,
      GIR_EraseRootFromParent_Done,
    // Label 2818: @184069
    GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(184128), // Rule ID 8122 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8122,
      GIR_EraseRootFromParent_Done,
    // Label 2819: @184128
    GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(184188), // Rule ID 8195 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8195,
      GIR_EraseRootFromParent_Done,
    // Label 2820: @184188
    GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(184248), // Rule ID 8199 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8199,
      GIR_EraseRootFromParent_Done,
    // Label 2821: @184248
    GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(184303), // Rule ID 8119 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2i64:{ *:[v2i64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8119,
      GIR_EraseRootFromParent_Done,
    // Label 2822: @184303
    GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(184358), // Rule ID 8123 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v2f64:{ *:[v2f64] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v2f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8123,
      GIR_EraseRootFromParent_Done,
    // Label 2823: @184358
    GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(184414), // Rule ID 4313 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2i64:{ *:[v2i64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4313,
      GIR_EraseRootFromParent_Done,
    // Label 2824: @184414
    GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(184470), // Rule ID 4319 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v2f64:{ *:[v2f64] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4319,
      GIR_EraseRootFromParent_Done,
    // Label 2825: @184470
    GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(184521), // Rule ID 4312 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2i64:{ *:[v2i64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4312,
      GIR_EraseRootFromParent_Done,
    // Label 2826: @184521
    GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(184572), // Rule ID 4318 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v2f64:{ *:[v2f64] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4318,
      GIR_EraseRootFromParent_Done,
    // Label 2827: @184572
    GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(184623), // Rule ID 4311 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2i64:{ *:[v2i64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4311,
      GIR_EraseRootFromParent_Done,
    // Label 2828: @184623
    GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(184674), // Rule ID 4317 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v2f64:{ *:[v2f64] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4317,
      GIR_EraseRootFromParent_Done,
    // Label 2829: @184674
    GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(184738), // Rule ID 4665 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4665,
      GIR_EraseRootFromParent_Done,
    // Label 2830: @184738
    GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(184799), // Rule ID 4667 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2i64:{ *:[v2i64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4667,
      GIR_EraseRootFromParent_Done,
    // Label 2831: @184799
    GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(184863), // Rule ID 4669 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4669,
      GIR_EraseRootFromParent_Done,
    // Label 2832: @184863
    GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(184924), // Rule ID 4671 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v2f64:{ *:[v2f64] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4671,
      GIR_EraseRootFromParent_Done,
    // Label 2833: @184924
    GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(185044), // Rule ID 8041 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8041,
      GIR_EraseRootFromParent_Done,
    // Label 2834: @185044
    GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(185164), // Rule ID 8045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8045,
      GIR_EraseRootFromParent_Done,
    // Label 2835: @185164
    GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(185223), // Rule ID 4664 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4664,
      GIR_EraseRootFromParent_Done,
    // Label 2836: @185223
    GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(185279), // Rule ID 4666 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2i64:{ *:[v2i64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4666,
      GIR_EraseRootFromParent_Done,
    // Label 2837: @185279
    GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(185338), // Rule ID 4668 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4668,
      GIR_EraseRootFromParent_Done,
    // Label 2838: @185338
    GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(185394), // Rule ID 4670 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v2f64:{ *:[v2f64] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4670,
      GIR_EraseRootFromParent_Done,
    // Label 2839: @185394
    GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(185510), // Rule ID 8043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v2i64:{ *:[v2i64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2i64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8043,
      GIR_EraseRootFromParent_Done,
    // Label 2840: @185510
    GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(185626), // Rule ID 8047 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v2f64:{ *:[v2f64] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8047,
      GIR_EraseRootFromParent_Done,
    // Label 2841: @185626
    GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(185682), // Rule ID 3902 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2i64:{ *:[v2i64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3902,
      GIR_EraseRootFromParent_Done,
    // Label 2842: @185682
    GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(185738), // Rule ID 3906 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v2f64:{ *:[v2f64] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3906,
      GIR_EraseRootFromParent_Done,
    // Label 2843: @185738
    GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(185789), // Rule ID 3901 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2i64:{ *:[v2i64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3901,
      GIR_EraseRootFromParent_Done,
    // Label 2844: @185789
    GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(185840), // Rule ID 3905 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v2f64:{ *:[v2f64] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3905,
      GIR_EraseRootFromParent_Done,
    // Label 2845: @185840
    GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(185892), // Rule ID 3622 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2i64:{ *:[v2i64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3622,
      GIR_EraseRootFromParent_Done,
    // Label 2846: @185892
    GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(185944), // Rule ID 3624 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v2f64:{ *:[v2f64] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2f64] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3624,
      GIR_EraseRootFromParent_Done,
    // Label 2847: @185944
    GIM_Reject,
    // Label 2433: @185945
    GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(186000), // Rule ID 8178 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8178,
      GIR_EraseRootFromParent_Done,
    // Label 2848: @186000
    GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(186055), // Rule ID 8182 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8182,
      GIR_EraseRootFromParent_Done,
    // Label 2849: @186055
    GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(186114), // Rule ID 8102 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8102,
      GIR_EraseRootFromParent_Done,
    // Label 2850: @186114
    GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(186173), // Rule ID 8106 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B96 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8106,
      GIR_EraseRootFromParent_Done,
    // Label 2851: @186173
    GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(186224), // Rule ID 8179 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8179,
      GIR_EraseRootFromParent_Done,
    // Label 2852: @186224
    GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(186275), // Rule ID 8183 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8183,
      GIR_EraseRootFromParent_Done,
    // Label 2853: @186275
    GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(186330), // Rule ID 8103 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v3i32:{ *:[v3i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8103,
      GIR_EraseRootFromParent_Done,
    // Label 2854: @186330
    GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(186385), // Rule ID 8107 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v3f32:{ *:[v3f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B96_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9449:{ *:[v3f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B96_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8107,
      GIR_EraseRootFromParent_Done,
    // Label 2855: @186385
    GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(186444), // Rule ID 6693 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6693,
      GIR_EraseRootFromParent_Done,
    // Label 2856: @186444
    GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(186503), // Rule ID 6695 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET VReg_96:{ *:[v3i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6695,
      GIR_EraseRootFromParent_Done,
    // Label 2857: @186503
    GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(186559), // Rule ID 4352 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v3i32:{ *:[v3i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SVS anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4352,
      GIR_EraseRootFromParent_Done,
    // Label 2858: @186559
    GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(186610), // Rule ID 4351 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v3i32:{ *:[v3i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3_SADDR anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4351,
      GIR_EraseRootFromParent_Done,
    // Label 2859: @186610
    GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(186661), // Rule ID 4350 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v3i32:{ *:[v3i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX3 anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX3),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4350,
      GIR_EraseRootFromParent_Done,
    // Label 2860: @186661
    GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(186725), // Rule ID 4649 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4649,
      GIR_EraseRootFromParent_Done,
    // Label 2861: @186725
    GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(186786), // Rule ID 4651 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3i32:{ *:[v3i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4651,
      GIR_EraseRootFromParent_Done,
    // Label 2862: @186786
    GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(186850), // Rule ID 4653 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4653,
      GIR_EraseRootFromParent_Done,
    // Label 2863: @186850
    GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(186911), // Rule ID 4655 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_ADDR64 v3f32:{ *:[v3f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4655,
      GIR_EraseRootFromParent_Done,
    // Label 2864: @186911
    GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(186975), // Rule ID 6692 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6692,
      GIR_EraseRootFromParent_Done,
    // Label 2865: @186975
    GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(187039), // Rule ID 6694 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v3i32:{ *:[v3i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN VReg_96:{ *:[v3i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6694,
      GIR_EraseRootFromParent_Done,
    // Label 2866: @187039
    GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(187098), // Rule ID 4648 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4648,
      GIR_EraseRootFromParent_Done,
    // Label 2867: @187098
    GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(187154), // Rule ID 4650 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v3i32:{ *:[v3i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4650,
      GIR_EraseRootFromParent_Done,
    // Label 2868: @187154
    GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(187213), // Rule ID 4652 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4652,
      GIR_EraseRootFromParent_Done,
    // Label 2869: @187213
    GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(187269), // Rule ID 4654 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v3f32:{ *:[v3f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4654,
      GIR_EraseRootFromParent_Done,
    // Label 2870: @187269
    GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(187325), // Rule ID 3932 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v3i32:{ *:[v3i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3_SADDR ?:{ *:[i32] }:$voffset, anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3932,
      GIR_EraseRootFromParent_Done,
    // Label 2871: @187325
    GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(187376), // Rule ID 3931 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v3i32:{ *:[v3i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX3),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3931,
      GIR_EraseRootFromParent_Done,
    // Label 2872: @187376
    GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(187428), // Rule ID 3616 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v3i32:{ *:[v3i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX3 ?:{ *:[i64] }:$vaddr, anonymous_9449:{ *:[v3i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX3),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3616,
      GIR_EraseRootFromParent_Done,
    // Label 2873: @187428
    GIM_Reject,
    // Label 2434: @187429
    GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(187493), // Rule ID 8154 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8154,
      GIR_EraseRootFromParent_Done,
    // Label 2874: @187493
    GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(187557), // Rule ID 8158 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4bf16:{ *:[v4bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8158,
      GIR_EraseRootFromParent_Done,
    // Label 2875: @187557
    GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(187621), // Rule ID 8162 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8162,
      GIR_EraseRootFromParent_Done,
    // Label 2876: @187621
    GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(187680), // Rule ID 8078 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8078,
      GIR_EraseRootFromParent_Done,
    // Label 2877: @187680
    GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(187739), // Rule ID 8082 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4bf16:{ *:[v4bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8082,
      GIR_EraseRootFromParent_Done,
    // Label 2878: @187739
    GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(187798), // Rule ID 8086 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align8_local_m0>>  =>  (DS_WRITE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8086,
      GIR_EraseRootFromParent_Done,
    // Label 2879: @187798
    GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(187858), // Rule ID 8155 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8155,
      GIR_EraseRootFromParent_Done,
    // Label 2880: @187858
    GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(187918), // Rule ID 8159 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4bf16:{ *:[v4bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8159,
      GIR_EraseRootFromParent_Done,
    // Label 2881: @187918
    GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(187978), // Rule ID 8163 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8163,
      GIR_EraseRootFromParent_Done,
    // Label 2882: @187978
    GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(188033), // Rule ID 8079 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4f16:{ *:[v4f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8079,
      GIR_EraseRootFromParent_Done,
    // Label 2883: @188033
    GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(188088), // Rule ID 8083 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4bf16:{ *:[v4bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8083,
      GIR_EraseRootFromParent_Done,
    // Label 2884: @188088
    GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(188143), // Rule ID 8087 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/8,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4i16:{ *:[v4i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align8_local>>  =>  (DS_WRITE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[v4i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8087,
      GIR_EraseRootFromParent_Done,
    // Label 2885: @188143
    GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(188199), // Rule ID 4262 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v4f16:{ *:[v4f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4262,
      GIR_EraseRootFromParent_Done,
    // Label 2886: @188199
    GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(188255), // Rule ID 4268 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v4bf16:{ *:[v4bf16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4268,
      GIR_EraseRootFromParent_Done,
    // Label 2887: @188255
    GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(188311), // Rule ID 4274 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v4i16:{ *:[v4i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SVS anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4274,
      GIR_EraseRootFromParent_Done,
    // Label 2888: @188311
    GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(188362), // Rule ID 4261 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v4f16:{ *:[v4f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4261,
      GIR_EraseRootFromParent_Done,
    // Label 2889: @188362
    GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(188413), // Rule ID 4267 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v4bf16:{ *:[v4bf16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4267,
      GIR_EraseRootFromParent_Done,
    // Label 2890: @188413
    GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(188464), // Rule ID 4273 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v4i16:{ *:[v4i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2_SADDR anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4273,
      GIR_EraseRootFromParent_Done,
    // Label 2891: @188464
    GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(188515), // Rule ID 4260 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v4f16:{ *:[v4f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4260,
      GIR_EraseRootFromParent_Done,
    // Label 2892: @188515
    GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(188566), // Rule ID 4266 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v4bf16:{ *:[v4bf16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4266,
      GIR_EraseRootFromParent_Done,
    // Label 2893: @188566
    GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(188617), // Rule ID 4272 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v4i16:{ *:[v4i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX2 anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX2),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4272,
      GIR_EraseRootFromParent_Done,
    // Label 2894: @188617
    GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(188681), // Rule ID 4625 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4625,
      GIR_EraseRootFromParent_Done,
    // Label 2895: @188681
    GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(188742), // Rule ID 4627 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4f16:{ *:[v4f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4627,
      GIR_EraseRootFromParent_Done,
    // Label 2896: @188742
    GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(188806), // Rule ID 4629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4bf16:{ *:[v4bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4bf16:{ *:[v4bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4629,
      GIR_EraseRootFromParent_Done,
    // Label 2897: @188806
    GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(188867), // Rule ID 4631 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4bf16:{ *:[v4bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4bf16:{ *:[v4bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4631,
      GIR_EraseRootFromParent_Done,
    // Label 2898: @188867
    GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(188931), // Rule ID 4633 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4633,
      GIR_EraseRootFromParent_Done,
    // Label 2899: @188931
    GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(188992), // Rule ID 4635 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_ADDR64 v4i16:{ *:[v4i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4635,
      GIR_EraseRootFromParent_Done,
    // Label 2900: @188992
    GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(189112), // Rule ID 8013 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8013,
      GIR_EraseRootFromParent_Done,
    // Label 2901: @189112
    GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(189232), // Rule ID 8017 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue v4bf16:{ *:[v4bf16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4bf16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4bf16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8017,
      GIR_EraseRootFromParent_Done,
    // Label 2902: @189232
    GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(189352), // Rule ID 8021 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (AMDGPUst_glue v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B32 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8021,
      GIR_EraseRootFromParent_Done,
    // Label 2903: @189352
    GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(189411), // Rule ID 4624 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4624,
      GIR_EraseRootFromParent_Done,
    // Label 2904: @189411
    GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(189467), // Rule ID 4626 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4f16:{ *:[v4f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4626,
      GIR_EraseRootFromParent_Done,
    // Label 2905: @189467
    GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(189526), // Rule ID 4628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4bf16:{ *:[v4bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4628,
      GIR_EraseRootFromParent_Done,
    // Label 2906: @189526
    GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(189582), // Rule ID 4630 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4bf16:{ *:[v4bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4630,
      GIR_EraseRootFromParent_Done,
    // Label 2907: @189582
    GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(189641), // Rule ID 4632 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4632,
      GIR_EraseRootFromParent_Done,
    // Label 2908: @189641
    GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(189697), // Rule ID 4634 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4i16:{ *:[v4i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4634,
      GIR_EraseRootFromParent_Done,
    // Label 2909: @189697
    GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(189813), // Rule ID 8015 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st v4f16:{ *:[v4f16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4f16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8015,
      GIR_EraseRootFromParent_Done,
    // Label 2910: @189813
    GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(189929), // Rule ID 8019 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st v4bf16:{ *:[v4bf16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4bf16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4bf16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8019,
      GIR_EraseRootFromParent_Done,
    // Label 2911: @189929
    GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(190045), // Rule ID 8023 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_64bit_4byte_aligned),
      // (st v4i16:{ *:[v4i16] }:$value, (DS64Bit4ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B32_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[v4i16] }:$value, sub1:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(11), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(3), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B32_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8023,
      GIR_EraseRootFromParent_Done,
    // Label 2912: @190045
    GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(190101), // Rule ID 3868 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v4f16:{ *:[v4f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3868,
      GIR_EraseRootFromParent_Done,
    // Label 2913: @190101
    GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(190157), // Rule ID 3872 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v4bf16:{ *:[v4bf16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3872,
      GIR_EraseRootFromParent_Done,
    // Label 2914: @190157
    GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(190213), // Rule ID 3876 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v4i16:{ *:[v4i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3876,
      GIR_EraseRootFromParent_Done,
    // Label 2915: @190213
    GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(190264), // Rule ID 3867 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v4f16:{ *:[v4f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3867,
      GIR_EraseRootFromParent_Done,
    // Label 2916: @190264
    GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(190315), // Rule ID 3871 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v4bf16:{ *:[v4bf16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3871,
      GIR_EraseRootFromParent_Done,
    // Label 2917: @190315
    GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(190366), // Rule ID 3875 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v4i16:{ *:[v4i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3875,
      GIR_EraseRootFromParent_Done,
    // Label 2918: @190366
    GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(190418), // Rule ID 3604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v4f16:{ *:[v4f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3604,
      GIR_EraseRootFromParent_Done,
    // Label 2919: @190418
    GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(190470), // Rule ID 3606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v4bf16:{ *:[v4bf16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3606,
      GIR_EraseRootFromParent_Done,
    // Label 2920: @190470
    GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(190522), // Rule ID 3608 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v4i16:{ *:[v4i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX2 ?:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v4i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX2),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3608,
      GIR_EraseRootFromParent_Done,
    // Label 2921: @190522
    GIM_Reject,
    // Label 2435: @190523
    GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(190587), // Rule ID 8186 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8186,
      GIR_EraseRootFromParent_Done,
    // Label 2922: @190587
    GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(190651), // Rule ID 8190 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8190,
      GIR_EraseRootFromParent_Done,
    // Label 2923: @190651
    GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(190710), // Rule ID 8110 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8110,
      GIR_EraseRootFromParent_Done,
    // Label 2924: @190710
    GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(190769), // Rule ID 8114 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8114,
      GIR_EraseRootFromParent_Done,
    // Label 2925: @190769
    GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(190829), // Rule ID 8187 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8187,
      GIR_EraseRootFromParent_Done,
    // Label 2926: @190829
    GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(190889), // Rule ID 8191 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8191,
      GIR_EraseRootFromParent_Done,
    // Label 2927: @190889
    GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(190944), // Rule ID 8111 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4i32:{ *:[v4i32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8111,
      GIR_EraseRootFromParent_Done,
    // Label 2928: @190944
    GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(190999), // Rule ID 8115 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v4f32:{ *:[v4f32] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v4f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8115,
      GIR_EraseRootFromParent_Done,
    // Label 2929: @190999
    GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(191058), // Rule ID 6697 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6697,
      GIR_EraseRootFromParent_Done,
    // Label 2930: @191058
    GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(191117), // Rule ID 6699 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offset),
      // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET VReg_128:{ *:[v4i32] }:$value, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6699,
      GIR_EraseRootFromParent_Done,
    // Label 2931: @191117
    GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(191173), // Rule ID 4301 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v4i32:{ *:[v4i32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4301,
      GIR_EraseRootFromParent_Done,
    // Label 2932: @191173
    GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(191229), // Rule ID 4307 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v4f32:{ *:[v4f32] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4307,
      GIR_EraseRootFromParent_Done,
    // Label 2933: @191229
    GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(191280), // Rule ID 4300 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v4i32:{ *:[v4i32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4300,
      GIR_EraseRootFromParent_Done,
    // Label 2934: @191280
    GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(191331), // Rule ID 4306 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v4f32:{ *:[v4f32] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4306,
      GIR_EraseRootFromParent_Done,
    // Label 2935: @191331
    GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(191382), // Rule ID 4299 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v4i32:{ *:[v4i32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4299,
      GIR_EraseRootFromParent_Done,
    // Label 2936: @191382
    GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(191433), // Rule ID 4305 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v4f32:{ *:[v4f32] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4305,
      GIR_EraseRootFromParent_Done,
    // Label 2937: @191433
    GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(191497), // Rule ID 4657 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4657,
      GIR_EraseRootFromParent_Done,
    // Label 2938: @191497
    GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(191558), // Rule ID 4659 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4i32:{ *:[v4i32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4659,
      GIR_EraseRootFromParent_Done,
    // Label 2939: @191558
    GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(191622), // Rule ID 4661 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4661,
      GIR_EraseRootFromParent_Done,
    // Label 2940: @191622
    GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(191683), // Rule ID 4663 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v4f32:{ *:[v4f32] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4663,
      GIR_EraseRootFromParent_Done,
    // Label 2941: @191683
    GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(191747), // Rule ID 6696 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6696,
      GIR_EraseRootFromParent_Done,
    // Label 2942: @191747
    GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(191811), // Rule ID 6698 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_DisableFlatScratch),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_scratch_offen),
      // (st v4i32:{ *:[v4i32] }:$value, (MUBUFScratchOffen:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN VReg_128:{ *:[v4i32] }:$value, ?:{ *:[i32] }:$vaddr, ?:{ *:[v4i32] }:$srsrc, ?:{ *:[i32] }:$soffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] }, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN),
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6698,
      GIR_EraseRootFromParent_Done,
    // Label 2943: @191811
    GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(191931), // Rule ID 7997 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7997,
      GIR_EraseRootFromParent_Done,
    // Label 2944: @191931
    GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(192051), // Rule ID 8037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8037,
      GIR_EraseRootFromParent_Done,
    // Label 2945: @192051
    GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(192110), // Rule ID 4656 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4656,
      GIR_EraseRootFromParent_Done,
    // Label 2946: @192110
    GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(192166), // Rule ID 4658 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4i32:{ *:[v4i32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4658,
      GIR_EraseRootFromParent_Done,
    // Label 2947: @192166
    GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(192225), // Rule ID 4660 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4660,
      GIR_EraseRootFromParent_Done,
    // Label 2948: @192225
    GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(192281), // Rule ID 4662 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v4f32:{ *:[v4f32] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4662,
      GIR_EraseRootFromParent_Done,
    // Label 2949: @192281
    GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(192397), // Rule ID 7999 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v4i32:{ *:[v4i32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4i32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7999,
      GIR_EraseRootFromParent_Done,
    // Label 2950: @192397
    GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(192513), // Rule ID 8039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v4f32:{ *:[v4f32] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v4f32] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8039,
      GIR_EraseRootFromParent_Done,
    // Label 2951: @192513
    GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(192569), // Rule ID 3894 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v4i32:{ *:[v4i32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3894,
      GIR_EraseRootFromParent_Done,
    // Label 2952: @192569
    GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(192625), // Rule ID 3898 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v4f32:{ *:[v4f32] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3898,
      GIR_EraseRootFromParent_Done,
    // Label 2953: @192625
    GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(192676), // Rule ID 3893 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v4i32:{ *:[v4i32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3893,
      GIR_EraseRootFromParent_Done,
    // Label 2954: @192676
    GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(192727), // Rule ID 3897 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v4f32:{ *:[v4f32] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3897,
      GIR_EraseRootFromParent_Done,
    // Label 2955: @192727
    GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(192779), // Rule ID 3618 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v4i32:{ *:[v4i32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v4i32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3618,
      GIR_EraseRootFromParent_Done,
    // Label 2956: @192779
    GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(192831), // Rule ID 3620 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v4f32:{ *:[v4f32] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v4f32] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3620,
      GIR_EraseRootFromParent_Done,
    // Label 2957: @192831
    GIM_Reject,
    // Label 2436: @192832
    GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(192896), // Rule ID 8202 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8202,
      GIR_EraseRootFromParent_Done,
    // Label 2958: @192896
    GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(192960), // Rule ID 8206 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8206,
      GIR_EraseRootFromParent_Done,
    // Label 2959: @192960
    GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(193024), // Rule ID 8210 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_LDSRequiresM0Init),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local_m0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8bf16:{ *:[v8bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align_less_than_4_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8210,
      GIR_EraseRootFromParent_Done,
    // Label 2960: @193024
    GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(193083), // Rule ID 8126 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8126,
      GIR_EraseRootFromParent_Done,
    // Label 2961: @193083
    GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(193142), // Rule ID 8130 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8130,
      GIR_EraseRootFromParent_Done,
    // Label 2962: @193142
    GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(193201), // Rule ID 8134 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (AMDGPUst_glue v8bf16:{ *:[v8bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>><<P:Predicate_store_align16_local_m0>>  =>  (DS_WRITE_B128 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8134,
      GIR_EraseRootFromParent_Done,
    // Label 2963: @193201
    GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(193261), // Rule ID 8203 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8203,
      GIR_EraseRootFromParent_Done,
    // Label 2964: @193261
    GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(193321), // Rule ID 8207 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8207,
      GIR_EraseRootFromParent_Done,
    // Label 2965: @193321
    GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(193381), // Rule ID 8211 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnalignedAccessMode_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_store_align_less_than_4_local),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8bf16:{ *:[v8bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align_less_than_4_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8211,
      GIR_EraseRootFromParent_Done,
    // Label 2966: @193381
    GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(193436), // Rule ID 8127 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8i16:{ *:[v8i16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8i16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8127,
      GIR_EraseRootFromParent_Done,
    // Label 2967: @193436
    GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(193491), // Rule ID 8131 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8f16:{ *:[v8f16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8131,
      GIR_EraseRootFromParent_Done,
    // Label 2968: @193491
    GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(193546), // Rule ID 8135 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckMemoryAlignment, /*MI*/0, /*MMO*/0, /*MinAlign*/16,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
      // (st v8bf16:{ *:[v8bf16] }:$value, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>><<P:Predicate_store_align16_local>>  =>  (DS_WRITE_B128_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9448:{ *:[v8bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE_B128_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_RootToRootCopy, /*OpIdx*/0, // value
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8135,
      GIR_EraseRootFromParent_Done,
    // Label 2969: @193546
    GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(193602), // Rule ID 4325 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v8i16:{ *:[v8i16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4325,
      GIR_EraseRootFromParent_Done,
    // Label 2970: @193602
    GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(193658), // Rule ID 4331 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v8f16:{ *:[v8f16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4331,
      GIR_EraseRootFromParent_Done,
    // Label 2971: @193658
    GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(193714), // Rule ID 4337 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts_HasFlatScratchSVSMode),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_svaddr),
      // (st v8bf16:{ *:[v8bf16] }:$data, (ScratchSVAddr:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SVS anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SVS),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4337,
      GIR_EraseRootFromParent_Done,
    // Label 2972: @193714
    GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(193765), // Rule ID 4324 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v8i16:{ *:[v8i16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4324,
      GIR_EraseRootFromParent_Done,
    // Label 2973: @193765
    GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(193816), // Rule ID 4330 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v8f16:{ *:[v8f16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4330,
      GIR_EraseRootFromParent_Done,
    // Label 2974: @193816
    GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(193867), // Rule ID 4336 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_saddr),
      // (st v8bf16:{ *:[v8bf16] }:$data, (ScratchSAddr:{ *:[iPTR] } SGPR_32:{ *:[i32] }:$saddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4_SADDR anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i32] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4_SADDR),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4336,
      GIR_EraseRootFromParent_Done,
    // Label 2975: @193867
    GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(193918), // Rule ID 4323 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v8i16:{ *:[v8i16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4323,
      GIR_EraseRootFromParent_Done,
    // Label 2976: @193918
    GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(193969), // Rule ID 4329 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v8f16:{ *:[v8f16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4329,
      GIR_EraseRootFromParent_Done,
    // Label 2977: @193969
    GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(194020), // Rule ID 4335 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_EnableFlatScratch_HasFlatScratchInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/5,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_scratch_offset),
      // (st v8bf16:{ *:[v8bf16] }:$data, (ScratchOffset:{ *:[iPTR] } VGPR_32:{ *:[i32] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_private>>  =>  (SCRATCH_STORE_DWORDX4 anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i32] }:$vaddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCRATCH_STORE_DWORDX4),
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4335,
      GIR_EraseRootFromParent_Done,
    // Label 2978: @194020
    GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(194084), // Rule ID 4673 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4673,
      GIR_EraseRootFromParent_Done,
    // Label 2979: @194084
    GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(194145), // Rule ID 4675 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8i16:{ *:[v8i16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4675,
      GIR_EraseRootFromParent_Done,
    // Label 2980: @194145
    GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(194209), // Rule ID 4677 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4677,
      GIR_EraseRootFromParent_Done,
    // Label 2981: @194209
    GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(194270), // Rule ID 4679 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8f16:{ *:[v8f16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4679,
      GIR_EraseRootFromParent_Done,
    // Label 2982: @194270
    GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(194334), // Rule ID 4681 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8bf16:{ *:[v8bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_ADDR64 v8bf16:{ *:[v8bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4681,
      GIR_EraseRootFromParent_Done,
    // Label 2983: @194334
    GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(194395), // Rule ID 4683 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
      // (st v8bf16:{ *:[v8bf16] }:$vdata, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_ADDR64 v8bf16:{ *:[v8bf16] }:$vdata, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_ADDR64),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4683,
      GIR_EraseRootFromParent_Done,
    // Label 2984: @194395
    GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(194515), // Rule ID 8049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8049,
      GIR_EraseRootFromParent_Done,
    // Label 2985: @194515
    GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(194635), // Rule ID 8053 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8053,
      GIR_EraseRootFromParent_Done,
    // Label 2986: @194635
    GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(194755), // Rule ID 8057 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX7Plus),
      GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (AMDGPUst_glue v8bf16:{ *:[v8bf16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore_glue>><<P:Predicate_store_glue>><<P:Predicate_store_local_m0>>  =>  (DS_WRITE2_B64 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8bf16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8bf16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8057,
      GIR_EraseRootFromParent_Done,
    // Label 2987: @194755
    GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(194814), // Rule ID 4672 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4672,
      GIR_EraseRootFromParent_Done,
    // Label 2988: @194814
    GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(194870), // Rule ID 4674 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8i16:{ *:[v8i16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4674,
      GIR_EraseRootFromParent_Done,
    // Label 2989: @194870
    GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(194929), // Rule ID 4676 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4676,
      GIR_EraseRootFromParent_Done,
    // Label 2990: @194929
    GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(194985), // Rule ID 4678 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8f16:{ *:[v8f16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4678,
      GIR_EraseRootFromParent_Done,
    // Label 2991: @194985
    GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(195044), // Rule ID 4680 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8bf16:{ *:[v8bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_OFFSET v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4680,
      GIR_EraseRootFromParent_Done,
    // Label 2992: @195044
    GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(195100), // Rule ID 4682 //
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
      // (st v8bf16:{ *:[v8bf16] }:$vdata, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET),
      GIR_RootToRootCopy, /*OpIdx*/0, // vdata
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 4682,
      GIR_EraseRootFromParent_Done,
    // Label 2993: @195100
    GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(195216), // Rule ID 8051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v8i16:{ *:[v8i16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8i16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8051,
      GIR_EraseRootFromParent_Done,
    // Label 2994: @195216
    GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(195332), // Rule ID 8055 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v8f16:{ *:[v8f16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8f16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8055,
      GIR_EraseRootFromParent_Done,
    // Label 2995: @195332
    GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(195448), // Rule ID 8059 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_128bit_8byte_aligned),
      // (st v8bf16:{ *:[v8bf16] }:$value, (DS128Bit8ByteAligned:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset0, i32:{ *:[i32] }:$offset1))<<P:Predicate_unindexedstore>><<P:Predicate_store_local>>  =>  (DS_WRITE2_B64_gfx9 ?:{ *:[i32] }:$ptr, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8bf16] }:$value, sub0_sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v8bf16] }:$value, sub2_sub3:{ *:[i32] }), ?:{ *:[i32] }:$offset0, ?:{ *:[i32] }:$offset1, 0:{ *:[i1] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(24), // value
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(4), // value
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRITE2_B64_gfx9),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8059,
      GIR_EraseRootFromParent_Done,
    // Label 2996: @195448
    GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(195504), // Rule ID 3910 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v8i16:{ *:[v8i16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3910,
      GIR_EraseRootFromParent_Done,
    // Label 2997: @195504
    GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(195560), // Rule ID 3914 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v8f16:{ *:[v8f16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3914,
      GIR_EraseRootFromParent_Done,
    // Label 2998: @195560
    GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(195616), // Rule ID 3918 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
      // (st v8bf16:{ *:[v8bf16] }:$data, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4_SADDR),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3918,
      GIR_EraseRootFromParent_Done,
    // Label 2999: @195616
    GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(195667), // Rule ID 3909 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v8i16:{ *:[v8i16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3909,
      GIR_EraseRootFromParent_Done,
    // Label 3000: @195667
    GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(195718), // Rule ID 3913 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v8f16:{ *:[v8f16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3913,
      GIR_EraseRootFromParent_Done,
    // Label 3001: @195718
    GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(195769), // Rule ID 3917 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
      // (st v8bf16:{ *:[v8bf16] }:$data, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_global>>  =>  (GLOBAL_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3917,
      GIR_EraseRootFromParent_Done,
    // Label 3002: @195769
    GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(195821), // Rule ID 3626 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v8i16:{ *:[v8i16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8i16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3626,
      GIR_EraseRootFromParent_Done,
    // Label 3003: @195821
    GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(195873), // Rule ID 3628 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v8f16:{ *:[v8f16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8f16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3628,
      GIR_EraseRootFromParent_Done,
    // Label 3004: @195873
    GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(195925), // Rule ID 3630 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
      GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/2, /*AddrSpace*/0, /*AddrSpace*/1,
      GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
      // (st v8bf16:{ *:[v8bf16] }:$data, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store_flat>>  =>  (FLAT_STORE_DWORDX4 ?:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v8bf16] }:$data, ?:{ *:[i32] }:$offset)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_STORE_DWORDX4),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
      GIR_RootToRootCopy, /*OpIdx*/0, // data
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 3630,
      GIR_EraseRootFromParent_Done,
    // Label 3005: @195925
    GIM_Reject,
    // Label 2437: @195926
    GIM_Reject,
    // Label 18: @195927
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3008*/ GIMT_Encode4(197052),
    /*GILLT_s32*//*Label 3006*/ GIMT_Encode4(195946),
    /*GILLT_s64*//*Label 3007*/ GIMT_Encode4(196499),
    // Label 3006: @195946
    GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(196498),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(196009), // Rule ID 8222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8222,
        GIR_EraseRootFromParent_Done,
      // Label 3010: @196009
      GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(196061), // Rule ID 8224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPST_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8224,
        GIR_EraseRootFromParent_Done,
      // Label 3011: @196061
      GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(196113), // Rule ID 8226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPST_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8226,
        GIR_EraseRootFromParent_Done,
      // Label 3012: @196113
      GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(196165), // Rule ID 8228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i32>>  =>  (DS_CMPSTORE_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$swap, anonymous_9451:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8228,
        GIR_EraseRootFromParent_Done,
      // Label 3013: @196165
      GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(196217), // Rule ID 8230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i32>>  =>  (DS_CMPSTORE_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$swap, anonymous_9451:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8230,
        GIR_EraseRootFromParent_Done,
      // Label 3014: @196217
      GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(196273), // Rule ID 8221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8221,
        GIR_EraseRootFromParent_Done,
      // Label 3015: @196273
      GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(196329), // Rule ID 8223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPST_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8223,
        GIR_EraseRootFromParent_Done,
      // Label 3016: @196329
      GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(196385), // Rule ID 8225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPST_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$cmp, anonymous_9451:{ *:[i32] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8225,
        GIR_EraseRootFromParent_Done,
      // Label 3017: @196385
      GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(196441), // Rule ID 8227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i32>>  =>  (DS_CMPSTORE_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$swap, anonymous_9451:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8227,
        GIR_EraseRootFromParent_Done,
      // Label 3018: @196441
      GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(196497), // Rule ID 8229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$cmp, i32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i32>>  =>  (DS_CMPSTORE_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$swap, anonymous_9451:{ *:[i32] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8229,
        GIR_EraseRootFromParent_Done,
      // Label 3019: @196497
      GIM_Reject,
    // Label 3009: @196498
    GIM_Reject,
    // Label 3007: @196499
    GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(197051),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(196562), // Rule ID 8403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8403,
        GIR_EraseRootFromParent_Done,
      // Label 3021: @196562
      GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(196614), // Rule ID 8405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPST_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8405,
        GIR_EraseRootFromParent_Done,
      // Label 3022: @196614
      GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(196666), // Rule ID 8407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPST_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8407,
        GIR_EraseRootFromParent_Done,
      // Label 3023: @196666
      GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(196718), // Rule ID 8409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_noret_i64>>  =>  (DS_CMPSTORE_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$swap, anonymous_9450:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8409,
        GIR_EraseRootFromParent_Done,
      // Label 3024: @196718
      GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(196770), // Rule ID 8411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_noret_i64>>  =>  (DS_CMPSTORE_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$swap, anonymous_9450:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8411,
        GIR_EraseRootFromParent_Done,
      // Label 3025: @196770
      GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(196826), // Rule ID 8402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8402,
        GIR_EraseRootFromParent_Done,
      // Label 3026: @196826
      GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(196882), // Rule ID 8404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPST_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8404,
        GIR_EraseRootFromParent_Done,
      // Label 3027: @196882
      GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(196938), // Rule ID 8406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX6GFX7GFX8GFX9GFX10),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPST_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$cmp, anonymous_9450:{ *:[i64] }:$swap, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPST_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8406,
        GIR_EraseRootFromParent_Done,
      // Label 3028: @196938
      GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(196994), // Rule ID 8408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_local_i64>>  =>  (DS_CMPSTORE_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$swap, anonymous_9450:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8408,
        GIR_EraseRootFromParent_Done,
      // Label 3029: @196994
      GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(197050), // Rule ID 8410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_isGFX11Plus),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_cmp_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$cmp, i64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_region_m0_i64>>  =>  (DS_CMPSTORE_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$swap, anonymous_9450:{ *:[i64] }:$cmp, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_CMPSTORE_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // swap
        GIR_RootToRootCopy, /*OpIdx*/2, // cmp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8410,
        GIR_EraseRootFromParent_Done,
      // Label 3030: @197050
      GIM_Reject,
    // Label 3020: @197051
    GIM_Reject,
    // Label 3008: @197052
    GIM_Reject,
    // Label 19: @197053
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3033*/ GIMT_Encode4(199264),
    /*GILLT_s32*//*Label 3031*/ GIMT_Encode4(197072),
    /*GILLT_s64*//*Label 3032*/ GIMT_Encode4(198168),
    // Label 3031: @197072
    GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(198167),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(197142), // Rule ID 5609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5609,
        GIR_EraseRootFromParent_Done,
      // Label 3035: @197142
      GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(197201), // Rule ID 5613 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5613,
        GIR_EraseRootFromParent_Done,
      // Label 3036: @197201
      GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(197267), // Rule ID 5605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5605,
        GIR_EraseRootFromParent_Done,
      // Label 3037: @197267
      GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(197330), // Rule ID 5611 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5611,
        GIR_EraseRootFromParent_Done,
      // Label 3038: @197330
      GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(197387), // Rule ID 5608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5608,
        GIR_EraseRootFromParent_Done,
      // Label 3039: @197387
      GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(197441), // Rule ID 5612 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5612,
        GIR_EraseRootFromParent_Done,
      // Label 3040: @197441
      GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(197502), // Rule ID 5604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5604,
        GIR_EraseRootFromParent_Done,
      // Label 3041: @197502
      GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(197560), // Rule ID 5610 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_swap_global_i32>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5610,
        GIR_EraseRootFromParent_Done,
      // Label 3042: @197560
      GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(197614), // Rule ID 8212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8212,
        GIR_EraseRootFromParent_Done,
      // Label 3043: @197614
      GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(197668), // Rule ID 8213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_local_i32>>  =>  (DS_WRXCHG_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8213,
        GIR_EraseRootFromParent_Done,
      // Label 3044: @197668
      GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(197722), // Rule ID 8214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_swap_region_m0_i32>>  =>  (DS_WRXCHG_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8214,
        GIR_EraseRootFromParent_Done,
      // Label 3045: @197722
      GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(197779), // Rule ID 4008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4008,
        GIR_EraseRootFromParent_Done,
      // Label 3046: @197779
      GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(197840), // Rule ID 4010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4010,
        GIR_EraseRootFromParent_Done,
      // Label 3047: @197840
      GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(197892), // Rule ID 4007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4007,
        GIR_EraseRootFromParent_Done,
      // Label 3048: @197892
      GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(197948), // Rule ID 4009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (GLOBAL_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4009,
        GIR_EraseRootFromParent_Done,
      // Label 3049: @197948
      GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(198001), // Rule ID 3656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3656,
        GIR_EraseRootFromParent_Done,
      // Label 3050: @198001
      GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(198053), // Rule ID 3716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_SWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3716,
        GIR_EraseRootFromParent_Done,
      // Label 3051: @198053
      GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(198110), // Rule ID 3655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_flat_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3655,
        GIR_EraseRootFromParent_Done,
      // Label 3052: @198110
      GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(198166), // Rule ID 3715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_swap_global_i32>>  =>  (FLAT_ATOMIC_SWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3715,
        GIR_EraseRootFromParent_Done,
      // Label 3053: @198166
      GIM_Reject,
    // Label 3034: @198167
    GIM_Reject,
    // Label 3032: @198168
    GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(199263),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(198238), // Rule ID 5705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5705,
        GIR_EraseRootFromParent_Done,
      // Label 3055: @198238
      GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(198297), // Rule ID 5709 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5709,
        GIR_EraseRootFromParent_Done,
      // Label 3056: @198297
      GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(198363), // Rule ID 5703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5703,
        GIR_EraseRootFromParent_Done,
      // Label 3057: @198363
      GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(198426), // Rule ID 5707 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5707,
        GIR_EraseRootFromParent_Done,
      // Label 3058: @198426
      GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(198483), // Rule ID 5704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5704,
        GIR_EraseRootFromParent_Done,
      // Label 3059: @198483
      GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(198537), // Rule ID 5708 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5708,
        GIR_EraseRootFromParent_Done,
      // Label 3060: @198537
      GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(198598), // Rule ID 5702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5702,
        GIR_EraseRootFromParent_Done,
      // Label 3061: @198598
      GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(198656), // Rule ID 5706 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_swap_global_i64>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5706,
        GIR_EraseRootFromParent_Done,
      // Label 3062: @198656
      GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(198710), // Rule ID 8321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8321,
        GIR_EraseRootFromParent_Done,
      // Label 3063: @198710
      GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(198764), // Rule ID 8322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_local_i64>>  =>  (DS_WRXCHG_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8322,
        GIR_EraseRootFromParent_Done,
      // Label 3064: @198764
      GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(198818), // Rule ID 8323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_swap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_swap_region_m0_i64>>  =>  (DS_WRXCHG_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_WRXCHG_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8323,
        GIR_EraseRootFromParent_Done,
      // Label 3065: @198818
      GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(198875), // Rule ID 4064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4064,
        GIR_EraseRootFromParent_Done,
      // Label 3066: @198875
      GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(198936), // Rule ID 4066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4066,
        GIR_EraseRootFromParent_Done,
      // Label 3067: @198936
      GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(198988), // Rule ID 4063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4063,
        GIR_EraseRootFromParent_Done,
      // Label 3068: @198988
      GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(199044), // Rule ID 4065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (GLOBAL_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4065,
        GIR_EraseRootFromParent_Done,
      // Label 3069: @199044
      GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(199097), // Rule ID 3682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3682,
        GIR_EraseRootFromParent_Done,
      // Label 3070: @199097
      GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(199149), // Rule ID 3742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_SWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3742,
        GIR_EraseRootFromParent_Done,
      // Label 3071: @199149
      GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(199206), // Rule ID 3681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_flat_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3681,
        GIR_EraseRootFromParent_Done,
      // Label 3072: @199206
      GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(199262), // Rule ID 3741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_swap_global_i64>>  =>  (FLAT_ATOMIC_SWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3741,
        GIR_EraseRootFromParent_Done,
      // Label 3073: @199262
      GIM_Reject,
    // Label 3054: @199263
    GIM_Reject,
    // Label 3033: @199264
    GIM_Reject,
    // Label 20: @199265
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3076*/ GIMT_Encode4(201776),
    /*GILLT_s32*//*Label 3074*/ GIMT_Encode4(199284),
    /*GILLT_s64*//*Label 3075*/ GIMT_Encode4(200530),
    // Label 3074: @199284
    GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(200529),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(199354), // Rule ID 5617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5617,
        GIR_EraseRootFromParent_Done,
      // Label 3078: @199354
      GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(199413), // Rule ID 5621 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5621,
        GIR_EraseRootFromParent_Done,
      // Label 3079: @199413
      GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(199479), // Rule ID 5615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5615,
        GIR_EraseRootFromParent_Done,
      // Label 3080: @199479
      GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(199542), // Rule ID 5619 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5619,
        GIR_EraseRootFromParent_Done,
      // Label 3081: @199542
      GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(199599), // Rule ID 5616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5616,
        GIR_EraseRootFromParent_Done,
      // Label 3082: @199599
      GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(199653), // Rule ID 5620 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5620,
        GIR_EraseRootFromParent_Done,
      // Label 3083: @199653
      GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(199714), // Rule ID 5614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5614,
        GIR_EraseRootFromParent_Done,
      // Label 3084: @199714
      GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(199772), // Rule ID 5618 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i32>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5618,
        GIR_EraseRootFromParent_Done,
      // Label 3085: @199772
      GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(199822), // Rule ID 8216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8216,
        GIR_EraseRootFromParent_Done,
      // Label 3086: @199822
      GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(199872), // Rule ID 8218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_noret_i32>>  =>  (DS_ADD_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8218,
        GIR_EraseRootFromParent_Done,
      // Label 3087: @199872
      GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(199922), // Rule ID 8220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i32>>  =>  (DS_ADD_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8220,
        GIR_EraseRootFromParent_Done,
      // Label 3088: @199922
      GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(199976), // Rule ID 8215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8215,
        GIR_EraseRootFromParent_Done,
      // Label 3089: @199976
      GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(200030), // Rule ID 8217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_local_i32>>  =>  (DS_ADD_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8217,
        GIR_EraseRootFromParent_Done,
      // Label 3090: @200030
      GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(200084), // Rule ID 8219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_add_region_m0_i32>>  =>  (DS_ADD_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8219,
        GIR_EraseRootFromParent_Done,
      // Label 3091: @200084
      GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(200141), // Rule ID 3540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3540,
        GIR_EraseRootFromParent_Done,
      // Label 3092: @200141
      GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(200202), // Rule ID 3542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_add:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3542,
        GIR_EraseRootFromParent_Done,
      // Label 3093: @200202
      GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(200254), // Rule ID 3539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (GLOBAL_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3539,
        GIR_EraseRootFromParent_Done,
      // Label 3094: @200254
      GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(200310), // Rule ID 3541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_add:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (GLOBAL_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3541,
        GIR_EraseRootFromParent_Done,
      // Label 3095: @200310
      GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(200363), // Rule ID 3531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3531,
        GIR_EraseRootFromParent_Done,
      // Label 3096: @200363
      GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(200415), // Rule ID 3696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_noret_i32>>  =>  (FLAT_ATOMIC_ADD VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3696,
        GIR_EraseRootFromParent_Done,
      // Label 3097: @200415
      GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(200472), // Rule ID 3532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_flat_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3532,
        GIR_EraseRootFromParent_Done,
      // Label 3098: @200472
      GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(200528), // Rule ID 3695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_add_global_i32>>  =>  (FLAT_ATOMIC_ADD_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3695,
        GIR_EraseRootFromParent_Done,
      // Label 3099: @200528
      GIM_Reject,
    // Label 3077: @200529
    GIM_Reject,
    // Label 3075: @200530
    GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(201775),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(200600), // Rule ID 5713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5713,
        GIR_EraseRootFromParent_Done,
      // Label 3101: @200600
      GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(200659), // Rule ID 5717 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5717,
        GIR_EraseRootFromParent_Done,
      // Label 3102: @200659
      GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(200725), // Rule ID 5711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5711,
        GIR_EraseRootFromParent_Done,
      // Label 3103: @200725
      GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(200788), // Rule ID 5715 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_add:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5715,
        GIR_EraseRootFromParent_Done,
      // Label 3104: @200788
      GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(200845), // Rule ID 5712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5712,
        GIR_EraseRootFromParent_Done,
      // Label 3105: @200845
      GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(200899), // Rule ID 5716 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5716,
        GIR_EraseRootFromParent_Done,
      // Label 3106: @200899
      GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(200960), // Rule ID 5710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5710,
        GIR_EraseRootFromParent_Done,
      // Label 3107: @200960
      GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(201018), // Rule ID 5714 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_add:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_add_global_i64>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5714,
        GIR_EraseRootFromParent_Done,
      // Label 3108: @201018
      GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(201068), // Rule ID 8325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8325,
        GIR_EraseRootFromParent_Done,
      // Label 3109: @201068
      GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(201118), // Rule ID 8327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_noret_i64>>  =>  (DS_ADD_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8327,
        GIR_EraseRootFromParent_Done,
      // Label 3110: @201118
      GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(201168), // Rule ID 8329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_noret_i64>>  =>  (DS_ADD_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8329,
        GIR_EraseRootFromParent_Done,
      // Label 3111: @201168
      GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(201222), // Rule ID 8324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8324,
        GIR_EraseRootFromParent_Done,
      // Label 3112: @201222
      GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(201276), // Rule ID 8326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_local_i64>>  =>  (DS_ADD_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8326,
        GIR_EraseRootFromParent_Done,
      // Label 3113: @201276
      GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(201330), // Rule ID 8328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_add_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_add_region_m0_i64>>  =>  (DS_ADD_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8328,
        GIR_EraseRootFromParent_Done,
      // Label 3114: @201330
      GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(201387), // Rule ID 4024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4024,
        GIR_EraseRootFromParent_Done,
      // Label 3115: @201387
      GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(201448), // Rule ID 4026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_add:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4026,
        GIR_EraseRootFromParent_Done,
      // Label 3116: @201448
      GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(201500), // Rule ID 4023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4023,
        GIR_EraseRootFromParent_Done,
      // Label 3117: @201500
      GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(201556), // Rule ID 4025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_add:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (GLOBAL_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4025,
        GIR_EraseRootFromParent_Done,
      // Label 3118: @201556
      GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(201609), // Rule ID 3662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3662,
        GIR_EraseRootFromParent_Done,
      // Label 3119: @201609
      GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(201661), // Rule ID 3722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_noret_i64>>  =>  (FLAT_ATOMIC_ADD_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3722,
        GIR_EraseRootFromParent_Done,
      // Label 3120: @201661
      GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(201718), // Rule ID 3661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_flat_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3661,
        GIR_EraseRootFromParent_Done,
      // Label 3121: @201718
      GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(201774), // Rule ID 3721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_add:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_add_global_i64>>  =>  (FLAT_ATOMIC_ADD_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3721,
        GIR_EraseRootFromParent_Done,
      // Label 3122: @201774
      GIM_Reject,
    // Label 3100: @201775
    GIM_Reject,
    // Label 3076: @201776
    GIM_Reject,
    // Label 21: @201777
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3125*/ GIMT_Encode4(204288),
    /*GILLT_s32*//*Label 3123*/ GIMT_Encode4(201796),
    /*GILLT_s64*//*Label 3124*/ GIMT_Encode4(203042),
    // Label 3123: @201796
    GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(203041),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(201866), // Rule ID 5625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5625,
        GIR_EraseRootFromParent_Done,
      // Label 3127: @201866
      GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(201925), // Rule ID 5629 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5629,
        GIR_EraseRootFromParent_Done,
      // Label 3128: @201925
      GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(201991), // Rule ID 5623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5623,
        GIR_EraseRootFromParent_Done,
      // Label 3129: @201991
      GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(202054), // Rule ID 5627 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5627,
        GIR_EraseRootFromParent_Done,
      // Label 3130: @202054
      GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(202111), // Rule ID 5624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5624,
        GIR_EraseRootFromParent_Done,
      // Label 3131: @202111
      GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(202165), // Rule ID 5628 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5628,
        GIR_EraseRootFromParent_Done,
      // Label 3132: @202165
      GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(202226), // Rule ID 5622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5622,
        GIR_EraseRootFromParent_Done,
      // Label 3133: @202226
      GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(202284), // Rule ID 5626 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5626,
        GIR_EraseRootFromParent_Done,
      // Label 3134: @202284
      GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(202334), // Rule ID 8232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8232,
        GIR_EraseRootFromParent_Done,
      // Label 3135: @202334
      GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(202384), // Rule ID 8234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i32>>  =>  (DS_SUB_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8234,
        GIR_EraseRootFromParent_Done,
      // Label 3136: @202384
      GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(202434), // Rule ID 8236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i32>>  =>  (DS_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8236,
        GIR_EraseRootFromParent_Done,
      // Label 3137: @202434
      GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(202488), // Rule ID 8231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8231,
        GIR_EraseRootFromParent_Done,
      // Label 3138: @202488
      GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(202542), // Rule ID 8233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_local_i32>>  =>  (DS_SUB_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8233,
        GIR_EraseRootFromParent_Done,
      // Label 3139: @202542
      GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(202596), // Rule ID 8235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i32>>  =>  (DS_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8235,
        GIR_EraseRootFromParent_Done,
      // Label 3140: @202596
      GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(202653), // Rule ID 3972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3972,
        GIR_EraseRootFromParent_Done,
      // Label 3141: @202653
      GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(202714), // Rule ID 3974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_sub:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3974,
        GIR_EraseRootFromParent_Done,
      // Label 3142: @202714
      GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(202766), // Rule ID 3971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3971,
        GIR_EraseRootFromParent_Done,
      // Label 3143: @202766
      GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(202822), // Rule ID 3973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_sub:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (GLOBAL_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3973,
        GIR_EraseRootFromParent_Done,
      // Label 3144: @202822
      GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(202875), // Rule ID 3638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3638,
        GIR_EraseRootFromParent_Done,
      // Label 3145: @202875
      GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(202927), // Rule ID 3698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i32>>  =>  (FLAT_ATOMIC_SUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3698,
        GIR_EraseRootFromParent_Done,
      // Label 3146: @202927
      GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(202984), // Rule ID 3637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_flat_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3637,
        GIR_EraseRootFromParent_Done,
      // Label 3147: @202984
      GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(203040), // Rule ID 3697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_sub_global_i32>>  =>  (FLAT_ATOMIC_SUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3697,
        GIR_EraseRootFromParent_Done,
      // Label 3148: @203040
      GIM_Reject,
    // Label 3126: @203041
    GIM_Reject,
    // Label 3124: @203042
    GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(204287),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(203112), // Rule ID 5721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5721,
        GIR_EraseRootFromParent_Done,
      // Label 3150: @203112
      GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(203171), // Rule ID 5725 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5725,
        GIR_EraseRootFromParent_Done,
      // Label 3151: @203171
      GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(203237), // Rule ID 5719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5719,
        GIR_EraseRootFromParent_Done,
      // Label 3152: @203237
      GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(203300), // Rule ID 5723 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_sub:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5723,
        GIR_EraseRootFromParent_Done,
      // Label 3153: @203300
      GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(203357), // Rule ID 5720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5720,
        GIR_EraseRootFromParent_Done,
      // Label 3154: @203357
      GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(203411), // Rule ID 5724 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5724,
        GIR_EraseRootFromParent_Done,
      // Label 3155: @203411
      GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(203472), // Rule ID 5718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5718,
        GIR_EraseRootFromParent_Done,
      // Label 3156: @203472
      GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(203530), // Rule ID 5722 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_sub:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5722,
        GIR_EraseRootFromParent_Done,
      // Label 3157: @203530
      GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(203580), // Rule ID 8331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8331,
        GIR_EraseRootFromParent_Done,
      // Label 3158: @203580
      GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(203630), // Rule ID 8333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_noret_i64>>  =>  (DS_SUB_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8333,
        GIR_EraseRootFromParent_Done,
      // Label 3159: @203630
      GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(203680), // Rule ID 8335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_noret_i64>>  =>  (DS_SUB_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8335,
        GIR_EraseRootFromParent_Done,
      // Label 3160: @203680
      GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(203734), // Rule ID 8330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8330,
        GIR_EraseRootFromParent_Done,
      // Label 3161: @203734
      GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(203788), // Rule ID 8332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_local_i64>>  =>  (DS_SUB_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8332,
        GIR_EraseRootFromParent_Done,
      // Label 3162: @203788
      GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(203842), // Rule ID 8334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_sub_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_sub_region_m0_i64>>  =>  (DS_SUB_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8334,
        GIR_EraseRootFromParent_Done,
      // Label 3163: @203842
      GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(203899), // Rule ID 4028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4028,
        GIR_EraseRootFromParent_Done,
      // Label 3164: @203899
      GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(203960), // Rule ID 4030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_sub:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4030,
        GIR_EraseRootFromParent_Done,
      // Label 3165: @203960
      GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(204012), // Rule ID 4027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4027,
        GIR_EraseRootFromParent_Done,
      // Label 3166: @204012
      GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(204068), // Rule ID 4029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_sub:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (GLOBAL_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SUB_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4029,
        GIR_EraseRootFromParent_Done,
      // Label 3167: @204068
      GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(204121), // Rule ID 3664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3664,
        GIR_EraseRootFromParent_Done,
      // Label 3168: @204121
      GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(204173), // Rule ID 3724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_noret_i64>>  =>  (FLAT_ATOMIC_SUB_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3724,
        GIR_EraseRootFromParent_Done,
      // Label 3169: @204173
      GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(204230), // Rule ID 3663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_flat_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3663,
        GIR_EraseRootFromParent_Done,
      // Label 3170: @204230
      GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(204286), // Rule ID 3723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_sub:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_sub_global_i64>>  =>  (FLAT_ATOMIC_SUB_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SUB_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3723,
        GIR_EraseRootFromParent_Done,
      // Label 3171: @204286
      GIM_Reject,
    // Label 3149: @204287
    GIM_Reject,
    // Label 3125: @204288
    GIM_Reject,
    // Label 22: @204289
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3174*/ GIMT_Encode4(206800),
    /*GILLT_s32*//*Label 3172*/ GIMT_Encode4(204308),
    /*GILLT_s64*//*Label 3173*/ GIMT_Encode4(205554),
    // Label 3172: @204308
    GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(205553),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(204378), // Rule ID 5665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5665,
        GIR_EraseRootFromParent_Done,
      // Label 3176: @204378
      GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(204437), // Rule ID 5669 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5669,
        GIR_EraseRootFromParent_Done,
      // Label 3177: @204437
      GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(204503), // Rule ID 5663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5663,
        GIR_EraseRootFromParent_Done,
      // Label 3178: @204503
      GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(204566), // Rule ID 5667 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5667,
        GIR_EraseRootFromParent_Done,
      // Label 3179: @204566
      GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(204623), // Rule ID 5664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5664,
        GIR_EraseRootFromParent_Done,
      // Label 3180: @204623
      GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(204677), // Rule ID 5668 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5668,
        GIR_EraseRootFromParent_Done,
      // Label 3181: @204677
      GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(204738), // Rule ID 5662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5662,
        GIR_EraseRootFromParent_Done,
      // Label 3182: @204738
      GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(204796), // Rule ID 5666 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i32>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5666,
        GIR_EraseRootFromParent_Done,
      // Label 3183: @204796
      GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(204846), // Rule ID 8250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8250,
        GIR_EraseRootFromParent_Done,
      // Label 3184: @204846
      GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(204896), // Rule ID 8252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_noret_i32>>  =>  (DS_AND_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8252,
        GIR_EraseRootFromParent_Done,
      // Label 3185: @204896
      GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(204946), // Rule ID 8254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i32>>  =>  (DS_AND_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8254,
        GIR_EraseRootFromParent_Done,
      // Label 3186: @204946
      GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(205000), // Rule ID 8249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8249,
        GIR_EraseRootFromParent_Done,
      // Label 3187: @205000
      GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(205054), // Rule ID 8251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_local_i32>>  =>  (DS_AND_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8251,
        GIR_EraseRootFromParent_Done,
      // Label 3188: @205054
      GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(205108), // Rule ID 8253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_and_region_m0_i32>>  =>  (DS_AND_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8253,
        GIR_EraseRootFromParent_Done,
      // Label 3189: @205108
      GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(205165), // Rule ID 3984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3984,
        GIR_EraseRootFromParent_Done,
      // Label 3190: @205165
      GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(205226), // Rule ID 3986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_and:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3986,
        GIR_EraseRootFromParent_Done,
      // Label 3191: @205226
      GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(205278), // Rule ID 3983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (GLOBAL_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3983,
        GIR_EraseRootFromParent_Done,
      // Label 3192: @205278
      GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(205334), // Rule ID 3985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_and:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (GLOBAL_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3985,
        GIR_EraseRootFromParent_Done,
      // Label 3193: @205334
      GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(205387), // Rule ID 3644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3644,
        GIR_EraseRootFromParent_Done,
      // Label 3194: @205387
      GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(205439), // Rule ID 3704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_noret_i32>>  =>  (FLAT_ATOMIC_AND VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3704,
        GIR_EraseRootFromParent_Done,
      // Label 3195: @205439
      GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(205496), // Rule ID 3643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_flat_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3643,
        GIR_EraseRootFromParent_Done,
      // Label 3196: @205496
      GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(205552), // Rule ID 3703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_and_global_i32>>  =>  (FLAT_ATOMIC_AND_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3703,
        GIR_EraseRootFromParent_Done,
      // Label 3197: @205552
      GIM_Reject,
    // Label 3175: @205553
    GIM_Reject,
    // Label 3173: @205554
    GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(206799),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(205624), // Rule ID 5761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5761,
        GIR_EraseRootFromParent_Done,
      // Label 3199: @205624
      GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(205683), // Rule ID 5765 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5765,
        GIR_EraseRootFromParent_Done,
      // Label 3200: @205683
      GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(205749), // Rule ID 5759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5759,
        GIR_EraseRootFromParent_Done,
      // Label 3201: @205749
      GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(205812), // Rule ID 5763 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_and:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5763,
        GIR_EraseRootFromParent_Done,
      // Label 3202: @205812
      GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(205869), // Rule ID 5760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5760,
        GIR_EraseRootFromParent_Done,
      // Label 3203: @205869
      GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(205923), // Rule ID 5764 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5764,
        GIR_EraseRootFromParent_Done,
      // Label 3204: @205923
      GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(205984), // Rule ID 5758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5758,
        GIR_EraseRootFromParent_Done,
      // Label 3205: @205984
      GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(206042), // Rule ID 5762 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_and:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_and_global_i64>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5762,
        GIR_EraseRootFromParent_Done,
      // Label 3206: @206042
      GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(206092), // Rule ID 8349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8349,
        GIR_EraseRootFromParent_Done,
      // Label 3207: @206092
      GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(206142), // Rule ID 8351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_noret_i64>>  =>  (DS_AND_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8351,
        GIR_EraseRootFromParent_Done,
      // Label 3208: @206142
      GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(206192), // Rule ID 8353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_noret_i64>>  =>  (DS_AND_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8353,
        GIR_EraseRootFromParent_Done,
      // Label 3209: @206192
      GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(206246), // Rule ID 8348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8348,
        GIR_EraseRootFromParent_Done,
      // Label 3210: @206246
      GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(206300), // Rule ID 8350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_local_i64>>  =>  (DS_AND_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8350,
        GIR_EraseRootFromParent_Done,
      // Label 3211: @206300
      GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(206354), // Rule ID 8352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_and_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_and_region_m0_i64>>  =>  (DS_AND_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_AND_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8352,
        GIR_EraseRootFromParent_Done,
      // Label 3212: @206354
      GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(206411), // Rule ID 4040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4040,
        GIR_EraseRootFromParent_Done,
      // Label 3213: @206411
      GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(206472), // Rule ID 4042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_and:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4042,
        GIR_EraseRootFromParent_Done,
      // Label 3214: @206472
      GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(206524), // Rule ID 4039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (GLOBAL_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4039,
        GIR_EraseRootFromParent_Done,
      // Label 3215: @206524
      GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(206580), // Rule ID 4041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_and:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (GLOBAL_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_AND_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4041,
        GIR_EraseRootFromParent_Done,
      // Label 3216: @206580
      GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(206633), // Rule ID 3670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3670,
        GIR_EraseRootFromParent_Done,
      // Label 3217: @206633
      GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(206685), // Rule ID 3730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_noret_i64>>  =>  (FLAT_ATOMIC_AND_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3730,
        GIR_EraseRootFromParent_Done,
      // Label 3218: @206685
      GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(206742), // Rule ID 3669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_flat_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3669,
        GIR_EraseRootFromParent_Done,
      // Label 3219: @206742
      GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(206798), // Rule ID 3729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_and:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_and_global_i64>>  =>  (FLAT_ATOMIC_AND_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_AND_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3729,
        GIR_EraseRootFromParent_Done,
      // Label 3220: @206798
      GIM_Reject,
    // Label 3198: @206799
    GIM_Reject,
    // Label 3174: @206800
    GIM_Reject,
    // Label 23: @206801
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3223*/ GIMT_Encode4(209312),
    /*GILLT_s32*//*Label 3221*/ GIMT_Encode4(206820),
    /*GILLT_s64*//*Label 3222*/ GIMT_Encode4(208066),
    // Label 3221: @206820
    GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(208065),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(206890), // Rule ID 5673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5673,
        GIR_EraseRootFromParent_Done,
      // Label 3225: @206890
      GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(206949), // Rule ID 5677 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5677,
        GIR_EraseRootFromParent_Done,
      // Label 3226: @206949
      GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(207015), // Rule ID 5671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5671,
        GIR_EraseRootFromParent_Done,
      // Label 3227: @207015
      GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(207078), // Rule ID 5675 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5675,
        GIR_EraseRootFromParent_Done,
      // Label 3228: @207078
      GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(207135), // Rule ID 5672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5672,
        GIR_EraseRootFromParent_Done,
      // Label 3229: @207135
      GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(207189), // Rule ID 5676 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5676,
        GIR_EraseRootFromParent_Done,
      // Label 3230: @207189
      GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(207250), // Rule ID 5670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5670,
        GIR_EraseRootFromParent_Done,
      // Label 3231: @207250
      GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(207308), // Rule ID 5674 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i32>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5674,
        GIR_EraseRootFromParent_Done,
      // Label 3232: @207308
      GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(207358), // Rule ID 8256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8256,
        GIR_EraseRootFromParent_Done,
      // Label 3233: @207358
      GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(207408), // Rule ID 8258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_noret_i32>>  =>  (DS_OR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8258,
        GIR_EraseRootFromParent_Done,
      // Label 3234: @207408
      GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(207458), // Rule ID 8260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i32>>  =>  (DS_OR_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8260,
        GIR_EraseRootFromParent_Done,
      // Label 3235: @207458
      GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(207512), // Rule ID 8255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8255,
        GIR_EraseRootFromParent_Done,
      // Label 3236: @207512
      GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(207566), // Rule ID 8257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_local_i32>>  =>  (DS_OR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8257,
        GIR_EraseRootFromParent_Done,
      // Label 3237: @207566
      GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(207620), // Rule ID 8259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_or_region_m0_i32>>  =>  (DS_OR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8259,
        GIR_EraseRootFromParent_Done,
      // Label 3238: @207620
      GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(207677), // Rule ID 4004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4004,
        GIR_EraseRootFromParent_Done,
      // Label 3239: @207677
      GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(207738), // Rule ID 4006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_or:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4006,
        GIR_EraseRootFromParent_Done,
      // Label 3240: @207738
      GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(207790), // Rule ID 4003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (GLOBAL_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4003,
        GIR_EraseRootFromParent_Done,
      // Label 3241: @207790
      GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(207846), // Rule ID 4005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_or:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (GLOBAL_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4005,
        GIR_EraseRootFromParent_Done,
      // Label 3242: @207846
      GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(207899), // Rule ID 3654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3654,
        GIR_EraseRootFromParent_Done,
      // Label 3243: @207899
      GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(207951), // Rule ID 3714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_noret_i32>>  =>  (FLAT_ATOMIC_OR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3714,
        GIR_EraseRootFromParent_Done,
      // Label 3244: @207951
      GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(208008), // Rule ID 3653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_flat_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3653,
        GIR_EraseRootFromParent_Done,
      // Label 3245: @208008
      GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(208064), // Rule ID 3713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_or_global_i32>>  =>  (FLAT_ATOMIC_OR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3713,
        GIR_EraseRootFromParent_Done,
      // Label 3246: @208064
      GIM_Reject,
    // Label 3224: @208065
    GIM_Reject,
    // Label 3222: @208066
    GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(209311),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(208136), // Rule ID 5769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5769,
        GIR_EraseRootFromParent_Done,
      // Label 3248: @208136
      GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(208195), // Rule ID 5773 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5773,
        GIR_EraseRootFromParent_Done,
      // Label 3249: @208195
      GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(208261), // Rule ID 5767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5767,
        GIR_EraseRootFromParent_Done,
      // Label 3250: @208261
      GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(208324), // Rule ID 5771 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_or:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5771,
        GIR_EraseRootFromParent_Done,
      // Label 3251: @208324
      GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(208381), // Rule ID 5768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5768,
        GIR_EraseRootFromParent_Done,
      // Label 3252: @208381
      GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(208435), // Rule ID 5772 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5772,
        GIR_EraseRootFromParent_Done,
      // Label 3253: @208435
      GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(208496), // Rule ID 5766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5766,
        GIR_EraseRootFromParent_Done,
      // Label 3254: @208496
      GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(208554), // Rule ID 5770 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_or:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_or_global_i64>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5770,
        GIR_EraseRootFromParent_Done,
      // Label 3255: @208554
      GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(208604), // Rule ID 8355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8355,
        GIR_EraseRootFromParent_Done,
      // Label 3256: @208604
      GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(208654), // Rule ID 8357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_noret_i64>>  =>  (DS_OR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8357,
        GIR_EraseRootFromParent_Done,
      // Label 3257: @208654
      GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(208704), // Rule ID 8359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_noret_i64>>  =>  (DS_OR_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8359,
        GIR_EraseRootFromParent_Done,
      // Label 3258: @208704
      GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(208758), // Rule ID 8354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8354,
        GIR_EraseRootFromParent_Done,
      // Label 3259: @208758
      GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(208812), // Rule ID 8356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_local_i64>>  =>  (DS_OR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8356,
        GIR_EraseRootFromParent_Done,
      // Label 3260: @208812
      GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(208866), // Rule ID 8358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_or_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_or_region_m0_i64>>  =>  (DS_OR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_OR_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8358,
        GIR_EraseRootFromParent_Done,
      // Label 3261: @208866
      GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(208923), // Rule ID 4060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4060,
        GIR_EraseRootFromParent_Done,
      // Label 3262: @208923
      GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(208984), // Rule ID 4062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_or:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4062,
        GIR_EraseRootFromParent_Done,
      // Label 3263: @208984
      GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(209036), // Rule ID 4059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (GLOBAL_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4059,
        GIR_EraseRootFromParent_Done,
      // Label 3264: @209036
      GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(209092), // Rule ID 4061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_or:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (GLOBAL_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_OR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4061,
        GIR_EraseRootFromParent_Done,
      // Label 3265: @209092
      GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(209145), // Rule ID 3680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3680,
        GIR_EraseRootFromParent_Done,
      // Label 3266: @209145
      GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(209197), // Rule ID 3740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_noret_i64>>  =>  (FLAT_ATOMIC_OR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3740,
        GIR_EraseRootFromParent_Done,
      // Label 3267: @209197
      GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(209254), // Rule ID 3679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_flat_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3679,
        GIR_EraseRootFromParent_Done,
      // Label 3268: @209254
      GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(209310), // Rule ID 3739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_or:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_or_global_i64>>  =>  (FLAT_ATOMIC_OR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_OR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3739,
        GIR_EraseRootFromParent_Done,
      // Label 3269: @209310
      GIM_Reject,
    // Label 3247: @209311
    GIM_Reject,
    // Label 3223: @209312
    GIM_Reject,
    // Label 24: @209313
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3272*/ GIMT_Encode4(211824),
    /*GILLT_s32*//*Label 3270*/ GIMT_Encode4(209332),
    /*GILLT_s64*//*Label 3271*/ GIMT_Encode4(210578),
    // Label 3270: @209332
    GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(210577),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(209402), // Rule ID 5681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5681,
        GIR_EraseRootFromParent_Done,
      // Label 3274: @209402
      GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(209461), // Rule ID 5685 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5685,
        GIR_EraseRootFromParent_Done,
      // Label 3275: @209461
      GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(209527), // Rule ID 5679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5679,
        GIR_EraseRootFromParent_Done,
      // Label 3276: @209527
      GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(209590), // Rule ID 5683 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5683,
        GIR_EraseRootFromParent_Done,
      // Label 3277: @209590
      GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(209647), // Rule ID 5680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5680,
        GIR_EraseRootFromParent_Done,
      // Label 3278: @209647
      GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(209701), // Rule ID 5684 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5684,
        GIR_EraseRootFromParent_Done,
      // Label 3279: @209701
      GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(209762), // Rule ID 5678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5678,
        GIR_EraseRootFromParent_Done,
      // Label 3280: @209762
      GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(209820), // Rule ID 5682 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5682,
        GIR_EraseRootFromParent_Done,
      // Label 3281: @209820
      GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(209870), // Rule ID 8262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8262,
        GIR_EraseRootFromParent_Done,
      // Label 3282: @209870
      GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(209920), // Rule ID 8264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i32>>  =>  (DS_XOR_B32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8264,
        GIR_EraseRootFromParent_Done,
      // Label 3283: @209920
      GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(209970), // Rule ID 8266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i32>>  =>  (DS_XOR_B32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8266,
        GIR_EraseRootFromParent_Done,
      // Label 3284: @209970
      GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(210024), // Rule ID 8261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8261,
        GIR_EraseRootFromParent_Done,
      // Label 3285: @210024
      GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(210078), // Rule ID 8263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_local_i32>>  =>  (DS_XOR_RTN_B32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8263,
        GIR_EraseRootFromParent_Done,
      // Label 3286: @210078
      GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(210132), // Rule ID 8265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i32>>  =>  (DS_XOR_RTN_B32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8265,
        GIR_EraseRootFromParent_Done,
      // Label 3287: @210132
      GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(210189), // Rule ID 4016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4016,
        GIR_EraseRootFromParent_Done,
      // Label 3288: @210189
      GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(210250), // Rule ID 4018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_xor:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4018,
        GIR_EraseRootFromParent_Done,
      // Label 3289: @210250
      GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(210302), // Rule ID 4015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (GLOBAL_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4015,
        GIR_EraseRootFromParent_Done,
      // Label 3290: @210302
      GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(210358), // Rule ID 4017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_xor:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (GLOBAL_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4017,
        GIR_EraseRootFromParent_Done,
      // Label 3291: @210358
      GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(210411), // Rule ID 3660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3660,
        GIR_EraseRootFromParent_Done,
      // Label 3292: @210411
      GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(210463), // Rule ID 3720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i32>>  =>  (FLAT_ATOMIC_XOR VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3720,
        GIR_EraseRootFromParent_Done,
      // Label 3293: @210463
      GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(210520), // Rule ID 3659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_flat_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3659,
        GIR_EraseRootFromParent_Done,
      // Label 3294: @210520
      GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(210576), // Rule ID 3719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_xor_global_i32>>  =>  (FLAT_ATOMIC_XOR_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3719,
        GIR_EraseRootFromParent_Done,
      // Label 3295: @210576
      GIM_Reject,
    // Label 3273: @210577
    GIM_Reject,
    // Label 3271: @210578
    GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(211823),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(210648), // Rule ID 5777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5777,
        GIR_EraseRootFromParent_Done,
      // Label 3297: @210648
      GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(210707), // Rule ID 5781 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5781,
        GIR_EraseRootFromParent_Done,
      // Label 3298: @210707
      GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(210773), // Rule ID 5775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5775,
        GIR_EraseRootFromParent_Done,
      // Label 3299: @210773
      GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(210836), // Rule ID 5779 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_xor:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5779,
        GIR_EraseRootFromParent_Done,
      // Label 3300: @210836
      GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(210893), // Rule ID 5776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5776,
        GIR_EraseRootFromParent_Done,
      // Label 3301: @210893
      GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(210947), // Rule ID 5780 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5780,
        GIR_EraseRootFromParent_Done,
      // Label 3302: @210947
      GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(211008), // Rule ID 5774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5774,
        GIR_EraseRootFromParent_Done,
      // Label 3303: @211008
      GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(211066), // Rule ID 5778 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_xor:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5778,
        GIR_EraseRootFromParent_Done,
      // Label 3304: @211066
      GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(211116), // Rule ID 8361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8361,
        GIR_EraseRootFromParent_Done,
      // Label 3305: @211116
      GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(211166), // Rule ID 8363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_noret_i64>>  =>  (DS_XOR_B64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8363,
        GIR_EraseRootFromParent_Done,
      // Label 3306: @211166
      GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(211216), // Rule ID 8365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_noret_i64>>  =>  (DS_XOR_B64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_B64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8365,
        GIR_EraseRootFromParent_Done,
      // Label 3307: @211216
      GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(211270), // Rule ID 8360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8360,
        GIR_EraseRootFromParent_Done,
      // Label 3308: @211270
      GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(211324), // Rule ID 8362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_local_i64>>  =>  (DS_XOR_RTN_B64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8362,
        GIR_EraseRootFromParent_Done,
      // Label 3309: @211324
      GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(211378), // Rule ID 8364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_xor_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_xor_region_m0_i64>>  =>  (DS_XOR_RTN_B64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_XOR_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8364,
        GIR_EraseRootFromParent_Done,
      // Label 3310: @211378
      GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(211435), // Rule ID 4072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4072,
        GIR_EraseRootFromParent_Done,
      // Label 3311: @211435
      GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(211496), // Rule ID 4074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_xor:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4074,
        GIR_EraseRootFromParent_Done,
      // Label 3312: @211496
      GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(211548), // Rule ID 4071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4071,
        GIR_EraseRootFromParent_Done,
      // Label 3313: @211548
      GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(211604), // Rule ID 4073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_xor:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (GLOBAL_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_XOR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4073,
        GIR_EraseRootFromParent_Done,
      // Label 3314: @211604
      GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(211657), // Rule ID 3686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3686,
        GIR_EraseRootFromParent_Done,
      // Label 3315: @211657
      GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(211709), // Rule ID 3746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_noret_i64>>  =>  (FLAT_ATOMIC_XOR_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3746,
        GIR_EraseRootFromParent_Done,
      // Label 3316: @211709
      GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(211766), // Rule ID 3685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_flat_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3685,
        GIR_EraseRootFromParent_Done,
      // Label 3317: @211766
      GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(211822), // Rule ID 3745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_xor:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_xor_global_i64>>  =>  (FLAT_ATOMIC_XOR_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_XOR_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3745,
        GIR_EraseRootFromParent_Done,
      // Label 3318: @211822
      GIM_Reject,
    // Label 3296: @211823
    GIM_Reject,
    // Label 3272: @211824
    GIM_Reject,
    // Label 25: @211825
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3321*/ GIMT_Encode4(214336),
    /*GILLT_s32*//*Label 3319*/ GIMT_Encode4(211844),
    /*GILLT_s64*//*Label 3320*/ GIMT_Encode4(213090),
    // Label 3319: @211844
    GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(213089),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(211914), // Rule ID 5649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5649,
        GIR_EraseRootFromParent_Done,
      // Label 3323: @211914
      GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(211973), // Rule ID 5653 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5653,
        GIR_EraseRootFromParent_Done,
      // Label 3324: @211973
      GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(212039), // Rule ID 5647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5647,
        GIR_EraseRootFromParent_Done,
      // Label 3325: @212039
      GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(212102), // Rule ID 5651 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5651,
        GIR_EraseRootFromParent_Done,
      // Label 3326: @212102
      GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(212159), // Rule ID 5648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5648,
        GIR_EraseRootFromParent_Done,
      // Label 3327: @212159
      GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(212213), // Rule ID 5652 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5652,
        GIR_EraseRootFromParent_Done,
      // Label 3328: @212213
      GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(212274), // Rule ID 5646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5646,
        GIR_EraseRootFromParent_Done,
      // Label 3329: @212274
      GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(212332), // Rule ID 5650 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i32>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5650,
        GIR_EraseRootFromParent_Done,
      // Label 3330: @212332
      GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(212382), // Rule ID 8274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8274,
        GIR_EraseRootFromParent_Done,
      // Label 3331: @212382
      GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(212432), // Rule ID 8276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_noret_i32>>  =>  (DS_MAX_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8276,
        GIR_EraseRootFromParent_Done,
      // Label 3332: @212432
      GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(212482), // Rule ID 8278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i32>>  =>  (DS_MAX_I32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8278,
        GIR_EraseRootFromParent_Done,
      // Label 3333: @212482
      GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(212536), // Rule ID 8273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8273,
        GIR_EraseRootFromParent_Done,
      // Label 3334: @212536
      GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(212590), // Rule ID 8275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_local_i32>>  =>  (DS_MAX_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8275,
        GIR_EraseRootFromParent_Done,
      // Label 3335: @212590
      GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(212644), // Rule ID 8277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_max_region_m0_i32>>  =>  (DS_MAX_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8277,
        GIR_EraseRootFromParent_Done,
      // Label 3336: @212644
      GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(212701), // Rule ID 3988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3988,
        GIR_EraseRootFromParent_Done,
      // Label 3337: @212701
      GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(212762), // Rule ID 3990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_max:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3990,
        GIR_EraseRootFromParent_Done,
      // Label 3338: @212762
      GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(212814), // Rule ID 3987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3987,
        GIR_EraseRootFromParent_Done,
      // Label 3339: @212814
      GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(212870), // Rule ID 3989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_max:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (GLOBAL_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3989,
        GIR_EraseRootFromParent_Done,
      // Label 3340: @212870
      GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(212923), // Rule ID 3646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3646,
        GIR_EraseRootFromParent_Done,
      // Label 3341: @212923
      GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(212975), // Rule ID 3706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_noret_i32>>  =>  (FLAT_ATOMIC_SMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3706,
        GIR_EraseRootFromParent_Done,
      // Label 3342: @212975
      GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(213032), // Rule ID 3645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_flat_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3645,
        GIR_EraseRootFromParent_Done,
      // Label 3343: @213032
      GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(213088), // Rule ID 3705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_max_global_i32>>  =>  (FLAT_ATOMIC_SMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3705,
        GIR_EraseRootFromParent_Done,
      // Label 3344: @213088
      GIM_Reject,
    // Label 3322: @213089
    GIM_Reject,
    // Label 3320: @213090
    GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(214335),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(213160), // Rule ID 5745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5745,
        GIR_EraseRootFromParent_Done,
      // Label 3346: @213160
      GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(213219), // Rule ID 5749 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5749,
        GIR_EraseRootFromParent_Done,
      // Label 3347: @213219
      GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(213285), // Rule ID 5743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5743,
        GIR_EraseRootFromParent_Done,
      // Label 3348: @213285
      GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(213348), // Rule ID 5747 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_max:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5747,
        GIR_EraseRootFromParent_Done,
      // Label 3349: @213348
      GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(213405), // Rule ID 5744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5744,
        GIR_EraseRootFromParent_Done,
      // Label 3350: @213405
      GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(213459), // Rule ID 5748 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5748,
        GIR_EraseRootFromParent_Done,
      // Label 3351: @213459
      GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(213520), // Rule ID 5742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5742,
        GIR_EraseRootFromParent_Done,
      // Label 3352: @213520
      GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(213578), // Rule ID 5746 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_max:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_max_global_i64>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5746,
        GIR_EraseRootFromParent_Done,
      // Label 3353: @213578
      GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(213628), // Rule ID 8373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8373,
        GIR_EraseRootFromParent_Done,
      // Label 3354: @213628
      GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(213678), // Rule ID 8375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_noret_i64>>  =>  (DS_MAX_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8375,
        GIR_EraseRootFromParent_Done,
      // Label 3355: @213678
      GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(213728), // Rule ID 8377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_noret_i64>>  =>  (DS_MAX_I64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_I64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8377,
        GIR_EraseRootFromParent_Done,
      // Label 3356: @213728
      GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(213782), // Rule ID 8372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8372,
        GIR_EraseRootFromParent_Done,
      // Label 3357: @213782
      GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(213836), // Rule ID 8374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_local_i64>>  =>  (DS_MAX_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8374,
        GIR_EraseRootFromParent_Done,
      // Label 3358: @213836
      GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(213890), // Rule ID 8376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_max_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_max_region_m0_i64>>  =>  (DS_MAX_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_I64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8376,
        GIR_EraseRootFromParent_Done,
      // Label 3359: @213890
      GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(213947), // Rule ID 4044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4044,
        GIR_EraseRootFromParent_Done,
      // Label 3360: @213947
      GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(214008), // Rule ID 4046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_max:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4046,
        GIR_EraseRootFromParent_Done,
      // Label 3361: @214008
      GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(214060), // Rule ID 4043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4043,
        GIR_EraseRootFromParent_Done,
      // Label 3362: @214060
      GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(214116), // Rule ID 4045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_max:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (GLOBAL_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4045,
        GIR_EraseRootFromParent_Done,
      // Label 3363: @214116
      GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(214169), // Rule ID 3672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3672,
        GIR_EraseRootFromParent_Done,
      // Label 3364: @214169
      GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(214221), // Rule ID 3732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_noret_i64>>  =>  (FLAT_ATOMIC_SMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3732,
        GIR_EraseRootFromParent_Done,
      // Label 3365: @214221
      GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(214278), // Rule ID 3671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_flat_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3671,
        GIR_EraseRootFromParent_Done,
      // Label 3366: @214278
      GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(214334), // Rule ID 3731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_max:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_max_global_i64>>  =>  (FLAT_ATOMIC_SMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3731,
        GIR_EraseRootFromParent_Done,
      // Label 3367: @214334
      GIM_Reject,
    // Label 3345: @214335
    GIM_Reject,
    // Label 3321: @214336
    GIM_Reject,
    // Label 26: @214337
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3370*/ GIMT_Encode4(216848),
    /*GILLT_s32*//*Label 3368*/ GIMT_Encode4(214356),
    /*GILLT_s64*//*Label 3369*/ GIMT_Encode4(215602),
    // Label 3368: @214356
    GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(215601),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(214426), // Rule ID 5633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5633,
        GIR_EraseRootFromParent_Done,
      // Label 3372: @214426
      GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(214485), // Rule ID 5637 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5637,
        GIR_EraseRootFromParent_Done,
      // Label 3373: @214485
      GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(214551), // Rule ID 5631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5631,
        GIR_EraseRootFromParent_Done,
      // Label 3374: @214551
      GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(214614), // Rule ID 5635 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5635,
        GIR_EraseRootFromParent_Done,
      // Label 3375: @214614
      GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(214671), // Rule ID 5632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5632,
        GIR_EraseRootFromParent_Done,
      // Label 3376: @214671
      GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(214725), // Rule ID 5636 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5636,
        GIR_EraseRootFromParent_Done,
      // Label 3377: @214725
      GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(214786), // Rule ID 5630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5630,
        GIR_EraseRootFromParent_Done,
      // Label 3378: @214786
      GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(214844), // Rule ID 5634 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i32>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5634,
        GIR_EraseRootFromParent_Done,
      // Label 3379: @214844
      GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(214894), // Rule ID 8268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8268,
        GIR_EraseRootFromParent_Done,
      // Label 3380: @214894
      GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(214944), // Rule ID 8270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_noret_i32>>  =>  (DS_MIN_I32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8270,
        GIR_EraseRootFromParent_Done,
      // Label 3381: @214944
      GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(214994), // Rule ID 8272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i32>>  =>  (DS_MIN_I32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8272,
        GIR_EraseRootFromParent_Done,
      // Label 3382: @214994
      GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(215048), // Rule ID 8267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8267,
        GIR_EraseRootFromParent_Done,
      // Label 3383: @215048
      GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(215102), // Rule ID 8269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_local_i32>>  =>  (DS_MIN_RTN_I32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8269,
        GIR_EraseRootFromParent_Done,
      // Label 3384: @215102
      GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(215156), // Rule ID 8271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_min_region_m0_i32>>  =>  (DS_MIN_RTN_I32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8271,
        GIR_EraseRootFromParent_Done,
      // Label 3385: @215156
      GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(215213), // Rule ID 3996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3996,
        GIR_EraseRootFromParent_Done,
      // Label 3386: @215213
      GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(215274), // Rule ID 3998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_min:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3998,
        GIR_EraseRootFromParent_Done,
      // Label 3387: @215274
      GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(215326), // Rule ID 3995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (GLOBAL_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3995,
        GIR_EraseRootFromParent_Done,
      // Label 3388: @215326
      GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(215382), // Rule ID 3997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_min:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (GLOBAL_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3997,
        GIR_EraseRootFromParent_Done,
      // Label 3389: @215382
      GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(215435), // Rule ID 3650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3650,
        GIR_EraseRootFromParent_Done,
      // Label 3390: @215435
      GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(215487), // Rule ID 3710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_noret_i32>>  =>  (FLAT_ATOMIC_SMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3710,
        GIR_EraseRootFromParent_Done,
      // Label 3391: @215487
      GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(215544), // Rule ID 3649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_flat_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3649,
        GIR_EraseRootFromParent_Done,
      // Label 3392: @215544
      GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(215600), // Rule ID 3709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_min_global_i32>>  =>  (FLAT_ATOMIC_SMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3709,
        GIR_EraseRootFromParent_Done,
      // Label 3393: @215600
      GIM_Reject,
    // Label 3371: @215601
    GIM_Reject,
    // Label 3369: @215602
    GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(216847),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(215672), // Rule ID 5729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5729,
        GIR_EraseRootFromParent_Done,
      // Label 3395: @215672
      GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(215731), // Rule ID 5733 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5733,
        GIR_EraseRootFromParent_Done,
      // Label 3396: @215731
      GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(215797), // Rule ID 5727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5727,
        GIR_EraseRootFromParent_Done,
      // Label 3397: @215797
      GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(215860), // Rule ID 5731 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_min:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5731,
        GIR_EraseRootFromParent_Done,
      // Label 3398: @215860
      GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(215917), // Rule ID 5728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5728,
        GIR_EraseRootFromParent_Done,
      // Label 3399: @215917
      GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(215971), // Rule ID 5732 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5732,
        GIR_EraseRootFromParent_Done,
      // Label 3400: @215971
      GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(216032), // Rule ID 5726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5726,
        GIR_EraseRootFromParent_Done,
      // Label 3401: @216032
      GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(216090), // Rule ID 5730 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_min:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_min_global_i64>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5730,
        GIR_EraseRootFromParent_Done,
      // Label 3402: @216090
      GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(216140), // Rule ID 8367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8367,
        GIR_EraseRootFromParent_Done,
      // Label 3403: @216140
      GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(216190), // Rule ID 8369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_noret_i64>>  =>  (DS_MIN_I64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8369,
        GIR_EraseRootFromParent_Done,
      // Label 3404: @216190
      GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(216240), // Rule ID 8371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_noret_i64>>  =>  (DS_MIN_I64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_I64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8371,
        GIR_EraseRootFromParent_Done,
      // Label 3405: @216240
      GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(216294), // Rule ID 8366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8366,
        GIR_EraseRootFromParent_Done,
      // Label 3406: @216294
      GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(216348), // Rule ID 8368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_local_i64>>  =>  (DS_MIN_RTN_I64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8368,
        GIR_EraseRootFromParent_Done,
      // Label 3407: @216348
      GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(216402), // Rule ID 8370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_min_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_min_region_m0_i64>>  =>  (DS_MIN_RTN_I64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_I64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8370,
        GIR_EraseRootFromParent_Done,
      // Label 3408: @216402
      GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(216459), // Rule ID 4052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4052,
        GIR_EraseRootFromParent_Done,
      // Label 3409: @216459
      GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(216520), // Rule ID 4054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_min:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4054,
        GIR_EraseRootFromParent_Done,
      // Label 3410: @216520
      GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(216572), // Rule ID 4051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4051,
        GIR_EraseRootFromParent_Done,
      // Label 3411: @216572
      GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(216628), // Rule ID 4053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_min:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (GLOBAL_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_SMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4053,
        GIR_EraseRootFromParent_Done,
      // Label 3412: @216628
      GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(216681), // Rule ID 3676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3676,
        GIR_EraseRootFromParent_Done,
      // Label 3413: @216681
      GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(216733), // Rule ID 3736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_noret_i64>>  =>  (FLAT_ATOMIC_SMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3736,
        GIR_EraseRootFromParent_Done,
      // Label 3414: @216733
      GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(216790), // Rule ID 3675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_flat_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3675,
        GIR_EraseRootFromParent_Done,
      // Label 3415: @216790
      GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(216846), // Rule ID 3735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_min:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_min_global_i64>>  =>  (FLAT_ATOMIC_SMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_SMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3735,
        GIR_EraseRootFromParent_Done,
      // Label 3416: @216846
      GIM_Reject,
    // Label 3394: @216847
    GIM_Reject,
    // Label 3370: @216848
    GIM_Reject,
    // Label 27: @216849
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3419*/ GIMT_Encode4(219360),
    /*GILLT_s32*//*Label 3417*/ GIMT_Encode4(216868),
    /*GILLT_s64*//*Label 3418*/ GIMT_Encode4(218114),
    // Label 3417: @216868
    GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(218113),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(216938), // Rule ID 5657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5657,
        GIR_EraseRootFromParent_Done,
      // Label 3421: @216938
      GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(216997), // Rule ID 5661 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5661,
        GIR_EraseRootFromParent_Done,
      // Label 3422: @216997
      GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(217063), // Rule ID 5655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5655,
        GIR_EraseRootFromParent_Done,
      // Label 3423: @217063
      GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(217126), // Rule ID 5659 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5659,
        GIR_EraseRootFromParent_Done,
      // Label 3424: @217126
      GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(217183), // Rule ID 5656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5656,
        GIR_EraseRootFromParent_Done,
      // Label 3425: @217183
      GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(217237), // Rule ID 5660 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5660,
        GIR_EraseRootFromParent_Done,
      // Label 3426: @217237
      GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(217298), // Rule ID 5654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5654,
        GIR_EraseRootFromParent_Done,
      // Label 3427: @217298
      GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(217356), // Rule ID 5658 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5658,
        GIR_EraseRootFromParent_Done,
      // Label 3428: @217356
      GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(217406), // Rule ID 8286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8286,
        GIR_EraseRootFromParent_Done,
      // Label 3429: @217406
      GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(217456), // Rule ID 8288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i32>>  =>  (DS_MAX_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8288,
        GIR_EraseRootFromParent_Done,
      // Label 3430: @217456
      GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(217506), // Rule ID 8290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i32>>  =>  (DS_MAX_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8290,
        GIR_EraseRootFromParent_Done,
      // Label 3431: @217506
      GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(217560), // Rule ID 8285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8285,
        GIR_EraseRootFromParent_Done,
      // Label 3432: @217560
      GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(217614), // Rule ID 8287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_local_i32>>  =>  (DS_MAX_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8287,
        GIR_EraseRootFromParent_Done,
      // Label 3433: @217614
      GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(217668), // Rule ID 8289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i32>>  =>  (DS_MAX_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8289,
        GIR_EraseRootFromParent_Done,
      // Label 3434: @217668
      GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(217725), // Rule ID 3992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3992,
        GIR_EraseRootFromParent_Done,
      // Label 3435: @217725
      GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(217786), // Rule ID 3994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umax:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3994,
        GIR_EraseRootFromParent_Done,
      // Label 3436: @217786
      GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(217838), // Rule ID 3991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3991,
        GIR_EraseRootFromParent_Done,
      // Label 3437: @217838
      GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(217894), // Rule ID 3993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umax:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (GLOBAL_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3993,
        GIR_EraseRootFromParent_Done,
      // Label 3438: @217894
      GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(217947), // Rule ID 3648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3648,
        GIR_EraseRootFromParent_Done,
      // Label 3439: @217947
      GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(217999), // Rule ID 3708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i32>>  =>  (FLAT_ATOMIC_UMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3708,
        GIR_EraseRootFromParent_Done,
      // Label 3440: @217999
      GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(218056), // Rule ID 3647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_flat_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3647,
        GIR_EraseRootFromParent_Done,
      // Label 3441: @218056
      GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(218112), // Rule ID 3707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umax_global_i32>>  =>  (FLAT_ATOMIC_UMAX_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3707,
        GIR_EraseRootFromParent_Done,
      // Label 3442: @218112
      GIM_Reject,
    // Label 3420: @218113
    GIM_Reject,
    // Label 3418: @218114
    GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(219359),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(218184), // Rule ID 5753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5753,
        GIR_EraseRootFromParent_Done,
      // Label 3444: @218184
      GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(218243), // Rule ID 5757 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5757,
        GIR_EraseRootFromParent_Done,
      // Label 3445: @218243
      GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(218309), // Rule ID 5751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5751,
        GIR_EraseRootFromParent_Done,
      // Label 3446: @218309
      GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(218372), // Rule ID 5755 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umax:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5755,
        GIR_EraseRootFromParent_Done,
      // Label 3447: @218372
      GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(218429), // Rule ID 5752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5752,
        GIR_EraseRootFromParent_Done,
      // Label 3448: @218429
      GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(218483), // Rule ID 5756 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5756,
        GIR_EraseRootFromParent_Done,
      // Label 3449: @218483
      GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(218544), // Rule ID 5750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5750,
        GIR_EraseRootFromParent_Done,
      // Label 3450: @218544
      GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(218602), // Rule ID 5754 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umax:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5754,
        GIR_EraseRootFromParent_Done,
      // Label 3451: @218602
      GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(218652), // Rule ID 8385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8385,
        GIR_EraseRootFromParent_Done,
      // Label 3452: @218652
      GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(218702), // Rule ID 8387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_noret_i64>>  =>  (DS_MAX_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8387,
        GIR_EraseRootFromParent_Done,
      // Label 3453: @218702
      GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(218752), // Rule ID 8389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_noret_i64>>  =>  (DS_MAX_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8389,
        GIR_EraseRootFromParent_Done,
      // Label 3454: @218752
      GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(218806), // Rule ID 8384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8384,
        GIR_EraseRootFromParent_Done,
      // Label 3455: @218806
      GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(218860), // Rule ID 8386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_local_i64>>  =>  (DS_MAX_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8386,
        GIR_EraseRootFromParent_Done,
      // Label 3456: @218860
      GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(218914), // Rule ID 8388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umax_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umax_region_m0_i64>>  =>  (DS_MAX_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8388,
        GIR_EraseRootFromParent_Done,
      // Label 3457: @218914
      GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(218971), // Rule ID 4048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4048,
        GIR_EraseRootFromParent_Done,
      // Label 3458: @218971
      GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(219032), // Rule ID 4050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umax:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4050,
        GIR_EraseRootFromParent_Done,
      // Label 3459: @219032
      GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(219084), // Rule ID 4047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4047,
        GIR_EraseRootFromParent_Done,
      // Label 3460: @219084
      GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(219140), // Rule ID 4049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umax:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (GLOBAL_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4049,
        GIR_EraseRootFromParent_Done,
      // Label 3461: @219140
      GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(219193), // Rule ID 3674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3674,
        GIR_EraseRootFromParent_Done,
      // Label 3462: @219193
      GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(219245), // Rule ID 3734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_noret_i64>>  =>  (FLAT_ATOMIC_UMAX_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3734,
        GIR_EraseRootFromParent_Done,
      // Label 3463: @219245
      GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(219302), // Rule ID 3673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_flat_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3673,
        GIR_EraseRootFromParent_Done,
      // Label 3464: @219302
      GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(219358), // Rule ID 3733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umax:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umax_global_i64>>  =>  (FLAT_ATOMIC_UMAX_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMAX_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3733,
        GIR_EraseRootFromParent_Done,
      // Label 3465: @219358
      GIM_Reject,
    // Label 3443: @219359
    GIM_Reject,
    // Label 3419: @219360
    GIM_Reject,
    // Label 28: @219361
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3468*/ GIMT_Encode4(221872),
    /*GILLT_s32*//*Label 3466*/ GIMT_Encode4(219380),
    /*GILLT_s64*//*Label 3467*/ GIMT_Encode4(220626),
    // Label 3466: @219380
    GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(220625),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(219450), // Rule ID 5641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5641,
        GIR_EraseRootFromParent_Done,
      // Label 3470: @219450
      GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(219509), // Rule ID 5645 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5645,
        GIR_EraseRootFromParent_Done,
      // Label 3471: @219509
      GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(219575), // Rule ID 5639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5639,
        GIR_EraseRootFromParent_Done,
      // Label 3472: @219575
      GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(219638), // Rule ID 5643 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5643,
        GIR_EraseRootFromParent_Done,
      // Label 3473: @219638
      GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(219695), // Rule ID 5640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5640,
        GIR_EraseRootFromParent_Done,
      // Label 3474: @219695
      GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(219749), // Rule ID 5644 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5644,
        GIR_EraseRootFromParent_Done,
      // Label 3475: @219749
      GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(219810), // Rule ID 5638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5638,
        GIR_EraseRootFromParent_Done,
      // Label 3476: @219810
      GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(219868), // Rule ID 5642 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5642,
        GIR_EraseRootFromParent_Done,
      // Label 3477: @219868
      GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(219918), // Rule ID 8280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8280,
        GIR_EraseRootFromParent_Done,
      // Label 3478: @219918
      GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(219968), // Rule ID 8282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i32>>  =>  (DS_MIN_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8282,
        GIR_EraseRootFromParent_Done,
      // Label 3479: @219968
      GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(220018), // Rule ID 8284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i32>>  =>  (DS_MIN_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8284,
        GIR_EraseRootFromParent_Done,
      // Label 3480: @220018
      GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(220072), // Rule ID 8279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8279,
        GIR_EraseRootFromParent_Done,
      // Label 3481: @220072
      GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(220126), // Rule ID 8281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_local_i32>>  =>  (DS_MIN_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8281,
        GIR_EraseRootFromParent_Done,
      // Label 3482: @220126
      GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(220180), // Rule ID 8283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i32>>  =>  (DS_MIN_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8283,
        GIR_EraseRootFromParent_Done,
      // Label 3483: @220180
      GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(220237), // Rule ID 4000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4000,
        GIR_EraseRootFromParent_Done,
      // Label 3484: @220237
      GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(220298), // Rule ID 4002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umin:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4002,
        GIR_EraseRootFromParent_Done,
      // Label 3485: @220298
      GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(220350), // Rule ID 3999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (GLOBAL_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3999,
        GIR_EraseRootFromParent_Done,
      // Label 3486: @220350
      GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(220406), // Rule ID 4001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umin:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (GLOBAL_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4001,
        GIR_EraseRootFromParent_Done,
      // Label 3487: @220406
      GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(220459), // Rule ID 3652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3652,
        GIR_EraseRootFromParent_Done,
      // Label 3488: @220459
      GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(220511), // Rule ID 3712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i32>>  =>  (FLAT_ATOMIC_UMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3712,
        GIR_EraseRootFromParent_Done,
      // Label 3489: @220511
      GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(220568), // Rule ID 3651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_flat_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3651,
        GIR_EraseRootFromParent_Done,
      // Label 3490: @220568
      GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(220624), // Rule ID 3711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_umin_global_i32>>  =>  (FLAT_ATOMIC_UMIN_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3711,
        GIR_EraseRootFromParent_Done,
      // Label 3491: @220624
      GIM_Reject,
    // Label 3469: @220625
    GIM_Reject,
    // Label 3467: @220626
    GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(221871),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(220696), // Rule ID 5737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5737,
        GIR_EraseRootFromParent_Done,
      // Label 3493: @220696
      GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(220755), // Rule ID 5741 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5741,
        GIR_EraseRootFromParent_Done,
      // Label 3494: @220755
      GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(220821), // Rule ID 5735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5735,
        GIR_EraseRootFromParent_Done,
      // Label 3495: @220821
      GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(220884), // Rule ID 5739 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_umin:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5739,
        GIR_EraseRootFromParent_Done,
      // Label 3496: @220884
      GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(220941), // Rule ID 5736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5736,
        GIR_EraseRootFromParent_Done,
      // Label 3497: @220941
      GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(220995), // Rule ID 5740 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5740,
        GIR_EraseRootFromParent_Done,
      // Label 3498: @220995
      GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(221056), // Rule ID 5734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5734,
        GIR_EraseRootFromParent_Done,
      // Label 3499: @221056
      GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(221114), // Rule ID 5738 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_umin:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5738,
        GIR_EraseRootFromParent_Done,
      // Label 3500: @221114
      GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(221164), // Rule ID 8379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8379,
        GIR_EraseRootFromParent_Done,
      // Label 3501: @221164
      GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(221214), // Rule ID 8381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_noret_i64>>  =>  (DS_MIN_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8381,
        GIR_EraseRootFromParent_Done,
      // Label 3502: @221214
      GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(221264), // Rule ID 8383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_noret_i64>>  =>  (DS_MIN_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8383,
        GIR_EraseRootFromParent_Done,
      // Label 3503: @221264
      GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(221318), // Rule ID 8378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8378,
        GIR_EraseRootFromParent_Done,
      // Label 3504: @221318
      GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(221372), // Rule ID 8380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_local_i64>>  =>  (DS_MIN_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8380,
        GIR_EraseRootFromParent_Done,
      // Label 3505: @221372
      GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(221426), // Rule ID 8382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_umin_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_umin_region_m0_i64>>  =>  (DS_MIN_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8382,
        GIR_EraseRootFromParent_Done,
      // Label 3506: @221426
      GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(221483), // Rule ID 4056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4056,
        GIR_EraseRootFromParent_Done,
      // Label 3507: @221483
      GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(221544), // Rule ID 4058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_umin:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4058,
        GIR_EraseRootFromParent_Done,
      // Label 3508: @221544
      GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(221596), // Rule ID 4055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4055,
        GIR_EraseRootFromParent_Done,
      // Label 3509: @221596
      GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(221652), // Rule ID 4057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_umin:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (GLOBAL_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_UMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4057,
        GIR_EraseRootFromParent_Done,
      // Label 3510: @221652
      GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(221705), // Rule ID 3678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3678,
        GIR_EraseRootFromParent_Done,
      // Label 3511: @221705
      GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(221757), // Rule ID 3738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_noret_i64>>  =>  (FLAT_ATOMIC_UMIN_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3738,
        GIR_EraseRootFromParent_Done,
      // Label 3512: @221757
      GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(221814), // Rule ID 3677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_flat_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3677,
        GIR_EraseRootFromParent_Done,
      // Label 3513: @221814
      GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(221870), // Rule ID 3737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_umin:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_umin_global_i64>>  =>  (FLAT_ATOMIC_UMIN_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_UMIN_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3737,
        GIR_EraseRootFromParent_Done,
      // Label 3514: @221870
      GIM_Reject,
    // Label 3492: @221871
    GIM_Reject,
    // Label 3468: @221872
    GIM_Reject,
    // Label 29: @221873
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 3518*/ GIMT_Encode4(224731),
    /*GILLT_s32*//*Label 3515*/ GIMT_Encode4(221896),
    /*GILLT_s64*//*Label 3516*/ GIMT_Encode4(222554),
    /*GILLT_v2s16*//*Label 3517*/ GIMT_Encode4(223004),
    // Label 3515: @221896
    GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(222553),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(221954), // Rule ID 8316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8316,
        GIR_EraseRootFromParent_Done,
      // Label 3520: @221954
      GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(222004), // Rule ID 8318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f32>>  =>  (DS_ADD_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8318,
        GIR_EraseRootFromParent_Done,
      // Label 3521: @222004
      GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(222054), // Rule ID 8320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_f32>>  =>  (DS_ADD_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8320,
        GIR_EraseRootFromParent_Done,
      // Label 3522: @222054
      GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(222108), // Rule ID 8315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8315,
        GIR_EraseRootFromParent_Done,
      // Label 3523: @222108
      GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(222162), // Rule ID 8317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLDSFPAtomicAddF32_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_local_f32>>  =>  (DS_ADD_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8317,
        GIR_EraseRootFromParent_Done,
      // Label 3524: @222162
      GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(222216), // Rule ID 8319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS_HasLDSFPAtomicAddF32),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_f32>>  =>  (DS_ADD_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8319,
        GIR_EraseRootFromParent_Done,
      // Label 3525: @222216
      GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(222273), // Rule ID 4122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4122,
        GIR_EraseRootFromParent_Done,
      // Label 3526: @222273
      GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(222334), // Rule ID 4126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4126,
        GIR_EraseRootFromParent_Done,
      // Label 3527: @222334
      GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(222386), // Rule ID 4121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4121,
        GIR_EraseRootFromParent_Done,
      // Label 3528: @222386
      GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(222442), // Rule ID 4125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_global_f32>>  =>  (GLOBAL_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F32_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4125,
        GIR_EraseRootFromParent_Done,
      // Label 3529: @222442
      GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(222495), // Rule ID 4146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f32>>  =>  (FLAT_ATOMIC_ADD_F32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4146,
        GIR_EraseRootFromParent_Done,
      // Label 3530: @222495
      GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(222552), // Rule ID 4145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAtomicFaddF32Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fadd_flat_f32>>  =>  (FLAT_ATOMIC_ADD_F32_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F32_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4145,
        GIR_EraseRootFromParent_Done,
      // Label 3531: @222552
      GIM_Reject,
    // Label 3519: @222553
    GIM_Reject,
    // Label 3516: @222554
    GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(223003),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(222612), // Rule ID 8413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_f64>>  =>  (DS_ADD_F64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8413,
        GIR_EraseRootFromParent_Done,
      // Label 3533: @222612
      GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(222666), // Rule ID 8412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLdsAtomicAddF64),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fadd_local_f64>>  =>  (DS_ADD_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_RTN_F64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8412,
        GIR_EraseRootFromParent_Done,
      // Label 3534: @222666
      GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(222723), // Rule ID 4140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4140,
        GIR_EraseRootFromParent_Done,
      // Label 3535: @222723
      GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(222784), // Rule ID 4142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4142,
        GIR_EraseRootFromParent_Done,
      // Label 3536: @222784
      GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(222836), // Rule ID 4139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4139,
        GIR_EraseRootFromParent_Done,
      // Label 3537: @222836
      GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(222892), // Rule ID 4141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_global_f64>>  =>  (GLOBAL_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ADD_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4141,
        GIR_EraseRootFromParent_Done,
      // Label 3538: @222892
      GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(222945), // Rule ID 4144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_f64>>  =>  (FLAT_ATOMIC_ADD_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4144,
        GIR_EraseRootFromParent_Done,
      // Label 3539: @222945
      GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(223002), // Rule ID 4143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fadd_flat_f64>>  =>  (FLAT_ATOMIC_ADD_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_ADD_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4143,
        GIR_EraseRootFromParent_Done,
      // Label 3540: @223002
      GIM_Reject,
    // Label 3532: @223003
    GIM_Reject,
    // Label 3517: @223004
    GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(224730),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(223062), // Rule ID 8304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8304,
        GIR_EraseRootFromParent_Done,
      // Label 3542: @223062
      GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(223112), // Rule ID 8306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8306,
        GIR_EraseRootFromParent_Done,
      // Label 3543: @223112
      GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(223162), // Rule ID 8308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8308,
        GIR_EraseRootFromParent_Done,
      // Label 3544: @223162
      GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(223212), // Rule ID 8310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2bf16>>  =>  (DS_PK_ADD_BF16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_BF16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8310,
        GIR_EraseRootFromParent_Done,
      // Label 3545: @223212
      GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(223262), // Rule ID 8312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2bf16>>  =>  (DS_PK_ADD_BF16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_BF16_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8312,
        GIR_EraseRootFromParent_Done,
      // Label 3546: @223262
      GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(223312), // Rule ID 8314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2bf16>>  =>  (DS_PK_ADD_BF16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_BF16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8314,
        GIR_EraseRootFromParent_Done,
      // Label 3547: @223312
      GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(223362), // Rule ID 8415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8415,
        GIR_EraseRootFromParent_Done,
      // Label 3548: @223362
      GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(223412), // Rule ID 8417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_noret_v2f16>>  =>  (DS_PK_ADD_F16_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8417,
        GIR_EraseRootFromParent_Done,
      // Label 3549: @223412
      GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(223462), // Rule ID 8419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_noret_v2f16>>  =>  (DS_PK_ADD_F16 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8419,
        GIR_EraseRootFromParent_Done,
      // Label 3550: @223462
      GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(223516), // Rule ID 8303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8303,
        GIR_EraseRootFromParent_Done,
      // Label 3551: @223516
      GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(223570), // Rule ID 8305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8305,
        GIR_EraseRootFromParent_Done,
      // Label 3552: @223570
      GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(223624), // Rule ID 8307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8307,
        GIR_EraseRootFromParent_Done,
      // Label 3553: @223624
      GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(223678), // Rule ID 8309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2bf16>>  =>  (DS_PK_ADD_RTN_BF16:{ *:[v2bf16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_BF16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8309,
        GIR_EraseRootFromParent_Done,
      // Label 3554: @223678
      GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(223732), // Rule ID 8311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2bf16>>  =>  (DS_PK_ADD_RTN_BF16_gfx9:{ *:[v2bf16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_BF16_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8311,
        GIR_EraseRootFromParent_Done,
      // Label 3555: @223732
      GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(223786), // Rule ID 8313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2bf16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2bf16>>  =>  (DS_PK_ADD_RTN_BF16:{ *:[v2bf16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2bf16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_BF16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8313,
        GIR_EraseRootFromParent_Done,
      // Label 3556: @223786
      GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(223840), // Rule ID 8414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8414,
        GIR_EraseRootFromParent_Done,
      // Label 3557: @223840
      GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(223894), // Rule ID 8416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_local_v2f16>>  =>  (DS_PK_ADD_RTN_F16_gfx9:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8416,
        GIR_EraseRootFromParent_Done,
      // Label 3558: @223894
      GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(223948), // Rule ID 8418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicDsPkAdd16Insts_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fadd_glue:{ *:[v2f16] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$value)<<P:Predicate_atomic_load_fadd_region_m0_v2f16>>  =>  (DS_PK_ADD_RTN_F16:{ *:[v2f16] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[v2f16] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PK_ADD_RTN_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8418,
        GIR_EraseRootFromParent_Done,
      // Label 3559: @223948
      GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(224005), // Rule ID 4124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4124,
        GIR_EraseRootFromParent_Done,
      // Label 3560: @224005
      GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(224062), // Rule ID 4128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4128,
        GIR_EraseRootFromParent_Done,
      // Label 3561: @224062
      GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(224119), // Rule ID 4152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicGlobalPkAddBF16Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[v2bf16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2bf16>>  =>  (GLOBAL_ATOMIC_PK_ADD_BF16_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_BF16_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4152,
        GIR_EraseRootFromParent_Done,
      // Label 3562: @224119
      GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(224180), // Rule ID 4130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN:{ *:[v2f16] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4130,
        GIR_EraseRootFromParent_Done,
      // Label 3563: @224180
      GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(224241), // Rule ID 4154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicGlobalPkAddBF16Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fadd:{ *:[v2bf16] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2bf16>>  =>  (GLOBAL_ATOMIC_PK_ADD_BF16_SADDR_RTN:{ *:[v2bf16] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_BF16_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4154,
        GIR_EraseRootFromParent_Done,
      // Label 3564: @224241
      GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(224293), // Rule ID 4123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4123,
        GIR_EraseRootFromParent_Done,
      // Label 3565: @224293
      GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(224345), // Rule ID 4127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4127,
        GIR_EraseRootFromParent_Done,
      // Label 3566: @224345
      GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(224397), // Rule ID 4151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicGlobalPkAddBF16Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_global_noret_v2bf16>>  =>  (GLOBAL_ATOMIC_PK_ADD_BF16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_BF16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4151,
        GIR_EraseRootFromParent_Done,
      // Label 3567: @224397
      GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(224453), // Rule ID 4129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[v2f16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2f16>>  =>  (GLOBAL_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_F16_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4129,
        GIR_EraseRootFromParent_Done,
      // Label 3568: @224453
      GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(224509), // Rule ID 4153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicGlobalPkAddBF16Inst),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_global_v2bf16>>  =>  (GLOBAL_ATOMIC_PK_ADD_BF16_RTN:{ *:[v2bf16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_PK_ADD_BF16_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4153,
        GIR_EraseRootFromParent_Done,
      // Label 3569: @224509
      GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(224562), // Rule ID 4148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4148,
        GIR_EraseRootFromParent_Done,
      // Label 3570: @224562
      GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(224615), // Rule ID 4150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_flat_noret_v2bf16>>  =>  (FLAT_ATOMIC_PK_ADD_BF16 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_BF16),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4150,
        GIR_EraseRootFromParent_Done,
      // Label 3571: @224615
      GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(224672), // Rule ID 4147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[v2f16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2f16:{ *:[v2f16] }:$data)<<P:Predicate_atomic_load_fadd_flat_v2f16>>  =>  (FLAT_ATOMIC_PK_ADD_F16_RTN:{ *:[v2f16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2f16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_F16_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4147,
        GIR_EraseRootFromParent_Done,
      // Label 3572: @224672
      GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(224729), // Rule ID 4149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFlatPkAdd16Insts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fadd:{ *:[v2bf16] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2bf16:{ *:[v2bf16] }:$data)<<P:Predicate_atomic_load_fadd_flat_v2bf16>>  =>  (FLAT_ATOMIC_PK_ADD_BF16_RTN:{ *:[v2bf16] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[v2bf16] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_PK_ADD_BF16_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4149,
        GIR_EraseRootFromParent_Done,
      // Label 3573: @224729
      GIM_Reject,
    // Label 3541: @224730
    GIM_Reject,
    // Label 3518: @224731
    GIM_Reject,
    // Label 30: @224732
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3576*/ GIMT_Encode4(227377),
    /*GILLT_s32*//*Label 3574*/ GIMT_Encode4(224751),
    /*GILLT_s64*//*Label 3575*/ GIMT_Encode4(226119),
    // Label 3574: @224751
    GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(226118),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(224821), // Rule ID 5809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64 anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5809,
        GIR_EraseRootFromParent_Done,
      // Label 3578: @224821
      GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(224883), // Rule ID 5813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64 anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5813,
        GIR_EraseRootFromParent_Done,
      // Label 3579: @224883
      GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(224949), // Rule ID 5807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_ADDR64_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5807,
        GIR_EraseRootFromParent_Done,
      // Label 3580: @224949
      GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(225015), // Rule ID 5811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5811,
        GIR_EraseRootFromParent_Done,
      // Label 3581: @225015
      GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(225072), // Rule ID 5808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5808,
        GIR_EraseRootFromParent_Done,
      // Label 3582: @225072
      GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(225129), // Rule ID 5812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5812,
        GIR_EraseRootFromParent_Done,
      // Label 3583: @225129
      GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(225190), // Rule ID 5806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5806,
        GIR_EraseRootFromParent_Done,
      // Label 3584: @225190
      GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(225251), // Rule ID 5810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5810,
        GIR_EraseRootFromParent_Done,
      // Label 3585: @225251
      GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(225301), // Rule ID 8298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8298,
        GIR_EraseRootFromParent_Done,
      // Label 3586: @225301
      GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(225351), // Rule ID 8300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f32>>  =>  (DS_MAX_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8300,
        GIR_EraseRootFromParent_Done,
      // Label 3587: @225351
      GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(225401), // Rule ID 8302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f32>>  =>  (DS_MAX_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8302,
        GIR_EraseRootFromParent_Done,
      // Label 3588: @225401
      GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(225455), // Rule ID 8297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8297,
        GIR_EraseRootFromParent_Done,
      // Label 3589: @225455
      GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(225509), // Rule ID 8299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_local_f32>>  =>  (DS_MAX_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8299,
        GIR_EraseRootFromParent_Done,
      // Label 3590: @225509
      GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(225563), // Rule ID 8301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f32>>  =>  (DS_MAX_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8301,
        GIR_EraseRootFromParent_Done,
      // Label 3591: @225563
      GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(225620), // Rule ID 4102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4102,
        GIR_EraseRootFromParent_Done,
      // Label 3592: @225620
      GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(225681), // Rule ID 4104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmax:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4104,
        GIR_EraseRootFromParent_Done,
      // Label 3593: @225681
      GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(225733), // Rule ID 4101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4101,
        GIR_EraseRootFromParent_Done,
      // Label 3594: @225733
      GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(225789), // Rule ID 4103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmax:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4103,
        GIR_EraseRootFromParent_Done,
      // Label 3595: @225789
      GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(225842), // Rule ID 3690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3690,
        GIR_EraseRootFromParent_Done,
      // Label 3596: @225842
      GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(225894), // Rule ID 3750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3750,
        GIR_EraseRootFromParent_Done,
      // Label 3597: @225894
      GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(225947), // Rule ID 4108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4108,
        GIR_EraseRootFromParent_Done,
      // Label 3598: @225947
      GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(226004), // Rule ID 3689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3689,
        GIR_EraseRootFromParent_Done,
      // Label 3599: @226004
      GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(226060), // Rule ID 3749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_global_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3749,
        GIR_EraseRootFromParent_Done,
      // Label 3600: @226060
      GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(226117), // Rule ID 4107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmax_flat_f32>>  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4107,
        GIR_EraseRootFromParent_Done,
      // Label 3601: @226117
      GIM_Reject,
    // Label 3577: @226118
    GIM_Reject,
    // Label 3575: @226119
    GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(227376),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(226189), // Rule ID 5825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64 anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5825,
        GIR_EraseRootFromParent_Done,
      // Label 3603: @226189
      GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(226251), // Rule ID 5829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64 anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5829,
        GIR_EraseRootFromParent_Done,
      // Label 3604: @226251
      GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(226317), // Rule ID 5823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_ADDR64_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5823,
        GIR_EraseRootFromParent_Done,
      // Label 3605: @226317
      GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(226383), // Rule ID 5827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5827,
        GIR_EraseRootFromParent_Done,
      // Label 3606: @226383
      GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(226440), // Rule ID 5824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5824,
        GIR_EraseRootFromParent_Done,
      // Label 3607: @226440
      GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(226497), // Rule ID 5828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5828,
        GIR_EraseRootFromParent_Done,
      // Label 3608: @226497
      GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(226558), // Rule ID 5822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5822,
        GIR_EraseRootFromParent_Done,
      // Label 3609: @226558
      GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(226619), // Rule ID 5826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmax:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5826,
        GIR_EraseRootFromParent_Done,
      // Label 3610: @226619
      GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(226669), // Rule ID 8397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8397,
        GIR_EraseRootFromParent_Done,
      // Label 3611: @226669
      GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(226719), // Rule ID 8399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_noret_f64>>  =>  (DS_MAX_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8399,
        GIR_EraseRootFromParent_Done,
      // Label 3612: @226719
      GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(226769), // Rule ID 8401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_noret_f64>>  =>  (DS_MAX_F64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8401,
        GIR_EraseRootFromParent_Done,
      // Label 3613: @226769
      GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(226823), // Rule ID 8396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8396,
        GIR_EraseRootFromParent_Done,
      // Label 3614: @226823
      GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(226877), // Rule ID 8398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_local_f64>>  =>  (DS_MAX_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8398,
        GIR_EraseRootFromParent_Done,
      // Label 3615: @226877
      GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(226931), // Rule ID 8400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmax_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmax_region_m0_f64>>  =>  (DS_MAX_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MAX_RTN_F64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8400,
        GIR_EraseRootFromParent_Done,
      // Label 3616: @226931
      GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(226988), // Rule ID 4136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4136,
        GIR_EraseRootFromParent_Done,
      // Label 3617: @226988
      GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(227049), // Rule ID 4138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmax:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4138,
        GIR_EraseRootFromParent_Done,
      // Label 3618: @227049
      GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(227101), // Rule ID 4135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4135,
        GIR_EraseRootFromParent_Done,
      // Label 3619: @227101
      GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(227157), // Rule ID 4137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmax:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (GLOBAL_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MAX_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4137,
        GIR_EraseRootFromParent_Done,
      // Label 3620: @227157
      GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(227210), // Rule ID 3694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3694,
        GIR_EraseRootFromParent_Done,
      // Label 3621: @227210
      GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(227262), // Rule ID 3754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_noret_f64>>  =>  (FLAT_ATOMIC_MAX_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3754,
        GIR_EraseRootFromParent_Done,
      // Label 3622: @227262
      GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(227319), // Rule ID 3693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_flat_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3693,
        GIR_EraseRootFromParent_Done,
      // Label 3623: @227319
      GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(227375), // Rule ID 3753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmax:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmax_global_f64>>  =>  (FLAT_ATOMIC_MAX_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MAX_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3753,
        GIR_EraseRootFromParent_Done,
      // Label 3624: @227375
      GIM_Reject,
    // Label 3602: @227376
    GIM_Reject,
    // Label 3576: @227377
    GIM_Reject,
    // Label 31: @227378
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3627*/ GIMT_Encode4(230023),
    /*GILLT_s32*//*Label 3625*/ GIMT_Encode4(227397),
    /*GILLT_s64*//*Label 3626*/ GIMT_Encode4(228765),
    // Label 3625: @227397
    GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(228764),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(227467), // Rule ID 5801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64 anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5801,
        GIR_EraseRootFromParent_Done,
      // Label 3629: @227467
      GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(227529), // Rule ID 5805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64 anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5805,
        GIR_EraseRootFromParent_Done,
      // Label 3630: @227529
      GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(227595), // Rule ID 5799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_ADDR64_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5799,
        GIR_EraseRootFromParent_Done,
      // Label 3631: @227595
      GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(227661), // Rule ID 5803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5803,
        GIR_EraseRootFromParent_Done,
      // Label 3632: @227661
      GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(227718), // Rule ID 5800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5800,
        GIR_EraseRootFromParent_Done,
      // Label 3633: @227718
      GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(227775), // Rule ID 5804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5804,
        GIR_EraseRootFromParent_Done,
      // Label 3634: @227775
      GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(227836), // Rule ID 5798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5798,
        GIR_EraseRootFromParent_Done,
      // Label 3635: @227836
      GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(227897), // Rule ID 5802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5802,
        GIR_EraseRootFromParent_Done,
      // Label 3636: @227897
      GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(227947), // Rule ID 8292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8292,
        GIR_EraseRootFromParent_Done,
      // Label 3637: @227947
      GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(227997), // Rule ID 8294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f32>>  =>  (DS_MIN_F32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8294,
        GIR_EraseRootFromParent_Done,
      // Label 3638: @227997
      GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(228047), // Rule ID 8296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f32>>  =>  (DS_MIN_F32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8296,
        GIR_EraseRootFromParent_Done,
      // Label 3639: @228047
      GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(228101), // Rule ID 8291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8291,
        GIR_EraseRootFromParent_Done,
      // Label 3640: @228101
      GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(228155), // Rule ID 8293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_local_f32>>  =>  (DS_MIN_RTN_F32_gfx9:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8293,
        GIR_EraseRootFromParent_Done,
      // Label 3641: @228155
      GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(228209), // Rule ID 8295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f32>>  =>  (DS_MIN_RTN_F32:{ *:[f32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[f32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8295,
        GIR_EraseRootFromParent_Done,
      // Label 3642: @228209
      GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(228266), // Rule ID 4098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4098,
        GIR_EraseRootFromParent_Done,
      // Label 3643: @228266
      GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(228327), // Rule ID 4100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmin:{ *:[f32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4100,
        GIR_EraseRootFromParent_Done,
      // Label 3644: @228327
      GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(228379), // Rule ID 4097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4097,
        GIR_EraseRootFromParent_Done,
      // Label 3645: @228379
      GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(228435), // Rule ID 4099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmin:{ *:[f32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4099,
        GIR_EraseRootFromParent_Done,
      // Label 3646: @228435
      GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(228488), // Rule ID 3688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3688,
        GIR_EraseRootFromParent_Done,
      // Label 3647: @228488
      GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(228540), // Rule ID 3748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3748,
        GIR_EraseRootFromParent_Done,
      // Label 3648: @228540
      GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(228593), // Rule ID 4106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f32>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4106,
        GIR_EraseRootFromParent_Done,
      // Label 3649: @228593
      GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(228650), // Rule ID 3687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3687,
        GIR_EraseRootFromParent_Done,
      // Label 3650: @228650
      GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(228706), // Rule ID 3747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_global_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3747,
        GIR_EraseRootFromParent_Done,
      // Label 3651: @228706
      GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(228763), // Rule ID 4105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32FlatInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_atomic_load_fmin_flat_f32>>  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4105,
        GIR_EraseRootFromParent_Done,
      // Label 3652: @228763
      GIM_Reject,
    // Label 3628: @228764
    GIM_Reject,
    // Label 3626: @228765
    GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(230022),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(228835), // Rule ID 5817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64 anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5817,
        GIR_EraseRootFromParent_Done,
      // Label 3654: @228835
      GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(228897), // Rule ID 5821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64 anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5821,
        GIR_EraseRootFromParent_Done,
      // Label 3655: @228897
      GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(228963), // Rule ID 5815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_ADDR64_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5815,
        GIR_EraseRootFromParent_Done,
      // Label 3656: @228963
      GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(229029), // Rule ID 5819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5819,
        GIR_EraseRootFromParent_Done,
      // Label 3657: @229029
      GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(229086), // Rule ID 5816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5816,
        GIR_EraseRootFromParent_Done,
      // Label 3658: @229086
      GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(229143), // Rule ID 5820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5820,
        GIR_EraseRootFromParent_Done,
      // Label 3659: @229143
      GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(229204), // Rule ID 5814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5814,
        GIR_EraseRootFromParent_Done,
      // Label 3660: @229204
      GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(229265), // Rule ID 5818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_fmin:{ *:[f64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$vdata_in)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5818,
        GIR_EraseRootFromParent_Done,
      // Label 3661: @229265
      GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(229315), // Rule ID 8391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8391,
        GIR_EraseRootFromParent_Done,
      // Label 3662: @229315
      GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(229365), // Rule ID 8393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_noret_f64>>  =>  (DS_MIN_F64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8393,
        GIR_EraseRootFromParent_Done,
      // Label 3663: @229365
      GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(229415), // Rule ID 8395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_noret_f64>>  =>  (DS_MIN_F64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8395,
        GIR_EraseRootFromParent_Done,
      // Label 3664: @229415
      GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(229469), // Rule ID 8390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8390,
        GIR_EraseRootFromParent_Done,
      // Label 3665: @229469
      GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(229523), // Rule ID 8392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_local_f64>>  =>  (DS_MIN_RTN_F64_gfx9:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8392,
        GIR_EraseRootFromParent_Done,
      // Label 3666: @229523
      GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(229577), // Rule ID 8394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_fmin_glue:{ *:[f64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$value)<<P:Predicate_atomic_load_fmin_region_m0_f64>>  =>  (DS_MIN_RTN_F64:{ *:[f64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[f64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_MIN_RTN_F64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8394,
        GIR_EraseRootFromParent_Done,
      // Label 3667: @229577
      GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(229634), // Rule ID 4132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4132,
        GIR_EraseRootFromParent_Done,
      // Label 3668: @229634
      GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(229695), // Rule ID 4134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_fmin:{ *:[f64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_SADDR_RTN:{ *:[f64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4134,
        GIR_EraseRootFromParent_Done,
      // Label 3669: @229695
      GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(229747), // Rule ID 4131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4131,
        GIR_EraseRootFromParent_Done,
      // Label 3670: @229747
      GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(229803), // Rule ID 4133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_fmin:{ *:[f64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (GLOBAL_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_MIN_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4133,
        GIR_EraseRootFromParent_Done,
      // Label 3671: @229803
      GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(229856), // Rule ID 3692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3692,
        GIR_EraseRootFromParent_Done,
      // Label 3672: @229856
      GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(229908), // Rule ID 3752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_noret_f64>>  =>  (FLAT_ATOMIC_MIN_F64 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3752,
        GIR_EraseRootFromParent_Done,
      // Label 3673: @229908
      GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(229965), // Rule ID 3691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_flat_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3691,
        GIR_EraseRootFromParent_Done,
      // Label 3674: @229965
      GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(230021), // Rule ID 3751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64FlatInsts_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_fmin:{ *:[f64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f64:{ *:[f64] }:$data)<<P:Predicate_atomic_load_fmin_global_f64>>  =>  (FLAT_ATOMIC_MIN_F64_RTN:{ *:[f64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[f64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_MIN_F64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3751,
        GIR_EraseRootFromParent_Done,
      // Label 3675: @230021
      GIM_Reject,
    // Label 3653: @230022
    GIM_Reject,
    // Label 3627: @230023
    GIM_Reject,
    // Label 32: @230024
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3678*/ GIMT_Encode4(232535),
    /*GILLT_s32*//*Label 3676*/ GIMT_Encode4(230043),
    /*GILLT_s64*//*Label 3677*/ GIMT_Encode4(231289),
    // Label 3676: @230043
    GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(231288),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(230113), // Rule ID 5689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5689,
        GIR_EraseRootFromParent_Done,
      // Label 3680: @230113
      GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(230172), // Rule ID 5693 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5693,
        GIR_EraseRootFromParent_Done,
      // Label 3681: @230172
      GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(230238), // Rule ID 5687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5687,
        GIR_EraseRootFromParent_Done,
      // Label 3682: @230238
      GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(230301), // Rule ID 5691 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5691,
        GIR_EraseRootFromParent_Done,
      // Label 3683: @230301
      GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(230358), // Rule ID 5688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5688,
        GIR_EraseRootFromParent_Done,
      // Label 3684: @230358
      GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(230412), // Rule ID 5692 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5692,
        GIR_EraseRootFromParent_Done,
      // Label 3685: @230412
      GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(230473), // Rule ID 5686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5686,
        GIR_EraseRootFromParent_Done,
      // Label 3686: @230473
      GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(230531), // Rule ID 5690 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5690,
        GIR_EraseRootFromParent_Done,
      // Label 3687: @230531
      GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(230581), // Rule ID 8238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8238,
        GIR_EraseRootFromParent_Done,
      // Label 3688: @230581
      GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(230631), // Rule ID 8240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i32>>  =>  (DS_INC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8240,
        GIR_EraseRootFromParent_Done,
      // Label 3689: @230631
      GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(230681), // Rule ID 8242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i32>>  =>  (DS_INC_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8242,
        GIR_EraseRootFromParent_Done,
      // Label 3690: @230681
      GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(230735), // Rule ID 8237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8237,
        GIR_EraseRootFromParent_Done,
      // Label 3691: @230735
      GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(230789), // Rule ID 8239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i32>>  =>  (DS_INC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8239,
        GIR_EraseRootFromParent_Done,
      // Label 3692: @230789
      GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(230843), // Rule ID 8241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i32>>  =>  (DS_INC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8241,
        GIR_EraseRootFromParent_Done,
      // Label 3693: @230843
      GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(230900), // Rule ID 3976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3976,
        GIR_EraseRootFromParent_Done,
      // Label 3694: @230900
      GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(230961), // Rule ID 3978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3978,
        GIR_EraseRootFromParent_Done,
      // Label 3695: @230961
      GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(231013), // Rule ID 3975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3975,
        GIR_EraseRootFromParent_Done,
      // Label 3696: @231013
      GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(231069), // Rule ID 3977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3977,
        GIR_EraseRootFromParent_Done,
      // Label 3697: @231069
      GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(231122), // Rule ID 3640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3640,
        GIR_EraseRootFromParent_Done,
      // Label 3698: @231122
      GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(231174), // Rule ID 3700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_INC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3700,
        GIR_EraseRootFromParent_Done,
      // Label 3699: @231174
      GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(231231), // Rule ID 3639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3639,
        GIR_EraseRootFromParent_Done,
      // Label 3700: @231231
      GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(231287), // Rule ID 3699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i32>>  =>  (FLAT_ATOMIC_INC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3699,
        GIR_EraseRootFromParent_Done,
      // Label 3701: @231287
      GIM_Reject,
    // Label 3679: @231288
    GIM_Reject,
    // Label 3677: @231289
    GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(232534),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(231359), // Rule ID 5785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5785,
        GIR_EraseRootFromParent_Done,
      // Label 3703: @231359
      GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(231418), // Rule ID 5789 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5789,
        GIR_EraseRootFromParent_Done,
      // Label 3704: @231418
      GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(231484), // Rule ID 5783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5783,
        GIR_EraseRootFromParent_Done,
      // Label 3705: @231484
      GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(231547), // Rule ID 5787 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5787,
        GIR_EraseRootFromParent_Done,
      // Label 3706: @231547
      GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(231604), // Rule ID 5784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5784,
        GIR_EraseRootFromParent_Done,
      // Label 3707: @231604
      GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(231658), // Rule ID 5788 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5788,
        GIR_EraseRootFromParent_Done,
      // Label 3708: @231658
      GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(231719), // Rule ID 5782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5782,
        GIR_EraseRootFromParent_Done,
      // Label 3709: @231719
      GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(231777), // Rule ID 5786 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5786,
        GIR_EraseRootFromParent_Done,
      // Label 3710: @231777
      GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(231827), // Rule ID 8337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8337,
        GIR_EraseRootFromParent_Done,
      // Label 3711: @231827
      GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(231877), // Rule ID 8339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_noret_i64>>  =>  (DS_INC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8339,
        GIR_EraseRootFromParent_Done,
      // Label 3712: @231877
      GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(231927), // Rule ID 8341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_noret_i64>>  =>  (DS_INC_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8341,
        GIR_EraseRootFromParent_Done,
      // Label 3713: @231927
      GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(231981), // Rule ID 8336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8336,
        GIR_EraseRootFromParent_Done,
      // Label 3714: @231981
      GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(232035), // Rule ID 8338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_local_i64>>  =>  (DS_INC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8338,
        GIR_EraseRootFromParent_Done,
      // Label 3715: @232035
      GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(232089), // Rule ID 8340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_uinc_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_uinc_wrap_region_m0_i64>>  =>  (DS_INC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_INC_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8340,
        GIR_EraseRootFromParent_Done,
      // Label 3716: @232089
      GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(232146), // Rule ID 4032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4032,
        GIR_EraseRootFromParent_Done,
      // Label 3717: @232146
      GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(232207), // Rule ID 4034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4034,
        GIR_EraseRootFromParent_Done,
      // Label 3718: @232207
      GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(232259), // Rule ID 4031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4031,
        GIR_EraseRootFromParent_Done,
      // Label 3719: @232259
      GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(232315), // Rule ID 4033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_INC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4033,
        GIR_EraseRootFromParent_Done,
      // Label 3720: @232315
      GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(232368), // Rule ID 3666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3666,
        GIR_EraseRootFromParent_Done,
      // Label 3721: @232368
      GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(232420), // Rule ID 3726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_INC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3726,
        GIR_EraseRootFromParent_Done,
      // Label 3722: @232420
      GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(232477), // Rule ID 3665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_flat_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3665,
        GIR_EraseRootFromParent_Done,
      // Label 3723: @232477
      GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(232533), // Rule ID 3725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_uinc_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_uinc_wrap_global_i64>>  =>  (FLAT_ATOMIC_INC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_INC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3725,
        GIR_EraseRootFromParent_Done,
      // Label 3724: @232533
      GIM_Reject,
    // Label 3702: @232534
    GIM_Reject,
    // Label 3678: @232535
    GIM_Reject,
    // Label 33: @232536
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 3727*/ GIMT_Encode4(235047),
    /*GILLT_s32*//*Label 3725*/ GIMT_Encode4(232555),
    /*GILLT_s64*//*Label 3726*/ GIMT_Encode4(233801),
    // Label 3725: @232555
    GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(233800),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(232625), // Rule ID 5697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5697,
        GIR_EraseRootFromParent_Done,
      // Label 3729: @232625
      GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(232684), // Rule ID 5701 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64 anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5701,
        GIR_EraseRootFromParent_Done,
      // Label 3730: @232684
      GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(232750), // Rule ID 5695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5695,
        GIR_EraseRootFromParent_Done,
      // Label 3731: @232750
      GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(232813), // Rule ID 5699 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5699,
        GIR_EraseRootFromParent_Done,
      // Label 3732: @232813
      GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(232870), // Rule ID 5696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5696,
        GIR_EraseRootFromParent_Done,
      // Label 3733: @232870
      GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(232924), // Rule ID 5700 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5700,
        GIR_EraseRootFromParent_Done,
      // Label 3734: @232924
      GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(232985), // Rule ID 5694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5694,
        GIR_EraseRootFromParent_Done,
      // Label 3735: @232985
      GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(233043), // Rule ID 5698 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5698,
        GIR_EraseRootFromParent_Done,
      // Label 3736: @233043
      GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(233093), // Rule ID 8244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8244,
        GIR_EraseRootFromParent_Done,
      // Label 3737: @233093
      GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(233143), // Rule ID 8246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i32>>  =>  (DS_DEC_U32_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8246,
        GIR_EraseRootFromParent_Done,
      // Label 3738: @233143
      GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(233193), // Rule ID 8248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i32>>  =>  (DS_DEC_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8248,
        GIR_EraseRootFromParent_Done,
      // Label 3739: @233193
      GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(233247), // Rule ID 8243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8243,
        GIR_EraseRootFromParent_Done,
      // Label 3740: @233247
      GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(233301), // Rule ID 8245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i32>>  =>  (DS_DEC_RTN_U32_gfx9:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8245,
        GIR_EraseRootFromParent_Done,
      // Label 3741: @233301
      GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(233355), // Rule ID 8247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i32] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i32>>  =>  (DS_DEC_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8247,
        GIR_EraseRootFromParent_Done,
      // Label 3742: @233355
      GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(233412), // Rule ID 3980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3980,
        GIR_EraseRootFromParent_Done,
      // Label 3743: @233412
      GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(233473), // Rule ID 3982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_udec_wrap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3982,
        GIR_EraseRootFromParent_Done,
      // Label 3744: @233473
      GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(233525), // Rule ID 3979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3979,
        GIR_EraseRootFromParent_Done,
      // Label 3745: @233525
      GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(233581), // Rule ID 3981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (GLOBAL_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3981,
        GIR_EraseRootFromParent_Done,
      // Label 3746: @233581
      GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(233634), // Rule ID 3642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3642,
        GIR_EraseRootFromParent_Done,
      // Label 3747: @233634
      GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(233686), // Rule ID 3702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i32>>  =>  (FLAT_ATOMIC_DEC VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3702,
        GIR_EraseRootFromParent_Done,
      // Label 3748: @233686
      GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(233743), // Rule ID 3641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3641,
        GIR_EraseRootFromParent_Done,
      // Label 3749: @233743
      GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(233799), // Rule ID 3701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i32>>  =>  (FLAT_ATOMIC_DEC_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3701,
        GIR_EraseRootFromParent_Done,
      // Label 3750: @233799
      GIM_Reject,
    // Label 3728: @233800
    GIM_Reject,
    // Label 3726: @233801
    GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(235046),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(233871), // Rule ID 5793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5793,
        GIR_EraseRootFromParent_Done,
      // Label 3752: @233871
      GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(233930), // Rule ID 5797 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64 anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5797,
        GIR_EraseRootFromParent_Done,
      // Label 3753: @233930
      GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(233996), // Rule ID 5791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5791,
        GIR_EraseRootFromParent_Done,
      // Label 3754: @233996
      GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(234059), // Rule ID 5795 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5795,
        GIR_EraseRootFromParent_Done,
      // Label 3755: @234059
      GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(234116), // Rule ID 5792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5792,
        GIR_EraseRootFromParent_Done,
      // Label 3756: @234116
      GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(234170), // Rule ID 5796 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5796,
        GIR_EraseRootFromParent_Done,
      // Label 3757: @234170
      GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(234231), // Rule ID 5790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5790,
        GIR_EraseRootFromParent_Done,
      // Label 3758: @234231
      GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(234289), // Rule ID 5794 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$vdata_in)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5794,
        GIR_EraseRootFromParent_Done,
      // Label 3759: @234289
      GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(234339), // Rule ID 8343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8343,
        GIR_EraseRootFromParent_Done,
      // Label 3760: @234339
      GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(234389), // Rule ID 8345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_noret_i64>>  =>  (DS_DEC_U64_gfx9 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64_gfx9),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8345,
        GIR_EraseRootFromParent_Done,
      // Label 3761: @234389
      GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(234439), // Rule ID 8347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_noret_i64>>  =>  (DS_DEC_U64 ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_U64),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8347,
        GIR_EraseRootFromParent_Done,
      // Label 3762: @234439
      GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(234493), // Rule ID 8342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_LDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8342,
        GIR_EraseRootFromParent_Done,
      // Label 3763: @234493
      GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(234547), // Rule ID 8344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotLDSRequiresM0Init),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_local_i64>>  =>  (DS_DEC_RTN_U64_gfx9:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64_gfx9),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8344,
        GIR_EraseRootFromParent_Done,
      // Label 3764: @234547
      GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(234601), // Rule ID 8346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGDS),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/2,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (atomic_load_udec_wrap_glue:{ *:[i64] } (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$value)<<P:Predicate_atomic_load_udec_wrap_region_m0_i64>>  =>  (DS_DEC_RTN_U64:{ *:[i64] } ?:{ *:[i32] }:$ptr, anonymous_9450:{ *:[i64] }:$value, Offset:{ *:[i32] }:$offset, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DEC_RTN_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/2, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8346,
        GIR_EraseRootFromParent_Done,
      // Label 3765: @234601
      GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(234658), // Rule ID 4036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4036,
        GIR_EraseRootFromParent_Done,
      // Label 3766: @234658
      GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(234719), // Rule ID 4038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (atomic_load_udec_wrap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4038,
        GIR_EraseRootFromParent_Done,
      // Label 3767: @234719
      GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(234771), // Rule ID 4035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4035,
        GIR_EraseRootFromParent_Done,
      // Label 3768: @234771
      GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(234827), // Rule ID 4037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (GLOBAL_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_DEC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4037,
        GIR_EraseRootFromParent_Done,
      // Label 3769: @234827
      GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(234880), // Rule ID 3668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3668,
        GIR_EraseRootFromParent_Done,
      // Label 3770: @234880
      GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(234932), // Rule ID 3728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_noret_i64>>  =>  (FLAT_ATOMIC_DEC_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3728,
        GIR_EraseRootFromParent_Done,
      // Label 3771: @234932
      GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(234989), // Rule ID 3667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_flat_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3667,
        GIR_EraseRootFromParent_Done,
      // Label 3772: @234989
      GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(235045), // Rule ID 3727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (atomic_load_udec_wrap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)<<P:Predicate_atomic_load_udec_wrap_global_i64>>  =>  (FLAT_ATOMIC_DEC_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_DEC_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3727,
        GIR_EraseRootFromParent_Done,
      // Label 3773: @235045
      GIM_Reject,
    // Label 3751: @235046
    GIM_Reject,
    // Label 3727: @235047
    GIM_Reject,
    // Label 34: @235048
    GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(235066), // Rule ID 1335 //
      // MIs[0] ordering
      GIM_CheckIsImm, /*MI*/0, /*Op*/0,
      // MIs[0] scope
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // (atomic_fence (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)  =>  (ATOMIC_FENCE (timm:{ *:[i32] }):$ordering, (timm:{ *:[i32] }):$scope)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::ATOMIC_FENCE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1335,
      GIR_Done,
    // Label 3774: @235066
    GIM_Reject,
    // Label 35: @235067
    GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(235502),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_smrd_prefetch),
      GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(235185),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(235139), // Rule ID 3519 //
          GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
          // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
          GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 3519,
          GIR_EraseRootFromParent_Done,
        // Label 3777: @235139
        GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(235184), // Rule ID 3522 //
          GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
          // (prefetch (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
          GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 3522,
          GIR_EraseRootFromParent_Done,
        // Label 3778: @235184
        GIM_Reject,
      // Label 3776: @235185
      GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(235235), // Rule ID 3520 //
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // MIs[0] Operand 1
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] Operand 2
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] Operand 3
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
        // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
        GIR_RootToRootCopy, /*OpIdx*/0, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3520,
        GIR_EraseRootFromParent_Done,
      // Label 3779: @235235
      GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(235343), // Rule ID 3521 //
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // MIs[0] Operand 1
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] Operand 2
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] Operand 3
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_zero),
        // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_zero>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_INST (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_INST),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3521,
        GIR_EraseRootFromParent_Done,
      // Label 3780: @235343
      GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(235393), // Rule ID 3523 //
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // MIs[0] Operand 1
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] Operand 2
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] Operand 3
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
        // (prefetch SReg_64:{ *:[i64] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_RootToRootCopy, /*OpIdx*/0, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3523,
        GIR_EraseRootFromParent_Done,
      // Label 3781: @235393
      GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(235501), // Rule ID 3524 //
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // MIs[0] Operand 1
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] Operand 2
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] Operand 3
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32imm_one),
        // (prefetch SReg_32:{ *:[i32] }:$sbase, (timm:{ *:[i32] }), (timm:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_i32imm_one>>)<<P:Predicate_smrd_prefetch>>  =>  (S_PREFETCH_DATA (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$sbase, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i32] } 0:{ *:[i32] }), sub1:{ *:[i32] }), 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, 0:{ *:[i8] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // sbase
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3524,
        GIR_EraseRootFromParent_Done,
      // Label 3782: @235501
      GIM_Reject,
    // Label 3775: @235502
    GIM_Reject,
    // Label 36: @235503
    GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(235584),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
      GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(235535), // Rule ID 20 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getpc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3133:{ *:[iPTR] })  =>  (S_GETPC_B64_pseudo:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETPC_B64_pseudo),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 20,
        GIR_EraseRootFromParent_Done,
      // Label 3784: @235535
      GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(235559), // Rule ID 1345 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_groupstaticsize),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 2191:{ *:[iPTR] })  =>  (GET_GROUPSTATICSIZE:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GET_GROUPSTATICSIZE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1345,
        GIR_EraseRootFromParent_Done,
      // Label 3785: @235559
      GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(235583), // Rule ID 1352 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ps_live),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        // (intrinsic_wo_chain:{ *:[i1] } 3053:{ *:[iPTR] })  =>  (SI_PS_LIVE:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_PS_LIVE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1352,
        GIR_EraseRootFromParent_Done,
      // Label 3786: @235583
      GIM_Reject,
    // Label 3783: @235584
    GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(239330),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(235674), // Rule ID 2610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20844),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2167:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20844>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2610,
        GIR_EraseRootFromParent_Done,
      // Label 3788: @235674
      GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(235756), // Rule ID 2612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20846),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2981:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20846>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2612,
        GIR_EraseRootFromParent_Done,
      // Label 3789: @235756
      GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(235838), // Rule ID 2614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20838),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20838>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RCP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2614,
        GIR_EraseRootFromParent_Done,
      // Label 3790: @235838
      GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(235920), // Rule ID 2616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20840),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20840>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_RSQ_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2616,
        GIR_EraseRootFromParent_Done,
      // Label 3791: @235920
      GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(236002), // Rule ID 2619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20842),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20842>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2619,
        GIR_EraseRootFromParent_Done,
      // Label 3792: @236002
      GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(236035), // Rule ID 16 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13367),
        // (intrinsic_wo_chain:{ *:[i32] } 3173:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13367>>  =>  (S_FLBIT_I32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 16,
        GIR_EraseRootFromParent_Done,
      // Label 3793: @236035
      GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(236067), // Rule ID 1336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i1] } 2971:{ *:[iPTR] }, i32:{ *:[i32] }:$mask)  =>  (S_INVERSE_BALLOT_U32:{ *:[i1] } i32:{ *:[i32] }:$mask)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1336,
        GIR_EraseRootFromParent_Done,
      // Label 3794: @236067
      GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(236099), // Rule ID 1337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_inverse_ballot),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i1] } 2971:{ *:[iPTR] }, i64:{ *:[i64] }:$mask)  =>  (S_INVERSE_BALLOT_U64:{ *:[i1] } i64:{ *:[i64] }:$mask)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INVERSE_BALLOT_U64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1337,
        GIR_EraseRootFromParent_Done,
      // Label 3795: @236099
      GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(236160), // Rule ID 1072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20833),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2167:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20833>>  =>  (V_S_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1072,
        GIR_EraseRootFromParent_Done,
      // Label 3796: @236160
      GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(236221), // Rule ID 1074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20836),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2981:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20836>>  =>  (V_S_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1074,
        GIR_EraseRootFromParent_Done,
      // Label 3797: @236221
      GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(236282), // Rule ID 1076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20838),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20838>>  =>  (V_S_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RCP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1076,
        GIR_EraseRootFromParent_Done,
      // Label 3798: @236282
      GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(236343), // Rule ID 1078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20840),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20840>>  =>  (V_S_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_RSQ_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1078,
        GIR_EraseRootFromParent_Done,
      // Label 3799: @236343
      GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(236404), // Rule ID 1081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20842),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20842>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1081,
        GIR_EraseRootFromParent_Done,
      // Label 3800: @236404
      GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(236458), // Rule ID 656 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2181:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 656,
        GIR_EraseRootFromParent_Done,
      // Label 3801: @236458
      GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(236512), // Rule ID 662 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2167:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 662,
        GIR_EraseRootFromParent_Done,
      // Label 3802: @236512
      GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(236566), // Rule ID 664 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2981:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 664,
        GIR_EraseRootFromParent_Done,
      // Label 3803: @236566
      GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(236620), // Rule ID 666 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 666,
        GIR_EraseRootFromParent_Done,
      // Label 3804: @236620
      GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(236674), // Rule ID 669 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 669,
        GIR_EraseRootFromParent_Done,
      // Label 3805: @236674
      GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(236728), // Rule ID 671 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 671,
        GIR_EraseRootFromParent_Done,
      // Label 3806: @236728
      GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(236782), // Rule ID 672 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 672,
        GIR_EraseRootFromParent_Done,
      // Label 3807: @236782
      GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(236836), // Rule ID 674 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 674,
        GIR_EraseRootFromParent_Done,
      // Label 3808: @236836
      GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(236890), // Rule ID 676 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 676,
        GIR_EraseRootFromParent_Done,
      // Label 3809: @236890
      GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(236944), // Rule ID 677 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3174:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 677,
        GIR_EraseRootFromParent_Done,
      // Label 3810: @236944
      GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(236998), // Rule ID 679 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2061:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 679,
        GIR_EraseRootFromParent_Done,
      // Label 3811: @236998
      GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(237037), // Rule ID 686 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sffbh),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 3173:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 686,
        GIR_EraseRootFromParent_Done,
      // Label 3812: @237037
      GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(237091), // Rule ID 688 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 2182:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 688,
        GIR_EraseRootFromParent_Done,
      // Label 3813: @237091
      GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(237145), // Rule ID 689 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 2183:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 689,
        GIR_EraseRootFromParent_Done,
      // Label 3814: @237145
      GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(237199), // Rule ID 690 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 2181:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 690,
        GIR_EraseRootFromParent_Done,
      // Label 3815: @237199
      GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(237248), // Rule ID 692 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 2182:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp))  =>  (V_FREXP_EXP_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I32_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 692,
        GIR_EraseRootFromParent_Done,
      // Label 3816: @237248
      GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(237302), // Rule ID 693 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2183:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 693,
        GIR_EraseRootFromParent_Done,
      // Label 3817: @237302
      GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(237359), // Rule ID 694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log_clamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2982:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_CLAMP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 694,
        GIR_EraseRootFromParent_Done,
      // Label 3818: @237359
      GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(237416), // Rule ID 695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3107:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 695,
        GIR_EraseRootFromParent_Done,
      // Label 3819: @237416
      GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(237473), // Rule ID 697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3112:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 697,
        GIR_EraseRootFromParent_Done,
      // Label 3820: @237473
      GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(237530), // Rule ID 699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 3113:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 699,
        GIR_EraseRootFromParent_Done,
      // Label 3821: @237530
      GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(237587), // Rule ID 700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq_clamp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f64] } 3112:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_CLAMP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_CLAMP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 700,
        GIR_EraseRootFromParent_Done,
      // Label 3822: @237587
      GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(237644), // Rule ID 718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 718,
        GIR_EraseRootFromParent_Done,
      // Label 3823: @237644
      GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(237701), // Rule ID 722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3106:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 722,
        GIR_EraseRootFromParent_Done,
      // Label 3824: @237701
      GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(237758), // Rule ID 725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 725,
        GIR_EraseRootFromParent_Done,
      // Label 3825: @237758
      GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(237815), // Rule ID 729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3204:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 729,
        GIR_EraseRootFromParent_Done,
      // Label 3826: @237815
      GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(237872), // Rule ID 730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 730,
        GIR_EraseRootFromParent_Done,
      // Label 3827: @237872
      GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(237929), // Rule ID 734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3111:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RSQ_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 734,
        GIR_EraseRootFromParent_Done,
      // Label 3828: @237929
      GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(237986), // Rule ID 736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2981:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 736,
        GIR_EraseRootFromParent_Done,
      // Label 3829: @237986
      GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(238043), // Rule ID 740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2981:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 740,
        GIR_EraseRootFromParent_Done,
      // Label 3830: @238043
      GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(238100), // Rule ID 742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2167:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 742,
        GIR_EraseRootFromParent_Done,
      // Label 3831: @238100
      GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(238157), // Rule ID 746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2167:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 746,
        GIR_EraseRootFromParent_Done,
      // Label 3832: @238157
      GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(238214), // Rule ID 748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3174:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 748,
        GIR_EraseRootFromParent_Done,
      // Label 3833: @238214
      GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(238271), // Rule ID 752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 3174:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 752,
        GIR_EraseRootFromParent_Done,
      // Label 3834: @238271
      GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(238328), // Rule ID 754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2061:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 754,
        GIR_EraseRootFromParent_Done,
      // Label 3835: @238328
      GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(238385), // Rule ID 758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2061:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_COS_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 758,
        GIR_EraseRootFromParent_Done,
      // Label 3836: @238385
      GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(238442), // Rule ID 760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2183:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 760,
        GIR_EraseRootFromParent_Done,
      // Label 3837: @238442
      GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(238499), // Rule ID 762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2183:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_MANT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 762,
        GIR_EraseRootFromParent_Done,
      // Label 3838: @238499
      GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(238556), // Rule ID 763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i16] } 2182:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 763,
        GIR_EraseRootFromParent_Done,
      // Label 3839: @238556
      GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(238613), // Rule ID 765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i16] } 2182:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FREXP_EXP_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 765,
        GIR_EraseRootFromParent_Done,
      // Label 3840: @238613
      GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(238670), // Rule ID 778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2181:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 778,
        GIR_EraseRootFromParent_Done,
      // Label 3841: @238670
      GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(238727), // Rule ID 782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f16] } 2181:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FRACT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 782,
        GIR_EraseRootFromParent_Done,
      // Label 3842: @238727
      GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(238769), // Rule ID 784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrngInst),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_prng_b32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 3052:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_PRNG_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PRNG_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 784,
        GIR_EraseRootFromParent_Done,
      // Label 3843: @238769
      GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(238825), // Rule ID 720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rcp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 3106:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RCP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 720,
        GIR_EraseRootFromParent_Done,
      // Label 3844: @238825
      GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(238881), // Rule ID 727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sqrt),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 3204:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 727,
        GIR_EraseRootFromParent_Done,
      // Label 3845: @238881
      GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(238937), // Rule ID 732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_rsq),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 3111:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_RSQ_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RSQ_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 732,
        GIR_EraseRootFromParent_Done,
      // Label 3846: @238937
      GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(238993), // Rule ID 738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_log),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2981:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 738,
        GIR_EraseRootFromParent_Done,
      // Label 3847: @238993
      GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(239049), // Rule ID 744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_exp2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2167:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 744,
        GIR_EraseRootFromParent_Done,
      // Label 3848: @239049
      GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(239105), // Rule ID 750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 3174:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SIN_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 750,
        GIR_EraseRootFromParent_Done,
      // Label 3849: @239105
      GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(239161), // Rule ID 756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cos),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2061:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_COS_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_COS_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 756,
        GIR_EraseRootFromParent_Done,
      // Label 3850: @239161
      GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(239217), // Rule ID 761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_mant),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2183:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_MANT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_MANT_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 761,
        GIR_EraseRootFromParent_Done,
      // Label 3851: @239217
      GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(239273), // Rule ID 764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_frexp_exp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[i16] } 2182:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FREXP_EXP_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FREXP_EXP_I16_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 764,
        GIR_EraseRootFromParent_Done,
      // Label 3852: @239273
      GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(239329), // Rule ID 780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fract),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2181:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FRACT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 780,
        GIR_EraseRootFromParent_Done,
      // Label 3853: @239329
      GIM_Reject,
    // Label 3787: @239330
    GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(241969),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(239387), // Rule ID 1891 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (intrinsic_wo_chain:{ *:[i1] } 2060:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1891,
        GIR_EraseRootFromParent_Done,
      // Label 3855: @239387
      GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(239442), // Rule ID 1893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (intrinsic_wo_chain:{ *:[i1] } 2060:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1893,
        GIR_EraseRootFromParent_Done,
      // Label 3856: @239442
      GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(239491), // Rule ID 1895 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (intrinsic_wo_chain:{ *:[i1] } 2060:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1895,
        GIR_EraseRootFromParent_Done,
      // Label 3857: @239491
      GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(239543), // Rule ID 1897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_class),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (intrinsic_wo_chain:{ *:[i1] } 2060:{ *:[iPTR] }, (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src1)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1897,
        GIR_EraseRootFromParent_Done,
      // Label 3858: @239543
      GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(239598), // Rule ID 2298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2298,
        GIR_EraseRootFromParent_Done,
      // Label 3859: @239598
      GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(239653), // Rule ID 2299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtFP8VOP1Bug_HasFP8ConversionInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2299,
        GIR_EraseRootFromParent_Done,
      // Label 3860: @239653
      GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(239696), // Rule ID 2300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_FP8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2300,
        GIR_EraseRootFromParent_Done,
      // Label 3861: @239696
      GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(239739), // Rule ID 2301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasNoCvtFP8VOP1Bug_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i32] })  =>  (V_CVT_F32_BF8_e32:{ *:[f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2301,
        GIR_EraseRootFromParent_Done,
      // Label 3862: @239739
      GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(239794), // Rule ID 2302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2302,
        GIR_EraseRootFromParent_Done,
      // Label 3863: @239794
      GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(239849), // Rule ID 2303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2303,
        GIR_EraseRootFromParent_Done,
      // Label 3864: @239849
      GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(239904), // Rule ID 2304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2304,
        GIR_EraseRootFromParent_Done,
      // Label 3865: @239904
      GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(239959), // Rule ID 2305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 2:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 2:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2305,
        GIR_EraseRootFromParent_Done,
      // Label 3866: @239959
      GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(240014), // Rule ID 2306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_FP8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2306,
        GIR_EraseRootFromParent_Done,
      // Label 3867: @240014
      GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(240069), // Rule ID 2307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 3:{ *:[i32] })  =>  (V_CVT_F32_BF8_sdwa:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 3:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2307,
        GIR_EraseRootFromParent_Done,
      // Label 3868: @240069
      GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(240112), // Rule ID 2308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2071:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2308,
        GIR_EraseRootFromParent_Done,
      // Label 3869: @240112
      GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(240155), // Rule ID 2309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2070:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2309,
        GIR_EraseRootFromParent_Done,
      // Label 3870: @240155
      GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(240210), // Rule ID 2310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2071:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2310,
        GIR_EraseRootFromParent_Done,
      // Label 3871: @240210
      GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(240265), // Rule ID 2311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_HasSDWA),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2070:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_sdwa:{ *:[v2f32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] }, 5:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_sdwa),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2311,
        GIR_EraseRootFromParent_Done,
      // Label 3872: @240265
      GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(240308), // Rule ID 2314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2071:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2314,
        GIR_EraseRootFromParent_Done,
      // Label 3873: @240308
      GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(240351), // Rule ID 2315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2070:{ *:[iPTR] }, i32:{ *:[i32] }:$src, 0:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e32:{ *:[v2f32] } ?:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2315,
        GIR_EraseRootFromParent_Done,
      // Label 3874: @240351
      GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(240400), // Rule ID 2316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2071:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_FP8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_FP8_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2316,
        GIR_EraseRootFromParent_Done,
      // Label 3875: @240400
      GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(240449), // Rule ID 2317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 3
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f32] } 2070:{ *:[iPTR] }, i32:{ *:[i32] }:$src, -1:{ *:[i1] })  =>  (V_CVT_PK_F32_BF8_fake16_e64:{ *:[v2f32] } 4:{ *:[i32] }, ?:{ *:[i32] }:$src, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F32_BF8_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2317,
        GIR_EraseRootFromParent_Done,
      // Label 3876: @240449
      GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(240490), // Rule ID 2312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] byte_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 2068:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_FP8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_FP8_OP_SEL_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2312,
        GIR_EraseRootFromParent_Done,
      // Label 3877: @240490
      GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(240531), // Rule ID 2313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] byte_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 2067:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_F32_BF8_OP_SEL_e64:{ *:[f32] } ?:{ *:[i32] }:$src0, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_BF8_OP_SEL_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2313,
        GIR_EraseRootFromParent_Done,
      // Label 3878: @240531
      GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(240580), // Rule ID 108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13407),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2078:{ *:[iPTR] }, SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13407>>  =>  (S_CVT_PK_RTZ_F16_F32:{ *:[v2f16] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_PK_RTZ_F16_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 108,
        GIR_EraseRootFromParent_Done,
      // Label 3879: @240580
      GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(240683), // Rule ID 2411 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3039:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_I32_I24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 2411,
        GIR_EraseRootFromParent_Done,
      // Label 3880: @240683
      GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(240786), // Rule ID 2413 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub0:{ *:[i32] }, (V_MUL_HI_U32_U24_e64:{ *:[i16] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 2413,
        GIR_EraseRootFromParent_Done,
      // Label 3881: @240786
      GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(240860), // Rule ID 789 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 789,
        GIR_EraseRootFromParent_Done,
      // Label 3882: @240860
      GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(240929), // Rule ID 823 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_i16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[v2i16] } 2076:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_I16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_I16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 823,
        GIR_EraseRootFromParent_Done,
      // Label 3883: @240929
      GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(240998), // Rule ID 825 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pknorm_u16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[v2i16] } 2077:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKNORM_U16_F32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKNORM_U16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 825,
        GIR_EraseRootFromParent_Done,
      // Label 3884: @240998
      GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(241072), // Rule ID 827 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pkrtz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2078:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_CVT_PKRTZ_F16_F32_e64:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PKRTZ_F16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 827,
        GIR_EraseRootFromParent_Done,
      // Label 3885: @241072
      GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(241146), // Rule ID 978 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_trig_preop),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f64] } 3270:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_TRIG_PREOP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_TRIG_PREOP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 978,
        GIR_EraseRootFromParent_Done,
      // Label 3886: @241146
      GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(241220), // Rule ID 8510 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8510,
        GIR_EraseRootFromParent_Done,
      // Label 3887: @241220
      GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(241267), // Rule ID 1042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_fp6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32f32] } 2110:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_FP6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_FP6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1042,
        GIR_EraseRootFromParent_Done,
      // Label 3888: @241267
      GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(241314), // Rule ID 1043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f32_bf6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32f32] } 2109:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F32_BF6_e64:{ *:[v32f32] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F32_BF6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1043,
        GIR_EraseRootFromParent_Done,
      // Label 3889: @241314
      GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(241361), // Rule ID 1044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_fp6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32f16] } 2108:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_FP6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_FP6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1044,
        GIR_EraseRootFromParent_Done,
      // Label 3890: @241361
      GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(241408), // Rule ID 1045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf16_fp6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32bf16] } 2104:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF16_FP6_e64:{ *:[v32bf16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF16_FP6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1045,
        GIR_EraseRootFromParent_Done,
      // Label 3891: @241408
      GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(241455), // Rule ID 1046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_f16_bf6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32f16] } 2107:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_F16_BF6_e64:{ *:[v32f16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_F16_BF6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1046,
        GIR_EraseRootFromParent_Done,
      // Label 3892: @241455
      GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(241502), // Rule ID 1047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf16_bf6),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v32bf16] } 2103:{ *:[iPTR] }, (VOP3Mods0:{ *:[v6i32] } v6i32:{ *:[v6i32] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF16_BF6_e64:{ *:[v32bf16] } v6i32:{ *:[v6i32] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF16_BF6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1047,
        GIR_EraseRootFromParent_Done,
      // Label 3893: @241502
      GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(241549), // Rule ID 1048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_fp6_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2112:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_FP6_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1048,
        GIR_EraseRootFromParent_Done,
      // Label 3894: @241549
      GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(241596), // Rule ID 1049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf6_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2106:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF6_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1049,
        GIR_EraseRootFromParent_Done,
      // Label 3895: @241596
      GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(241643), // Rule ID 1050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_fp6_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2111:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32bf16] } v32bf16:{ *:[v32bf16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_FP6_BF16_e64:{ *:[v6i32] } v32bf16:{ *:[v32bf16] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_FP6_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1050,
        GIR_EraseRootFromParent_Done,
      // Label 3896: @241643
      GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(241690), // Rule ID 1051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk32_bf6_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2105:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32bf16] } v32bf16:{ *:[v32bf16] }:$src0), f32:{ *:[f32] }:$src1)  =>  (V_CVT_SCALEF32_PK32_BF6_BF16_e64:{ *:[v6i32] } v32bf16:{ *:[v32bf16] }:$src0, f32:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK32_BF6_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1051,
        GIR_EraseRootFromParent_Done,
      // Label 3897: @241690
      GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(241727), // Rule ID 793 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_i24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3039:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_I32_I24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 793,
        GIR_EraseRootFromParent_Done,
      // Label 3898: @241727
      GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(241761), // Rule ID 795 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_i24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3041:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_I24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_I24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 795,
        GIR_EraseRootFromParent_Done,
      // Label 3899: @241761
      GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(241798), // Rule ID 797 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mul_u24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3040:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_U32_U24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 797,
        GIR_EraseRootFromParent_Done,
      // Label 3900: @241798
      GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(241832), // Rule ID 799 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mulhi_u24),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3042:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_U24_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_U24_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 799,
        GIR_EraseRootFromParent_Done,
      // Label 3901: @241832
      GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(241866), // Rule ID 819 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_lo),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 2986:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_LO_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_LO_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 819,
        GIR_EraseRootFromParent_Done,
      // Label 3902: @241866
      GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(241900), // Rule ID 820 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mbcnt_hi),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 2985:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MBCNT_HI_U32_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MBCNT_HI_U32_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 820,
        GIR_EraseRootFromParent_Done,
      // Label 3903: @241900
      GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(241934), // Rule ID 829 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 2074:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_U16_U32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U16_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 829,
        GIR_EraseRootFromParent_Done,
      // Label 3904: @241934
      GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(241968), // Rule ID 831 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_i16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 2073:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 831,
        GIR_EraseRootFromParent_Done,
      // Label 3905: @241968
      GIM_Reject,
    // Label 3854: @241969
    GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(246844),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(242067), // Rule ID 6976 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2960:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P10_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F32_inreg),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6976,
        GIR_EraseRootFromParent_Done,
      // Label 3907: @242067
      GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(242157), // Rule ID 6977 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2962:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_INTERP_P2_F32_inreg:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32_inreg),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6977,
        GIR_EraseRootFromParent_Done,
      // Label 3908: @242157
      GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(242244), // Rule ID 7054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2178:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7054,
        GIR_EraseRootFromParent_Done,
      // Label 3909: @242244
      GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(242331), // Rule ID 7058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2177:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7058,
        GIR_EraseRootFromParent_Done,
      // Label 3910: @242331
      GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(242418), // Rule ID 7060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (intrinsic_wo_chain:{ *:[f16] } 2178:{ *:[iPTR] }, (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7060,
        GIR_EraseRootFromParent_Done,
      // Label 3911: @242418
      GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(242481), // Rule ID 2661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_BF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2661,
        GIR_EraseRootFromParent_Done,
      // Label 3912: @242481
      GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(242544), // Rule ID 2662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2138:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_FP8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2662,
        GIR_EraseRootFromParent_Done,
      // Label 3913: @242544
      GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(242607), // Rule ID 2663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2140:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_FP8_FP8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_FP8_FP8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2663,
        GIR_EraseRootFromParent_Done,
      // Label 3914: @242607
      GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(242670), // Rule ID 2664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot11Insts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_dot4_f32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2137:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT4_F32_BF8_BF8:{ *:[f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_F32_BF8_BF8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2664,
        GIR_EraseRootFromParent_Done,
      // Label 3915: @242670
      GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(242735), // Rule ID 6969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2978:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (LDS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_PARAM_LOAD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/3, // attr
        GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6969,
        GIR_EraseRootFromParent_Done,
      // Label 3916: @242735
      GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(242803), // Rule ID 6971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_param_load),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2978:{ *:[iPTR] }, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (DS_PARAM_LOAD:{ *:[f32] } (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, 0:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PARAM_LOAD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/3, // attr
        GIR_RootToRootCopy, /*OpIdx*/2, // attrchan
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6971,
        GIR_EraseRootFromParent_Done,
      // Label 3917: @242803
      GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(242855), // Rule ID 2529 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[f32] } 2084:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_FP8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2529,
        GIR_EraseRootFromParent_Done,
      // Label 3918: @242855
      GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(242907), // Rule ID 2530 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[f32] } 2083:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_F32_BF8_e64:{ *:[f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F32_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2530,
        GIR_EraseRootFromParent_Done,
      // Label 3919: @242907
      GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(242959), // Rule ID 2531 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f16] } 2092:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F16_FP4_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2531,
        GIR_EraseRootFromParent_Done,
      // Label 3920: @242959
      GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(243011), // Rule ID 2532 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf16_fp4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 2086:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_BF16_FP4_e64:{ *:[v2bf16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF16_FP4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2532,
        GIR_EraseRootFromParent_Done,
      // Label 3921: @243011
      GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(243060), // Rule ID 2539 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f32] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_FP8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2539,
        GIR_EraseRootFromParent_Done,
      // Label 3922: @243060
      GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(243109), // Rule ID 2540 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f32] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F32_BF8_e64:{ *:[v2f32] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2540,
        GIR_EraseRootFromParent_Done,
      // Label 3923: @243109
      GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(243158), // Rule ID 2541 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f16] } 2091:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_BF8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2541,
        GIR_EraseRootFromParent_Done,
      // Label 3924: @243158
      GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(243207), // Rule ID 2542 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf16_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 2085:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF16_BF8_e64:{ *:[v2bf16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF16_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2542,
        GIR_EraseRootFromParent_Done,
      // Label 3925: @243207
      GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(243256), // Rule ID 2543 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f16_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f16] } 2093:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_F16_FP8_e64:{ *:[v2f16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F16_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2543,
        GIR_EraseRootFromParent_Done,
      // Label 3926: @243256
      GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(243305), // Rule ID 2544 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf16_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 2087:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF16_FP8_e64:{ *:[v2bf16] } (SrcSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[i32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF16_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2544,
        GIR_EraseRootFromParent_Done,
      // Label 3927: @243305
      GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(243357), // Rule ID 2549 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_f32_fp4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // (intrinsic_wo_chain:{ *:[v2f32] } 2095:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_F32_FP4_e64:{ *:[v2f32] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_F32_FP4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2549,
        GIR_EraseRootFromParent_Done,
      // Label 3928: @243357
      GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(243399), // Rule ID 2624 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3164:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2624,
        GIR_EraseRootFromParent_Done,
      // Label 3929: @243399
      GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(243441), // Rule ID 2625 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_hi_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3162:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_HI_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_HI_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2625,
        GIR_EraseRootFromParent_Done,
      // Label 3930: @243441
      GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(243483), // Rule ID 2626 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sad_u16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3163:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_SAD_U16_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SAD_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2626,
        GIR_EraseRootFromParent_Done,
      // Label 3931: @243483
      GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(243525), // Rule ID 2627 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_msad_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3038:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MSAD_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MSAD_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2627,
        GIR_EraseRootFromParent_Done,
      // Label 3932: @243525
      GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(243567), // Rule ID 2628 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_pk_u16_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3036:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_MQSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_PK_U16_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2628,
        GIR_EraseRootFromParent_Done,
      // Label 3933: @243567
      GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(243609), // Rule ID 2629 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_qsad_pk_u16_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3054:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2)  =>  (V_QSAD_PK_U16_U8_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, i64:{ *:[i64] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_QSAD_PK_U16_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2629,
        GIR_EraseRootFromParent_Done,
      // Label 3934: @243609
      GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(243651), // Rule ID 2630 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mqsad_u32_u8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3037:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (V_MQSAD_U32_U8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MQSAD_U32_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2630,
        GIR_EraseRootFromParent_Done,
      // Label 3935: @243651
      GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(243748), // Rule ID 923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2178:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 923,
        GIR_EraseRootFromParent_Done,
      // Label 3936: @243748
      GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(243845), // Rule ID 925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2177:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 925,
        GIR_EraseRootFromParent_Done,
      // Label 3937: @243845
      GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(243939), // Rule ID 948 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubeid),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2063:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEID_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEID_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 948,
        GIR_EraseRootFromParent_Done,
      // Label 3938: @243939
      GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(244033), // Rule ID 949 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubesc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2065:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBESC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBESC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 949,
        GIR_EraseRootFromParent_Done,
      // Label 3939: @244033
      GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(244127), // Rule ID 950 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubetc),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2066:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBETC_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBETC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 950,
        GIR_EraseRootFromParent_Done,
      // Label 3940: @244127
      GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(244221), // Rule ID 951 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cubema),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2064:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CUBEMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CUBEMA_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 951,
        GIR_EraseRootFromParent_Done,
      // Label 3941: @244221
      GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(244315), // Rule ID 967 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2179:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 967,
        GIR_EraseRootFromParent_Done,
      // Label 3942: @244315
      GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(244404), // Rule ID 971 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_u8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[i32] } 2075:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_CVT_PK_U8_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_U8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 971,
        GIR_EraseRootFromParent_Done,
      // Label 3943: @244404
      GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(244498), // Rule ID 972 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2134:{ *:[iPTR] }, (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 972,
        GIR_EraseRootFromParent_Done,
      // Label 3944: @244498
      GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(244592), // Rule ID 974 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f64] } 2134:{ *:[iPTR] }, (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 974,
        GIR_EraseRootFromParent_Done,
      // Label 3945: @244592
      GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(244689), // Rule ID 993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f16] } 2134:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 993,
        GIR_EraseRootFromParent_Done,
      // Label 3946: @244689
      GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(244786), // Rule ID 1006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmad_ftz),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f16] } 2178:{ *:[iPTR] }, (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1006,
        GIR_EraseRootFromParent_Done,
      // Label 3947: @244786
      GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(244883), // Rule ID 8545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaLegacy32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fma_legacy),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2177:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8545,
        GIR_EraseRootFromParent_Done,
      // Label 3948: @244883
      GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(244979), // Rule ID 997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2134:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 997,
        GIR_EraseRootFromParent_Done,
      // Label 3949: @244979
      GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(245075), // Rule ID 999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2134:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 999,
        GIR_EraseRootFromParent_Done,
      // Label 3950: @245075
      GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(245171), // Rule ID 1001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fixup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2134:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DIV_FIXUP_F16_gfx9_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FIXUP_F16_gfx9_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1001,
        GIR_EraseRootFromParent_Done,
      // Label 3951: @245171
      GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(245267), // Rule ID 1010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2179:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1010,
        GIR_EraseRootFromParent_Done,
      // Label 3952: @245267
      GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(245363), // Rule ID 1012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2179:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1012,
        GIR_EraseRootFromParent_Done,
      // Label 3953: @245363
      GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(245459), // Rule ID 1014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmed3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2179:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1014,
        GIR_EraseRootFromParent_Done,
      // Label 3954: @245459
      GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(245549), // Rule ID 1066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2172:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1066,
        GIR_EraseRootFromParent_Done,
      // Label 3955: @245549
      GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(245639), // Rule ID 1067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2172:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1067,
        GIR_EraseRootFromParent_Done,
      // Label 3956: @245639
      GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(245729), // Rule ID 1068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2172:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_F16_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F16_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1068,
        GIR_EraseRootFromParent_Done,
      // Label 3957: @245729
      GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(245819), // Rule ID 1069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_NotHasTrue16BitInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_bf16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[bf16] } 2171:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[bf16] } bf16:{ *:[bf16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_BF16_BF16_e64:{ *:[bf16] } i32:{ *:[i32] }:$src0_modifiers, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, bf16:{ *:[bf16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_BF16_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1069,
        GIR_EraseRootFromParent_Done,
      // Label 3958: @245819
      GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(245909), // Rule ID 1070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_bf16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[bf16] } 2171:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[bf16] } bf16:{ *:[bf16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_BF16_BF16_t16_e64:{ *:[bf16] } i32:{ *:[i32] }:$src0_modifiers, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, bf16:{ *:[bf16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_BF16_BF16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1070,
        GIR_EraseRootFromParent_Done,
      // Label 3959: @245909
      GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(245999), // Rule ID 1071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot9Insts_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_bf16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[bf16] } 2171:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[bf16] } bf16:{ *:[bf16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_DOT2_BF16_BF16_fake16_e64:{ *:[bf16] } i32:{ *:[i32] }:$src0_modifiers, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, bf16:{ *:[bf16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_BF16_BF16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1071,
        GIR_EraseRootFromParent_Done,
      // Label 3960: @245999
      GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(246089), // Rule ID 1082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_i8_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[i16] } 2052:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_I8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_I8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1082,
        GIR_EraseRootFromParent_Done,
      // Label 3961: @246089
      GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(246179), // Rule ID 1083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAshrPkInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ashr_pk_u8_i32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (intrinsic_wo_chain:{ *:[i16] } 2053:{ *:[iPTR] }, (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_ASHR_PK_U8_I32_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_PK_U8_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1083,
        GIR_EraseRootFromParent_Done,
      // Label 3962: @246179
      GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(246228), // Rule ID 928 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lerp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 2979:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_LERP_U8_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LERP_U8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 928,
        GIR_EraseRootFromParent_Done,
      // Label 3963: @246228
      GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(246277), // Rule ID 952 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ubfe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 3271:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 952,
        GIR_EraseRootFromParent_Done,
      // Label 3964: @246277
      GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(246326), // Rule ID 954 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sbfe),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 3165:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_BFE_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 954,
        GIR_EraseRootFromParent_Done,
      // Label 3965: @246326
      GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(246375), // Rule ID 958 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_alignbyte),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 2051:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBYTE_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBYTE_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 958,
        GIR_EraseRootFromParent_Done,
      // Label 3966: @246375
      GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(246427), // Rule ID 991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_perm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[i32] } 3043:{ *:[iPTR] }, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_PERM_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 991,
        GIR_EraseRootFromParent_Done,
      // Label 3967: @246427
      GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(246479), // Rule ID 1052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2122:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32bf16] } v32bf16:{ *:[v32bf16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_BF16_e64:{ *:[v6i32] } v32bf16:{ *:[v32bf16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1052,
        GIR_EraseRootFromParent_Done,
      // Label 3968: @246479
      GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(246531), // Rule ID 1053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2123:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1053,
        GIR_EraseRootFromParent_Done,
      // Label 3969: @246531
      GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(246583), // Rule ID 1054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_bf6_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2124:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_BF6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_BF6_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1054,
        GIR_EraseRootFromParent_Done,
      // Label 3970: @246583
      GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(246635), // Rule ID 1055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2125:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32bf16] } v32bf16:{ *:[v32bf16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_BF16_e64:{ *:[v6i32] } v32bf16:{ *:[v32bf16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1055,
        GIR_EraseRootFromParent_Done,
      // Label 3971: @246635
      GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(246687), // Rule ID 1056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2126:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f16] } v32f16:{ *:[v32f16] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F16_e64:{ *:[v6i32] } v32f16:{ *:[v32f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1056,
        GIR_EraseRootFromParent_Done,
      // Label 3972: @246687
      GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(246739), // Rule ID 1057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF16BF16ToFP6BF6ConversionScaleInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk32_fp6_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2127:{ *:[iPTR] }, (VOP3Mods0:{ *:[v32f32] } v32f32:{ *:[v32f32] }:$src0), i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_SR_PK32_FP6_F32_e64:{ *:[v6i32] } v32f32:{ *:[v32f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK32_FP6_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1057,
        GIR_EraseRootFromParent_Done,
      // Label 3973: @246739
      GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(246791), // Rule ID 1058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_fp6_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2080:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_FP6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_FP6_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1058,
        GIR_EraseRootFromParent_Done,
      // Label 3974: @246791
      GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(246843), // Rule ID 1059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_2xpk16_bf6_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_192RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (intrinsic_wo_chain:{ *:[v6i32] } 2079:{ *:[iPTR] }, (VOP3Mods0:{ *:[v16f32] } v16f32:{ *:[v16f32] }:$src0), v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_CVT_SCALEF32_2XPK16_BF6_F32_e64:{ *:[v6i32] } v16f32:{ *:[v16f32] }:$src0, v16f32:{ *:[v16f32] }:$src1, f32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_2XPK16_BF6_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1059,
        GIR_EraseRootFromParent_Done,
      // Label 3975: @246843
      GIM_Reject,
    // Label 3906: @246844
    GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(252211),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(246905), // Rule ID 2425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot5Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2170:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, v2f16:{ *:[v2f16] }:$src1, f32:{ *:[f32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_F32_F16_e32:{ *:[f32] } ?:{ *:[v2f16] }:$src0, ?:{ *:[v2f16] }:$src1, ?:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_F32_F16_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2425,
        GIR_EraseRootFromParent_Done,
      // Label 3977: @246905
      GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(246958), // Rule ID 2427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot13Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[f32] } 2173:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src0, v2bf16:{ *:[v2bf16] }:$src1, f32:{ *:[f32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_F32_BF16_e32:{ *:[f32] } ?:{ *:[v2bf16] }:$src0, ?:{ *:[v2bf16] }:$src1, ?:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_F32_BF16_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2427,
        GIR_EraseRootFromParent_Done,
      // Label 3978: @246958
      GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(247011), // Rule ID 2428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot6Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 3169:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT4C_I32_I8_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4C_I32_I8_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2428,
        GIR_EraseRootFromParent_Done,
      // Label 3979: @247011
      GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(247064), // Rule ID 2429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot4Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 3168:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT2C_I32_I16_e32:{ *:[i32] } ?:{ *:[v2i16] }:$src0, ?:{ *:[v2i16] }:$src1, ?:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2C_I32_I16_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2429,
        GIR_EraseRootFromParent_Done,
      // Label 3980: @247064
      GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(247117), // Rule ID 2430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot3Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, 0:{ *:[i1] })  =>  (V_DOT8C_I32_I4_e32:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8C_I32_I4_e32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2430,
        GIR_EraseRootFromParent_Done,
      // Label 3981: @247117
      GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(247224), // Rule ID 6972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2961:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6972,
        GIR_EraseRootFromParent_Done,
      // Label 3982: @247224
      GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(247331), // Rule ID 6973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        // (intrinsic_wo_chain:{ *:[f32] } 2961:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6973,
        GIR_EraseRootFromParent_Done,
      // Label 3983: @247331
      GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(247492), // Rule ID 6974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2961:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6974,
        GIR_EraseRootFromParent_Done,
      // Label 3984: @247492
      GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(247653), // Rule ID 6975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p10_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2961:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6975,
        GIR_EraseRootFromParent_Done,
      // Label 3985: @247653
      GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(247787), // Rule ID 6978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2963:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6978,
        GIR_EraseRootFromParent_Done,
      // Label 3986: @247787
      GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(247921), // Rule ID 6979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2963:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6979,
        GIR_EraseRootFromParent_Done,
      // Label 3987: @247921
      GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(248082), // Rule ID 6980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2967:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, lo16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src2
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6980,
        GIR_EraseRootFromParent_Done,
      // Label 3988: @248082
      GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(248243), // Rule ID 6981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2967:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_t16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src2, hi16:{ *:[i32] }), 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src2
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6981,
        GIR_EraseRootFromParent_Done,
      // Label 3989: @248243
      GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(248377), // Rule ID 6982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2970:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, lo16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(2), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6982,
        GIR_EraseRootFromParent_Done,
      // Label 3990: @248377
      GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(248511), // Rule ID 6983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2970:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_t16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, (EXTRACT_SUBREG:{ *:[f16] } VGPR_32:{ *:[f32] }:$src0, hi16:{ *:[i32] }), ?:{ *:[i32] }:$src1_modifiers, VGPR_32:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, VGPR_32:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandSubRegRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, /*SubRegIdx*/GIMT_Encode2(1), // src0
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_t16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6983,
        GIR_EraseRootFromParent_Done,
      // Label 3991: @248511
      GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(248618), // Rule ID 6984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2963:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6984,
        GIR_EraseRootFromParent_Done,
      // Label 3992: @248618
      GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(248725), // Rule ID 6985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_inreg_p2_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2963:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6985,
        GIR_EraseRootFromParent_Done,
      // Label 3993: @248725
      GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(248832), // Rule ID 6986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f32] } 2967:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6986,
        GIR_EraseRootFromParent_Done,
      // Label 3994: @248832
      GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(248939), // Rule ID 6987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p10_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        // (intrinsic_wo_chain:{ *:[f32] } 2967:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P10_RTZ_F16_F32_inreg_fake16:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P10_RTZ_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6987,
        GIR_EraseRootFromParent_Done,
      // Label 3995: @248939
      GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(249046), // Rule ID 6988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2970:{ *:[iPTR] }, (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6988,
        GIR_EraseRootFromParent_Done,
      // Label 3996: @249046
      GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(249153), // Rule ID 6989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_rtz_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vinterpmods_hi),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vinterpmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vinterpmods),
        // (intrinsic_wo_chain:{ *:[f16] } 2970:{ *:[iPTR] }, (VINTERPModsHi:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VINTERPMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), -1:{ *:[i1] })  =>  (V_INTERP_P2_RTZ_F16_F32_inreg_fake16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 7:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_RTZ_F16_F32_inreg_fake16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6989,
        GIR_EraseRootFromParent_Done,
      // Label 3997: @249153
      GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(249267), // Rule ID 2595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2135:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2595,
        GIR_EraseRootFromParent_Done,
      // Label 3998: @249267
      GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(249381), // Rule ID 2597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXEC_XNULLRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f64] } 2135:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2597,
        GIR_EraseRootFromParent_Done,
      // Label 3999: @249381
      GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(249495), // Rule ID 2599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2135:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f32] }:$src2)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2599,
        GIR_EraseRootFromParent_Done,
      // Label 4000: @249495
      GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(249609), // Rule ID 2601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_div_fmas),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f64] } 2135:{ *:[iPTR] }, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers), VCC_LO:{ *:[i1] })  =>  (V_DIV_FMAS_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f64] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f64] }:$src2)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::VCC_LO), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // VCC_LO
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DIV_FMAS_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2601,
        GIR_EraseRootFromParent_Done,
      // Label 4001: @249609
      GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(249690), // Rule ID 2492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] byte_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[i32] } 2131:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_FP8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_gfx12_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2492,
        GIR_EraseRootFromParent_Done,
      // Label 4002: @249690
      GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(249771), // Rule ID 2493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] byte_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[i32] } 2129:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$old, (timm:{ *:[i32] }):$byte_sel)  =>  (V_CVT_SR_BF8_F32_gfx12_e64:{ *:[i32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$old, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$byte_sel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_gfx12_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // byte_sel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2493,
        GIR_EraseRootFromParent_Done,
      // Label 4003: @249771
      GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(249834), // Rule ID 1332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_mov),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] vsrc
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2964:{ *:[iPTR] }, (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_MOV_F32:{ *:[f32] } (timm:{ *:[i32] }):$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_MOV_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
        GIR_RootToRootCopy, /*OpIdx*/4, // attr
        GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1332,
        GIR_EraseRootFromParent_Done,
      // Label 4004: @249834
      GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(249897), // Rule ID 1329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_has32BankLDS_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2965:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
        GIR_RootToRootCopy, /*OpIdx*/4, // attr
        GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1329,
        GIR_EraseRootFromParent_Done,
      // Label 4005: @249897
      GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(249960), // Rule ID 1330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_has16BankLDS_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2965:{ *:[iPTR] }, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P1_F32_16bank:{ *:[f32] } f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1_F32_16bank),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // vsrc
        GIR_RootToRootCopy, /*OpIdx*/4, // attr
        GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1330,
        GIR_EraseRootFromParent_Done,
      // Label 4006: @249960
      GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(250022), // Rule ID 2480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 2072:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2480,
        GIR_EraseRootFromParent_Done,
      // Label 4007: @250022
      GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(250084), // Rule ID 2481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 2069:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2481,
        GIR_EraseRootFromParent_Done,
      // Label 4008: @250084
      GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(250146), // Rule ID 2482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[i32] } 2072:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2482,
        GIR_EraseRootFromParent_Done,
      // Label 4009: @250146
      GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(250208), // Rule ID 2483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_pk_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[i32] } 2069:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$old, -1:{ *:[i1] })  =>  (V_CVT_PK_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2483,
        GIR_EraseRootFromParent_Done,
      // Label 4010: @250208
      GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(250273), // Rule ID 2484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 2131:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2484,
        GIR_EraseRootFromParent_Done,
      // Label 4011: @250273
      GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(250338), // Rule ID 2485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[i32] } 2129:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 0:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2485,
        GIR_EraseRootFromParent_Done,
      // Label 4012: @250338
      GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(250403), // Rule ID 2486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[i32] } 2131:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2486,
        GIR_EraseRootFromParent_Done,
      // Label 4013: @250403
      GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(250468), // Rule ID 2487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
        // (intrinsic_wo_chain:{ *:[i32] } 2129:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 1:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2487,
        GIR_EraseRootFromParent_Done,
      // Label 4014: @250468
      GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(250533), // Rule ID 2488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[i32] } 2131:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2488,
        GIR_EraseRootFromParent_Done,
      // Label 4015: @250533
      GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(250598), // Rule ID 2489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(2),
        // (intrinsic_wo_chain:{ *:[i32] } 2129:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 2:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 0:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2489,
        GIR_EraseRootFromParent_Done,
      // Label 4016: @250598
      GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(250663), // Rule ID 2490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[i32] } 2131:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_FP8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2490,
        GIR_EraseRootFromParent_Done,
      // Label 4017: @250663
      GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(250728), // Rule ID 2491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8ConversionInsts_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(3),
        // (intrinsic_wo_chain:{ *:[i32] } 2129:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$old, 3:{ *:[i32] })  =>  (V_CVT_SR_BF8_F32_e64:{ *:[i32] } 8:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, 4:{ *:[i32] }, ?:{ *:[i32] }:$old, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
        GIR_RootToRootCopy, /*OpIdx*/4, // old
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2491,
        GIR_EraseRootFromParent_Done,
      // Label 4018: @250728
      GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(250782), // Rule ID 2545 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2101:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2545,
        GIR_EraseRootFromParent_Done,
      // Label 4019: @250782
      GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(250836), // Rule ID 2546 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2100:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2bf16:{ *:[v2bf16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_BF16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2546,
        GIR_EraseRootFromParent_Done,
      // Label 4020: @250836
      GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(250890), // Rule ID 2547 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2089:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2547,
        GIR_EraseRootFromParent_Done,
      // Label 4021: @250890
      GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(250944), // Rule ID 2548 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2088:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2bf16:{ *:[v2bf16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_BF16_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[v2bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2548,
        GIR_EraseRootFromParent_Done,
      // Label 4022: @250944
      GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(251004), // Rule ID 2551 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 2098:{ *:[iPTR] }, i32:{ *:[i32] }:$src2, v2f16:{ *:[v2f16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2551,
        GIR_EraseRootFromParent_Done,
      // Label 4023: @251004
      GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(251064), // Rule ID 2552 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$src2, v2bf16:{ *:[v2bf16] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_BF16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2552,
        GIR_EraseRootFromParent_Done,
      // Label 4024: @251064
      GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(251121), // Rule ID 2608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF32ToF16BF16ConversionSRInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_bf16_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 2128:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SR_BF16_F32_e64:{ *:[v2bf16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, VGPR_32:{ *:[v2bf16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_BF16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2608,
        GIR_EraseRootFromParent_Done,
      // Label 4025: @251121
      GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(251178), // Rule ID 2609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasF32ToF16BF16ConversionSRInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_sr_f16_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[v2f16] } 2130:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SR_F16_F32_e64:{ *:[v2f16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SR_F16_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2609,
        GIR_EraseRootFromParent_Done,
      // Label 4026: @251178
      GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(251240), // Rule ID 2659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2659,
        GIR_EraseRootFromParent_Done,
      // Label 4027: @251240
      GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(251302), // Rule ID 2660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // (intrinsic_wo_chain:{ *:[i32] } 3169:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } 9:{ *:[i32] }, i32:{ *:[i32] }:$src0, 9:{ *:[i32] }, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2660,
        GIR_EraseRootFromParent_Done,
      // Label 4028: @251302
      GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(251346), // Rule ID 2591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] bitop3
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[i32] } 2056:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2, (timm:{ *:[i32] }):$bitop3)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2591,
        GIR_EraseRootFromParent_Done,
      // Label 4029: @251346
      GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(251402), // Rule ID 2592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBitOp3Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_bitop3),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] bitop3
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[i16] } 2056:{ *:[iPTR] }, i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$bitop3)  =>  (V_BITOP3_B16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, (timm:{ *:[i32] }):$bitop3, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BITOP3_B16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // bitop3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2592,
        GIR_EraseRootFromParent_Done,
      // Label 4030: @251402
      GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(251506), // Rule ID 1110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3168:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_I32_I16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_I32_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1110,
        GIR_EraseRootFromParent_Done,
      // Label 4031: @251506
      GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(251610), // Rule ID 1111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot2Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3272:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_U32_U16:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_U32_U16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1111,
        GIR_EraseRootFromParent_Done,
      // Label 4032: @251610
      GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(251714), // Rule ID 1112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot10Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[f32] } 2170:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_F32_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F32_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1112,
        GIR_EraseRootFromParent_Done,
      // Label 4033: @251714
      GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(251812), // Rule ID 1114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3273:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_U32_U8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_U32_U8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1114,
        GIR_EraseRootFromParent_Done,
      // Label 4034: @251812
      GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(251910), // Rule ID 1115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot7Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_udot8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3274:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_U32_U4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_U32_U4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1115,
        GIR_EraseRootFromParent_Done,
      // Label 4035: @251910
      GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(252008), // Rule ID 1116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3169:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_I8:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_I8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1116,
        GIR_EraseRootFromParent_Done,
      // Label 4036: @252008
      GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(252106), // Rule ID 1117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot1Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sdot8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[i32] } 3170:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_I4:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_I4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1117,
        GIR_EraseRootFromParent_Done,
      // Label 4037: @252106
      GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(252210), // Rule ID 1118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot12Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fdot2_f32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmodsdot),
        // (intrinsic_wo_chain:{ *:[f32] } 2173:{ *:[iPTR] }, (VOP3PModsDOT:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PModsDOT:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PModsDOT:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (timm:{ *:[i1] }):$clamp)  =>  (V_DOT2_F32_BF16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2bf16:{ *:[v2bf16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT2_F32_BF16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1118,
        GIR_EraseRootFromParent_Done,
      // Label 4038: @252210
      GIM_Reject,
    // Label 3976: @252211
    GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(253423),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
      GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(252287), // Rule ID 2533 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] src_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] Operand 6
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2082:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2533,
        GIR_EraseRootFromParent_Done,
      // Label 4040: @252287
      GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(252355), // Rule ID 2534 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] src_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] Operand 6
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2081:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, 0:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_0:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_0), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_0), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2534,
        GIR_EraseRootFromParent_Done,
      // Label 4041: @252355
      GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(252423), // Rule ID 2535 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] src_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] Operand 6
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2082:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_FP8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2535,
        GIR_EraseRootFromParent_Done,
      // Label 4042: @252423
      GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(252491), // Rule ID 2536 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_f16_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] src_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] Operand 6
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/6, GIMT_Encode8(-1),
        // (intrinsic_wo_chain:{ *:[v2f16] } 2081:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, i32:{ *:[i32] }:$src0, f32:{ *:[f32] }:$src1, (timm:{ *:[i32] }):$src_sel, -1:{ *:[i1] })  =>  (V_CVT_SCALEF32_F16_BF8_e64:{ *:[v2f16] } (SrcAndDstSelToOpSelXForm_0_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[i32] }:$src0, (SrcAndDstSelToOpSelXForm_1_1:{ *:[i32] } ?:{ *:[i32] }:$src_sel), ?:{ *:[f32] }:$src1, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_F16_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_0_1), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_1_1), // src_sel
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2536,
        GIR_EraseRootFromParent_Done,
      // Label 4043: @252491
      GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(252559), // Rule ID 1331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 2968:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, M0:{ *:[i32] })  =>  (V_INTERP_P2_F32:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$vsrc, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // vsrc
        GIR_RootToRootCopy, /*OpIdx*/5, // attr
        GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1331,
        GIR_EraseRootFromParent_Done,
      // Label 4044: @252559
      GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(252621), // Rule ID 2537 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2102:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_FP8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2537,
        GIR_EraseRootFromParent_Done,
      // Label 4045: @252621
      GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(252683), // Rule ID 2538 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] word_sel
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[v2i16] } 2090:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$word_sel)  =>  (V_CVT_SCALEF32_PK_BF8_F32_e64:{ *:[v2i16] } (DstSelToOpSelXForm:{ *:[i32] } ?:{ *:[i1] }:$word_sel), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSelXForm), // word_sel
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2538,
        GIR_EraseRootFromParent_Done,
      // Label 4046: @252683
      GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(252748), // Rule ID 2550 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_pk_fp4_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2099:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_PK_FP4_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2550,
        GIR_EraseRootFromParent_Done,
      // Label 4047: @252748
      GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(252813), // Rule ID 2553 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2553,
        GIR_EraseRootFromParent_Done,
      // Label 4048: @252813
      GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(252878), // Rule ID 2554 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2119:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_BF16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2554,
        GIR_EraseRootFromParent_Done,
      // Label 4049: @252878
      GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(252943), // Rule ID 2555 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_pk_fp4_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_PK_FP4_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[v2f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_PK_FP4_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2555,
        GIR_EraseRootFromParent_Done,
      // Label 4050: @252943
      GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(253008), // Rule ID 2556 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2113:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, bf16:{ *:[bf16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_BF16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2556,
        GIR_EraseRootFromParent_Done,
      // Label 4051: @253008
      GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(253073), // Rule ID 2557 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2557,
        GIR_EraseRootFromParent_Done,
      // Label 4052: @253073
      GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(253138), // Rule ID 2558 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_bf8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_BF8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_BF8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2558,
        GIR_EraseRootFromParent_Done,
      // Label 4053: @253138
      GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(253203), // Rule ID 2559 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2116:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, bf16:{ *:[bf16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_BF16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[bf16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2559,
        GIR_EraseRootFromParent_Done,
      // Label 4054: @253203
      GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(253268), // Rule ID 2560 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2117:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F16_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2560,
        GIR_EraseRootFromParent_Done,
      // Label 4055: @253268
      GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(253333), // Rule ID 2561 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_cvt_scalef32_sr_fp8_f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] index
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2, (timm:{ *:[i32] }):$index)  =>  (V_CVT_SCALEF32_SR_FP8_F32_e64:{ *:[i32] } (DstSelToOpSel3XForm:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[i32] }:$src1, (SrcAndDstSelToOpSelXForm_2_0:{ *:[i32] } ?:{ *:[i32] }:$index), ?:{ *:[f32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_SCALEF32_SR_FP8_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderDstSelToOpSel3XFormXForm), // index
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderSrcAndDstSelToOpSelXForm_2_0), // index
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2561,
        GIR_EraseRootFromParent_Done,
      // Label 4056: @253333
      GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(253422), // Rule ID 1009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_has32BankLDS_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p1_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] high
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f32] } 2966:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P1LL_F16:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i1] }):$high)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P1LL_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // attr
        GIR_RootToRootCopy, /*OpIdx*/3, // attrchan
        GIR_RootToRootCopy, /*OpIdx*/5, // high
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1009,
        GIR_EraseRootFromParent_Done,
      // Label 4057: @253422
      GIM_Reject,
    // Label 4039: @253423
    GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(253698),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
      GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(253511), // Rule ID 2657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[i32] } 3257:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT4_I32_IU8:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT4_I32_IU8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2657,
        GIR_EraseRootFromParent_Done,
      // Label 4059: @253511
      GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(253591), // Rule ID 2658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDot8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_sudot8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[i32] } 3258:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_mods), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_mods), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_DOT8_I32_IU4:{ *:[i32] } ?:{ *:[i32] }:$src0_mods, i32:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1_mods, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_DOT8_I32_IU4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_mods
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_mods
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2658,
        GIR_EraseRootFromParent_Done,
      // Label 4060: @253591
      GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(253697), // Rule ID 1008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isNotGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_interp_p2_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] attrchan
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] attr
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] high
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (intrinsic_wo_chain:{ *:[f16] } 2969:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (timm:{ *:[i32] }):$attrchan, (timm:{ *:[i32] }):$attr, (timm:{ *:[i1] }):$high, M0:{ *:[i32] })  =>  (V_INTERP_P2_F16:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, (timm:{ *:[i32] }):$attr, (timm:{ *:[i32] }):$attrchan, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, (timm:{ *:[i1] }):$high)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_INTERP_P2_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/5, // attr
        GIR_RootToRootCopy, /*OpIdx*/4, // attrchan
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // high
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1008,
        GIR_EraseRootFromParent_Done,
      // Label 4061: @253697
      GIM_Reject,
    // Label 4058: @253698
    GIM_Reject,
    // Label 37: @253699
    GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(253873),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
      GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(253722), // Rule ID 1316 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv),
        // (intrinsic_void 3125:{ *:[iPTR] })  =>  (S_DCACHE_INV)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1316,
        GIR_EraseRootFromParent_Done,
      // Label 4063: @253722
      GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(253740), // Rule ID 1317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7GFX8GFX9),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_inv_vol),
        // (intrinsic_void 3126:{ *:[iPTR] })  =>  (S_DCACHE_INV_VOL)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_INV_VOL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1317,
        GIR_EraseRootFromParent_Done,
      // Label 4064: @253740
      GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(253758), // Rule ID 1318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb),
        // (intrinsic_void 3127:{ *:[iPTR] })  =>  (S_DCACHE_WB)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1318,
        GIR_EraseRootFromParent_Done,
      // Label 4065: @253758
      GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(253776), // Rule ID 1319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasScalarStores_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_dcache_wb_vol),
        // (intrinsic_void 3128:{ *:[iPTR] })  =>  (S_DCACHE_WB_VOL)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DCACHE_WB_VOL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1319,
        GIR_EraseRootFromParent_Done,
      // Label 4066: @253776
      GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(253794), // Rule ID 1326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_sc),
        // (intrinsic_void 2058:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_SC)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_SC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1326,
        GIR_EraseRootFromParent_Done,
      // Label 4067: @253794
      GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(253812), // Rule ID 1327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1),
        // (intrinsic_void 2057:{ *:[iPTR] })  =>  (BUFFER_WBINVL1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1327,
        GIR_EraseRootFromParent_Done,
      // Label 4068: @253812
      GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(253830), // Rule ID 1328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_buffer_wbinvl1_vol),
        // (intrinsic_void 2059:{ *:[iPTR] })  =>  (BUFFER_WBINVL1_VOL)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_WBINVL1_VOL),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1328,
        GIR_EraseRootFromParent_Done,
      // Label 4069: @253830
      GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(253851), // Rule ID 1872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
        // (intrinsic_void 3153:{ *:[iPTR] })  =>  (S_WAIT_EVENT 0:{ *:[i16] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1872,
        GIR_EraseRootFromParent_Done,
      // Label 4070: @253851
      GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(253872), // Rule ID 1873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_event_export_ready),
        // (intrinsic_void 3153:{ *:[iPTR] })  =>  (S_WAIT_EVENT 2:{ *:[i16] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EVENT),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1873,
        GIR_EraseRootFromParent_Done,
      // Label 4071: @253872
      GIM_Reject,
    // Label 4062: @253873
    GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(254590),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
      GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(253939), // Rule ID 7013 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 2975:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7013,
        GIR_EraseRootFromParent_Done,
      // Label 4073: @253939
      GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(253997), // Rule ID 7016 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 3302:{ *:[iPTR] }, (xor:{ *:[i1] } i1:{ *:[i1] }:$src, -1:{ *:[i1] }))  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, -1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7016,
        GIR_EraseRootFromParent_Done,
      // Label 4074: @253997
      GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(254017), // Rule ID 178 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_nop),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3138:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_NOP (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_NOP),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 178,
        GIR_EraseRootFromParent_Done,
      // Label 4075: @254017
      GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(254037), // Rule ID 184 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_waitcnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3159:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_WAITCNT (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAITCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 184,
        GIR_EraseRootFromParent_Done,
      // Label 4076: @254037
      GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(254057), // Rule ID 185 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sethalt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3144:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SETHALT (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETHALT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 185,
        GIR_EraseRootFromParent_Done,
      // Label 4077: @254057
      GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(254077), // Rule ID 186 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3147:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_SLEEP (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 186,
        GIR_EraseRootFromParent_Done,
      // Label 4078: @254077
      GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(254097), // Rule ID 188 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setprio),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3145:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_SETPRIO (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETPRIO),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 188,
        GIR_EraseRootFromParent_Done,
      // Label 4079: @254097
      GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(254117), // Rule ID 191 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_incperflevel),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3135:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_INCPERFLEVEL (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_INCPERFLEVEL),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 191,
        GIR_EraseRootFromParent_Done,
      // Label 4080: @254117
      GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(254137), // Rule ID 192 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_decperflevel),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3129:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_DECPERFLEVEL (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_DECPERFLEVEL),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 192,
        GIR_EraseRootFromParent_Done,
      // Label 4081: @254137
      GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(254160), // Rule ID 195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata_imm),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3150:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_TTRACEDATA_IMM (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 195,
        GIR_EraseRootFromParent_Done,
      // Label 4082: @254160
      GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(254183), // Rule ID 196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_loadcnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3156:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_LOADCNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_LOADCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 196,
        GIR_EraseRootFromParent_Done,
      // Label 4083: @254183
      GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(254206), // Rule ID 197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_storecnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3158:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_STORECNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_STORECNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 197,
        GIR_EraseRootFromParent_Done,
      // Label 4084: @254206
      GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(254229), // Rule ID 198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_samplecnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3157:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_SAMPLECNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_SAMPLECNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 198,
        GIR_EraseRootFromParent_Done,
      // Label 4085: @254229
      GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(254252), // Rule ID 199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasImageInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_bvhcnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3151:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_BVHCNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_BVHCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 199,
        GIR_EraseRootFromParent_Done,
      // Label 4086: @254252
      GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(254275), // Rule ID 200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExportInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_expcnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3154:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_EXPCNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_EXPCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 200,
        GIR_EraseRootFromParent_Done,
      // Label 4087: @254275
      GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(254298), // Rule ID 201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_dscnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3152:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_DSCNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_DSCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 201,
        GIR_EraseRootFromParent_Done,
      // Label 4088: @254298
      GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(254321), // Rule ID 202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_wait_kmcnt),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3155:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_WAIT_KMCNT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WAIT_KMCNT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 202,
        GIR_EraseRootFromParent_Done,
      // Label 4089: @254321
      GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(254348), // Rule ID 1315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemTimeInst),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memtime),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 3137:{ *:[iPTR] })  =>  (S_MEMTIME:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMTIME),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1315,
        GIR_EraseRootFromParent_Done,
      // Label 4090: @254348
      GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(254375), // Rule ID 1320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMemRealTime),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_memrealtime),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
        // (intrinsic_w_chain:{ *:[i64] } 3136:{ *:[iPTR] })  =>  (S_MEMREALTIME:{ *:[i64] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MEMREALTIME),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1320,
        GIR_EraseRootFromParent_Done,
      // Label 4091: @254375
      GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(254402), // Rule ID 1321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGetWaveIdInst),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_get_waveid_in_workgroup),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 3132:{ *:[iPTR] })  =>  (S_GET_WAVEID_IN_WORKGROUP:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GET_WAVEID_IN_WORKGROUP),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1321,
        GIR_EraseRootFromParent_Done,
      // Label 4092: @254402
      GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(254430), // Rule ID 1353 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_live_mask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        // (intrinsic_w_chain:{ *:[i1] } 2980:{ *:[iPTR] })  =>  (SI_LIVE_MASK:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_LIVE_MASK),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1353,
        GIR_EraseRootFromParent_Done,
      // Label 4093: @254430
      GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(254463), // Rule ID 1876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9GFX10),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_pops_exiting_wave_id),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_w_chain:{ *:[i32] } 3051:{ *:[iPTR] })  =>  (S_MOV_B32_sideeffects:{ *:[i32] } SRC_POPS_EXITING_WAVE_ID:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32_sideeffects),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SRC_POPS_EXITING_WAVE_ID), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1876,
        GIR_EraseRootFromParent_Done,
      // Label 4094: @254463
      GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(254487), // Rule ID 187 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sleep_var),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_void 3148:{ *:[iPTR] }, SSrc_b32:{ *:[i32] }:$src0)  =>  (S_SLEEP_VAR SSrc_b32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SLEEP_VAR),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 187,
        GIR_EraseRootFromParent_Done,
      // Label 4095: @254487
      GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(254523), // Rule ID 193 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_ttracedata),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 3149:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (S_TTRACEDATA)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_TTRACEDATA),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 193,
        GIR_EraseRootFromParent_Done,
      // Label 4096: @254523
      GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(254556), // Rule ID 7012 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_kill),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
        // (intrinsic_void 2975:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_KILL_I1_PSEUDO SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_KILL_I1_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7012,
        GIR_EraseRootFromParent_Done,
      // Label 4097: @254556
      GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(254589), // Rule ID 7015 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wqm_demote),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
        // (intrinsic_void 3302:{ *:[iPTR] }, i1:{ *:[i1] }:$src)  =>  (SI_DEMOTE_I1 SCSrc_i1:{ *:[i1] }:$src, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_DEMOTE_I1),
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7015,
        GIR_EraseRootFromParent_Done,
      // Label 4098: @254589
      GIM_Reject,
    // Label 4072: @254590
    GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(255156),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(254667), // Rule ID 3527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (intrinsic_void 3139:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3527,
        GIR_EraseRootFromParent_Done,
      // Label 4100: @254667
      GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(254722), // Rule ID 3525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_imm),
        // (intrinsic_void 3139:{ *:[iPTR] }, (SMRDImm:{ *:[iPTR] } i64:{ *:[i64] }:$sbase, i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootToRootCopy, /*OpIdx*/2, // len
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3525,
        GIR_EraseRootFromParent_Done,
      // Label 4101: @254722
      GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(254759), // Rule ID 119 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_setreg),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_SIMM16bit),
        // (intrinsic_void 3146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_SIMM16bit>><<X:as_i16timm>>:$simm16, i32:{ *:[i32] }:$sdst)  =>  (S_SETREG_B32 i32:{ *:[i32] }:$sdst, (as_i16timm:{ *:[i32] } (timm:{ *:[i32] }):$simm16))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SETREG_B32),
        GIR_RootToRootCopy, /*OpIdx*/2, // sdst
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // simm16
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::MODE*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 119,
        GIR_EraseRootFromParent_Done,
      // Label 4102: @254759
      GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(254791), // Rule ID 25 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // MIs[0] src0
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // (intrinsic_w_chain:{ *:[i32] } 3142:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B32:{ *:[i32] } (timm:{ *:[i32] }):$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 25,
        GIR_EraseRootFromParent_Done,
      // Label 4103: @254791
      GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(254823), // Rule ID 26 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // MIs[0] src0
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // (intrinsic_w_chain:{ *:[i64] } 3142:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_SENDMSG_RTN_B64:{ *:[i64] } (timm:{ *:[i32] }):$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG_RTN_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 26,
        GIR_EraseRootFromParent_Done,
      // Label 4104: @254823
      GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(254852), // Rule ID 118 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_getreg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // (intrinsic_w_chain:{ *:[i32] } 3134:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16)  =>  (S_GETREG_B32:{ *:[i32] } (timm:{ *:[i32] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 118,
        GIR_EraseRootFromParent_Done,
      // Label 4105: @254852
      GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(254913), // Rule ID 3528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_void 3139:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, (imm:{ *:[i32] }):$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3528,
        GIR_EraseRootFromParent_Done,
      // Label 4106: @254913
      GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(254954), // Rule ID 189 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsg),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 3141:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSG (timm:{ *:[i32] }):$simm16)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSG),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 189,
        GIR_EraseRootFromParent_Done,
      // Label 4107: @254954
      GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(254995), // Rule ID 190 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_sendmsghalt),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 3143:{ *:[iPTR] }, (timm:{ *:[i32] }):$simm16, M0:{ *:[i32] })  =>  (S_SENDMSGHALT (timm:{ *:[i32] }):$simm16)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_SENDMSGHALT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 190,
        GIR_EraseRootFromParent_Done,
      // Label 4108: @254995
      GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(255050), // Rule ID 6968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_w_chain:{ *:[f32] } 2976:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (LDS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::LDS_DIRECT_LOAD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6968,
        GIR_EraseRootFromParent_Done,
      // Label 4109: @255050
      GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(255108), // Rule ID 6970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_lds_direct_load),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_w_chain:{ *:[f32] } 2976:{ *:[iPTR] }, M0:{ *:[i32] })  =>  (DS_DIRECT_LOAD:{ *:[f32] } 0:{ *:[i32] }, 1:{ *:[i32] })
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_DIRECT_LOAD),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6970,
        GIR_EraseRootFromParent_Done,
      // Label 4110: @255108
      GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(255155), // Rule ID 3526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_prefetch_data),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        // MIs[0] sbase
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_void 3139:{ *:[iPTR] }, SReg_64:{ *:[i64] }:$sbase, SReg_32:{ *:[i32] }:$len)  =>  (S_PREFETCH_DATA ?:{ *:[i64] }:$sbase, 0:{ *:[i32] }, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_PREFETCH_DATA),
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // len
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3526,
        GIR_EraseRootFromParent_Done,
      // Label 4111: @255155
      GIM_Reject,
    // Label 4099: @255156
    GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(257318),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(255234), // Rule ID 1323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1323,
        GIR_EraseRootFromParent_Done,
      // Label 4113: @255234
      GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(255304), // Rule ID 1325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, i64:{ *:[i64] }:$vaddr, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_ADDR64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1325,
        GIR_EraseRootFromParent_Done,
      // Label 4114: @255304
      GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(255369), // Rule ID 1322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1322,
        GIR_EraseRootFromParent_Done,
      // Label 4115: @255369
      GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(255434), // Rule ID 1324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX10_BEncoding),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$vdata_in)  =>  (BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CSUB_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1324,
        GIR_EraseRootFromParent_Done,
      // Label 4116: @255434
      GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(255495), // Rule ID 7874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_local_addrspace>>  =>  (DS_COND_SUB_U32 ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7874,
        GIR_EraseRootFromParent_Done,
      // Label 4117: @255495
      GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(255560), // Rule ID 7873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/1, /*AddrSpace*/3,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$value)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_local_addrspace>>  =>  (DS_COND_SUB_RTN_U32:{ *:[i32] } ?:{ *:[i32] }:$ptr, anonymous_9451:{ *:[i32] }:$value, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_COND_SUB_RTN_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_RootToRootCopy, /*OpIdx*/3, // value
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7873,
        GIR_EraseRootFromParent_Done,
      // Label 4118: @255560
      GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(255628), // Rule ID 4078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4078,
        GIR_EraseRootFromParent_Done,
      // Label 4119: @255628
      GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(255689), // Rule ID 4022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4022,
        GIR_EraseRootFromParent_Done,
      // Label 4120: @255689
      GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(255750), // Rule ID 4110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[f32] } 2186:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4110,
        GIR_EraseRootFromParent_Done,
      // Label 4121: @255750
      GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(255811), // Rule ID 4114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[f32] } 2185:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX_SADDR ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4114,
        GIR_EraseRootFromParent_Done,
      // Label 4122: @255811
      GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(255883), // Rule ID 4076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4076,
        GIR_EraseRootFromParent_Done,
      // Label 4123: @255883
      GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(255948), // Rule ID 4020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4020,
        GIR_EraseRootFromParent_Done,
      // Label 4124: @255948
      GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(256013), // Rule ID 4080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i64] } 2187:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4080,
        GIR_EraseRootFromParent_Done,
      // Label 4125: @256013
      GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(256078), // Rule ID 4112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[f32] } 2186:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4112,
        GIR_EraseRootFromParent_Done,
      // Label 4126: @256078
      GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(256143), // Rule ID 4116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[f32] } 2185:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_SADDR_RTN:{ *:[f32] } ?:{ *:[i32] }:$voffset, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4116,
        GIR_EraseRootFromParent_Done,
      // Label 4127: @256143
      GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(256206), // Rule ID 4077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4077,
        GIR_EraseRootFromParent_Done,
      // Label 4128: @256206
      GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(256262), // Rule ID 4021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_csub_noret>>  =>  (GLOBAL_ATOMIC_CSUB VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4021,
        GIR_EraseRootFromParent_Done,
      // Label 4129: @256262
      GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(256318), // Rule ID 4109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2186:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmin_num_noret>>  =>  (GLOBAL_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4109,
        GIR_EraseRootFromParent_Done,
      // Label 4130: @256318
      GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(256374), // Rule ID 4113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2185:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_global_atomic_fmax_num_noret>>  =>  (GLOBAL_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4113,
        GIR_EraseRootFromParent_Done,
      // Label 4131: @256374
      GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(256441), // Rule ID 4075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_global_addrspace>>  =>  (GLOBAL_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_COND_SUB_U32_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4075,
        GIR_EraseRootFromParent_Done,
      // Label 4132: @256441
      GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(256501), // Rule ID 4019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_csub),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2184:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)  =>  (GLOBAL_ATOMIC_CSUB_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CSUB_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4019,
        GIR_EraseRootFromParent_Done,
      // Label 4133: @256501
      GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(256561), // Rule ID 4079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_ordered_add_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i64] } 2187:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i64:{ *:[i64] }:$data)  =>  (GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_ORDERED_ADD_B64_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4079,
        GIR_EraseRootFromParent_Done,
      // Label 4134: @256561
      GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(256621), // Rule ID 4111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2186:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4111,
        GIR_EraseRootFromParent_Done,
      // Label 4135: @256621
      GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(256681), // Rule ID 4115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2185:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (GLOBAL_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4115,
        GIR_EraseRootFromParent_Done,
      // Label 4136: @256681
      GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(256723), // Rule ID 8421 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset32
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_w_chain:{ *:[i64] } 2141:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8421,
        GIR_EraseRootFromParent_Done,
      // Label 4137: @256723
      GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(256817), // Rule ID 8422 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_add_gs_reg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] offset32
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_w_chain:{ *:[i32] } 2141:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_ADD_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_ADD_GS_REG_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8422,
        GIR_EraseRootFromParent_Done,
      // Label 4138: @256817
      GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(256859), // Rule ID 8423 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset32
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_w_chain:{ *:[i64] } 2159:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8423,
        GIR_EraseRootFromParent_Done,
      // Label 4139: @256859
      GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(256953), // Rule ID 8424 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_sub_gs_reg_rtn),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] offset32
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_w_chain:{ *:[i32] } 2159:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset32)  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i64] } (DS_SUB_GS_REG_RTN:{ *:[i64] } VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$offset32)), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SUB_GS_REG_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset32
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 8424,
        GIR_EraseRootFromParent_Done,
      // Label 4140: @256953
      GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(257017), // Rule ID 3756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_noret_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32 VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3756,
        GIR_EraseRootFromParent_Done,
      // Label 4141: @257017
      GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(257073), // Rule ID 4118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2176:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmin_num_noret>>  =>  (FLAT_ATOMIC_FMIN VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4118,
        GIR_EraseRootFromParent_Done,
      // Label 4142: @257073
      GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(257129), // Rule ID 4120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2175:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)<<P:Predicate_int_amdgcn_flat_atomic_fmax_num_noret>>  =>  (FLAT_ATOMIC_FMAX VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4120,
        GIR_EraseRootFromParent_Done,
      // Label 4143: @257129
      GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(257197), // Rule ID 3755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_atomic_cond_sub_u32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2054:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data)<<P:Predicate_int_amdgcn_atomic_cond_sub_u32_flat_addrspace>>  =>  (FLAT_ATOMIC_COND_SUB_U32_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_COND_SUB_U32_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3755,
        GIR_EraseRootFromParent_Done,
      // Label 4144: @257197
      GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(257257), // Rule ID 4117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmin_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2176:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMIN_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMIN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4117,
        GIR_EraseRootFromParent_Done,
      // Label 4145: @257257
      GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(257317), // Rule ID 4119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_flat_atomic_fmax_num),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (intrinsic_w_chain:{ *:[f32] } 2175:{ *:[iPTR] }, (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), f32:{ *:[f32] }:$data)  =>  (FLAT_ATOMIC_FMAX_RTN:{ *:[f32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9451:{ *:[f32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_FMAX_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/3, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4119,
        GIR_EraseRootFromParent_Done,
      // Label 4146: @257317
      GIM_Reject,
    // Label 4112: @257318
    GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(257652),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
      GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_compr),
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      GIM_CheckIsImm, /*MI*/0, /*Op*/2,
      GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(257426), // Rule ID 6964 //
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/6, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6964,
        GIR_EraseRootFromParent_Done,
      // Label 4148: @257426
      GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(257501), // Rule ID 6965 //
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2i16] }:$src0, ExpSrc1:{ *:[v2i16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/6, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6965,
        GIR_EraseRootFromParent_Done,
      // Label 4149: @257501
      GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(257576), // Rule ID 6966 //
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/6, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6966,
        GIR_EraseRootFromParent_Done,
      // Label 4150: @257576
      GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(257651), // Rule ID 6967 //
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(-1),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[v2f16] }:$src0, ExpSrc1:{ *:[v2f16] }:$src1, (IMPLICIT_DEF:{ *:[i16] }), (IMPLICIT_DEF:{ *:[i16] }), (timm:{ *:[i1] }):$vm, 1:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/6, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6967,
        GIR_EraseRootFromParent_Done,
      // Label 4151: @257651
      GIM_Reject,
    // Label 4147: @257652
    GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(258409),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
      GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(257744), // Rule ID 6956 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // (intrinsic_void 2164:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_RootToRootCopy, /*OpIdx*/8, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6956,
        GIR_EraseRootFromParent_Done,
      // Label 4153: @257744
      GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(257828), // Rule ID 6957 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // (intrinsic_void 2164:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_RootToRootCopy, /*OpIdx*/8, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6957,
        GIR_EraseRootFromParent_Done,
      // Label 4154: @257828
      GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(257912), // Rule ID 6958 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // (intrinsic_void 2164:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_RootToRootCopy, /*OpIdx*/8, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6958,
        GIR_EraseRootFromParent_Done,
      // Label 4155: @257912
      GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(257996), // Rule ID 6959 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
        // MIs[0] vm
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // (intrinsic_void 2164:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, (timm:{ *:[i1] }):$vm)  =>  (EXP_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, (timm:{ *:[i1] }):$vm, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_RootToRootCopy, /*OpIdx*/8, // vm
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6959,
        GIR_EraseRootFromParent_Done,
      // Label 4156: @257996
      GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(258099), // Rule ID 6960 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 2166:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6960,
        GIR_EraseRootFromParent_Done,
      // Label 4157: @258099
      GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(258202), // Rule ID 6961 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
        GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 2166:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[i32] }:$src0, ExpSrc1:{ *:[i32] }:$src1, ExpSrc2:{ *:[i32] }:$src2, ExpSrc3:{ *:[i32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6961,
        GIR_EraseRootFromParent_Done,
      // Label 4158: @258202
      GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(258305), // Rule ID 6962 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 2166:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6962,
        GIR_EraseRootFromParent_Done,
      // Label 4159: @258305
      GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(258408), // Rule ID 6963 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_exp_row),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        // MIs[0] tgt
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // MIs[0] en
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(-1),
        GIM_RootCheckRegBankForClass, /*Op*/8, /*RC*/GIMT_Encode2(AMDGPU::M0_CLASSRegClassID),
        // (intrinsic_void 2166:{ *:[iPTR] }, (timm:{ *:[i32] }):$tgt, (timm:{ *:[i32] }):$en, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, -1:{ *:[i1] }, M0:{ *:[i32] })  =>  (EXP_ROW_DONE (timm:{ *:[i32] }):$tgt, ExpSrc0:{ *:[f32] }:$src0, ExpSrc1:{ *:[f32] }:$src1, ExpSrc2:{ *:[f32] }:$src2, ExpSrc3:{ *:[f32] }:$src3, 0:{ *:[i1] }, 0:{ *:[i1] }, (timm:{ *:[i32] }):$en)
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AMDGPU::M0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, // M0
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::EXP_ROW_DONE),
        GIR_RootToRootCopy, /*OpIdx*/1, // tgt
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/6, // src3
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // en
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6963,
        GIR_EraseRootFromParent_Done,
      // Label 4160: @258408
      GIM_Reject,
    // Label 4152: @258409
    GIM_Reject,
    // Label 38: @258410
    GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(259276),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(258457), // Rule ID 7708 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, (imm:{ *:[i32] }):$src)  =>  (S_MOV_B32:{ *:[i32] } SReg_32:{ *:[i32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7708,
        GIR_EraseRootFromParent_Done,
      // Label 4162: @258457
      GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(258490), // Rule ID 2283 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2283,
        GIR_EraseRootFromParent_Done,
      // Label 4163: @258490
      GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(258523), // Rule ID 2284 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[f32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2284,
        GIR_EraseRootFromParent_Done,
      // Label 4164: @258523
      GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(258556), // Rule ID 2285 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2285,
        GIR_EraseRootFromParent_Done,
      // Label 4165: @258556
      GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(258589), // Rule ID 2286 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f16] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2286,
        GIR_EraseRootFromParent_Done,
      // Label 4166: @258589
      GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(258622), // Rule ID 2287 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[v2bf16] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[v2bf16] } VRegOrLdsSrc_32:{ *:[v2bf16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2287,
        GIR_EraseRootFromParent_Done,
      // Label 4167: @258622
      GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(258655), // Rule ID 2288 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2288,
        GIR_EraseRootFromParent_Done,
      // Label 4168: @258655
      GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(258688), // Rule ID 2289 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2289,
        GIR_EraseRootFromParent_Done,
      // Label 4169: @258688
      GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(258721), // Rule ID 2290 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2290,
        GIR_EraseRootFromParent_Done,
      // Label 4170: @258721
      GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(258754), // Rule ID 2291 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readfirstlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VRegOrLds_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3108:{ *:[iPTR] }, VRegOrLdsSrc_32:{ *:[i32] }:$src0)  =>  (V_READFIRSTLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READFIRSTLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2291,
        GIR_EraseRootFromParent_Done,
      // Label 4171: @258754
      GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(258787), // Rule ID 2318 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2318,
        GIR_EraseRootFromParent_Done,
      // Label 4172: @258787
      GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(258820), // Rule ID 2319 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[f32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[f32] } VRegSrc_32:{ *:[f32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2319,
        GIR_EraseRootFromParent_Done,
      // Label 4173: @258820
      GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(258853), // Rule ID 2320 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[v2i16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2i16] } VRegSrc_32:{ *:[v2i16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2320,
        GIR_EraseRootFromParent_Done,
      // Label 4174: @258853
      GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(258886), // Rule ID 2321 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f16] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[v2f16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2f16] } VRegSrc_32:{ *:[v2f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2321,
        GIR_EraseRootFromParent_Done,
      // Label 4175: @258886
      GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(258919), // Rule ID 2322 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[v2bf16] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[v2bf16] } VRegSrc_32:{ *:[v2bf16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2322,
        GIR_EraseRootFromParent_Done,
      // Label 4176: @258919
      GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(258952), // Rule ID 2323 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2323,
        GIR_EraseRootFromParent_Done,
      // Label 4177: @258952
      GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(258985), // Rule ID 2324 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2324,
        GIR_EraseRootFromParent_Done,
      // Label 4178: @258985
      GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(259018), // Rule ID 2325 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2325,
        GIR_EraseRootFromParent_Done,
      // Label 4179: @259018
      GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(259051), // Rule ID 2326 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3048:{ *:[iPTR] }, VRegSrc_32:{ *:[i32] }:$src0)  =>  (V_PERMLANE64_B32:{ *:[i32] } VRegSrc_32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2326,
        GIR_EraseRootFromParent_Done,
      // Label 4180: @259051
      GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(259083), // Rule ID 2 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3161:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_WQM_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2,
        GIR_EraseRootFromParent_Done,
      // Label 4181: @259083
      GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(259115), // Rule ID 3 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_wqm),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3161:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_WQM_B64:{ *:[i64] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3,
        GIR_EraseRootFromParent_Done,
      // Label 4182: @259115
      GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(259144), // Rule ID 21 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3140:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_QUADMASK_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 21,
        GIR_EraseRootFromParent_Done,
      // Label 4183: @259144
      GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(259173), // Rule ID 22 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_quadmask),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3140:{ *:[iPTR] }, i64:{ *:[i64] }:$src0)  =>  (S_QUADMASK_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_QUADMASK_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 22,
        GIR_EraseRootFromParent_Done,
      // Label 4184: @259173
      GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(259205), // Rule ID 24 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_s_bitreplicate),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i64] } 3122:{ *:[iPTR] }, i32:{ *:[i32] }:$src0)  =>  (S_BITREPLICATE_B64_B32:{ *:[i64] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BITREPLICATE_B64_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 24,
        GIR_EraseRootFromParent_Done,
      // Label 4185: @259205
      GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(259240), // Rule ID 1864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i1] } 3303:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B32:{ *:[i1] }:{ *:[i1] } SSrc_b32:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1864,
        GIR_EraseRootFromParent_Done,
      // Label 4186: @259240
      GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(259275), // Rule ID 1865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wqm_vote),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        // (intrinsic_wo_chain:{ *:[i1] } 3303:{ *:[iPTR] }, i1:{ *:[i1] }:$src0)  =>  (S_WQM_B64:{ *:[i1] }:{ *:[i1] } SSrc_b64:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_WQM_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1865,
        GIR_EraseRootFromParent_Done,
      // Label 4187: @259275
      GIM_Reject,
    // Label 4161: @259276
    GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(261799),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(259336), // Rule ID 1366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_permute),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_wo_chain:{ *:[i32] } 2154:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_PERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_PERMUTE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // data0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1366,
        GIR_EraseRootFromParent_Done,
      // Label 4189: @259336
      GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(259388), // Rule ID 1367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_bpermute),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_wo_chain:{ *:[i32] } 2143:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$offset), i32:{ *:[i32] }:$data0)  =>  (DS_BPERMUTE_B32:{ *:[i32] } i32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$data0, i32:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_BPERMUTE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // addr
        GIR_RootToRootCopy, /*OpIdx*/3, // data0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1367,
        GIR_EraseRootFromParent_Done,
      // Label 4190: @259388
      GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(259441), // Rule ID 2351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2351,
        GIR_EraseRootFromParent_Done,
      // Label 4191: @259441
      GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(259494), // Rule ID 2352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2352,
        GIR_EraseRootFromParent_Done,
      // Label 4192: @259494
      GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(259547), // Rule ID 2353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2353,
        GIR_EraseRootFromParent_Done,
      // Label 4193: @259547
      GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(259600), // Rule ID 2354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 3035:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2354,
        GIR_EraseRootFromParent_Done,
      // Label 4194: @259600
      GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(259653), // Rule ID 2355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 3035:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2355,
        GIR_EraseRootFromParent_Done,
      // Label 4195: @259653
      GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(259706), // Rule ID 2356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[f32] } 3035:{ *:[iPTR] }, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[f32] } VGPR_32:{ *:[f32] }:$src, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2356,
        GIR_EraseRootFromParent_Done,
      // Label 4196: @259706
      GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(259759), // Rule ID 2357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3035:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2357,
        GIR_EraseRootFromParent_Done,
      // Label 4197: @259759
      GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(259812), // Rule ID 2358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3035:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2358,
        GIR_EraseRootFromParent_Done,
      // Label 4198: @259812
      GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(259865), // Rule ID 2359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3035:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$src, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2359,
        GIR_EraseRootFromParent_Done,
      // Label 4199: @259865
      GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(259918), // Rule ID 2360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3035:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2360,
        GIR_EraseRootFromParent_Done,
      // Label 4200: @259918
      GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(259971), // Rule ID 2361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3035:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2361,
        GIR_EraseRootFromParent_Done,
      // Label 4201: @259971
      GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(260024), // Rule ID 2362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3035:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2362,
        GIR_EraseRootFromParent_Done,
      // Label 4202: @260024
      GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(260077), // Rule ID 2363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3035:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[v2bf16] } VGPR_32:{ *:[v2bf16] }:$src, VGPR_32:{ *:[v2bf16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2363,
        GIR_EraseRootFromParent_Done,
      // Label 4203: @260077
      GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(260130), // Rule ID 2364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3035:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[v2bf16] } VGPR_32:{ *:[v2bf16] }:$src, VGPR_32:{ *:[v2bf16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2364,
        GIR_EraseRootFromParent_Done,
      // Label 4204: @260130
      GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(260183), // Rule ID 2365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3035:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[v2bf16] } VGPR_32:{ *:[v2bf16] }:$src, VGPR_32:{ *:[v2bf16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2365,
        GIR_EraseRootFromParent_Done,
      // Label 4205: @260183
      GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(260236), // Rule ID 2366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2366,
        GIR_EraseRootFromParent_Done,
      // Label 4206: @260236
      GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(260289), // Rule ID 2367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2367,
        GIR_EraseRootFromParent_Done,
      // Label 4207: @260289
      GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(260342), // Rule ID 2368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2368,
        GIR_EraseRootFromParent_Done,
      // Label 4208: @260342
      GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(260395), // Rule ID 2369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2369,
        GIR_EraseRootFromParent_Done,
      // Label 4209: @260395
      GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(260448), // Rule ID 2370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2370,
        GIR_EraseRootFromParent_Done,
      // Label 4210: @260448
      GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(260501), // Rule ID 2371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2371,
        GIR_EraseRootFromParent_Done,
      // Label 4211: @260501
      GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(260554), // Rule ID 2372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2372,
        GIR_EraseRootFromParent_Done,
      // Label 4212: @260554
      GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(260607), // Rule ID 2373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2373,
        GIR_EraseRootFromParent_Done,
      // Label 4213: @260607
      GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(260660), // Rule ID 2374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2374,
        GIR_EraseRootFromParent_Done,
      // Label 4214: @260660
      GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(260713), // Rule ID 2375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx10:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx10),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2375,
        GIR_EraseRootFromParent_Done,
      // Label 4215: @260713
      GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(260766), // Rule ID 2376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx11:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx11),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2376,
        GIR_EraseRootFromParent_Done,
      // Label 4216: @260766
      GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(260819), // Rule ID 2377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Only),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp8
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 3035:{ *:[iPTR] }, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp8)  =>  (V_MOV_B32_dpp8_gfx12:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp8), 233:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp8_gfx12),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp8
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(233),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2377,
        GIR_EraseRootFromParent_Done,
      // Label 4217: @260819
      GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(260860), // Rule ID 7875 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_swizzle),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset16
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // (intrinsic_wo_chain:{ *:[i32] } 2160:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$offset16)  =>  (DS_SWIZZLE_B32:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, (as_i16timm:{ *:[i16] } ?:{ *:[i32] }:$offset16), 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_SWIZZLE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // offset16
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7875,
        GIR_EraseRootFromParent_Done,
      // Label 4218: @260860
      GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(260894), // Rule ID 2378 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3109:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2378,
        GIR_EraseRootFromParent_Done,
      // Label 4219: @260894
      GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(260928), // Rule ID 2380 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 3109:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[f32] } VRegOrLdsSrc_32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2380,
        GIR_EraseRootFromParent_Done,
      // Label 4220: @260928
      GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(260962), // Rule ID 2382 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 3109:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2i16] } VRegOrLdsSrc_32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2382,
        GIR_EraseRootFromParent_Done,
      // Label 4221: @260962
      GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(260996), // Rule ID 2384 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f16] } 3109:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2f16] } VRegOrLdsSrc_32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2384,
        GIR_EraseRootFromParent_Done,
      // Label 4222: @260996
      GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(261030), // Rule ID 2386 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3109:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[v2bf16] } VRegOrLdsSrc_32:{ *:[v2bf16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2386,
        GIR_EraseRootFromParent_Done,
      // Label 4223: @261030
      GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(261064), // Rule ID 2388 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3109:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2388,
        GIR_EraseRootFromParent_Done,
      // Label 4224: @261064
      GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(261098), // Rule ID 2390 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3109:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2390,
        GIR_EraseRootFromParent_Done,
      // Label 4225: @261098
      GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(261132), // Rule ID 2392 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3109:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2392,
        GIR_EraseRootFromParent_Done,
      // Label 4226: @261132
      GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(261166), // Rule ID 2394 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_readlane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3109:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_READLANE_B32:{ *:[i32] } VRegOrLdsSrc_32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_READLANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2394,
        GIR_EraseRootFromParent_Done,
      // Label 4227: @261166
      GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(261223), // Rule ID 6992 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6992,
        GIR_EraseRootFromParent_Done,
      // Label 4228: @261223
      GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(261280), // Rule ID 6993 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 3171:{ *:[iPTR] }, f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[f32] } 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[f32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6993,
        GIR_EraseRootFromParent_Done,
      // Label 4229: @261280
      GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(261337), // Rule ID 6994 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 3171:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src, v2i16:{ *:[v2i16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6994,
        GIR_EraseRootFromParent_Done,
      // Label 4230: @261337
      GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(261394), // Rule ID 6995 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f16] } 3171:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src, v2f16:{ *:[v2f16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2f16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6995,
        GIR_EraseRootFromParent_Done,
      // Label 4231: @261394
      GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(261451), // Rule ID 6996 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3171:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src, v2bf16:{ *:[v2bf16] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[v2bf16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2bf16] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[v2bf16] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6996,
        GIR_EraseRootFromParent_Done,
      // Label 4232: @261451
      GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(261508), // Rule ID 6997 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p2:{ *:[i32] }:$src, p2:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6997,
        GIR_EraseRootFromParent_Done,
      // Label 4233: @261508
      GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(261565), // Rule ID 6998 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p3:{ *:[i32] }:$src, p3:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6998,
        GIR_EraseRootFromParent_Done,
      // Label 4234: @261565
      GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(261622), // Rule ID 6999 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p5:{ *:[i32] }:$src, p5:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6999,
        GIR_EraseRootFromParent_Done,
      // Label 4235: @261622
      GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(261679), // Rule ID 7000 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3171:{ *:[iPTR] }, p6:{ *:[i32] }:$src, p6:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$src, 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7000,
        GIR_EraseRootFromParent_Done,
      // Label 4236: @261679
      GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(261736), // Rule ID 7001 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_set_inactive_chain_arg),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3172:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$inactive)  =>  (V_SET_INACTIVE_B32:{ *:[i32] } 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$src, 0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$inactive, (IMPLICIT_DEF:{ *:[i1] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SET_INACTIVE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // inactive
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7001,
        GIR_EraseRootFromParent_Done,
      // Label 4237: @261736
      GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(261767), // Rule ID 1338 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umin),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
        // MIs[0] strategy
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[i32] } 3280:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMIN_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMIN_PSEUDO_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/3, // strategy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1338,
        GIR_EraseRootFromParent_Done,
      // Label 4238: @261767
      GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(261798), // Rule ID 1339 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wave_reduce_umax),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
        // MIs[0] strategy
        // No operand predicates
        // (intrinsic_wo_chain:{ *:[i32] } 3279:{ *:[iPTR] }, i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)  =>  (WAVE_REDUCE_UMAX_PSEUDO_U32:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$strategy)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_REDUCE_UMAX_PSEUDO_U32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/3, // strategy
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1339,
        GIR_EraseRootFromParent_Done,
      // Label 4239: @261798
      GIM_Reject,
    // Label 4188: @261799
    GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(264163),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
      GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(261898), // Rule ID 2726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w32_threeaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2726,
        GIR_EraseRootFromParent_Done,
      // Label 4241: @261898
      GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(261989), // Rule ID 2759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_F16_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2759,
        GIR_EraseRootFromParent_Done,
      // Label 4242: @261989
      GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(262082), // Rule ID 2711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3289:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2711,
        GIR_EraseRootFromParent_Done,
      // Label 4243: @262082
      GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(262175), // Rule ID 2712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3286:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w32:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2712,
        GIR_EraseRootFromParent_Done,
      // Label 4244: @262175
      GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(262268), // Rule ID 2717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3289:{ *:[iPTR] }, (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16f16:{ *:[v16f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2717,
        GIR_EraseRootFromParent_Done,
      // Label 4245: @262268
      GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(262361), // Rule ID 2718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3286:{ *:[iPTR] }, (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v16i16] } v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_twoaddr_w64:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v16i16:{ *:[v16i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16i16:{ *:[v16i16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2718,
        GIR_EraseRootFromParent_Done,
      // Label 4246: @262361
      GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(262454), // Rule ID 2725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2725,
        GIR_EraseRootFromParent_Done,
      // Label 4247: @262454
      GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(262547), // Rule ID 2758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3289:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_F16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2758,
        GIR_EraseRootFromParent_Done,
      // Label 4248: @262547
      GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(262614), // Rule ID 2728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3286:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w32_threeaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2728,
        GIR_EraseRootFromParent_Done,
      // Label 4249: @262614
      GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(262675), // Rule ID 2738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3291:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2738,
        GIR_EraseRootFromParent_Done,
      // Label 4250: @262675
      GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(262736), // Rule ID 2740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3290:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2740,
        GIR_EraseRootFromParent_Done,
      // Label 4251: @262736
      GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(262797), // Rule ID 2742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3288:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2742,
        GIR_EraseRootFromParent_Done,
      // Label 4252: @262797
      GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(262858), // Rule ID 2744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3287:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2744,
        GIR_EraseRootFromParent_Done,
      // Label 4253: @262858
      GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(262925), // Rule ID 2761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3286:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF16_w64_threeaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2761,
        GIR_EraseRootFromParent_Done,
      // Label 4254: @262925
      GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(262986), // Rule ID 2771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3291:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2771,
        GIR_EraseRootFromParent_Done,
      // Label 4255: @262986
      GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(263047), // Rule ID 2773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3290:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2773,
        GIR_EraseRootFromParent_Done,
      // Label 4256: @263047
      GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(263108), // Rule ID 2775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3288:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2775,
        GIR_EraseRootFromParent_Done,
      // Label 4257: @263108
      GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(263169), // Rule ID 2777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3287:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, 8:{ *:[i32] }, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2777,
        GIR_EraseRootFromParent_Done,
      // Label 4258: @263169
      GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(263238), // Rule ID 2727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3286:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2727,
        GIR_EraseRootFromParent_Done,
      // Label 4259: @263238
      GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(263301), // Rule ID 2737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3291:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2737,
        GIR_EraseRootFromParent_Done,
      // Label 4260: @263301
      GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(263364), // Rule ID 2739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3290:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2739,
        GIR_EraseRootFromParent_Done,
      // Label 4261: @263364
      GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(263427), // Rule ID 2741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3288:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2741,
        GIR_EraseRootFromParent_Done,
      // Label 4262: @263427
      GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(263490), // Rule ID 2743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3287:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v8f32] } v8f32:{ *:[v8f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f32:{ *:[v8f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2743,
        GIR_EraseRootFromParent_Done,
      // Label 4263: @263490
      GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(263559), // Rule ID 2760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3286:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2760,
        GIR_EraseRootFromParent_Done,
      // Label 4264: @263559
      GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(263622), // Rule ID 2770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3291:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_FP8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2770,
        GIR_EraseRootFromParent_Done,
      // Label 4265: @263622
      GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(263685), // Rule ID 2772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3290:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_FP8_BF8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2772,
        GIR_EraseRootFromParent_Done,
      // Label 4266: @263685
      GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(263748), // Rule ID 2774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3288:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_FP8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2774,
        GIR_EraseRootFromParent_Done,
      // Label 4267: @263748
      GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(263811), // Rule ID 2776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f32_16x16x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamods),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3287:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (WMMAModsF32NegAbs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F32_16X16X16_BF8_BF8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2776,
        GIR_EraseRootFromParent_Done,
      // Label 4268: @263811
      GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(263850), // Rule ID 2379 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2379,
        GIR_EraseRootFromParent_Done,
      // Label 4269: @263850
      GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(263889), // Rule ID 2381 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[f32] } 3304:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, f32:{ *:[f32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[f32] } SCSrc_b32:{ *:[f32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2381,
        GIR_EraseRootFromParent_Done,
      // Label 4270: @263889
      GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(263928), // Rule ID 2383 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2i16] } 3304:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, v2i16:{ *:[v2i16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2i16] } SCSrc_b32:{ *:[v2i16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2383,
        GIR_EraseRootFromParent_Done,
      // Label 4271: @263928
      GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(263967), // Rule ID 2385 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2f16] } 3304:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, v2f16:{ *:[v2f16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2f16] } SCSrc_b32:{ *:[v2f16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2385,
        GIR_EraseRootFromParent_Done,
      // Label 4272: @263967
      GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(264006), // Rule ID 2387 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3304:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1, v2bf16:{ *:[v2bf16] }:$src2)  =>  (V_WRITELANE_B32:{ *:[v2bf16] } SCSrc_b32:{ *:[v2bf16] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[v2bf16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2387,
        GIR_EraseRootFromParent_Done,
      // Label 4273: @264006
      GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(264045), // Rule ID 2389 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p2:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2389,
        GIR_EraseRootFromParent_Done,
      // Label 4274: @264045
      GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(264084), // Rule ID 2391 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p3:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2391,
        GIR_EraseRootFromParent_Done,
      // Label 4275: @264084
      GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(264123), // Rule ID 2393 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p5:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2393,
        GIR_EraseRootFromParent_Done,
      // Label 4276: @264123
      GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(264162), // Rule ID 2395 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_writelane),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (intrinsic_wo_chain:{ *:[i32] } 3304:{ *:[iPTR] }, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, p6:{ *:[i32] }:$src2)  =>  (V_WRITELANE_B32:{ *:[i32] } SCSrc_b32:{ *:[i32] }:$src0, SCSrc_b32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WRITELANE_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2395,
        GIR_EraseRootFromParent_Done,
      // Label 4277: @264162
      GIM_Reject,
    // Label 4240: @264163
    GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(266636),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
      GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(264273), // Rule ID 2730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8f16] } 3284:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_threeaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, 8:{ *:[i32] }, v8f16:{ *:[v8f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2730,
        GIR_EraseRootFromParent_Done,
      // Label 4279: @264273
      GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(264375), // Rule ID 2763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4f16] } 3284:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAVISrc:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_threeaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, 8:{ *:[i32] }, v4f16:{ *:[v4f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2763,
        GIR_EraseRootFromParent_Done,
      // Label 4280: @264375
      GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(264479), // Rule ID 2729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
        // (intrinsic_wo_chain:{ *:[v8f16] } 3284:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2729,
        GIR_EraseRootFromParent_Done,
      // Label 4281: @264479
      GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(264583), // Rule ID 2762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmamodsf16NegAbs),
        // (intrinsic_wo_chain:{ *:[v4f16] } 3284:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (WMMAModsF16NegAbs:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers), 0:{ *:[i1] })  =>  (V_WMMA_F16_16X16X16_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4f16:{ *:[v4f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v4f16:{ *:[v4f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2762,
        GIR_EraseRootFromParent_Done,
      // Label 4282: @264583
      GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(264681), // Rule ID 2747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3264:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w32_twoaddr:{ *:[v8f32] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2747,
        GIR_EraseRootFromParent_Done,
      // Label 4283: @264681
      GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(264779), // Rule ID 2749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f16] } 3260:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v16f16] } v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v8f16:{ *:[v8f16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w32_twoaddr:{ *:[v8f16] } i32:{ *:[i32] }:$src0_modifiers, v8f16:{ *:[v8f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2749,
        GIR_EraseRootFromParent_Done,
      // Label 4284: @264779
      GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(264877), // Rule ID 2780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3264:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_F16_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_F16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2780,
        GIR_EraseRootFromParent_Done,
      // Label 4285: @264877
      GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(264975), // Rule ID 2782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f16_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_wmmamodsf16Neg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f16] } 3260:{ *:[iPTR] }, (WMMAModsF16Neg:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (WMMAModsF16Neg:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), v4f16:{ *:[v4f16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F16_16X16X32_F16_w64_twoaddr:{ *:[v4f16] } i32:{ *:[i32] }:$src0_modifiers, v4f16:{ *:[v4f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v8f16:{ *:[v8f16] }:$src1, v4f16:{ *:[v4f16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F16_16X16X32_F16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2782,
        GIR_EraseRootFromParent_Done,
      // Label 4286: @264975
      GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(265053), // Rule ID 2732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8i16] } 3282:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, (WMMAVISrc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_threeaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2732,
        GIR_EraseRootFromParent_Done,
      // Label 4287: @265053
      GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(265131), // Rule ID 2765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4i16] } 3282:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, (WMMAVISrc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$src2), 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_threeaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2765,
        GIR_EraseRootFromParent_Done,
      // Label 4288: @265131
      GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(265205), // Rule ID 2748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3261:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr:{ *:[v8f32] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2748,
        GIR_EraseRootFromParent_Done,
      // Label 4289: @265205
      GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(265279), // Rule ID 2750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8i16] } 3259:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2750,
        GIR_EraseRootFromParent_Done,
      // Label 4290: @265279
      GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(265341), // Rule ID 2754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3266:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2754,
        GIR_EraseRootFromParent_Done,
      // Label 4291: @265341
      GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(265403), // Rule ID 2755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3265:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2755,
        GIR_EraseRootFromParent_Done,
      // Label 4292: @265403
      GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(265465), // Rule ID 2756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3263:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2756,
        GIR_EraseRootFromParent_Done,
      // Label 4293: @265465
      GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(265527), // Rule ID 2757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8f32] } 3262:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr:{ *:[v8f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v8f32:{ *:[v8f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_16bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2757,
        GIR_EraseRootFromParent_Done,
      // Label 4294: @265527
      GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(265601), // Rule ID 2781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3261:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr:{ *:[v4f32] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2781,
        GIR_EraseRootFromParent_Done,
      // Label 4295: @265601
      GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(265675), // Rule ID 2783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_bf16_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4i16] } 3259:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, v4i16:{ *:[v4i16] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_BF16_16X16X32_BF16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2783,
        GIR_EraseRootFromParent_Done,
      // Label 4296: @265675
      GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(265737), // Rule ID 2787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3266:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_FP8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2787,
        GIR_EraseRootFromParent_Done,
      // Label 4297: @265737
      GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(265799), // Rule ID 2788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3265:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_FP8_BF8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2788,
        GIR_EraseRootFromParent_Done,
      // Label 4298: @265799
      GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(265861), // Rule ID 2789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3263:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_FP8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2789,
        GIR_EraseRootFromParent_Done,
      // Label 4299: @265861
      GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(265923), // Rule ID 2790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_f32_16x16x32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3262:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit))  =>  (V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr:{ *:[v4f32] } i32:{ *:[i32] }:$src0, v2i32:{ *:[v2i32] }:$src1, v4f32:{ *:[v4f32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_F32_16X16X32_BF8_BF8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // index_key_8bit
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2790,
        GIR_EraseRootFromParent_Done,
      // Label 4300: @265923
      GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(265995), // Rule ID 2709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v16f16] } 3284:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2709,
        GIR_EraseRootFromParent_Done,
      // Label 4301: @265995
      GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(266067), // Rule ID 2713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v16i16] } 3282:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2713,
        GIR_EraseRootFromParent_Done,
      // Label 4302: @266067
      GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(266139), // Rule ID 2714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v16f16] } 3285:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f16:{ *:[v16f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32:{ *:[v16f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16f16:{ *:[v16f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2714,
        GIR_EraseRootFromParent_Done,
      // Label 4303: @266139
      GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(266211), // Rule ID 2715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v16i16] } 3283:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v16i16:{ *:[v16i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32:{ *:[v16i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v16i16:{ *:[v16i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2715,
        GIR_EraseRootFromParent_Done,
      // Label 4304: @266211
      GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(266283), // Rule ID 2719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v8f16] } 3284:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2719,
        GIR_EraseRootFromParent_Done,
      // Label 4305: @266283
      GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(266355), // Rule ID 2720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v8i16] } 3282:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2720,
        GIR_EraseRootFromParent_Done,
      // Label 4306: @266355
      GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(266427), // Rule ID 2721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_f16_16x16x16_f16_tied),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v8f16] } 3285:{ *:[iPTR] }, v16f16:{ *:[v16f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v8f16:{ *:[v8f16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64:{ *:[v8f16] } 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src0, 8:{ *:[i32] }, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8f16:{ *:[v8f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_F16_16X16X16_F16_TIED_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2721,
        GIR_EraseRootFromParent_Done,
      // Label 4307: @266427
      GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(266499), // Rule ID 2722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16_tied),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_wmmaopselvop3pmods),
        // (intrinsic_wo_chain:{ *:[v8i16] } 3283:{ *:[iPTR] }, v16i16:{ *:[v16i16] }:$src0, v16i16:{ *:[v16i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, (WMMAOpSelVOP3PMods:{ *:[i1] } i32:{ *:[i32] }:$src2_modifiers))  =>  (V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64:{ *:[v8i16] } 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src0, 8:{ *:[i32] }, v16i16:{ *:[v16i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v8i16:{ *:[v8i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_TIED_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2_modifiers
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2722,
        GIR_EraseRootFromParent_Done,
      // Label 4308: @266499
      GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(266567), // Rule ID 2731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v8i16] } 3282:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w32_twoaddr:{ *:[v8i16] } 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src0, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src1, 8:{ *:[i32] }, v8i16:{ *:[v8i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2731,
        GIR_EraseRootFromParent_Done,
      // Label 4309: @266567
      GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(266635), // Rule ID 2764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_bf16_16x16x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] Operand 5
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(0),
        // (intrinsic_wo_chain:{ *:[v4i16] } 3282:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4i16:{ *:[v4i16] }:$src2, 0:{ *:[i1] })  =>  (V_WMMA_BF16_16X16X16_BF16_w64_twoaddr:{ *:[v4i16] } 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src0, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src1, 8:{ *:[i32] }, v4i16:{ *:[v4i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_BF16_16X16X16_BF16_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2764,
        GIR_EraseRootFromParent_Done,
      // Label 4310: @266635
      GIM_Reject,
    // Label 4278: @266636
    GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(266908),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
      GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(266714), // Rule ID 2327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 3034:{ *:[iPTR] }, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$src, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2327,
        GIR_EraseRootFromParent_Done,
      // Label 4312: @266714
      GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(266781), // Rule ID 7693 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mov_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/3,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i64] } 3034:{ *:[iPTR] }, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$src, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_RootToRootCopy, /*OpIdx*/2, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7693,
        GIR_EraseRootFromParent_Done,
      // Label 4313: @266781
      GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(266844), // Rule ID 2589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16_var),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 3046:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_VAR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2589,
        GIR_EraseRootFromParent_Done,
      // Label 4314: @266844
      GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(266907), // Rule ID 2590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16_var),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // (intrinsic_wo_chain:{ *:[i32] } 3050:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_VAR_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), VGPR_32:{ *:[i32] }:$src1, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_VAR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2590,
        GIR_EraseRootFromParent_Done,
      // Label 4315: @266907
      GIM_Reject,
    // Label 4311: @266908
    GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(277870),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
      GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(266997), // Rule ID 2734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2734,
        GIR_EraseRootFromParent_Done,
      // Label 4317: @266997
      GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(267078), // Rule ID 2736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2736,
        GIR_EraseRootFromParent_Done,
      // Label 4318: @267078
      GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(267159), // Rule ID 2746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3294:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, (WMMAVISrc:{ *:[v8i32] } v8i32:{ *:[v8i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_threeaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2746,
        GIR_EraseRootFromParent_Done,
      // Label 4319: @267159
      GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(267240), // Rule ID 2767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2767,
        GIR_EraseRootFromParent_Done,
      // Label 4320: @267240
      GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(267321), // Rule ID 2769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2769,
        GIR_EraseRootFromParent_Done,
      // Label 4321: @267321
      GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(267402), // Rule ID 2779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_wmmavisrc),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3294:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, (WMMAVISrc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src2), i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_threeaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_threeaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2779,
        GIR_EraseRootFromParent_Done,
      // Label 4322: @267402
      GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(267482), // Rule ID 2710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2710,
        GIR_EraseRootFromParent_Done,
      // Label 4323: @267482
      GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(267562), // Rule ID 2716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w32:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2716,
        GIR_EraseRootFromParent_Done,
      // Label 4324: @267562
      GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(267642), // Rule ID 2723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v4i32:{ *:[v4i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v4i32:{ *:[v4i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2723,
        GIR_EraseRootFromParent_Done,
      // Label 4325: @267642
      GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(267722), // Rule ID 2724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Only_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i1] }):$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_twoaddr_w64:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, 8:{ *:[i32] }, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_twoaddr_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2724,
        GIR_EraseRootFromParent_Done,
      // Label 4326: @267722
      GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(267793), // Rule ID 2733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2733,
        GIR_EraseRootFromParent_Done,
      // Label 4327: @267793
      GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(267864), // Rule ID 2735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2735,
        GIR_EraseRootFromParent_Done,
      // Label 4328: @267864
      GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(267935), // Rule ID 2745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3294:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2745,
        GIR_EraseRootFromParent_Done,
      // Label 4329: @267935
      GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(268006), // Rule ID 2766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3293:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2766,
        GIR_EraseRootFromParent_Done,
      // Label 4330: @268006
      GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(268077), // Rule ID 2768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x16_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3292:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X16_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X16_IU4_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2768,
        GIR_EraseRootFromParent_Done,
      // Label 4331: @268077
      GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(268148), // Rule ID 2778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_wmma_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3294:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_WMMA_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_WMMA_I32_16X16X32_IU4_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // src2
        GIR_RootToRootCopy, /*OpIdx*/7, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2778,
        GIR_EraseRootFromParent_Done,
      // Label 4332: @268148
      GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(268221), // Rule ID 2328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3276:{ *:[iPTR] }, i32:{ *:[i32] }:$old, i32:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2328,
        GIR_EraseRootFromParent_Done,
      // Label 4333: @268221
      GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(268294), // Rule ID 2329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[f32] } 3276:{ *:[iPTR] }, f32:{ *:[f32] }:$old, f32:{ *:[f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[f32] } VGPR_32:{ *:[f32] }:$old, VGPR_32:{ *:[f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2329,
        GIR_EraseRootFromParent_Done,
      // Label 4334: @268294
      GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(268367), // Rule ID 2330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3276:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$old, v2i16:{ *:[v2i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2i16] } VGPR_32:{ *:[v2i16] }:$old, VGPR_32:{ *:[v2i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2330,
        GIR_EraseRootFromParent_Done,
      // Label 4335: @268367
      GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(268440), // Rule ID 2331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3276:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$old, v2f16:{ *:[v2f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$old, VGPR_32:{ *:[v2f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2331,
        GIR_EraseRootFromParent_Done,
      // Label 4336: @268440
      GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(268513), // Rule ID 2332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3276:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$old, v2bf16:{ *:[v2bf16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[v2bf16] } VGPR_32:{ *:[v2bf16] }:$old, VGPR_32:{ *:[v2bf16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2332,
        GIR_EraseRootFromParent_Done,
      // Label 4337: @268513
      GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(268586), // Rule ID 2333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3276:{ *:[iPTR] }, p2:{ *:[i32] }:$old, p2:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2333,
        GIR_EraseRootFromParent_Done,
      // Label 4338: @268586
      GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(268659), // Rule ID 2334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3276:{ *:[iPTR] }, p3:{ *:[i32] }:$old, p3:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2334,
        GIR_EraseRootFromParent_Done,
      // Label 4339: @268659
      GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(268732), // Rule ID 2335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3276:{ *:[iPTR] }, p5:{ *:[i32] }:$old, p5:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2335,
        GIR_EraseRootFromParent_Done,
      // Label 4340: @268732
      GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(268805), // Rule ID 2336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3276:{ *:[iPTR] }, p6:{ *:[i32] }:$old, p6:{ *:[i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B32_dpp:{ *:[i32] } VGPR_32:{ *:[i32] }:$old, VGPR_32:{ *:[i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_dpp),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2336,
        GIR_EraseRootFromParent_Done,
      // Label 4341: @268805
      GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(268875), // Rule ID 7694 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i64] } 3276:{ *:[iPTR] }, i64:{ *:[i64] }:$old, i64:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7694,
        GIR_EraseRootFromParent_Done,
      // Label 4342: @268875
      GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(268945), // Rule ID 7695 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[f64] } 3276:{ *:[iPTR] }, f64:{ *:[f64] }:$old, f64:{ *:[f64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[f64] } VReg_64_Align2:{ *:[f64] }:$old, VReg_64_Align2:{ *:[f64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7695,
        GIR_EraseRootFromParent_Done,
      // Label 4343: @268945
      GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(269015), // Rule ID 7696 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2i32] } 3276:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$old, v2i32:{ *:[v2i32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2i32] } VReg_64_Align2:{ *:[v2i32] }:$old, VReg_64_Align2:{ *:[v2i32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7696,
        GIR_EraseRootFromParent_Done,
      // Label 4344: @269015
      GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(269085), // Rule ID 7697 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2f32] } 3276:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$old, v2f32:{ *:[v2f32] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v2f32] } VReg_64_Align2:{ *:[v2f32] }:$old, VReg_64_Align2:{ *:[v2f32] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7697,
        GIR_EraseRootFromParent_Done,
      // Label 4345: @269085
      GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(269155), // Rule ID 7698 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p0s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i64] } 3276:{ *:[iPTR] }, p0:{ *:[i64] }:$old, p0:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7698,
        GIR_EraseRootFromParent_Done,
      // Label 4346: @269155
      GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(269225), // Rule ID 7699 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p1s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p1s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p1s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i64] } 3276:{ *:[iPTR] }, p1:{ *:[i64] }:$old, p1:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7699,
        GIR_EraseRootFromParent_Done,
      // Label 4347: @269225
      GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(269295), // Rule ID 7700 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p4s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p4s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i64] } 3276:{ *:[iPTR] }, p4:{ *:[i64] }:$old, p4:{ *:[i64] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[i64] } VReg_64_Align2:{ *:[i64] }:$old, VReg_64_Align2:{ *:[i64] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7700,
        GIR_EraseRootFromParent_Done,
      // Label 4348: @269295
      GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(269365), // Rule ID 7701 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4i16] } 3276:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$old, v4i16:{ *:[v4i16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4i16] } VReg_64_Align2:{ *:[v4i16] }:$old, VReg_64_Align2:{ *:[v4i16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7701,
        GIR_EraseRootFromParent_Done,
      // Label 4349: @269365
      GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(269435), // Rule ID 7702 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f16] } 3276:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$old, v4f16:{ *:[v4f16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4f16] } VReg_64_Align2:{ *:[v4f16] }:$old, VReg_64_Align2:{ *:[v4f16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7702,
        GIR_EraseRootFromParent_Done,
      // Label 4350: @269435
      GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(269505), // Rule ID 7703 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_update_dpp),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] dpp_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/4,
        // MIs[0] row_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] bank_mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bound_ctrl
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4bf16] } 3276:{ *:[iPTR] }, v4bf16:{ *:[v4bf16] }:$old, v4bf16:{ *:[v4bf16] }:$src, (timm:{ *:[i32] }):$dpp_ctrl, (timm:{ *:[i32] }):$row_mask, (timm:{ *:[i32] }):$bank_mask, (timm:{ *:[i1] }):$bound_ctrl)  =>  (V_MOV_B64_DPP_PSEUDO:{ *:[v4bf16] } VReg_64_Align2:{ *:[v4bf16] }:$old, VReg_64_Align2:{ *:[v4bf16] }:$src, (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$dpp_ctrl), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$row_mask), (as_i32timm:{ *:[i32] } ?:{ *:[i32] }:$bank_mask), (as_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bound_ctrl))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_DPP_PSEUDO),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // old
        GIR_RootToRootCopy, /*OpIdx*/3, // src
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/4, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // dpp_ctrl
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/5, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // row_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bank_mask
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // bound_ctrl
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7703,
        GIR_EraseRootFromParent_Done,
      // Label 4351: @269505
      GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(269576), // Rule ID 2563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3044:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2563,
        GIR_EraseRootFromParent_Done,
      // Label 4352: @269576
      GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(269647), // Rule ID 2564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3049:{ *:[iPTR] }, i32:{ *:[i32] }:$vdst_in, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2564,
        GIR_EraseRootFromParent_Done,
      // Label 4353: @269647
      GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(269718), // Rule ID 2565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[f32] } 3044:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2565,
        GIR_EraseRootFromParent_Done,
      // Label 4354: @269718
      GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(269789), // Rule ID 2566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[f32] } 3049:{ *:[iPTR] }, f32:{ *:[f32] }:$vdst_in, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[f32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[f32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[f32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2566,
        GIR_EraseRootFromParent_Done,
      // Label 4355: @269789
      GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(269860), // Rule ID 2567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3044:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2567,
        GIR_EraseRootFromParent_Done,
      // Label 4356: @269860
      GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(269931), // Rule ID 2568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2i16] } 3049:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$vdst_in, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2i16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2i16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2i16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2568,
        GIR_EraseRootFromParent_Done,
      // Label 4357: @269931
      GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(270002), // Rule ID 2569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3044:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2569,
        GIR_EraseRootFromParent_Done,
      // Label 4358: @270002
      GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(270073), // Rule ID 2570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2f16] } 3049:{ *:[iPTR] }, v2f16:{ *:[v2f16] }:$vdst_in, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2f16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2f16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2f16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2570,
        GIR_EraseRootFromParent_Done,
      // Label 4359: @270073
      GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(270144), // Rule ID 2571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3044:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$vdst_in, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[v2bf16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2bf16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2bf16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2571,
        GIR_EraseRootFromParent_Done,
      // Label 4360: @270144
      GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(270215), // Rule ID 2572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v2bf16] } 3049:{ *:[iPTR] }, v2bf16:{ *:[v2bf16] }:$vdst_in, v2bf16:{ *:[v2bf16] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[v2bf16] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[v2bf16] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[v2bf16] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2572,
        GIR_EraseRootFromParent_Done,
      // Label 4361: @270215
      GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(270286), // Rule ID 2573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3044:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2573,
        GIR_EraseRootFromParent_Done,
      // Label 4362: @270286
      GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(270357), // Rule ID 2574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3049:{ *:[iPTR] }, p2:{ *:[i32] }:$vdst_in, p2:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2574,
        GIR_EraseRootFromParent_Done,
      // Label 4363: @270357
      GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(270428), // Rule ID 2575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3044:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2575,
        GIR_EraseRootFromParent_Done,
      // Label 4364: @270428
      GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(270499), // Rule ID 2576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p3s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3049:{ *:[iPTR] }, p3:{ *:[i32] }:$vdst_in, p3:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2576,
        GIR_EraseRootFromParent_Done,
      // Label 4365: @270499
      GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(270570), // Rule ID 2577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3044:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2577,
        GIR_EraseRootFromParent_Done,
      // Label 4366: @270570
      GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(270641), // Rule ID 2578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p5s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3049:{ *:[iPTR] }, p5:{ *:[i32] }:$vdst_in, p5:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2578,
        GIR_EraseRootFromParent_Done,
      // Label 4367: @270641
      GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(270712), // Rule ID 2579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlane16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3044:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANE16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANE16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2579,
        GIR_EraseRootFromParent_Done,
      // Label 4368: @270712
      GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(270783), // Rule ID 2580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX10Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_permlanex16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // MIs[0] fi
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] bc
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[i32] } 3049:{ *:[iPTR] }, p6:{ *:[i32] }:$vdst_in, p6:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2, (timm:{ *:[i1] }):$fi, (timm:{ *:[i1] }):$bc)  =>  (V_PERMLANEX16_B32_e64:{ *:[i32] } (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$fi), VGPR_32:{ *:[i32] }:$src0, (opsel_i1timm:{ *:[i32] } ?:{ *:[i1] }:$bc), SCSrc_b32:{ *:[i32] }:$src1, 0:{ *:[i32] }, SCSrc_b32:{ *:[i32] }:$src2, VGPR_32:{ *:[i32] }:$vdst_in)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERMLANEX16_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // fi
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderOpSelTImm), // bc
        GIR_RootToRootCopy, /*OpIdx*/4, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // src2
        GIR_RootToRootCopy, /*OpIdx*/2, // vdst_in
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2580,
        GIR_EraseRootFromParent_Done,
      // Label 4369: @270783
      GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(270844), // Rule ID 1119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22537),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3017:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22537>>  =>  (V_MFMA_F32_4X4X1F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1119,
        GIR_EraseRootFromParent_Done,
      // Label 4370: @270844
      GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(270905), // Rule ID 1120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22539),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3017:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22539>>  =>  (V_MFMA_F32_4X4X1F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X1F32_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1120,
        GIR_EraseRootFromParent_Done,
      // Label 4371: @270905
      GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(270966), // Rule ID 1121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22543),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2989:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22543>>  =>  (V_MFMA_F32_16X16X1F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1121,
        GIR_EraseRootFromParent_Done,
      // Label 4372: @270966
      GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(271027), // Rule ID 1122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22545),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2989:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22545>>  =>  (V_MFMA_F32_16X16X1F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X1F32_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1122,
        GIR_EraseRootFromParent_Done,
      // Label 4373: @271027
      GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(271088), // Rule ID 1123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22547),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2999:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22547>>  =>  (V_MFMA_F32_16X16X4F32_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1123,
        GIR_EraseRootFromParent_Done,
      // Label 4374: @271088
      GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(271149), // Rule ID 1124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22549),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2999:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22549>>  =>  (V_MFMA_F32_16X16X4F32_vgprcd_e64:{ *:[v4f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F32_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1124,
        GIR_EraseRootFromParent_Done,
      // Label 4375: @271149
      GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(271210), // Rule ID 1125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22553),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3008:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22553>>  =>  (V_MFMA_F32_32X32X1F32_mac_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1125,
        GIR_EraseRootFromParent_Done,
      // Label 4376: @271210
      GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(271271), // Rule ID 1126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x1f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22555),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3008:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22555>>  =>  (V_MFMA_F32_32X32X1F32_mac_vgprcd_e64:{ *:[v32f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X1F32_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1126,
        GIR_EraseRootFromParent_Done,
      // Label 4377: @271271
      GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(271332), // Rule ID 1127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22557),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3010:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22557>>  =>  (V_MFMA_F32_32X32X2F32_mac_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1127,
        GIR_EraseRootFromParent_Done,
      // Label 4378: @271332
      GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(271393), // Rule ID 1128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2f32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22559),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3010:{ *:[iPTR] }, f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22559>>  =>  (V_MFMA_F32_32X32X2F32_mac_vgprcd_e64:{ *:[v16f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2F32_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1128,
        GIR_EraseRootFromParent_Done,
      // Label 4379: @271393
      GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(271454), // Rule ID 1129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22561),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22561>>  =>  (V_MFMA_F32_4X4X4F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1129,
        GIR_EraseRootFromParent_Done,
      // Label 4380: @271454
      GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(271515), // Rule ID 1130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22563),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3020:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22563>>  =>  (V_MFMA_F32_4X4X4F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4F16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1130,
        GIR_EraseRootFromParent_Done,
      // Label 4381: @271515
      GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(271576), // Rule ID 1131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22565),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3031:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22565>>  =>  (V_MFMA_I32_4X4X4I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1131,
        GIR_EraseRootFromParent_Done,
      // Label 4382: @271576
      GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(271637), // Rule ID 1132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_4x4x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22567),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3031:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22567>>  =>  (V_MFMA_I32_4X4X4I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_4X4X4I8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1132,
        GIR_EraseRootFromParent_Done,
      // Label 4383: @271637
      GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(271698), // Rule ID 1133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22571),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2998:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22571>>  =>  (V_MFMA_F32_16X16X4F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1133,
        GIR_EraseRootFromParent_Done,
      // Label 4384: @271698
      GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(271759), // Rule ID 1134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22573),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2998:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22573>>  =>  (V_MFMA_F32_16X16X4F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4F16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1134,
        GIR_EraseRootFromParent_Done,
      // Label 4385: @271759
      GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(271820), // Rule ID 1135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22575),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2988:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22575>>  =>  (V_MFMA_F32_16X16X16F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1135,
        GIR_EraseRootFromParent_Done,
      // Label 4386: @271820
      GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(271881), // Rule ID 1136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22577),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2988:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22577>>  =>  (V_MFMA_F32_16X16X16F16_vgprcd_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16F16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1136,
        GIR_EraseRootFromParent_Done,
      // Label 4387: @271881
      GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(271942), // Rule ID 1137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22581),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3025:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22581>>  =>  (V_MFMA_I32_16X16X4I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1137,
        GIR_EraseRootFromParent_Done,
      // Label 4388: @271942
      GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(272003), // Rule ID 1138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22583),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3025:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22583>>  =>  (V_MFMA_I32_16X16X4I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X4I8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1138,
        GIR_EraseRootFromParent_Done,
      // Label 4389: @272003
      GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(272064), // Rule ID 1139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22587),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3014:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22587>>  =>  (V_MFMA_F32_32X32X4F16_mac_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1139,
        GIR_EraseRootFromParent_Done,
      // Label 4390: @272064
      GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(272125), // Rule ID 1140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22589),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3014:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22589>>  =>  (V_MFMA_F32_32X32X4F16_mac_vgprcd_e64:{ *:[v32f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4F16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1140,
        GIR_EraseRootFromParent_Done,
      // Label 4391: @272125
      GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(272186), // Rule ID 1141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22591),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3016:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22591>>  =>  (V_MFMA_F32_32X32X8F16_mac_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1141,
        GIR_EraseRootFromParent_Done,
      // Label 4392: @272186
      GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(272247), // Rule ID 1142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22593),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3016:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22593>>  =>  (V_MFMA_F32_32X32X8F16_mac_vgprcd_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v4f16:{ *:[v4f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8F16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1142,
        GIR_EraseRootFromParent_Done,
      // Label 4393: @272247
      GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(272308), // Rule ID 1143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22597),
        // (intrinsic_wo_chain:{ *:[v32i32] } 3029:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22597>>  =>  (V_MFMA_I32_32X32X4I8_mac_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1143,
        GIR_EraseRootFromParent_Done,
      // Label 4394: @272308
      GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(272369), // Rule ID 1144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMAIInsts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x4i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22599),
        // (intrinsic_wo_chain:{ *:[v32i32] } 3029:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22599>>  =>  (V_MFMA_I32_32X32X4I8_mac_vgprcd_e64:{ *:[v32i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v32i32:{ *:[v32i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X4I8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1144,
        GIR_EraseRootFromParent_Done,
      // Label 4395: @272369
      GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(272430), // Rule ID 1145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22601),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3023:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22601>>  =>  (V_MFMA_I32_16X16X16I8_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1145,
        GIR_EraseRootFromParent_Done,
      // Label 4396: @272430
      GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(272491), // Rule ID 1146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x16i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22603),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3023:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22603>>  =>  (V_MFMA_I32_16X16X16I8_vgprcd_e64:{ *:[v4i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X16I8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1146,
        GIR_EraseRootFromParent_Done,
      // Label 4397: @272491
      GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(272552), // Rule ID 1147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22605),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3030:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22605>>  =>  (V_MFMA_I32_32X32X8I8_mac_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1147,
        GIR_EraseRootFromParent_Done,
      // Label 4398: @272552
      GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(272613), // Rule ID 1148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x8i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22607),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3030:{ *:[iPTR] }, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22607>>  =>  (V_MFMA_I32_32X32X8I8_mac_vgprcd_e64:{ *:[v16i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X8I8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1148,
        GIR_EraseRootFromParent_Done,
      // Label 4399: @272613
      GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(272674), // Rule ID 1149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22609),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3018:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22609>>  =>  (V_MFMA_F32_4X4X2BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1149,
        GIR_EraseRootFromParent_Done,
      // Label 4400: @272674
      GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(272735), // Rule ID 1150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22611),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3018:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22611>>  =>  (V_MFMA_F32_4X4X2BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X2BF16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1150,
        GIR_EraseRootFromParent_Done,
      // Label 4401: @272735
      GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(272796), // Rule ID 1151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22615),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2990:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22615>>  =>  (V_MFMA_F32_16X16X2BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1151,
        GIR_EraseRootFromParent_Done,
      // Label 4402: @272796
      GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(272857), // Rule ID 1152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22617),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2990:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22617>>  =>  (V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X2BF16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1152,
        GIR_EraseRootFromParent_Done,
      // Label 4403: @272857
      GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(272918), // Rule ID 1153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22619),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3001:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22619>>  =>  (V_MFMA_F32_16X16X8BF16_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1153,
        GIR_EraseRootFromParent_Done,
      // Label 4404: @272918
      GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(272979), // Rule ID 1154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22621),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3001:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22621>>  =>  (V_MFMA_F32_16X16X8BF16_vgprcd_e64:{ *:[v4f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8BF16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1154,
        GIR_EraseRootFromParent_Done,
      // Label 4405: @272979
      GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(273040), // Rule ID 1155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22625),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3009:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22625>>  =>  (V_MFMA_F32_32X32X2BF16_mac_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1155,
        GIR_EraseRootFromParent_Done,
      // Label 4406: @273040
      GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(273101), // Rule ID 1156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x2bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22627),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3009:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22627>>  =>  (V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64:{ *:[v32f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X2BF16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1156,
        GIR_EraseRootFromParent_Done,
      // Label 4407: @273101
      GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(273162), // Rule ID 1157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22629),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3012:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22629>>  =>  (V_MFMA_F32_32X32X4BF16_mac_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1157,
        GIR_EraseRootFromParent_Done,
      // Label 4408: @273162
      GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(273223), // Rule ID 1158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX908orGFX90A),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22631),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3012:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22631>>  =>  (V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64:{ *:[v16f32] } v2i16:{ *:[v2i16] }:$src0, v2i16:{ *:[v2i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1158,
        GIR_EraseRootFromParent_Done,
      // Label 4409: @273223
      GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(273284), // Rule ID 1159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22633),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2994:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22633>>  =>  (V_MFMA_F32_16X16X32_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1159,
        GIR_EraseRootFromParent_Done,
      // Label 4410: @273284
      GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(273345), // Rule ID 1160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22635),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2994:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22635>>  =>  (V_MFMA_F32_16X16X32_F16_vgprcd_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_F16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1160,
        GIR_EraseRootFromParent_Done,
      // Label 4411: @273345
      GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(273406), // Rule ID 1161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22639),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3005:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22639>>  =>  (V_MFMA_F32_32X32X16_F16_mac_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1161,
        GIR_EraseRootFromParent_Done,
      // Label 4412: @273406
      GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(273467), // Rule ID 1162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22641),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3005:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22641>>  =>  (V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_F16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1162,
        GIR_EraseRootFromParent_Done,
      // Label 4413: @273467
      GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(273528), // Rule ID 1163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22643),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2991:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22643>>  =>  (V_MFMA_F32_16X16X32_BF16_e64:{ *:[v4f32] } v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1163,
        GIR_EraseRootFromParent_Done,
      // Label 4414: @273528
      GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(273589), // Rule ID 1164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22645),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2991:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22645>>  =>  (V_MFMA_F32_16X16X32_BF16_vgprcd_e64:{ *:[v4f32] } v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF16_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1164,
        GIR_EraseRootFromParent_Done,
      // Label 4415: @273589
      GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(273650), // Rule ID 1165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22647),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3026:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22647>>  =>  (V_MFMA_I32_16X16X64_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1165,
        GIR_EraseRootFromParent_Done,
      // Label 4416: @273650
      GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(273711), // Rule ID 1166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x64_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22649),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3026:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22649>>  =>  (V_MFMA_I32_16X16X64_I8_vgprcd_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X64_I8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1166,
        GIR_EraseRootFromParent_Done,
      // Label 4417: @273711
      GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(273772), // Rule ID 1167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22653),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3002:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22653>>  =>  (V_MFMA_F32_32X32X16_BF16_mac_e64:{ *:[v16f32] } v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF16_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1167,
        GIR_EraseRootFromParent_Done,
      // Label 4418: @273772
      GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(273833), // Rule ID 1168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22655),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3002:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22655>>  =>  (V_MFMA_F32_32X32X16_BF16_mac_vgprcd_e64:{ *:[v16f32] } v8bf16:{ *:[v8bf16] }:$src0, v8bf16:{ *:[v8bf16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF16_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1168,
        GIR_EraseRootFromParent_Done,
      // Label 4419: @273833
      GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(273894), // Rule ID 1169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22659),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3028:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22659>>  =>  (V_MFMA_I32_32X32X32_I8_mac_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1169,
        GIR_EraseRootFromParent_Done,
      // Label 4420: @273894
      GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(273955), // Rule ID 1170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x32_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22661),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3028:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22661>>  =>  (V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X32_I8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1170,
        GIR_EraseRootFromParent_Done,
      // Label 4421: @273955
      GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(274016), // Rule ID 1243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22783),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3013:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22783>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1243,
        GIR_EraseRootFromParent_Done,
      // Label 4422: @274016
      GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(274077), // Rule ID 1244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v32s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_1024RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22785),
        // (intrinsic_wo_chain:{ *:[v32f32] } 3013:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22785>>  =>  (V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64:{ *:[v32f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v32f32:{ *:[v32f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4BF16_1K_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1244,
        GIR_EraseRootFromParent_Done,
      // Label 4423: @274077
      GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(274138), // Rule ID 1245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22789),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2997:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22789>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1245,
        GIR_EraseRootFromParent_Done,
      // Label 4424: @274138
      GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(274199), // Rule ID 1246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22791),
        // (intrinsic_wo_chain:{ *:[v16f32] } 2997:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22791>>  =>  (V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X4BF16_1K_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1246,
        GIR_EraseRootFromParent_Done,
      // Label 4425: @274199
      GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(274260), // Rule ID 1247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22793),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3019:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22793>>  =>  (V_MFMA_F32_4X4X4BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1247,
        GIR_EraseRootFromParent_Done,
      // Label 4426: @274260
      GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(274321), // Rule ID 1248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_4x4x4bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22795),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3019:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22795>>  =>  (V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_4X4X4BF16_1K_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1248,
        GIR_EraseRootFromParent_Done,
      // Label 4427: @274321
      GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(274382), // Rule ID 1249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22797),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3015:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22797>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1249,
        GIR_EraseRootFromParent_Done,
      // Label 4428: @274382
      GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(274443), // Rule ID 1250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x8bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22799),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3015:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22799>>  =>  (V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X8BF16_1K_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1250,
        GIR_EraseRootFromParent_Done,
      // Label 4429: @274443
      GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(274504), // Rule ID 1251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22801),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2987:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22801>>  =>  (V_MFMA_F32_16X16X16BF16_1K_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1251,
        GIR_EraseRootFromParent_Done,
      // Label 4430: @274504
      GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(274565), // Rule ID 1252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x16bf16_1k),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22803),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2987:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22803>>  =>  (V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v4i16:{ *:[v4i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X16BF16_1K_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1252,
        GIR_EraseRootFromParent_Done,
      // Label 4431: @274565
      GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(274626), // Rule ID 1253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_256RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22807),
        // (intrinsic_wo_chain:{ *:[v4f64] } 3021:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22807>>  =>  (V_MFMA_F64_16X16X4F64_mac_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1253,
        GIR_EraseRootFromParent_Done,
      // Label 4432: @274626
      GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(274687), // Rule ID 1254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_16x16x4f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22809),
        // (intrinsic_wo_chain:{ *:[v4f64] } 3021:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22809>>  =>  (V_MFMA_F64_16X16X4F64_mac_vgprcd_e64:{ *:[v4f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, v4f64:{ *:[v4f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_16X16X4F64_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1254,
        GIR_EraseRootFromParent_Done,
      // Label 4433: @274687
      GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(274748), // Rule ID 1255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_64RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22811),
        // (intrinsic_wo_chain:{ *:[f64] } 3022:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22811>>  =>  (V_MFMA_F64_4X4X4F64_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1255,
        GIR_EraseRootFromParent_Done,
      // Label 4434: @274748
      GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(274809), // Rule ID 1256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f64_4x4x4f64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22813),
        // (intrinsic_wo_chain:{ *:[f64] } 3022:{ *:[iPTR] }, f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22813>>  =>  (V_MFMA_F64_4X4X4F64_vgprcd_e64:{ *:[f64] } f64:{ *:[f64] }:$src0, f64:{ *:[f64] }:$src1, f64:{ *:[f64] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F64_4X4X4F64_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1256,
        GIR_EraseRootFromParent_Done,
      // Label 4435: @274809
      GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(274870), // Rule ID 1257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22817),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3027:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22817>>  =>  (V_MFMA_I32_32X32X16I8_mac_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1257,
        GIR_EraseRootFromParent_Done,
      // Label 4436: @274870
      GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(274931), // Rule ID 1258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_32x32x16_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22819),
        // (intrinsic_wo_chain:{ *:[v16i32] } 3027:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22819>>  =>  (V_MFMA_I32_32X32X16I8_mac_vgprcd_e64:{ *:[v16i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16i32:{ *:[v16i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_32X32X16I8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1258,
        GIR_EraseRootFromParent_Done,
      // Label 4437: @274931
      GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(274992), // Rule ID 1259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22821),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3024:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22821>>  =>  (V_MFMA_I32_16X16X32I8_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1259,
        GIR_EraseRootFromParent_Done,
      // Label 4438: @274992
      GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(275053), // Rule ID 1260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX90APlus_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_i32_16x16x32_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22823),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3024:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22823>>  =>  (V_MFMA_I32_16X16X32I8_vgprcd_e64:{ *:[v4i32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4i32:{ *:[v4i32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_I32_16X16X32I8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1260,
        GIR_EraseRootFromParent_Done,
      // Label 4439: @275053
      GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(275114), // Rule ID 1261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22825),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3000:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22825>>  =>  (V_MFMA_F32_16X16X8XF32_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1261,
        GIR_EraseRootFromParent_Done,
      // Label 4440: @275114
      GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(275175), // Rule ID 1262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x8_xf32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22827),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3000:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22827>>  =>  (V_MFMA_F32_16X16X8XF32_vgprcd_e64:{ *:[v4f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X8XF32_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1262,
        GIR_EraseRootFromParent_Done,
      // Label 4441: @275175
      GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(275236), // Rule ID 1263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22831),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3011:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22831>>  =>  (V_MFMA_F32_32X32X4XF32_mac_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1263,
        GIR_EraseRootFromParent_Done,
      // Label 4442: @275236
      GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(275297), // Rule ID 1264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXF32Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x4_xf32),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22833),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3011:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22833>>  =>  (V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64:{ *:[v16f32] } v2f32:{ *:[v2f32] }:$src0, v2f32:{ *:[v2f32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X4XF32_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1264,
        GIR_EraseRootFromParent_Done,
      // Label 4443: @275297
      GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(275358), // Rule ID 1265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22835),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2992:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22835>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1265,
        GIR_EraseRootFromParent_Done,
      // Label 4444: @275358
      GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(275419), // Rule ID 1266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22837),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2992:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22837>>  =>  (V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_BF8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1266,
        GIR_EraseRootFromParent_Done,
      // Label 4445: @275419
      GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(275480), // Rule ID 1267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22839),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2993:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22839>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1267,
        GIR_EraseRootFromParent_Done,
      // Label 4446: @275480
      GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(275541), // Rule ID 1268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22841),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2993:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22841>>  =>  (V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_BF8_FP8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1268,
        GIR_EraseRootFromParent_Done,
      // Label 4447: @275541
      GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(275602), // Rule ID 1269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22843),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2995:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22843>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1269,
        GIR_EraseRootFromParent_Done,
      // Label 4448: @275602
      GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(275663), // Rule ID 1270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22845),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2995:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22845>>  =>  (V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_BF8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1270,
        GIR_EraseRootFromParent_Done,
      // Label 4449: @275663
      GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(275724), // Rule ID 1271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22847),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2996:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22847>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1271,
        GIR_EraseRootFromParent_Done,
      // Label 4450: @275724
      GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(275785), // Rule ID 1272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_16x16x32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22849),
        // (intrinsic_wo_chain:{ *:[v4f32] } 2996:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22849>>  =>  (V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64:{ *:[v4f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X32_FP8_FP8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1272,
        GIR_EraseRootFromParent_Done,
      // Label 4451: @275785
      GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(275846), // Rule ID 1273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22853),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3003:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22853>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1273,
        GIR_EraseRootFromParent_Done,
      // Label 4452: @275846
      GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(275907), // Rule ID 1274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22855),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3003:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22855>>  =>  (V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_BF8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1274,
        GIR_EraseRootFromParent_Done,
      // Label 4453: @275907
      GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(275968), // Rule ID 1275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22857),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3004:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22857>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1275,
        GIR_EraseRootFromParent_Done,
      // Label 4454: @275968
      GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(276029), // Rule ID 1276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22859),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3004:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22859>>  =>  (V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_BF8_FP8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1276,
        GIR_EraseRootFromParent_Done,
      // Label 4455: @276029
      GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(276090), // Rule ID 1277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22861),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3006:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22861>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1277,
        GIR_EraseRootFromParent_Done,
      // Label 4456: @276090
      GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(276151), // Rule ID 1278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22863),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3006:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22863>>  =>  (V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_BF8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1278,
        GIR_EraseRootFromParent_Done,
      // Label 4457: @276151
      GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(276212), // Rule ID 1279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22865),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3007:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22865>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1279,
        GIR_EraseRootFromParent_Done,
      // Label 4458: @276212
      GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(276273), // Rule ID 1280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_f32_32x32x16_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22867),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3007:{ *:[iPTR] }, i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)<<P:Predicate_anonymous_22867>>  =>  (V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64:{ *:[v16f32] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X16_FP8_FP8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // abid
        GIR_RootToRootCopy, /*OpIdx*/7, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1280,
        GIR_EraseRootFromParent_Done,
      // Label 4459: @276273
      GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(276330), // Rule ID 1281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3180:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_F16_e64:{ *:[v4f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1281,
        GIR_EraseRootFromParent_Done,
      // Label 4460: @276330
      GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(276387), // Rule ID 1282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3188:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_F16_e64:{ *:[v16f32] } v4f16:{ *:[v4f16] }:$src0, v8f16:{ *:[v8f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1282,
        GIR_EraseRootFromParent_Done,
      // Label 4461: @276387
      GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(276444), // Rule ID 1283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3179:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X32_BF16_e64:{ *:[v4f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X32_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1283,
        GIR_EraseRootFromParent_Done,
      // Label 4462: @276444
      GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(276501), // Rule ID 1284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x16_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3187:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X16_BF16_e64:{ *:[v16f32] } v4i16:{ *:[v4i16] }:$src0, v8i16:{ *:[v8i16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X16_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1284,
        GIR_EraseRootFromParent_Done,
      // Label 4463: @276501
      GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(276558), // Rule ID 1285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x64_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4i32] } 3200:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X64_I8_e64:{ *:[v4i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X64_I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1285,
        GIR_EraseRootFromParent_Done,
      // Label 4464: @276558
      GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(276615), // Rule ID 1286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX940Plus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x32_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16i32] } 3201:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X32_I8_e64:{ *:[v16i32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X32_I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1286,
        GIR_EraseRootFromParent_Done,
      // Label 4465: @276615
      GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(276672), // Rule ID 1287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3182:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1287,
        GIR_EraseRootFromParent_Done,
      // Label 4466: @276672
      GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(276729), // Rule ID 1288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3183:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1288,
        GIR_EraseRootFromParent_Done,
      // Label 4467: @276729
      GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(276786), // Rule ID 1289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3185:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_BF8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1289,
        GIR_EraseRootFromParent_Done,
      // Label 4468: @276786
      GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(276843), // Rule ID 1290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3186:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_FP8_FP8_e64:{ *:[v4f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_FP8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1290,
        GIR_EraseRootFromParent_Done,
      // Label 4469: @276843
      GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(276900), // Rule ID 1291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3190:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1291,
        GIR_EraseRootFromParent_Done,
      // Label 4470: @276900
      GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(276957), // Rule ID 1292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3191:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1292,
        GIR_EraseRootFromParent_Done,
      // Label 4471: @276957
      GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(277014), // Rule ID 1293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3193:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_BF8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1293,
        GIR_EraseRootFromParent_Done,
      // Label 4472: @277014
      GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(277071), // Rule ID 1294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3194:{ *:[iPTR] }, v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_FP8_FP8_e64:{ *:[v16f32] } v2i32:{ *:[v2i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_FP8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1294,
        GIR_EraseRootFromParent_Done,
      // Label 4473: @277071
      GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(277128), // Rule ID 1295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3184:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_F16_e64:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1295,
        GIR_EraseRootFromParent_Done,
      // Label 4474: @277128
      GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(277185), // Rule ID 1296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_f16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3192:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_F16_e64:{ *:[v16f32] } v8f16:{ *:[v8f16] }:$src0, v16f16:{ *:[v16f16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1296,
        GIR_EraseRootFromParent_Done,
      // Label 4475: @277185
      GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(277242), // Rule ID 1297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x64_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3181:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v16bf16:{ *:[v16bf16] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X64_BF16_e64:{ *:[v4f32] } v8bf16:{ *:[v8bf16] }:$src0, v16bf16:{ *:[v16bf16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X64_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1297,
        GIR_EraseRootFromParent_Done,
      // Label 4476: @277242
      GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(277299), // Rule ID 1298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x32_bf16),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3189:{ *:[iPTR] }, v8bf16:{ *:[v8bf16] }:$src0, v16bf16:{ *:[v16bf16] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X32_BF16_e64:{ *:[v16f32] } v8bf16:{ *:[v8bf16] }:$src0, v16bf16:{ *:[v16bf16] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X32_BF16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1298,
        GIR_EraseRootFromParent_Done,
      // Label 4477: @277299
      GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(277356), // Rule ID 1299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_16x16x128_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4i32] } 3199:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4i32:{ *:[v4i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_16X16X128_I8_e64:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4i32:{ *:[v4i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_16X16X128_I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1299,
        GIR_EraseRootFromParent_Done,
      // Label 4478: @277356
      GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(277413), // Rule ID 1300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_i32_32x32x64_i8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16i32] } 3202:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16i32:{ *:[v16i32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_I32_32X32X64_I8_e64:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16i32:{ *:[v16i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_I32_32X32X64_I8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1300,
        GIR_EraseRootFromParent_Done,
      // Label 4479: @277413
      GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(277470), // Rule ID 1301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3175:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1301,
        GIR_EraseRootFromParent_Done,
      // Label 4480: @277470
      GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(277527), // Rule ID 1302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3176:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_BF8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_BF8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1302,
        GIR_EraseRootFromParent_Done,
      // Label 4481: @277527
      GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(277584), // Rule ID 1303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3177:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_BF8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1303,
        GIR_EraseRootFromParent_Done,
      // Label 4482: @277584
      GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(277641), // Rule ID 1304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_16x16x128_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v4f32] } 3178:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_16X16X128_FP8_FP8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v4f32:{ *:[v4f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_16X16X128_FP8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1304,
        GIR_EraseRootFromParent_Done,
      // Label 4483: @277641
      GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(277698), // Rule ID 1305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3195:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1305,
        GIR_EraseRootFromParent_Done,
      // Label 4484: @277698
      GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(277755), // Rule ID 1306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_bf8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3196:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_BF8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_BF8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1306,
        GIR_EraseRootFromParent_Done,
      // Label 4485: @277755
      GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(277812), // Rule ID 1307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_bf8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3197:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_BF8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_BF8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1307,
        GIR_EraseRootFromParent_Done,
      // Label 4486: @277812
      GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(277869), // Rule ID 1308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_smfmac_f32_32x32x64_fp8_fp8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] abid
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // (intrinsic_wo_chain:{ *:[v16f32] } 3198:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid)  =>  (V_SMFMAC_F32_32X32X64_FP8_FP8_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, i32:{ *:[i32] }:$idx, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$abid, v16f32:{ *:[v16f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SMFMAC_F32_32X32X64_FP8_FP8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/5, // idx
        GIR_RootToRootCopy, /*OpIdx*/6, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/7, // abid
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1308,
        GIR_EraseRootFromParent_Done,
      // Label 4487: @277869
      GIM_Reject,
    // Label 4316: @277870
    GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(278410),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
      GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(277969), // Rule ID 2751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3268:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2751,
        GIR_EraseRootFromParent_Done,
      // Label 4489: @277969
      GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(278060), // Rule ID 2752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3267:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2752,
        GIR_EraseRootFromParent_Done,
      // Label 4490: @278060
      GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(278151), // Rule ID 2784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu8),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex8),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3268:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex8:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_8bit, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU8_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_8bit
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2784,
        GIR_EraseRootFromParent_Done,
      // Label 4491: @278151
      GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(278242), // Rule ID 2785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x32_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3267:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X32_IU4_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2785,
        GIR_EraseRootFromParent_Done,
      // Label 4492: @278242
      GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(278333), // Rule ID 2786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_swmmacindex16),
        // (intrinsic_wo_chain:{ *:[v4i32] } 3269:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), i32:{ *:[i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, (SWMMACIndex16:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit), i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr:{ *:[v4i32] } i32:{ *:[i32] }:$src0_modifiers, i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i32:{ *:[v2i32] }:$src1, v4i32:{ *:[v4i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$index_key_16bit, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w64_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // index_key_16bit
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2786,
        GIR_EraseRootFromParent_Done,
      // Label 4493: @278333
      GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(278409), // Rule ID 2753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_swmmac_i32_16x16x64_iu4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
        GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_256RegClassID),
        // MIs[0] clamp
        // No operand predicates
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmodsneg),
        // (intrinsic_wo_chain:{ *:[v8i32] } 3269:{ *:[iPTR] }, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers), v2i32:{ *:[v2i32] }:$src0, (VOP3PModsNeg:{ *:[i1] } i32:{ *:[i32] }:$src1_modifiers), v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)  =>  (V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr:{ *:[v8i32] } i32:{ *:[i32] }:$src0_modifiers, v2i32:{ *:[v2i32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v4i32:{ *:[v4i32] }:$src1, v8i32:{ *:[v8i32] }:$srcTiedDef, i32:{ *:[i32] }:$src2, i1:{ *:[i1] }:$clamp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SWMMAC_I32_16X16X64_IU4_w32_twoaddr),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0_modifiers
        GIR_RootToRootCopy, /*OpIdx*/3, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1_modifiers
        GIR_RootToRootCopy, /*OpIdx*/5, // src1
        GIR_RootToRootCopy, /*OpIdx*/6, // srcTiedDef
        GIR_RootToRootCopy, /*OpIdx*/7, // src2
        GIR_RootToRootCopy, /*OpIdx*/8, // clamp
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2753,
        GIR_EraseRootFromParent_Done,
      // Label 4494: @278409
      GIM_Reject,
    // Label 4488: @278410
    GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(284323),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/11,
      GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(278488), // Rule ID 1171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1171,
        GIR_EraseRootFromParent_Done,
      // Label 4496: @278488
      GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(278558), // Rule ID 1172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1172,
        GIR_EraseRootFromParent_Done,
      // Label 4497: @278558
      GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(278628), // Rule ID 1173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1173,
        GIR_EraseRootFromParent_Done,
      // Label 4498: @278628
      GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(278698), // Rule ID 1174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1174,
        GIR_EraseRootFromParent_Done,
      // Label 4499: @278698
      GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(278768), // Rule ID 1175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1175,
        GIR_EraseRootFromParent_Done,
      // Label 4500: @278768
      GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(278838), // Rule ID 1176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1176,
        GIR_EraseRootFromParent_Done,
      // Label 4501: @278838
      GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(278908), // Rule ID 1177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1177,
        GIR_EraseRootFromParent_Done,
      // Label 4502: @278908
      GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(278978), // Rule ID 1178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1178,
        GIR_EraseRootFromParent_Done,
      // Label 4503: @278978
      GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(279048), // Rule ID 1179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1179,
        GIR_EraseRootFromParent_Done,
      // Label 4504: @279048
      GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(279118), // Rule ID 1180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1180,
        GIR_EraseRootFromParent_Done,
      // Label 4505: @279118
      GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(279188), // Rule ID 1181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1181,
        GIR_EraseRootFromParent_Done,
      // Label 4506: @279188
      GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(279258), // Rule ID 1182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1182,
        GIR_EraseRootFromParent_Done,
      // Label 4507: @279258
      GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(279328), // Rule ID 1183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1183,
        GIR_EraseRootFromParent_Done,
      // Label 4508: @279328
      GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(279398), // Rule ID 1184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1184,
        GIR_EraseRootFromParent_Done,
      // Label 4509: @279398
      GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(279468), // Rule ID 1185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1185,
        GIR_EraseRootFromParent_Done,
      // Label 4510: @279468
      GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(279538), // Rule ID 1186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1186,
        GIR_EraseRootFromParent_Done,
      // Label 4511: @279538
      GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(279608), // Rule ID 1187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22663),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22663>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1187,
        GIR_EraseRootFromParent_Done,
      // Label 4512: @279608
      GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(279678), // Rule ID 1188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22665),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22665>>  =>  (V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1188,
        GIR_EraseRootFromParent_Done,
      // Label 4513: @279678
      GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(279748), // Rule ID 1189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1189,
        GIR_EraseRootFromParent_Done,
      // Label 4514: @279748
      GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(279818), // Rule ID 1190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1190,
        GIR_EraseRootFromParent_Done,
      // Label 4515: @279818
      GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(279888), // Rule ID 1191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1191,
        GIR_EraseRootFromParent_Done,
      // Label 4516: @279888
      GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(279958), // Rule ID 1192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1192,
        GIR_EraseRootFromParent_Done,
      // Label 4517: @279958
      GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(280028), // Rule ID 1193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1193,
        GIR_EraseRootFromParent_Done,
      // Label 4518: @280028
      GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(280098), // Rule ID 1194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1194,
        GIR_EraseRootFromParent_Done,
      // Label 4519: @280098
      GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(280168), // Rule ID 1195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1195,
        GIR_EraseRootFromParent_Done,
      // Label 4520: @280168
      GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(280238), // Rule ID 1196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1196,
        GIR_EraseRootFromParent_Done,
      // Label 4521: @280238
      GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(280308), // Rule ID 1197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1197,
        GIR_EraseRootFromParent_Done,
      // Label 4522: @280308
      GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(280378), // Rule ID 1198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1198,
        GIR_EraseRootFromParent_Done,
      // Label 4523: @280378
      GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(280448), // Rule ID 1199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1199,
        GIR_EraseRootFromParent_Done,
      // Label 4524: @280448
      GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(280518), // Rule ID 1200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1200,
        GIR_EraseRootFromParent_Done,
      // Label 4525: @280518
      GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(280588), // Rule ID 1201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1201,
        GIR_EraseRootFromParent_Done,
      // Label 4526: @280588
      GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(280658), // Rule ID 1202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1202,
        GIR_EraseRootFromParent_Done,
      // Label 4527: @280658
      GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(280728), // Rule ID 1203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1203,
        GIR_EraseRootFromParent_Done,
      // Label 4528: @280728
      GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(280798), // Rule ID 1204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1204,
        GIR_EraseRootFromParent_Done,
      // Label 4529: @280798
      GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(280868), // Rule ID 1205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22685),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22685>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1205,
        GIR_EraseRootFromParent_Done,
      // Label 4530: @280868
      GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(280938), // Rule ID 1206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts_isGFX90APlus),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
        // MIs[0] Operand 9
        // No operand predicates
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/10, 0,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22687),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, srcvalue:{ *:[i32] }, 0:{ *:[i32] }, srcvalue:{ *:[i32] }, 0:{ *:[i32] })<<P:Predicate_anonymous_22687>>  =>  (V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1206,
        GIR_EraseRootFromParent_Done,
      // Label 4531: @280938
      GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(281032), // Rule ID 1207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1207,
        GIR_EraseRootFromParent_Done,
      // Label 4532: @281032
      GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(281126), // Rule ID 1208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1208,
        GIR_EraseRootFromParent_Done,
      // Label 4533: @281126
      GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(281220), // Rule ID 1209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1209,
        GIR_EraseRootFromParent_Done,
      // Label 4534: @281220
      GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(281314), // Rule ID 1210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1210,
        GIR_EraseRootFromParent_Done,
      // Label 4535: @281314
      GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(281408), // Rule ID 1211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1211,
        GIR_EraseRootFromParent_Done,
      // Label 4536: @281408
      GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(281502), // Rule ID 1212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1212,
        GIR_EraseRootFromParent_Done,
      // Label 4537: @281502
      GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(281596), // Rule ID 1213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1213,
        GIR_EraseRootFromParent_Done,
      // Label 4538: @281596
      GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(281690), // Rule ID 1214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1214,
        GIR_EraseRootFromParent_Done,
      // Label 4539: @281690
      GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(281784), // Rule ID 1215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1215,
        GIR_EraseRootFromParent_Done,
      // Label 4540: @281784
      GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(281878), // Rule ID 1216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64:{ *:[v4f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f8_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1216,
        GIR_EraseRootFromParent_Done,
      // Label 4541: @281878
      GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(281972), // Rule ID 1217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1217,
        GIR_EraseRootFromParent_Done,
      // Label 4542: @281972
      GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(282066), // Rule ID 1218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f8_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1218,
        GIR_EraseRootFromParent_Done,
      // Label 4543: @282066
      GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(282160), // Rule ID 1219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1219,
        GIR_EraseRootFromParent_Done,
      // Label 4544: @282160
      GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(282254), // Rule ID 1220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64:{ *:[v4f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f6_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1220,
        GIR_EraseRootFromParent_Done,
      // Label 4545: @282254
      GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(282348), // Rule ID 1221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1221,
        GIR_EraseRootFromParent_Done,
      // Label 4546: @282348
      GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(282442), // Rule ID 1222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f6_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1222,
        GIR_EraseRootFromParent_Done,
      // Label 4547: @282442
      GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(282536), // Rule ID 1223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22721),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22721>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1223,
        GIR_EraseRootFromParent_Done,
      // Label 4548: @282536
      GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(282630), // Rule ID 1224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_16x16x128_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22723),
        // (intrinsic_wo_chain:{ *:[v4f32] } 3032:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22723>>  =>  (V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v4f32:{ *:[v4f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_16X16X128_F8F6F4_f4_f4_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1224,
        GIR_EraseRootFromParent_Done,
      // Label 4549: @282630
      GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(282724), // Rule ID 1225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1225,
        GIR_EraseRootFromParent_Done,
      // Label 4550: @282724
      GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(282818), // Rule ID 1226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1226,
        GIR_EraseRootFromParent_Done,
      // Label 4551: @282818
      GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(282912), // Rule ID 1227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1227,
        GIR_EraseRootFromParent_Done,
      // Label 4552: @282912
      GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(283006), // Rule ID 1228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1228,
        GIR_EraseRootFromParent_Done,
      // Label 4553: @283006
      GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(283100), // Rule ID 1229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1229,
        GIR_EraseRootFromParent_Done,
      // Label 4554: @283100
      GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(283194), // Rule ID 1230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1230,
        GIR_EraseRootFromParent_Done,
      // Label 4555: @283194
      GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(283288), // Rule ID 1231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1231,
        GIR_EraseRootFromParent_Done,
      // Label 4556: @283288
      GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(283382), // Rule ID 1232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1232,
        GIR_EraseRootFromParent_Done,
      // Label 4557: @283382
      GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(283476), // Rule ID 1233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1233,
        GIR_EraseRootFromParent_Done,
      // Label 4558: @283476
      GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(283570), // Rule ID 1234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64:{ *:[v16f32] } v8i32:{ *:[v8i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f8_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1234,
        GIR_EraseRootFromParent_Done,
      // Label 4559: @283570
      GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(283664), // Rule ID 1235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1235,
        GIR_EraseRootFromParent_Done,
      // Label 4560: @283664
      GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(283758), // Rule ID 1236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v8i32:{ *:[v8i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f8_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1236,
        GIR_EraseRootFromParent_Done,
      // Label 4561: @283758
      GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(283852), // Rule ID 1237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1237,
        GIR_EraseRootFromParent_Done,
      // Label 4562: @283852
      GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(283946), // Rule ID 1238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64:{ *:[v16f32] } v6i32:{ *:[v6i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f6_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1238,
        GIR_EraseRootFromParent_Done,
      // Label 4563: @283946
      GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(284040), // Rule ID 1239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1239,
        GIR_EraseRootFromParent_Done,
      // Label 4564: @284040
      GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(284134), // Rule ID 1240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v6s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v6i32:{ *:[v6i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f6_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1240,
        GIR_EraseRootFromParent_Done,
      // Label 4565: @284134
      GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(284228), // Rule ID 1241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22743),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22743>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1241,
        GIR_EraseRootFromParent_Done,
      // Label 4566: @284228
      GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(284322), // Rule ID 1242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_mfma_scale_f32_32x32x64_f8f6f4),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
        GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s32,
        GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
        GIM_RootCheckType, /*Op*/10, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_512RegClassID),
        // MIs[0] cbsz
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] blgp
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] scale_src0_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        // MIs[0] scale_src1_opsel
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_MFMALdScaleModifierOp),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_22745),
        // (intrinsic_wo_chain:{ *:[v16f32] } 3033:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src0_opsel, i32:{ *:[i32] }:$scale_src0, (timm:{ *:[i32] })<<P:Predicate_MFMALdScaleModifierOp>><<X:MFMALdScaleXForm>>:$scale_src1_opsel, i32:{ *:[i32] }:$scale_src1)<<P:Predicate_anonymous_22745>>  =>  (V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$src0, v4i32:{ *:[v4i32] }:$src1, v16f32:{ *:[v16f32] }:$src2, (timm:{ *:[i32] }):$cbsz, (timm:{ *:[i32] }):$blgp, i32:{ *:[i32] }:$scale_src0, i32:{ *:[i32] }:$scale_src1, (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src0_opsel), (MFMALdScaleXForm:{ *:[i32] } (timm:{ *:[i32] }):$scale_src1_opsel))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MFMA_SCALE_F32_32X32X64_F8F6F4_f4_f4_mac_vgprcd_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/3, // src1
        GIR_RootToRootCopy, /*OpIdx*/4, // src2
        GIR_RootToRootCopy, /*OpIdx*/5, // cbsz
        GIR_RootToRootCopy, /*OpIdx*/6, // blgp
        GIR_RootToRootCopy, /*OpIdx*/8, // scale_src0
        GIR_RootToRootCopy, /*OpIdx*/10, // scale_src1
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src0_opsel
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/9, /*OperandRenderer*/GIMT_Encode2(GICR_renderScaledMAIIntrinsicOperand), // scale_src1_opsel
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1242,
        GIR_EraseRootFromParent_Done,
      // Label 4567: @284322
      GIM_Reject,
    // Label 4495: @284323
    GIM_Reject,
    // Label 39: @284324
    GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(284400),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
      GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(284347), // Rule ID 181 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier),
        // (intrinsic_void 3114:{ *:[iPTR] })  =>  (S_BARRIER)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 181,
        GIR_EraseRootFromParent_Done,
      // Label 4569: @284347
      GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(284362), // Rule ID 1346 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_wave_barrier),
        // (intrinsic_void 3277:{ *:[iPTR] })  =>  (WAVE_BARRIER)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::WAVE_BARRIER),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1346,
        GIR_EraseRootFromParent_Done,
      // Label 4570: @284362
      GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(284381), // Rule ID 1354 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_unreachable),
        // (intrinsic_void 3275:{ *:[iPTR] })  =>  (SI_MASKED_UNREACHABLE)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_MASKED_UNREACHABLE),
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1354,
        GIR_EraseRootFromParent_Done,
      // Label 4571: @284381
      GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(284399), // Rule ID 1867 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_endpgm),
        // (intrinsic_void 2163:{ *:[iPTR] })  =>  (S_ENDPGM 0:{ *:[i16] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ENDPGM),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1867,
        GIR_EraseRootFromParent_Done,
      // Label 4572: @284399
      GIM_Reject,
    // Label 4568: @284400
    GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(284559),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
      GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(284428), // Rule ID 41 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_signal),
        // MIs[0] src0
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3118:{ *:[iPTR] }, (timm:{ *:[i32] }):$src0)  =>  (S_BARRIER_SIGNAL_IMM (timm:{ *:[i32] }):$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_SIGNAL_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 41,
        GIR_EraseRootFromParent_Done,
      // Label 4574: @284428
      GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(284448), // Rule ID 182 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_wait),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3121:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_BARRIER_WAIT (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_WAIT),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 182,
        GIR_EraseRootFromParent_Done,
      // Label 4575: @284448
      GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(284468), // Rule ID 183 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_s_barrier_leave),
        // MIs[0] simm16
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3117:{ *:[iPTR] }, (timm:{ *:[i16] }):$simm16)  =>  (S_BARRIER_LEAVE_IMM (timm:{ *:[i16] }):$simm16)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BARRIER_LEAVE_IMM),
        GIR_RootToRootCopy, /*OpIdx*/1, // simm16
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 183,
        GIR_EraseRootFromParent_Done,
      // Label 4576: @284468
      GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(284488), // Rule ID 1347 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_barrier),
        // MIs[0] mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 3166:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (SCHED_BARRIER (timm:{ *:[i32] }):$mask)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_BARRIER),
        GIR_RootToRootCopy, /*OpIdx*/1, // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1347,
        GIR_EraseRootFromParent_Done,
      // Label 4577: @284488
      GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(284508), // Rule ID 1349 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_iglp_opt),
        // MIs[0] mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 2195:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask)  =>  (IGLP_OPT (timm:{ *:[i32] }):$mask)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::IGLP_OPT),
        GIR_RootToRootCopy, /*OpIdx*/1, // mask
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1349,
        GIR_EraseRootFromParent_Done,
      // Label 4578: @284508
      GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(284531), // Rule ID 1355 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec),
        // MIs[0] src
        GIM_CheckIsImm, /*MI*/0, /*Op*/1,
        // (intrinsic_void 2957:{ *:[iPTR] }, (timm:{ *:[i64] }):$src)  =>  (SI_INIT_EXEC (timm:{ *:[i64] }):$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC),
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1355,
        GIR_EraseRootFromParent_Done,
      // Label 4579: @284531
      GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(284558), // Rule ID 1357 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_init_whole_wave),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        // (intrinsic_w_chain:{ *:[i1] } 2959:{ *:[iPTR] })  =>  (SI_INIT_WHOLE_WAVE:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_WHOLE_WAVE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1357,
        GIR_EraseRootFromParent_Done,
      // Label 4580: @284558
      GIM_Reject,
    // Label 4573: @284559
    GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(285846),
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
      GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(284622), // Rule ID 8425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr4_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v2i32] } 2156:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B4:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B4),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8425,
        GIR_EraseRootFromParent_Done,
      // Label 4582: @284622
      GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(284677), // Rule ID 8426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr8_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v2i32] } 2158:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B8:{ *:[v2i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B8),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8426,
        GIR_EraseRootFromParent_Done,
      // Label 4583: @284677
      GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(284732), // Rule ID 8427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr6_b96),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v3s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v3i32] } 2157:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B96_TR_B6:{ *:[v3i32] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B96_TR_B6),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8427,
        GIR_EraseRootFromParent_Done,
      // Label 4584: @284732
      GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(284787), // Rule ID 8428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v4i16] } 2155:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4i16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8428,
        GIR_EraseRootFromParent_Done,
      // Label 4585: @284787
      GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(284842), // Rule ID 8429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v4f16] } 2155:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4f16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8429,
        GIR_EraseRootFromParent_Done,
      // Label 4586: @284842
      GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(284897), // Rule ID 8430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGFX950Insts),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_ds_read_tr16_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ds_1addr_1offset),
        // (intrinsic_w_chain:{ *:[v4bf16] } 2155:{ *:[iPTR] }, (DS1Addr1Offset:{ *:[iPTR] } i32:{ *:[i32] }:$ptr, i32:{ *:[i32] }:$offset))  =>  (DS_READ_B64_TR_B16:{ *:[v4bf16] } ?:{ *:[i32] }:$ptr, Offset:{ *:[i32] }:$offset, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::DS_READ_B64_TR_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // ptr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8430,
        GIR_EraseRootFromParent_Done,
      // Label 4587: @284897
      GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(284957), // Rule ID 4082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v2i32] } 2190:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32_SADDR:{ *:[v2i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4082,
        GIR_EraseRootFromParent_Done,
      // Label 4588: @284957
      GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(285017), // Rule ID 4084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v8i16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4084,
        GIR_EraseRootFromParent_Done,
      // Label 4589: @285017
      GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(285077), // Rule ID 4086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v8f16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4086,
        GIR_EraseRootFromParent_Done,
      // Label 4590: @285077
      GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(285137), // Rule ID 4088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v8bf16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32_SADDR:{ *:[v8bf16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4088,
        GIR_EraseRootFromParent_Done,
      // Label 4591: @285137
      GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(285197), // Rule ID 4090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[i32] } 2190:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64_SADDR:{ *:[i32] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4090,
        GIR_EraseRootFromParent_Done,
      // Label 4592: @285197
      GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(285257), // Rule ID 4092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v4i16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4i16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4092,
        GIR_EraseRootFromParent_Done,
      // Label 4593: @285257
      GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(285317), // Rule ID 4094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v4f16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4f16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4094,
        GIR_EraseRootFromParent_Done,
      // Label 4594: @285317
      GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(285377), // Rule ID 4096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (intrinsic_w_chain:{ *:[v4bf16] } 2189:{ *:[iPTR] }, (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64_SADDR:{ *:[v4bf16] } ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$voffset, ?:{ *:[i32] }:$offset, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64_SADDR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4096,
        GIR_EraseRootFromParent_Done,
      // Label 4595: @285377
      GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(285432), // Rule ID 4081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v2i32] } 2190:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w32:{ *:[v2i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4081,
        GIR_EraseRootFromParent_Done,
      // Label 4596: @285432
      GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(285487), // Rule ID 4083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v8i16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4083,
        GIR_EraseRootFromParent_Done,
      // Label 4597: @285487
      GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(285542), // Rule ID 4085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v8f16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4085,
        GIR_EraseRootFromParent_Done,
      // Label 4598: @285542
      GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(285597), // Rule ID 4087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave32),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v8bf16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w32:{ *:[v8bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4087,
        GIR_EraseRootFromParent_Done,
      // Label 4599: @285597
      GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(285652), // Rule ID 4089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b64),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[i32] } 2190:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B64_w64:{ *:[i32] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B64_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4089,
        GIR_EraseRootFromParent_Done,
      // Label 4600: @285652
      GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(285707), // Rule ID 4091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v4i16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4i16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4091,
        GIR_EraseRootFromParent_Done,
      // Label 4601: @285707
      GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(285762), // Rule ID 4093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v4f16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4f16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4093,
        GIR_EraseRootFromParent_Done,
      // Label 4602: @285762
      GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(285817), // Rule ID 4095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus_isWave64),
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_global_load_tr_b128),
        GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (intrinsic_w_chain:{ *:[v4bf16] } 2189:{ *:[iPTR] }, (GlobalOffset:{ *:[iPTR] } VReg_64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset))  =>  (GLOBAL_LOAD_TR_B128_w64:{ *:[v4bf16] } ?:{ *:[i64] }:$vaddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_LOAD_TR_B128_w64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4095,
        GIR_EraseRootFromParent_Done,
      // Label 4603: @285817
      GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(285845), // Rule ID 1356 //
        GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_init_exec_from_input),
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        // MIs[0] shift
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        // (intrinsic_void 2958:{ *:[iPTR] }, i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)  =>  (SI_INIT_EXEC_FROM_INPUT i32:{ *:[i32] }:$input, (timm:{ *:[i32] }):$shift)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SI_INIT_EXEC_FROM_INPUT),
        GIR_RootToRootCopy, /*OpIdx*/1, // input
        GIR_RootToRootCopy, /*OpIdx*/2, // shift
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::EXEC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1356,
        GIR_EraseRootFromParent_Done,
      // Label 4604: @285845
      GIM_Reject,
    // Label 4581: @285846
    GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(285879), // Rule ID 1348 //
      GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
      GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::amdgcn_sched_group_barrier),
      // MIs[0] mask
      GIM_CheckIsImm, /*MI*/0, /*Op*/1,
      // MIs[0] size
      GIM_CheckIsImm, /*MI*/0, /*Op*/2,
      // MIs[0] syncid
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      // (intrinsic_void 3167:{ *:[iPTR] }, (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)  =>  (SCHED_GROUP_BARRIER (timm:{ *:[i32] }):$mask, (timm:{ *:[i32] }):$size, (timm:{ *:[i32] }):$syncid)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::SCHED_GROUP_BARRIER),
      GIR_RootToRootCopy, /*OpIdx*/1, // mask
      GIR_RootToRootCopy, /*OpIdx*/2, // size
      GIR_RootToRootCopy, /*OpIdx*/3, // syncid
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1348,
      GIR_EraseRootFromParent_Done,
    // Label 4605: @285879
    GIM_Reject,
    // Label 40: @285880
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4609*/ GIMT_Encode4(286442),
    /*GILLT_s16*//*Label 4606*/ GIMT_Encode4(285903),
    /*GILLT_s32*//*Label 4607*/ GIMT_Encode4(285940),
    /*GILLT_s64*//*Label 4608*/ GIMT_Encode4(286039),
    // Label 4606: @285903
    GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(285939), // Rule ID 2466 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (anyext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2466,
      GIR_EraseRootFromParent_Done,
    // Label 4610: @285939
    GIM_Reject,
    // Label 4607: @285940
    GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(286005), // Rule ID 2347 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_18673),
      // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_18673>>  =>  (REG_SEQUENCE:{ *:[i32] } VGPR_32:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // GIR_Coverage, 2347,
      GIR_EraseRootFromParent_Done,
    // Label 4611: @286005
    GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(286038), // Rule ID 7482 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (anyext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7482,
      GIR_EraseRootFromParent_Done,
    // Label 4612: @286038
    GIM_Reject,
    // Label 4608: @286039
    GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(286122), // Rule ID 2338 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX8Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2338,
      GIR_EraseRootFromParent_Done,
    // Label 4613: @286122
    GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(286205), // Rule ID 2342 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX8Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (COPY:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2342,
      GIR_EraseRootFromParent_Done,
    // Label 4614: @286205
    GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(286291), // Rule ID 2348 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (anyext:{ *:[i64] } i16:{ *:[i16] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i16] }:$src, lo16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i16] }), hi16:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/5, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2348,
      GIR_EraseRootFromParent_Done,
    // Label 4615: @286291
    GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(286349), // Rule ID 7555 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // (anyext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 7555,
      GIR_EraseRootFromParent_Done,
    // Label 4616: @286349
    GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(286441), // Rule ID 7557 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (anyext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7557,
      GIR_EraseRootFromParent_Done,
    // Label 4617: @286441
    GIM_Reject,
    // Label 4609: @286442
    GIM_Reject,
    // Label 41: @286443
    GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(286682),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4621*/ GIMT_Encode4(286566),
      /*GILLT_s16*//*Label 4619*/ GIMT_Encode4(286470),
      /*GILLT_s32*//*Label 4620*/ GIMT_Encode4(286518),
      // Label 4619: @286470
      GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(286517), // Rule ID 7605 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34004),
        // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34004>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7605,
        GIR_EraseRootFromParent_Done,
      // Label 4622: @286517
      GIM_Reject,
      // Label 4620: @286518
      GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(286565), // Rule ID 7604 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34004),
        // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34004>>  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } (V_AND_B32_e64:{ *:[i16] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7604,
        GIR_EraseRootFromParent_Done,
      // Label 4623: @286565
      GIM_Reject,
      // Label 4621: @286566
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4626*/ GIMT_Encode4(286681),
      /*GILLT_s16*//*Label 4624*/ GIMT_Encode4(286585),
      /*GILLT_s32*//*Label 4625*/ GIMT_Encode4(286633),
      // Label 4624: @286585
      GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(286632), // Rule ID 7602 //
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34000),
        // (trunc:{ *:[i1] } i16:{ *:[i16] }:$a)<<P:Predicate_anonymous_34000>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i16] }:$a), 1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7602,
        GIR_EraseRootFromParent_Done,
      // Label 4627: @286632
      GIM_Reject,
      // Label 4625: @286633
      GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(286680), // Rule ID 7601 //
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34000),
        // (trunc:{ *:[i1] } i32:{ *:[i32] }:$a)<<P:Predicate_anonymous_34000>>  =>  (S_CMP_EQ_U32:{ *:[i1] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } 1:{ *:[i32] }, ?:{ *:[i32] }:$a), 1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::SCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_CMP_EQ_U32),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7601,
        GIR_EraseRootFromParent_Done,
      // Label 4628: @286680
      GIM_Reject,
      // Label 4626: @286681
      GIM_Reject,
    // Label 4618: @286682
    GIM_Reject,
    // Label 42: @286683
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(11), /*)*//*default:*//*Label 4640*/ GIMT_Encode4(287408),
    /*GILLT_p0s64*//*Label 4629*/ GIMT_Encode4(286738),
    /*GILLT_p1s64*//*Label 4630*/ GIMT_Encode4(286781),
    /*GILLT_p2s32*//*Label 4631*/ GIMT_Encode4(286824),
    /*GILLT_p3s32*//*Label 4632*/ GIMT_Encode4(286867),
    /*GILLT_p4s64*//*Label 4633*/ GIMT_Encode4(286910),
    /*GILLT_p5s32*//*Label 4634*/ GIMT_Encode4(286953),
    /*GILLT_p6s32*//*Label 4635*/ GIMT_Encode4(286996),
    /*GILLT_s1*//*Label 4636*/ GIMT_Encode4(287039),
    /*GILLT_s16*//*Label 4637*/ GIMT_Encode4(287084),
    /*GILLT_s32*//*Label 4638*/ GIMT_Encode4(287188),
    /*GILLT_s64*//*Label 4639*/ GIMT_Encode4(287231),
    // Label 4629: @286738
    GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(286761), // Rule ID 7468 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33840),
      // (imm:{ *:[i64] })<<P:Predicate_anonymous_33840>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7468,
      GIR_EraseRootFromParent_Done,
    // Label 4641: @286761
    GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(286780), // Rule ID 7470 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7470,
      GIR_EraseRootFromParent_Done,
    // Label 4642: @286780
    GIM_Reject,
    // Label 4630: @286781
    GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(286804), // Rule ID 7465 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33836),
      // (imm:{ *:[i64] })<<P:Predicate_anonymous_33836>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7465,
      GIR_EraseRootFromParent_Done,
    // Label 4643: @286804
    GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(286823), // Rule ID 7467 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7467,
      GIR_EraseRootFromParent_Done,
    // Label 4644: @286823
    GIM_Reject,
    // Label 4631: @286824
    GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(286847), // Rule ID 7437 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33799),
      // (imm:{ *:[i32] })<<P:Predicate_anonymous_33799>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7437,
      GIR_EraseRootFromParent_Done,
    // Label 4645: @286847
    GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(286866), // Rule ID 7438 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7438,
      GIR_EraseRootFromParent_Done,
    // Label 4646: @286866
    GIM_Reject,
    // Label 4632: @286867
    GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(286890), // Rule ID 7431 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33790),
      // (imm:{ *:[i32] })<<P:Predicate_anonymous_33790>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7431,
      GIR_EraseRootFromParent_Done,
    // Label 4647: @286890
    GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(286909), // Rule ID 7432 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7432,
      GIR_EraseRootFromParent_Done,
    // Label 4648: @286909
    GIM_Reject,
    // Label 4633: @286910
    GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(286933), // Rule ID 7471 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33844),
      // (imm:{ *:[i64] })<<P:Predicate_anonymous_33844>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7471,
      GIR_EraseRootFromParent_Done,
    // Label 4649: @286933
    GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(286952), // Rule ID 7473 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7473,
      GIR_EraseRootFromParent_Done,
    // Label 4650: @286952
    GIM_Reject,
    // Label 4634: @286953
    GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(286976), // Rule ID 7433 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33793),
      // (imm:{ *:[i32] })<<P:Predicate_anonymous_33793>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7433,
      GIR_EraseRootFromParent_Done,
    // Label 4651: @286976
    GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(286995), // Rule ID 7434 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7434,
      GIR_EraseRootFromParent_Done,
    // Label 4652: @286995
    GIM_Reject,
    // Label 4635: @286996
    GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(287019), // Rule ID 7435 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33796),
      // (imm:{ *:[i32] })<<P:Predicate_anonymous_33796>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7435,
      GIR_EraseRootFromParent_Done,
    // Label 4653: @287019
    GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(287038), // Rule ID 7436 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7436,
      GIR_EraseRootFromParent_Done,
    // Label 4654: @287038
    GIM_Reject,
    // Label 4636: @287039
    GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(287061), // Rule ID 7477 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B64:{ *:[i1] } (imm:{ *:[i1] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7477,
      GIR_EraseRootFromParent_Done,
    // Label 4655: @287061
    GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(287083), // Rule ID 7478 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isWave32),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i1] }):$imm  =>  (S_MOV_B32:{ *:[i1] } (imm:{ *:[i1] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7478,
      GIR_EraseRootFromParent_Done,
    // Label 4656: @287083
    GIM_Reject,
    // Label 4637: @287084
    GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(287110), // Rule ID 7443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33809),
      // (imm:{ *:[i16] })<<P:Predicate_anonymous_33809>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7443,
      GIR_EraseRootFromParent_Done,
    // Label 4657: @287110
    GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(287136), // Rule ID 7446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33809),
      // (imm:{ *:[i16] })<<P:Predicate_anonymous_33809>>:$imm  =>  (V_MOV_B32_e32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7446,
      GIR_EraseRootFromParent_Done,
    // Label 4658: @287136
    GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(287168), // Rule ID 7449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33809),
      // (imm:{ *:[i16] })<<P:Predicate_anonymous_33809>>:$imm  =>  (V_MOV_B16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, (imm:{ *:[i16] }):$imm, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B16_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7449,
      GIR_EraseRootFromParent_Done,
    // Label 4659: @287168
    GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(287187), // Rule ID 1870 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$imm  =>  (S_MOV_B32:{ *:[i16] } (imm:{ *:[i16] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1870,
      GIR_EraseRootFromParent_Done,
    // Label 4660: @287187
    GIM_Reject,
    // Label 4638: @287188
    GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(287211), // Rule ID 7429 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33789),
      // (imm:{ *:[i32] })<<P:Predicate_anonymous_33789>>:$imm  =>  (V_MOV_B32_e32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7429,
      GIR_EraseRootFromParent_Done,
    // Label 4661: @287211
    GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(287230), // Rule ID 7430 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$imm  =>  (S_MOV_B32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7430,
      GIR_EraseRootFromParent_Done,
    // Label 4662: @287230
    GIM_Reject,
    // Label 4639: @287231
    GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(287254), // Rule ID 7463 //
      GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7463,
      GIR_EraseRootFromParent_Done,
    // Label 4663: @287254
    GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(287277), // Rule ID 7466 //
      GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7466,
      GIR_EraseRootFromParent_Done,
    // Label 4664: @287277
    GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(287300), // Rule ID 7469 //
      GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7469,
      GIR_EraseRootFromParent_Done,
    // Label 4665: @287300
    GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(287323), // Rule ID 7472 //
      GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_InlineImm64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm  =>  (S_MOV_B64:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_InlineImm64>>:$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7472,
      GIR_EraseRootFromParent_Done,
    // Label 4666: @287323
    GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(287346), // Rule ID 7452 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33821),
      // (imm:{ *:[i64] })<<P:Predicate_anonymous_33821>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7452,
      GIR_EraseRootFromParent_Done,
    // Label 4667: @287346
    GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(287369), // Rule ID 7462 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33821),
      // (imm:{ *:[i64] })<<P:Predicate_anonymous_33821>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7462,
      GIR_EraseRootFromParent_Done,
    // Label 4668: @287369
    GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(287388), // Rule ID 7454 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7454,
      GIR_EraseRootFromParent_Done,
    // Label 4669: @287388
    GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(287407), // Rule ID 7464 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[i64] } (imm:{ *:[i64] }):$imm)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7464,
      GIR_EraseRootFromParent_Done,
    // Label 4670: @287407
    GIM_Reject,
    // Label 4640: @287408
    GIM_Reject,
    // Label 43: @287409
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4674*/ GIMT_Encode4(287786),
    /*GILLT_s16*//*Label 4671*/ GIMT_Encode4(287432),
    /*GILLT_s32*//*Label 4672*/ GIMT_Encode4(287600),
    /*GILLT_s64*//*Label 4673*/ GIMT_Encode4(287668),
    // Label 4671: @287432
    GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(287457), // Rule ID 7444 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33811),
      // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_33811>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7444,
      GIR_EraseRootFromParent_Done,
    // Label 4675: @287457
    GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(287482), // Rule ID 7445 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33811),
      // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_33811>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[bf16] } ?:{ *:[f16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7445,
      GIR_EraseRootFromParent_Done,
    // Label 4676: @287482
    GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(287507), // Rule ID 7447 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33811),
      // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_33811>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[f16] } ?:{ *:[f16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7447,
      GIR_EraseRootFromParent_Done,
    // Label 4677: @287507
    GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(287532), // Rule ID 7448 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33811),
      // (fpimm:{ *:[f16] })<<P:Predicate_anonymous_33811>>:$imm  =>  (V_MOV_B32_e32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[bf16] } ?:{ *:[f16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7448,
      GIR_EraseRootFromParent_Done,
    // Label 4678: @287532
    GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(287557), // Rule ID 7458 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33818),
      // (fpimm:{ *:[bf16] })<<P:Predicate_anonymous_33818>>:$imm  =>  (V_MOV_B32_e32:{ *:[bf16] } (bitcast_fpimm_to_i32:{ *:[bf16] } ?:{ *:[bf16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7458,
      GIR_EraseRootFromParent_Done,
    // Label 4679: @287557
    GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(287578), // Rule ID 7457 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f16] }):$imm  =>  (S_MOV_B32:{ *:[f16] } (bitcast_fpimm_to_i32:{ *:[i32] } ?:{ *:[f16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7457,
      GIR_EraseRootFromParent_Done,
    // Label 4680: @287578
    GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(287599), // Rule ID 7459 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[bf16] }):$imm  =>  (S_MOV_B32:{ *:[bf16] } (bitcast_fpimm_to_i32:{ *:[i32] } ?:{ *:[bf16] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7459,
      GIR_EraseRootFromParent_Done,
    // Label 4681: @287599
    GIM_Reject,
    // Label 4672: @287600
    GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(287625), // Rule ID 7460 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33831),
      // (fpimm:{ *:[f32] })<<P:Predicate_anonymous_33831>>:$imm  =>  (V_MOV_B32_e32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7460,
      GIR_EraseRootFromParent_Done,
    // Label 4682: @287625
    GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(287646), // Rule ID 7456 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7456,
      GIR_EraseRootFromParent_Done,
    // Label 4683: @287646
    GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(287667), // Rule ID 7461 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f32] }):$imm  =>  (S_MOV_B32:{ *:[f32] } (bitcast_fpimm_to_i32:{ *:[f32] } ?:{ *:[f32] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm32), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7461,
      GIR_EraseRootFromParent_Done,
    // Label 4684: @287667
    GIM_Reject,
    // Label 4673: @287668
    GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(287693), // Rule ID 7475 //
      GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_InlineImmFP64),
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] })<<P:Predicate_InlineImmFP64>>:$imm  =>  (S_MOV_B64:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } ?:{ *:[f64] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7475,
      GIR_EraseRootFromParent_Done,
    // Label 4685: @287693
    GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(287718), // Rule ID 7453 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33823),
      // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_33823>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7453,
      GIR_EraseRootFromParent_Done,
    // Label 4686: @287718
    GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(287743), // Rule ID 7474 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33823),
      // (fpimm:{ *:[f64] })<<P:Predicate_anonymous_33823>>:$imm  =>  (V_MOV_B64_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[f64] } ?:{ *:[f64] }:$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7474,
      GIR_EraseRootFromParent_Done,
    // Label 4687: @287743
    GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(287764), // Rule ID 7455 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7455,
      GIR_EraseRootFromParent_Done,
    // Label 4688: @287764
    GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(287785), // Rule ID 7476 //
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // MIs[0] Operand 1
      // No operand predicates
      // (fpimm:{ *:[f64] }):$imm  =>  (S_MOV_B64_IMM_PSEUDO:{ *:[f64] } (bitcast_fpimm_to_i64:{ *:[i64] } (fpimm:{ *:[f64] }):$imm))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B64_IMM_PSEUDO),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderBitcastFPImm64), // imm
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7476,
      GIR_EraseRootFromParent_Done,
    // Label 4689: @287785
    GIM_Reject,
    // Label 4674: @287786
    GIM_Reject,
    // Label 44: @287787
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4693*/ GIMT_Encode4(288589),
    /*GILLT_s16*//*Label 4690*/ GIMT_Encode4(287810),
    /*GILLT_s32*//*Label 4691*/ GIMT_Encode4(287847),
    /*GILLT_s64*//*Label 4692*/ GIMT_Encode4(287935),
    // Label 4690: @287810
    GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(287846), // Rule ID 2467 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2467,
      GIR_EraseRootFromParent_Done,
    // Label 4694: @287846
    GIM_Reject,
    // Label 4691: @287847
    GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(287870), // Rule ID 1871 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13418),
      // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13418>>  =>  (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1871,
      GIR_Done,
    // Label 4695: @287870
    GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(287901), // Rule ID 2474 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19675),
      // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_19675>>  =>  (V_BFE_I32_e64:{ *:[i32] } i16:{ *:[i16] }:$src, 0:{ *:[i32] }, 16:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2474,
      GIR_EraseRootFromParent_Done,
    // Label 4696: @287901
    GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(287934), // Rule ID 7480 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7480,
      GIR_EraseRootFromParent_Done,
    // Label 4697: @287934
    GIM_Reject,
    // Label 4692: @287935
    GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(288080), // Rule ID 1881 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13418),
      // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13418>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } (S_SEXT_I32_I16:{ *:[i32] } ?:{ *:[i16] }:$src), (S_MOV_B32:{ *:[i1] } 31:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
      GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_SEXT_I32_I16),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 1881,
      GIR_EraseRootFromParent_Done,
    // Label 4698: @288080
    GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(288302), // Rule ID 2475 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19675),
      // (sext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_19675>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] })), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e32:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 31:{ *:[i32] }), (V_BFE_I32_e64:{ *:[i32] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i16] } 0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 16:{ *:[i32] }))), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/9, /*Imm*/16,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
      GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/8, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
      GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
      GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
      GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/8,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
      GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
      GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e32),
      GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
      GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
      GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/16,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFE_I32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2475,
      GIR_EraseRootFromParent_Done,
    // Label 4699: @288302
    GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(288394), // Rule ID 7558 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13418),
      // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_13418>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_ASHR_I32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i32] }:$src, 31:{ *:[i32] }), SReg_32_XM0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 7558,
      GIR_EraseRootFromParent_Done,
    // Label 4700: @288394
    GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(288483), // Rule ID 7559 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19675),
      // (sext:{ *:[i64] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_19675>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (V_ASHRREV_I32_e64:{ *:[i16] } 31:{ *:[i32] }, ?:{ *:[i32] }:$src), VGPR_32:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7559,
      GIR_EraseRootFromParent_Done,
    // Label 4701: @288483
    GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(288588), // Rule ID 7560 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (sext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7560,
      GIR_EraseRootFromParent_Done,
    // Label 4702: @288588
    GIM_Reject,
    // Label 4693: @288589
    GIM_Reject,
    // Label 45: @288590
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4706*/ GIMT_Encode4(291635),
    /*GILLT_s16*//*Label 4703*/ GIMT_Encode4(288613),
    /*GILLT_s32*//*Label 4704*/ GIMT_Encode4(288650),
    /*GILLT_s64*//*Label 4705*/ GIMT_Encode4(289781),
    // Label 4703: @288613
    GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(288649), // Rule ID 2465 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (zext:{ *:[i16] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2465,
      GIR_EraseRootFromParent_Done,
    // Label 4707: @288649
    GIM_Reject,
    // Label 4704: @288650
    GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(288726), // Rule ID 2462 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2462,
      GIR_EraseRootFromParent_Done,
    // Label 4708: @288726
    GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(288802), // Rule ID 2458 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2458,
      GIR_EraseRootFromParent_Done,
    // Label 4709: @288802
    GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(288878), // Rule ID 2454 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2454,
      GIR_EraseRootFromParent_Done,
    // Label 4710: @288878
    GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(288942), // Rule ID 2440 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_NegSubInlineIntConst16),
      // MIs[2] Operand 1
      // No operand predicates
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>><<X:NegateImm>>:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, (NegateImm:{ *:[i16 i32 bf16 f16 f32 v2i16 v2f16 v2bf16] } (imm:{ *:[i16] })<<P:Predicate_NegSubInlineIntConst16>>:$src1))
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderNegateImm), // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2440,
      GIR_EraseRootFromParent_Done,
    // Label 4711: @288942
    GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(289013), // Rule ID 2476 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (zext:{ *:[i32] } (add:{ *:[i16] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2476,
      GIR_EraseRootFromParent_Done,
    // Label 4712: @289013
    GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(289084), // Rule ID 8582 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/2,
      // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src2, (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MAD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, VSrc_b16:{ *:[i16] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 8582,
      GIR_EraseRootFromParent_Done,
    // Label 4713: @289084
    GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(289154), // Rule ID 7614 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (bswap:{ *:[i16] } i16:{ *:[i16] }:$a))  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7614,
      GIR_EraseRootFromParent_Done,
    // Label 4714: @289154
    GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(289205), // Rule ID 2431 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_ADD_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2431,
      GIR_EraseRootFromParent_Done,
    // Label 4715: @289205
    GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(289253), // Rule ID 2461 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_ASHRREV_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2461,
      GIR_EraseRootFromParent_Done,
    // Label 4716: @289253
    GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(289301), // Rule ID 2457 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHRREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2457,
      GIR_EraseRootFromParent_Done,
    // Label 4717: @289301
    GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(289349), // Rule ID 2441 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MUL_LO_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2441,
      GIR_EraseRootFromParent_Done,
    // Label 4718: @289349
    GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(289397), // Rule ID 2453 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_LSHLREV_B16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2453,
      GIR_EraseRootFromParent_Done,
    // Label 4719: @289397
    GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(289445), // Rule ID 2447 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2447,
      GIR_EraseRootFromParent_Done,
    // Label 4720: @289445
    GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(289493), // Rule ID 2445 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_I16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2445,
      GIR_EraseRootFromParent_Done,
    // Label 4721: @289493
    GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(289544), // Rule ID 2443 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_SUB_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2443,
      GIR_EraseRootFromParent_Done,
    // Label 4722: @289544
    GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(289592), // Rule ID 2451 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MAX_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2451,
      GIR_EraseRootFromParent_Done,
    // Label 4723: @289592
    GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(289640), // Rule ID 2449 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i32] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MIN_U16_e64:{ *:[i32] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2449,
      GIR_EraseRootFromParent_Done,
    // Label 4724: @289640
    GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(289695), // Rule ID 1882 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13430),
      // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13430>>  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1882,
      GIR_EraseRootFromParent_Done,
    // Label 4725: @289695
    GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(289747), // Rule ID 7597 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33995),
      // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_33995>>  =>  (V_AND_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src)
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7597,
      GIR_EraseRootFromParent_Done,
    // Label 4726: @289747
    GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(289780), // Rule ID 7481 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (zext:{ *:[i32] } i1:{ *:[i1] }:$src0)  =>  (V_CNDMASK_B32_e64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, i1:{ *:[i1] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7481,
      GIR_EraseRootFromParent_Done,
    // Label 4727: @289780
    GIM_Reject,
    // Label 4705: @289781
    GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(289914), // Rule ID 2464 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2464,
      GIR_EraseRootFromParent_Done,
    // Label 4728: @289914
    GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(290047), // Rule ID 2460 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2460,
      GIR_EraseRootFromParent_Done,
    // Label 4729: @290047
    GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(290180), // Rule ID 2456 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
      GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
      GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
      GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
      // MIs[3] Operand 1
      // No operand predicates
      GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
      GIM_CheckIsSafeToFold, /*NumInsns*/3,
      // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2456,
      GIR_EraseRootFromParent_Done,
    // Label 4730: @290180
    GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(290288), // Rule ID 2432 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (add:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ADD_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2432,
      GIR_EraseRootFromParent_Done,
    // Label 4731: @290288
    GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(290393), // Rule ID 2463 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_ASHRREV_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2463,
      GIR_EraseRootFromParent_Done,
    // Label 4732: @290393
    GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(290498), // Rule ID 2459 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHRREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2459,
      GIR_EraseRootFromParent_Done,
    // Label 4733: @290498
    GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(290603), // Rule ID 2442 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (mul:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MUL_LO_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LO_U16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2442,
      GIR_EraseRootFromParent_Done,
    // Label 4734: @290603
    GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(290708), // Rule ID 2455 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_LSHLREV_B16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2455,
      GIR_EraseRootFromParent_Done,
    // Label 4735: @290708
    GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(290813), // Rule ID 2448 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2448,
      GIR_EraseRootFromParent_Done,
    // Label 4736: @290813
    GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(290918), // Rule ID 2446 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_I16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2446,
      GIR_EraseRootFromParent_Done,
    // Label 4737: @290918
    GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(291026), // Rule ID 2444 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (sub:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_SUB_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2444,
      GIR_EraseRootFromParent_Done,
    // Label 4738: @291026
    GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(291131), // Rule ID 2452 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MAX_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2452,
      GIR_EraseRootFromParent_Done,
    // Label 4739: @291131
    GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(291236), // Rule ID 2450 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8GFX9),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (zext:{ *:[i64] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_MIN_U16_e64:{ *:[i16] } ?:{ *:[i16] }:$src0, ?:{ *:[i16] }:$src1), sub0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 2450,
      GIR_EraseRootFromParent_Done,
    // Label 4740: @291236
    GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(291370), // Rule ID 1880 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13430),
      // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_13430>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } ?:{ *:[i16] }:$src, (S_MOV_B32:{ *:[i1] } 65535:{ *:[i32] })), SGPR_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(65535),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SGPR_32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 1880,
      GIR_EraseRootFromParent_Done,
    // Label 4741: @291370
    GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(291481), // Rule ID 7598 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33995),
      // (zext:{ *:[i64] } i16:{ *:[i16] }:$src)<<P:Predicate_anonymous_33995>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 65535:{ *:[i32] }), ?:{ *:[i16] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(65535),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7598,
      GIR_EraseRootFromParent_Done,
    // Label 4742: @291481
    GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(291542), // Rule ID 7554 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      // (zext:{ *:[i64] } i32:{ *:[i32] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, ?:{ *:[i32] }:$src, sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 7554,
      GIR_EraseRootFromParent_Done,
    // Label 4743: @291542
    GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(291634), // Rule ID 7556 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (zext:{ *:[i64] } i1:{ *:[i1] }:$src)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, ?:{ *:[i1] }:$src), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // GIR_Coverage, 7556,
      GIR_EraseRootFromParent_Done,
    // Label 4744: @291634
    GIM_Reject,
    // Label 4706: @291635
    GIM_Reject,
    // Label 46: @291636
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4749*/ GIMT_Encode4(293171),
    /*GILLT_s16*//*Label 4745*/ GIMT_Encode4(291663),
    /*GILLT_s32*//*Label 4746*/ GIMT_Encode4(291974),
    /*GILLT_s64*//*Label 4747*/ GIMT_Encode4(292615),
    /*GILLT_v2s16*//*Label 4748*/ GIMT_Encode4(293002),
    // Label 4745: @291663
    GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(291973),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(291760), // Rule ID 844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 844,
        GIR_EraseRootFromParent_Done,
      // Label 4751: @291760
      GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(291816), // Rule ID 843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (shl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHLREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 843,
        GIR_EraseRootFromParent_Done,
      // Label 4752: @291816
      GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(291871), // Rule ID 842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 842,
        GIR_EraseRootFromParent_Done,
      // Label 4753: @291871
      GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(291926), // Rule ID 846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 846,
        GIR_EraseRootFromParent_Done,
      // Label 4754: @291926
      GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(291949), // Rule ID 841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 841,
        GIR_EraseRootFromParent_Done,
      // Label 4755: @291949
      GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(291972), // Rule ID 845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHLREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 845,
        GIR_EraseRootFromParent_Done,
      // Label 4756: @291972
      GIM_Reject,
    // Label 4750: @291973
    GIM_Reject,
    // Label 4746: @291974
    GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(292614),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(292053), // Rule ID 7709 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34117),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34117>>  =>  (S_BFM_B32:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BFM_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7709,
        GIR_EraseRootFromParent_Done,
      // Label 4758: @292053
      GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(292121), // Rule ID 7711 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34119),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$a), -1:{ *:[i32] }), i32:{ *:[i32] }:$b)<<P:Predicate_anonymous_34119>>  =>  (V_BFM_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // a
        GIR_RootToRootCopy, /*OpIdx*/2, // b
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7711,
        GIR_EraseRootFromParent_Done,
      // Label 4759: @292121
      GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(292216), // Rule ID 2497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordNamedOperand, /*MI*/2, /*Op*/1, /*StoreIdx*/2, // Name : pred:2:z
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[3] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20100),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20101>>, (and:{ *:[i32] } i32:{ *:[i32] }:$src2:$pred:2:z, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:2:Predicate_anonymous_20100>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2497,
        GIR_EraseRootFromParent_Done,
      // Label 4760: @292216
      GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(292284), // Rule ID 69 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13393),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13393>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 69,
        GIR_EraseRootFromParent_Done,
      // Label 4761: @292284
      GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(292340), // Rule ID 2401 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19063),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19063>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2401,
        GIR_EraseRootFromParent_Done,
      // Label 4762: @292340
      GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(292405), // Rule ID 2496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
        GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
        GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:2:z
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20100),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (shl:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:2:x, i32:{ *:[i32] }:$src1:$pred:2:y)<<P:Predicate_anonymous_20101>>, i32:{ *:[i32] }:$src2:$pred:2:z)<<P:2:Predicate_anonymous_20100>>  =>  (V_ADD_LSHL_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_LSHL_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2496,
        GIR_EraseRootFromParent_Done,
      // Label 4763: @292405
      GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(292439), // Rule ID 68 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13393),
        // (shl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13393>>  =>  (S_LSHL_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 68,
        GIR_Done,
      // Label 4764: @292439
      GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(292463), // Rule ID 2400 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19063),
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19063>>  =>  (V_LSHLREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2400,
        GIR_EraseRootFromParent_Done,
      // Label 4765: @292463
      GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(292515), // Rule ID 814 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 814,
        GIR_EraseRootFromParent_Done,
      // Label 4766: @292515
      GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(292570), // Rule ID 840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 840,
        GIR_EraseRootFromParent_Done,
      // Label 4767: @292570
      GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(292590), // Rule ID 813 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 813,
        GIR_EraseRootFromParent_Done,
      // Label 4768: @292590
      GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(292613), // Rule ID 839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 839,
        GIR_Done,
      // Label 4769: @292613
      GIM_Reject,
    // Label 4757: @292614
    GIM_Reject,
    // Label 4747: @292615
    GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(293001),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(292694), // Rule ID 71 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13394),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13394>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 71,
        GIR_EraseRootFromParent_Done,
      // Label 4771: @292694
      GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(292728), // Rule ID 70 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13394),
        // (shl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13394>>  =>  (S_LSHL_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHL_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 70,
        GIR_Done,
      // Label 4772: @292728
      GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(292793), // Rule ID 980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 980,
        GIR_EraseRootFromParent_Done,
      // Label 4773: @292793
      GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(292856), // Rule ID 990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 990,
        GIR_EraseRootFromParent_Done,
      // Label 4774: @292856
      GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(292889), // Rule ID 979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (shl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHL_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHL_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 979,
        GIR_EraseRootFromParent_Done,
      // Label 4775: @292889
      GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(292922), // Rule ID 989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8GFX9GFX10GFX11),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHLREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 989,
        GIR_EraseRootFromParent_Done,
      // Label 4776: @292922
      GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(292977), // Rule ID 921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 921,
        GIR_EraseRootFromParent_Done,
      // Label 4777: @292977
      GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(293000), // Rule ID 920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (shl:{ *:[i64] } i64:{ *:[i64] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHLREV_B64_pseudo_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 920,
        GIR_EraseRootFromParent_Done,
      // Label 4778: @293000
      GIM_Reject,
    // Label 4770: @293001
    GIM_Reject,
    // Label 4748: @293002
    GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(293170),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(293108), // Rule ID 1105 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1105,
        GIR_EraseRootFromParent_Done,
      // Label 4780: @293108
      GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(293169), // Rule ID 1104 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (shl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHLREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHLREV_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1104,
        GIR_EraseRootFromParent_Done,
      // Label 4781: @293169
      GIM_Reject,
    // Label 4779: @293170
    GIM_Reject,
    // Label 4749: @293171
    GIM_Reject,
    // Label 47: @293172
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4786*/ GIMT_Encode4(294333),
    /*GILLT_s16*//*Label 4782*/ GIMT_Encode4(293199),
    /*GILLT_s32*//*Label 4783*/ GIMT_Encode4(293510),
    /*GILLT_s64*//*Label 4784*/ GIMT_Encode4(293855),
    /*GILLT_v2s16*//*Label 4785*/ GIMT_Encode4(294164),
    // Label 4782: @293199
    GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(293509),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(293296), // Rule ID 850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 850,
        GIR_EraseRootFromParent_Done,
      // Label 4788: @293296
      GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(293352), // Rule ID 849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (srl:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LSHRREV_B16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 849,
        GIR_EraseRootFromParent_Done,
      // Label 4789: @293352
      GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(293407), // Rule ID 848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 848,
        GIR_EraseRootFromParent_Done,
      // Label 4790: @293407
      GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(293462), // Rule ID 852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 852,
        GIR_EraseRootFromParent_Done,
      // Label 4791: @293462
      GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(293485), // Rule ID 847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 847,
        GIR_EraseRootFromParent_Done,
      // Label 4792: @293485
      GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(293508), // Rule ID 851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_LSHRREV_B16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 851,
        GIR_EraseRootFromParent_Done,
      // Label 4793: @293508
      GIM_Reject,
    // Label 4787: @293509
    GIM_Reject,
    // Label 4783: @293510
    GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(293854),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(293589), // Rule ID 73 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13395),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13395>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 73,
        GIR_EraseRootFromParent_Done,
      // Label 4795: @293589
      GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(293645), // Rule ID 2397 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19059),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19059>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2397,
        GIR_EraseRootFromParent_Done,
      // Label 4796: @293645
      GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(293679), // Rule ID 72 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13395),
        // (srl:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13395>>  =>  (S_LSHR_B32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 72,
        GIR_Done,
      // Label 4797: @293679
      GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(293703), // Rule ID 2396 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19059),
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19059>>  =>  (V_LSHRREV_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2396,
        GIR_EraseRootFromParent_Done,
      // Label 4798: @293703
      GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(293755), // Rule ID 810 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 810,
        GIR_EraseRootFromParent_Done,
      // Label 4799: @293755
      GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(293810), // Rule ID 836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 836,
        GIR_EraseRootFromParent_Done,
      // Label 4800: @293810
      GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(293830), // Rule ID 809 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_LSHRREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 809,
        GIR_EraseRootFromParent_Done,
      // Label 4801: @293830
      GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(293853), // Rule ID 835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 835,
        GIR_Done,
      // Label 4802: @293853
      GIM_Reject,
    // Label 4794: @293854
    GIM_Reject,
    // Label 4784: @293855
    GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(294163),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(293934), // Rule ID 75 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13396),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13396>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 75,
        GIR_EraseRootFromParent_Done,
      // Label 4804: @293934
      GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(293968), // Rule ID 74 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13396),
        // (srl:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13396>>  =>  (S_LSHR_B64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_LSHR_B64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 74,
        GIR_Done,
      // Label 4805: @293968
      GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(294033), // Rule ID 982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 982,
        GIR_EraseRootFromParent_Done,
      // Label 4806: @294033
      GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(294096), // Rule ID 986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 986,
        GIR_EraseRootFromParent_Done,
      // Label 4807: @294096
      GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(294129), // Rule ID 981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (srl:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_LSHR_B64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHR_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 981,
        GIR_EraseRootFromParent_Done,
      // Label 4808: @294129
      GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(294162), // Rule ID 985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (srl:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_LSHRREV_B64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 985,
        GIR_EraseRootFromParent_Done,
      // Label 4809: @294162
      GIM_Reject,
    // Label 4803: @294163
    GIM_Reject,
    // Label 4785: @294164
    GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(294332),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(294270), // Rule ID 1109 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1109,
        GIR_EraseRootFromParent_Done,
      // Label 4811: @294270
      GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(294331), // Rule ID 1108 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (srl:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_LSHRREV_B16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_LSHRREV_B16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1108,
        GIR_EraseRootFromParent_Done,
      // Label 4812: @294331
      GIM_Reject,
    // Label 4810: @294332
    GIM_Reject,
    // Label 4786: @294333
    GIM_Reject,
    // Label 48: @294334
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 4817*/ GIMT_Encode4(295495),
    /*GILLT_s16*//*Label 4813*/ GIMT_Encode4(294361),
    /*GILLT_s32*//*Label 4814*/ GIMT_Encode4(294672),
    /*GILLT_s64*//*Label 4815*/ GIMT_Encode4(295017),
    /*GILLT_v2s16*//*Label 4816*/ GIMT_Encode4(295326),
    // Label 4813: @294361
    GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(294671),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(294458), // Rule ID 856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 856,
        GIR_EraseRootFromParent_Done,
      // Label 4819: @294458
      GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(294514), // Rule ID 855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (sra:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_ASHRREV_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 855,
        GIR_EraseRootFromParent_Done,
      // Label 4820: @294514
      GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(294569), // Rule ID 854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 854,
        GIR_EraseRootFromParent_Done,
      // Label 4821: @294569
      GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(294624), // Rule ID 858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, (and:{ *:[i16] } i16:{ *:[i16] }:$src0, (imm:{ *:[i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 858,
        GIR_EraseRootFromParent_Done,
      // Label 4822: @294624
      GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(294647), // Rule ID 853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 853,
        GIR_EraseRootFromParent_Done,
      // Label 4823: @294647
      GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(294670), // Rule ID 857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)  =>  (V_ASHRREV_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 857,
        GIR_EraseRootFromParent_Done,
      // Label 4824: @294670
      GIM_Reject,
    // Label 4818: @294671
    GIM_Reject,
    // Label 4814: @294672
    GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(295016),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(294751), // Rule ID 77 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13397),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_13397>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 77,
        GIR_EraseRootFromParent_Done,
      // Label 4826: @294751
      GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(294807), // Rule ID 2399 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19061),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)<<P:Predicate_anonymous_19061>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2399,
        GIR_EraseRootFromParent_Done,
      // Label 4827: @294807
      GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(294841), // Rule ID 76 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13397),
        // (sra:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13397>>  =>  (S_ASHR_I32:{ *:[i32] }:{ *:[i1] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 76,
        GIR_Done,
      // Label 4828: @294841
      GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(294865), // Rule ID 2398 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19061),
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_19061>>  =>  (V_ASHRREV_I32_e64:{ *:[i32] } ?:{ *:[i32] }:$src1, ?:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2398,
        GIR_EraseRootFromParent_Done,
      // Label 4829: @294865
      GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(294917), // Rule ID 812 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, (and:{ *:[i32] } i32:{ *:[i32] }:$src0, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 812,
        GIR_EraseRootFromParent_Done,
      // Label 4830: @294917
      GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(294972), // Rule ID 838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_32),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_32>>)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 838,
        GIR_EraseRootFromParent_Done,
      // Label 4831: @294972
      GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(294992), // Rule ID 811 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)  =>  (V_ASHRREV_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 811,
        GIR_EraseRootFromParent_Done,
      // Label 4832: @294992
      GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(295015), // Rule ID 837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 837,
        GIR_Done,
      // Label 4833: @295015
      GIM_Reject,
    // Label 4825: @295016
    GIM_Reject,
    // Label 4815: @295017
    GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(295325),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(295096), // Rule ID 79 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13398),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, (and:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)<<P:Predicate_anonymous_13398>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 79,
        GIR_EraseRootFromParent_Done,
      // Label 4835: @295096
      GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(295130), // Rule ID 78 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13398),
        // (sra:{ *:[i64] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13398>>  =>  (S_ASHR_I64:{ *:[i64] }:{ *:[i1] } SSrc_b64:{ *:[i64] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ASHR_I64),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 78,
        GIR_Done,
      // Label 4836: @295130
      GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(295195), // Rule ID 984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), (and:{ *:[i32] } i32:{ *:[i32] }:$src1, (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 984,
        GIR_EraseRootFromParent_Done,
      // Label 4837: @295195
      GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(295258), // Rule ID 988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_64),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (and:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), (imm:{ *:[i32] }))<<P:Predicate_csh_mask_64>>)  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 988,
        GIR_EraseRootFromParent_Done,
      // Label 4838: @295258
      GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(295291), // Rule ID 983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (sra:{ *:[i64] } (VOP3Mods0:{ *:[i64] } i64:{ *:[i64] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_ASHR_I64_e64:{ *:[i64] } i64:{ *:[i64] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHR_I64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 983,
        GIR_EraseRootFromParent_Done,
      // Label 4839: @295291
      GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(295324), // Rule ID 987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (sra:{ *:[i64] } i64:{ *:[i64] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_ASHRREV_I64_e64:{ *:[i64] } i32:{ *:[i32] }:$src0, i64:{ *:[i64] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ASHRREV_I64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootToRootCopy, /*OpIdx*/1, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 987,
        GIR_EraseRootFromParent_Done,
      // Label 4840: @295324
      GIM_Reject,
    // Label 4834: @295325
    GIM_Reject,
    // Label 4816: @295326
    GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(295494),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(295432), // Rule ID 1107 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_csh_mask_16),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (and:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (imm:{ *:[v2i16] }))<<P:Predicate_csh_mask_16>>)  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1107,
        GIR_EraseRootFromParent_Done,
      // Label 4842: @295432
      GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(295493), // Rule ID 1106 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (sra:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_ASHRREV_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ASHRREV_I16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1106,
        GIR_EraseRootFromParent_Done,
      // Label 4843: @295493
      GIM_Reject,
    // Label 4841: @295494
    GIM_Reject,
    // Label 4817: @295495
    GIM_Reject,
    // Label 49: @295496
    GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(295540), // Rule ID 957 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fshr:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_RootToRootCopy, /*OpIdx*/3, // src2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 957,
      GIR_EraseRootFromParent_Done,
    // Label 4844: @295540
    GIM_Reject,
    // Label 50: @295541
    GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(295572), // Rule ID 7497 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ALIGNBIT_B32_e64:{ *:[i32] } ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src0, ?:{ *:[i32] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7497,
      GIR_EraseRootFromParent_Done,
    // Label 4845: @295572
    GIM_Reject,
    // Label 51: @295573
    GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(296834),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
      GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4850*/ GIMT_Encode4(296534),
      /*GILLT_s16*//*Label 4847*/ GIMT_Encode4(295604),
      /*GILLT_s32*//*Label 4848*/ GIMT_Encode4(296338),
      /*GILLT_s64*//*Label 4849*/ GIMT_Encode4(296436),
      // Label 4847: @295604
      GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(296337),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(295640), // Rule ID 460 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 460,
          GIR_EraseRootFromParent_Done,
        // Label 4852: @295640
        GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(295664), // Rule ID 461 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 461,
          GIR_EraseRootFromParent_Done,
        // Label 4853: @295664
        GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(295688), // Rule ID 462 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 462,
          GIR_EraseRootFromParent_Done,
        // Label 4854: @295688
        GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(295712), // Rule ID 466 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 466,
          GIR_EraseRootFromParent_Done,
        // Label 4855: @295712
        GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(295736), // Rule ID 467 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 467,
          GIR_EraseRootFromParent_Done,
        // Label 4856: @295736
        GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(295760), // Rule ID 468 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 468,
          GIR_EraseRootFromParent_Done,
        // Label 4857: @295760
        GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(295784), // Rule ID 469 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 469,
          GIR_EraseRootFromParent_Done,
        // Label 4858: @295784
        GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(295808), // Rule ID 470 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 470,
          GIR_EraseRootFromParent_Done,
        // Label 4859: @295808
        GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(295832), // Rule ID 471 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 471,
          GIR_EraseRootFromParent_Done,
        // Label 4860: @295832
        GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(295856), // Rule ID 475 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 475,
          GIR_EraseRootFromParent_Done,
        // Label 4861: @295856
        GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(295880), // Rule ID 476 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 476,
          GIR_EraseRootFromParent_Done,
        // Label 4862: @295880
        GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(295904), // Rule ID 477 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 477,
          GIR_EraseRootFromParent_Done,
        // Label 4863: @295904
        GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(295928), // Rule ID 484 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 484,
          GIR_EraseRootFromParent_Done,
        // Label 4864: @295928
        GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(295952), // Rule ID 485 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 485,
          GIR_EraseRootFromParent_Done,
        // Label 4865: @295952
        GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(295976), // Rule ID 486 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 486,
          GIR_EraseRootFromParent_Done,
        // Label 4866: @295976
        GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(296000), // Rule ID 487 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 487,
          GIR_EraseRootFromParent_Done,
        // Label 4867: @296000
        GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(296024), // Rule ID 489 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 489,
          GIR_EraseRootFromParent_Done,
        // Label 4868: @296024
        GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(296048), // Rule ID 491 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 491,
          GIR_EraseRootFromParent_Done,
        // Label 4869: @296048
        GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(296072), // Rule ID 493 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 493,
          GIR_EraseRootFromParent_Done,
        // Label 4870: @296072
        GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(296096), // Rule ID 494 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 494,
          GIR_EraseRootFromParent_Done,
        // Label 4871: @296096
        GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(296120), // Rule ID 495 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 495,
          GIR_EraseRootFromParent_Done,
        // Label 4872: @296120
        GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(296144), // Rule ID 496 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 496,
          GIR_EraseRootFromParent_Done,
        // Label 4873: @296144
        GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(296168), // Rule ID 497 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 497,
          GIR_EraseRootFromParent_Done,
        // Label 4874: @296168
        GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(296192), // Rule ID 498 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 498,
          GIR_EraseRootFromParent_Done,
        // Label 4875: @296192
        GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(296216), // Rule ID 499 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 499,
          GIR_EraseRootFromParent_Done,
        // Label 4876: @296216
        GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(296240), // Rule ID 501 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 501,
          GIR_EraseRootFromParent_Done,
        // Label 4877: @296240
        GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(296264), // Rule ID 503 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 503,
          GIR_EraseRootFromParent_Done,
        // Label 4878: @296264
        GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(296288), // Rule ID 505 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 505,
          GIR_EraseRootFromParent_Done,
        // Label 4879: @296288
        GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(296312), // Rule ID 506 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_t16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 506,
          GIR_EraseRootFromParent_Done,
        // Label 4880: @296312
        GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(296336), // Rule ID 507 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
          // (setcc:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U16_fake16_e64:{ *:[i1] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 507,
          GIR_EraseRootFromParent_Done,
        // Label 4881: @296336
        GIM_Reject,
      // Label 4851: @296337
      GIM_Reject,
      // Label 4848: @296338
      GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(296435),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(296371), // Rule ID 560 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 560,
          GIR_EraseRootFromParent_Done,
        // Label 4883: @296371
        GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(296392), // Rule ID 562 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 562,
          GIR_EraseRootFromParent_Done,
        // Label 4884: @296392
        GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(296413), // Rule ID 563 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 563,
          GIR_EraseRootFromParent_Done,
        // Label 4885: @296413
        GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(296434), // Rule ID 565 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 565,
          GIR_EraseRootFromParent_Done,
        // Label 4886: @296434
        GIM_Reject,
      // Label 4882: @296435
      GIM_Reject,
      // Label 4849: @296436
      GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(296533),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(296469), // Rule ID 576 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLT:{ *:[Other] })  =>  (V_CMP_LT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_I64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 576,
          GIR_EraseRootFromParent_Done,
        // Label 4888: @296469
        GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(296490), // Rule ID 578 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETLE:{ *:[Other] })  =>  (V_CMP_LE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_I64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 578,
          GIR_EraseRootFromParent_Done,
        // Label 4889: @296490
        GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(296511), // Rule ID 579 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGT:{ *:[Other] })  =>  (V_CMP_GT_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_I64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 579,
          GIR_EraseRootFromParent_Done,
        // Label 4890: @296511
        GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(296532), // Rule ID 581 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETGE:{ *:[Other] })  =>  (V_CMP_GE_I64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_I64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 581,
          GIR_EraseRootFromParent_Done,
        // Label 4891: @296532
        GIM_Reject,
      // Label 4887: @296533
      GIM_Reject,
      // Label 4850: @296534
      GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 4894*/ GIMT_Encode4(296833),
      /*GILLT_s32*//*Label 4892*/ GIMT_Encode4(296553),
      /*GILLT_s64*//*Label 4893*/ GIMT_Encode4(296693),
      // Label 4892: @296553
      GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(296692),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(296586), // Rule ID 592 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 592,
          GIR_EraseRootFromParent_Done,
        // Label 4896: @296586
        GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(296607), // Rule ID 593 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 593,
          GIR_EraseRootFromParent_Done,
        // Label 4897: @296607
        GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(296628), // Rule ID 595 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 595,
          GIR_EraseRootFromParent_Done,
        // Label 4898: @296628
        GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(296649), // Rule ID 596 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 596,
          GIR_EraseRootFromParent_Done,
        // Label 4899: @296649
        GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(296670), // Rule ID 597 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 597,
          GIR_EraseRootFromParent_Done,
        // Label 4900: @296670
        GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(296691), // Rule ID 599 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
          // (setcc:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 599,
          GIR_EraseRootFromParent_Done,
        // Label 4901: @296691
        GIM_Reject,
      // Label 4895: @296692
      GIM_Reject,
      // Label 4893: @296693
      GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(296832),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(296726), // Rule ID 610 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULT:{ *:[Other] })  =>  (V_CMP_LT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 610,
          GIR_EraseRootFromParent_Done,
        // Label 4903: @296726
        GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(296747), // Rule ID 611 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETEQ:{ *:[Other] })  =>  (V_CMP_EQ_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 611,
          GIR_EraseRootFromParent_Done,
        // Label 4904: @296747
        GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(296768), // Rule ID 613 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETULE:{ *:[Other] })  =>  (V_CMP_LE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 613,
          GIR_EraseRootFromParent_Done,
        // Label 4905: @296768
        GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(296789), // Rule ID 614 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGT:{ *:[Other] })  =>  (V_CMP_GT_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 614,
          GIR_EraseRootFromParent_Done,
        // Label 4906: @296789
        GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(296810), // Rule ID 615 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETNE:{ *:[Other] })  =>  (V_CMP_NE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NE_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 615,
          GIR_EraseRootFromParent_Done,
        // Label 4907: @296810
        GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(296831), // Rule ID 617 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
          // (setcc:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1, SETUGE:{ *:[Other] })  =>  (V_CMP_GE_U64_e64:{ *:[i1] } i64:{ *:[i64] }:$src0, i64:{ *:[i64] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_U64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_RootToRootCopy, /*OpIdx*/2, // src0
          GIR_RootToRootCopy, /*OpIdx*/3, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 617,
          GIR_EraseRootFromParent_Done,
        // Label 4908: @296831
        GIM_Reject,
      // Label 4902: @296832
      GIM_Reject,
      // Label 4894: @296833
      GIM_Reject,
    // Label 4846: @296834
    GIM_Reject,
    // Label 52: @296835
    GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(300955),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
      GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 4913*/ GIMT_Encode4(300954),
      /*GILLT_s16*//*Label 4910*/ GIMT_Encode4(296866),
      /*GILLT_s32*//*Label 4911*/ GIMT_Encode4(299358),
      /*GILLT_s64*//*Label 4912*/ GIMT_Encode4(300156),
      // Label 4910: @296866
      GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(299357),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(296937), // Rule ID 346 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 346,
          GIR_EraseRootFromParent_Done,
        // Label 4915: @296937
        GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(296996), // Rule ID 348 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 348,
          GIR_EraseRootFromParent_Done,
        // Label 4916: @296996
        GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(297055), // Rule ID 350 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 350,
          GIR_EraseRootFromParent_Done,
        // Label 4917: @297055
        GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(297114), // Rule ID 352 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 352,
          GIR_EraseRootFromParent_Done,
        // Label 4918: @297114
        GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(297173), // Rule ID 354 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 354,
          GIR_EraseRootFromParent_Done,
        // Label 4919: @297173
        GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(297232), // Rule ID 356 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 356,
          GIR_EraseRootFromParent_Done,
        // Label 4920: @297232
        GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(297291), // Rule ID 358 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 358,
          GIR_EraseRootFromParent_Done,
        // Label 4921: @297291
        GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(297350), // Rule ID 360 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 360,
          GIR_EraseRootFromParent_Done,
        // Label 4922: @297350
        GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(297409), // Rule ID 362 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 362,
          GIR_EraseRootFromParent_Done,
        // Label 4923: @297409
        GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(297468), // Rule ID 364 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 364,
          GIR_EraseRootFromParent_Done,
        // Label 4924: @297468
        GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(297527), // Rule ID 366 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 366,
          GIR_EraseRootFromParent_Done,
        // Label 4925: @297527
        GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(297586), // Rule ID 368 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 368,
          GIR_EraseRootFromParent_Done,
        // Label 4926: @297586
        GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(297645), // Rule ID 370 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 370,
          GIR_EraseRootFromParent_Done,
        // Label 4927: @297645
        GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(297704), // Rule ID 372 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 372,
          GIR_EraseRootFromParent_Done,
        // Label 4928: @297704
        GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(297763), // Rule ID 374 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 374,
          GIR_EraseRootFromParent_Done,
        // Label 4929: @297763
        GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(297822), // Rule ID 376 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 376,
          GIR_EraseRootFromParent_Done,
        // Label 4930: @297822
        GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(297881), // Rule ID 378 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 378,
          GIR_EraseRootFromParent_Done,
        // Label 4931: @297881
        GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(297940), // Rule ID 380 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 380,
          GIR_EraseRootFromParent_Done,
        // Label 4932: @297940
        GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(297999), // Rule ID 382 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 382,
          GIR_EraseRootFromParent_Done,
        // Label 4933: @297999
        GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(298058), // Rule ID 383 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 383,
          GIR_EraseRootFromParent_Done,
        // Label 4934: @298058
        GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(298117), // Rule ID 384 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 384,
          GIR_EraseRootFromParent_Done,
        // Label 4935: @298117
        GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(298176), // Rule ID 385 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 385,
          GIR_EraseRootFromParent_Done,
        // Label 4936: @298176
        GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(298235), // Rule ID 386 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 386,
          GIR_EraseRootFromParent_Done,
        // Label 4937: @298235
        GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(298294), // Rule ID 387 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 387,
          GIR_EraseRootFromParent_Done,
        // Label 4938: @298294
        GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(298353), // Rule ID 388 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 388,
          GIR_EraseRootFromParent_Done,
        // Label 4939: @298353
        GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(298412), // Rule ID 389 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 389,
          GIR_EraseRootFromParent_Done,
        // Label 4940: @298412
        GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(298471), // Rule ID 390 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 390,
          GIR_EraseRootFromParent_Done,
        // Label 4941: @298471
        GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(298530), // Rule ID 391 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 391,
          GIR_EraseRootFromParent_Done,
        // Label 4942: @298530
        GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(298589), // Rule ID 392 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 392,
          GIR_EraseRootFromParent_Done,
        // Label 4943: @298589
        GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(298648), // Rule ID 393 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 393,
          GIR_EraseRootFromParent_Done,
        // Label 4944: @298648
        GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(298707), // Rule ID 394 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 394,
          GIR_EraseRootFromParent_Done,
        // Label 4945: @298707
        GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(298766), // Rule ID 395 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 395,
          GIR_EraseRootFromParent_Done,
        // Label 4946: @298766
        GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(298825), // Rule ID 396 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 396,
          GIR_EraseRootFromParent_Done,
        // Label 4947: @298825
        GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(298884), // Rule ID 397 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 397,
          GIR_EraseRootFromParent_Done,
        // Label 4948: @298884
        GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(298943), // Rule ID 398 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 398,
          GIR_EraseRootFromParent_Done,
        // Label 4949: @298943
        GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(299002), // Rule ID 399 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 399,
          GIR_EraseRootFromParent_Done,
        // Label 4950: @299002
        GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(299061), // Rule ID 400 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 400,
          GIR_EraseRootFromParent_Done,
        // Label 4951: @299061
        GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(299120), // Rule ID 401 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 401,
          GIR_EraseRootFromParent_Done,
        // Label 4952: @299120
        GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(299179), // Rule ID 402 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 402,
          GIR_EraseRootFromParent_Done,
        // Label 4953: @299179
        GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(299238), // Rule ID 403 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 403,
          GIR_EraseRootFromParent_Done,
        // Label 4954: @299238
        GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(299297), // Rule ID 404 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseRealTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_t16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_t16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 404,
          GIR_EraseRootFromParent_Done,
        // Label 4955: @299297
        GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(299356), // Rule ID 405 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_UseFakeTrue16Insts),
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 405,
          GIR_EraseRootFromParent_Done,
        // Label 4956: @299356
        GIM_Reject,
      // Label 4914: @299357
      GIM_Reject,
      // Label 4911: @299358
      GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(300155),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(299426), // Rule ID 204 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 204,
          GIR_EraseRootFromParent_Done,
        // Label 4958: @299426
        GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(299482), // Rule ID 206 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 206,
          GIR_EraseRootFromParent_Done,
        // Label 4959: @299482
        GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(299538), // Rule ID 208 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 208,
          GIR_EraseRootFromParent_Done,
        // Label 4960: @299538
        GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(299594), // Rule ID 210 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 210,
          GIR_EraseRootFromParent_Done,
        // Label 4961: @299594
        GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(299650), // Rule ID 212 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 212,
          GIR_EraseRootFromParent_Done,
        // Label 4962: @299650
        GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(299706), // Rule ID 214 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 214,
          GIR_EraseRootFromParent_Done,
        // Label 4963: @299706
        GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(299762), // Rule ID 216 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 216,
          GIR_EraseRootFromParent_Done,
        // Label 4964: @299762
        GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(299818), // Rule ID 217 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 217,
          GIR_EraseRootFromParent_Done,
        // Label 4965: @299818
        GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(299874), // Rule ID 218 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 218,
          GIR_EraseRootFromParent_Done,
        // Label 4966: @299874
        GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(299930), // Rule ID 219 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 219,
          GIR_EraseRootFromParent_Done,
        // Label 4967: @299930
        GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(299986), // Rule ID 220 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 220,
          GIR_EraseRootFromParent_Done,
        // Label 4968: @299986
        GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(300042), // Rule ID 221 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 221,
          GIR_EraseRootFromParent_Done,
        // Label 4969: @300042
        GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(300098), // Rule ID 222 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 222,
          GIR_EraseRootFromParent_Done,
        // Label 4970: @300098
        GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(300154), // Rule ID 223 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 223,
          GIR_EraseRootFromParent_Done,
        // Label 4971: @300154
        GIM_Reject,
      // Label 4957: @300155
      GIM_Reject,
      // Label 4912: @300156
      GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(300953),
        GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(300224), // Rule ID 242 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLT:{ *:[Other] })  =>  (V_CMP_LT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LT_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 242,
          GIR_EraseRootFromParent_Done,
        // Label 4973: @300224
        GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(300280), // Rule ID 244 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOEQ:{ *:[Other] })  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 244,
          GIR_EraseRootFromParent_Done,
        // Label 4974: @300280
        GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(300336), // Rule ID 246 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOLE:{ *:[Other] })  =>  (V_CMP_LE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LE_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 246,
          GIR_EraseRootFromParent_Done,
        // Label 4975: @300336
        GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(300392), // Rule ID 248 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGT:{ *:[Other] })  =>  (V_CMP_GT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GT_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 248,
          GIR_EraseRootFromParent_Done,
        // Label 4976: @300392
        GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(300448), // Rule ID 250 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETONE:{ *:[Other] })  =>  (V_CMP_LG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_LG_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 250,
          GIR_EraseRootFromParent_Done,
        // Label 4977: @300448
        GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(300504), // Rule ID 252 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETOGE:{ *:[Other] })  =>  (V_CMP_GE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_GE_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 252,
          GIR_EraseRootFromParent_Done,
        // Label 4978: @300504
        GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(300560), // Rule ID 254 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETO:{ *:[Other] })  =>  (V_CMP_O_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_O_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 254,
          GIR_EraseRootFromParent_Done,
        // Label 4979: @300560
        GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(300616), // Rule ID 255 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUO:{ *:[Other] })  =>  (V_CMP_U_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_U_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 255,
          GIR_EraseRootFromParent_Done,
        // Label 4980: @300616
        GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(300672), // Rule ID 256 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULT:{ *:[Other] })  =>  (V_CMP_NGE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGE_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 256,
          GIR_EraseRootFromParent_Done,
        // Label 4981: @300672
        GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(300728), // Rule ID 257 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUEQ:{ *:[Other] })  =>  (V_CMP_NLG_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLG_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 257,
          GIR_EraseRootFromParent_Done,
        // Label 4982: @300728
        GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(300784), // Rule ID 258 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETULE:{ *:[Other] })  =>  (V_CMP_NGT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NGT_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 258,
          GIR_EraseRootFromParent_Done,
        // Label 4983: @300784
        GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(300840), // Rule ID 259 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGT),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGT:{ *:[Other] })  =>  (V_CMP_NLE_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLE_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 259,
          GIR_EraseRootFromParent_Done,
        // Label 4984: @300840
        GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(300896), // Rule ID 260 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUNE:{ *:[Other] })  =>  (V_CMP_NEQ_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NEQ_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 260,
          GIR_EraseRootFromParent_Done,
        // Label 4985: @300896
        GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(300952), // Rule ID 261 //
          // MIs[0] Operand 1
          GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
          // (setcc:{ *:[i1] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), SETUGE:{ *:[Other] })  =>  (V_CMP_NLT_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_NLT_F64_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 261,
          GIR_EraseRootFromParent_Done,
        // Label 4986: @300952
        GIM_Reject,
      // Label 4972: @300953
      GIM_Reject,
      // Label 4913: @300954
      GIM_Reject,
    // Label 4909: @300955
    GIM_Reject,
    // Label 53: @300956
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 4989*/ GIMT_Encode4(301159),
    /*GILLT_s16*//*Label 4987*/ GIMT_Encode4(300975),
    /*GILLT_s32*//*Label 4988*/ GIMT_Encode4(301043),
    // Label 4987: @300975
    GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(301042),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(301017), // Rule ID 7066 //
        // (select:{ *:[f16] } i1:{ *:[i1] }:$src0, f16:{ *:[f16] }:$src1, f16:{ *:[f16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[f16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7066,
        GIR_EraseRootFromParent_Done,
      // Label 4991: @301017
      GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(301041), // Rule ID 7067 //
        // (select:{ *:[i16] } i1:{ *:[i1] }:$src0, i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src2)  =>  (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src2, 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7067,
        GIR_EraseRootFromParent_Done,
      // Label 4992: @301041
      GIM_Reject,
    // Label 4990: @301042
    GIM_Reject,
    // Label 4988: @301043
    GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(301158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(301109), // Rule ID 7064 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (select:{ *:[i32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[i32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[i32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[i32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7064,
        GIR_EraseRootFromParent_Done,
      // Label 4994: @301109
      GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(301157), // Rule ID 7065 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (select:{ *:[f32] } i1:{ *:[i1] }:$src0, (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_CNDMASK_B32_e64:{ *:[f32] } FP32InputMods:{ *:[i32] }:$src2_mods, VSrc_b32:{ *:[f32] }:$src2, FP32InputMods:{ *:[i32] }:$src1_mods, VSrc_b32:{ *:[f32] }:$src1, SSrc_i1:{ *:[i1] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7065,
        GIR_EraseRootFromParent_Done,
      // Label 4995: @301157
      GIM_Reject,
    // Label 4993: @301158
    GIM_Reject,
    // Label 4989: @301159
    GIM_Reject,
    // Label 54: @301160
    GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(301268),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(301205), // Rule ID 86 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13400),
        // (mulhu:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13400>>  =>  (S_MUL_HI_U32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_U32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 86,
        GIR_Done,
      // Label 4997: @301205
      GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(301267),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(301240), // Rule ID 940 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (mulhu:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_RootToRootCopy, /*OpIdx*/2, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 940,
          GIR_EraseRootFromParent_Done,
        // Label 4999: @301240
        GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(301266), // Rule ID 8559 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_U32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_RootToRootCopy, /*OpIdx*/1, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 8559,
          GIR_EraseRootFromParent_Done,
        // Label 5000: @301266
        GIM_Reject,
      // Label 4998: @301267
      GIM_Reject,
    // Label 4996: @301268
    GIM_Reject,
    // Label 55: @301269
    GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(301377),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(301314), // Rule ID 87 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13401),
        // (mulhs:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13401>>  =>  (S_MUL_HI_I32:{ *:[i32] } SSrc_b32:{ *:[i32] }:$src0, SSrc_b32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_HI_I32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 87,
        GIR_Done,
      // Label 5002: @301314
      GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(301376),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(301349), // Rule ID 941 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (mulhs:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1)  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_RootToRootCopy, /*OpIdx*/2, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 941,
          GIR_EraseRootFromParent_Done,
        // Label 5004: @301349
        GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(301375), // Rule ID 8560 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$src1, (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_MUL_HI_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_HI_I32_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_RootToRootCopy, /*OpIdx*/1, // src1
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 8560,
          GIR_EraseRootFromParent_Done,
        // Label 5005: @301375
        GIM_Reject,
      // Label 5003: @301376
      GIM_Reject,
    // Label 5001: @301377
    GIM_Reject,
    // Label 56: @301378
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5009*/ GIMT_Encode4(301765),
    /*GILLT_s16*//*Label 5006*/ GIMT_Encode4(301405),
    /*GILLT_s32*//*Label 5007*/ GIMT_Encode4(301621), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 5008*/ GIMT_Encode4(301690),
    // Label 5006: @301405
    GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(301620),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(301475), // Rule ID 2581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2581,
        GIR_EraseRootFromParent_Done,
      // Label 5011: @301475
      GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(301534), // Rule ID 2584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2584,
        GIR_EraseRootFromParent_Done,
      // Label 5012: @301534
      GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(301593), // Rule ID 2586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (uaddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_NC_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2586,
        GIR_EraseRootFromParent_Done,
      // Label 5013: @301593
      GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(301619), // Rule ID 2472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (uaddsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_ADD_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2472,
        GIR_EraseRootFromParent_Done,
      // Label 5014: @301619
      GIM_Reject,
    // Label 5010: @301620
    GIM_Reject,
    // Label 5007: @301621
    GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(301689),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(301658), // Rule ID 2470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
        // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2470,
        GIR_EraseRootFromParent_Done,
      // Label 5016: @301658
      GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(301688), // Rule ID 2468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
        // (uaddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_CO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2468,
        GIR_EraseRootFromParent_Done,
      // Label 5017: @301688
      GIM_Reject,
    // Label 5015: @301689
    GIM_Reject,
    // Label 5008: @301690
    GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(301764), // Rule ID 2633 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (uaddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2633,
      GIR_EraseRootFromParent_Done,
    // Label 5018: @301764
    GIM_Reject,
    // Label 5009: @301765
    GIM_Reject,
    // Label 57: @301766
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5022*/ GIMT_Encode4(302091),
    /*GILLT_s16*//*Label 5019*/ GIMT_Encode4(301793),
    /*GILLT_s32*//*Label 5020*/ GIMT_Encode4(301983), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 5021*/ GIMT_Encode4(302016),
    // Label 5019: @301793
    GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(301982),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(301863), // Rule ID 2510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2510,
        GIR_EraseRootFromParent_Done,
      // Label 5024: @301863
      GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(301922), // Rule ID 2512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2512,
        GIR_EraseRootFromParent_Done,
      // Label 5025: @301922
      GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(301981), // Rule ID 2514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (saddsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2514,
        GIR_EraseRootFromParent_Done,
      // Label 5026: @301981
      GIM_Reject,
    // Label 5023: @301982
    GIM_Reject,
    // Label 5020: @301983
    GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(302015), // Rule ID 2507 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (saddsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_ADD_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2507,
      GIR_EraseRootFromParent_Done,
    // Label 5027: @302015
    GIM_Reject,
    // Label 5021: @302016
    GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(302090), // Rule ID 2634 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (saddsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2634,
      GIR_EraseRootFromParent_Done,
    // Label 5028: @302090
    GIM_Reject,
    // Label 5022: @302091
    GIM_Reject,
    // Label 58: @302092
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5032*/ GIMT_Encode4(302479),
    /*GILLT_s16*//*Label 5029*/ GIMT_Encode4(302119),
    /*GILLT_s32*//*Label 5030*/ GIMT_Encode4(302335), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 5031*/ GIMT_Encode4(302404),
    // Label 5029: @302119
    GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(302334),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(302189), // Rule ID 2582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2582,
        GIR_EraseRootFromParent_Done,
      // Label 5034: @302189
      GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(302248), // Rule ID 2585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2585,
        GIR_EraseRootFromParent_Done,
      // Label 5035: @302248
      GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(302307), // Rule ID 2587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (usubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_NC_U16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_NC_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2587,
        GIR_EraseRootFromParent_Done,
      // Label 5036: @302307
      GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(302333), // Rule ID 2473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasIntClamp),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (usubsat:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_SUB_U16_e64:{ *:[i16] } VSrc_b16:{ *:[i16] }:$src0, VSrc_b16:{ *:[i16] }:$src1, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2473,
        GIR_EraseRootFromParent_Done,
      // Label 5037: @302333
      GIM_Reject,
    // Label 5033: @302334
    GIM_Reject,
    // Label 5030: @302335
    GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(302403),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(302372), // Rule ID 2471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts_HasIntClamp),
        // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2471,
        GIR_EraseRootFromParent_Done,
      // Label 5039: @302372
      GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(302402), // Rule ID 2469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasIntClamp),
        // (usubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_CO_U32_e64:{ *:[i32] }:{ *:[i1] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2469,
        GIR_EraseRootFromParent_Done,
      // Label 5040: @302402
      GIM_Reject,
    // Label 5038: @302403
    GIM_Reject,
    // Label 5031: @302404
    GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(302478), // Rule ID 2635 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (usubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_U16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2635,
      GIR_EraseRootFromParent_Done,
    // Label 5041: @302478
    GIM_Reject,
    // Label 5032: @302479
    GIM_Reject,
    // Label 59: @302480
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5045*/ GIMT_Encode4(302805),
    /*GILLT_s16*//*Label 5042*/ GIMT_Encode4(302507),
    /*GILLT_s32*//*Label 5043*/ GIMT_Encode4(302697), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 5044*/ GIMT_Encode4(302730),
    // Label 5042: @302507
    GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(302696),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(302577), // Rule ID 2511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2511,
        GIR_EraseRootFromParent_Done,
      // Label 5047: @302577
      GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(302636), // Rule ID 2513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_t16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2513,
        GIR_EraseRootFromParent_Done,
      // Label 5048: @302636
      GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(302695), // Rule ID 2515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opsel),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opsel),
        // (ssubsat:{ *:[i16] } (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSel:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_I16_fake16_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[i16] }:$src1, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2515,
        GIR_EraseRootFromParent_Done,
      // Label 5049: @302695
      GIM_Reject,
    // Label 5046: @302696
    GIM_Reject,
    // Label 5043: @302697
    GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(302729), // Rule ID 2508 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (ssubsat:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_SUB_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2508,
      GIR_EraseRootFromParent_Done,
    // Label 5050: @302729
    GIM_Reject,
    // Label 5044: @302730
    GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(302804), // Rule ID 2636 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (ssubsat:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_SUB_I16:{ *:[v2i16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2i16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[v2i16] }:$src1, 1:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_SUB_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2636,
      GIR_EraseRootFromParent_Done,
    // Label 5051: @302804
    GIM_Reject,
    // Label 5045: @302805
    GIM_Reject,
    // Label 60: @302806
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5057*/ GIMT_Encode4(304163),
    /*GILLT_s16*//*Label 5052*/ GIMT_Encode4(302837),
    /*GILLT_s32*//*Label 5053*/ GIMT_Encode4(303199),
    /*GILLT_s64*//*Label 5054*/ GIMT_Encode4(303763),
    /*GILLT_v2s16*//*Label 5055*/ GIMT_Encode4(304016),
    /*GILLT_v2s32*//*Label 5056*/ GIMT_Encode4(304088),
    // Label 5052: @302837
    GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(303198),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(302883), // Rule ID 97 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13402),
        // (fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13402>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 97,
        GIR_Done,
      // Label 5059: @302883
      GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(302946), // Rule ID 860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 860,
        GIR_EraseRootFromParent_Done,
      // Label 5060: @302946
      GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(303009), // Rule ID 864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 864,
        GIR_EraseRootFromParent_Done,
      // Label 5061: @303009
      GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(303072), // Rule ID 8520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8520,
        GIR_EraseRootFromParent_Done,
      // Label 5062: @303072
      GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(303135), // Rule ID 8522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8522,
        GIR_EraseRootFromParent_Done,
      // Label 5063: @303135
      GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(303197), // Rule ID 862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 862,
        GIR_EraseRootFromParent_Done,
      // Label 5064: @303197
      GIM_Reject,
    // Label 5058: @303198
    GIM_Reject,
    // Label 5053: @303199
    GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(303762),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(303306), // Rule ID 11241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fadd:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2), (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11241,
        GIR_EraseRootFromParent_Done,
      // Label 5066: @303306
      GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(303408), // Rule ID 11243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod), (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11243,
        GIR_EraseRootFromParent_Done,
      // Label 5067: @303408
      GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(303504), // Rule ID 7056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals_isGFX6GFX7GFX10),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1)), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_LEGACY_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7056,
        GIR_EraseRootFromParent_Done,
      // Label 5068: @303504
      GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(303606), // Rule ID 7062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts_NoFP32Denormals),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
        GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::amdgcn_fmul_legacy),
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f32] } (intrinsic_wo_chain:{ *:[f32] } 2180:{ *:[iPTR] }, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mod)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mod))  =>  (V_MAD_LEGACY_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mod, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mod, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mod, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_LEGACY_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mod
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7062,
        GIR_EraseRootFromParent_Done,
      // Label 5069: @303606
      GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(303641), // Rule ID 89 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13402),
        // (fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13402>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 89,
        GIR_Done,
      // Label 5070: @303641
      GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(303701), // Rule ID 786 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 786,
        GIR_EraseRootFromParent_Done,
      // Label 5071: @303701
      GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(303761), // Rule ID 8509 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8509,
        GIR_EraseRootFromParent_Done,
      // Label 5072: @303761
      GIM_Reject,
    // Label 5065: @303762
    GIM_Reject,
    // Label 5054: @303763
    GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(304015),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(303837), // Rule ID 914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 914,
        GIR_EraseRootFromParent_Done,
      // Label 5074: @303837
      GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(303896), // Rule ID 932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 932,
        GIR_EraseRootFromParent_Done,
      // Label 5075: @303896
      GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(303955), // Rule ID 8538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8538,
        GIR_EraseRootFromParent_Done,
      // Label 5076: @303955
      GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(304014), // Rule ID 8551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8551,
        GIR_EraseRootFromParent_Done,
      // Label 5077: @304014
      GIM_Reject,
    // Label 5073: @304015
    GIM_Reject,
    // Label 5055: @304016
    GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(304087), // Rule ID 1088 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1088,
      GIR_EraseRootFromParent_Done,
    // Label 5078: @304087
    GIM_Reject,
    // Label 5056: @304088
    GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(304162), // Rule ID 1314 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1314,
      GIR_EraseRootFromParent_Done,
    // Label 5079: @304162
    GIM_Reject,
    // Label 5057: @304163
    GIM_Reject,
    // Label 61: @304164
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5082*/ GIMT_Encode4(304527),
    /*GILLT_s16*//*Label 5080*/ GIMT_Encode4(304183),
    /*GILLT_s32*//*Label 5081*/ GIMT_Encode4(304419),
    // Label 5080: @304183
    GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(304418),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(304229), // Rule ID 105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13406),
        // (fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13406>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 105,
        GIR_Done,
      // Label 5084: @304229
      GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(304292), // Rule ID 866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 866,
        GIR_EraseRootFromParent_Done,
      // Label 5085: @304292
      GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(304355), // Rule ID 870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 870,
        GIR_EraseRootFromParent_Done,
      // Label 5086: @304355
      GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(304417), // Rule ID 868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 868,
        GIR_EraseRootFromParent_Done,
      // Label 5087: @304417
      GIM_Reject,
    // Label 5083: @304418
    GIM_Reject,
    // Label 5081: @304419
    GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(304526),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(304465), // Rule ID 107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13406),
        // (fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13406>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 107,
        GIR_Done,
      // Label 5089: @304465
      GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(304525), // Rule ID 788 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 788,
        GIR_EraseRootFromParent_Done,
      // Label 5090: @304525
      GIM_Reject,
    // Label 5088: @304526
    GIM_Reject,
    // Label 5082: @304527
    GIM_Reject,
    // Label 62: @304528
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5096*/ GIMT_Encode4(305913),
    /*GILLT_s16*//*Label 5091*/ GIMT_Encode4(304559),
    /*GILLT_s32*//*Label 5092*/ GIMT_Encode4(304921),
    /*GILLT_s64*//*Label 5093*/ GIMT_Encode4(305089),
    /*GILLT_v2s16*//*Label 5094*/ GIMT_Encode4(305766),
    /*GILLT_v2s32*//*Label 5095*/ GIMT_Encode4(305838),
    // Label 5091: @304559
    GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(304920),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(304605), // Rule ID 99 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13405),
        // (fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13405>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 99,
        GIR_Done,
      // Label 5098: @304605
      GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(304668), // Rule ID 872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 872,
        GIR_EraseRootFromParent_Done,
      // Label 5099: @304668
      GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(304731), // Rule ID 876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 876,
        GIR_EraseRootFromParent_Done,
      // Label 5100: @304731
      GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(304794), // Rule ID 8524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8524,
        GIR_EraseRootFromParent_Done,
      // Label 5101: @304794
      GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(304857), // Rule ID 8526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8526,
        GIR_EraseRootFromParent_Done,
      // Label 5102: @304857
      GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(304919), // Rule ID 874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 874,
        GIR_EraseRootFromParent_Done,
      // Label 5103: @304919
      GIM_Reject,
    // Label 5097: @304920
    GIM_Reject,
    // Label 5092: @304921
    GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(305088),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(304967), // Rule ID 95 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13405),
        // (fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13405>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 95,
        GIR_Done,
      // Label 5105: @304967
      GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(305027), // Rule ID 792 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 792,
        GIR_EraseRootFromParent_Done,
      // Label 5106: @305027
      GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(305087), // Rule ID 8513 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8513,
        GIR_EraseRootFromParent_Done,
      // Label 5107: @305087
      GIM_Reject,
    // Label 5104: @305088
    GIM_Reject,
    // Label 5093: @305089
    GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(305765),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(305178), // Rule ID 7868 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7868,
        GIR_EraseRootFromParent_Done,
      // Label 5109: @305178
      GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(305252), // Rule ID 12926 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12926,
        GIR_EraseRootFromParent_Done,
      // Label 5110: @305252
      GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(305328), // Rule ID 7872 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7872,
        GIR_EraseRootFromParent_Done,
      // Label 5111: @305328
      GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(305404), // Rule ID 12930 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12930,
        GIR_EraseRootFromParent_Done,
      // Label 5112: @305404
      GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(305466), // Rule ID 12928 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12928,
        GIR_EraseRootFromParent_Done,
      // Label 5113: @305466
      GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(305528), // Rule ID 7870 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7870,
        GIR_EraseRootFromParent_Done,
      // Label 5114: @305528
      GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(305587), // Rule ID 915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 915,
        GIR_EraseRootFromParent_Done,
      // Label 5115: @305587
      GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(305646), // Rule ID 934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 934,
        GIR_EraseRootFromParent_Done,
      // Label 5116: @305646
      GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(305705), // Rule ID 8539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8539,
        GIR_EraseRootFromParent_Done,
      // Label 5117: @305705
      GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(305764), // Rule ID 8553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8553,
        GIR_EraseRootFromParent_Done,
      // Label 5118: @305764
      GIM_Reject,
    // Label 5108: @305765
    GIM_Reject,
    // Label 5094: @305766
    GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(305837), // Rule ID 1090 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1090,
      GIR_EraseRootFromParent_Done,
    // Label 5119: @305837
    GIM_Reject,
    // Label 5095: @305838
    GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(305912), // Rule ID 1312 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1312,
      GIR_EraseRootFromParent_Done,
    // Label 5120: @305912
    GIM_Reject,
    // Label 5096: @305913
    GIM_Reject,
    // Label 63: @305914
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5126*/ GIMT_Encode4(307551),
    /*GILLT_s16*//*Label 5121*/ GIMT_Encode4(305945),
    /*GILLT_s32*//*Label 5122*/ GIMT_Encode4(306379),
    /*GILLT_s64*//*Label 5123*/ GIMT_Encode4(307132),
    /*GILLT_v2s16*//*Label 5124*/ GIMT_Encode4(307364),
    /*GILLT_v2s32*//*Label 5125*/ GIMT_Encode4(307456),
    // Label 5121: @305945
    GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(306378),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(305998), // Rule ID 113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13408),
        // (fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13408>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 113,
        GIR_Done,
      // Label 5128: @305998
      GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(306068), // Rule ID 7644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f16] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7644,
        GIR_EraseRootFromParent_Done,
      // Label 5129: @306068
      GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(306138), // Rule ID 7645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX10Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fma:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_FMAC_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7645,
        GIR_EraseRootFromParent_Done,
      // Label 5130: @306138
      GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(306218), // Rule ID 996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 996,
        GIR_EraseRootFromParent_Done,
      // Label 5131: @306218
      GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(306298), // Rule ID 8568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8568,
        GIR_EraseRootFromParent_Done,
      // Label 5132: @306298
      GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(306377), // Rule ID 1004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1004,
        GIR_EraseRootFromParent_Done,
      // Label 5133: @306377
      GIM_Reject,
    // Label 5127: @306378
    GIM_Reject,
    // Label 5122: @306379
    GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(307131),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(306472), // Rule ID 2648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2648,
        GIR_EraseRootFromParent_Done,
      // Label 5135: @306472
      GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(306551), // Rule ID 2649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2649,
        GIR_EraseRootFromParent_Done,
      // Label 5136: @306551
      GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(306630), // Rule ID 2650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2650,
        GIR_EraseRootFromParent_Done,
      // Label 5137: @306630
      GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(306709), // Rule ID 8610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8610,
        GIR_EraseRootFromParent_Done,
      // Label 5138: @306709
      GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(306788), // Rule ID 8611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fma:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8611,
        GIR_EraseRootFromParent_Done,
      // Label 5139: @306788
      GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(306867), // Rule ID 8612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        // (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_FMA_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8612,
        GIR_EraseRootFromParent_Done,
      // Label 5140: @306867
      GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(306906), // Rule ID 111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13408),
        // (fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13408>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 111,
        GIR_Done,
      // Label 5141: @306906
      GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(306976), // Rule ID 7643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDLInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fma:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_FMAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7643,
        GIR_EraseRootFromParent_Done,
      // Label 5142: @306976
      GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(307053), // Rule ID 927 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 927,
        GIR_EraseRootFromParent_Done,
      // Label 5143: @307053
      GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(307130), // Rule ID 8547 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8547,
        GIR_EraseRootFromParent_Done,
      // Label 5144: @307130
      GIM_Reject,
    // Label 5134: @307131
    GIM_Reject,
    // Label 5123: @307132
    GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(307363),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(307216), // Rule ID 7646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmacF64Inst),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fma:{ *:[f64] } (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src0), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src1), (VOP3NoMods:{ *:[f64] } f64:{ *:[f64] }:$src2))  =>  (V_FMAC_F64_e64:{ *:[f64] } 0:{ *:[i32] }, ?:{ *:[f64] }:$src0, 0:{ *:[i32] }, ?:{ *:[f64] }:$src1, 0:{ *:[i32] }, ?:{ *:[f64] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMAC_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7646,
        GIR_EraseRootFromParent_Done,
      // Label 5146: @307216
      GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(307289), // Rule ID 930 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 930,
        GIR_EraseRootFromParent_Done,
      // Label 5147: @307289
      GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(307362), // Rule ID 8549 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8549,
        GIR_EraseRootFromParent_Done,
      // Label 5148: @307362
      GIM_Reject,
    // Label 5145: @307363
    GIM_Reject,
    // Label 5124: @307364
    GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(307455), // Rule ID 1086 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1086,
      GIR_EraseRootFromParent_Done,
    // Label 5149: @307455
    GIM_Reject,
    // Label 5125: @307456
    GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(307550), // Rule ID 1310 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1310,
      GIR_EraseRootFromParent_Done,
    // Label 5150: @307550
    GIM_Reject,
    // Label 5126: @307551
    GIM_Reject,
    // Label 64: @307552
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5153*/ GIMT_Encode4(308497),
    /*GILLT_s16*//*Label 5151*/ GIMT_Encode4(307571),
    /*GILLT_s32*//*Label 5152*/ GIMT_Encode4(307809),
    // Label 5151: @307571
    GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(307808),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(307655), // Rule ID 7059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fmad:{ *:[f16] } (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src0), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src1), (VOP3NoMods:{ *:[f16] } f16:{ *:[f16] }:$src2))  =>  (V_MAC_F16_e64:{ *:[f16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src0, 0:{ *:[i32] }, ?:{ *:[f16] }:$src1, 0:{ *:[i32] }, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7059,
        GIR_EraseRootFromParent_Done,
      // Label 5155: @307655
      GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(307731), // Rule ID 1005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmad:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1005,
        GIR_EraseRootFromParent_Done,
      // Label 5156: @307731
      GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(307807), // Rule ID 8569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmad:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8569,
        GIR_EraseRootFromParent_Done,
      // Label 5157: @307807
      GIM_Reject,
    // Label 5154: @307808
    GIM_Reject,
    // Label 5152: @307809
    GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(308496),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(307902), // Rule ID 2637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2637,
        GIR_EraseRootFromParent_Done,
      // Label 5159: @307902
      GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(307977), // Rule ID 2638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2638,
        GIR_EraseRootFromParent_Done,
      // Label 5160: @307977
      GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(308052), // Rule ID 2639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2639,
        GIR_EraseRootFromParent_Done,
      // Label 5161: @308052
      GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(308118), // Rule ID 7053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_no_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_no_mods),
        // (fmad:{ *:[f32] } (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src0), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src1), (VOP3NoMods:{ *:[f32] } f32:{ *:[f32] }:$src2))  =>  (V_MAC_F32_e64:{ *:[f32] } 0:{ *:[i32] }, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAC_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7053,
        GIR_EraseRootFromParent_Done,
      // Label 5162: @308118
      GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(308193), // Rule ID 8607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8607,
        GIR_EraseRootFromParent_Done,
      // Label 5163: @308193
      GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(308268), // Rule ID 8608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (fmad:{ *:[f32] } (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8608,
        GIR_EraseRootFromParent_Done,
      // Label 5164: @308268
      GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(308343), // Rule ID 8609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods_ext),
        // (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMadMixModsExt:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAD_MIX_F32:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIX_F32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8609,
        GIR_EraseRootFromParent_Done,
      // Label 5165: @308343
      GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(308419), // Rule ID 922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmad:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 922,
        GIR_EraseRootFromParent_Done,
      // Label 5166: @308419
      GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(308495), // Rule ID 8544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMacF32Insts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmad:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MAD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8544,
        GIR_EraseRootFromParent_Done,
      // Label 5167: @308495
      GIM_Reject,
    // Label 5158: @308496
    GIM_Reject,
    // Label 5153: @308497
    GIM_Reject,
    // Label 65: @308498
    GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(308615), // Rule ID 7479 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (fpow:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_EXP_F32_e64:{ *:[f32] } 0:{ *:[i32] }, (V_MUL_LEGACY_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, (V_LOG_F32_e64:{ *:[i16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0), 0:{ *:[i1] }, 0:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F32_e64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
      GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_LEGACY_F32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7479,
      GIR_EraseRootFromParent_Done,
    // Label 5168: @308615
    GIM_Reject,
    // Label 66: @308616
    GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(308838),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(308698), // Rule ID 2611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20844),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20844>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_EXP_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_EXP_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2611,
        GIR_EraseRootFromParent_Done,
      // Label 5170: @308698
      GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(308792),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(308749), // Rule ID 743 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 743,
          GIR_EraseRootFromParent_Done,
        // Label 5172: @308749
        GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(308791), // Rule ID 747 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (fexp2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_EXP_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 747,
          GIR_EraseRootFromParent_Done,
        // Label 5173: @308791
        GIM_Reject,
      // Label 5171: @308792
      GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(308837), // Rule ID 745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fexp2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_EXP_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_EXP_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 745,
        GIR_EraseRootFromParent_Done,
      // Label 5174: @308837
      GIM_Reject,
    // Label 5169: @308838
    GIM_Reject,
    // Label 67: @308839
    GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(309061),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(308921), // Rule ID 2613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20846),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20846>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_LOG_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_LOG_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2613,
        GIR_EraseRootFromParent_Done,
      // Label 5176: @308921
      GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(309015),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(308972), // Rule ID 737 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 737,
          GIR_EraseRootFromParent_Done,
        // Label 5178: @308972
        GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(309014), // Rule ID 741 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
          // (flog2:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_LOG_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 741,
          GIR_EraseRootFromParent_Done,
        // Label 5179: @309014
        GIM_Reject,
      // Label 5177: @309015
      GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(309060), // Rule ID 739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (flog2:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_LOG_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LOG_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 739,
        GIR_EraseRootFromParent_Done,
      // Label 5180: @309060
      GIM_Reject,
    // Label 5175: @309061
    GIM_Reject,
    // Label 68: @309062
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5184*/ GIMT_Encode4(309424),
    /*GILLT_s16*//*Label 5181*/ GIMT_Encode4(309085),
    /*GILLT_s32*//*Label 5182*/ GIMT_Encode4(309290),
    /*GILLT_s64*//*Label 5183*/ GIMT_Encode4(309357),
    // Label 5181: @309085
    GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(309289),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(309159), // Rule ID 2416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2416,
        GIR_EraseRootFromParent_Done,
      // Label 5186: @309159
      GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(309225), // Rule ID 2418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2418,
        GIR_EraseRootFromParent_Done,
      // Label 5187: @309225
      GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(309288), // Rule ID 2420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2420,
        GIR_EraseRootFromParent_Done,
      // Label 5188: @309288
      GIM_Reject,
    // Label 5185: @309289
    GIM_Reject,
    // Label 5182: @309290
    GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(309356), // Rule ID 822 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 822,
      GIR_EraseRootFromParent_Done,
    // Label 5189: @309356
    GIM_Reject,
    // Label 5183: @309357
    GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(309423), // Rule ID 977 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 977,
      GIR_EraseRootFromParent_Done,
    // Label 5190: @309423
    GIM_Reject,
    // Label 5184: @309424
    GIM_Reject,
    // Label 69: @309425
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5196*/ GIMT_Encode4(311763),
    /*GILLT_s16*//*Label 5191*/ GIMT_Encode4(309456),
    /*GILLT_s32*//*Label 5192*/ GIMT_Encode4(310418),
    /*GILLT_s64*//*Label 5193*/ GIMT_Encode4(310672),
    /*GILLT_v2s16*//*Label 5194*/ GIMT_Encode4(311350),
    /*GILLT_v2s32*//*Label 5195*/ GIMT_Encode4(311706),
    // Label 5191: @309456
    GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(310417),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(309537), // Rule ID 7377 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src))<<P:Predicate_anonymous_33728>>  =>  (S_OR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7377,
        GIR_EraseRootFromParent_Done,
      // Label 5198: @309537
      GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(309610), // Rule ID 7380 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[bf16] } (fabs:{ *:[bf16] } SReg_32:{ *:[bf16] }:$src))<<P:Predicate_anonymous_33728>>  =>  (S_OR_B32:{ *:[bf16] }:{ *:[i1] } SReg_32:{ *:[bf16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7380,
        GIR_EraseRootFromParent_Done,
      // Label 5199: @309610
      GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(309679), // Rule ID 7396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7396,
        GIR_EraseRootFromParent_Done,
      // Label 5200: @309679
      GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(309740), // Rule ID 7399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src))  =>  (V_OR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7399,
        GIR_EraseRootFromParent_Done,
      // Label 5201: @309740
      GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(309809), // Rule ID 7402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f16] } (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src))  =>  (V_OR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7402,
        GIR_EraseRootFromParent_Done,
      // Label 5202: @309809
      GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(309878), // Rule ID 7405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[bf16] } (fabs:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src))  =>  (V_OR_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7405,
        GIR_EraseRootFromParent_Done,
      // Label 5203: @309878
      GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(309947), // Rule ID 7408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[bf16] } (fabs:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src))  =>  (V_OR_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7408,
        GIR_EraseRootFromParent_Done,
      // Label 5204: @309947
      GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(310008), // Rule ID 7411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[bf16] } (fabs:{ *:[bf16] } VGPR_16:{ *:[bf16] }:$src))  =>  (V_OR_B16_t16_e64:{ *:[bf16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[bf16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7411,
        GIR_EraseRootFromParent_Done,
      // Label 5205: @310008
      GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(310064), // Rule ID 7375 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        // (fneg:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_33728>>  =>  (S_XOR_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7375,
        GIR_EraseRootFromParent_Done,
      // Label 5206: @310064
      GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(310120), // Rule ID 7378 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        // (fneg:{ *:[bf16] } SReg_32:{ *:[bf16] }:$src)<<P:Predicate_anonymous_33728>>  =>  (S_XOR_B32:{ *:[bf16] }:{ *:[i1] } SReg_32:{ *:[bf16] }:$src, (S_MOV_B32:{ *:[i1] } 32768:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7378,
        GIR_EraseRootFromParent_Done,
      // Label 5207: @310120
      GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(310172), // Rule ID 7395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7395,
        GIR_EraseRootFromParent_Done,
      // Label 5208: @310172
      GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(310216), // Rule ID 7398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // (fneg:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_XOR_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7398,
        GIR_EraseRootFromParent_Done,
      // Label 5209: @310216
      GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(310268), // Rule ID 7401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7401,
        GIR_EraseRootFromParent_Done,
      // Label 5210: @310268
      GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(310320), // Rule ID 7404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src)  =>  (V_XOR_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7404,
        GIR_EraseRootFromParent_Done,
      // Label 5211: @310320
      GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(310372), // Rule ID 7407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src)  =>  (V_XOR_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32768:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32768),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7407,
        GIR_EraseRootFromParent_Done,
      // Label 5212: @310372
      GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(310416), // Rule ID 7410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // (fneg:{ *:[bf16] } VGPR_16:{ *:[bf16] }:$src)  =>  (V_XOR_B16_t16_e64:{ *:[bf16] } 0:{ *:[i32] }, 32768:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[bf16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32768),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7410,
        GIR_EraseRootFromParent_Done,
      // Label 5213: @310416
      GIM_Reject,
    // Label 5197: @310417
    GIM_Reject,
    // Label 5192: @310418
    GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(310671),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(310499), // Rule ID 7372 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src))<<P:Predicate_anonymous_33728>>  =>  (S_OR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7372,
        GIR_EraseRootFromParent_Done,
      // Label 5215: @310499
      GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(310565), // Rule ID 7391 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f32] } (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src))  =>  (V_OR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7391,
        GIR_EraseRootFromParent_Done,
      // Label 5216: @310565
      GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(310621), // Rule ID 7374 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        // (fneg:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_33728>>  =>  (S_XOR_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7374,
        GIR_EraseRootFromParent_Done,
      // Label 5217: @310621
      GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(310670), // Rule ID 7393 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_XOR_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483648:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7393,
        GIR_EraseRootFromParent_Done,
      // Label 5218: @310670
      GIM_Reject,
    // Label 5214: @310671
    GIM_Reject,
    // Label 5193: @310672
    GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(311349),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(310868), // Rule ID 7390 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src))<<P:Predicate_anonymous_33728>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_OR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        // GIR_Coverage, 7390,
        GIR_EraseRootFromParent_Done,
      // Label 5220: @310868
      GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(311029), // Rule ID 7417 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[f64] } (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src))  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_OR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7417,
        GIR_EraseRootFromParent_Done,
      // Label 5221: @311029
      GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(311202), // Rule ID 7389 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        // (fneg:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_33728>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_XOR_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        // GIR_Coverage, 7389,
        GIR_EraseRootFromParent_Done,
      // Label 5222: @311202
      GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(311348), // Rule ID 7416 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (fneg:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_XOR_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483648:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483648),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7416,
        GIR_EraseRootFromParent_Done,
      // Label 5223: @311348
      GIM_Reject,
    // Label 5219: @311349
    GIM_Reject,
    // Label 5194: @311350
    GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(311705),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(311460), // Rule ID 7383 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2147450879),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (fneg:{ *:[v2f16] } (bitconvert:{ *:[v2f16] } (and:{ *:[i32] } SReg_32:{ *:[i32] }:$src, 2147450879:{ *:[i32] })<<P:Predicate_and_oneuse>>))<<P:Predicate_anonymous_33728>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[i32] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7383,
        GIR_EraseRootFromParent_Done,
      // Label 5225: @311460
      GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(311533), // Rule ID 7384 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src))<<P:Predicate_anonymous_33728>>  =>  (S_OR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_OR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7384,
        GIR_EraseRootFromParent_Done,
      // Label 5226: @311533
      GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(311599), // Rule ID 7414 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s16,
        GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (fneg:{ *:[v2f16] } (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src))  =>  (V_OR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_OR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7414,
        GIR_EraseRootFromParent_Done,
      // Label 5227: @311599
      GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(311655), // Rule ID 7381 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33728),
        // (fneg:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_33728>>  =>  (S_XOR_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147516416:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_XOR_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7381,
        GIR_EraseRootFromParent_Done,
      // Label 5228: @311655
      GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(311704), // Rule ID 7412 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fneg:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_XOR_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147516416:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147516416),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_XOR_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7412,
        GIR_EraseRootFromParent_Done,
      // Label 5229: @311704
      GIM_Reject,
    // Label 5224: @311705
    GIM_Reject,
    // Label 5195: @311706
    GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(311762), // Rule ID 7418 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33776),
      // (fneg:{ *:[v2f32] } VReg_64:{ *:[v2f32] }:$src)<<P:Predicate_anonymous_33776>>  =>  (V_PK_ADD_F32:{ *:[v2f32] } 11:{ *:[i32] }, VReg_64:{ *:[v2f32] }:$src, 11:{ *:[i32] }, 0:{ *:[i64] }, 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7418,
      GIR_EraseRootFromParent_Done,
    // Label 5230: @311762
    GIM_Reject,
    // Label 5196: @311763
    GIM_Reject,
    // Label 70: @311764
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 5233*/ GIMT_Encode4(312163),
    /*GILLT_s32*//*Label 5231*/ GIMT_Encode4(311783),
    /*GILLT_s64*//*Label 5232*/ GIMT_Encode4(311957),
    // Label 5231: @311783
    GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(311956),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(311818), // Rule ID 31 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13375),
        // (fpextend:{ *:[f32] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13375>>  =>  (S_CVT_F32_F16:{ *:[f32] } f16:{ *:[f16] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 31,
        GIR_Done,
      // Label 5235: @311818
      GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(311864), // Rule ID 645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 645,
        GIR_EraseRootFromParent_Done,
      // Label 5236: @311864
      GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(311910), // Rule ID 649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fpextend:{ *:[f32] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F16_fake16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 649,
        GIR_EraseRootFromParent_Done,
      // Label 5237: @311910
      GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(311955), // Rule ID 647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fpextend:{ *:[f32] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F32_F16_t16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 647,
        GIR_EraseRootFromParent_Done,
      // Label 5238: @311955
      GIM_Reject,
    // Label 5234: @311956
    GIM_Reject,
    // Label 5232: @311957
    GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(312009), // Rule ID 7036 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7036,
      GIR_EraseRootFromParent_Done,
    // Label 5239: @312009
    GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(312064), // Rule ID 7042 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7042,
      GIR_EraseRootFromParent_Done,
    // Label 5240: @312064
    GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(312116), // Rule ID 7048 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (fpextend:{ *:[f64] } f16:{ *:[f16] }:$src)  =>  (V_CVT_F64_F32_e32:{ *:[f64] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7048,
      GIR_EraseRootFromParent_Done,
    // Label 5241: @312116
    GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(312162), // Rule ID 631 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fpextend:{ *:[f64] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_F32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 631,
      GIR_EraseRootFromParent_Done,
    // Label 5242: @312162
    GIM_Reject,
    // Label 5233: @312163
    GIM_Reject,
    // Label 71: @312164
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5246*/ GIMT_Encode4(313530),
    /*GILLT_s16*//*Label 5243*/ GIMT_Encode4(312191),
    /*GILLT_s32*//*Label 5244*/ GIMT_Encode4(312986), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 5245*/ GIMT_Encode4(313033),
    // Label 5243: @312191
    GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(312312), // Rule ID 2651 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      // (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2651,
      GIR_EraseRootFromParent_Done,
    // Label 5247: @312312
    GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(312433), // Rule ID 2640 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAD),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      // (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_modifiers, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2640,
      GIR_EraseRootFromParent_Done,
    // Label 5248: @312433
    GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(312539), // Rule ID 2644 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_MAD_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2644,
      GIR_EraseRootFromParent_Done,
    // Label 5249: @312539
    GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(312645), // Rule ID 2655 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
      GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
      // (fpround:{ *:[f16] } (fmul:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers)))  =>  (V_FMA_MIXLO_F16:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f32] }:$src1, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2655,
      GIR_EraseRootFromParent_Done,
    // Label 5250: @312645
    GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(312714), // Rule ID 2606 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16ConversionInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fpround:{ *:[bf16] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))<<P:Predicate_bf16_fpround>>  =>  (V_CVT_PK_BF16_F32_e64:{ *:[bf16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2606,
      GIR_EraseRootFromParent_Done,
    // Label 5251: @312714
    GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(312809), // Rule ID 2607 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16ConversionInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fpround:{ *:[bf16] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))<<P:Predicate_bf16_fpround>>  =>  (V_CVT_PK_BF16_F32_e64:{ *:[bf16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0), 0:{ *:[i32] }, (IMPLICIT_DEF:{ *:[f32] }))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2607,
      GIR_EraseRootFromParent_Done,
    // Label 5252: @312809
    GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(312839), // Rule ID 36 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13380),
      // (fpround:{ *:[f16] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13380>>  =>  (S_CVT_F16_F32:{ *:[f16] } f32:{ *:[f32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F16_F32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 36,
      GIR_Done,
    // Label 5253: @312839
    GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(312888), // Rule ID 639 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 639,
      GIR_EraseRootFromParent_Done,
    // Label 5254: @312888
    GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(312937), // Rule ID 643 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fpround:{ *:[f16] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 643,
      GIR_EraseRootFromParent_Done,
    // Label 5255: @312937
    GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(312985), // Rule ID 641 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
      // (fpround:{ *:[f16] } (VOP3OpSelMods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 641,
      GIR_EraseRootFromParent_Done,
    // Label 5256: @312985
    GIM_Reject,
    // Label 5244: @312986
    GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(313032), // Rule ID 629 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fpround:{ *:[f32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_F64_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 629,
      GIR_EraseRootFromParent_Done,
    // Label 5257: @313032
    GIM_Reject,
    // Label 5245: @313033
    GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(313133), // Rule ID 2603 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16ConversionInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
      // (fpround:{ *:[v2bf16] } v2f32:{ *:[v2f32] }:$src)<<P:Predicate_bf16_fpround>>  =>  (V_CVT_PK_BF16_F32_e64:{ *:[v2bf16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub1:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2603,
      GIR_EraseRootFromParent_Done,
    // Label 5258: @313133
    GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(313285), // Rule ID 2604 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBF16ConversionInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf16_fpround),
      // (fpround:{ *:[v2bf16] } v2f64:{ *:[v2f64] }:$src)<<P:Predicate_bf16_fpround>>  =>  (V_CVT_PK_BF16_F32_e64:{ *:[v2bf16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub0_sub1:{ *:[i32] })), 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub2_sub3:{ *:[i32] })))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(24), // src
      GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_BF16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2604,
      GIR_EraseRootFromParent_Done,
    // Label 5259: @313285
    GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(313381), // Rule ID 2526 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fpround:{ *:[v2f16] } v2f32:{ *:[v2f32] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub0:{ *:[i32] }), 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[v2f32] }:$src, sub1:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2526,
      GIR_EraseRootFromParent_Done,
    // Label 5260: @313381
    GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(313529), // Rule ID 2527 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCvtPkF16F32Inst),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fpround:{ *:[v2f16] } v2f64:{ *:[v2f64] }:$src)  =>  (V_CVT_PK_F16_F32_e64:{ *:[v2f16] } 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub0_sub1:{ *:[i32] })), 0:{ *:[i32] }, (V_CVT_F32_F64_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i64] } VReg_128:{ *:[v2f64] }:$src, sub2_sub3:{ *:[i32] })))
      GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(24), // src
      GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F64_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_F16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2527,
      GIR_EraseRootFromParent_Done,
    // Label 5261: @313529
    GIM_Reject,
    // Label 5246: @313530
    GIM_Reject,
    // Label 72: @313531
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5265*/ GIMT_Encode4(314198),
    /*GILLT_s1*//*Label 5262*/ GIMT_Encode4(313554),
    /*GILLT_s16*//*Label 5263*/ GIMT_Encode4(313769),
    /*GILLT_s32*//*Label 5264*/ GIMT_Encode4(313916),
    // Label 5262: @313554
    GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(313609), // Rule ID 7562 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7562,
      GIR_EraseRootFromParent_Done,
    // Label 5266: @313609
    GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(313664), // Rule ID 7564 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 48128:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7564,
      GIR_EraseRootFromParent_Done,
    // Label 5267: @313664
    GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(313716), // Rule ID 7566 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7566,
      GIR_EraseRootFromParent_Done,
    // Label 5268: @313716
    GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(313768), // Rule ID 7568 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_sint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, -4616189618054758400:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-4616189618054758400),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7568,
      GIR_EraseRootFromParent_Done,
    // Label 5269: @313768
    GIM_Reject,
    // Label 5263: @313769
    GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(313915),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(313823), // Rule ID 715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 715,
        GIR_EraseRootFromParent_Done,
      // Label 5271: @313823
      GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(313869), // Rule ID 717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fp_to_sint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 717,
        GIR_EraseRootFromParent_Done,
      // Label 5272: @313869
      GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(313914), // Rule ID 716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fp_to_sint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_I16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I16_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 716,
        GIR_EraseRootFromParent_Done,
      // Label 5273: @313914
      GIM_Reject,
    // Label 5270: @313915
    GIM_Reject,
    // Label 5264: @313916
    GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(313946), // Rule ID 29 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13373),
      // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13373>>  =>  (S_CVT_I32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_I32_F32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 29,
      GIR_Done,
    // Label 5274: @313946
    GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(313998), // Rule ID 7037 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7037,
      GIR_EraseRootFromParent_Done,
    // Label 5275: @313998
    GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(314053), // Rule ID 7043 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7043,
      GIR_EraseRootFromParent_Done,
    // Label 5276: @314053
    GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(314105), // Rule ID 7049 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_I32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7049,
      GIR_EraseRootFromParent_Done,
    // Label 5277: @314105
    GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(314151), // Rule ID 627 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 627,
      GIR_EraseRootFromParent_Done,
    // Label 5278: @314151
    GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(314197), // Rule ID 637 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fp_to_sint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_I32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_I32_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 637,
      GIR_EraseRootFromParent_Done,
    // Label 5279: @314197
    GIM_Reject,
    // Label 5265: @314198
    GIM_Reject,
    // Label 73: @314199
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(10), /*)*//*default:*//*Label 5283*/ GIMT_Encode4(314866),
    /*GILLT_s1*//*Label 5280*/ GIMT_Encode4(314222),
    /*GILLT_s16*//*Label 5281*/ GIMT_Encode4(314437),
    /*GILLT_s32*//*Label 5282*/ GIMT_Encode4(314584),
    // Label 5280: @314222
    GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(314277), // Rule ID 7561 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7561,
      GIR_EraseRootFromParent_Done,
    // Label 5284: @314277
    GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(314332), // Rule ID 7563 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F16_t16_e64:{ *:[i1] } 0:{ *:[i32] }, 15360:{ *:[i16] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F16_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7563,
      GIR_EraseRootFromParent_Done,
    // Label 5285: @314332
    GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(314384), // Rule ID 7565 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F32_e64:{ *:[i1] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f32] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7565,
      GIR_EraseRootFromParent_Done,
    // Label 5286: @314384
    GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(314436), // Rule ID 7567 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (fp_to_uint:{ *:[i1] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CMP_EQ_F64_e64:{ *:[i1] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f64] }:$src0, 0:{ *:[i1] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_EQ_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7567,
      GIR_EraseRootFromParent_Done,
    // Label 5287: @314436
    GIM_Reject,
    // Label 5281: @314437
    GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(314583),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(314491), // Rule ID 712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 712,
        GIR_EraseRootFromParent_Done,
      // Label 5289: @314491
      GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(314537), // Rule ID 714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fp_to_uint:{ *:[i16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U16_F16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 714,
        GIR_EraseRootFromParent_Done,
      // Label 5290: @314537
      GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(314582), // Rule ID 713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fp_to_uint:{ *:[i16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_U16_F16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U16_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 713,
        GIR_EraseRootFromParent_Done,
      // Label 5291: @314582
      GIM_Reject,
    // Label 5288: @314583
    GIM_Reject,
    // Label 5282: @314584
    GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(314614), // Rule ID 30 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13374),
      // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13374>>  =>  (S_CVT_U32_F32:{ *:[i32] } f32:{ *:[f32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_U32_F32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 30,
      GIR_Done,
    // Label 5292: @314614
    GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(314666), // Rule ID 7038 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7038,
      GIR_EraseRootFromParent_Done,
    // Label 5293: @314666
    GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(314721), // Rule ID 7044 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_t16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrcT_b16:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_t16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7044,
      GIR_EraseRootFromParent_Done,
    // Label 5294: @314721
    GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(314773), // Rule ID 7050 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$src)  =>  (V_CVT_U32_F32_e32:{ *:[i32] } (V_CVT_F32_F16_fake16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[f16] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_F16_fake16_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7050,
      GIR_EraseRootFromParent_Done,
    // Label 5295: @314773
    GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(314819), // Rule ID 632 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F64_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 632,
      GIR_EraseRootFromParent_Done,
    // Label 5296: @314819
    GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(314865), // Rule ID 636 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fp_to_uint:{ *:[i32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_U32_F32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_U32_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 636,
      GIR_EraseRootFromParent_Done,
    // Label 5297: @314865
    GIM_Reject,
    // Label 5283: @314866
    GIM_Reject,
    // Label 74: @314867
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5301*/ GIMT_Encode4(315599),
    /*GILLT_s16*//*Label 5298*/ GIMT_Encode4(314890),
    /*GILLT_s32*//*Label 5299*/ GIMT_Encode4(315393),
    /*GILLT_s64*//*Label 5300*/ GIMT_Encode4(315505),
    // Label 5298: @314890
    GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(314942), // Rule ID 7039 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7039,
      GIR_EraseRootFromParent_Done,
    // Label 5302: @314942
    GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(314997), // Rule ID 7045 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7045,
      GIR_EraseRootFromParent_Done,
    // Label 5303: @314997
    GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(315049), // Rule ID 7051 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_I32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7051,
      GIR_EraseRootFromParent_Done,
    // Label 5304: @315049
    GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(315111), // Rule ID 7585 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7585,
      GIR_EraseRootFromParent_Done,
    // Label 5305: @315111
    GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(315185), // Rule ID 7586 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7586,
      GIR_EraseRootFromParent_Done,
    // Label 5306: @315185
    GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(315256), // Rule ID 7587 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(3212836864),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7587,
      GIR_EraseRootFromParent_Done,
    // Label 5307: @315256
    GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(315300), // Rule ID 709 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 709,
      GIR_EraseRootFromParent_Done,
    // Label 5308: @315300
    GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(315344), // Rule ID 711 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (sint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_I16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 711,
      GIR_EraseRootFromParent_Done,
    // Label 5309: @315344
    GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(315392), // Rule ID 710 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
      // (sint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_I16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_I16_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 710,
      GIR_EraseRootFromParent_Done,
    // Label 5310: @315392
    GIM_Reject,
    // Label 5299: @315393
    GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(315423), // Rule ID 27 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13371),
      // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13371>>  =>  (S_CVT_F32_I32:{ *:[f32] } i32:{ *:[i32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_I32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 27,
      GIR_Done,
    // Label 5311: @315423
    GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(315463), // Rule ID 7591 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (sint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 3212836864:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7591,
      GIR_EraseRootFromParent_Done,
    // Label 5312: @315463
    GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(315504), // Rule ID 634 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (sint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_I32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 634,
      GIR_EraseRootFromParent_Done,
    // Label 5313: @315504
    GIM_Reject,
    // Label 5300: @315505
    GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(315557), // Rule ID 7593 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (sint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_I32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, -1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7593,
      GIR_EraseRootFromParent_Done,
    // Label 5314: @315557
    GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(315598), // Rule ID 628 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (sint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_I32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 628,
      GIR_EraseRootFromParent_Done,
    // Label 5315: @315598
    GIM_Reject,
    // Label 5301: @315599
    GIM_Reject,
    // Label 75: @315600
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5319*/ GIMT_Encode4(316332),
    /*GILLT_s16*//*Label 5316*/ GIMT_Encode4(315623),
    /*GILLT_s32*//*Label 5317*/ GIMT_Encode4(316126),
    /*GILLT_s64*//*Label 5318*/ GIMT_Encode4(316238),
    // Label 5316: @315623
    GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(315675), // Rule ID 7040 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7040,
      GIR_EraseRootFromParent_Done,
    // Label 5320: @315675
    GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(315730), // Rule ID 7046 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7046,
      GIR_EraseRootFromParent_Done,
    // Label 5321: @315730
    GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(315782), // Rule ID 7052 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (uint_to_fp:{ *:[f16] } i32:{ *:[i32] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CVT_F32_U32_e32:{ *:[i16] } VSrc_b32:{ *:[i32] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7052,
      GIR_EraseRootFromParent_Done,
    // Label 5322: @315782
    GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(315844), // Rule ID 7588 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_e32:{ *:[f16] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7588,
      GIR_EraseRootFromParent_Done,
    // Label 5323: @315844
    GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(315918), // Rule ID 7589 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_t16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] }, 0:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7589,
      GIR_EraseRootFromParent_Done,
    // Label 5324: @315918
    GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(315989), // Rule ID 7590 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (uint_to_fp:{ *:[f16] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F16_F32_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src), 0:{ *:[i1] }, 0:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(1065353216),
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_F32_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7590,
      GIR_EraseRootFromParent_Done,
    // Label 5325: @315989
    GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(316033), // Rule ID 706 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 706,
      GIR_EraseRootFromParent_Done,
    // Label 5326: @316033
    GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(316077), // Rule ID 708 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (uint_to_fp:{ *:[f16] } (VOP3Mods0:{ *:[i16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F16_U16_fake16_e64:{ *:[f16] } i16:{ *:[i16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_fake16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 708,
      GIR_EraseRootFromParent_Done,
    // Label 5327: @316077
    GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(316125), // Rule ID 707 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
      // (uint_to_fp:{ *:[f16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CVT_F16_U16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F16_U16_t16_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 707,
      GIR_EraseRootFromParent_Done,
    // Label 5328: @316125
    GIM_Reject,
    // Label 5317: @316126
    GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(316156), // Rule ID 28 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13372),
      // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13372>>  =>  (S_CVT_F32_U32:{ *:[f32] } i32:{ *:[i32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CVT_F32_U32),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 28,
      GIR_Done,
    // Label 5329: @316156
    GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(316196), // Rule ID 7592 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (uint_to_fp:{ *:[f32] } i1:{ *:[i1] }:$src)  =>  (V_CNDMASK_B32_e64:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1065353216:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
      GIR_RootToRootCopy, /*OpIdx*/1, // src
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7592,
      GIR_EraseRootFromParent_Done,
    // Label 5330: @316196
    GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(316237), // Rule ID 635 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (uint_to_fp:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_U32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_U32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 635,
      GIR_EraseRootFromParent_Done,
    // Label 5331: @316237
    GIM_Reject,
    // Label 5318: @316238
    GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(316290), // Rule ID 7594 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      // (uint_to_fp:{ *:[f64] } i1:{ *:[i1] }:$src)  =>  (V_CVT_F64_U32_e32:{ *:[f64] } (V_CNDMASK_B32_e64:{ *:[i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, SSrc_i1:{ *:[i1] }:$src))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B32_e64),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
      GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7594,
      GIR_EraseRootFromParent_Done,
    // Label 5332: @316290
    GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(316331), // Rule ID 633 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (uint_to_fp:{ *:[f64] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F64_U32_e64:{ *:[f64] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F64_U32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 633,
      GIR_EraseRootFromParent_Done,
    // Label 5333: @316331
    GIM_Reject,
    // Label 5319: @316332
    GIM_Reject,
    // Label 76: @316333
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5338*/ GIMT_Encode4(317337),
    /*GILLT_s16*//*Label 5334*/ GIMT_Encode4(316360),
    /*GILLT_s32*//*Label 5335*/ GIMT_Encode4(316778),
    /*GILLT_s64*//*Label 5336*/ GIMT_Encode4(316893),
    /*GILLT_v2s16*//*Label 5337*/ GIMT_Encode4(317222),
    // Label 5334: @316360
    GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(316777),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(316424), // Rule ID 7376 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33730),
        // (fabs:{ *:[f16] } SReg_32:{ *:[f16] }:$src)<<P:Predicate_anonymous_33730>>  =>  (S_AND_B32:{ *:[f16] }:{ *:[i1] } SReg_32:{ *:[f16] }:$src, (S_MOV_B32:{ *:[i1] } 32767:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7376,
        GIR_EraseRootFromParent_Done,
      // Label 5340: @316424
      GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(316480), // Rule ID 7379 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33730),
        // (fabs:{ *:[bf16] } SReg_32:{ *:[bf16] }:$src)<<P:Predicate_anonymous_33730>>  =>  (S_AND_B32:{ *:[bf16] }:{ *:[i1] } SReg_32:{ *:[bf16] }:$src, (S_MOV_B32:{ *:[i1] } 32767:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7379,
        GIR_EraseRootFromParent_Done,
      // Label 5341: @316480
      GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(316532), // Rule ID 7394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7394,
        GIR_EraseRootFromParent_Done,
      // Label 5342: @316532
      GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(316576), // Rule ID 7397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // (fabs:{ *:[f16] } VGPR_16:{ *:[f16] }:$src)  =>  (V_AND_B16_t16_e64:{ *:[f16] } 0:{ *:[i32] }, 32767:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32767),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7397,
        GIR_EraseRootFromParent_Done,
      // Label 5343: @316576
      GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(316628), // Rule ID 7400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[f16] } VGPR_32:{ *:[f16] }:$src)  =>  (V_AND_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7400,
        GIR_EraseRootFromParent_Done,
      // Label 5344: @316628
      GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(316680), // Rule ID 7403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src)  =>  (V_AND_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7403,
        GIR_EraseRootFromParent_Done,
      // Label 5345: @316680
      GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(316732), // Rule ID 7406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[bf16] } VGPR_32:{ *:[bf16] }:$src)  =>  (V_AND_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), VGPR_32:{ *:[bf16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7406,
        GIR_EraseRootFromParent_Done,
      // Label 5346: @316732
      GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(316776), // Rule ID 7409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        // (fabs:{ *:[bf16] } VGPR_16:{ *:[bf16] }:$src)  =>  (V_AND_B16_t16_e64:{ *:[bf16] } 0:{ *:[i32] }, 32767:{ *:[i16] }, 0:{ *:[i32] }, VGPR_16:{ *:[bf16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(32767),
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7409,
        GIR_EraseRootFromParent_Done,
      // Label 5347: @316776
      GIM_Reject,
    // Label 5339: @316777
    GIM_Reject,
    // Label 5335: @316778
    GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(316892),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(316842), // Rule ID 7373 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33730),
        // (fabs:{ *:[f32] } SReg_32:{ *:[f32] }:$src)<<P:Predicate_anonymous_33730>>  =>  (S_AND_B32:{ *:[f32] }:{ *:[i1] } SReg_32:{ *:[f32] }:$src, (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7373,
        GIR_EraseRootFromParent_Done,
      // Label 5349: @316842
      GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(316891), // Rule ID 7392 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[f32] } VGPR_32:{ *:[f32] }:$src)  =>  (V_AND_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), VGPR_32:{ *:[f32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7392,
        GIR_EraseRootFromParent_Done,
      // Label 5350: @316891
      GIM_Reject,
    // Label 5348: @316892
    GIM_Reject,
    // Label 5336: @316893
    GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(317221),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(317074), // Rule ID 7388 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33730),
        // (fabs:{ *:[f64] } SReg_64:{ *:[f64] }:$src)<<P:Predicate_anonymous_33730>>  =>  (REG_SEQUENCE:{ *:[f64] } SReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_AND_B32:{ *:[i1] }:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i1] } 2147483647:{ *:[i32] })), SReg_32:{ *:[i32] }), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/5, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
        GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for AMDGPU::SCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        // GIR_Coverage, 7388,
        GIR_EraseRootFromParent_Done,
      // Label 5352: @317074
      GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(317220), // Rule ID 7415 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // (fabs:{ *:[f64] } VReg_64:{ *:[f64] }:$src)  =>  (REG_SEQUENCE:{ *:[f64] } VReg_64:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub0:{ *:[i32] }), sub0:{ *:[i32] }, (V_AND_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i32] } 2147483647:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[f64] }:$src, sub1:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7415,
        GIR_EraseRootFromParent_Done,
      // Label 5353: @317220
      GIM_Reject,
    // Label 5351: @317221
    GIM_Reject,
    // Label 5337: @317222
    GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(317336),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(317286), // Rule ID 7382 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33730),
        // (fabs:{ *:[v2f16] } SReg_32:{ *:[v2f16] }:$src)<<P:Predicate_anonymous_33730>>  =>  (S_AND_B32:{ *:[v2f16] }:{ *:[i1] } SReg_32:{ *:[v2f16] }:$src, (S_MOV_B32:{ *:[i1] } 2147450879:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7382,
        GIR_EraseRootFromParent_Done,
      // Label 5355: @317286
      GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(317335), // Rule ID 7413 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fabs:{ *:[v2f16] } VGPR_32:{ *:[v2f16] }:$src)  =>  (V_AND_B32_e64:{ *:[v2f16] } (S_MOV_B32:{ *:[i16] } 2147450879:{ *:[i32] }), VGPR_32:{ *:[v2f16] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147450879),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_AND_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7413,
        GIR_EraseRootFromParent_Done,
      // Label 5356: @317335
      GIM_Reject,
    // Label 5354: @317336
    GIM_Reject,
    // Label 5338: @317337
    GIM_Reject,
    // Label 77: @317338
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 5359*/ GIMT_Encode4(317894),
    /*GILLT_s16*//*Label 5357*/ GIMT_Encode4(317357),
    /*GILLT_s32*//*Label 5358*/ GIMT_Encode4(317611),
    // Label 5357: @317357
    GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(317610),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(317415), // Rule ID 7419 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, ?:{ *:[f16] }:$src1)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7419,
        GIR_EraseRootFromParent_Done,
      // Label 5361: @317415
      GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(317487), // Rule ID 7422 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f16] } f16:{ *:[f16] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[f16] }:$src0, (V_LSHRREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f32] }:$src1))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7422,
        GIR_EraseRootFromParent_Done,
      // Label 5362: @317487
      GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(317537), // Rule ID 7424 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[bf16] } bf16:{ *:[bf16] }:$src0, bf16:{ *:[bf16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[bf16] }:$src0, ?:{ *:[bf16] }:$src1)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7424,
        GIR_EraseRootFromParent_Done,
      // Label 5363: @317537
      GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(317609), // Rule ID 7427 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[bf16] } bf16:{ *:[bf16] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[bf16] } (S_MOV_B32:{ *:[i16] } 32767:{ *:[i32] }), ?:{ *:[bf16] }:$src0, (V_LSHRREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f32] }:$src1))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHRREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7427,
        GIR_EraseRootFromParent_Done,
      // Label 5364: @317609
      GIM_Reject,
    // Label 5360: @317610
    GIM_Reject,
    // Label 5358: @317611
    GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(317893),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(317691), // Rule ID 7420 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f16:{ *:[f16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (V_LSHLREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[f16] }:$src1))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7420,
        GIR_EraseRootFromParent_Done,
      // Label 5366: @317691
      GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(317763), // Rule ID 7425 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, bf16:{ *:[bf16] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (V_LSHLREV_B32_e64:{ *:[i16] } 16:{ *:[i32] }, ?:{ *:[bf16] }:$src1))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_LSHLREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/16,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7425,
        GIR_EraseRootFromParent_Done,
      // Label 5367: @317763
      GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(317813), // Rule ID 7493 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f32:{ *:[f32] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, ?:{ *:[f32] }:$src1)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_RootToRootCopy, /*OpIdx*/2, // src1
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7493,
        GIR_EraseRootFromParent_Done,
      // Label 5368: @317813
      GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(317892), // Rule ID 7494 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$src0, f64:{ *:[f64] }:$src1)  =>  (V_BFI_B32_e64:{ *:[f32] } (S_MOV_B32:{ *:[i16] } 2147483647:{ *:[i32] }), ?:{ *:[f32] }:$src0, (EXTRACT_SUBREG:{ *:[i32] } SReg_64:{ *:[f64] }:$src1, sub1:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(11), // src1
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(2147483647),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7494,
        GIR_EraseRootFromParent_Done,
      // Label 5369: @317892
      GIM_Reject,
    // Label 5365: @317893
    GIM_Reject,
    // Label 5359: @317894
    GIM_Reject,
    // Label 78: @317895
    GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(318166),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 5374*/ GIMT_Encode4(318165),
      /*GILLT_s16*//*Label 5371*/ GIMT_Encode4(317926),
      /*GILLT_s32*//*Label 5372*/ GIMT_Encode4(318049),
      /*GILLT_s64*//*Label 5373*/ GIMT_Encode4(318107),
      // Label 5371: @317926
      GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(318048),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(317991), // Rule ID 2791 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
          // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2791,
          GIR_EraseRootFromParent_Done,
        // Label 5376: @317991
        GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(318047), // Rule ID 2792 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
          // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F16_fake16_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f16:{ *:[f16] }:$src0, 0:{ *:[i32] }, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
          GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F16_fake16_e64),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
          GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 2792,
          GIR_EraseRootFromParent_Done,
        // Label 5377: @318047
        GIM_Reject,
      // Label 5375: @318048
      GIM_Reject,
      // Label 5372: @318049
      GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(318106), // Rule ID 2793 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        // MIs[0] mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F32_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f32:{ *:[f32] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2793,
        GIR_EraseRootFromParent_Done,
      // Label 5378: @318106
      GIM_Reject,
      // Label 5373: @318107
      GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(318164), // Rule ID 2794 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_1RegClassID),
        // MIs[0] mask
        GIM_CheckIsImm, /*MI*/0, /*Op*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3modsnoncanonicalizing),
        // (is_fpclass:{ *:[i1] } (VOP3ModsNonCanonicalizing:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (timm:{ *:[i32] }):$mask)  =>  (V_CMP_CLASS_F64_e64:{ *:[i1] } i32:{ *:[i32] }:$src0_mods, f64:{ *:[f64] }:$src0, (V_MOV_B32_e32:{ *:[i16] } (timm:{ *:[i32] }):$mask))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B32_e32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // mask
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2794,
        GIR_EraseRootFromParent_Done,
      // Label 5379: @318164
      GIM_Reject,
      // Label 5374: @318165
      GIM_Reject,
    // Label 5370: @318166
    GIM_Reject,
    // Label 79: @318167
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 5385*/ GIMT_Encode4(319366),
    /*GILLT_s16*//*Label 5380*/ GIMT_Encode4(318198),
    /*GILLT_s32*//*Label 5381*/ GIMT_Encode4(318636),
    /*GILLT_s64*//*Label 5382*/ GIMT_Encode4(318856),
    /*GILLT_v2s16*//*Label 5383*/ GIMT_Encode4(319113),
    /*GILLT_v2s32*//*Label 5384*/ GIMT_Encode4(319298),
    // Label 5380: @318198
    GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(318635),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(318258), // Rule ID 7634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_NotHasTrue16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7634,
        GIR_EraseRootFromParent_Done,
      // Label 5387: @318258
      GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(318306), // Rule ID 7635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_HasMinMaxDenormModes_HasTrue16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7635,
        GIR_EraseRootFromParent_Done,
      // Label 5388: @318306
      GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(318354), // Rule ID 7640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_NotHasMinMaxDenormModes_NotHasTrue16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7640,
        GIR_EraseRootFromParent_Done,
      // Label 5389: @318354
      GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(318402), // Rule ID 7641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_Has16BitInsts_HasTrue16BitInsts_NotHasMinMaxDenormModes),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7641,
        GIR_EraseRootFromParent_Done,
      // Label 5390: @318402
      GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(318467), // Rule ID 7623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7623,
        GIR_EraseRootFromParent_Done,
      // Label 5391: @318467
      GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(318532), // Rule ID 7625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTrue16BitInsts),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (fneg:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 48128:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(48128),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7625,
        GIR_EraseRootFromParent_Done,
      // Label 5392: @318532
      GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(318583), // Rule ID 7622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7622,
        GIR_EraseRootFromParent_Done,
      // Label 5393: @318583
      GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(318634), // Rule ID 7624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTrue16BitInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f16] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7624,
        GIR_EraseRootFromParent_Done,
      // Label 5394: @318634
      GIM_Reject,
    // Label 5386: @318635
    GIM_Reject,
    // Label 5381: @318636
    GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(318855),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(318696), // Rule ID 7631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7631,
        GIR_EraseRootFromParent_Done,
      // Label 5396: @318696
      GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(318744), // Rule ID 7637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FalsePredicate_NotHasMinMaxDenormModes),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7637,
        GIR_EraseRootFromParent_Done,
      // Label 5397: @318744
      GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(318806), // Rule ID 7628 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f32] } (fneg:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods)))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 3212836864:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3212836864),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7628,
        GIR_EraseRootFromParent_Done,
      // Label 5398: @318806
      GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(318854), // Rule ID 7627 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F32_e64:{ *:[f32] } 0:{ *:[i32] }, 1065353216:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f32] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7627,
        GIR_EraseRootFromParent_Done,
      // Label 5399: @318854
      GIM_Reject,
    // Label 5395: @318855
    GIM_Reject,
    // Label 5382: @318856
    GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(319112),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(318916), // Rule ID 7632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7632,
        GIR_EraseRootFromParent_Done,
      // Label 5401: @318916
      GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(318964), // Rule ID 7633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7633,
        GIR_EraseRootFromParent_Done,
      // Label 5402: @318964
      GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(319012), // Rule ID 7638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7638,
        GIR_EraseRootFromParent_Done,
      // Label 5403: @319012
      GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(319060), // Rule ID 7639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP64Denormals_NotHasMinMaxDenormModes_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7639,
        GIR_EraseRootFromParent_Done,
      // Label 5404: @319060
      GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(319111), // Rule ID 7630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (fcanonicalize:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_MUL_F64_e64:{ *:[f64] } 0:{ *:[i32] }, 4607182418800017408:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[f64] }:$src)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(4607182418800017408),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7630,
        GIR_EraseRootFromParent_Done,
      // Label 5405: @319111
      GIM_Reject,
    // Label 5400: @319112
    GIM_Reject,
    // Label 5383: @319113
    GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(319297),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(319182), // Rule ID 7636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinMaxDenormModes),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7636,
        GIR_EraseRootFromParent_Done,
      // Label 5407: @319182
      GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(319239), // Rule ID 7642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_FP16Denormals_NotHasMinMaxDenormModes),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7642,
        GIR_EraseRootFromParent_Done,
      // Label 5408: @319239
      GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(319296), // Rule ID 7626 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fcanonicalize:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F16:{ *:[v2f16] } 0:{ *:[i32] }, 15360:{ *:[i32] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f16] }:$src, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(15360),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7626,
        GIR_EraseRootFromParent_Done,
      // Label 5409: @319296
      GIM_Reject,
    // Label 5406: @319297
    GIM_Reject,
    // Label 5384: @319298
    GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(319365), // Rule ID 7629 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fcanonicalize:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src, i32:{ *:[i32] }:$src_mods))  =>  (V_PK_MUL_F32:{ *:[v2f32] } 0:{ *:[i32] }, 1065353216:{ *:[i64] }, ?:{ *:[i32] }:$src_mods, ?:{ *:[v2f32] }:$src)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(1065353216),
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src_mods
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7629,
      GIR_EraseRootFromParent_Done,
    // Label 5410: @319365
    GIM_Reject,
    // Label 5385: @319366
    GIM_Reject,
    // Label 80: @319367
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5415*/ GIMT_Encode4(372985),
    /*GILLT_s16*//*Label 5411*/ GIMT_Encode4(319394),
    /*GILLT_s32*//*Label 5412*/ GIMT_Encode4(355148),
    /*GILLT_s64*//*Label 5413*/ GIMT_Encode4(372660),
    /*GILLT_v2s16*//*Label 5414*/ GIMT_Encode4(372913),
    // Label 5411: @319394
    GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(355147),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(319540), // Rule ID 12357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12357,
        GIR_EraseRootFromParent_Done,
      // Label 5417: @319540
      GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(319675), // Rule ID 12358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12358,
        GIR_EraseRootFromParent_Done,
      // Label 5418: @319675
      GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(319810), // Rule ID 12361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12361,
        GIR_EraseRootFromParent_Done,
      // Label 5419: @319810
      GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(319945), // Rule ID 12362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12362,
        GIR_EraseRootFromParent_Done,
      // Label 5420: @319945
      GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(320080), // Rule ID 12837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12837,
        GIR_EraseRootFromParent_Done,
      // Label 5421: @320080
      GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(320215), // Rule ID 12838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12838,
        GIR_EraseRootFromParent_Done,
      // Label 5422: @320215
      GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(320350), // Rule ID 12841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12841,
        GIR_EraseRootFromParent_Done,
      // Label 5423: @320350
      GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(320485), // Rule ID 12842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12842,
        GIR_EraseRootFromParent_Done,
      // Label 5424: @320485
      GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(320620), // Rule ID 12342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12342,
        GIR_EraseRootFromParent_Done,
      // Label 5425: @320620
      GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(320755), // Rule ID 12343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12343,
        GIR_EraseRootFromParent_Done,
      // Label 5426: @320755
      GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(320890), // Rule ID 12346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12346,
        GIR_EraseRootFromParent_Done,
      // Label 5427: @320890
      GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(321025), // Rule ID 12347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12347,
        GIR_EraseRootFromParent_Done,
      // Label 5428: @321025
      GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(321160), // Rule ID 12822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12822,
        GIR_EraseRootFromParent_Done,
      // Label 5429: @321160
      GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(321295), // Rule ID 12823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12823,
        GIR_EraseRootFromParent_Done,
      // Label 5430: @321295
      GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(321430), // Rule ID 12826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12826,
        GIR_EraseRootFromParent_Done,
      // Label 5431: @321430
      GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(321565), // Rule ID 12827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12827,
        GIR_EraseRootFromParent_Done,
      // Label 5432: @321565
      GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(321700), // Rule ID 7788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7788,
        GIR_EraseRootFromParent_Done,
      // Label 5433: @321700
      GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(321835), // Rule ID 7820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7820,
        GIR_EraseRootFromParent_Done,
      // Label 5434: @321835
      GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(321970), // Rule ID 12356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12356,
        GIR_EraseRootFromParent_Done,
      // Label 5435: @321970
      GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(322105), // Rule ID 12359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12359,
        GIR_EraseRootFromParent_Done,
      // Label 5436: @322105
      GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(322240), // Rule ID 12360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12360,
        GIR_EraseRootFromParent_Done,
      // Label 5437: @322240
      GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(322375), // Rule ID 12836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12836,
        GIR_EraseRootFromParent_Done,
      // Label 5438: @322375
      GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(322510), // Rule ID 12839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12839,
        GIR_EraseRootFromParent_Done,
      // Label 5439: @322510
      GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(322645), // Rule ID 12840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12840,
        GIR_EraseRootFromParent_Done,
      // Label 5440: @322645
      GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(322780), // Rule ID 7787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7787,
        GIR_EraseRootFromParent_Done,
      // Label 5441: @322780
      GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(322915), // Rule ID 7819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7819,
        GIR_EraseRootFromParent_Done,
      // Label 5442: @322915
      GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(323050), // Rule ID 12341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12341,
        GIR_EraseRootFromParent_Done,
      // Label 5443: @323050
      GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(323185), // Rule ID 12344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12344,
        GIR_EraseRootFromParent_Done,
      // Label 5444: @323185
      GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(323320), // Rule ID 12345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12345,
        GIR_EraseRootFromParent_Done,
      // Label 5445: @323320
      GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(323455), // Rule ID 12821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12821,
        GIR_EraseRootFromParent_Done,
      // Label 5446: @323455
      GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(323590), // Rule ID 12824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12824,
        GIR_EraseRootFromParent_Done,
      // Label 5447: @323590
      GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(323725), // Rule ID 12825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12825,
        GIR_EraseRootFromParent_Done,
      // Label 5448: @323725
      GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(323860), // Rule ID 12327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12327,
        GIR_EraseRootFromParent_Done,
      // Label 5449: @323860
      GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(323995), // Rule ID 12328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12328,
        GIR_EraseRootFromParent_Done,
      // Label 5450: @323995
      GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(324130), // Rule ID 12331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12331,
        GIR_EraseRootFromParent_Done,
      // Label 5451: @324130
      GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(324265), // Rule ID 12332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12332,
        GIR_EraseRootFromParent_Done,
      // Label 5452: @324265
      GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(324400), // Rule ID 12807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12807,
        GIR_EraseRootFromParent_Done,
      // Label 5453: @324400
      GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(324535), // Rule ID 12808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12808,
        GIR_EraseRootFromParent_Done,
      // Label 5454: @324535
      GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(324670), // Rule ID 12811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12811,
        GIR_EraseRootFromParent_Done,
      // Label 5455: @324670
      GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(324805), // Rule ID 12812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12812,
        GIR_EraseRootFromParent_Done,
      // Label 5456: @324805
      GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(324940), // Rule ID 12312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12312,
        GIR_EraseRootFromParent_Done,
      // Label 5457: @324940
      GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(325075), // Rule ID 12313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12313,
        GIR_EraseRootFromParent_Done,
      // Label 5458: @325075
      GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(325210), // Rule ID 12316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12316,
        GIR_EraseRootFromParent_Done,
      // Label 5459: @325210
      GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(325345), // Rule ID 12317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12317,
        GIR_EraseRootFromParent_Done,
      // Label 5460: @325345
      GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(325480), // Rule ID 12792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12792,
        GIR_EraseRootFromParent_Done,
      // Label 5461: @325480
      GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(325615), // Rule ID 12793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12793,
        GIR_EraseRootFromParent_Done,
      // Label 5462: @325615
      GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(325750), // Rule ID 12796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12796,
        GIR_EraseRootFromParent_Done,
      // Label 5463: @325750
      GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(325885), // Rule ID 12797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12797,
        GIR_EraseRootFromParent_Done,
      // Label 5464: @325885
      GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(326020), // Rule ID 7786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7786,
        GIR_EraseRootFromParent_Done,
      // Label 5465: @326020
      GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(326155), // Rule ID 7818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7818,
        GIR_EraseRootFromParent_Done,
      // Label 5466: @326155
      GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(326290), // Rule ID 12326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12326,
        GIR_EraseRootFromParent_Done,
      // Label 5467: @326290
      GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(326425), // Rule ID 12329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12329,
        GIR_EraseRootFromParent_Done,
      // Label 5468: @326425
      GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(326560), // Rule ID 12330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12330,
        GIR_EraseRootFromParent_Done,
      // Label 5469: @326560
      GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(326695), // Rule ID 12806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12806,
        GIR_EraseRootFromParent_Done,
      // Label 5470: @326695
      GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(326830), // Rule ID 12809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12809,
        GIR_EraseRootFromParent_Done,
      // Label 5471: @326830
      GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(326965), // Rule ID 12810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12810,
        GIR_EraseRootFromParent_Done,
      // Label 5472: @326965
      GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(327100), // Rule ID 7785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7785,
        GIR_EraseRootFromParent_Done,
      // Label 5473: @327100
      GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(327235), // Rule ID 7817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7817,
        GIR_EraseRootFromParent_Done,
      // Label 5474: @327235
      GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(327370), // Rule ID 12311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12311,
        GIR_EraseRootFromParent_Done,
      // Label 5475: @327370
      GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(327505), // Rule ID 12314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12314,
        GIR_EraseRootFromParent_Done,
      // Label 5476: @327505
      GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(327640), // Rule ID 12315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12315,
        GIR_EraseRootFromParent_Done,
      // Label 5477: @327640
      GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(327775), // Rule ID 12791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12791,
        GIR_EraseRootFromParent_Done,
      // Label 5478: @327775
      GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(327910), // Rule ID 12794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12794,
        GIR_EraseRootFromParent_Done,
      // Label 5479: @327910
      GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(328045), // Rule ID 12795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12795,
        GIR_EraseRootFromParent_Done,
      // Label 5480: @328045
      GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(328180), // Rule ID 12367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12367,
        GIR_EraseRootFromParent_Done,
      // Label 5481: @328180
      GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(328315), // Rule ID 12368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12368,
        GIR_EraseRootFromParent_Done,
      // Label 5482: @328315
      GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(328450), // Rule ID 12369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12369,
        GIR_EraseRootFromParent_Done,
      // Label 5483: @328450
      GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(328585), // Rule ID 12370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12370,
        GIR_EraseRootFromParent_Done,
      // Label 5484: @328585
      GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(328720), // Rule ID 12847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12847,
        GIR_EraseRootFromParent_Done,
      // Label 5485: @328720
      GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(328855), // Rule ID 12848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12848,
        GIR_EraseRootFromParent_Done,
      // Label 5486: @328855
      GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(328990), // Rule ID 12849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12849,
        GIR_EraseRootFromParent_Done,
      // Label 5487: @328990
      GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(329125), // Rule ID 12850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12850,
        GIR_EraseRootFromParent_Done,
      // Label 5488: @329125
      GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(329260), // Rule ID 12307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12307,
        GIR_EraseRootFromParent_Done,
      // Label 5489: @329260
      GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(329395), // Rule ID 12308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12308,
        GIR_EraseRootFromParent_Done,
      // Label 5490: @329395
      GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(329530), // Rule ID 12309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12309,
        GIR_EraseRootFromParent_Done,
      // Label 5491: @329530
      GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(329665), // Rule ID 12310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12310,
        GIR_EraseRootFromParent_Done,
      // Label 5492: @329665
      GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(329800), // Rule ID 12787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12787,
        GIR_EraseRootFromParent_Done,
      // Label 5493: @329800
      GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(329935), // Rule ID 12788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12788,
        GIR_EraseRootFromParent_Done,
      // Label 5494: @329935
      GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(330070), // Rule ID 12789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12789,
        GIR_EraseRootFromParent_Done,
      // Label 5495: @330070
      GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(330205), // Rule ID 12790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12790,
        GIR_EraseRootFromParent_Done,
      // Label 5496: @330205
      GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(330340), // Rule ID 12352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12352,
        GIR_EraseRootFromParent_Done,
      // Label 5497: @330340
      GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(330475), // Rule ID 12353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12353,
        GIR_EraseRootFromParent_Done,
      // Label 5498: @330475
      GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(330610), // Rule ID 12354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12354,
        GIR_EraseRootFromParent_Done,
      // Label 5499: @330610
      GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(330745), // Rule ID 12355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12355,
        GIR_EraseRootFromParent_Done,
      // Label 5500: @330745
      GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(330880), // Rule ID 12832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12832,
        GIR_EraseRootFromParent_Done,
      // Label 5501: @330880
      GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(331015), // Rule ID 12833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12833,
        GIR_EraseRootFromParent_Done,
      // Label 5502: @331015
      GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(331150), // Rule ID 12834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12834,
        GIR_EraseRootFromParent_Done,
      // Label 5503: @331150
      GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(331285), // Rule ID 12835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12835,
        GIR_EraseRootFromParent_Done,
      // Label 5504: @331285
      GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(331420), // Rule ID 12292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12292,
        GIR_EraseRootFromParent_Done,
      // Label 5505: @331420
      GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(331555), // Rule ID 12293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12293,
        GIR_EraseRootFromParent_Done,
      // Label 5506: @331555
      GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(331690), // Rule ID 12294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12294,
        GIR_EraseRootFromParent_Done,
      // Label 5507: @331690
      GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(331825), // Rule ID 12295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12295,
        GIR_EraseRootFromParent_Done,
      // Label 5508: @331825
      GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(331960), // Rule ID 12772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12772,
        GIR_EraseRootFromParent_Done,
      // Label 5509: @331960
      GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(332095), // Rule ID 12773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12773,
        GIR_EraseRootFromParent_Done,
      // Label 5510: @332095
      GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(332230), // Rule ID 12774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12774,
        GIR_EraseRootFromParent_Done,
      // Label 5511: @332230
      GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(332365), // Rule ID 12775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12775,
        GIR_EraseRootFromParent_Done,
      // Label 5512: @332365
      GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(332500), // Rule ID 12363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12363,
        GIR_EraseRootFromParent_Done,
      // Label 5513: @332500
      GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(332635), // Rule ID 12364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12364,
        GIR_EraseRootFromParent_Done,
      // Label 5514: @332635
      GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(332770), // Rule ID 12365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12365,
        GIR_EraseRootFromParent_Done,
      // Label 5515: @332770
      GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(332905), // Rule ID 12366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12366,
        GIR_EraseRootFromParent_Done,
      // Label 5516: @332905
      GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(333040), // Rule ID 12843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12843,
        GIR_EraseRootFromParent_Done,
      // Label 5517: @333040
      GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(333175), // Rule ID 12844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12844,
        GIR_EraseRootFromParent_Done,
      // Label 5518: @333175
      GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(333310), // Rule ID 12845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12845,
        GIR_EraseRootFromParent_Done,
      // Label 5519: @333310
      GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(333445), // Rule ID 12846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12846,
        GIR_EraseRootFromParent_Done,
      // Label 5520: @333445
      GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(333580), // Rule ID 12303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12303,
        GIR_EraseRootFromParent_Done,
      // Label 5521: @333580
      GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(333715), // Rule ID 12304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12304,
        GIR_EraseRootFromParent_Done,
      // Label 5522: @333715
      GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(333850), // Rule ID 12305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12305,
        GIR_EraseRootFromParent_Done,
      // Label 5523: @333850
      GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(333985), // Rule ID 12306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12306,
        GIR_EraseRootFromParent_Done,
      // Label 5524: @333985
      GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(334120), // Rule ID 12783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12783,
        GIR_EraseRootFromParent_Done,
      // Label 5525: @334120
      GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(334255), // Rule ID 12784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12784,
        GIR_EraseRootFromParent_Done,
      // Label 5526: @334255
      GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(334390), // Rule ID 12785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12785,
        GIR_EraseRootFromParent_Done,
      // Label 5527: @334390
      GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(334525), // Rule ID 12786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12786,
        GIR_EraseRootFromParent_Done,
      // Label 5528: @334525
      GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(334660), // Rule ID 12348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12348,
        GIR_EraseRootFromParent_Done,
      // Label 5529: @334660
      GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(334795), // Rule ID 12349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12349,
        GIR_EraseRootFromParent_Done,
      // Label 5530: @334795
      GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(334930), // Rule ID 12350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12350,
        GIR_EraseRootFromParent_Done,
      // Label 5531: @334930
      GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(335065), // Rule ID 12351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12351,
        GIR_EraseRootFromParent_Done,
      // Label 5532: @335065
      GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(335200), // Rule ID 12828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12828,
        GIR_EraseRootFromParent_Done,
      // Label 5533: @335200
      GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(335335), // Rule ID 12829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12829,
        GIR_EraseRootFromParent_Done,
      // Label 5534: @335335
      GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(335470), // Rule ID 12830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12830,
        GIR_EraseRootFromParent_Done,
      // Label 5535: @335470
      GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(335605), // Rule ID 12831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12831,
        GIR_EraseRootFromParent_Done,
      // Label 5536: @335605
      GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(335740), // Rule ID 12288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12288,
        GIR_EraseRootFromParent_Done,
      // Label 5537: @335740
      GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(335875), // Rule ID 12289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12289,
        GIR_EraseRootFromParent_Done,
      // Label 5538: @335875
      GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(336010), // Rule ID 12290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12290,
        GIR_EraseRootFromParent_Done,
      // Label 5539: @336010
      GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(336145), // Rule ID 12291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12291,
        GIR_EraseRootFromParent_Done,
      // Label 5540: @336145
      GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(336280), // Rule ID 12768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12768,
        GIR_EraseRootFromParent_Done,
      // Label 5541: @336280
      GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(336415), // Rule ID 12769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12769,
        GIR_EraseRootFromParent_Done,
      // Label 5542: @336415
      GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(336550), // Rule ID 12770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12770,
        GIR_EraseRootFromParent_Done,
      // Label 5543: @336550
      GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(336685), // Rule ID 12771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12771,
        GIR_EraseRootFromParent_Done,
      // Label 5544: @336685
      GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(336820), // Rule ID 12297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12297,
        GIR_EraseRootFromParent_Done,
      // Label 5545: @336820
      GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(336955), // Rule ID 12298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12298,
        GIR_EraseRootFromParent_Done,
      // Label 5546: @336955
      GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(337090), // Rule ID 12301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12301,
        GIR_EraseRootFromParent_Done,
      // Label 5547: @337090
      GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(337225), // Rule ID 12302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12302,
        GIR_EraseRootFromParent_Done,
      // Label 5548: @337225
      GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(337360), // Rule ID 12777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12777,
        GIR_EraseRootFromParent_Done,
      // Label 5549: @337360
      GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(337495), // Rule ID 12778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12778,
        GIR_EraseRootFromParent_Done,
      // Label 5550: @337495
      GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(337630), // Rule ID 12781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12781,
        GIR_EraseRootFromParent_Done,
      // Label 5551: @337630
      GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(337765), // Rule ID 12782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12782,
        GIR_EraseRootFromParent_Done,
      // Label 5552: @337765
      GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(337900), // Rule ID 12282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12282,
        GIR_EraseRootFromParent_Done,
      // Label 5553: @337900
      GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(338035), // Rule ID 12283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12283,
        GIR_EraseRootFromParent_Done,
      // Label 5554: @338035
      GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(338170), // Rule ID 12286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12286,
        GIR_EraseRootFromParent_Done,
      // Label 5555: @338170
      GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(338305), // Rule ID 12287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12287,
        GIR_EraseRootFromParent_Done,
      // Label 5556: @338305
      GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(338440), // Rule ID 12762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12762,
        GIR_EraseRootFromParent_Done,
      // Label 5557: @338440
      GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(338575), // Rule ID 12763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12763,
        GIR_EraseRootFromParent_Done,
      // Label 5558: @338575
      GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(338710), // Rule ID 12766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12766,
        GIR_EraseRootFromParent_Done,
      // Label 5559: @338710
      GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(338845), // Rule ID 12767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12767,
        GIR_EraseRootFromParent_Done,
      // Label 5560: @338845
      GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(338980), // Rule ID 7784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7784,
        GIR_EraseRootFromParent_Done,
      // Label 5561: @338980
      GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(339115), // Rule ID 7816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7816,
        GIR_EraseRootFromParent_Done,
      // Label 5562: @339115
      GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(339250), // Rule ID 12296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12296,
        GIR_EraseRootFromParent_Done,
      // Label 5563: @339250
      GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(339385), // Rule ID 12299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12299,
        GIR_EraseRootFromParent_Done,
      // Label 5564: @339385
      GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(339520), // Rule ID 12300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12300,
        GIR_EraseRootFromParent_Done,
      // Label 5565: @339520
      GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(339655), // Rule ID 12776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12776,
        GIR_EraseRootFromParent_Done,
      // Label 5566: @339655
      GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(339790), // Rule ID 12779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12779,
        GIR_EraseRootFromParent_Done,
      // Label 5567: @339790
      GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(339925), // Rule ID 12780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12780,
        GIR_EraseRootFromParent_Done,
      // Label 5568: @339925
      GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(340060), // Rule ID 7783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7783,
        GIR_EraseRootFromParent_Done,
      // Label 5569: @340060
      GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(340195), // Rule ID 7815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7815,
        GIR_EraseRootFromParent_Done,
      // Label 5570: @340195
      GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(340330), // Rule ID 12281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12281,
        GIR_EraseRootFromParent_Done,
      // Label 5571: @340330
      GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(340465), // Rule ID 12284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12284,
        GIR_EraseRootFromParent_Done,
      // Label 5572: @340465
      GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(340600), // Rule ID 12285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12285,
        GIR_EraseRootFromParent_Done,
      // Label 5573: @340600
      GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(340735), // Rule ID 12761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12761,
        GIR_EraseRootFromParent_Done,
      // Label 5574: @340735
      GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(340870), // Rule ID 12764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12764,
        GIR_EraseRootFromParent_Done,
      // Label 5575: @340870
      GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(341005), // Rule ID 12765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12765,
        GIR_EraseRootFromParent_Done,
      // Label 5576: @341005
      GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(341140), // Rule ID 12267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12267,
        GIR_EraseRootFromParent_Done,
      // Label 5577: @341140
      GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(341275), // Rule ID 12268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12268,
        GIR_EraseRootFromParent_Done,
      // Label 5578: @341275
      GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(341410), // Rule ID 12271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12271,
        GIR_EraseRootFromParent_Done,
      // Label 5579: @341410
      GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(341545), // Rule ID 12272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12272,
        GIR_EraseRootFromParent_Done,
      // Label 5580: @341545
      GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(341680), // Rule ID 12747 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12747,
        GIR_EraseRootFromParent_Done,
      // Label 5581: @341680
      GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(341815), // Rule ID 12748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12748,
        GIR_EraseRootFromParent_Done,
      // Label 5582: @341815
      GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(341950), // Rule ID 12751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12751,
        GIR_EraseRootFromParent_Done,
      // Label 5583: @341950
      GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(342085), // Rule ID 12752 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12752,
        GIR_EraseRootFromParent_Done,
      // Label 5584: @342085
      GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(342220), // Rule ID 12252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12252,
        GIR_EraseRootFromParent_Done,
      // Label 5585: @342220
      GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(342355), // Rule ID 12253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12253,
        GIR_EraseRootFromParent_Done,
      // Label 5586: @342355
      GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(342490), // Rule ID 12256 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12256,
        GIR_EraseRootFromParent_Done,
      // Label 5587: @342490
      GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(342625), // Rule ID 12257 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12257,
        GIR_EraseRootFromParent_Done,
      // Label 5588: @342625
      GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(342760), // Rule ID 12732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12732,
        GIR_EraseRootFromParent_Done,
      // Label 5589: @342760
      GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(342895), // Rule ID 12733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12733,
        GIR_EraseRootFromParent_Done,
      // Label 5590: @342895
      GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(343030), // Rule ID 12736 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12736,
        GIR_EraseRootFromParent_Done,
      // Label 5591: @343030
      GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(343165), // Rule ID 12737 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12737,
        GIR_EraseRootFromParent_Done,
      // Label 5592: @343165
      GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(343300), // Rule ID 7782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7782,
        GIR_EraseRootFromParent_Done,
      // Label 5593: @343300
      GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(343435), // Rule ID 7814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7814,
        GIR_EraseRootFromParent_Done,
      // Label 5594: @343435
      GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(343570), // Rule ID 12266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12266,
        GIR_EraseRootFromParent_Done,
      // Label 5595: @343570
      GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(343705), // Rule ID 12269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12269,
        GIR_EraseRootFromParent_Done,
      // Label 5596: @343705
      GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(343840), // Rule ID 12270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12270,
        GIR_EraseRootFromParent_Done,
      // Label 5597: @343840
      GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(343975), // Rule ID 12746 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12746,
        GIR_EraseRootFromParent_Done,
      // Label 5598: @343975
      GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(344110), // Rule ID 12749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12749,
        GIR_EraseRootFromParent_Done,
      // Label 5599: @344110
      GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(344245), // Rule ID 12750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12750,
        GIR_EraseRootFromParent_Done,
      // Label 5600: @344245
      GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(344380), // Rule ID 7781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7781,
        GIR_EraseRootFromParent_Done,
      // Label 5601: @344380
      GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(344515), // Rule ID 7813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7813,
        GIR_EraseRootFromParent_Done,
      // Label 5602: @344515
      GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(344650), // Rule ID 12251 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12251,
        GIR_EraseRootFromParent_Done,
      // Label 5603: @344650
      GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(344785), // Rule ID 12254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12254,
        GIR_EraseRootFromParent_Done,
      // Label 5604: @344785
      GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(344920), // Rule ID 12255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12255,
        GIR_EraseRootFromParent_Done,
      // Label 5605: @344920
      GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(345055), // Rule ID 12731 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12731,
        GIR_EraseRootFromParent_Done,
      // Label 5606: @345055
      GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(345190), // Rule ID 12734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12734,
        GIR_EraseRootFromParent_Done,
      // Label 5607: @345190
      GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(345325), // Rule ID 12735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12735,
        GIR_EraseRootFromParent_Done,
      // Label 5608: @345325
      GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(345460), // Rule ID 12337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12337,
        GIR_EraseRootFromParent_Done,
      // Label 5609: @345460
      GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(345595), // Rule ID 12338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12338,
        GIR_EraseRootFromParent_Done,
      // Label 5610: @345595
      GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(345730), // Rule ID 12339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12339,
        GIR_EraseRootFromParent_Done,
      // Label 5611: @345730
      GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(345865), // Rule ID 12340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12340,
        GIR_EraseRootFromParent_Done,
      // Label 5612: @345865
      GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(346000), // Rule ID 12817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12817,
        GIR_EraseRootFromParent_Done,
      // Label 5613: @346000
      GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(346135), // Rule ID 12818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12818,
        GIR_EraseRootFromParent_Done,
      // Label 5614: @346135
      GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(346270), // Rule ID 12819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12819,
        GIR_EraseRootFromParent_Done,
      // Label 5615: @346270
      GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(346405), // Rule ID 12820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12820,
        GIR_EraseRootFromParent_Done,
      // Label 5616: @346405
      GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(346540), // Rule ID 12277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12277,
        GIR_EraseRootFromParent_Done,
      // Label 5617: @346540
      GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(346675), // Rule ID 12278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12278,
        GIR_EraseRootFromParent_Done,
      // Label 5618: @346675
      GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(346810), // Rule ID 12279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12279,
        GIR_EraseRootFromParent_Done,
      // Label 5619: @346810
      GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(346945), // Rule ID 12280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12280,
        GIR_EraseRootFromParent_Done,
      // Label 5620: @346945
      GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(347080), // Rule ID 12757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12757,
        GIR_EraseRootFromParent_Done,
      // Label 5621: @347080
      GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(347215), // Rule ID 12758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12758,
        GIR_EraseRootFromParent_Done,
      // Label 5622: @347215
      GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(347350), // Rule ID 12759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12759,
        GIR_EraseRootFromParent_Done,
      // Label 5623: @347350
      GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(347485), // Rule ID 12760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12760,
        GIR_EraseRootFromParent_Done,
      // Label 5624: @347485
      GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(347620), // Rule ID 12322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12322,
        GIR_EraseRootFromParent_Done,
      // Label 5625: @347620
      GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(347755), // Rule ID 12323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12323,
        GIR_EraseRootFromParent_Done,
      // Label 5626: @347755
      GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(347890), // Rule ID 12324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12324,
        GIR_EraseRootFromParent_Done,
      // Label 5627: @347890
      GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(348025), // Rule ID 12325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12325,
        GIR_EraseRootFromParent_Done,
      // Label 5628: @348025
      GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(348160), // Rule ID 12802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12802,
        GIR_EraseRootFromParent_Done,
      // Label 5629: @348160
      GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(348295), // Rule ID 12803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12803,
        GIR_EraseRootFromParent_Done,
      // Label 5630: @348295
      GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(348430), // Rule ID 12804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12804,
        GIR_EraseRootFromParent_Done,
      // Label 5631: @348430
      GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(348565), // Rule ID 12805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12805,
        GIR_EraseRootFromParent_Done,
      // Label 5632: @348565
      GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(348700), // Rule ID 12262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12262,
        GIR_EraseRootFromParent_Done,
      // Label 5633: @348700
      GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(348835), // Rule ID 12263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12263,
        GIR_EraseRootFromParent_Done,
      // Label 5634: @348835
      GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(348970), // Rule ID 12264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12264,
        GIR_EraseRootFromParent_Done,
      // Label 5635: @348970
      GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(349105), // Rule ID 12265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12265,
        GIR_EraseRootFromParent_Done,
      // Label 5636: @349105
      GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(349240), // Rule ID 12742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12742,
        GIR_EraseRootFromParent_Done,
      // Label 5637: @349240
      GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(349375), // Rule ID 12743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12743,
        GIR_EraseRootFromParent_Done,
      // Label 5638: @349375
      GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(349510), // Rule ID 12744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12744,
        GIR_EraseRootFromParent_Done,
      // Label 5639: @349510
      GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(349645), // Rule ID 12745 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12745,
        GIR_EraseRootFromParent_Done,
      // Label 5640: @349645
      GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(349780), // Rule ID 12333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12333,
        GIR_EraseRootFromParent_Done,
      // Label 5641: @349780
      GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(349915), // Rule ID 12334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12334,
        GIR_EraseRootFromParent_Done,
      // Label 5642: @349915
      GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(350050), // Rule ID 12335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12335,
        GIR_EraseRootFromParent_Done,
      // Label 5643: @350050
      GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(350185), // Rule ID 12336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12336,
        GIR_EraseRootFromParent_Done,
      // Label 5644: @350185
      GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(350320), // Rule ID 12813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12813,
        GIR_EraseRootFromParent_Done,
      // Label 5645: @350320
      GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(350455), // Rule ID 12814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12814,
        GIR_EraseRootFromParent_Done,
      // Label 5646: @350455
      GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(350590), // Rule ID 12815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12815,
        GIR_EraseRootFromParent_Done,
      // Label 5647: @350590
      GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(350725), // Rule ID 12816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12816,
        GIR_EraseRootFromParent_Done,
      // Label 5648: @350725
      GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(350860), // Rule ID 12273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12273,
        GIR_EraseRootFromParent_Done,
      // Label 5649: @350860
      GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(350995), // Rule ID 12274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12274,
        GIR_EraseRootFromParent_Done,
      // Label 5650: @350995
      GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(351130), // Rule ID 12275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12275,
        GIR_EraseRootFromParent_Done,
      // Label 5651: @351130
      GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(351265), // Rule ID 12276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12276,
        GIR_EraseRootFromParent_Done,
      // Label 5652: @351265
      GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(351400), // Rule ID 12753 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12753,
        GIR_EraseRootFromParent_Done,
      // Label 5653: @351400
      GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(351535), // Rule ID 12754 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12754,
        GIR_EraseRootFromParent_Done,
      // Label 5654: @351535
      GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(351670), // Rule ID 12755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12755,
        GIR_EraseRootFromParent_Done,
      // Label 5655: @351670
      GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(351805), // Rule ID 12756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12756,
        GIR_EraseRootFromParent_Done,
      // Label 5656: @351805
      GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(351940), // Rule ID 12318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12318,
        GIR_EraseRootFromParent_Done,
      // Label 5657: @351940
      GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(352075), // Rule ID 12319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12319,
        GIR_EraseRootFromParent_Done,
      // Label 5658: @352075
      GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(352210), // Rule ID 12320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12320,
        GIR_EraseRootFromParent_Done,
      // Label 5659: @352210
      GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(352345), // Rule ID 12321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12321,
        GIR_EraseRootFromParent_Done,
      // Label 5660: @352345
      GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(352480), // Rule ID 12798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12798,
        GIR_EraseRootFromParent_Done,
      // Label 5661: @352480
      GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(352615), // Rule ID 12799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12799,
        GIR_EraseRootFromParent_Done,
      // Label 5662: @352615
      GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(352750), // Rule ID 12800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12800,
        GIR_EraseRootFromParent_Done,
      // Label 5663: @352750
      GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(352885), // Rule ID 12801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12801,
        GIR_EraseRootFromParent_Done,
      // Label 5664: @352885
      GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(353020), // Rule ID 12258 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12258,
        GIR_EraseRootFromParent_Done,
      // Label 5665: @353020
      GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(353155), // Rule ID 12259 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12259,
        GIR_EraseRootFromParent_Done,
      // Label 5666: @353155
      GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(353290), // Rule ID 12260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12260,
        GIR_EraseRootFromParent_Done,
      // Label 5667: @353290
      GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(353425), // Rule ID 12261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12261,
        GIR_EraseRootFromParent_Done,
      // Label 5668: @353425
      GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(353560), // Rule ID 12738 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12738,
        GIR_EraseRootFromParent_Done,
      // Label 5669: @353560
      GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(353695), // Rule ID 12739 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12739,
        GIR_EraseRootFromParent_Done,
      // Label 5670: @353695
      GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(353830), // Rule ID 12740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12740,
        GIR_EraseRootFromParent_Done,
      // Label 5671: @353830
      GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(353965), // Rule ID 12741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12741,
        GIR_EraseRootFromParent_Done,
      // Label 5672: @353965
      GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(354077), // Rule ID 12886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12886,
        GIR_EraseRootFromParent_Done,
      // Label 5673: @354077
      GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(354189), // Rule ID 12885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12885,
        GIR_EraseRootFromParent_Done,
      // Label 5674: @354189
      GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(354301), // Rule ID 7856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7856,
        GIR_EraseRootFromParent_Done,
      // Label 5675: @354301
      GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(354413), // Rule ID 7855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7855,
        GIR_EraseRootFromParent_Done,
      // Label 5676: @354413
      GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(354509), // Rule ID 12870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12870,
        GIR_EraseRootFromParent_Done,
      // Label 5677: @354509
      GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(354605), // Rule ID 12869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12869,
        GIR_EraseRootFromParent_Done,
      // Label 5678: @354605
      GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(354701), // Rule ID 7840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7840,
        GIR_EraseRootFromParent_Done,
      // Label 5679: @354701
      GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(354797), // Rule ID 7839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7839,
        GIR_EraseRootFromParent_Done,
      // Label 5680: @354797
      GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(354832), // Rule ID 101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13403),
        // (fminnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13403>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 101,
        GIR_Done,
      // Label 5681: @354832
      GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(354895), // Rule ID 887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 887,
        GIR_EraseRootFromParent_Done,
      // Label 5682: @354895
      GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(354958), // Rule ID 891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 891,
        GIR_EraseRootFromParent_Done,
      // Label 5683: @354958
      GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(355021), // Rule ID 8532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8532,
        GIR_EraseRootFromParent_Done,
      // Label 5684: @355021
      GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(355084), // Rule ID 8534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8534,
        GIR_EraseRootFromParent_Done,
      // Label 5685: @355084
      GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(355146), // Rule ID 889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fminnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 889,
        GIR_EraseRootFromParent_Done,
      // Label 5686: @355146
      GIM_Reject,
    // Label 5416: @355147
    GIM_Reject,
    // Label 5412: @355148
    GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(372659),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(355288), // Rule ID 11847 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11847,
        GIR_EraseRootFromParent_Done,
      // Label 5688: @355288
      GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(355417), // Rule ID 11848 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11848,
        GIR_EraseRootFromParent_Done,
      // Label 5689: @355417
      GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(355546), // Rule ID 11851 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11851,
        GIR_EraseRootFromParent_Done,
      // Label 5690: @355546
      GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(355675), // Rule ID 11852 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11852,
        GIR_EraseRootFromParent_Done,
      // Label 5691: @355675
      GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(355804), // Rule ID 11832 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11832,
        GIR_EraseRootFromParent_Done,
      // Label 5692: @355804
      GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(355933), // Rule ID 11833 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11833,
        GIR_EraseRootFromParent_Done,
      // Label 5693: @355933
      GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(356062), // Rule ID 11836 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11836,
        GIR_EraseRootFromParent_Done,
      // Label 5694: @356062
      GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(356191), // Rule ID 11837 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11837,
        GIR_EraseRootFromParent_Done,
      // Label 5695: @356191
      GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(356320), // Rule ID 7754 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7754,
        GIR_EraseRootFromParent_Done,
      // Label 5696: @356320
      GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(356449), // Rule ID 11846 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11846,
        GIR_EraseRootFromParent_Done,
      // Label 5697: @356449
      GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(356578), // Rule ID 11849 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11849,
        GIR_EraseRootFromParent_Done,
      // Label 5698: @356578
      GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(356707), // Rule ID 11850 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11850,
        GIR_EraseRootFromParent_Done,
      // Label 5699: @356707
      GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(356836), // Rule ID 7753 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7753,
        GIR_EraseRootFromParent_Done,
      // Label 5700: @356836
      GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(356965), // Rule ID 11831 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11831,
        GIR_EraseRootFromParent_Done,
      // Label 5701: @356965
      GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(357094), // Rule ID 11834 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11834,
        GIR_EraseRootFromParent_Done,
      // Label 5702: @357094
      GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(357223), // Rule ID 11835 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11835,
        GIR_EraseRootFromParent_Done,
      // Label 5703: @357223
      GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(357352), // Rule ID 11817 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11817,
        GIR_EraseRootFromParent_Done,
      // Label 5704: @357352
      GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(357481), // Rule ID 11818 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11818,
        GIR_EraseRootFromParent_Done,
      // Label 5705: @357481
      GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(357610), // Rule ID 11821 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11821,
        GIR_EraseRootFromParent_Done,
      // Label 5706: @357610
      GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(357739), // Rule ID 11822 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11822,
        GIR_EraseRootFromParent_Done,
      // Label 5707: @357739
      GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(357868), // Rule ID 11802 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11802,
        GIR_EraseRootFromParent_Done,
      // Label 5708: @357868
      GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(357997), // Rule ID 11803 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11803,
        GIR_EraseRootFromParent_Done,
      // Label 5709: @357997
      GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(358126), // Rule ID 11806 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11806,
        GIR_EraseRootFromParent_Done,
      // Label 5710: @358126
      GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(358255), // Rule ID 11807 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11807,
        GIR_EraseRootFromParent_Done,
      // Label 5711: @358255
      GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(358384), // Rule ID 7752 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7752,
        GIR_EraseRootFromParent_Done,
      // Label 5712: @358384
      GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(358513), // Rule ID 11816 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11816,
        GIR_EraseRootFromParent_Done,
      // Label 5713: @358513
      GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(358642), // Rule ID 11819 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11819,
        GIR_EraseRootFromParent_Done,
      // Label 5714: @358642
      GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(358771), // Rule ID 11820 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11820,
        GIR_EraseRootFromParent_Done,
      // Label 5715: @358771
      GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(358900), // Rule ID 7751 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7751,
        GIR_EraseRootFromParent_Done,
      // Label 5716: @358900
      GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(359029), // Rule ID 11801 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11801,
        GIR_EraseRootFromParent_Done,
      // Label 5717: @359029
      GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(359158), // Rule ID 11804 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11804,
        GIR_EraseRootFromParent_Done,
      // Label 5718: @359158
      GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(359287), // Rule ID 11805 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11805,
        GIR_EraseRootFromParent_Done,
      // Label 5719: @359287
      GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(359416), // Rule ID 11857 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11857,
        GIR_EraseRootFromParent_Done,
      // Label 5720: @359416
      GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(359545), // Rule ID 11858 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11858,
        GIR_EraseRootFromParent_Done,
      // Label 5721: @359545
      GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(359674), // Rule ID 11859 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11859,
        GIR_EraseRootFromParent_Done,
      // Label 5722: @359674
      GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(359803), // Rule ID 11860 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11860,
        GIR_EraseRootFromParent_Done,
      // Label 5723: @359803
      GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(359932), // Rule ID 11797 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11797,
        GIR_EraseRootFromParent_Done,
      // Label 5724: @359932
      GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(360061), // Rule ID 11798 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11798,
        GIR_EraseRootFromParent_Done,
      // Label 5725: @360061
      GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(360190), // Rule ID 11799 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11799,
        GIR_EraseRootFromParent_Done,
      // Label 5726: @360190
      GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(360319), // Rule ID 11800 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11800,
        GIR_EraseRootFromParent_Done,
      // Label 5727: @360319
      GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(360448), // Rule ID 11842 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11842,
        GIR_EraseRootFromParent_Done,
      // Label 5728: @360448
      GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(360577), // Rule ID 11843 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11843,
        GIR_EraseRootFromParent_Done,
      // Label 5729: @360577
      GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(360706), // Rule ID 11844 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11844,
        GIR_EraseRootFromParent_Done,
      // Label 5730: @360706
      GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(360835), // Rule ID 11845 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11845,
        GIR_EraseRootFromParent_Done,
      // Label 5731: @360835
      GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(360964), // Rule ID 11782 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11782,
        GIR_EraseRootFromParent_Done,
      // Label 5732: @360964
      GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(361093), // Rule ID 11783 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11783,
        GIR_EraseRootFromParent_Done,
      // Label 5733: @361093
      GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(361222), // Rule ID 11784 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11784,
        GIR_EraseRootFromParent_Done,
      // Label 5734: @361222
      GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(361351), // Rule ID 11785 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11785,
        GIR_EraseRootFromParent_Done,
      // Label 5735: @361351
      GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(361480), // Rule ID 11853 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11853,
        GIR_EraseRootFromParent_Done,
      // Label 5736: @361480
      GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(361609), // Rule ID 11854 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11854,
        GIR_EraseRootFromParent_Done,
      // Label 5737: @361609
      GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(361738), // Rule ID 11855 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11855,
        GIR_EraseRootFromParent_Done,
      // Label 5738: @361738
      GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(361867), // Rule ID 11856 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11856,
        GIR_EraseRootFromParent_Done,
      // Label 5739: @361867
      GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(361996), // Rule ID 11793 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11793,
        GIR_EraseRootFromParent_Done,
      // Label 5740: @361996
      GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(362125), // Rule ID 11794 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11794,
        GIR_EraseRootFromParent_Done,
      // Label 5741: @362125
      GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(362254), // Rule ID 11795 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11795,
        GIR_EraseRootFromParent_Done,
      // Label 5742: @362254
      GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(362383), // Rule ID 11796 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11796,
        GIR_EraseRootFromParent_Done,
      // Label 5743: @362383
      GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(362512), // Rule ID 11838 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11838,
        GIR_EraseRootFromParent_Done,
      // Label 5744: @362512
      GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(362641), // Rule ID 11839 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11839,
        GIR_EraseRootFromParent_Done,
      // Label 5745: @362641
      GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(362770), // Rule ID 11840 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11840,
        GIR_EraseRootFromParent_Done,
      // Label 5746: @362770
      GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(362899), // Rule ID 11841 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11841,
        GIR_EraseRootFromParent_Done,
      // Label 5747: @362899
      GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(363028), // Rule ID 11778 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11778,
        GIR_EraseRootFromParent_Done,
      // Label 5748: @363028
      GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(363157), // Rule ID 11779 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11779,
        GIR_EraseRootFromParent_Done,
      // Label 5749: @363157
      GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(363286), // Rule ID 11780 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11780,
        GIR_EraseRootFromParent_Done,
      // Label 5750: @363286
      GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(363415), // Rule ID 11781 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11781,
        GIR_EraseRootFromParent_Done,
      // Label 5751: @363415
      GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(363544), // Rule ID 11787 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11787,
        GIR_EraseRootFromParent_Done,
      // Label 5752: @363544
      GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(363673), // Rule ID 11788 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11788,
        GIR_EraseRootFromParent_Done,
      // Label 5753: @363673
      GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(363802), // Rule ID 11791 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11791,
        GIR_EraseRootFromParent_Done,
      // Label 5754: @363802
      GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(363931), // Rule ID 11792 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11792,
        GIR_EraseRootFromParent_Done,
      // Label 5755: @363931
      GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(364060), // Rule ID 11772 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11772,
        GIR_EraseRootFromParent_Done,
      // Label 5756: @364060
      GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(364189), // Rule ID 11773 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11773,
        GIR_EraseRootFromParent_Done,
      // Label 5757: @364189
      GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(364318), // Rule ID 11776 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11776,
        GIR_EraseRootFromParent_Done,
      // Label 5758: @364318
      GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(364447), // Rule ID 11777 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11777,
        GIR_EraseRootFromParent_Done,
      // Label 5759: @364447
      GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(364576), // Rule ID 7750 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7750,
        GIR_EraseRootFromParent_Done,
      // Label 5760: @364576
      GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(364705), // Rule ID 11786 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11786,
        GIR_EraseRootFromParent_Done,
      // Label 5761: @364705
      GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(364834), // Rule ID 11789 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11789,
        GIR_EraseRootFromParent_Done,
      // Label 5762: @364834
      GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(364963), // Rule ID 11790 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11790,
        GIR_EraseRootFromParent_Done,
      // Label 5763: @364963
      GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(365092), // Rule ID 7749 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7749,
        GIR_EraseRootFromParent_Done,
      // Label 5764: @365092
      GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(365221), // Rule ID 11771 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11771,
        GIR_EraseRootFromParent_Done,
      // Label 5765: @365221
      GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(365350), // Rule ID 11774 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11774,
        GIR_EraseRootFromParent_Done,
      // Label 5766: @365350
      GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(365479), // Rule ID 11775 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11775,
        GIR_EraseRootFromParent_Done,
      // Label 5767: @365479
      GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(365608), // Rule ID 11757 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11757,
        GIR_EraseRootFromParent_Done,
      // Label 5768: @365608
      GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(365737), // Rule ID 11758 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11758,
        GIR_EraseRootFromParent_Done,
      // Label 5769: @365737
      GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(365866), // Rule ID 11761 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11761,
        GIR_EraseRootFromParent_Done,
      // Label 5770: @365866
      GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(365995), // Rule ID 11762 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11762,
        GIR_EraseRootFromParent_Done,
      // Label 5771: @365995
      GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(366124), // Rule ID 11742 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11742,
        GIR_EraseRootFromParent_Done,
      // Label 5772: @366124
      GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(366253), // Rule ID 11743 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11743,
        GIR_EraseRootFromParent_Done,
      // Label 5773: @366253
      GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(366382), // Rule ID 11746 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11746,
        GIR_EraseRootFromParent_Done,
      // Label 5774: @366382
      GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(366511), // Rule ID 11747 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11747,
        GIR_EraseRootFromParent_Done,
      // Label 5775: @366511
      GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(366640), // Rule ID 7748 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7748,
        GIR_EraseRootFromParent_Done,
      // Label 5776: @366640
      GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(366769), // Rule ID 11756 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11756,
        GIR_EraseRootFromParent_Done,
      // Label 5777: @366769
      GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(366898), // Rule ID 11759 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11759,
        GIR_EraseRootFromParent_Done,
      // Label 5778: @366898
      GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(367027), // Rule ID 11760 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11760,
        GIR_EraseRootFromParent_Done,
      // Label 5779: @367027
      GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(367156), // Rule ID 7747 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7747,
        GIR_EraseRootFromParent_Done,
      // Label 5780: @367156
      GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(367285), // Rule ID 11741 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11741,
        GIR_EraseRootFromParent_Done,
      // Label 5781: @367285
      GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(367414), // Rule ID 11744 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11744,
        GIR_EraseRootFromParent_Done,
      // Label 5782: @367414
      GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(367543), // Rule ID 11745 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11745,
        GIR_EraseRootFromParent_Done,
      // Label 5783: @367543
      GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(367672), // Rule ID 11827 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11827,
        GIR_EraseRootFromParent_Done,
      // Label 5784: @367672
      GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(367801), // Rule ID 11828 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11828,
        GIR_EraseRootFromParent_Done,
      // Label 5785: @367801
      GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(367930), // Rule ID 11829 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11829,
        GIR_EraseRootFromParent_Done,
      // Label 5786: @367930
      GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(368059), // Rule ID 11830 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11830,
        GIR_EraseRootFromParent_Done,
      // Label 5787: @368059
      GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(368188), // Rule ID 11767 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11767,
        GIR_EraseRootFromParent_Done,
      // Label 5788: @368188
      GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(368317), // Rule ID 11768 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11768,
        GIR_EraseRootFromParent_Done,
      // Label 5789: @368317
      GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(368446), // Rule ID 11769 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11769,
        GIR_EraseRootFromParent_Done,
      // Label 5790: @368446
      GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(368575), // Rule ID 11770 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11770,
        GIR_EraseRootFromParent_Done,
      // Label 5791: @368575
      GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(368704), // Rule ID 11812 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11812,
        GIR_EraseRootFromParent_Done,
      // Label 5792: @368704
      GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(368833), // Rule ID 11813 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11813,
        GIR_EraseRootFromParent_Done,
      // Label 5793: @368833
      GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(368962), // Rule ID 11814 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11814,
        GIR_EraseRootFromParent_Done,
      // Label 5794: @368962
      GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(369091), // Rule ID 11815 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11815,
        GIR_EraseRootFromParent_Done,
      // Label 5795: @369091
      GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(369220), // Rule ID 11752 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11752,
        GIR_EraseRootFromParent_Done,
      // Label 5796: @369220
      GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(369349), // Rule ID 11753 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11753,
        GIR_EraseRootFromParent_Done,
      // Label 5797: @369349
      GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(369478), // Rule ID 11754 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11754,
        GIR_EraseRootFromParent_Done,
      // Label 5798: @369478
      GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(369607), // Rule ID 11755 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11755,
        GIR_EraseRootFromParent_Done,
      // Label 5799: @369607
      GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(369736), // Rule ID 11823 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11823,
        GIR_EraseRootFromParent_Done,
      // Label 5800: @369736
      GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(369865), // Rule ID 11824 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11824,
        GIR_EraseRootFromParent_Done,
      // Label 5801: @369865
      GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(369994), // Rule ID 11825 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11825,
        GIR_EraseRootFromParent_Done,
      // Label 5802: @369994
      GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(370123), // Rule ID 11826 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11826,
        GIR_EraseRootFromParent_Done,
      // Label 5803: @370123
      GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(370252), // Rule ID 11763 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11763,
        GIR_EraseRootFromParent_Done,
      // Label 5804: @370252
      GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(370381), // Rule ID 11764 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11764,
        GIR_EraseRootFromParent_Done,
      // Label 5805: @370381
      GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(370510), // Rule ID 11765 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11765,
        GIR_EraseRootFromParent_Done,
      // Label 5806: @370510
      GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(370639), // Rule ID 11766 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11766,
        GIR_EraseRootFromParent_Done,
      // Label 5807: @370639
      GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(370768), // Rule ID 11808 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11808,
        GIR_EraseRootFromParent_Done,
      // Label 5808: @370768
      GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(370897), // Rule ID 11809 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11809,
        GIR_EraseRootFromParent_Done,
      // Label 5809: @370897
      GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(371026), // Rule ID 11810 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11810,
        GIR_EraseRootFromParent_Done,
      // Label 5810: @371026
      GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(371155), // Rule ID 11811 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11811,
        GIR_EraseRootFromParent_Done,
      // Label 5811: @371155
      GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(371284), // Rule ID 11748 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11748,
        GIR_EraseRootFromParent_Done,
      // Label 5812: @371284
      GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(371413), // Rule ID 11749 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11749,
        GIR_EraseRootFromParent_Done,
      // Label 5813: @371413
      GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(371542), // Rule ID 11750 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11750,
        GIR_EraseRootFromParent_Done,
      // Label 5814: @371542
      GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(371671), // Rule ID 11751 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11751,
        GIR_EraseRootFromParent_Done,
      // Label 5815: @371671
      GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(371783), // Rule ID 12878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12878,
        GIR_EraseRootFromParent_Done,
      // Label 5816: @371783
      GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(371895), // Rule ID 12877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12877,
        GIR_EraseRootFromParent_Done,
      // Label 5817: @371895
      GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(372007), // Rule ID 7848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7848,
        GIR_EraseRootFromParent_Done,
      // Label 5818: @372007
      GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(372119), // Rule ID 7847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7847,
        GIR_EraseRootFromParent_Done,
      // Label 5819: @372119
      GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(372215), // Rule ID 12862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12862,
        GIR_EraseRootFromParent_Done,
      // Label 5820: @372215
      GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(372311), // Rule ID 12861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12861,
        GIR_EraseRootFromParent_Done,
      // Label 5821: @372311
      GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(372407), // Rule ID 7832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7832,
        GIR_EraseRootFromParent_Done,
      // Label 5822: @372407
      GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(372503), // Rule ID 7831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7831,
        GIR_EraseRootFromParent_Done,
      // Label 5823: @372503
      GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(372538), // Rule ID 91 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13403),
        // (fminnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13403>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 91,
        GIR_Done,
      // Label 5824: @372538
      GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(372598), // Rule ID 802 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 802,
        GIR_EraseRootFromParent_Done,
      // Label 5825: @372598
      GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(372658), // Rule ID 8515 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8515,
        GIR_EraseRootFromParent_Done,
      // Label 5826: @372658
      GIM_Reject,
    // Label 5687: @372659
    GIM_Reject,
    // Label 5413: @372660
    GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(372912),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(372734), // Rule ID 917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 917,
        GIR_EraseRootFromParent_Done,
      // Label 5828: @372734
      GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(372793), // Rule ID 936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 936,
        GIR_EraseRootFromParent_Done,
      // Label 5829: @372793
      GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(372852), // Rule ID 8541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8541,
        GIR_EraseRootFromParent_Done,
      // Label 5830: @372852
      GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(372911), // Rule ID 8555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8555,
        GIR_EraseRootFromParent_Done,
      // Label 5831: @372911
      GIM_Reject,
    // Label 5827: @372912
    GIM_Reject,
    // Label 5414: @372913
    GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(372984), // Rule ID 1094 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fminnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1094,
      GIR_EraseRootFromParent_Done,
    // Label 5832: @372984
    GIM_Reject,
    // Label 5415: @372985
    GIM_Reject,
    // Label 81: @372986
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 5837*/ GIMT_Encode4(426604),
    /*GILLT_s16*//*Label 5833*/ GIMT_Encode4(373013),
    /*GILLT_s32*//*Label 5834*/ GIMT_Encode4(408767),
    /*GILLT_s64*//*Label 5835*/ GIMT_Encode4(426279),
    /*GILLT_v2s16*//*Label 5836*/ GIMT_Encode4(426532),
    // Label 5833: @373013
    GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(408766),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(373159), // Rule ID 12117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12117,
        GIR_EraseRootFromParent_Done,
      // Label 5839: @373159
      GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(373294), // Rule ID 12118 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12118,
        GIR_EraseRootFromParent_Done,
      // Label 5840: @373294
      GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(373429), // Rule ID 12121 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12121,
        GIR_EraseRootFromParent_Done,
      // Label 5841: @373429
      GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(373564), // Rule ID 12122 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12122,
        GIR_EraseRootFromParent_Done,
      // Label 5842: @373564
      GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(373699), // Rule ID 12597 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12597,
        GIR_EraseRootFromParent_Done,
      // Label 5843: @373699
      GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(373834), // Rule ID 12598 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12598,
        GIR_EraseRootFromParent_Done,
      // Label 5844: @373834
      GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(373969), // Rule ID 12601 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12601,
        GIR_EraseRootFromParent_Done,
      // Label 5845: @373969
      GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(374104), // Rule ID 12602 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12602,
        GIR_EraseRootFromParent_Done,
      // Label 5846: @374104
      GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(374239), // Rule ID 12102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12102,
        GIR_EraseRootFromParent_Done,
      // Label 5847: @374239
      GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(374374), // Rule ID 12103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12103,
        GIR_EraseRootFromParent_Done,
      // Label 5848: @374374
      GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(374509), // Rule ID 12106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12106,
        GIR_EraseRootFromParent_Done,
      // Label 5849: @374509
      GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(374644), // Rule ID 12107 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12107,
        GIR_EraseRootFromParent_Done,
      // Label 5850: @374644
      GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(374779), // Rule ID 12582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12582,
        GIR_EraseRootFromParent_Done,
      // Label 5851: @374779
      GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(374914), // Rule ID 12583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12583,
        GIR_EraseRootFromParent_Done,
      // Label 5852: @374914
      GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(375049), // Rule ID 12586 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12586,
        GIR_EraseRootFromParent_Done,
      // Label 5853: @375049
      GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(375184), // Rule ID 12587 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12587,
        GIR_EraseRootFromParent_Done,
      // Label 5854: @375184
      GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(375319), // Rule ID 7772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7772,
        GIR_EraseRootFromParent_Done,
      // Label 5855: @375319
      GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(375454), // Rule ID 7804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7804,
        GIR_EraseRootFromParent_Done,
      // Label 5856: @375454
      GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(375589), // Rule ID 12116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12116,
        GIR_EraseRootFromParent_Done,
      // Label 5857: @375589
      GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(375724), // Rule ID 12119 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12119,
        GIR_EraseRootFromParent_Done,
      // Label 5858: @375724
      GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(375859), // Rule ID 12120 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12120,
        GIR_EraseRootFromParent_Done,
      // Label 5859: @375859
      GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(375994), // Rule ID 12596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12596,
        GIR_EraseRootFromParent_Done,
      // Label 5860: @375994
      GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(376129), // Rule ID 12599 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12599,
        GIR_EraseRootFromParent_Done,
      // Label 5861: @376129
      GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(376264), // Rule ID 12600 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12600,
        GIR_EraseRootFromParent_Done,
      // Label 5862: @376264
      GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(376399), // Rule ID 7771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7771,
        GIR_EraseRootFromParent_Done,
      // Label 5863: @376399
      GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(376534), // Rule ID 7803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7803,
        GIR_EraseRootFromParent_Done,
      // Label 5864: @376534
      GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(376669), // Rule ID 12101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12101,
        GIR_EraseRootFromParent_Done,
      // Label 5865: @376669
      GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(376804), // Rule ID 12104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12104,
        GIR_EraseRootFromParent_Done,
      // Label 5866: @376804
      GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(376939), // Rule ID 12105 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12105,
        GIR_EraseRootFromParent_Done,
      // Label 5867: @376939
      GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(377074), // Rule ID 12581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12581,
        GIR_EraseRootFromParent_Done,
      // Label 5868: @377074
      GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(377209), // Rule ID 12584 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12584,
        GIR_EraseRootFromParent_Done,
      // Label 5869: @377209
      GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(377344), // Rule ID 12585 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12585,
        GIR_EraseRootFromParent_Done,
      // Label 5870: @377344
      GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(377479), // Rule ID 12087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12087,
        GIR_EraseRootFromParent_Done,
      // Label 5871: @377479
      GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(377614), // Rule ID 12088 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12088,
        GIR_EraseRootFromParent_Done,
      // Label 5872: @377614
      GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(377749), // Rule ID 12091 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12091,
        GIR_EraseRootFromParent_Done,
      // Label 5873: @377749
      GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(377884), // Rule ID 12092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12092,
        GIR_EraseRootFromParent_Done,
      // Label 5874: @377884
      GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(378019), // Rule ID 12567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12567,
        GIR_EraseRootFromParent_Done,
      // Label 5875: @378019
      GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(378154), // Rule ID 12568 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12568,
        GIR_EraseRootFromParent_Done,
      // Label 5876: @378154
      GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(378289), // Rule ID 12571 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12571,
        GIR_EraseRootFromParent_Done,
      // Label 5877: @378289
      GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(378424), // Rule ID 12572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12572,
        GIR_EraseRootFromParent_Done,
      // Label 5878: @378424
      GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(378559), // Rule ID 12072 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12072,
        GIR_EraseRootFromParent_Done,
      // Label 5879: @378559
      GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(378694), // Rule ID 12073 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12073,
        GIR_EraseRootFromParent_Done,
      // Label 5880: @378694
      GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(378829), // Rule ID 12076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12076,
        GIR_EraseRootFromParent_Done,
      // Label 5881: @378829
      GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(378964), // Rule ID 12077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12077,
        GIR_EraseRootFromParent_Done,
      // Label 5882: @378964
      GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(379099), // Rule ID 12552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12552,
        GIR_EraseRootFromParent_Done,
      // Label 5883: @379099
      GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(379234), // Rule ID 12553 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12553,
        GIR_EraseRootFromParent_Done,
      // Label 5884: @379234
      GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(379369), // Rule ID 12556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12556,
        GIR_EraseRootFromParent_Done,
      // Label 5885: @379369
      GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(379504), // Rule ID 12557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12557,
        GIR_EraseRootFromParent_Done,
      // Label 5886: @379504
      GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(379639), // Rule ID 7770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7770,
        GIR_EraseRootFromParent_Done,
      // Label 5887: @379639
      GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(379774), // Rule ID 7802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7802,
        GIR_EraseRootFromParent_Done,
      // Label 5888: @379774
      GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(379909), // Rule ID 12086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12086,
        GIR_EraseRootFromParent_Done,
      // Label 5889: @379909
      GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(380044), // Rule ID 12089 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12089,
        GIR_EraseRootFromParent_Done,
      // Label 5890: @380044
      GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(380179), // Rule ID 12090 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12090,
        GIR_EraseRootFromParent_Done,
      // Label 5891: @380179
      GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(380314), // Rule ID 12566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12566,
        GIR_EraseRootFromParent_Done,
      // Label 5892: @380314
      GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(380449), // Rule ID 12569 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12569,
        GIR_EraseRootFromParent_Done,
      // Label 5893: @380449
      GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(380584), // Rule ID 12570 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12570,
        GIR_EraseRootFromParent_Done,
      // Label 5894: @380584
      GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(380719), // Rule ID 7769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7769,
        GIR_EraseRootFromParent_Done,
      // Label 5895: @380719
      GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(380854), // Rule ID 7801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7801,
        GIR_EraseRootFromParent_Done,
      // Label 5896: @380854
      GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(380989), // Rule ID 12071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12071,
        GIR_EraseRootFromParent_Done,
      // Label 5897: @380989
      GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(381124), // Rule ID 12074 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12074,
        GIR_EraseRootFromParent_Done,
      // Label 5898: @381124
      GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(381259), // Rule ID 12075 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12075,
        GIR_EraseRootFromParent_Done,
      // Label 5899: @381259
      GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(381394), // Rule ID 12551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12551,
        GIR_EraseRootFromParent_Done,
      // Label 5900: @381394
      GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(381529), // Rule ID 12554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12554,
        GIR_EraseRootFromParent_Done,
      // Label 5901: @381529
      GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(381664), // Rule ID 12555 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12555,
        GIR_EraseRootFromParent_Done,
      // Label 5902: @381664
      GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(381799), // Rule ID 12127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12127,
        GIR_EraseRootFromParent_Done,
      // Label 5903: @381799
      GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(381934), // Rule ID 12128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12128,
        GIR_EraseRootFromParent_Done,
      // Label 5904: @381934
      GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(382069), // Rule ID 12129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12129,
        GIR_EraseRootFromParent_Done,
      // Label 5905: @382069
      GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(382204), // Rule ID 12130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12130,
        GIR_EraseRootFromParent_Done,
      // Label 5906: @382204
      GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(382339), // Rule ID 12607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12607,
        GIR_EraseRootFromParent_Done,
      // Label 5907: @382339
      GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(382474), // Rule ID 12608 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12608,
        GIR_EraseRootFromParent_Done,
      // Label 5908: @382474
      GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(382609), // Rule ID 12609 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12609,
        GIR_EraseRootFromParent_Done,
      // Label 5909: @382609
      GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(382744), // Rule ID 12610 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12610,
        GIR_EraseRootFromParent_Done,
      // Label 5910: @382744
      GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(382879), // Rule ID 12067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12067,
        GIR_EraseRootFromParent_Done,
      // Label 5911: @382879
      GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(383014), // Rule ID 12068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12068,
        GIR_EraseRootFromParent_Done,
      // Label 5912: @383014
      GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(383149), // Rule ID 12069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12069,
        GIR_EraseRootFromParent_Done,
      // Label 5913: @383149
      GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(383284), // Rule ID 12070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12070,
        GIR_EraseRootFromParent_Done,
      // Label 5914: @383284
      GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(383419), // Rule ID 12547 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12547,
        GIR_EraseRootFromParent_Done,
      // Label 5915: @383419
      GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(383554), // Rule ID 12548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12548,
        GIR_EraseRootFromParent_Done,
      // Label 5916: @383554
      GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(383689), // Rule ID 12549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12549,
        GIR_EraseRootFromParent_Done,
      // Label 5917: @383689
      GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(383824), // Rule ID 12550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12550,
        GIR_EraseRootFromParent_Done,
      // Label 5918: @383824
      GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(383959), // Rule ID 12112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12112,
        GIR_EraseRootFromParent_Done,
      // Label 5919: @383959
      GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(384094), // Rule ID 12113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12113,
        GIR_EraseRootFromParent_Done,
      // Label 5920: @384094
      GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(384229), // Rule ID 12114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12114,
        GIR_EraseRootFromParent_Done,
      // Label 5921: @384229
      GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(384364), // Rule ID 12115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12115,
        GIR_EraseRootFromParent_Done,
      // Label 5922: @384364
      GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(384499), // Rule ID 12592 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12592,
        GIR_EraseRootFromParent_Done,
      // Label 5923: @384499
      GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(384634), // Rule ID 12593 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12593,
        GIR_EraseRootFromParent_Done,
      // Label 5924: @384634
      GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(384769), // Rule ID 12594 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12594,
        GIR_EraseRootFromParent_Done,
      // Label 5925: @384769
      GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(384904), // Rule ID 12595 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12595,
        GIR_EraseRootFromParent_Done,
      // Label 5926: @384904
      GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(385039), // Rule ID 12052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12052,
        GIR_EraseRootFromParent_Done,
      // Label 5927: @385039
      GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(385174), // Rule ID 12053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12053,
        GIR_EraseRootFromParent_Done,
      // Label 5928: @385174
      GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(385309), // Rule ID 12054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12054,
        GIR_EraseRootFromParent_Done,
      // Label 5929: @385309
      GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(385444), // Rule ID 12055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12055,
        GIR_EraseRootFromParent_Done,
      // Label 5930: @385444
      GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(385579), // Rule ID 12532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12532,
        GIR_EraseRootFromParent_Done,
      // Label 5931: @385579
      GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(385714), // Rule ID 12533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12533,
        GIR_EraseRootFromParent_Done,
      // Label 5932: @385714
      GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(385849), // Rule ID 12534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12534,
        GIR_EraseRootFromParent_Done,
      // Label 5933: @385849
      GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(385984), // Rule ID 12535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12535,
        GIR_EraseRootFromParent_Done,
      // Label 5934: @385984
      GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(386119), // Rule ID 12123 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12123,
        GIR_EraseRootFromParent_Done,
      // Label 5935: @386119
      GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(386254), // Rule ID 12124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12124,
        GIR_EraseRootFromParent_Done,
      // Label 5936: @386254
      GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(386389), // Rule ID 12125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12125,
        GIR_EraseRootFromParent_Done,
      // Label 5937: @386389
      GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(386524), // Rule ID 12126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12126,
        GIR_EraseRootFromParent_Done,
      // Label 5938: @386524
      GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(386659), // Rule ID 12603 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12603,
        GIR_EraseRootFromParent_Done,
      // Label 5939: @386659
      GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(386794), // Rule ID 12604 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12604,
        GIR_EraseRootFromParent_Done,
      // Label 5940: @386794
      GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(386929), // Rule ID 12605 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12605,
        GIR_EraseRootFromParent_Done,
      // Label 5941: @386929
      GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(387064), // Rule ID 12606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12606,
        GIR_EraseRootFromParent_Done,
      // Label 5942: @387064
      GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(387199), // Rule ID 12063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12063,
        GIR_EraseRootFromParent_Done,
      // Label 5943: @387199
      GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(387334), // Rule ID 12064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12064,
        GIR_EraseRootFromParent_Done,
      // Label 5944: @387334
      GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(387469), // Rule ID 12065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12065,
        GIR_EraseRootFromParent_Done,
      // Label 5945: @387469
      GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(387604), // Rule ID 12066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12066,
        GIR_EraseRootFromParent_Done,
      // Label 5946: @387604
      GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(387739), // Rule ID 12543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12543,
        GIR_EraseRootFromParent_Done,
      // Label 5947: @387739
      GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(387874), // Rule ID 12544 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12544,
        GIR_EraseRootFromParent_Done,
      // Label 5948: @387874
      GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(388009), // Rule ID 12545 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12545,
        GIR_EraseRootFromParent_Done,
      // Label 5949: @388009
      GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(388144), // Rule ID 12546 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12546,
        GIR_EraseRootFromParent_Done,
      // Label 5950: @388144
      GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(388279), // Rule ID 12108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12108,
        GIR_EraseRootFromParent_Done,
      // Label 5951: @388279
      GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(388414), // Rule ID 12109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12109,
        GIR_EraseRootFromParent_Done,
      // Label 5952: @388414
      GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(388549), // Rule ID 12110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12110,
        GIR_EraseRootFromParent_Done,
      // Label 5953: @388549
      GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(388684), // Rule ID 12111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12111,
        GIR_EraseRootFromParent_Done,
      // Label 5954: @388684
      GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(388819), // Rule ID 12588 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12588,
        GIR_EraseRootFromParent_Done,
      // Label 5955: @388819
      GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(388954), // Rule ID 12589 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12589,
        GIR_EraseRootFromParent_Done,
      // Label 5956: @388954
      GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(389089), // Rule ID 12590 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12590,
        GIR_EraseRootFromParent_Done,
      // Label 5957: @389089
      GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(389224), // Rule ID 12591 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12591,
        GIR_EraseRootFromParent_Done,
      // Label 5958: @389224
      GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(389359), // Rule ID 12048 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12048,
        GIR_EraseRootFromParent_Done,
      // Label 5959: @389359
      GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(389494), // Rule ID 12049 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12049,
        GIR_EraseRootFromParent_Done,
      // Label 5960: @389494
      GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(389629), // Rule ID 12050 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12050,
        GIR_EraseRootFromParent_Done,
      // Label 5961: @389629
      GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(389764), // Rule ID 12051 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12051,
        GIR_EraseRootFromParent_Done,
      // Label 5962: @389764
      GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(389899), // Rule ID 12528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12528,
        GIR_EraseRootFromParent_Done,
      // Label 5963: @389899
      GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(390034), // Rule ID 12529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12529,
        GIR_EraseRootFromParent_Done,
      // Label 5964: @390034
      GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(390169), // Rule ID 12530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12530,
        GIR_EraseRootFromParent_Done,
      // Label 5965: @390169
      GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(390304), // Rule ID 12531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12531,
        GIR_EraseRootFromParent_Done,
      // Label 5966: @390304
      GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(390439), // Rule ID 12057 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12057,
        GIR_EraseRootFromParent_Done,
      // Label 5967: @390439
      GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(390574), // Rule ID 12058 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12058,
        GIR_EraseRootFromParent_Done,
      // Label 5968: @390574
      GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(390709), // Rule ID 12061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12061,
        GIR_EraseRootFromParent_Done,
      // Label 5969: @390709
      GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(390844), // Rule ID 12062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12062,
        GIR_EraseRootFromParent_Done,
      // Label 5970: @390844
      GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(390979), // Rule ID 12537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12537,
        GIR_EraseRootFromParent_Done,
      // Label 5971: @390979
      GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(391114), // Rule ID 12538 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12538,
        GIR_EraseRootFromParent_Done,
      // Label 5972: @391114
      GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(391249), // Rule ID 12541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12541,
        GIR_EraseRootFromParent_Done,
      // Label 5973: @391249
      GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(391384), // Rule ID 12542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12542,
        GIR_EraseRootFromParent_Done,
      // Label 5974: @391384
      GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(391519), // Rule ID 12042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12042,
        GIR_EraseRootFromParent_Done,
      // Label 5975: @391519
      GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(391654), // Rule ID 12043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12043,
        GIR_EraseRootFromParent_Done,
      // Label 5976: @391654
      GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(391789), // Rule ID 12046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12046,
        GIR_EraseRootFromParent_Done,
      // Label 5977: @391789
      GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(391924), // Rule ID 12047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12047,
        GIR_EraseRootFromParent_Done,
      // Label 5978: @391924
      GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(392059), // Rule ID 12522 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12522,
        GIR_EraseRootFromParent_Done,
      // Label 5979: @392059
      GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(392194), // Rule ID 12523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12523,
        GIR_EraseRootFromParent_Done,
      // Label 5980: @392194
      GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(392329), // Rule ID 12526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12526,
        GIR_EraseRootFromParent_Done,
      // Label 5981: @392329
      GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(392464), // Rule ID 12527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12527,
        GIR_EraseRootFromParent_Done,
      // Label 5982: @392464
      GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(392599), // Rule ID 7768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7768,
        GIR_EraseRootFromParent_Done,
      // Label 5983: @392599
      GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(392734), // Rule ID 7800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7800,
        GIR_EraseRootFromParent_Done,
      // Label 5984: @392734
      GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(392869), // Rule ID 12056 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12056,
        GIR_EraseRootFromParent_Done,
      // Label 5985: @392869
      GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(393004), // Rule ID 12059 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12059,
        GIR_EraseRootFromParent_Done,
      // Label 5986: @393004
      GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(393139), // Rule ID 12060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12060,
        GIR_EraseRootFromParent_Done,
      // Label 5987: @393139
      GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(393274), // Rule ID 12536 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12536,
        GIR_EraseRootFromParent_Done,
      // Label 5988: @393274
      GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(393409), // Rule ID 12539 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12539,
        GIR_EraseRootFromParent_Done,
      // Label 5989: @393409
      GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(393544), // Rule ID 12540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12540,
        GIR_EraseRootFromParent_Done,
      // Label 5990: @393544
      GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(393679), // Rule ID 7767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7767,
        GIR_EraseRootFromParent_Done,
      // Label 5991: @393679
      GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(393814), // Rule ID 7799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7799,
        GIR_EraseRootFromParent_Done,
      // Label 5992: @393814
      GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(393949), // Rule ID 12041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12041,
        GIR_EraseRootFromParent_Done,
      // Label 5993: @393949
      GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(394084), // Rule ID 12044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12044,
        GIR_EraseRootFromParent_Done,
      // Label 5994: @394084
      GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(394219), // Rule ID 12045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12045,
        GIR_EraseRootFromParent_Done,
      // Label 5995: @394219
      GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(394354), // Rule ID 12521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12521,
        GIR_EraseRootFromParent_Done,
      // Label 5996: @394354
      GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(394489), // Rule ID 12524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12524,
        GIR_EraseRootFromParent_Done,
      // Label 5997: @394489
      GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(394624), // Rule ID 12525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12525,
        GIR_EraseRootFromParent_Done,
      // Label 5998: @394624
      GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(394759), // Rule ID 12027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12027,
        GIR_EraseRootFromParent_Done,
      // Label 5999: @394759
      GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(394894), // Rule ID 12028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12028,
        GIR_EraseRootFromParent_Done,
      // Label 6000: @394894
      GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(395029), // Rule ID 12031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12031,
        GIR_EraseRootFromParent_Done,
      // Label 6001: @395029
      GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(395164), // Rule ID 12032 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12032,
        GIR_EraseRootFromParent_Done,
      // Label 6002: @395164
      GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(395299), // Rule ID 12507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12507,
        GIR_EraseRootFromParent_Done,
      // Label 6003: @395299
      GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(395434), // Rule ID 12508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12508,
        GIR_EraseRootFromParent_Done,
      // Label 6004: @395434
      GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(395569), // Rule ID 12511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12511,
        GIR_EraseRootFromParent_Done,
      // Label 6005: @395569
      GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(395704), // Rule ID 12512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12512,
        GIR_EraseRootFromParent_Done,
      // Label 6006: @395704
      GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(395839), // Rule ID 12012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12012,
        GIR_EraseRootFromParent_Done,
      // Label 6007: @395839
      GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(395974), // Rule ID 12013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12013,
        GIR_EraseRootFromParent_Done,
      // Label 6008: @395974
      GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(396109), // Rule ID 12016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12016,
        GIR_EraseRootFromParent_Done,
      // Label 6009: @396109
      GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(396244), // Rule ID 12017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12017,
        GIR_EraseRootFromParent_Done,
      // Label 6010: @396244
      GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(396379), // Rule ID 12492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12492,
        GIR_EraseRootFromParent_Done,
      // Label 6011: @396379
      GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(396514), // Rule ID 12493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12493,
        GIR_EraseRootFromParent_Done,
      // Label 6012: @396514
      GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(396649), // Rule ID 12496 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12496,
        GIR_EraseRootFromParent_Done,
      // Label 6013: @396649
      GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(396784), // Rule ID 12497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12497,
        GIR_EraseRootFromParent_Done,
      // Label 6014: @396784
      GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(396919), // Rule ID 7766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7766,
        GIR_EraseRootFromParent_Done,
      // Label 6015: @396919
      GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(397054), // Rule ID 7798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7798,
        GIR_EraseRootFromParent_Done,
      // Label 6016: @397054
      GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(397189), // Rule ID 12026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12026,
        GIR_EraseRootFromParent_Done,
      // Label 6017: @397189
      GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(397324), // Rule ID 12029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12029,
        GIR_EraseRootFromParent_Done,
      // Label 6018: @397324
      GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(397459), // Rule ID 12030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12030,
        GIR_EraseRootFromParent_Done,
      // Label 6019: @397459
      GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(397594), // Rule ID 12506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12506,
        GIR_EraseRootFromParent_Done,
      // Label 6020: @397594
      GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(397729), // Rule ID 12509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12509,
        GIR_EraseRootFromParent_Done,
      // Label 6021: @397729
      GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(397864), // Rule ID 12510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12510,
        GIR_EraseRootFromParent_Done,
      // Label 6022: @397864
      GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(397999), // Rule ID 7765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7765,
        GIR_EraseRootFromParent_Done,
      // Label 6023: @397999
      GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(398134), // Rule ID 7797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7797,
        GIR_EraseRootFromParent_Done,
      // Label 6024: @398134
      GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(398269), // Rule ID 12011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12011,
        GIR_EraseRootFromParent_Done,
      // Label 6025: @398269
      GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(398404), // Rule ID 12014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12014,
        GIR_EraseRootFromParent_Done,
      // Label 6026: @398404
      GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(398539), // Rule ID 12015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12015,
        GIR_EraseRootFromParent_Done,
      // Label 6027: @398539
      GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(398674), // Rule ID 12491 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12491,
        GIR_EraseRootFromParent_Done,
      // Label 6028: @398674
      GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(398809), // Rule ID 12494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12494,
        GIR_EraseRootFromParent_Done,
      // Label 6029: @398809
      GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(398944), // Rule ID 12495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12495,
        GIR_EraseRootFromParent_Done,
      // Label 6030: @398944
      GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(399079), // Rule ID 12097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12097,
        GIR_EraseRootFromParent_Done,
      // Label 6031: @399079
      GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(399214), // Rule ID 12098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12098,
        GIR_EraseRootFromParent_Done,
      // Label 6032: @399214
      GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(399349), // Rule ID 12099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12099,
        GIR_EraseRootFromParent_Done,
      // Label 6033: @399349
      GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(399484), // Rule ID 12100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12100,
        GIR_EraseRootFromParent_Done,
      // Label 6034: @399484
      GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(399619), // Rule ID 12577 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12577,
        GIR_EraseRootFromParent_Done,
      // Label 6035: @399619
      GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(399754), // Rule ID 12578 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12578,
        GIR_EraseRootFromParent_Done,
      // Label 6036: @399754
      GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(399889), // Rule ID 12579 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12579,
        GIR_EraseRootFromParent_Done,
      // Label 6037: @399889
      GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(400024), // Rule ID 12580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12580,
        GIR_EraseRootFromParent_Done,
      // Label 6038: @400024
      GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(400159), // Rule ID 12037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12037,
        GIR_EraseRootFromParent_Done,
      // Label 6039: @400159
      GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(400294), // Rule ID 12038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12038,
        GIR_EraseRootFromParent_Done,
      // Label 6040: @400294
      GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(400429), // Rule ID 12039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12039,
        GIR_EraseRootFromParent_Done,
      // Label 6041: @400429
      GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(400564), // Rule ID 12040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12040,
        GIR_EraseRootFromParent_Done,
      // Label 6042: @400564
      GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(400699), // Rule ID 12517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12517,
        GIR_EraseRootFromParent_Done,
      // Label 6043: @400699
      GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(400834), // Rule ID 12518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12518,
        GIR_EraseRootFromParent_Done,
      // Label 6044: @400834
      GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(400969), // Rule ID 12519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12519,
        GIR_EraseRootFromParent_Done,
      // Label 6045: @400969
      GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(401104), // Rule ID 12520 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12520,
        GIR_EraseRootFromParent_Done,
      // Label 6046: @401104
      GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(401239), // Rule ID 12082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12082,
        GIR_EraseRootFromParent_Done,
      // Label 6047: @401239
      GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(401374), // Rule ID 12083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12083,
        GIR_EraseRootFromParent_Done,
      // Label 6048: @401374
      GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(401509), // Rule ID 12084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12084,
        GIR_EraseRootFromParent_Done,
      // Label 6049: @401509
      GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(401644), // Rule ID 12085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12085,
        GIR_EraseRootFromParent_Done,
      // Label 6050: @401644
      GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(401779), // Rule ID 12562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12562,
        GIR_EraseRootFromParent_Done,
      // Label 6051: @401779
      GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(401914), // Rule ID 12563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12563,
        GIR_EraseRootFromParent_Done,
      // Label 6052: @401914
      GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(402049), // Rule ID 12564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12564,
        GIR_EraseRootFromParent_Done,
      // Label 6053: @402049
      GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(402184), // Rule ID 12565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12565,
        GIR_EraseRootFromParent_Done,
      // Label 6054: @402184
      GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(402319), // Rule ID 12022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12022,
        GIR_EraseRootFromParent_Done,
      // Label 6055: @402319
      GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(402454), // Rule ID 12023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12023,
        GIR_EraseRootFromParent_Done,
      // Label 6056: @402454
      GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(402589), // Rule ID 12024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12024,
        GIR_EraseRootFromParent_Done,
      // Label 6057: @402589
      GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(402724), // Rule ID 12025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12025,
        GIR_EraseRootFromParent_Done,
      // Label 6058: @402724
      GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(402859), // Rule ID 12502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12502,
        GIR_EraseRootFromParent_Done,
      // Label 6059: @402859
      GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(402994), // Rule ID 12503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12503,
        GIR_EraseRootFromParent_Done,
      // Label 6060: @402994
      GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(403129), // Rule ID 12504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12504,
        GIR_EraseRootFromParent_Done,
      // Label 6061: @403129
      GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(403264), // Rule ID 12505 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12505,
        GIR_EraseRootFromParent_Done,
      // Label 6062: @403264
      GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(403399), // Rule ID 12093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12093,
        GIR_EraseRootFromParent_Done,
      // Label 6063: @403399
      GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(403534), // Rule ID 12094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12094,
        GIR_EraseRootFromParent_Done,
      // Label 6064: @403534
      GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(403669), // Rule ID 12095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12095,
        GIR_EraseRootFromParent_Done,
      // Label 6065: @403669
      GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(403804), // Rule ID 12096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12096,
        GIR_EraseRootFromParent_Done,
      // Label 6066: @403804
      GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(403939), // Rule ID 12573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12573,
        GIR_EraseRootFromParent_Done,
      // Label 6067: @403939
      GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(404074), // Rule ID 12574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12574,
        GIR_EraseRootFromParent_Done,
      // Label 6068: @404074
      GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(404209), // Rule ID 12575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12575,
        GIR_EraseRootFromParent_Done,
      // Label 6069: @404209
      GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(404344), // Rule ID 12576 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12576,
        GIR_EraseRootFromParent_Done,
      // Label 6070: @404344
      GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(404479), // Rule ID 12033 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12033,
        GIR_EraseRootFromParent_Done,
      // Label 6071: @404479
      GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(404614), // Rule ID 12034 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12034,
        GIR_EraseRootFromParent_Done,
      // Label 6072: @404614
      GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(404749), // Rule ID 12035 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12035,
        GIR_EraseRootFromParent_Done,
      // Label 6073: @404749
      GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(404884), // Rule ID 12036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12036,
        GIR_EraseRootFromParent_Done,
      // Label 6074: @404884
      GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(405019), // Rule ID 12513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12513,
        GIR_EraseRootFromParent_Done,
      // Label 6075: @405019
      GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(405154), // Rule ID 12514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12514,
        GIR_EraseRootFromParent_Done,
      // Label 6076: @405154
      GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(405289), // Rule ID 12515 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12515,
        GIR_EraseRootFromParent_Done,
      // Label 6077: @405289
      GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(405424), // Rule ID 12516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12516,
        GIR_EraseRootFromParent_Done,
      // Label 6078: @405424
      GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(405559), // Rule ID 12078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12078,
        GIR_EraseRootFromParent_Done,
      // Label 6079: @405559
      GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(405694), // Rule ID 12079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12079,
        GIR_EraseRootFromParent_Done,
      // Label 6080: @405694
      GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(405829), // Rule ID 12080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12080,
        GIR_EraseRootFromParent_Done,
      // Label 6081: @405829
      GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(405964), // Rule ID 12081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12081,
        GIR_EraseRootFromParent_Done,
      // Label 6082: @405964
      GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(406099), // Rule ID 12558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12558,
        GIR_EraseRootFromParent_Done,
      // Label 6083: @406099
      GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(406234), // Rule ID 12559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12559,
        GIR_EraseRootFromParent_Done,
      // Label 6084: @406234
      GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(406369), // Rule ID 12560 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12560,
        GIR_EraseRootFromParent_Done,
      // Label 6085: @406369
      GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(406504), // Rule ID 12561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12561,
        GIR_EraseRootFromParent_Done,
      // Label 6086: @406504
      GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(406639), // Rule ID 12018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12018,
        GIR_EraseRootFromParent_Done,
      // Label 6087: @406639
      GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(406774), // Rule ID 12019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12019,
        GIR_EraseRootFromParent_Done,
      // Label 6088: @406774
      GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(406909), // Rule ID 12020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12020,
        GIR_EraseRootFromParent_Done,
      // Label 6089: @406909
      GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(407044), // Rule ID 12021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12021,
        GIR_EraseRootFromParent_Done,
      // Label 6090: @407044
      GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(407179), // Rule ID 12498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12498,
        GIR_EraseRootFromParent_Done,
      // Label 6091: @407179
      GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(407314), // Rule ID 12499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12499,
        GIR_EraseRootFromParent_Done,
      // Label 6092: @407314
      GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(407449), // Rule ID 12500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12500,
        GIR_EraseRootFromParent_Done,
      // Label 6093: @407449
      GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(407584), // Rule ID 12501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12501,
        GIR_EraseRootFromParent_Done,
      // Label 6094: @407584
      GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(407696), // Rule ID 12882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12882,
        GIR_EraseRootFromParent_Done,
      // Label 6095: @407696
      GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(407808), // Rule ID 12881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12881,
        GIR_EraseRootFromParent_Done,
      // Label 6096: @407808
      GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(407920), // Rule ID 7852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7852,
        GIR_EraseRootFromParent_Done,
      // Label 6097: @407920
      GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(408032), // Rule ID 7851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7851,
        GIR_EraseRootFromParent_Done,
      // Label 6098: @408032
      GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(408128), // Rule ID 12866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12866,
        GIR_EraseRootFromParent_Done,
      // Label 6099: @408128
      GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(408224), // Rule ID 12865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12865,
        GIR_EraseRootFromParent_Done,
      // Label 6100: @408224
      GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(408320), // Rule ID 7836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7836,
        GIR_EraseRootFromParent_Done,
      // Label 6101: @408320
      GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(408416), // Rule ID 7835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7835,
        GIR_EraseRootFromParent_Done,
      // Label 6102: @408416
      GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(408451), // Rule ID 103 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13404),
        // (fmaxnum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13404>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 103,
        GIR_Done,
      // Label 6103: @408451
      GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(408514), // Rule ID 881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 881,
        GIR_EraseRootFromParent_Done,
      // Label 6104: @408514
      GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(408577), // Rule ID 885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 885,
        GIR_EraseRootFromParent_Done,
      // Label 6105: @408577
      GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(408640), // Rule ID 8528 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8528,
        GIR_EraseRootFromParent_Done,
      // Label 6106: @408640
      GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(408703), // Rule ID 8530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8530,
        GIR_EraseRootFromParent_Done,
      // Label 6107: @408703
      GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(408765), // Rule ID 883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fmaxnum:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 883,
        GIR_EraseRootFromParent_Done,
      // Label 6108: @408765
      GIM_Reject,
    // Label 5838: @408766
    GIM_Reject,
    // Label 5834: @408767
    GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(426278),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(408907), // Rule ID 11607 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11607,
        GIR_EraseRootFromParent_Done,
      // Label 6110: @408907
      GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(409036), // Rule ID 11608 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11608,
        GIR_EraseRootFromParent_Done,
      // Label 6111: @409036
      GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(409165), // Rule ID 11611 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11611,
        GIR_EraseRootFromParent_Done,
      // Label 6112: @409165
      GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(409294), // Rule ID 11612 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11612,
        GIR_EraseRootFromParent_Done,
      // Label 6113: @409294
      GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(409423), // Rule ID 11592 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11592,
        GIR_EraseRootFromParent_Done,
      // Label 6114: @409423
      GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(409552), // Rule ID 11593 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11593,
        GIR_EraseRootFromParent_Done,
      // Label 6115: @409552
      GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(409681), // Rule ID 11596 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11596,
        GIR_EraseRootFromParent_Done,
      // Label 6116: @409681
      GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(409810), // Rule ID 11597 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11597,
        GIR_EraseRootFromParent_Done,
      // Label 6117: @409810
      GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(409939), // Rule ID 7738 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7738,
        GIR_EraseRootFromParent_Done,
      // Label 6118: @409939
      GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(410068), // Rule ID 11606 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11606,
        GIR_EraseRootFromParent_Done,
      // Label 6119: @410068
      GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(410197), // Rule ID 11609 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11609,
        GIR_EraseRootFromParent_Done,
      // Label 6120: @410197
      GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(410326), // Rule ID 11610 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11610,
        GIR_EraseRootFromParent_Done,
      // Label 6121: @410326
      GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(410455), // Rule ID 7737 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7737,
        GIR_EraseRootFromParent_Done,
      // Label 6122: @410455
      GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(410584), // Rule ID 11591 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11591,
        GIR_EraseRootFromParent_Done,
      // Label 6123: @410584
      GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(410713), // Rule ID 11594 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11594,
        GIR_EraseRootFromParent_Done,
      // Label 6124: @410713
      GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(410842), // Rule ID 11595 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11595,
        GIR_EraseRootFromParent_Done,
      // Label 6125: @410842
      GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(410971), // Rule ID 11577 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11577,
        GIR_EraseRootFromParent_Done,
      // Label 6126: @410971
      GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(411100), // Rule ID 11578 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11578,
        GIR_EraseRootFromParent_Done,
      // Label 6127: @411100
      GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(411229), // Rule ID 11581 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11581,
        GIR_EraseRootFromParent_Done,
      // Label 6128: @411229
      GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(411358), // Rule ID 11582 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11582,
        GIR_EraseRootFromParent_Done,
      // Label 6129: @411358
      GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(411487), // Rule ID 11562 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11562,
        GIR_EraseRootFromParent_Done,
      // Label 6130: @411487
      GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(411616), // Rule ID 11563 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11563,
        GIR_EraseRootFromParent_Done,
      // Label 6131: @411616
      GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(411745), // Rule ID 11566 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11566,
        GIR_EraseRootFromParent_Done,
      // Label 6132: @411745
      GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(411874), // Rule ID 11567 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11567,
        GIR_EraseRootFromParent_Done,
      // Label 6133: @411874
      GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(412003), // Rule ID 7736 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7736,
        GIR_EraseRootFromParent_Done,
      // Label 6134: @412003
      GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(412132), // Rule ID 11576 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11576,
        GIR_EraseRootFromParent_Done,
      // Label 6135: @412132
      GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(412261), // Rule ID 11579 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11579,
        GIR_EraseRootFromParent_Done,
      // Label 6136: @412261
      GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(412390), // Rule ID 11580 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11580,
        GIR_EraseRootFromParent_Done,
      // Label 6137: @412390
      GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(412519), // Rule ID 7735 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7735,
        GIR_EraseRootFromParent_Done,
      // Label 6138: @412519
      GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(412648), // Rule ID 11561 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11561,
        GIR_EraseRootFromParent_Done,
      // Label 6139: @412648
      GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(412777), // Rule ID 11564 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11564,
        GIR_EraseRootFromParent_Done,
      // Label 6140: @412777
      GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(412906), // Rule ID 11565 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11565,
        GIR_EraseRootFromParent_Done,
      // Label 6141: @412906
      GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(413035), // Rule ID 11617 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11617,
        GIR_EraseRootFromParent_Done,
      // Label 6142: @413035
      GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(413164), // Rule ID 11618 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11618,
        GIR_EraseRootFromParent_Done,
      // Label 6143: @413164
      GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(413293), // Rule ID 11619 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11619,
        GIR_EraseRootFromParent_Done,
      // Label 6144: @413293
      GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(413422), // Rule ID 11620 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11620,
        GIR_EraseRootFromParent_Done,
      // Label 6145: @413422
      GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(413551), // Rule ID 11557 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11557,
        GIR_EraseRootFromParent_Done,
      // Label 6146: @413551
      GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(413680), // Rule ID 11558 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11558,
        GIR_EraseRootFromParent_Done,
      // Label 6147: @413680
      GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(413809), // Rule ID 11559 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11559,
        GIR_EraseRootFromParent_Done,
      // Label 6148: @413809
      GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(413938), // Rule ID 11560 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11560,
        GIR_EraseRootFromParent_Done,
      // Label 6149: @413938
      GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(414067), // Rule ID 11602 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11602,
        GIR_EraseRootFromParent_Done,
      // Label 6150: @414067
      GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(414196), // Rule ID 11603 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11603,
        GIR_EraseRootFromParent_Done,
      // Label 6151: @414196
      GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(414325), // Rule ID 11604 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11604,
        GIR_EraseRootFromParent_Done,
      // Label 6152: @414325
      GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(414454), // Rule ID 11605 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11605,
        GIR_EraseRootFromParent_Done,
      // Label 6153: @414454
      GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(414583), // Rule ID 11542 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11542,
        GIR_EraseRootFromParent_Done,
      // Label 6154: @414583
      GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(414712), // Rule ID 11543 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11543,
        GIR_EraseRootFromParent_Done,
      // Label 6155: @414712
      GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(414841), // Rule ID 11544 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11544,
        GIR_EraseRootFromParent_Done,
      // Label 6156: @414841
      GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(414970), // Rule ID 11545 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11545,
        GIR_EraseRootFromParent_Done,
      // Label 6157: @414970
      GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(415099), // Rule ID 11613 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11613,
        GIR_EraseRootFromParent_Done,
      // Label 6158: @415099
      GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(415228), // Rule ID 11614 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11614,
        GIR_EraseRootFromParent_Done,
      // Label 6159: @415228
      GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(415357), // Rule ID 11615 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11615,
        GIR_EraseRootFromParent_Done,
      // Label 6160: @415357
      GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(415486), // Rule ID 11616 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11616,
        GIR_EraseRootFromParent_Done,
      // Label 6161: @415486
      GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(415615), // Rule ID 11553 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11553,
        GIR_EraseRootFromParent_Done,
      // Label 6162: @415615
      GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(415744), // Rule ID 11554 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11554,
        GIR_EraseRootFromParent_Done,
      // Label 6163: @415744
      GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(415873), // Rule ID 11555 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11555,
        GIR_EraseRootFromParent_Done,
      // Label 6164: @415873
      GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(416002), // Rule ID 11556 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11556,
        GIR_EraseRootFromParent_Done,
      // Label 6165: @416002
      GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(416131), // Rule ID 11598 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11598,
        GIR_EraseRootFromParent_Done,
      // Label 6166: @416131
      GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(416260), // Rule ID 11599 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11599,
        GIR_EraseRootFromParent_Done,
      // Label 6167: @416260
      GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(416389), // Rule ID 11600 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11600,
        GIR_EraseRootFromParent_Done,
      // Label 6168: @416389
      GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(416518), // Rule ID 11601 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11601,
        GIR_EraseRootFromParent_Done,
      // Label 6169: @416518
      GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(416647), // Rule ID 11538 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11538,
        GIR_EraseRootFromParent_Done,
      // Label 6170: @416647
      GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(416776), // Rule ID 11539 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11539,
        GIR_EraseRootFromParent_Done,
      // Label 6171: @416776
      GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(416905), // Rule ID 11540 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11540,
        GIR_EraseRootFromParent_Done,
      // Label 6172: @416905
      GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(417034), // Rule ID 11541 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11541,
        GIR_EraseRootFromParent_Done,
      // Label 6173: @417034
      GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(417163), // Rule ID 11547 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11547,
        GIR_EraseRootFromParent_Done,
      // Label 6174: @417163
      GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(417292), // Rule ID 11548 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11548,
        GIR_EraseRootFromParent_Done,
      // Label 6175: @417292
      GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(417421), // Rule ID 11551 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11551,
        GIR_EraseRootFromParent_Done,
      // Label 6176: @417421
      GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(417550), // Rule ID 11552 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11552,
        GIR_EraseRootFromParent_Done,
      // Label 6177: @417550
      GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(417679), // Rule ID 11532 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11532,
        GIR_EraseRootFromParent_Done,
      // Label 6178: @417679
      GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(417808), // Rule ID 11533 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11533,
        GIR_EraseRootFromParent_Done,
      // Label 6179: @417808
      GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(417937), // Rule ID 11536 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11536,
        GIR_EraseRootFromParent_Done,
      // Label 6180: @417937
      GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(418066), // Rule ID 11537 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11537,
        GIR_EraseRootFromParent_Done,
      // Label 6181: @418066
      GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(418195), // Rule ID 7734 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7734,
        GIR_EraseRootFromParent_Done,
      // Label 6182: @418195
      GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(418324), // Rule ID 11546 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11546,
        GIR_EraseRootFromParent_Done,
      // Label 6183: @418324
      GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(418453), // Rule ID 11549 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11549,
        GIR_EraseRootFromParent_Done,
      // Label 6184: @418453
      GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(418582), // Rule ID 11550 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11550,
        GIR_EraseRootFromParent_Done,
      // Label 6185: @418582
      GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(418711), // Rule ID 7733 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7733,
        GIR_EraseRootFromParent_Done,
      // Label 6186: @418711
      GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(418840), // Rule ID 11531 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11531,
        GIR_EraseRootFromParent_Done,
      // Label 6187: @418840
      GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(418969), // Rule ID 11534 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11534,
        GIR_EraseRootFromParent_Done,
      // Label 6188: @418969
      GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(419098), // Rule ID 11535 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11535,
        GIR_EraseRootFromParent_Done,
      // Label 6189: @419098
      GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(419227), // Rule ID 11517 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11517,
        GIR_EraseRootFromParent_Done,
      // Label 6190: @419227
      GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(419356), // Rule ID 11518 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11518,
        GIR_EraseRootFromParent_Done,
      // Label 6191: @419356
      GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(419485), // Rule ID 11521 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11521,
        GIR_EraseRootFromParent_Done,
      // Label 6192: @419485
      GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(419614), // Rule ID 11522 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11522,
        GIR_EraseRootFromParent_Done,
      // Label 6193: @419614
      GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(419743), // Rule ID 11502 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11502,
        GIR_EraseRootFromParent_Done,
      // Label 6194: @419743
      GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(419872), // Rule ID 11503 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11503,
        GIR_EraseRootFromParent_Done,
      // Label 6195: @419872
      GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(420001), // Rule ID 11506 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11506,
        GIR_EraseRootFromParent_Done,
      // Label 6196: @420001
      GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(420130), // Rule ID 11507 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11507,
        GIR_EraseRootFromParent_Done,
      // Label 6197: @420130
      GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(420259), // Rule ID 7732 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7732,
        GIR_EraseRootFromParent_Done,
      // Label 6198: @420259
      GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(420388), // Rule ID 11516 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11516,
        GIR_EraseRootFromParent_Done,
      // Label 6199: @420388
      GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(420517), // Rule ID 11519 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11519,
        GIR_EraseRootFromParent_Done,
      // Label 6200: @420517
      GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(420646), // Rule ID 11520 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11520,
        GIR_EraseRootFromParent_Done,
      // Label 6201: @420646
      GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(420775), // Rule ID 7731 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7731,
        GIR_EraseRootFromParent_Done,
      // Label 6202: @420775
      GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(420904), // Rule ID 11501 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11501,
        GIR_EraseRootFromParent_Done,
      // Label 6203: @420904
      GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(421033), // Rule ID 11504 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11504,
        GIR_EraseRootFromParent_Done,
      // Label 6204: @421033
      GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(421162), // Rule ID 11505 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11505,
        GIR_EraseRootFromParent_Done,
      // Label 6205: @421162
      GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(421291), // Rule ID 11587 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11587,
        GIR_EraseRootFromParent_Done,
      // Label 6206: @421291
      GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(421420), // Rule ID 11588 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11588,
        GIR_EraseRootFromParent_Done,
      // Label 6207: @421420
      GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(421549), // Rule ID 11589 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11589,
        GIR_EraseRootFromParent_Done,
      // Label 6208: @421549
      GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(421678), // Rule ID 11590 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11590,
        GIR_EraseRootFromParent_Done,
      // Label 6209: @421678
      GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(421807), // Rule ID 11527 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11527,
        GIR_EraseRootFromParent_Done,
      // Label 6210: @421807
      GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(421936), // Rule ID 11528 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11528,
        GIR_EraseRootFromParent_Done,
      // Label 6211: @421936
      GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(422065), // Rule ID 11529 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11529,
        GIR_EraseRootFromParent_Done,
      // Label 6212: @422065
      GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(422194), // Rule ID 11530 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11530,
        GIR_EraseRootFromParent_Done,
      // Label 6213: @422194
      GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(422323), // Rule ID 11572 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11572,
        GIR_EraseRootFromParent_Done,
      // Label 6214: @422323
      GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(422452), // Rule ID 11573 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11573,
        GIR_EraseRootFromParent_Done,
      // Label 6215: @422452
      GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(422581), // Rule ID 11574 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11574,
        GIR_EraseRootFromParent_Done,
      // Label 6216: @422581
      GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(422710), // Rule ID 11575 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11575,
        GIR_EraseRootFromParent_Done,
      // Label 6217: @422710
      GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(422839), // Rule ID 11512 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11512,
        GIR_EraseRootFromParent_Done,
      // Label 6218: @422839
      GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(422968), // Rule ID 11513 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11513,
        GIR_EraseRootFromParent_Done,
      // Label 6219: @422968
      GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(423097), // Rule ID 11514 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11514,
        GIR_EraseRootFromParent_Done,
      // Label 6220: @423097
      GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(423226), // Rule ID 11515 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11515,
        GIR_EraseRootFromParent_Done,
      // Label 6221: @423226
      GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(423355), // Rule ID 11583 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11583,
        GIR_EraseRootFromParent_Done,
      // Label 6222: @423355
      GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(423484), // Rule ID 11584 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11584,
        GIR_EraseRootFromParent_Done,
      // Label 6223: @423484
      GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(423613), // Rule ID 11585 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11585,
        GIR_EraseRootFromParent_Done,
      // Label 6224: @423613
      GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(423742), // Rule ID 11586 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11586,
        GIR_EraseRootFromParent_Done,
      // Label 6225: @423742
      GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(423871), // Rule ID 11523 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11523,
        GIR_EraseRootFromParent_Done,
      // Label 6226: @423871
      GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(424000), // Rule ID 11524 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11524,
        GIR_EraseRootFromParent_Done,
      // Label 6227: @424000
      GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(424129), // Rule ID 11525 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11525,
        GIR_EraseRootFromParent_Done,
      // Label 6228: @424129
      GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(424258), // Rule ID 11526 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11526,
        GIR_EraseRootFromParent_Done,
      // Label 6229: @424258
      GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(424387), // Rule ID 11568 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11568,
        GIR_EraseRootFromParent_Done,
      // Label 6230: @424387
      GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(424516), // Rule ID 11569 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11569,
        GIR_EraseRootFromParent_Done,
      // Label 6231: @424516
      GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(424645), // Rule ID 11570 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11570,
        GIR_EraseRootFromParent_Done,
      // Label 6232: @424645
      GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(424774), // Rule ID 11571 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11571,
        GIR_EraseRootFromParent_Done,
      // Label 6233: @424774
      GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(424903), // Rule ID 11508 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11508,
        GIR_EraseRootFromParent_Done,
      // Label 6234: @424903
      GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(425032), // Rule ID 11509 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11509,
        GIR_EraseRootFromParent_Done,
      // Label 6235: @425032
      GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(425161), // Rule ID 11510 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11510,
        GIR_EraseRootFromParent_Done,
      // Label 6236: @425161
      GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(425290), // Rule ID 11511 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11511,
        GIR_EraseRootFromParent_Done,
      // Label 6237: @425290
      GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(425402), // Rule ID 12874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12874,
        GIR_EraseRootFromParent_Done,
      // Label 6238: @425402
      GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(425514), // Rule ID 12873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12873,
        GIR_EraseRootFromParent_Done,
      // Label 6239: @425514
      GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(425626), // Rule ID 7844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7844,
        GIR_EraseRootFromParent_Done,
      // Label 6240: @425626
      GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(425738), // Rule ID 7843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7843,
        GIR_EraseRootFromParent_Done,
      // Label 6241: @425738
      GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(425834), // Rule ID 12858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12858,
        GIR_EraseRootFromParent_Done,
      // Label 6242: @425834
      GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(425930), // Rule ID 12857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12857,
        GIR_EraseRootFromParent_Done,
      // Label 6243: @425930
      GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(426026), // Rule ID 7828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7828,
        GIR_EraseRootFromParent_Done,
      // Label 6244: @426026
      GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(426122), // Rule ID 7827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7827,
        GIR_EraseRootFromParent_Done,
      // Label 6245: @426122
      GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(426157), // Rule ID 93 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13404),
        // (fmaxnum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13404>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 93,
        GIR_Done,
      // Label 6246: @426157
      GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(426217), // Rule ID 804 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 804,
        GIR_EraseRootFromParent_Done,
      // Label 6247: @426217
      GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(426277), // Rule ID 8517 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8517,
        GIR_EraseRootFromParent_Done,
      // Label 6248: @426277
      GIM_Reject,
    // Label 6109: @426278
    GIM_Reject,
    // Label 5835: @426279
    GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(426531),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(426353), // Rule ID 919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 919,
        GIR_EraseRootFromParent_Done,
      // Label 6250: @426353
      GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(426412), // Rule ID 938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 938,
        GIR_EraseRootFromParent_Done,
      // Label 6251: @426412
      GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(426471), // Rule ID 8543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8543,
        GIR_EraseRootFromParent_Done,
      // Label 6252: @426471
      GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(426530), // Rule ID 8557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8557,
        GIR_EraseRootFromParent_Done,
      // Label 6253: @426530
      GIM_Reject,
    // Label 6249: @426531
    GIM_Reject,
    // Label 5836: @426532
    GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(426603), // Rule ID 1092 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fmaxnum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1092,
      GIR_EraseRootFromParent_Done,
    // Label 6254: @426603
    GIM_Reject,
    // Label 5837: @426604
    GIM_Reject,
    // Label 82: @426605
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6259*/ GIMT_Encode4(480223),
    /*GILLT_s16*//*Label 6255*/ GIMT_Encode4(426632),
    /*GILLT_s32*//*Label 6256*/ GIMT_Encode4(462386),
    /*GILLT_s64*//*Label 6257*/ GIMT_Encode4(479898),
    /*GILLT_v2s16*//*Label 6258*/ GIMT_Encode4(480151),
    // Label 6255: @426632
    GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(462385),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(426778), // Rule ID 12237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12237,
        GIR_EraseRootFromParent_Done,
      // Label 6261: @426778
      GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(426913), // Rule ID 12238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12238,
        GIR_EraseRootFromParent_Done,
      // Label 6262: @426913
      GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(427048), // Rule ID 12241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12241,
        GIR_EraseRootFromParent_Done,
      // Label 6263: @427048
      GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(427183), // Rule ID 12242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12242,
        GIR_EraseRootFromParent_Done,
      // Label 6264: @427183
      GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(427318), // Rule ID 12717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12717,
        GIR_EraseRootFromParent_Done,
      // Label 6265: @427318
      GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(427453), // Rule ID 12718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12718,
        GIR_EraseRootFromParent_Done,
      // Label 6266: @427453
      GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(427588), // Rule ID 12721 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12721,
        GIR_EraseRootFromParent_Done,
      // Label 6267: @427588
      GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(427723), // Rule ID 12722 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12722,
        GIR_EraseRootFromParent_Done,
      // Label 6268: @427723
      GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(427858), // Rule ID 12222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12222,
        GIR_EraseRootFromParent_Done,
      // Label 6269: @427858
      GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(427993), // Rule ID 12223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12223,
        GIR_EraseRootFromParent_Done,
      // Label 6270: @427993
      GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(428128), // Rule ID 12226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12226,
        GIR_EraseRootFromParent_Done,
      // Label 6271: @428128
      GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(428263), // Rule ID 12227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12227,
        GIR_EraseRootFromParent_Done,
      // Label 6272: @428263
      GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(428398), // Rule ID 12702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12702,
        GIR_EraseRootFromParent_Done,
      // Label 6273: @428398
      GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(428533), // Rule ID 12703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12703,
        GIR_EraseRootFromParent_Done,
      // Label 6274: @428533
      GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(428668), // Rule ID 12706 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12706,
        GIR_EraseRootFromParent_Done,
      // Label 6275: @428668
      GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(428803), // Rule ID 12707 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12707,
        GIR_EraseRootFromParent_Done,
      // Label 6276: @428803
      GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(428938), // Rule ID 7780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7780,
        GIR_EraseRootFromParent_Done,
      // Label 6277: @428938
      GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(429073), // Rule ID 7812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7812,
        GIR_EraseRootFromParent_Done,
      // Label 6278: @429073
      GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(429208), // Rule ID 12236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12236,
        GIR_EraseRootFromParent_Done,
      // Label 6279: @429208
      GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(429343), // Rule ID 12239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12239,
        GIR_EraseRootFromParent_Done,
      // Label 6280: @429343
      GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(429478), // Rule ID 12240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12240,
        GIR_EraseRootFromParent_Done,
      // Label 6281: @429478
      GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(429613), // Rule ID 12716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12716,
        GIR_EraseRootFromParent_Done,
      // Label 6282: @429613
      GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(429748), // Rule ID 12719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12719,
        GIR_EraseRootFromParent_Done,
      // Label 6283: @429748
      GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(429883), // Rule ID 12720 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12720,
        GIR_EraseRootFromParent_Done,
      // Label 6284: @429883
      GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(430018), // Rule ID 7779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7779,
        GIR_EraseRootFromParent_Done,
      // Label 6285: @430018
      GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(430153), // Rule ID 7811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7811,
        GIR_EraseRootFromParent_Done,
      // Label 6286: @430153
      GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(430288), // Rule ID 12221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12221,
        GIR_EraseRootFromParent_Done,
      // Label 6287: @430288
      GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(430423), // Rule ID 12224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12224,
        GIR_EraseRootFromParent_Done,
      // Label 6288: @430423
      GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(430558), // Rule ID 12225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12225,
        GIR_EraseRootFromParent_Done,
      // Label 6289: @430558
      GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(430693), // Rule ID 12701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12701,
        GIR_EraseRootFromParent_Done,
      // Label 6290: @430693
      GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(430828), // Rule ID 12704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12704,
        GIR_EraseRootFromParent_Done,
      // Label 6291: @430828
      GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(430963), // Rule ID 12705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12705,
        GIR_EraseRootFromParent_Done,
      // Label 6292: @430963
      GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(431098), // Rule ID 12207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12207,
        GIR_EraseRootFromParent_Done,
      // Label 6293: @431098
      GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(431233), // Rule ID 12208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12208,
        GIR_EraseRootFromParent_Done,
      // Label 6294: @431233
      GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(431368), // Rule ID 12211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12211,
        GIR_EraseRootFromParent_Done,
      // Label 6295: @431368
      GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(431503), // Rule ID 12212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12212,
        GIR_EraseRootFromParent_Done,
      // Label 6296: @431503
      GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(431638), // Rule ID 12687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12687,
        GIR_EraseRootFromParent_Done,
      // Label 6297: @431638
      GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(431773), // Rule ID 12688 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12688,
        GIR_EraseRootFromParent_Done,
      // Label 6298: @431773
      GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(431908), // Rule ID 12691 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12691,
        GIR_EraseRootFromParent_Done,
      // Label 6299: @431908
      GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(432043), // Rule ID 12692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12692,
        GIR_EraseRootFromParent_Done,
      // Label 6300: @432043
      GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(432178), // Rule ID 12192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12192,
        GIR_EraseRootFromParent_Done,
      // Label 6301: @432178
      GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(432313), // Rule ID 12193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12193,
        GIR_EraseRootFromParent_Done,
      // Label 6302: @432313
      GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(432448), // Rule ID 12196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12196,
        GIR_EraseRootFromParent_Done,
      // Label 6303: @432448
      GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(432583), // Rule ID 12197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12197,
        GIR_EraseRootFromParent_Done,
      // Label 6304: @432583
      GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(432718), // Rule ID 12672 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12672,
        GIR_EraseRootFromParent_Done,
      // Label 6305: @432718
      GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(432853), // Rule ID 12673 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12673,
        GIR_EraseRootFromParent_Done,
      // Label 6306: @432853
      GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(432988), // Rule ID 12676 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12676,
        GIR_EraseRootFromParent_Done,
      // Label 6307: @432988
      GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(433123), // Rule ID 12677 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12677,
        GIR_EraseRootFromParent_Done,
      // Label 6308: @433123
      GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(433258), // Rule ID 7778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7778,
        GIR_EraseRootFromParent_Done,
      // Label 6309: @433258
      GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(433393), // Rule ID 7810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7810,
        GIR_EraseRootFromParent_Done,
      // Label 6310: @433393
      GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(433528), // Rule ID 12206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12206,
        GIR_EraseRootFromParent_Done,
      // Label 6311: @433528
      GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(433663), // Rule ID 12209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12209,
        GIR_EraseRootFromParent_Done,
      // Label 6312: @433663
      GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(433798), // Rule ID 12210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12210,
        GIR_EraseRootFromParent_Done,
      // Label 6313: @433798
      GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(433933), // Rule ID 12686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12686,
        GIR_EraseRootFromParent_Done,
      // Label 6314: @433933
      GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(434068), // Rule ID 12689 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12689,
        GIR_EraseRootFromParent_Done,
      // Label 6315: @434068
      GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(434203), // Rule ID 12690 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12690,
        GIR_EraseRootFromParent_Done,
      // Label 6316: @434203
      GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(434338), // Rule ID 7777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7777,
        GIR_EraseRootFromParent_Done,
      // Label 6317: @434338
      GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(434473), // Rule ID 7809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7809,
        GIR_EraseRootFromParent_Done,
      // Label 6318: @434473
      GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(434608), // Rule ID 12191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12191,
        GIR_EraseRootFromParent_Done,
      // Label 6319: @434608
      GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(434743), // Rule ID 12194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12194,
        GIR_EraseRootFromParent_Done,
      // Label 6320: @434743
      GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(434878), // Rule ID 12195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12195,
        GIR_EraseRootFromParent_Done,
      // Label 6321: @434878
      GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(435013), // Rule ID 12671 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12671,
        GIR_EraseRootFromParent_Done,
      // Label 6322: @435013
      GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(435148), // Rule ID 12674 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12674,
        GIR_EraseRootFromParent_Done,
      // Label 6323: @435148
      GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(435283), // Rule ID 12675 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12675,
        GIR_EraseRootFromParent_Done,
      // Label 6324: @435283
      GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(435418), // Rule ID 12247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12247,
        GIR_EraseRootFromParent_Done,
      // Label 6325: @435418
      GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(435553), // Rule ID 12248 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12248,
        GIR_EraseRootFromParent_Done,
      // Label 6326: @435553
      GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(435688), // Rule ID 12249 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12249,
        GIR_EraseRootFromParent_Done,
      // Label 6327: @435688
      GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(435823), // Rule ID 12250 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12250,
        GIR_EraseRootFromParent_Done,
      // Label 6328: @435823
      GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(435958), // Rule ID 12727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12727,
        GIR_EraseRootFromParent_Done,
      // Label 6329: @435958
      GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(436093), // Rule ID 12728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12728,
        GIR_EraseRootFromParent_Done,
      // Label 6330: @436093
      GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(436228), // Rule ID 12729 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12729,
        GIR_EraseRootFromParent_Done,
      // Label 6331: @436228
      GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(436363), // Rule ID 12730 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12730,
        GIR_EraseRootFromParent_Done,
      // Label 6332: @436363
      GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(436498), // Rule ID 12187 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12187,
        GIR_EraseRootFromParent_Done,
      // Label 6333: @436498
      GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(436633), // Rule ID 12188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12188,
        GIR_EraseRootFromParent_Done,
      // Label 6334: @436633
      GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(436768), // Rule ID 12189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12189,
        GIR_EraseRootFromParent_Done,
      // Label 6335: @436768
      GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(436903), // Rule ID 12190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12190,
        GIR_EraseRootFromParent_Done,
      // Label 6336: @436903
      GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(437038), // Rule ID 12667 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12667,
        GIR_EraseRootFromParent_Done,
      // Label 6337: @437038
      GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(437173), // Rule ID 12668 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12668,
        GIR_EraseRootFromParent_Done,
      // Label 6338: @437173
      GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(437308), // Rule ID 12669 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12669,
        GIR_EraseRootFromParent_Done,
      // Label 6339: @437308
      GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(437443), // Rule ID 12670 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12670,
        GIR_EraseRootFromParent_Done,
      // Label 6340: @437443
      GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(437578), // Rule ID 12232 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12232,
        GIR_EraseRootFromParent_Done,
      // Label 6341: @437578
      GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(437713), // Rule ID 12233 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12233,
        GIR_EraseRootFromParent_Done,
      // Label 6342: @437713
      GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(437848), // Rule ID 12234 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12234,
        GIR_EraseRootFromParent_Done,
      // Label 6343: @437848
      GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(437983), // Rule ID 12235 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12235,
        GIR_EraseRootFromParent_Done,
      // Label 6344: @437983
      GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(438118), // Rule ID 12712 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12712,
        GIR_EraseRootFromParent_Done,
      // Label 6345: @438118
      GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(438253), // Rule ID 12713 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12713,
        GIR_EraseRootFromParent_Done,
      // Label 6346: @438253
      GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(438388), // Rule ID 12714 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12714,
        GIR_EraseRootFromParent_Done,
      // Label 6347: @438388
      GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(438523), // Rule ID 12715 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12715,
        GIR_EraseRootFromParent_Done,
      // Label 6348: @438523
      GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(438658), // Rule ID 12172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12172,
        GIR_EraseRootFromParent_Done,
      // Label 6349: @438658
      GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(438793), // Rule ID 12173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12173,
        GIR_EraseRootFromParent_Done,
      // Label 6350: @438793
      GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(438928), // Rule ID 12174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12174,
        GIR_EraseRootFromParent_Done,
      // Label 6351: @438928
      GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(439063), // Rule ID 12175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12175,
        GIR_EraseRootFromParent_Done,
      // Label 6352: @439063
      GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(439198), // Rule ID 12652 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12652,
        GIR_EraseRootFromParent_Done,
      // Label 6353: @439198
      GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(439333), // Rule ID 12653 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12653,
        GIR_EraseRootFromParent_Done,
      // Label 6354: @439333
      GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(439468), // Rule ID 12654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12654,
        GIR_EraseRootFromParent_Done,
      // Label 6355: @439468
      GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(439603), // Rule ID 12655 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12655,
        GIR_EraseRootFromParent_Done,
      // Label 6356: @439603
      GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(439738), // Rule ID 12243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12243,
        GIR_EraseRootFromParent_Done,
      // Label 6357: @439738
      GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(439873), // Rule ID 12244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12244,
        GIR_EraseRootFromParent_Done,
      // Label 6358: @439873
      GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(440008), // Rule ID 12245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12245,
        GIR_EraseRootFromParent_Done,
      // Label 6359: @440008
      GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(440143), // Rule ID 12246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12246,
        GIR_EraseRootFromParent_Done,
      // Label 6360: @440143
      GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(440278), // Rule ID 12723 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12723,
        GIR_EraseRootFromParent_Done,
      // Label 6361: @440278
      GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(440413), // Rule ID 12724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12724,
        GIR_EraseRootFromParent_Done,
      // Label 6362: @440413
      GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(440548), // Rule ID 12725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12725,
        GIR_EraseRootFromParent_Done,
      // Label 6363: @440548
      GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(440683), // Rule ID 12726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12726,
        GIR_EraseRootFromParent_Done,
      // Label 6364: @440683
      GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(440818), // Rule ID 12183 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12183,
        GIR_EraseRootFromParent_Done,
      // Label 6365: @440818
      GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(440953), // Rule ID 12184 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12184,
        GIR_EraseRootFromParent_Done,
      // Label 6366: @440953
      GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(441088), // Rule ID 12185 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12185,
        GIR_EraseRootFromParent_Done,
      // Label 6367: @441088
      GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(441223), // Rule ID 12186 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12186,
        GIR_EraseRootFromParent_Done,
      // Label 6368: @441223
      GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(441358), // Rule ID 12663 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12663,
        GIR_EraseRootFromParent_Done,
      // Label 6369: @441358
      GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(441493), // Rule ID 12664 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12664,
        GIR_EraseRootFromParent_Done,
      // Label 6370: @441493
      GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(441628), // Rule ID 12665 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12665,
        GIR_EraseRootFromParent_Done,
      // Label 6371: @441628
      GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(441763), // Rule ID 12666 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12666,
        GIR_EraseRootFromParent_Done,
      // Label 6372: @441763
      GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(441898), // Rule ID 12228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12228,
        GIR_EraseRootFromParent_Done,
      // Label 6373: @441898
      GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(442033), // Rule ID 12229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12229,
        GIR_EraseRootFromParent_Done,
      // Label 6374: @442033
      GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(442168), // Rule ID 12230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12230,
        GIR_EraseRootFromParent_Done,
      // Label 6375: @442168
      GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(442303), // Rule ID 12231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12231,
        GIR_EraseRootFromParent_Done,
      // Label 6376: @442303
      GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(442438), // Rule ID 12708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12708,
        GIR_EraseRootFromParent_Done,
      // Label 6377: @442438
      GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(442573), // Rule ID 12709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12709,
        GIR_EraseRootFromParent_Done,
      // Label 6378: @442573
      GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(442708), // Rule ID 12710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12710,
        GIR_EraseRootFromParent_Done,
      // Label 6379: @442708
      GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(442843), // Rule ID 12711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12711,
        GIR_EraseRootFromParent_Done,
      // Label 6380: @442843
      GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(442978), // Rule ID 12168 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12168,
        GIR_EraseRootFromParent_Done,
      // Label 6381: @442978
      GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(443113), // Rule ID 12169 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12169,
        GIR_EraseRootFromParent_Done,
      // Label 6382: @443113
      GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(443248), // Rule ID 12170 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12170,
        GIR_EraseRootFromParent_Done,
      // Label 6383: @443248
      GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(443383), // Rule ID 12171 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12171,
        GIR_EraseRootFromParent_Done,
      // Label 6384: @443383
      GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(443518), // Rule ID 12648 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12648,
        GIR_EraseRootFromParent_Done,
      // Label 6385: @443518
      GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(443653), // Rule ID 12649 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12649,
        GIR_EraseRootFromParent_Done,
      // Label 6386: @443653
      GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(443788), // Rule ID 12650 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12650,
        GIR_EraseRootFromParent_Done,
      // Label 6387: @443788
      GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(443923), // Rule ID 12651 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12651,
        GIR_EraseRootFromParent_Done,
      // Label 6388: @443923
      GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(444058), // Rule ID 12177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12177,
        GIR_EraseRootFromParent_Done,
      // Label 6389: @444058
      GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(444193), // Rule ID 12178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12178,
        GIR_EraseRootFromParent_Done,
      // Label 6390: @444193
      GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(444328), // Rule ID 12181 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12181,
        GIR_EraseRootFromParent_Done,
      // Label 6391: @444328
      GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(444463), // Rule ID 12182 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12182,
        GIR_EraseRootFromParent_Done,
      // Label 6392: @444463
      GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(444598), // Rule ID 12657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12657,
        GIR_EraseRootFromParent_Done,
      // Label 6393: @444598
      GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(444733), // Rule ID 12658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12658,
        GIR_EraseRootFromParent_Done,
      // Label 6394: @444733
      GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(444868), // Rule ID 12661 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12661,
        GIR_EraseRootFromParent_Done,
      // Label 6395: @444868
      GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(445003), // Rule ID 12662 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12662,
        GIR_EraseRootFromParent_Done,
      // Label 6396: @445003
      GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(445138), // Rule ID 12162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12162,
        GIR_EraseRootFromParent_Done,
      // Label 6397: @445138
      GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(445273), // Rule ID 12163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12163,
        GIR_EraseRootFromParent_Done,
      // Label 6398: @445273
      GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(445408), // Rule ID 12166 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12166,
        GIR_EraseRootFromParent_Done,
      // Label 6399: @445408
      GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(445543), // Rule ID 12167 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12167,
        GIR_EraseRootFromParent_Done,
      // Label 6400: @445543
      GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(445678), // Rule ID 12642 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12642,
        GIR_EraseRootFromParent_Done,
      // Label 6401: @445678
      GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(445813), // Rule ID 12643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12643,
        GIR_EraseRootFromParent_Done,
      // Label 6402: @445813
      GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(445948), // Rule ID 12646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12646,
        GIR_EraseRootFromParent_Done,
      // Label 6403: @445948
      GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(446083), // Rule ID 12647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12647,
        GIR_EraseRootFromParent_Done,
      // Label 6404: @446083
      GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(446218), // Rule ID 7776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7776,
        GIR_EraseRootFromParent_Done,
      // Label 6405: @446218
      GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(446353), // Rule ID 7808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7808,
        GIR_EraseRootFromParent_Done,
      // Label 6406: @446353
      GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(446488), // Rule ID 12176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12176,
        GIR_EraseRootFromParent_Done,
      // Label 6407: @446488
      GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(446623), // Rule ID 12179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12179,
        GIR_EraseRootFromParent_Done,
      // Label 6408: @446623
      GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(446758), // Rule ID 12180 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12180,
        GIR_EraseRootFromParent_Done,
      // Label 6409: @446758
      GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(446893), // Rule ID 12656 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12656,
        GIR_EraseRootFromParent_Done,
      // Label 6410: @446893
      GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(447028), // Rule ID 12659 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12659,
        GIR_EraseRootFromParent_Done,
      // Label 6411: @447028
      GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(447163), // Rule ID 12660 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12660,
        GIR_EraseRootFromParent_Done,
      // Label 6412: @447163
      GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(447298), // Rule ID 7775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7775,
        GIR_EraseRootFromParent_Done,
      // Label 6413: @447298
      GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(447433), // Rule ID 7807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7807,
        GIR_EraseRootFromParent_Done,
      // Label 6414: @447433
      GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(447568), // Rule ID 12161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12161,
        GIR_EraseRootFromParent_Done,
      // Label 6415: @447568
      GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(447703), // Rule ID 12164 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12164,
        GIR_EraseRootFromParent_Done,
      // Label 6416: @447703
      GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(447838), // Rule ID 12165 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12165,
        GIR_EraseRootFromParent_Done,
      // Label 6417: @447838
      GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(447973), // Rule ID 12641 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12641,
        GIR_EraseRootFromParent_Done,
      // Label 6418: @447973
      GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(448108), // Rule ID 12644 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12644,
        GIR_EraseRootFromParent_Done,
      // Label 6419: @448108
      GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(448243), // Rule ID 12645 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12645,
        GIR_EraseRootFromParent_Done,
      // Label 6420: @448243
      GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(448378), // Rule ID 12147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12147,
        GIR_EraseRootFromParent_Done,
      // Label 6421: @448378
      GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(448513), // Rule ID 12148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12148,
        GIR_EraseRootFromParent_Done,
      // Label 6422: @448513
      GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(448648), // Rule ID 12151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12151,
        GIR_EraseRootFromParent_Done,
      // Label 6423: @448648
      GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(448783), // Rule ID 12152 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12152,
        GIR_EraseRootFromParent_Done,
      // Label 6424: @448783
      GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(448918), // Rule ID 12627 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12627,
        GIR_EraseRootFromParent_Done,
      // Label 6425: @448918
      GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(449053), // Rule ID 12628 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12628,
        GIR_EraseRootFromParent_Done,
      // Label 6426: @449053
      GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(449188), // Rule ID 12631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12631,
        GIR_EraseRootFromParent_Done,
      // Label 6427: @449188
      GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(449323), // Rule ID 12632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12632,
        GIR_EraseRootFromParent_Done,
      // Label 6428: @449323
      GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(449458), // Rule ID 12132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12132,
        GIR_EraseRootFromParent_Done,
      // Label 6429: @449458
      GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(449593), // Rule ID 12133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12133,
        GIR_EraseRootFromParent_Done,
      // Label 6430: @449593
      GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(449728), // Rule ID 12136 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12136,
        GIR_EraseRootFromParent_Done,
      // Label 6431: @449728
      GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(449863), // Rule ID 12137 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12137,
        GIR_EraseRootFromParent_Done,
      // Label 6432: @449863
      GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(449998), // Rule ID 12612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12612,
        GIR_EraseRootFromParent_Done,
      // Label 6433: @449998
      GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(450133), // Rule ID 12613 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12613,
        GIR_EraseRootFromParent_Done,
      // Label 6434: @450133
      GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(450268), // Rule ID 12616 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12616,
        GIR_EraseRootFromParent_Done,
      // Label 6435: @450268
      GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(450403), // Rule ID 12617 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12617,
        GIR_EraseRootFromParent_Done,
      // Label 6436: @450403
      GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(450538), // Rule ID 7774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7774,
        GIR_EraseRootFromParent_Done,
      // Label 6437: @450538
      GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(450673), // Rule ID 7806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7806,
        GIR_EraseRootFromParent_Done,
      // Label 6438: @450673
      GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(450808), // Rule ID 12146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12146,
        GIR_EraseRootFromParent_Done,
      // Label 6439: @450808
      GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(450943), // Rule ID 12149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12149,
        GIR_EraseRootFromParent_Done,
      // Label 6440: @450943
      GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(451078), // Rule ID 12150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12150,
        GIR_EraseRootFromParent_Done,
      // Label 6441: @451078
      GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(451213), // Rule ID 12626 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12626,
        GIR_EraseRootFromParent_Done,
      // Label 6442: @451213
      GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(451348), // Rule ID 12629 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12629,
        GIR_EraseRootFromParent_Done,
      // Label 6443: @451348
      GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(451483), // Rule ID 12630 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12630,
        GIR_EraseRootFromParent_Done,
      // Label 6444: @451483
      GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(451618), // Rule ID 7773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7773,
        GIR_EraseRootFromParent_Done,
      // Label 6445: @451618
      GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(451753), // Rule ID 7805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7805,
        GIR_EraseRootFromParent_Done,
      // Label 6446: @451753
      GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(451888), // Rule ID 12131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12131,
        GIR_EraseRootFromParent_Done,
      // Label 6447: @451888
      GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(452023), // Rule ID 12134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12134,
        GIR_EraseRootFromParent_Done,
      // Label 6448: @452023
      GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(452158), // Rule ID 12135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12135,
        GIR_EraseRootFromParent_Done,
      // Label 6449: @452158
      GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(452293), // Rule ID 12611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12611,
        GIR_EraseRootFromParent_Done,
      // Label 6450: @452293
      GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(452428), // Rule ID 12614 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12614,
        GIR_EraseRootFromParent_Done,
      // Label 6451: @452428
      GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(452563), // Rule ID 12615 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12615,
        GIR_EraseRootFromParent_Done,
      // Label 6452: @452563
      GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(452698), // Rule ID 12217 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12217,
        GIR_EraseRootFromParent_Done,
      // Label 6453: @452698
      GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(452833), // Rule ID 12218 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12218,
        GIR_EraseRootFromParent_Done,
      // Label 6454: @452833
      GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(452968), // Rule ID 12219 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12219,
        GIR_EraseRootFromParent_Done,
      // Label 6455: @452968
      GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(453103), // Rule ID 12220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12220,
        GIR_EraseRootFromParent_Done,
      // Label 6456: @453103
      GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(453238), // Rule ID 12697 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12697,
        GIR_EraseRootFromParent_Done,
      // Label 6457: @453238
      GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(453373), // Rule ID 12698 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12698,
        GIR_EraseRootFromParent_Done,
      // Label 6458: @453373
      GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(453508), // Rule ID 12699 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12699,
        GIR_EraseRootFromParent_Done,
      // Label 6459: @453508
      GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(453643), // Rule ID 12700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12700,
        GIR_EraseRootFromParent_Done,
      // Label 6460: @453643
      GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(453778), // Rule ID 12157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12157,
        GIR_EraseRootFromParent_Done,
      // Label 6461: @453778
      GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(453913), // Rule ID 12158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12158,
        GIR_EraseRootFromParent_Done,
      // Label 6462: @453913
      GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(454048), // Rule ID 12159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12159,
        GIR_EraseRootFromParent_Done,
      // Label 6463: @454048
      GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(454183), // Rule ID 12160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12160,
        GIR_EraseRootFromParent_Done,
      // Label 6464: @454183
      GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(454318), // Rule ID 12637 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12637,
        GIR_EraseRootFromParent_Done,
      // Label 6465: @454318
      GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(454453), // Rule ID 12638 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12638,
        GIR_EraseRootFromParent_Done,
      // Label 6466: @454453
      GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(454588), // Rule ID 12639 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12639,
        GIR_EraseRootFromParent_Done,
      // Label 6467: @454588
      GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(454723), // Rule ID 12640 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12640,
        GIR_EraseRootFromParent_Done,
      // Label 6468: @454723
      GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(454858), // Rule ID 12202 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12202,
        GIR_EraseRootFromParent_Done,
      // Label 6469: @454858
      GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(454993), // Rule ID 12203 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12203,
        GIR_EraseRootFromParent_Done,
      // Label 6470: @454993
      GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(455128), // Rule ID 12204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12204,
        GIR_EraseRootFromParent_Done,
      // Label 6471: @455128
      GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(455263), // Rule ID 12205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12205,
        GIR_EraseRootFromParent_Done,
      // Label 6472: @455263
      GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(455398), // Rule ID 12682 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12682,
        GIR_EraseRootFromParent_Done,
      // Label 6473: @455398
      GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(455533), // Rule ID 12683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12683,
        GIR_EraseRootFromParent_Done,
      // Label 6474: @455533
      GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(455668), // Rule ID 12684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12684,
        GIR_EraseRootFromParent_Done,
      // Label 6475: @455668
      GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(455803), // Rule ID 12685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12685,
        GIR_EraseRootFromParent_Done,
      // Label 6476: @455803
      GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(455938), // Rule ID 12142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12142,
        GIR_EraseRootFromParent_Done,
      // Label 6477: @455938
      GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(456073), // Rule ID 12143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12143,
        GIR_EraseRootFromParent_Done,
      // Label 6478: @456073
      GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(456208), // Rule ID 12144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12144,
        GIR_EraseRootFromParent_Done,
      // Label 6479: @456208
      GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(456343), // Rule ID 12145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12145,
        GIR_EraseRootFromParent_Done,
      // Label 6480: @456343
      GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(456478), // Rule ID 12622 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12622,
        GIR_EraseRootFromParent_Done,
      // Label 6481: @456478
      GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(456613), // Rule ID 12623 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12623,
        GIR_EraseRootFromParent_Done,
      // Label 6482: @456613
      GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(456748), // Rule ID 12624 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12624,
        GIR_EraseRootFromParent_Done,
      // Label 6483: @456748
      GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(456883), // Rule ID 12625 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12625,
        GIR_EraseRootFromParent_Done,
      // Label 6484: @456883
      GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(457018), // Rule ID 12213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12213,
        GIR_EraseRootFromParent_Done,
      // Label 6485: @457018
      GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(457153), // Rule ID 12214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12214,
        GIR_EraseRootFromParent_Done,
      // Label 6486: @457153
      GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(457288), // Rule ID 12215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12215,
        GIR_EraseRootFromParent_Done,
      // Label 6487: @457288
      GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(457423), // Rule ID 12216 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12216,
        GIR_EraseRootFromParent_Done,
      // Label 6488: @457423
      GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(457558), // Rule ID 12693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12693,
        GIR_EraseRootFromParent_Done,
      // Label 6489: @457558
      GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(457693), // Rule ID 12694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12694,
        GIR_EraseRootFromParent_Done,
      // Label 6490: @457693
      GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(457828), // Rule ID 12695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12695,
        GIR_EraseRootFromParent_Done,
      // Label 6491: @457828
      GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(457963), // Rule ID 12696 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12696,
        GIR_EraseRootFromParent_Done,
      // Label 6492: @457963
      GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(458098), // Rule ID 12153 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12153,
        GIR_EraseRootFromParent_Done,
      // Label 6493: @458098
      GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(458233), // Rule ID 12154 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12154,
        GIR_EraseRootFromParent_Done,
      // Label 6494: @458233
      GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(458368), // Rule ID 12155 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12155,
        GIR_EraseRootFromParent_Done,
      // Label 6495: @458368
      GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(458503), // Rule ID 12156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12156,
        GIR_EraseRootFromParent_Done,
      // Label 6496: @458503
      GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(458638), // Rule ID 12633 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12633,
        GIR_EraseRootFromParent_Done,
      // Label 6497: @458638
      GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(458773), // Rule ID 12634 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12634,
        GIR_EraseRootFromParent_Done,
      // Label 6498: @458773
      GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(458908), // Rule ID 12635 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12635,
        GIR_EraseRootFromParent_Done,
      // Label 6499: @458908
      GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(459043), // Rule ID 12636 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12636,
        GIR_EraseRootFromParent_Done,
      // Label 6500: @459043
      GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(459178), // Rule ID 12198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12198,
        GIR_EraseRootFromParent_Done,
      // Label 6501: @459178
      GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(459313), // Rule ID 12199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12199,
        GIR_EraseRootFromParent_Done,
      // Label 6502: @459313
      GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(459448), // Rule ID 12200 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12200,
        GIR_EraseRootFromParent_Done,
      // Label 6503: @459448
      GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(459583), // Rule ID 12201 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12201,
        GIR_EraseRootFromParent_Done,
      // Label 6504: @459583
      GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(459718), // Rule ID 12678 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12678,
        GIR_EraseRootFromParent_Done,
      // Label 6505: @459718
      GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(459853), // Rule ID 12679 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12679,
        GIR_EraseRootFromParent_Done,
      // Label 6506: @459853
      GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(459988), // Rule ID 12680 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12680,
        GIR_EraseRootFromParent_Done,
      // Label 6507: @459988
      GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(460123), // Rule ID 12681 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12681,
        GIR_EraseRootFromParent_Done,
      // Label 6508: @460123
      GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(460258), // Rule ID 12138 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12138,
        GIR_EraseRootFromParent_Done,
      // Label 6509: @460258
      GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(460393), // Rule ID 12139 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12139,
        GIR_EraseRootFromParent_Done,
      // Label 6510: @460393
      GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(460528), // Rule ID 12140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12140,
        GIR_EraseRootFromParent_Done,
      // Label 6511: @460528
      GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(460663), // Rule ID 12141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12141,
        GIR_EraseRootFromParent_Done,
      // Label 6512: @460663
      GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(460798), // Rule ID 12618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12618,
        GIR_EraseRootFromParent_Done,
      // Label 6513: @460798
      GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(460933), // Rule ID 12619 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12619,
        GIR_EraseRootFromParent_Done,
      // Label 6514: @460933
      GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(461068), // Rule ID 12620 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12620,
        GIR_EraseRootFromParent_Done,
      // Label 6515: @461068
      GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(461203), // Rule ID 12621 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12621,
        GIR_EraseRootFromParent_Done,
      // Label 6516: @461203
      GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(461315), // Rule ID 12884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12884,
        GIR_EraseRootFromParent_Done,
      // Label 6517: @461315
      GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(461427), // Rule ID 12883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12883,
        GIR_EraseRootFromParent_Done,
      // Label 6518: @461427
      GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(461539), // Rule ID 7854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7854,
        GIR_EraseRootFromParent_Done,
      // Label 6519: @461539
      GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(461651), // Rule ID 7853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7853,
        GIR_EraseRootFromParent_Done,
      // Label 6520: @461651
      GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(461747), // Rule ID 12868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12868,
        GIR_EraseRootFromParent_Done,
      // Label 6521: @461747
      GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(461843), // Rule ID 12867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12867,
        GIR_EraseRootFromParent_Done,
      // Label 6522: @461843
      GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(461939), // Rule ID 7838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7838,
        GIR_EraseRootFromParent_Done,
      // Label 6523: @461939
      GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(462035), // Rule ID 7837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7837,
        GIR_EraseRootFromParent_Done,
      // Label 6524: @462035
      GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(462070), // Rule ID 100 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13403),
        // (fminnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13403>>  =>  (S_MIN_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 100,
        GIR_Done,
      // Label 6525: @462070
      GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(462133), // Rule ID 886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 886,
        GIR_EraseRootFromParent_Done,
      // Label 6526: @462133
      GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(462196), // Rule ID 890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 890,
        GIR_EraseRootFromParent_Done,
      // Label 6527: @462196
      GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(462259), // Rule ID 8531 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8531,
        GIR_EraseRootFromParent_Done,
      // Label 6528: @462259
      GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(462322), // Rule ID 8533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8533,
        GIR_EraseRootFromParent_Done,
      // Label 6529: @462322
      GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(462384), // Rule ID 888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fminnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 888,
        GIR_EraseRootFromParent_Done,
      // Label 6530: @462384
      GIM_Reject,
    // Label 6260: @462385
    GIM_Reject,
    // Label 6256: @462386
    GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(479897),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(462526), // Rule ID 11727 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11727,
        GIR_EraseRootFromParent_Done,
      // Label 6532: @462526
      GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(462655), // Rule ID 11728 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11728,
        GIR_EraseRootFromParent_Done,
      // Label 6533: @462655
      GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(462784), // Rule ID 11731 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11731,
        GIR_EraseRootFromParent_Done,
      // Label 6534: @462784
      GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(462913), // Rule ID 11732 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11732,
        GIR_EraseRootFromParent_Done,
      // Label 6535: @462913
      GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(463042), // Rule ID 11712 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11712,
        GIR_EraseRootFromParent_Done,
      // Label 6536: @463042
      GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(463171), // Rule ID 11713 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11713,
        GIR_EraseRootFromParent_Done,
      // Label 6537: @463171
      GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(463300), // Rule ID 11716 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11716,
        GIR_EraseRootFromParent_Done,
      // Label 6538: @463300
      GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(463429), // Rule ID 11717 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11717,
        GIR_EraseRootFromParent_Done,
      // Label 6539: @463429
      GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(463558), // Rule ID 7746 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7746,
        GIR_EraseRootFromParent_Done,
      // Label 6540: @463558
      GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(463687), // Rule ID 11726 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11726,
        GIR_EraseRootFromParent_Done,
      // Label 6541: @463687
      GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(463816), // Rule ID 11729 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11729,
        GIR_EraseRootFromParent_Done,
      // Label 6542: @463816
      GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(463945), // Rule ID 11730 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11730,
        GIR_EraseRootFromParent_Done,
      // Label 6543: @463945
      GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(464074), // Rule ID 7745 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7745,
        GIR_EraseRootFromParent_Done,
      // Label 6544: @464074
      GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(464203), // Rule ID 11711 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11711,
        GIR_EraseRootFromParent_Done,
      // Label 6545: @464203
      GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(464332), // Rule ID 11714 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11714,
        GIR_EraseRootFromParent_Done,
      // Label 6546: @464332
      GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(464461), // Rule ID 11715 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11715,
        GIR_EraseRootFromParent_Done,
      // Label 6547: @464461
      GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(464590), // Rule ID 11697 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11697,
        GIR_EraseRootFromParent_Done,
      // Label 6548: @464590
      GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(464719), // Rule ID 11698 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11698,
        GIR_EraseRootFromParent_Done,
      // Label 6549: @464719
      GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(464848), // Rule ID 11701 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11701,
        GIR_EraseRootFromParent_Done,
      // Label 6550: @464848
      GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(464977), // Rule ID 11702 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11702,
        GIR_EraseRootFromParent_Done,
      // Label 6551: @464977
      GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(465106), // Rule ID 11682 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11682,
        GIR_EraseRootFromParent_Done,
      // Label 6552: @465106
      GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(465235), // Rule ID 11683 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11683,
        GIR_EraseRootFromParent_Done,
      // Label 6553: @465235
      GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(465364), // Rule ID 11686 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11686,
        GIR_EraseRootFromParent_Done,
      // Label 6554: @465364
      GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(465493), // Rule ID 11687 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11687,
        GIR_EraseRootFromParent_Done,
      // Label 6555: @465493
      GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(465622), // Rule ID 7744 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7744,
        GIR_EraseRootFromParent_Done,
      // Label 6556: @465622
      GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(465751), // Rule ID 11696 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11696,
        GIR_EraseRootFromParent_Done,
      // Label 6557: @465751
      GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(465880), // Rule ID 11699 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11699,
        GIR_EraseRootFromParent_Done,
      // Label 6558: @465880
      GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(466009), // Rule ID 11700 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11700,
        GIR_EraseRootFromParent_Done,
      // Label 6559: @466009
      GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(466138), // Rule ID 7743 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7743,
        GIR_EraseRootFromParent_Done,
      // Label 6560: @466138
      GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(466267), // Rule ID 11681 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11681,
        GIR_EraseRootFromParent_Done,
      // Label 6561: @466267
      GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(466396), // Rule ID 11684 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11684,
        GIR_EraseRootFromParent_Done,
      // Label 6562: @466396
      GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(466525), // Rule ID 11685 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11685,
        GIR_EraseRootFromParent_Done,
      // Label 6563: @466525
      GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(466654), // Rule ID 11737 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11737,
        GIR_EraseRootFromParent_Done,
      // Label 6564: @466654
      GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(466783), // Rule ID 11738 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11738,
        GIR_EraseRootFromParent_Done,
      // Label 6565: @466783
      GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(466912), // Rule ID 11739 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11739,
        GIR_EraseRootFromParent_Done,
      // Label 6566: @466912
      GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(467041), // Rule ID 11740 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11740,
        GIR_EraseRootFromParent_Done,
      // Label 6567: @467041
      GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(467170), // Rule ID 11677 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11677,
        GIR_EraseRootFromParent_Done,
      // Label 6568: @467170
      GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(467299), // Rule ID 11678 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11678,
        GIR_EraseRootFromParent_Done,
      // Label 6569: @467299
      GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(467428), // Rule ID 11679 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11679,
        GIR_EraseRootFromParent_Done,
      // Label 6570: @467428
      GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(467557), // Rule ID 11680 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11680,
        GIR_EraseRootFromParent_Done,
      // Label 6571: @467557
      GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(467686), // Rule ID 11722 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11722,
        GIR_EraseRootFromParent_Done,
      // Label 6572: @467686
      GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(467815), // Rule ID 11723 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11723,
        GIR_EraseRootFromParent_Done,
      // Label 6573: @467815
      GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(467944), // Rule ID 11724 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11724,
        GIR_EraseRootFromParent_Done,
      // Label 6574: @467944
      GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(468073), // Rule ID 11725 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11725,
        GIR_EraseRootFromParent_Done,
      // Label 6575: @468073
      GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(468202), // Rule ID 11662 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11662,
        GIR_EraseRootFromParent_Done,
      // Label 6576: @468202
      GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(468331), // Rule ID 11663 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11663,
        GIR_EraseRootFromParent_Done,
      // Label 6577: @468331
      GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(468460), // Rule ID 11664 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11664,
        GIR_EraseRootFromParent_Done,
      // Label 6578: @468460
      GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(468589), // Rule ID 11665 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11665,
        GIR_EraseRootFromParent_Done,
      // Label 6579: @468589
      GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(468718), // Rule ID 11733 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11733,
        GIR_EraseRootFromParent_Done,
      // Label 6580: @468718
      GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(468847), // Rule ID 11734 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11734,
        GIR_EraseRootFromParent_Done,
      // Label 6581: @468847
      GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(468976), // Rule ID 11735 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11735,
        GIR_EraseRootFromParent_Done,
      // Label 6582: @468976
      GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(469105), // Rule ID 11736 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11736,
        GIR_EraseRootFromParent_Done,
      // Label 6583: @469105
      GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(469234), // Rule ID 11673 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11673,
        GIR_EraseRootFromParent_Done,
      // Label 6584: @469234
      GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(469363), // Rule ID 11674 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11674,
        GIR_EraseRootFromParent_Done,
      // Label 6585: @469363
      GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(469492), // Rule ID 11675 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11675,
        GIR_EraseRootFromParent_Done,
      // Label 6586: @469492
      GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(469621), // Rule ID 11676 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11676,
        GIR_EraseRootFromParent_Done,
      // Label 6587: @469621
      GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(469750), // Rule ID 11718 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11718,
        GIR_EraseRootFromParent_Done,
      // Label 6588: @469750
      GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(469879), // Rule ID 11719 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11719,
        GIR_EraseRootFromParent_Done,
      // Label 6589: @469879
      GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(470008), // Rule ID 11720 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11720,
        GIR_EraseRootFromParent_Done,
      // Label 6590: @470008
      GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(470137), // Rule ID 11721 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11721,
        GIR_EraseRootFromParent_Done,
      // Label 6591: @470137
      GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(470266), // Rule ID 11658 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11658,
        GIR_EraseRootFromParent_Done,
      // Label 6592: @470266
      GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(470395), // Rule ID 11659 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11659,
        GIR_EraseRootFromParent_Done,
      // Label 6593: @470395
      GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(470524), // Rule ID 11660 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11660,
        GIR_EraseRootFromParent_Done,
      // Label 6594: @470524
      GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(470653), // Rule ID 11661 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11661,
        GIR_EraseRootFromParent_Done,
      // Label 6595: @470653
      GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(470782), // Rule ID 11667 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11667,
        GIR_EraseRootFromParent_Done,
      // Label 6596: @470782
      GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(470911), // Rule ID 11668 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11668,
        GIR_EraseRootFromParent_Done,
      // Label 6597: @470911
      GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(471040), // Rule ID 11671 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11671,
        GIR_EraseRootFromParent_Done,
      // Label 6598: @471040
      GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(471169), // Rule ID 11672 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11672,
        GIR_EraseRootFromParent_Done,
      // Label 6599: @471169
      GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(471298), // Rule ID 11652 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11652,
        GIR_EraseRootFromParent_Done,
      // Label 6600: @471298
      GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(471427), // Rule ID 11653 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11653,
        GIR_EraseRootFromParent_Done,
      // Label 6601: @471427
      GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(471556), // Rule ID 11656 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11656,
        GIR_EraseRootFromParent_Done,
      // Label 6602: @471556
      GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(471685), // Rule ID 11657 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11657,
        GIR_EraseRootFromParent_Done,
      // Label 6603: @471685
      GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(471814), // Rule ID 7742 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7742,
        GIR_EraseRootFromParent_Done,
      // Label 6604: @471814
      GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(471943), // Rule ID 11666 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11666,
        GIR_EraseRootFromParent_Done,
      // Label 6605: @471943
      GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(472072), // Rule ID 11669 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11669,
        GIR_EraseRootFromParent_Done,
      // Label 6606: @472072
      GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(472201), // Rule ID 11670 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11670,
        GIR_EraseRootFromParent_Done,
      // Label 6607: @472201
      GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(472330), // Rule ID 7741 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7741,
        GIR_EraseRootFromParent_Done,
      // Label 6608: @472330
      GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(472459), // Rule ID 11651 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11651,
        GIR_EraseRootFromParent_Done,
      // Label 6609: @472459
      GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(472588), // Rule ID 11654 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11654,
        GIR_EraseRootFromParent_Done,
      // Label 6610: @472588
      GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(472717), // Rule ID 11655 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11655,
        GIR_EraseRootFromParent_Done,
      // Label 6611: @472717
      GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(472846), // Rule ID 11637 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11637,
        GIR_EraseRootFromParent_Done,
      // Label 6612: @472846
      GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(472975), // Rule ID 11638 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11638,
        GIR_EraseRootFromParent_Done,
      // Label 6613: @472975
      GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(473104), // Rule ID 11641 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11641,
        GIR_EraseRootFromParent_Done,
      // Label 6614: @473104
      GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(473233), // Rule ID 11642 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11642,
        GIR_EraseRootFromParent_Done,
      // Label 6615: @473233
      GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(473362), // Rule ID 11622 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11622,
        GIR_EraseRootFromParent_Done,
      // Label 6616: @473362
      GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(473491), // Rule ID 11623 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11623,
        GIR_EraseRootFromParent_Done,
      // Label 6617: @473491
      GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(473620), // Rule ID 11626 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11626,
        GIR_EraseRootFromParent_Done,
      // Label 6618: @473620
      GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(473749), // Rule ID 11627 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11627,
        GIR_EraseRootFromParent_Done,
      // Label 6619: @473749
      GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(473878), // Rule ID 7740 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7740,
        GIR_EraseRootFromParent_Done,
      // Label 6620: @473878
      GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(474007), // Rule ID 11636 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11636,
        GIR_EraseRootFromParent_Done,
      // Label 6621: @474007
      GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(474136), // Rule ID 11639 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11639,
        GIR_EraseRootFromParent_Done,
      // Label 6622: @474136
      GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(474265), // Rule ID 11640 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11640,
        GIR_EraseRootFromParent_Done,
      // Label 6623: @474265
      GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(474394), // Rule ID 7739 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7739,
        GIR_EraseRootFromParent_Done,
      // Label 6624: @474394
      GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(474523), // Rule ID 11621 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11621,
        GIR_EraseRootFromParent_Done,
      // Label 6625: @474523
      GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(474652), // Rule ID 11624 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11624,
        GIR_EraseRootFromParent_Done,
      // Label 6626: @474652
      GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(474781), // Rule ID 11625 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11625,
        GIR_EraseRootFromParent_Done,
      // Label 6627: @474781
      GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(474910), // Rule ID 11707 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11707,
        GIR_EraseRootFromParent_Done,
      // Label 6628: @474910
      GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(475039), // Rule ID 11708 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11708,
        GIR_EraseRootFromParent_Done,
      // Label 6629: @475039
      GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(475168), // Rule ID 11709 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11709,
        GIR_EraseRootFromParent_Done,
      // Label 6630: @475168
      GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(475297), // Rule ID 11710 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11710,
        GIR_EraseRootFromParent_Done,
      // Label 6631: @475297
      GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(475426), // Rule ID 11647 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11647,
        GIR_EraseRootFromParent_Done,
      // Label 6632: @475426
      GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(475555), // Rule ID 11648 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11648,
        GIR_EraseRootFromParent_Done,
      // Label 6633: @475555
      GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(475684), // Rule ID 11649 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11649,
        GIR_EraseRootFromParent_Done,
      // Label 6634: @475684
      GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(475813), // Rule ID 11650 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11650,
        GIR_EraseRootFromParent_Done,
      // Label 6635: @475813
      GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(475942), // Rule ID 11692 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11692,
        GIR_EraseRootFromParent_Done,
      // Label 6636: @475942
      GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(476071), // Rule ID 11693 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11693,
        GIR_EraseRootFromParent_Done,
      // Label 6637: @476071
      GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(476200), // Rule ID 11694 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11694,
        GIR_EraseRootFromParent_Done,
      // Label 6638: @476200
      GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(476329), // Rule ID 11695 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11695,
        GIR_EraseRootFromParent_Done,
      // Label 6639: @476329
      GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(476458), // Rule ID 11632 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11632,
        GIR_EraseRootFromParent_Done,
      // Label 6640: @476458
      GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(476587), // Rule ID 11633 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11633,
        GIR_EraseRootFromParent_Done,
      // Label 6641: @476587
      GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(476716), // Rule ID 11634 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11634,
        GIR_EraseRootFromParent_Done,
      // Label 6642: @476716
      GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(476845), // Rule ID 11635 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11635,
        GIR_EraseRootFromParent_Done,
      // Label 6643: @476845
      GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(476974), // Rule ID 11703 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11703,
        GIR_EraseRootFromParent_Done,
      // Label 6644: @476974
      GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(477103), // Rule ID 11704 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11704,
        GIR_EraseRootFromParent_Done,
      // Label 6645: @477103
      GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(477232), // Rule ID 11705 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11705,
        GIR_EraseRootFromParent_Done,
      // Label 6646: @477232
      GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(477361), // Rule ID 11706 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11706,
        GIR_EraseRootFromParent_Done,
      // Label 6647: @477361
      GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(477490), // Rule ID 11643 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11643,
        GIR_EraseRootFromParent_Done,
      // Label 6648: @477490
      GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(477619), // Rule ID 11644 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11644,
        GIR_EraseRootFromParent_Done,
      // Label 6649: @477619
      GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(477748), // Rule ID 11645 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11645,
        GIR_EraseRootFromParent_Done,
      // Label 6650: @477748
      GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(477877), // Rule ID 11646 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11646,
        GIR_EraseRootFromParent_Done,
      // Label 6651: @477877
      GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(478006), // Rule ID 11688 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11688,
        GIR_EraseRootFromParent_Done,
      // Label 6652: @478006
      GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(478135), // Rule ID 11689 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11689,
        GIR_EraseRootFromParent_Done,
      // Label 6653: @478135
      GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(478264), // Rule ID 11690 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11690,
        GIR_EraseRootFromParent_Done,
      // Label 6654: @478264
      GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(478393), // Rule ID 11691 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11691,
        GIR_EraseRootFromParent_Done,
      // Label 6655: @478393
      GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(478522), // Rule ID 11628 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11628,
        GIR_EraseRootFromParent_Done,
      // Label 6656: @478522
      GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(478651), // Rule ID 11629 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11629,
        GIR_EraseRootFromParent_Done,
      // Label 6657: @478651
      GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(478780), // Rule ID 11630 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11630,
        GIR_EraseRootFromParent_Done,
      // Label 6658: @478780
      GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(478909), // Rule ID 11631 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fminnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fminnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11631,
        GIR_EraseRootFromParent_Done,
      // Label 6659: @478909
      GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(479021), // Rule ID 12876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12876,
        GIR_EraseRootFromParent_Done,
      // Label 6660: @479021
      GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(479133), // Rule ID 12875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12875,
        GIR_EraseRootFromParent_Done,
      // Label 6661: @479133
      GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(479245), // Rule ID 7846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7846,
        GIR_EraseRootFromParent_Done,
      // Label 6662: @479245
      GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(479357), // Rule ID 7845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7845,
        GIR_EraseRootFromParent_Done,
      // Label 6663: @479357
      GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(479453), // Rule ID 12860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12860,
        GIR_EraseRootFromParent_Done,
      // Label 6664: @479453
      GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(479549), // Rule ID 12859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>)  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12859,
        GIR_EraseRootFromParent_Done,
      // Label 6665: @479549
      GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(479645), // Rule ID 7830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7830,
        GIR_EraseRootFromParent_Done,
      // Label 6666: @479645
      GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(479741), // Rule ID 7829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaxnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MAXMIN_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7829,
        GIR_EraseRootFromParent_Done,
      // Label 6667: @479741
      GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(479776), // Rule ID 90 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13403),
        // (fminnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13403>>  =>  (S_MIN_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 90,
        GIR_Done,
      // Label 6668: @479776
      GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(479836), // Rule ID 801 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 801,
        GIR_EraseRootFromParent_Done,
      // Label 6669: @479836
      GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(479896), // Rule ID 8514 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8514,
        GIR_EraseRootFromParent_Done,
      // Label 6670: @479896
      GIM_Reject,
    // Label 6531: @479897
    GIM_Reject,
    // Label 6257: @479898
    GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(480150),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(479972), // Rule ID 916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 916,
        GIR_EraseRootFromParent_Done,
      // Label 6672: @479972
      GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(480031), // Rule ID 935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 935,
        GIR_EraseRootFromParent_Done,
      // Label 6673: @480031
      GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(480090), // Rule ID 8540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8540,
        GIR_EraseRootFromParent_Done,
      // Label 6674: @480090
      GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(480149), // Rule ID 8554 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MIN_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8554,
        GIR_EraseRootFromParent_Done,
      // Label 6675: @480149
      GIM_Reject,
    // Label 6671: @480150
    GIM_Reject,
    // Label 6258: @480151
    GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(480222), // Rule ID 1093 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fminnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1093,
      GIR_EraseRootFromParent_Done,
    // Label 6676: @480222
    GIM_Reject,
    // Label 6259: @480223
    GIM_Reject,
    // Label 83: @480224
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 6681*/ GIMT_Encode4(533842),
    /*GILLT_s16*//*Label 6677*/ GIMT_Encode4(480251),
    /*GILLT_s32*//*Label 6678*/ GIMT_Encode4(516005),
    /*GILLT_s64*//*Label 6679*/ GIMT_Encode4(533517),
    /*GILLT_v2s16*//*Label 6680*/ GIMT_Encode4(533770),
    // Label 6677: @480251
    GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(516004),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(480397), // Rule ID 11997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11997,
        GIR_EraseRootFromParent_Done,
      // Label 6683: @480397
      GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(480532), // Rule ID 11998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11998,
        GIR_EraseRootFromParent_Done,
      // Label 6684: @480532
      GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(480667), // Rule ID 12001 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12001,
        GIR_EraseRootFromParent_Done,
      // Label 6685: @480667
      GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(480802), // Rule ID 12002 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12002,
        GIR_EraseRootFromParent_Done,
      // Label 6686: @480802
      GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(480937), // Rule ID 12477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12477,
        GIR_EraseRootFromParent_Done,
      // Label 6687: @480937
      GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(481072), // Rule ID 12478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12478,
        GIR_EraseRootFromParent_Done,
      // Label 6688: @481072
      GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(481207), // Rule ID 12481 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12481,
        GIR_EraseRootFromParent_Done,
      // Label 6689: @481207
      GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(481342), // Rule ID 12482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12482,
        GIR_EraseRootFromParent_Done,
      // Label 6690: @481342
      GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(481477), // Rule ID 11982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11982,
        GIR_EraseRootFromParent_Done,
      // Label 6691: @481477
      GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(481612), // Rule ID 11983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11983,
        GIR_EraseRootFromParent_Done,
      // Label 6692: @481612
      GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(481747), // Rule ID 11986 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11986,
        GIR_EraseRootFromParent_Done,
      // Label 6693: @481747
      GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(481882), // Rule ID 11987 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11987,
        GIR_EraseRootFromParent_Done,
      // Label 6694: @481882
      GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(482017), // Rule ID 12462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12462,
        GIR_EraseRootFromParent_Done,
      // Label 6695: @482017
      GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(482152), // Rule ID 12463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12463,
        GIR_EraseRootFromParent_Done,
      // Label 6696: @482152
      GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(482287), // Rule ID 12466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12466,
        GIR_EraseRootFromParent_Done,
      // Label 6697: @482287
      GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(482422), // Rule ID 12467 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12467,
        GIR_EraseRootFromParent_Done,
      // Label 6698: @482422
      GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(482557), // Rule ID 7764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7764,
        GIR_EraseRootFromParent_Done,
      // Label 6699: @482557
      GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(482692), // Rule ID 7796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7796,
        GIR_EraseRootFromParent_Done,
      // Label 6700: @482692
      GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(482827), // Rule ID 11996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11996,
        GIR_EraseRootFromParent_Done,
      // Label 6701: @482827
      GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(482962), // Rule ID 11999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11999,
        GIR_EraseRootFromParent_Done,
      // Label 6702: @482962
      GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(483097), // Rule ID 12000 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12000,
        GIR_EraseRootFromParent_Done,
      // Label 6703: @483097
      GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(483232), // Rule ID 12476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12476,
        GIR_EraseRootFromParent_Done,
      // Label 6704: @483232
      GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(483367), // Rule ID 12479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12479,
        GIR_EraseRootFromParent_Done,
      // Label 6705: @483367
      GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(483502), // Rule ID 12480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12480,
        GIR_EraseRootFromParent_Done,
      // Label 6706: @483502
      GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(483637), // Rule ID 7763 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7763,
        GIR_EraseRootFromParent_Done,
      // Label 6707: @483637
      GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(483772), // Rule ID 7795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7795,
        GIR_EraseRootFromParent_Done,
      // Label 6708: @483772
      GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(483907), // Rule ID 11981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11981,
        GIR_EraseRootFromParent_Done,
      // Label 6709: @483907
      GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(484042), // Rule ID 11984 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11984,
        GIR_EraseRootFromParent_Done,
      // Label 6710: @484042
      GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(484177), // Rule ID 11985 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11985,
        GIR_EraseRootFromParent_Done,
      // Label 6711: @484177
      GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(484312), // Rule ID 12461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12461,
        GIR_EraseRootFromParent_Done,
      // Label 6712: @484312
      GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(484447), // Rule ID 12464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12464,
        GIR_EraseRootFromParent_Done,
      // Label 6713: @484447
      GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(484582), // Rule ID 12465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12465,
        GIR_EraseRootFromParent_Done,
      // Label 6714: @484582
      GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(484717), // Rule ID 11967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11967,
        GIR_EraseRootFromParent_Done,
      // Label 6715: @484717
      GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(484852), // Rule ID 11968 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11968,
        GIR_EraseRootFromParent_Done,
      // Label 6716: @484852
      GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(484987), // Rule ID 11971 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11971,
        GIR_EraseRootFromParent_Done,
      // Label 6717: @484987
      GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(485122), // Rule ID 11972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11972,
        GIR_EraseRootFromParent_Done,
      // Label 6718: @485122
      GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(485257), // Rule ID 12447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12447,
        GIR_EraseRootFromParent_Done,
      // Label 6719: @485257
      GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(485392), // Rule ID 12448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12448,
        GIR_EraseRootFromParent_Done,
      // Label 6720: @485392
      GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(485527), // Rule ID 12451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12451,
        GIR_EraseRootFromParent_Done,
      // Label 6721: @485527
      GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(485662), // Rule ID 12452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12452,
        GIR_EraseRootFromParent_Done,
      // Label 6722: @485662
      GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(485797), // Rule ID 11952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11952,
        GIR_EraseRootFromParent_Done,
      // Label 6723: @485797
      GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(485932), // Rule ID 11953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11953,
        GIR_EraseRootFromParent_Done,
      // Label 6724: @485932
      GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(486067), // Rule ID 11956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11956,
        GIR_EraseRootFromParent_Done,
      // Label 6725: @486067
      GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(486202), // Rule ID 11957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11957,
        GIR_EraseRootFromParent_Done,
      // Label 6726: @486202
      GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(486337), // Rule ID 12432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12432,
        GIR_EraseRootFromParent_Done,
      // Label 6727: @486337
      GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(486472), // Rule ID 12433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12433,
        GIR_EraseRootFromParent_Done,
      // Label 6728: @486472
      GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(486607), // Rule ID 12436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12436,
        GIR_EraseRootFromParent_Done,
      // Label 6729: @486607
      GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(486742), // Rule ID 12437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12437,
        GIR_EraseRootFromParent_Done,
      // Label 6730: @486742
      GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(486877), // Rule ID 7762 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7762,
        GIR_EraseRootFromParent_Done,
      // Label 6731: @486877
      GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(487012), // Rule ID 7794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7794,
        GIR_EraseRootFromParent_Done,
      // Label 6732: @487012
      GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(487147), // Rule ID 11966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11966,
        GIR_EraseRootFromParent_Done,
      // Label 6733: @487147
      GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(487282), // Rule ID 11969 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11969,
        GIR_EraseRootFromParent_Done,
      // Label 6734: @487282
      GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(487417), // Rule ID 11970 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11970,
        GIR_EraseRootFromParent_Done,
      // Label 6735: @487417
      GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(487552), // Rule ID 12446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12446,
        GIR_EraseRootFromParent_Done,
      // Label 6736: @487552
      GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(487687), // Rule ID 12449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12449,
        GIR_EraseRootFromParent_Done,
      // Label 6737: @487687
      GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(487822), // Rule ID 12450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12450,
        GIR_EraseRootFromParent_Done,
      // Label 6738: @487822
      GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(487957), // Rule ID 7761 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7761,
        GIR_EraseRootFromParent_Done,
      // Label 6739: @487957
      GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(488092), // Rule ID 7793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7793,
        GIR_EraseRootFromParent_Done,
      // Label 6740: @488092
      GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(488227), // Rule ID 11951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11951,
        GIR_EraseRootFromParent_Done,
      // Label 6741: @488227
      GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(488362), // Rule ID 11954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11954,
        GIR_EraseRootFromParent_Done,
      // Label 6742: @488362
      GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(488497), // Rule ID 11955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11955,
        GIR_EraseRootFromParent_Done,
      // Label 6743: @488497
      GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(488632), // Rule ID 12431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12431,
        GIR_EraseRootFromParent_Done,
      // Label 6744: @488632
      GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(488767), // Rule ID 12434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12434,
        GIR_EraseRootFromParent_Done,
      // Label 6745: @488767
      GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(488902), // Rule ID 12435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12435,
        GIR_EraseRootFromParent_Done,
      // Label 6746: @488902
      GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(489037), // Rule ID 12007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12007,
        GIR_EraseRootFromParent_Done,
      // Label 6747: @489037
      GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(489172), // Rule ID 12008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12008,
        GIR_EraseRootFromParent_Done,
      // Label 6748: @489172
      GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(489307), // Rule ID 12009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12009,
        GIR_EraseRootFromParent_Done,
      // Label 6749: @489307
      GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(489442), // Rule ID 12010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12010,
        GIR_EraseRootFromParent_Done,
      // Label 6750: @489442
      GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(489577), // Rule ID 12487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12487,
        GIR_EraseRootFromParent_Done,
      // Label 6751: @489577
      GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(489712), // Rule ID 12488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12488,
        GIR_EraseRootFromParent_Done,
      // Label 6752: @489712
      GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(489847), // Rule ID 12489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12489,
        GIR_EraseRootFromParent_Done,
      // Label 6753: @489847
      GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(489982), // Rule ID 12490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12490,
        GIR_EraseRootFromParent_Done,
      // Label 6754: @489982
      GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(490117), // Rule ID 11947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11947,
        GIR_EraseRootFromParent_Done,
      // Label 6755: @490117
      GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(490252), // Rule ID 11948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11948,
        GIR_EraseRootFromParent_Done,
      // Label 6756: @490252
      GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(490387), // Rule ID 11949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11949,
        GIR_EraseRootFromParent_Done,
      // Label 6757: @490387
      GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(490522), // Rule ID 11950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11950,
        GIR_EraseRootFromParent_Done,
      // Label 6758: @490522
      GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(490657), // Rule ID 12427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12427,
        GIR_EraseRootFromParent_Done,
      // Label 6759: @490657
      GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(490792), // Rule ID 12428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12428,
        GIR_EraseRootFromParent_Done,
      // Label 6760: @490792
      GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(490927), // Rule ID 12429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12429,
        GIR_EraseRootFromParent_Done,
      // Label 6761: @490927
      GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(491062), // Rule ID 12430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12430,
        GIR_EraseRootFromParent_Done,
      // Label 6762: @491062
      GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(491197), // Rule ID 11992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11992,
        GIR_EraseRootFromParent_Done,
      // Label 6763: @491197
      GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(491332), // Rule ID 11993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11993,
        GIR_EraseRootFromParent_Done,
      // Label 6764: @491332
      GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(491467), // Rule ID 11994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11994,
        GIR_EraseRootFromParent_Done,
      // Label 6765: @491467
      GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(491602), // Rule ID 11995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11995,
        GIR_EraseRootFromParent_Done,
      // Label 6766: @491602
      GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(491737), // Rule ID 12472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12472,
        GIR_EraseRootFromParent_Done,
      // Label 6767: @491737
      GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(491872), // Rule ID 12473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12473,
        GIR_EraseRootFromParent_Done,
      // Label 6768: @491872
      GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(492007), // Rule ID 12474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12474,
        GIR_EraseRootFromParent_Done,
      // Label 6769: @492007
      GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(492142), // Rule ID 12475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12475,
        GIR_EraseRootFromParent_Done,
      // Label 6770: @492142
      GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(492277), // Rule ID 11932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11932,
        GIR_EraseRootFromParent_Done,
      // Label 6771: @492277
      GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(492412), // Rule ID 11933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11933,
        GIR_EraseRootFromParent_Done,
      // Label 6772: @492412
      GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(492547), // Rule ID 11934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11934,
        GIR_EraseRootFromParent_Done,
      // Label 6773: @492547
      GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(492682), // Rule ID 11935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11935,
        GIR_EraseRootFromParent_Done,
      // Label 6774: @492682
      GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(492817), // Rule ID 12412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12412,
        GIR_EraseRootFromParent_Done,
      // Label 6775: @492817
      GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(492952), // Rule ID 12413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12413,
        GIR_EraseRootFromParent_Done,
      // Label 6776: @492952
      GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(493087), // Rule ID 12414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12414,
        GIR_EraseRootFromParent_Done,
      // Label 6777: @493087
      GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(493222), // Rule ID 12415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12415,
        GIR_EraseRootFromParent_Done,
      // Label 6778: @493222
      GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(493357), // Rule ID 12003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12003,
        GIR_EraseRootFromParent_Done,
      // Label 6779: @493357
      GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(493492), // Rule ID 12004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12004,
        GIR_EraseRootFromParent_Done,
      // Label 6780: @493492
      GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(493627), // Rule ID 12005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12005,
        GIR_EraseRootFromParent_Done,
      // Label 6781: @493627
      GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(493762), // Rule ID 12006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12006,
        GIR_EraseRootFromParent_Done,
      // Label 6782: @493762
      GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(493897), // Rule ID 12483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12483,
        GIR_EraseRootFromParent_Done,
      // Label 6783: @493897
      GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(494032), // Rule ID 12484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12484,
        GIR_EraseRootFromParent_Done,
      // Label 6784: @494032
      GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(494167), // Rule ID 12485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12485,
        GIR_EraseRootFromParent_Done,
      // Label 6785: @494167
      GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(494302), // Rule ID 12486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12486,
        GIR_EraseRootFromParent_Done,
      // Label 6786: @494302
      GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(494437), // Rule ID 11943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11943,
        GIR_EraseRootFromParent_Done,
      // Label 6787: @494437
      GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(494572), // Rule ID 11944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11944,
        GIR_EraseRootFromParent_Done,
      // Label 6788: @494572
      GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(494707), // Rule ID 11945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11945,
        GIR_EraseRootFromParent_Done,
      // Label 6789: @494707
      GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(494842), // Rule ID 11946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11946,
        GIR_EraseRootFromParent_Done,
      // Label 6790: @494842
      GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(494977), // Rule ID 12423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12423,
        GIR_EraseRootFromParent_Done,
      // Label 6791: @494977
      GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(495112), // Rule ID 12424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12424,
        GIR_EraseRootFromParent_Done,
      // Label 6792: @495112
      GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(495247), // Rule ID 12425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12425,
        GIR_EraseRootFromParent_Done,
      // Label 6793: @495247
      GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(495382), // Rule ID 12426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12426,
        GIR_EraseRootFromParent_Done,
      // Label 6794: @495382
      GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(495517), // Rule ID 11988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11988,
        GIR_EraseRootFromParent_Done,
      // Label 6795: @495517
      GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(495652), // Rule ID 11989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11989,
        GIR_EraseRootFromParent_Done,
      // Label 6796: @495652
      GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(495787), // Rule ID 11990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11990,
        GIR_EraseRootFromParent_Done,
      // Label 6797: @495787
      GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(495922), // Rule ID 11991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11991,
        GIR_EraseRootFromParent_Done,
      // Label 6798: @495922
      GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(496057), // Rule ID 12468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12468,
        GIR_EraseRootFromParent_Done,
      // Label 6799: @496057
      GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(496192), // Rule ID 12469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12469,
        GIR_EraseRootFromParent_Done,
      // Label 6800: @496192
      GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(496327), // Rule ID 12470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12470,
        GIR_EraseRootFromParent_Done,
      // Label 6801: @496327
      GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(496462), // Rule ID 12471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12471,
        GIR_EraseRootFromParent_Done,
      // Label 6802: @496462
      GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(496597), // Rule ID 11928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11928,
        GIR_EraseRootFromParent_Done,
      // Label 6803: @496597
      GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(496732), // Rule ID 11929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11929,
        GIR_EraseRootFromParent_Done,
      // Label 6804: @496732
      GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(496867), // Rule ID 11930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11930,
        GIR_EraseRootFromParent_Done,
      // Label 6805: @496867
      GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(497002), // Rule ID 11931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11931,
        GIR_EraseRootFromParent_Done,
      // Label 6806: @497002
      GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(497137), // Rule ID 12408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12408,
        GIR_EraseRootFromParent_Done,
      // Label 6807: @497137
      GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(497272), // Rule ID 12409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12409,
        GIR_EraseRootFromParent_Done,
      // Label 6808: @497272
      GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(497407), // Rule ID 12410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12410,
        GIR_EraseRootFromParent_Done,
      // Label 6809: @497407
      GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(497542), // Rule ID 12411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12411,
        GIR_EraseRootFromParent_Done,
      // Label 6810: @497542
      GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(497677), // Rule ID 11937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11937,
        GIR_EraseRootFromParent_Done,
      // Label 6811: @497677
      GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(497812), // Rule ID 11938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11938,
        GIR_EraseRootFromParent_Done,
      // Label 6812: @497812
      GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(497947), // Rule ID 11941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11941,
        GIR_EraseRootFromParent_Done,
      // Label 6813: @497947
      GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(498082), // Rule ID 11942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11942,
        GIR_EraseRootFromParent_Done,
      // Label 6814: @498082
      GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(498217), // Rule ID 12417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12417,
        GIR_EraseRootFromParent_Done,
      // Label 6815: @498217
      GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(498352), // Rule ID 12418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12418,
        GIR_EraseRootFromParent_Done,
      // Label 6816: @498352
      GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(498487), // Rule ID 12421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12421,
        GIR_EraseRootFromParent_Done,
      // Label 6817: @498487
      GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(498622), // Rule ID 12422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12422,
        GIR_EraseRootFromParent_Done,
      // Label 6818: @498622
      GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(498757), // Rule ID 11922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11922,
        GIR_EraseRootFromParent_Done,
      // Label 6819: @498757
      GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(498892), // Rule ID 11923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11923,
        GIR_EraseRootFromParent_Done,
      // Label 6820: @498892
      GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(499027), // Rule ID 11926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11926,
        GIR_EraseRootFromParent_Done,
      // Label 6821: @499027
      GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(499162), // Rule ID 11927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11927,
        GIR_EraseRootFromParent_Done,
      // Label 6822: @499162
      GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(499297), // Rule ID 12402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12402,
        GIR_EraseRootFromParent_Done,
      // Label 6823: @499297
      GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(499432), // Rule ID 12403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12403,
        GIR_EraseRootFromParent_Done,
      // Label 6824: @499432
      GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(499567), // Rule ID 12406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12406,
        GIR_EraseRootFromParent_Done,
      // Label 6825: @499567
      GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(499702), // Rule ID 12407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12407,
        GIR_EraseRootFromParent_Done,
      // Label 6826: @499702
      GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(499837), // Rule ID 7760 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7760,
        GIR_EraseRootFromParent_Done,
      // Label 6827: @499837
      GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(499972), // Rule ID 7792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7792,
        GIR_EraseRootFromParent_Done,
      // Label 6828: @499972
      GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(500107), // Rule ID 11936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11936,
        GIR_EraseRootFromParent_Done,
      // Label 6829: @500107
      GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(500242), // Rule ID 11939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11939,
        GIR_EraseRootFromParent_Done,
      // Label 6830: @500242
      GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(500377), // Rule ID 11940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11940,
        GIR_EraseRootFromParent_Done,
      // Label 6831: @500377
      GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(500512), // Rule ID 12416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12416,
        GIR_EraseRootFromParent_Done,
      // Label 6832: @500512
      GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(500647), // Rule ID 12419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12419,
        GIR_EraseRootFromParent_Done,
      // Label 6833: @500647
      GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(500782), // Rule ID 12420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12420,
        GIR_EraseRootFromParent_Done,
      // Label 6834: @500782
      GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(500917), // Rule ID 7759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7759,
        GIR_EraseRootFromParent_Done,
      // Label 6835: @500917
      GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(501052), // Rule ID 7791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7791,
        GIR_EraseRootFromParent_Done,
      // Label 6836: @501052
      GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(501187), // Rule ID 11921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11921,
        GIR_EraseRootFromParent_Done,
      // Label 6837: @501187
      GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(501322), // Rule ID 11924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11924,
        GIR_EraseRootFromParent_Done,
      // Label 6838: @501322
      GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(501457), // Rule ID 11925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11925,
        GIR_EraseRootFromParent_Done,
      // Label 6839: @501457
      GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(501592), // Rule ID 12401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12401,
        GIR_EraseRootFromParent_Done,
      // Label 6840: @501592
      GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(501727), // Rule ID 12404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12404,
        GIR_EraseRootFromParent_Done,
      // Label 6841: @501727
      GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(501862), // Rule ID 12405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12405,
        GIR_EraseRootFromParent_Done,
      // Label 6842: @501862
      GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(501997), // Rule ID 11907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11907,
        GIR_EraseRootFromParent_Done,
      // Label 6843: @501997
      GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(502132), // Rule ID 11908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11908,
        GIR_EraseRootFromParent_Done,
      // Label 6844: @502132
      GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(502267), // Rule ID 11911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11911,
        GIR_EraseRootFromParent_Done,
      // Label 6845: @502267
      GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(502402), // Rule ID 11912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11912,
        GIR_EraseRootFromParent_Done,
      // Label 6846: @502402
      GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(502537), // Rule ID 12387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12387,
        GIR_EraseRootFromParent_Done,
      // Label 6847: @502537
      GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(502672), // Rule ID 12388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12388,
        GIR_EraseRootFromParent_Done,
      // Label 6848: @502672
      GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(502807), // Rule ID 12391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12391,
        GIR_EraseRootFromParent_Done,
      // Label 6849: @502807
      GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(502942), // Rule ID 12392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12392,
        GIR_EraseRootFromParent_Done,
      // Label 6850: @502942
      GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(503077), // Rule ID 11892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11892,
        GIR_EraseRootFromParent_Done,
      // Label 6851: @503077
      GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(503212), // Rule ID 11893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11893,
        GIR_EraseRootFromParent_Done,
      // Label 6852: @503212
      GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(503347), // Rule ID 11896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11896,
        GIR_EraseRootFromParent_Done,
      // Label 6853: @503347
      GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(503482), // Rule ID 11897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11897,
        GIR_EraseRootFromParent_Done,
      // Label 6854: @503482
      GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(503617), // Rule ID 12372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12372,
        GIR_EraseRootFromParent_Done,
      // Label 6855: @503617
      GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(503752), // Rule ID 12373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12373,
        GIR_EraseRootFromParent_Done,
      // Label 6856: @503752
      GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(503887), // Rule ID 12376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12376,
        GIR_EraseRootFromParent_Done,
      // Label 6857: @503887
      GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(504022), // Rule ID 12377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12377,
        GIR_EraseRootFromParent_Done,
      // Label 6858: @504022
      GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(504157), // Rule ID 7758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7758,
        GIR_EraseRootFromParent_Done,
      // Label 6859: @504157
      GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(504292), // Rule ID 7790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7790,
        GIR_EraseRootFromParent_Done,
      // Label 6860: @504292
      GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(504427), // Rule ID 11906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11906,
        GIR_EraseRootFromParent_Done,
      // Label 6861: @504427
      GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(504562), // Rule ID 11909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11909,
        GIR_EraseRootFromParent_Done,
      // Label 6862: @504562
      GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(504697), // Rule ID 11910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11910,
        GIR_EraseRootFromParent_Done,
      // Label 6863: @504697
      GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(504832), // Rule ID 12386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12386,
        GIR_EraseRootFromParent_Done,
      // Label 6864: @504832
      GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(504967), // Rule ID 12389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12389,
        GIR_EraseRootFromParent_Done,
      // Label 6865: @504967
      GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(505102), // Rule ID 12390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12390,
        GIR_EraseRootFromParent_Done,
      // Label 6866: @505102
      GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(505237), // Rule ID 7757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7757,
        GIR_EraseRootFromParent_Done,
      // Label 6867: @505237
      GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(505372), // Rule ID 7789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7789,
        GIR_EraseRootFromParent_Done,
      // Label 6868: @505372
      GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(505507), // Rule ID 11891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11891,
        GIR_EraseRootFromParent_Done,
      // Label 6869: @505507
      GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(505642), // Rule ID 11894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11894,
        GIR_EraseRootFromParent_Done,
      // Label 6870: @505642
      GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(505777), // Rule ID 11895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11895,
        GIR_EraseRootFromParent_Done,
      // Label 6871: @505777
      GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(505912), // Rule ID 12371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12371,
        GIR_EraseRootFromParent_Done,
      // Label 6872: @505912
      GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(506047), // Rule ID 12374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12374,
        GIR_EraseRootFromParent_Done,
      // Label 6873: @506047
      GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(506182), // Rule ID 12375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12375,
        GIR_EraseRootFromParent_Done,
      // Label 6874: @506182
      GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(506317), // Rule ID 11977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11977,
        GIR_EraseRootFromParent_Done,
      // Label 6875: @506317
      GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(506452), // Rule ID 11978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11978,
        GIR_EraseRootFromParent_Done,
      // Label 6876: @506452
      GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(506587), // Rule ID 11979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11979,
        GIR_EraseRootFromParent_Done,
      // Label 6877: @506587
      GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(506722), // Rule ID 11980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11980,
        GIR_EraseRootFromParent_Done,
      // Label 6878: @506722
      GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(506857), // Rule ID 12457 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12457,
        GIR_EraseRootFromParent_Done,
      // Label 6879: @506857
      GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(506992), // Rule ID 12458 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12458,
        GIR_EraseRootFromParent_Done,
      // Label 6880: @506992
      GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(507127), // Rule ID 12459 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12459,
        GIR_EraseRootFromParent_Done,
      // Label 6881: @507127
      GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(507262), // Rule ID 12460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12460,
        GIR_EraseRootFromParent_Done,
      // Label 6882: @507262
      GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(507397), // Rule ID 11917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11917,
        GIR_EraseRootFromParent_Done,
      // Label 6883: @507397
      GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(507532), // Rule ID 11918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11918,
        GIR_EraseRootFromParent_Done,
      // Label 6884: @507532
      GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(507667), // Rule ID 11919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11919,
        GIR_EraseRootFromParent_Done,
      // Label 6885: @507667
      GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(507802), // Rule ID 11920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11920,
        GIR_EraseRootFromParent_Done,
      // Label 6886: @507802
      GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(507937), // Rule ID 12397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12397,
        GIR_EraseRootFromParent_Done,
      // Label 6887: @507937
      GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(508072), // Rule ID 12398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12398,
        GIR_EraseRootFromParent_Done,
      // Label 6888: @508072
      GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(508207), // Rule ID 12399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12399,
        GIR_EraseRootFromParent_Done,
      // Label 6889: @508207
      GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(508342), // Rule ID 12400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12400,
        GIR_EraseRootFromParent_Done,
      // Label 6890: @508342
      GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(508477), // Rule ID 11962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11962,
        GIR_EraseRootFromParent_Done,
      // Label 6891: @508477
      GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(508612), // Rule ID 11963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11963,
        GIR_EraseRootFromParent_Done,
      // Label 6892: @508612
      GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(508747), // Rule ID 11964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11964,
        GIR_EraseRootFromParent_Done,
      // Label 6893: @508747
      GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(508882), // Rule ID 11965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11965,
        GIR_EraseRootFromParent_Done,
      // Label 6894: @508882
      GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(509017), // Rule ID 12442 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12442,
        GIR_EraseRootFromParent_Done,
      // Label 6895: @509017
      GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(509152), // Rule ID 12443 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12443,
        GIR_EraseRootFromParent_Done,
      // Label 6896: @509152
      GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(509287), // Rule ID 12444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12444,
        GIR_EraseRootFromParent_Done,
      // Label 6897: @509287
      GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(509422), // Rule ID 12445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12445,
        GIR_EraseRootFromParent_Done,
      // Label 6898: @509422
      GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(509557), // Rule ID 11902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11902,
        GIR_EraseRootFromParent_Done,
      // Label 6899: @509557
      GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(509692), // Rule ID 11903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11903,
        GIR_EraseRootFromParent_Done,
      // Label 6900: @509692
      GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(509827), // Rule ID 11904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11904,
        GIR_EraseRootFromParent_Done,
      // Label 6901: @509827
      GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(509962), // Rule ID 11905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11905,
        GIR_EraseRootFromParent_Done,
      // Label 6902: @509962
      GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(510097), // Rule ID 12382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12382,
        GIR_EraseRootFromParent_Done,
      // Label 6903: @510097
      GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(510232), // Rule ID 12383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12383,
        GIR_EraseRootFromParent_Done,
      // Label 6904: @510232
      GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(510367), // Rule ID 12384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12384,
        GIR_EraseRootFromParent_Done,
      // Label 6905: @510367
      GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(510502), // Rule ID 12385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12385,
        GIR_EraseRootFromParent_Done,
      // Label 6906: @510502
      GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(510637), // Rule ID 11973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11973,
        GIR_EraseRootFromParent_Done,
      // Label 6907: @510637
      GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(510772), // Rule ID 11974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11974,
        GIR_EraseRootFromParent_Done,
      // Label 6908: @510772
      GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(510907), // Rule ID 11975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11975,
        GIR_EraseRootFromParent_Done,
      // Label 6909: @510907
      GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(511042), // Rule ID 11976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11976,
        GIR_EraseRootFromParent_Done,
      // Label 6910: @511042
      GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(511177), // Rule ID 12453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12453,
        GIR_EraseRootFromParent_Done,
      // Label 6911: @511177
      GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(511312), // Rule ID 12454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12454,
        GIR_EraseRootFromParent_Done,
      // Label 6912: @511312
      GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(511447), // Rule ID 12455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12455,
        GIR_EraseRootFromParent_Done,
      // Label 6913: @511447
      GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(511582), // Rule ID 12456 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12456,
        GIR_EraseRootFromParent_Done,
      // Label 6914: @511582
      GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(511717), // Rule ID 11913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11913,
        GIR_EraseRootFromParent_Done,
      // Label 6915: @511717
      GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(511852), // Rule ID 11914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11914,
        GIR_EraseRootFromParent_Done,
      // Label 6916: @511852
      GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(511987), // Rule ID 11915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11915,
        GIR_EraseRootFromParent_Done,
      // Label 6917: @511987
      GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(512122), // Rule ID 11916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11916,
        GIR_EraseRootFromParent_Done,
      // Label 6918: @512122
      GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(512257), // Rule ID 12393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12393,
        GIR_EraseRootFromParent_Done,
      // Label 6919: @512257
      GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(512392), // Rule ID 12394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12394,
        GIR_EraseRootFromParent_Done,
      // Label 6920: @512392
      GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(512527), // Rule ID 12395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12395,
        GIR_EraseRootFromParent_Done,
      // Label 6921: @512527
      GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(512662), // Rule ID 12396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12396,
        GIR_EraseRootFromParent_Done,
      // Label 6922: @512662
      GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(512797), // Rule ID 11958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11958,
        GIR_EraseRootFromParent_Done,
      // Label 6923: @512797
      GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(512932), // Rule ID 11959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11959,
        GIR_EraseRootFromParent_Done,
      // Label 6924: @512932
      GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(513067), // Rule ID 11960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11960,
        GIR_EraseRootFromParent_Done,
      // Label 6925: @513067
      GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(513202), // Rule ID 11961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11961,
        GIR_EraseRootFromParent_Done,
      // Label 6926: @513202
      GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(513337), // Rule ID 12438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12438,
        GIR_EraseRootFromParent_Done,
      // Label 6927: @513337
      GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(513472), // Rule ID 12439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12439,
        GIR_EraseRootFromParent_Done,
      // Label 6928: @513472
      GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(513607), // Rule ID 12440 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12440,
        GIR_EraseRootFromParent_Done,
      // Label 6929: @513607
      GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(513742), // Rule ID 12441 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12441,
        GIR_EraseRootFromParent_Done,
      // Label 6930: @513742
      GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(513877), // Rule ID 11898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11898,
        GIR_EraseRootFromParent_Done,
      // Label 6931: @513877
      GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(514012), // Rule ID 11899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11899,
        GIR_EraseRootFromParent_Done,
      // Label 6932: @514012
      GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(514147), // Rule ID 11900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11900,
        GIR_EraseRootFromParent_Done,
      // Label 6933: @514147
      GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(514282), // Rule ID 11901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11901,
        GIR_EraseRootFromParent_Done,
      // Label 6934: @514282
      GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(514417), // Rule ID 12378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12378,
        GIR_EraseRootFromParent_Done,
      // Label 6935: @514417
      GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(514552), // Rule ID 12379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12379,
        GIR_EraseRootFromParent_Done,
      // Label 6936: @514552
      GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(514687), // Rule ID 12380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12380,
        GIR_EraseRootFromParent_Done,
      // Label 6937: @514687
      GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(514822), // Rule ID 12381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMed3_16_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12381,
        GIR_EraseRootFromParent_Done,
      // Label 6938: @514822
      GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(514934), // Rule ID 12880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12880,
        GIR_EraseRootFromParent_Done,
      // Label 6939: @514934
      GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(515046), // Rule ID 12879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12879,
        GIR_EraseRootFromParent_Done,
      // Label 6940: @515046
      GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(515158), // Rule ID 7850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7850,
        GIR_EraseRootFromParent_Done,
      // Label 6941: @515158
      GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(515270), // Rule ID 7849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7849,
        GIR_EraseRootFromParent_Done,
      // Label 6942: @515270
      GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(515366), // Rule ID 12864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12864,
        GIR_EraseRootFromParent_Done,
      // Label 6943: @515366
      GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(515462), // Rule ID 12863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12863,
        GIR_EraseRootFromParent_Done,
      // Label 6944: @515462
      GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(515558), // Rule ID 7834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7834,
        GIR_EraseRootFromParent_Done,
      // Label 6945: @515558
      GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(515654), // Rule ID 7833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (fminnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7833,
        GIR_EraseRootFromParent_Done,
      // Label 6946: @515654
      GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(515689), // Rule ID 102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13404),
        // (fmaxnum_ieee:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13404>>  =>  (S_MAX_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 102,
        GIR_Done,
      // Label 6947: @515689
      GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(515752), // Rule ID 880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 880,
        GIR_EraseRootFromParent_Done,
      // Label 6948: @515752
      GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(515815), // Rule ID 884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 884,
        GIR_EraseRootFromParent_Done,
      // Label 6949: @515815
      GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(515878), // Rule ID 8527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8527,
        GIR_EraseRootFromParent_Done,
      // Label 6950: @515878
      GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(515941), // Rule ID 8529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8529,
        GIR_EraseRootFromParent_Done,
      // Label 6951: @515941
      GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(516003), // Rule ID 882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fmaxnum_ieee:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 882,
        GIR_EraseRootFromParent_Done,
      // Label 6952: @516003
      GIM_Reject,
    // Label 6682: @516004
    GIM_Reject,
    // Label 6678: @516005
    GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(533516),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(516145), // Rule ID 11487 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11487,
        GIR_EraseRootFromParent_Done,
      // Label 6954: @516145
      GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(516274), // Rule ID 11488 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11488,
        GIR_EraseRootFromParent_Done,
      // Label 6955: @516274
      GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(516403), // Rule ID 11491 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11491,
        GIR_EraseRootFromParent_Done,
      // Label 6956: @516403
      GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(516532), // Rule ID 11492 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11492,
        GIR_EraseRootFromParent_Done,
      // Label 6957: @516532
      GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(516661), // Rule ID 11472 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11472,
        GIR_EraseRootFromParent_Done,
      // Label 6958: @516661
      GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(516790), // Rule ID 11473 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11473,
        GIR_EraseRootFromParent_Done,
      // Label 6959: @516790
      GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(516919), // Rule ID 11476 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11476,
        GIR_EraseRootFromParent_Done,
      // Label 6960: @516919
      GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(517048), // Rule ID 11477 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11477,
        GIR_EraseRootFromParent_Done,
      // Label 6961: @517048
      GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(517177), // Rule ID 7730 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7730,
        GIR_EraseRootFromParent_Done,
      // Label 6962: @517177
      GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(517306), // Rule ID 11486 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11486,
        GIR_EraseRootFromParent_Done,
      // Label 6963: @517306
      GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(517435), // Rule ID 11489 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11489,
        GIR_EraseRootFromParent_Done,
      // Label 6964: @517435
      GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(517564), // Rule ID 11490 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11490,
        GIR_EraseRootFromParent_Done,
      // Label 6965: @517564
      GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(517693), // Rule ID 7729 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7729,
        GIR_EraseRootFromParent_Done,
      // Label 6966: @517693
      GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(517822), // Rule ID 11471 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11471,
        GIR_EraseRootFromParent_Done,
      // Label 6967: @517822
      GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(517951), // Rule ID 11474 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11474,
        GIR_EraseRootFromParent_Done,
      // Label 6968: @517951
      GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(518080), // Rule ID 11475 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11475,
        GIR_EraseRootFromParent_Done,
      // Label 6969: @518080
      GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(518209), // Rule ID 11457 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11457,
        GIR_EraseRootFromParent_Done,
      // Label 6970: @518209
      GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(518338), // Rule ID 11458 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11458,
        GIR_EraseRootFromParent_Done,
      // Label 6971: @518338
      GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(518467), // Rule ID 11461 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11461,
        GIR_EraseRootFromParent_Done,
      // Label 6972: @518467
      GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(518596), // Rule ID 11462 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11462,
        GIR_EraseRootFromParent_Done,
      // Label 6973: @518596
      GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(518725), // Rule ID 11442 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11442,
        GIR_EraseRootFromParent_Done,
      // Label 6974: @518725
      GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(518854), // Rule ID 11443 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11443,
        GIR_EraseRootFromParent_Done,
      // Label 6975: @518854
      GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(518983), // Rule ID 11446 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11446,
        GIR_EraseRootFromParent_Done,
      // Label 6976: @518983
      GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(519112), // Rule ID 11447 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11447,
        GIR_EraseRootFromParent_Done,
      // Label 6977: @519112
      GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(519241), // Rule ID 7728 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7728,
        GIR_EraseRootFromParent_Done,
      // Label 6978: @519241
      GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(519370), // Rule ID 11456 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11456,
        GIR_EraseRootFromParent_Done,
      // Label 6979: @519370
      GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(519499), // Rule ID 11459 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11459,
        GIR_EraseRootFromParent_Done,
      // Label 6980: @519499
      GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(519628), // Rule ID 11460 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11460,
        GIR_EraseRootFromParent_Done,
      // Label 6981: @519628
      GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(519757), // Rule ID 7727 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7727,
        GIR_EraseRootFromParent_Done,
      // Label 6982: @519757
      GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(519886), // Rule ID 11441 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11441,
        GIR_EraseRootFromParent_Done,
      // Label 6983: @519886
      GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(520015), // Rule ID 11444 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11444,
        GIR_EraseRootFromParent_Done,
      // Label 6984: @520015
      GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(520144), // Rule ID 11445 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11445,
        GIR_EraseRootFromParent_Done,
      // Label 6985: @520144
      GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(520273), // Rule ID 11497 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11497,
        GIR_EraseRootFromParent_Done,
      // Label 6986: @520273
      GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(520402), // Rule ID 11498 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11498,
        GIR_EraseRootFromParent_Done,
      // Label 6987: @520402
      GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(520531), // Rule ID 11499 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11499,
        GIR_EraseRootFromParent_Done,
      // Label 6988: @520531
      GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(520660), // Rule ID 11500 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11500,
        GIR_EraseRootFromParent_Done,
      // Label 6989: @520660
      GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(520789), // Rule ID 11437 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11437,
        GIR_EraseRootFromParent_Done,
      // Label 6990: @520789
      GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(520918), // Rule ID 11438 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11438,
        GIR_EraseRootFromParent_Done,
      // Label 6991: @520918
      GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(521047), // Rule ID 11439 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11439,
        GIR_EraseRootFromParent_Done,
      // Label 6992: @521047
      GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(521176), // Rule ID 11440 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11440,
        GIR_EraseRootFromParent_Done,
      // Label 6993: @521176
      GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(521305), // Rule ID 11482 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11482,
        GIR_EraseRootFromParent_Done,
      // Label 6994: @521305
      GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(521434), // Rule ID 11483 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11483,
        GIR_EraseRootFromParent_Done,
      // Label 6995: @521434
      GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(521563), // Rule ID 11484 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11484,
        GIR_EraseRootFromParent_Done,
      // Label 6996: @521563
      GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(521692), // Rule ID 11485 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11485,
        GIR_EraseRootFromParent_Done,
      // Label 6997: @521692
      GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(521821), // Rule ID 11422 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11422,
        GIR_EraseRootFromParent_Done,
      // Label 6998: @521821
      GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(521950), // Rule ID 11423 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11423,
        GIR_EraseRootFromParent_Done,
      // Label 6999: @521950
      GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(522079), // Rule ID 11424 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11424,
        GIR_EraseRootFromParent_Done,
      // Label 7000: @522079
      GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(522208), // Rule ID 11425 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11425,
        GIR_EraseRootFromParent_Done,
      // Label 7001: @522208
      GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(522337), // Rule ID 11493 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11493,
        GIR_EraseRootFromParent_Done,
      // Label 7002: @522337
      GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(522466), // Rule ID 11494 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11494,
        GIR_EraseRootFromParent_Done,
      // Label 7003: @522466
      GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(522595), // Rule ID 11495 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11495,
        GIR_EraseRootFromParent_Done,
      // Label 7004: @522595
      GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(522724), // Rule ID 11496 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11496,
        GIR_EraseRootFromParent_Done,
      // Label 7005: @522724
      GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(522853), // Rule ID 11433 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11433,
        GIR_EraseRootFromParent_Done,
      // Label 7006: @522853
      GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(522982), // Rule ID 11434 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11434,
        GIR_EraseRootFromParent_Done,
      // Label 7007: @522982
      GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(523111), // Rule ID 11435 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11435,
        GIR_EraseRootFromParent_Done,
      // Label 7008: @523111
      GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(523240), // Rule ID 11436 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11436,
        GIR_EraseRootFromParent_Done,
      // Label 7009: @523240
      GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(523369), // Rule ID 11478 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11478,
        GIR_EraseRootFromParent_Done,
      // Label 7010: @523369
      GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(523498), // Rule ID 11479 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11479,
        GIR_EraseRootFromParent_Done,
      // Label 7011: @523498
      GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(523627), // Rule ID 11480 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11480,
        GIR_EraseRootFromParent_Done,
      // Label 7012: @523627
      GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(523756), // Rule ID 11481 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11481,
        GIR_EraseRootFromParent_Done,
      // Label 7013: @523756
      GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(523885), // Rule ID 11418 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11418,
        GIR_EraseRootFromParent_Done,
      // Label 7014: @523885
      GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(524014), // Rule ID 11419 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11419,
        GIR_EraseRootFromParent_Done,
      // Label 7015: @524014
      GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(524143), // Rule ID 11420 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11420,
        GIR_EraseRootFromParent_Done,
      // Label 7016: @524143
      GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(524272), // Rule ID 11421 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11421,
        GIR_EraseRootFromParent_Done,
      // Label 7017: @524272
      GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(524401), // Rule ID 11427 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11427,
        GIR_EraseRootFromParent_Done,
      // Label 7018: @524401
      GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(524530), // Rule ID 11428 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11428,
        GIR_EraseRootFromParent_Done,
      // Label 7019: @524530
      GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(524659), // Rule ID 11431 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11431,
        GIR_EraseRootFromParent_Done,
      // Label 7020: @524659
      GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(524788), // Rule ID 11432 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11432,
        GIR_EraseRootFromParent_Done,
      // Label 7021: @524788
      GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(524917), // Rule ID 11412 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11412,
        GIR_EraseRootFromParent_Done,
      // Label 7022: @524917
      GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(525046), // Rule ID 11413 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11413,
        GIR_EraseRootFromParent_Done,
      // Label 7023: @525046
      GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(525175), // Rule ID 11416 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11416,
        GIR_EraseRootFromParent_Done,
      // Label 7024: @525175
      GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(525304), // Rule ID 11417 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11417,
        GIR_EraseRootFromParent_Done,
      // Label 7025: @525304
      GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(525433), // Rule ID 7726 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7726,
        GIR_EraseRootFromParent_Done,
      // Label 7026: @525433
      GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(525562), // Rule ID 11426 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11426,
        GIR_EraseRootFromParent_Done,
      // Label 7027: @525562
      GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(525691), // Rule ID 11429 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11429,
        GIR_EraseRootFromParent_Done,
      // Label 7028: @525691
      GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(525820), // Rule ID 11430 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11430,
        GIR_EraseRootFromParent_Done,
      // Label 7029: @525820
      GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(525949), // Rule ID 7725 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7725,
        GIR_EraseRootFromParent_Done,
      // Label 7030: @525949
      GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(526078), // Rule ID 11411 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11411,
        GIR_EraseRootFromParent_Done,
      // Label 7031: @526078
      GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(526207), // Rule ID 11414 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11414,
        GIR_EraseRootFromParent_Done,
      // Label 7032: @526207
      GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(526336), // Rule ID 11415 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11415,
        GIR_EraseRootFromParent_Done,
      // Label 7033: @526336
      GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(526465), // Rule ID 11397 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11397,
        GIR_EraseRootFromParent_Done,
      // Label 7034: @526465
      GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(526594), // Rule ID 11398 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11398,
        GIR_EraseRootFromParent_Done,
      // Label 7035: @526594
      GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(526723), // Rule ID 11401 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11401,
        GIR_EraseRootFromParent_Done,
      // Label 7036: @526723
      GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(526852), // Rule ID 11402 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11402,
        GIR_EraseRootFromParent_Done,
      // Label 7037: @526852
      GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(526981), // Rule ID 11382 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11382,
        GIR_EraseRootFromParent_Done,
      // Label 7038: @526981
      GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(527110), // Rule ID 11383 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11383,
        GIR_EraseRootFromParent_Done,
      // Label 7039: @527110
      GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(527239), // Rule ID 11386 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11386,
        GIR_EraseRootFromParent_Done,
      // Label 7040: @527239
      GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(527368), // Rule ID 11387 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11387,
        GIR_EraseRootFromParent_Done,
      // Label 7041: @527368
      GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(527497), // Rule ID 7724 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7724,
        GIR_EraseRootFromParent_Done,
      // Label 7042: @527497
      GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(527626), // Rule ID 11396 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11396,
        GIR_EraseRootFromParent_Done,
      // Label 7043: @527626
      GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(527755), // Rule ID 11399 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11399,
        GIR_EraseRootFromParent_Done,
      // Label 7044: @527755
      GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(527884), // Rule ID 11400 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11400,
        GIR_EraseRootFromParent_Done,
      // Label 7045: @527884
      GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(528013), // Rule ID 7723 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7723,
        GIR_EraseRootFromParent_Done,
      // Label 7046: @528013
      GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(528142), // Rule ID 11381 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11381,
        GIR_EraseRootFromParent_Done,
      // Label 7047: @528142
      GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(528271), // Rule ID 11384 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11384,
        GIR_EraseRootFromParent_Done,
      // Label 7048: @528271
      GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(528400), // Rule ID 11385 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11385,
        GIR_EraseRootFromParent_Done,
      // Label 7049: @528400
      GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(528529), // Rule ID 11467 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11467,
        GIR_EraseRootFromParent_Done,
      // Label 7050: @528529
      GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(528658), // Rule ID 11468 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11468,
        GIR_EraseRootFromParent_Done,
      // Label 7051: @528658
      GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(528787), // Rule ID 11469 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11469,
        GIR_EraseRootFromParent_Done,
      // Label 7052: @528787
      GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(528916), // Rule ID 11470 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11470,
        GIR_EraseRootFromParent_Done,
      // Label 7053: @528916
      GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(529045), // Rule ID 11407 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11407,
        GIR_EraseRootFromParent_Done,
      // Label 7054: @529045
      GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(529174), // Rule ID 11408 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11408,
        GIR_EraseRootFromParent_Done,
      // Label 7055: @529174
      GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(529303), // Rule ID 11409 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11409,
        GIR_EraseRootFromParent_Done,
      // Label 7056: @529303
      GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(529432), // Rule ID 11410 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11410,
        GIR_EraseRootFromParent_Done,
      // Label 7057: @529432
      GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(529561), // Rule ID 11452 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11452,
        GIR_EraseRootFromParent_Done,
      // Label 7058: @529561
      GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(529690), // Rule ID 11453 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11453,
        GIR_EraseRootFromParent_Done,
      // Label 7059: @529690
      GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(529819), // Rule ID 11454 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11454,
        GIR_EraseRootFromParent_Done,
      // Label 7060: @529819
      GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(529948), // Rule ID 11455 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11455,
        GIR_EraseRootFromParent_Done,
      // Label 7061: @529948
      GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(530077), // Rule ID 11392 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11392,
        GIR_EraseRootFromParent_Done,
      // Label 7062: @530077
      GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(530206), // Rule ID 11393 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11393,
        GIR_EraseRootFromParent_Done,
      // Label 7063: @530206
      GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(530335), // Rule ID 11394 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11394,
        GIR_EraseRootFromParent_Done,
      // Label 7064: @530335
      GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(530464), // Rule ID 11395 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods))), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11395,
        GIR_EraseRootFromParent_Done,
      // Label 7065: @530464
      GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(530593), // Rule ID 11463 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11463,
        GIR_EraseRootFromParent_Done,
      // Label 7066: @530593
      GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(530722), // Rule ID 11464 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11464,
        GIR_EraseRootFromParent_Done,
      // Label 7067: @530722
      GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(530851), // Rule ID 11465 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11465,
        GIR_EraseRootFromParent_Done,
      // Label 7068: @530851
      GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(530980), // Rule ID 11466 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11466,
        GIR_EraseRootFromParent_Done,
      // Label 7069: @530980
      GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(531109), // Rule ID 11403 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11403,
        GIR_EraseRootFromParent_Done,
      // Label 7070: @531109
      GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(531238), // Rule ID 11404 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11404,
        GIR_EraseRootFromParent_Done,
      // Label 7071: @531238
      GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(531367), // Rule ID 11405 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11405,
        GIR_EraseRootFromParent_Done,
      // Label 7072: @531367
      GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(531496), // Rule ID 11406 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11406,
        GIR_EraseRootFromParent_Done,
      // Label 7073: @531496
      GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(531625), // Rule ID 11448 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11448,
        GIR_EraseRootFromParent_Done,
      // Label 7074: @531625
      GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(531754), // Rule ID 11449 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11449,
        GIR_EraseRootFromParent_Done,
      // Label 7075: @531754
      GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(531883), // Rule ID 11450 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11450,
        GIR_EraseRootFromParent_Done,
      // Label 7076: @531883
      GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(532012), // Rule ID 11451 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11451,
        GIR_EraseRootFromParent_Done,
      // Label 7077: @532012
      GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(532141), // Rule ID 11388 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11388,
        GIR_EraseRootFromParent_Done,
      // Label 7078: @532141
      GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(532270), // Rule ID 11389 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11389,
        GIR_EraseRootFromParent_Done,
      // Label 7079: @532270
      GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(532399), // Rule ID 11390 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11390,
        GIR_EraseRootFromParent_Done,
      // Label 7080: @532399
      GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(532528), // Rule ID 11391 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        // MIs[3] VOP3Mods:src1:src1_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] VOP3Mods:src0:src0_mods
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_fmaxnum_like_nnan),
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods)), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods)))<<P:Predicate_fmaxnum_like_nnan>>  =>  (V_MED3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11391,
        GIR_EraseRootFromParent_Done,
      // Label 7081: @532528
      GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(532640), // Rule ID 12872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12872,
        GIR_EraseRootFromParent_Done,
      // Label 7082: @532640
      GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(532752), // Rule ID 12871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12871,
        GIR_EraseRootFromParent_Done,
      // Label 7083: @532752
      GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(532864), // Rule ID 7842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7842,
        GIR_EraseRootFromParent_Done,
      // Label 7084: @532864
      GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(532976), // Rule ID 7841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7841,
        GIR_EraseRootFromParent_Done,
      // Label 7085: @532976
      GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(533072), // Rule ID 12856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12856,
        GIR_EraseRootFromParent_Done,
      // Label 7086: @533072
      GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(533168), // Rule ID 12855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>)  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12855,
        GIR_EraseRootFromParent_Done,
      // Label 7087: @533168
      GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(533264), // Rule ID 7826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7826,
        GIR_EraseRootFromParent_Done,
      // Label 7088: @533264
      GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(533360), // Rule ID 7825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINNUM_IEEE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (fminnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminnum_ieee_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))  =>  (V_MINMAX_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7825,
        GIR_EraseRootFromParent_Done,
      // Label 7089: @533360
      GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(533395), // Rule ID 92 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13404),
        // (fmaxnum_ieee:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13404>>  =>  (S_MAX_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 92,
        GIR_Done,
      // Label 7090: @533395
      GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(533455), // Rule ID 803 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 803,
        GIR_EraseRootFromParent_Done,
      // Label 7091: @533455
      GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(533515), // Rule ID 8516 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum_ieee:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8516,
        GIR_EraseRootFromParent_Done,
      // Label 7092: @533515
      GIM_Reject,
    // Label 6953: @533516
    GIM_Reject,
    // Label 6679: @533517
    GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(533769),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(533591), // Rule ID 918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 918,
        GIR_EraseRootFromParent_Done,
      // Label 7094: @533591
      GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(533650), // Rule ID 937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 937,
        GIR_EraseRootFromParent_Done,
      // Label 7095: @533650
      GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(533709), // Rule ID 8542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8542,
        GIR_EraseRootFromParent_Done,
      // Label 7096: @533709
      GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(533768), // Rule ID 8556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaxnum_ieee:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8556,
        GIR_EraseRootFromParent_Done,
      // Label 7097: @533768
      GIM_Reject,
    // Label 7093: @533769
    GIM_Reject,
    // Label 6680: @533770
    GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(533841), // Rule ID 1091 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (fmaxnum_ieee:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1091,
      GIR_EraseRootFromParent_Done,
    // Label 7098: @533841
    GIM_Reject,
    // Label 6681: @533842
    GIM_Reject,
    // Label 84: @533843
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7103*/ GIMT_Encode4(535461),
    /*GILLT_s16*//*Label 7099*/ GIMT_Encode4(533870),
    /*GILLT_s32*//*Label 7100*/ GIMT_Encode4(534492),
    /*GILLT_s64*//*Label 7101*/ GIMT_Encode4(535171),
    /*GILLT_v2s16*//*Label 7102*/ GIMT_Encode4(535306),
    // Label 7099: @533870
    GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(534491),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(534000), // Rule ID 12924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34145>>)<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12924,
        GIR_EraseRootFromParent_Done,
      // Label 7105: @534000
      GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(534119), // Rule ID 7866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7866,
        GIR_EraseRootFromParent_Done,
      // Label 7106: @534119
      GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(534222), // Rule ID 12920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12920,
        GIR_EraseRootFromParent_Done,
      // Label 7107: @534222
      GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(534325), // Rule ID 7862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f16] } (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7862,
        GIR_EraseRootFromParent_Done,
      // Label 7108: @534325
      GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(534392), // Rule ID 944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_19584>>  =>  (V_MINIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 944,
        GIR_EraseRootFromParent_Done,
      // Label 7109: @534392
      GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(534459), // Rule ID 8563 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_19584>>  =>  (V_MINIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8563,
        GIR_EraseRootFromParent_Done,
      // Label 7110: @534459
      GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(534490), // Rule ID 116 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13409),
        // (fminimum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13409>>  =>  (S_MINIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 116,
        GIR_Done,
      // Label 7111: @534490
      GIM_Reject,
    // Label 7104: @534491
    GIM_Reject,
    // Label 7100: @534492
    GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(535170),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(534619), // Rule ID 12922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34145>>)<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12922,
        GIR_EraseRootFromParent_Done,
      // Label 7113: @534619
      GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(534735), // Rule ID 7864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7864,
        GIR_EraseRootFromParent_Done,
      // Label 7114: @534735
      GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(534835), // Rule ID 12918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>)<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12918,
        GIR_EraseRootFromParent_Done,
      // Label 7115: @534835
      GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(534935), // Rule ID 7860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMAXIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fmaximum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19584>>  =>  (V_MAXIMUMMINIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUMMINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7860,
        GIR_EraseRootFromParent_Done,
      // Label 7116: @534935
      GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(535002), // Rule ID 942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_19584>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 942,
        GIR_EraseRootFromParent_Done,
      // Label 7117: @535002
      GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(535069), // Rule ID 8561 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19584),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_19584>>  =>  (V_MINIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8561,
        GIR_EraseRootFromParent_Done,
      // Label 7118: @535069
      GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(535138), // Rule ID 2631 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MINIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2631,
        GIR_EraseRootFromParent_Done,
      // Label 7119: @535138
      GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(535169), // Rule ID 114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13409),
        // (fminimum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13409>>  =>  (S_MINIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MINIMUM_F32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 114,
        GIR_Done,
      // Label 7120: @535169
      GIM_Reject,
    // Label 7112: @535170
    GIM_Reject,
    // Label 7101: @535171
    GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(535305),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(535245), // Rule ID 946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fminimum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 946,
        GIR_EraseRootFromParent_Done,
      // Label 7122: @535245
      GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(535304), // Rule ID 8565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fminimum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MINIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8565,
        GIR_EraseRootFromParent_Done,
      // Label 7123: @535304
      GIM_Reject,
    // Label 7121: @535305
    GIM_Reject,
    // Label 7102: @535306
    GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(535460),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(535395), // Rule ID 2646 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MINIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM3_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2646,
        GIR_EraseRootFromParent_Done,
      // Label 7125: @535395
      GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(535459), // Rule ID 1102 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fminimum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MINIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MINIMUM_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1102,
        GIR_EraseRootFromParent_Done,
      // Label 7126: @535459
      GIM_Reject,
    // Label 7124: @535460
    GIM_Reject,
    // Label 7103: @535461
    GIM_Reject,
    // Label 85: @535462
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7131*/ GIMT_Encode4(537080),
    /*GILLT_s16*//*Label 7127*/ GIMT_Encode4(535489),
    /*GILLT_s32*//*Label 7128*/ GIMT_Encode4(536111),
    /*GILLT_s64*//*Label 7129*/ GIMT_Encode4(536790),
    /*GILLT_v2s16*//*Label 7130*/ GIMT_Encode4(536925),
    // Label 7127: @535489
    GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(536110),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(535619), // Rule ID 12923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34145>>)<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12923,
        GIR_EraseRootFromParent_Done,
      // Label 7133: @535619
      GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(535738), // Rule ID 7865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f16] } (fcanonicalize:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7865,
        GIR_EraseRootFromParent_Done,
      // Label 7134: @535738
      GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(535841), // Rule ID 12919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12919,
        GIR_EraseRootFromParent_Done,
      // Label 7135: @535841
      GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(535944), // Rule ID 7861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f16] } (fminimum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f16] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f16] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7861,
        GIR_EraseRootFromParent_Done,
      // Label 7136: @535944
      GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(536011), // Rule ID 945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_19587>>  =>  (V_MAXIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 945,
        GIR_EraseRootFromParent_Done,
      // Label 7137: @536011
      GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(536078), // Rule ID 8564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaximum:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_19587>>  =>  (V_MAXIMUM_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8564,
        GIR_EraseRootFromParent_Done,
      // Label 7138: @536078
      GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(536109), // Rule ID 117 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13410),
        // (fmaximum:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13410>>  =>  (S_MAXIMUM_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F16),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 117,
        GIR_Done,
      // Label 7139: @536109
      GIM_Reject,
    // Label 7132: @536110
    GIM_Reject,
    // Label 7128: @536111
    GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(536789),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(536238), // Rule ID 12921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34145>>)<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12921,
        GIR_EraseRootFromParent_Done,
      // Label 7141: @536238
      GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(536354), // Rule ID 7863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34145),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (fcanonicalize:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_34145>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7863,
        GIR_EraseRootFromParent_Done,
      // Label 7142: @536354
      GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(536454), // Rule ID 12917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods), (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>)<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12917,
        GIR_EraseRootFromParent_Done,
      // Label 7143: @536454
      GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(536554), // Rule ID 7859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMINIMUM),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (fminimum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))<<P:Predicate_fminimum_oneuse>>, (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_mods))<<P:Predicate_anonymous_19587>>  =>  (V_MINIMUMMAXIMUM_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src2_mods, ?:{ *:[f32] }:$src2, 0:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINIMUMMAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7859,
        GIR_EraseRootFromParent_Done,
      // Label 7144: @536554
      GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(536621), // Rule ID 943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))<<P:Predicate_anonymous_19587>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 943,
        GIR_EraseRootFromParent_Done,
      // Label 7145: @536621
      GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(536688), // Rule ID 8562 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_19587),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_19587>>  =>  (V_MAXIMUM_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8562,
        GIR_EraseRootFromParent_Done,
      // Label 7146: @536688
      GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(536757), // Rule ID 2632 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3F32),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_MAXIMUM3_F32_e64:{ *:[f32] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[f32] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[f32] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM3_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2632,
        GIR_EraseRootFromParent_Done,
      // Label 7147: @536757
      GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(536788), // Rule ID 115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13410),
        // (fmaximum:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13410>>  =>  (S_MAXIMUM_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAXIMUM_F32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 115,
        GIR_Done,
      // Label 7148: @536788
      GIM_Reject,
    // Label 7140: @536789
    GIM_Reject,
    // Label 7129: @536790
    GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(536924),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(536864), // Rule ID 947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (fmaximum:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 947,
        GIR_EraseRootFromParent_Done,
      // Label 7150: @536864
      GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(536923), // Rule ID 8566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fmaximum:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MAXIMUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXIMUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8566,
        GIR_EraseRootFromParent_Done,
      // Label 7151: @536923
      GIM_Reject,
    // Label 7149: @536924
    GIM_Reject,
    // Label 7130: @536925
    GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(537079),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(537014), // Rule ID 2647 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMinimum3Maximum3PKF16),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_mods), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_mods))  =>  (V_PK_MAXIMUM3_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_mods, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1, ?:{ *:[i32] }:$src1_mods, ?:{ *:[v2f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM3_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2647,
        GIR_EraseRootFromParent_Done,
      // Label 7153: @537014
      GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(537078), // Rule ID 1101 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
        // (fmaximum:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAXIMUM_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAXIMUM_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1101,
        GIR_EraseRootFromParent_Done,
      // Label 7154: @537078
      GIM_Reject,
    // Label 7152: @537079
    GIM_Reject,
    // Label 7131: @537080
    GIM_Reject,
    // Label 86: @537081
    GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(537204),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(537148), // Rule ID 1874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 8909823:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 47105:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(47105),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(8909823),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1874,
        GIR_EraseRootFromParent_Done,
      // Label 7156: @537148
      GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(537203), // Rule ID 1875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (get_fpmode:{ *:[i32] })  =>  (S_AND_B32:{ *:[i32] }:{ *:[i1] } 521215:{ *:[i32] }, (S_GETREG_B32:{ *:[i1] } 36865:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_GETREG_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(36865),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_AND_B32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(521215),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1875,
        GIR_EraseRootFromParent_Done,
      // Label 7157: @537203
      GIM_Reject,
    // Label 7155: @537204
    GIM_Reject,
    // Label 87: @537205
    GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(537281), // Rule ID 2499 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      // MIs[0] DstI[vdst]
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // MIs[0] Operand 1
      GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
      GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
      GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_PTR_ADD),
      GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckHasOneUse, /*MI*/1,
      // MIs[1] src0
      GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/32,
      GIM_RecordNamedOperand, /*MI*/1, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
      GIM_RecordNamedOperand, /*MI*/1, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
      GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/2, // Name : pred:4:z
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20105),
      GIM_CheckIsSafeToFold, /*NumInsns*/1,
      // (ptradd:{ *:[i32] } (ptradd:{ *:[i32] } i32:{ *:[i32] }:$src0:$pred:4:x, i32:{ *:[i32] }:$src1:$pred:4:y)<<P:Predicate_anonymous_20106>>, i32:{ *:[i32] }:$src2:$pred:4:z)<<P:4:Predicate_anonymous_20105>>  =>  (V_ADD3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD3_U32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
      GIR_RootToRootCopy, /*OpIdx*/2, // src2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 2499,
      GIR_EraseRootFromParent_Done,
    // Label 7158: @537281
    GIM_Reject,
    // Label 88: @537282
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7162*/ GIMT_Encode4(540509),
    /*GILLT_s16*//*Label 7159*/ GIMT_Encode4(537309),
    /*GILLT_s32*//*Label 7160*/ GIMT_Encode4(538992), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 7161*/ GIMT_Encode4(540437),
    // Label 7159: @537309
    GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(538991),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(537418), // Rule ID 11883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11883,
        GIR_EraseRootFromParent_Done,
      // Label 7164: @537418
      GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(537516), // Rule ID 11884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11884,
        GIR_EraseRootFromParent_Done,
      // Label 7165: @537516
      GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(537614), // Rule ID 11885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11885,
        GIR_EraseRootFromParent_Done,
      // Label 7166: @537614
      GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(537712), // Rule ID 11886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11886,
        GIR_EraseRootFromParent_Done,
      // Label 7167: @537712
      GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(537810), // Rule ID 11887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11887,
        GIR_EraseRootFromParent_Done,
      // Label 7168: @537810
      GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(537908), // Rule ID 11888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11888,
        GIR_EraseRootFromParent_Done,
      // Label 7169: @537908
      GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(538006), // Rule ID 11889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11889,
        GIR_EraseRootFromParent_Done,
      // Label 7170: @538006
      GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(538104), // Rule ID 11890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11890,
        GIR_EraseRootFromParent_Done,
      // Label 7171: @538104
      GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(538202), // Rule ID 7756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7756,
        GIR_EraseRootFromParent_Done,
      // Label 7172: @538202
      GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(538300), // Rule ID 11876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11876,
        GIR_EraseRootFromParent_Done,
      // Label 7173: @538300
      GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(538398), // Rule ID 11879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11879,
        GIR_EraseRootFromParent_Done,
      // Label 7174: @538398
      GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(538496), // Rule ID 11880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11880,
        GIR_EraseRootFromParent_Done,
      // Label 7175: @538496
      GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(538594), // Rule ID 11877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11877,
        GIR_EraseRootFromParent_Done,
      // Label 7176: @538594
      GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(538692), // Rule ID 11878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11878,
        GIR_EraseRootFromParent_Done,
      // Label 7177: @538692
      GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(538790), // Rule ID 11881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11881,
        GIR_EraseRootFromParent_Done,
      // Label 7178: @538790
      GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(538888), // Rule ID 11882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smax:{ *:[i16] } i16:{ *:[i16] }:$src2, (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11882,
        GIR_EraseRootFromParent_Done,
      // Label 7179: @538888
      GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(538944), // Rule ID 902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (smin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 902,
        GIR_EraseRootFromParent_Done,
      // Label 7180: @538944
      GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(538967), // Rule ID 901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 901,
        GIR_Done,
      // Label 7181: @538967
      GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(538990), // Rule ID 903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 903,
        GIR_Done,
      // Label 7182: @538990
      GIM_Reject,
    // Label 7163: @538991
    GIM_Reject,
    // Label 7160: @538992
    GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(540436),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(539083), // Rule ID 11328 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11328,
        GIR_EraseRootFromParent_Done,
      // Label 7184: @539083
      GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(539163), // Rule ID 11329 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11329,
        GIR_EraseRootFromParent_Done,
      // Label 7185: @539163
      GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(539243), // Rule ID 11330 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11330,
        GIR_EraseRootFromParent_Done,
      // Label 7186: @539243
      GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(539323), // Rule ID 11331 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11331,
        GIR_EraseRootFromParent_Done,
      // Label 7187: @539323
      GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(539403), // Rule ID 11332 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11332,
        GIR_EraseRootFromParent_Done,
      // Label 7188: @539403
      GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(539483), // Rule ID 11333 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11333,
        GIR_EraseRootFromParent_Done,
      // Label 7189: @539483
      GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(539563), // Rule ID 11334 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11334,
        GIR_EraseRootFromParent_Done,
      // Label 7190: @539563
      GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(539643), // Rule ID 11335 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11335,
        GIR_EraseRootFromParent_Done,
      // Label 7191: @539643
      GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(539723), // Rule ID 7719 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7719,
        GIR_EraseRootFromParent_Done,
      // Label 7192: @539723
      GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(539803), // Rule ID 11321 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11321,
        GIR_EraseRootFromParent_Done,
      // Label 7193: @539803
      GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(539883), // Rule ID 11324 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11324,
        GIR_EraseRootFromParent_Done,
      // Label 7194: @539883
      GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(539963), // Rule ID 11325 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11325,
        GIR_EraseRootFromParent_Done,
      // Label 7195: @539963
      GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(540043), // Rule ID 11322 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11322,
        GIR_EraseRootFromParent_Done,
      // Label 7196: @540043
      GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(540123), // Rule ID 11323 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11323,
        GIR_EraseRootFromParent_Done,
      // Label 7197: @540123
      GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(540203), // Rule ID 11326 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11326,
        GIR_EraseRootFromParent_Done,
      // Label 7198: @540203
      GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(540283), // Rule ID 11327 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11327,
        GIR_EraseRootFromParent_Done,
      // Label 7199: @540283
      GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(540336), // Rule ID 7821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34147),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34147>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7821,
        GIR_EraseRootFromParent_Done,
      // Label 7200: @540336
      GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(540389), // Rule ID 12851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34147),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smax_oneuse>>)<<P:Predicate_anonymous_34147>>  =>  (V_MAXMIN_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12851,
        GIR_EraseRootFromParent_Done,
      // Label 7201: @540389
      GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(540415), // Rule ID 47 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13385),
        // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13385>>  =>  (S_MIN_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 47,
        GIR_Done,
      // Label 7202: @540415
      GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(540435), // Rule ID 805 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_I32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 805,
        GIR_Done,
      // Label 7203: @540435
      GIM_Reject,
    // Label 7183: @540436
    GIM_Reject,
    // Label 7161: @540437
    GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(540508), // Rule ID 1097 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (smin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1097,
      GIR_EraseRootFromParent_Done,
    // Label 7204: @540508
    GIM_Reject,
    // Label 7162: @540509
    GIM_Reject,
    // Label 89: @540510
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7208*/ GIMT_Encode4(543899),
    /*GILLT_s16*//*Label 7205*/ GIMT_Encode4(540537),
    /*GILLT_s32*//*Label 7206*/ GIMT_Encode4(542220), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 7207*/ GIMT_Encode4(543827),
    // Label 7205: @540537
    GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(542219),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(540646), // Rule ID 11868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11868,
        GIR_EraseRootFromParent_Done,
      // Label 7210: @540646
      GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(540744), // Rule ID 11869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11869,
        GIR_EraseRootFromParent_Done,
      // Label 7211: @540744
      GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(540842), // Rule ID 11870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11870,
        GIR_EraseRootFromParent_Done,
      // Label 7212: @540842
      GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(540940), // Rule ID 11871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11871,
        GIR_EraseRootFromParent_Done,
      // Label 7213: @540940
      GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(541038), // Rule ID 11872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11872,
        GIR_EraseRootFromParent_Done,
      // Label 7214: @541038
      GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(541136), // Rule ID 11873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11873,
        GIR_EraseRootFromParent_Done,
      // Label 7215: @541136
      GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(541234), // Rule ID 11874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11874,
        GIR_EraseRootFromParent_Done,
      // Label 7216: @541234
      GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(541332), // Rule ID 11875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11875,
        GIR_EraseRootFromParent_Done,
      // Label 7217: @541332
      GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(541430), // Rule ID 7755 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7755,
        GIR_EraseRootFromParent_Done,
      // Label 7218: @541430
      GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(541528), // Rule ID 11861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11861,
        GIR_EraseRootFromParent_Done,
      // Label 7219: @541528
      GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(541626), // Rule ID 11864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11864,
        GIR_EraseRootFromParent_Done,
      // Label 7220: @541626
      GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(541724), // Rule ID 11865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11865,
        GIR_EraseRootFromParent_Done,
      // Label 7221: @541724
      GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(541822), // Rule ID 11862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11862,
        GIR_EraseRootFromParent_Done,
      // Label 7222: @541822
      GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(541920), // Rule ID 11863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11863,
        GIR_EraseRootFromParent_Done,
      // Label 7223: @541920
      GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(542018), // Rule ID 11866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11866,
        GIR_EraseRootFromParent_Done,
      // Label 7224: @542018
      GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(542116), // Rule ID 11867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i16] } (smin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (smin:{ *:[i16] } i16:{ *:[i16] }:$src2, (smax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_I16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11867,
        GIR_EraseRootFromParent_Done,
      // Label 7225: @542116
      GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(542172), // Rule ID 896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (smax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 896,
        GIR_EraseRootFromParent_Done,
      // Label 7226: @542172
      GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(542195), // Rule ID 895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 895,
        GIR_Done,
      // Label 7227: @542195
      GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(542218), // Rule ID 897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_I16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 897,
        GIR_Done,
      // Label 7228: @542218
      GIM_Reject,
    // Label 7209: @542219
    GIM_Reject,
    // Label 7206: @542220
    GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(543826),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(542311), // Rule ID 11343 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11343,
        GIR_EraseRootFromParent_Done,
      // Label 7230: @542311
      GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(542394), // Rule ID 11344 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11344,
        GIR_EraseRootFromParent_Done,
      // Label 7231: @542394
      GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(542477), // Rule ID 11345 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11345,
        GIR_EraseRootFromParent_Done,
      // Label 7232: @542477
      GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(542560), // Rule ID 11346 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11346,
        GIR_EraseRootFromParent_Done,
      // Label 7233: @542560
      GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(542643), // Rule ID 11347 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11347,
        GIR_EraseRootFromParent_Done,
      // Label 7234: @542643
      GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(542726), // Rule ID 11348 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11348,
        GIR_EraseRootFromParent_Done,
      // Label 7235: @542726
      GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(542809), // Rule ID 11349 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11349,
        GIR_EraseRootFromParent_Done,
      // Label 7236: @542809
      GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(542892), // Rule ID 11350 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11350,
        GIR_EraseRootFromParent_Done,
      // Label 7237: @542892
      GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(542975), // Rule ID 7720 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7720,
        GIR_EraseRootFromParent_Done,
      // Label 7238: @542975
      GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(543058), // Rule ID 11336 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11336,
        GIR_EraseRootFromParent_Done,
      // Label 7239: @543058
      GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(543141), // Rule ID 11339 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11339,
        GIR_EraseRootFromParent_Done,
      // Label 7240: @543141
      GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(543224), // Rule ID 11340 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11340,
        GIR_EraseRootFromParent_Done,
      // Label 7241: @543224
      GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(543307), // Rule ID 11337 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11337,
        GIR_EraseRootFromParent_Done,
      // Label 7242: @543307
      GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(543390), // Rule ID 11338 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11338,
        GIR_EraseRootFromParent_Done,
      // Label 7243: @543390
      GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(543473), // Rule ID 11341 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11341,
        GIR_EraseRootFromParent_Done,
      // Label 7244: @543473
      GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(543556), // Rule ID 11342 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (smin:{ *:[i32] } i32:{ *:[i32] }:$src2, (smax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11342,
        GIR_EraseRootFromParent_Done,
      // Label 7245: @543556
      GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(543610), // Rule ID 8571 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        // MIs[0] x
        GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13387),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x), i32:{ *:[i32] }:$x)<<P:Predicate_anonymous_13387>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // x
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8571,
        GIR_EraseRootFromParent_Done,
      // Label 7246: @543610
      GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(543661), // Rule ID 1869 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
        // MIs[1] x
        GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13387),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } i32:{ *:[i32] }:$x, (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$x))<<P:Predicate_anonymous_13387>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } SReg_32:{ *:[i32] }:$x)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // x
        GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AMDGPU::SCC*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1869,
        GIR_EraseRootFromParent_Done,
      // Label 7247: @543661
      GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(543717), // Rule ID 7822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34149),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34149>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7822,
        GIR_EraseRootFromParent_Done,
      // Label 7248: @543717
      GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(543773), // Rule ID 12852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34149),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (smax:{ *:[i32] } i32:{ *:[i32] }:$src2, (smin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_smin_oneuse>>)<<P:Predicate_anonymous_34149>>  =>  (V_MINMAX_I32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12852,
        GIR_EraseRootFromParent_Done,
      // Label 7249: @543773
      GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(543802), // Rule ID 49 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13387),
        // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13387>>  =>  (S_MAX_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 49,
        GIR_Done,
      // Label 7250: @543802
      GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(543825), // Rule ID 806 //
        GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (smax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 806,
        GIR_Done,
      // Label 7251: @543825
      GIM_Reject,
    // Label 7229: @543826
    GIM_Reject,
    // Label 7207: @543827
    GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(543898), // Rule ID 1099 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (smax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_I16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_I16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1099,
      GIR_EraseRootFromParent_Done,
    // Label 7252: @543898
    GIM_Reject,
    // Label 7208: @543899
    GIM_Reject,
    // Label 90: @543900
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7256*/ GIMT_Encode4(547127),
    /*GILLT_s16*//*Label 7253*/ GIMT_Encode4(543927),
    /*GILLT_s32*//*Label 7254*/ GIMT_Encode4(545610), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 7255*/ GIMT_Encode4(547055),
    // Label 7253: @543927
    GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(545609),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(544036), // Rule ID 12909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12909,
        GIR_EraseRootFromParent_Done,
      // Label 7258: @544036
      GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(544134), // Rule ID 12910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12910,
        GIR_EraseRootFromParent_Done,
      // Label 7259: @544134
      GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(544232), // Rule ID 12911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12911,
        GIR_EraseRootFromParent_Done,
      // Label 7260: @544232
      GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(544330), // Rule ID 12912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12912,
        GIR_EraseRootFromParent_Done,
      // Label 7261: @544330
      GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(544428), // Rule ID 12913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12913,
        GIR_EraseRootFromParent_Done,
      // Label 7262: @544428
      GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(544526), // Rule ID 12914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12914,
        GIR_EraseRootFromParent_Done,
      // Label 7263: @544526
      GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(544624), // Rule ID 12915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12915,
        GIR_EraseRootFromParent_Done,
      // Label 7264: @544624
      GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(544722), // Rule ID 12916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12916,
        GIR_EraseRootFromParent_Done,
      // Label 7265: @544722
      GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(544820), // Rule ID 7858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7858,
        GIR_EraseRootFromParent_Done,
      // Label 7266: @544820
      GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(544918), // Rule ID 12902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12902,
        GIR_EraseRootFromParent_Done,
      // Label 7267: @544918
      GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(545016), // Rule ID 12905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12905,
        GIR_EraseRootFromParent_Done,
      // Label 7268: @545016
      GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(545114), // Rule ID 12906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12906,
        GIR_EraseRootFromParent_Done,
      // Label 7269: @545114
      GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(545212), // Rule ID 12903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12903,
        GIR_EraseRootFromParent_Done,
      // Label 7270: @545212
      GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(545310), // Rule ID 12904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12904,
        GIR_EraseRootFromParent_Done,
      // Label 7271: @545310
      GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(545408), // Rule ID 12907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12907,
        GIR_EraseRootFromParent_Done,
      // Label 7272: @545408
      GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(545506), // Rule ID 12908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umax:{ *:[i16] } i16:{ *:[i16] }:$src2, (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12908,
        GIR_EraseRootFromParent_Done,
      // Label 7273: @545506
      GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(545562), // Rule ID 899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (umin:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 899,
        GIR_EraseRootFromParent_Done,
      // Label 7274: @545562
      GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(545585), // Rule ID 898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 898,
        GIR_Done,
      // Label 7275: @545585
      GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(545608), // Rule ID 900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MIN_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 900,
        GIR_Done,
      // Label 7276: @545608
      GIM_Reject,
    // Label 7257: @545609
    GIM_Reject,
    // Label 7254: @545610
    GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(547054),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(545701), // Rule ID 11358 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11358,
        GIR_EraseRootFromParent_Done,
      // Label 7278: @545701
      GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(545781), // Rule ID 11359 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11359,
        GIR_EraseRootFromParent_Done,
      // Label 7279: @545781
      GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(545861), // Rule ID 11360 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11360,
        GIR_EraseRootFromParent_Done,
      // Label 7280: @545861
      GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(545941), // Rule ID 11361 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11361,
        GIR_EraseRootFromParent_Done,
      // Label 7281: @545941
      GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(546021), // Rule ID 11362 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11362,
        GIR_EraseRootFromParent_Done,
      // Label 7282: @546021
      GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(546101), // Rule ID 11363 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11363,
        GIR_EraseRootFromParent_Done,
      // Label 7283: @546101
      GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(546181), // Rule ID 11364 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11364,
        GIR_EraseRootFromParent_Done,
      // Label 7284: @546181
      GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(546261), // Rule ID 11365 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11365,
        GIR_EraseRootFromParent_Done,
      // Label 7285: @546261
      GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(546341), // Rule ID 7721 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7721,
        GIR_EraseRootFromParent_Done,
      // Label 7286: @546341
      GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(546421), // Rule ID 11351 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11351,
        GIR_EraseRootFromParent_Done,
      // Label 7287: @546421
      GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(546501), // Rule ID 11354 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11354,
        GIR_EraseRootFromParent_Done,
      // Label 7288: @546501
      GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(546581), // Rule ID 11355 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11355,
        GIR_EraseRootFromParent_Done,
      // Label 7289: @546581
      GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(546661), // Rule ID 11352 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11352,
        GIR_EraseRootFromParent_Done,
      // Label 7290: @546661
      GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(546741), // Rule ID 11353 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11353,
        GIR_EraseRootFromParent_Done,
      // Label 7291: @546741
      GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(546821), // Rule ID 11356 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11356,
        GIR_EraseRootFromParent_Done,
      // Label 7292: @546821
      GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(546901), // Rule ID 11357 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11357,
        GIR_EraseRootFromParent_Done,
      // Label 7293: @546901
      GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(546954), // Rule ID 7823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34151),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34151>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7823,
        GIR_EraseRootFromParent_Done,
      // Label 7294: @546954
      GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(547007), // Rule ID 12853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34151),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umax_oneuse>>)<<P:Predicate_anonymous_34151>>  =>  (V_MAXMIN_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAXMIN_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12853,
        GIR_EraseRootFromParent_Done,
      // Label 7295: @547007
      GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(547033), // Rule ID 48 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13386),
        // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13386>>  =>  (S_MIN_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MIN_U32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 48,
        GIR_Done,
      // Label 7296: @547033
      GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(547053), // Rule ID 807 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MIN_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_U32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 807,
        GIR_Done,
      // Label 7297: @547053
      GIM_Reject,
    // Label 7277: @547054
    GIM_Reject,
    // Label 7255: @547055
    GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(547126), // Rule ID 1098 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (umin:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MIN_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MIN_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1098,
      GIR_EraseRootFromParent_Done,
    // Label 7298: @547126
    GIM_Reject,
    // Label 7256: @547127
    GIM_Reject,
    // Label 91: @547128
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7302*/ GIMT_Encode4(550355),
    /*GILLT_s16*//*Label 7299*/ GIMT_Encode4(547155),
    /*GILLT_s32*//*Label 7300*/ GIMT_Encode4(548838), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 7301*/ GIMT_Encode4(550283),
    // Label 7299: @547155
    GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(548837),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(547264), // Rule ID 12894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12894,
        GIR_EraseRootFromParent_Done,
      // Label 7304: @547264
      GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(547362), // Rule ID 12895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12895,
        GIR_EraseRootFromParent_Done,
      // Label 7305: @547362
      GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(547460), // Rule ID 12896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12896,
        GIR_EraseRootFromParent_Done,
      // Label 7306: @547460
      GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(547558), // Rule ID 12897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12897,
        GIR_EraseRootFromParent_Done,
      // Label 7307: @547558
      GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(547656), // Rule ID 12898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12898,
        GIR_EraseRootFromParent_Done,
      // Label 7308: @547656
      GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(547754), // Rule ID 12899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12899,
        GIR_EraseRootFromParent_Done,
      // Label 7309: @547754
      GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(547852), // Rule ID 12900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12900,
        GIR_EraseRootFromParent_Done,
      // Label 7310: @547852
      GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(547950), // Rule ID 12901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)), (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12901,
        GIR_EraseRootFromParent_Done,
      // Label 7311: @547950
      GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(548048), // Rule ID 7857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7857,
        GIR_EraseRootFromParent_Done,
      // Label 7312: @548048
      GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(548146), // Rule ID 12887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12887,
        GIR_EraseRootFromParent_Done,
      // Label 7313: @548146
      GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(548244), // Rule ID 12890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12890,
        GIR_EraseRootFromParent_Done,
      // Label 7314: @548244
      GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(548342), // Rule ID 12891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), i16:{ *:[i16] }:$src2))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12891,
        GIR_EraseRootFromParent_Done,
      // Label 7315: @548342
      GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(548440), // Rule ID 12888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12888,
        GIR_EraseRootFromParent_Done,
      // Label 7316: @548440
      GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(548538), // Rule ID 12889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12889,
        GIR_EraseRootFromParent_Done,
      // Label 7317: @548538
      GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(548636), // Rule ID 12892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12892,
        GIR_EraseRootFromParent_Done,
      // Label 7318: @548636
      GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(548734), // Rule ID 12893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i16] } (umin:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0), (umin:{ *:[i16] } i16:{ *:[i16] }:$src2, (umax:{ *:[i16] } i16:{ *:[i16] }:$src1, i16:{ *:[i16] }:$src0)))  =>  (V_MED3_U16_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src0, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src1, 0:{ *:[i32] }, VSrc_b16:{ *:[i16] }:$src2, 0:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12893,
        GIR_EraseRootFromParent_Done,
      // Label 7319: @548734
      GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(548790), // Rule ID 893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (umax:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 893,
        GIR_EraseRootFromParent_Done,
      // Label 7320: @548790
      GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(548813), // Rule ID 892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 892,
        GIR_Done,
      // Label 7321: @548813
      GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(548836), // Rule ID 894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umax:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)  =>  (V_MAX_U16_fake16_e64:{ *:[i16] } i16:{ *:[i16] }:$src0, i16:{ *:[i16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U16_fake16_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 894,
        GIR_Done,
      // Label 7322: @548836
      GIM_Reject,
    // Label 7303: @548837
    GIM_Reject,
    // Label 7300: @548838
    GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(550282),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(548929), // Rule ID 11373 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11373,
        GIR_EraseRootFromParent_Done,
      // Label 7324: @548929
      GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(549009), // Rule ID 11374 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11374,
        GIR_EraseRootFromParent_Done,
      // Label 7325: @549009
      GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(549089), // Rule ID 11375 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11375,
        GIR_EraseRootFromParent_Done,
      // Label 7326: @549089
      GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(549169), // Rule ID 11376 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11376,
        GIR_EraseRootFromParent_Done,
      // Label 7327: @549169
      GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(549249), // Rule ID 11377 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11377,
        GIR_EraseRootFromParent_Done,
      // Label 7328: @549249
      GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(549329), // Rule ID 11378 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11378,
        GIR_EraseRootFromParent_Done,
      // Label 7329: @549329
      GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(549409), // Rule ID 11379 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11379,
        GIR_EraseRootFromParent_Done,
      // Label 7330: @549409
      GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(549489), // Rule ID 11380 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMAX),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMIN),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)), (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11380,
        GIR_EraseRootFromParent_Done,
      // Label 7331: @549489
      GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(549569), // Rule ID 7722 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7722,
        GIR_EraseRootFromParent_Done,
      // Label 7332: @549569
      GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(549649), // Rule ID 11366 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11366,
        GIR_EraseRootFromParent_Done,
      // Label 7333: @549649
      GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(549729), // Rule ID 11369 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11369,
        GIR_EraseRootFromParent_Done,
      // Label 7334: @549729
      GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(549809), // Rule ID 11370 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src2))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11370,
        GIR_EraseRootFromParent_Done,
      // Label 7335: @549809
      GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(549889), // Rule ID 11367 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11367,
        GIR_EraseRootFromParent_Done,
      // Label 7336: @549889
      GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(549969), // Rule ID 11368 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11368,
        GIR_EraseRootFromParent_Done,
      // Label 7337: @549969
      GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(550049), // Rule ID 11371 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11371,
        GIR_EraseRootFromParent_Done,
      // Label 7338: @550049
      GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(550129), // Rule ID 11372 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_UMAX),
        // MIs[3] src1
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
        // MIs[3] src0
        GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
        GIM_CheckIsSafeToFold, /*NumInsns*/3,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0), (umin:{ *:[i32] } i32:{ *:[i32] }:$src2, (umax:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src0)))  =>  (V_MED3_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11372,
        GIR_EraseRootFromParent_Done,
      // Label 7339: @550129
      GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(550182), // Rule ID 7824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34153),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i32] } (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>, i32:{ *:[i32] }:$src2)<<P:Predicate_anonymous_34153>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/2, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7824,
        GIR_EraseRootFromParent_Done,
      // Label 7340: @550182
      GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(550235), // Rule ID 12854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX11Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UMIN),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckHasOneUse, /*MI*/1,
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_34153),
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (umax:{ *:[i32] } i32:{ *:[i32] }:$src2, (umin:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_umin_oneuse>>)<<P:Predicate_anonymous_34153>>  =>  (V_MINMAX_U32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$src0, VSrc_b32:{ *:[i32] }:$src1, VSrc_b32:{ *:[i32] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MINMAX_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src1
        GIR_RootToRootCopy, /*OpIdx*/1, // src2
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12854,
        GIR_EraseRootFromParent_Done,
      // Label 7341: @550235
      GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(550261), // Rule ID 50 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13388),
        // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)<<P:Predicate_anonymous_13388>>  =>  (S_MAX_U32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MAX_U32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 50,
        GIR_Done,
      // Label 7342: @550261
      GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(550281), // Rule ID 808 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // (umax:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_MAX_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_U32_e64),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 808,
        GIR_Done,
      // Label 7343: @550281
      GIM_Reject,
    // Label 7323: @550282
    GIM_Reject,
    // Label 7301: @550283
    GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(550354), // Rule ID 1100 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (umax:{ *:[v2i16] } (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MAX_U16:{ *:[v2i16] } i32:{ *:[i32] }:$src0_modifiers, v2i16:{ *:[v2i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2i16:{ *:[v2i16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_U16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1100,
      GIR_EraseRootFromParent_Done,
    // Label 7344: @550354
    GIM_Reject,
    // Label 7302: @550355
    GIM_Reject,
    // Label 92: @550356
    GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(550492),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(550416), // Rule ID 7596 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAddNoCarryInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33992),
        // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_33992>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_U32_e32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7596,
        GIR_EraseRootFromParent_Done,
      // Label 7346: @550416
      GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(550442), // Rule ID 23 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13370),
        // (abs:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13370>>  =>  (S_ABS_I32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ABS_I32),
        GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 23,
        GIR_Done,
      // Label 7347: @550442
      GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(550491), // Rule ID 7595 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33992),
        // (abs:{ *:[i32] } i32:{ *:[i32] }:$src)<<P:Predicate_anonymous_33992>>  =>  (V_MAX_I32_e64:{ *:[i32] } (V_SUB_CO_U32_e32:{ *:[i16] } 0:{ *:[i32] }, ?:{ *:[i32] }:$src), ?:{ *:[i32] }:$src)
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_CO_U32_e32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AMDGPU::VCC*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_I32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // src
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7595,
        GIR_EraseRootFromParent_Done,
      // Label 7348: @550491
      GIM_Reject,
    // Label 7345: @550492
    GIM_Reject,
    // Label 93: @550493
    GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(550526),
      GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
      GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(550513), // Rule ID 179 //
        // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH (bb:{ *:[Other] }):$simm16)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 179,
        GIR_Done,
      // Label 7350: @550513
      GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(550525), // Rule ID 180 //
        // (br (bb:{ *:[Other] }):$simm16)  =>  (S_BRANCH_pad_s_nop (bb:{ *:[Other] }):$simm16)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BRANCH_pad_s_nop),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 180,
        GIR_Done,
      // Label 7351: @550525
      GIM_Reject,
    // Label 7349: @550526
    GIM_Reject,
    // Label 94: @550527
    GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(550625),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7355*/ GIMT_Encode4(550624),
      /*GILLT_s32*//*Label 7353*/ GIMT_Encode4(550554),
      /*GILLT_s64*//*Label 7354*/ GIMT_Encode4(550603),
      // Label 7353: @550554
      GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(550574), // Rule ID 10 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13365),
        // (cttz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13365>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 10,
        GIR_Done,
      // Label 7356: @550574
      GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(550602), // Rule ID 684 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (cttz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 684,
        GIR_EraseRootFromParent_Done,
      // Label 7357: @550602
      GIM_Reject,
      // Label 7354: @550603
      GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(550623), // Rule ID 8 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13365),
        // (cttz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13365>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8,
        GIR_Done,
      // Label 7358: @550623
      GIM_Reject,
      // Label 7355: @550624
      GIM_Reject,
    // Label 7352: @550625
    GIM_Reject,
    // Label 95: @550626
    GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(550727),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7362*/ GIMT_Encode4(550695),
      /*GILLT_s32*//*Label 7360*/ GIMT_Encode4(550653),
      /*GILLT_s64*//*Label 7361*/ GIMT_Encode4(550674),
      // Label 7360: @550653
      GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(550673), // Rule ID 12 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13366),
        // (ctlz_zero_undef:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13366>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12,
        GIR_Done,
      // Label 7363: @550673
      GIM_Reject,
      // Label 7361: @550674
      GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(550694), // Rule ID 14 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13366),
        // (ctlz_zero_undef:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13366>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 14,
        GIR_Done,
      // Label 7364: @550694
      GIM_Reject,
      // Label 7362: @550695
      GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(550726), // Rule ID 682 //
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ctlz_zero_undef:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 682,
        GIR_EraseRootFromParent_Done,
      // Label 7365: @550726
      GIM_Reject,
    // Label 7359: @550727
    GIM_Reject,
    // Label 96: @550728
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7368*/ GIMT_Encode4(550942),
    /*GILLT_s32*//*Label 7366*/ GIMT_Encode4(550747),
    /*GILLT_s64*//*Label 7367*/ GIMT_Encode4(550834),
    // Label 7366: @550747
    GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(550776), // Rule ID 6 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13364),
      // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13364>>  =>  (S_BCNT1_I32_B32:{ *:[i32] }:{ *:[i1] } i32:{ *:[i32] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B32),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 6,
      GIR_Done,
    // Label 7369: @550776
    GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(550805), // Rule ID 7 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13364),
      // (ctpop:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13364>>  =>  (S_BCNT1_I32_B64:{ *:[i32] }:{ *:[i1] } i64:{ *:[i64] }:$src0)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
      GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AMDGPU::SCC), GIMT_Encode2(RegState::Dead),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7,
      GIR_Done,
    // Label 7370: @550805
    GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(550833), // Rule ID 7069 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_33421),
      // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$popcnt)<<P:Predicate_anonymous_33421>>  =>  (V_BCNT_U32_B32_e64:{ *:[i32] } VSrc_b32:{ *:[i32] }:$popcnt, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BCNT_U32_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_RootToRootCopy, /*OpIdx*/1, // popcnt
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7069,
      GIR_EraseRootFromParent_Done,
    // Label 7371: @550833
    GIM_Reject,
    // Label 7367: @550834
    GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(550941), // Rule ID 1868 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13364),
      // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$src)<<P:Predicate_anonymous_13364>>  =>  (REG_SEQUENCE:{ *:[i64] } SReg_64:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[i32] } (S_BCNT1_I32_B64:{ *:[i1] }:{ *:[i1] } ?:{ *:[i64] }:$src), SReg_32:{ *:[i32] }), sub0:{ *:[i32] }, (S_MOV_B32:{ *:[i1] } 0:{ *:[i32] }), sub1:{ *:[i32] })
      GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
      GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
      GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_BCNT1_I32_B64),
      GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
      GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for AMDGPU::SCC*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
      GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32RegClassID),
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
      GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_64RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::SReg_32_XEXEC_HI_and_SReg_32_XM0RegClassID),
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::SReg_32_XM0RegClassID),
      // GIR_Coverage, 1868,
      GIR_EraseRootFromParent_Done,
    // Label 7372: @550941
    GIM_Reject,
    // Label 7368: @550942
    GIM_Reject,
    // Label 97: @550943
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 7377*/ GIMT_Encode4(551889),
    /*GILLT_s16*//*Label 7373*/ GIMT_Encode4(550970),
    /*GILLT_s32*//*Label 7374*/ GIMT_Encode4(551025),
    /*GILLT_s64*//*Label 7375*/ GIMT_Encode4(551181),
    /*GILLT_v2s16*//*Label 7376*/ GIMT_Encode4(551834),
    // Label 7373: @550970
    GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(551024), // Rule ID 7613 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bswap:{ *:[i16] } i16:{ *:[i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[i16] }:$a, (S_MOV_B32:{ *:[i16] } 202113025:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(202113025),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7613,
      GIR_EraseRootFromParent_Done,
    // Label 7378: @551024
    GIM_Reject,
    // Label 7374: @551025
    GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(551180),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(551084), // Rule ID 7611 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_PERM_B32_e64:{ *:[i32] } 0:{ *:[i32] }, VSrc_b32:{ *:[i32] }:$a, (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(66051),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // a
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7611,
        GIR_EraseRootFromParent_Done,
      // Label 7380: @551084
      GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(551179), // Rule ID 7609 //
        // (bswap:{ *:[i32] } i32:{ *:[i32] }:$a)  =>  (V_BFI_B32_e64:{ *:[i32] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } VSrc_b32:{ *:[i32] }:$a, VSrc_b32:{ *:[i32] }:$a, 8:{ *:[i32] }))
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_AddImm8, /*InsnID*/3, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
        GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(16711935),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7609,
        GIR_EraseRootFromParent_Done,
      // Label 7381: @551179
      GIM_Reject,
    // Label 7379: @551180
    GIM_Reject,
    // Label 7375: @551181
    GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(551833),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(551384), // Rule ID 7612 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
        // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub0:{ *:[i32] }, (V_PERM_B32_e64:{ *:[i16] } 0:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i16] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (S_MOV_B32:{ *:[i16] } 66051:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/6, /*Imm*/GIMT_Encode8(66051),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
        GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/3, /*Imm*/GIMT_Encode8(66051),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7612,
        GIR_EraseRootFromParent_Done,
      // Label 7383: @551384
      GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(551832), // Rule ID 7610 //
        // (bswap:{ *:[i64] } i64:{ *:[i64] }:$a)  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] }), 8:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFI_B32_e64:{ *:[i16] } (S_MOV_B32:{ *:[i16] } 16711935:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 24:{ *:[i32] }), (V_ALIGNBIT_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] }), 8:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/16, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/15, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
        GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
        GIR_AddImm8, /*InsnID*/14, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
        GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/13, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/13, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/12, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
        GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
        GIR_AddImm8, /*InsnID*/11, /*Imm*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
        GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/10, /*Imm*/GIMT_Encode8(16711935),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
        GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
        GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
        GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/7, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
        GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/7,
        GIR_AddImm8, /*InsnID*/6, /*Imm*/8,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_ALIGNBIT_B32_e64),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/2, /*Imm*/GIMT_Encode8(16711935),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFI_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7610,
        GIR_EraseRootFromParent_Done,
      // Label 7384: @551832
      GIM_Reject,
    // Label 7382: @551833
    GIM_Reject,
    // Label 7376: @551834
    GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(551888), // Rule ID 7615 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX8Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (bswap:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a)  =>  (V_PERM_B32_e64:{ *:[v2i16] } 0:{ *:[i32] }, VSrc_b32:{ *:[v2i16] }:$a, (S_MOV_B32:{ *:[i16] } 33751041:{ *:[i32] }))
      GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
      GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
      GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
      GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(33751041),
      GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PERM_B32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootToRootCopy, /*OpIdx*/1, // a
      GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7615,
      GIR_EraseRootFromParent_Done,
    // Label 7385: @551888
    GIM_Reject,
    // Label 7377: @551889
    GIM_Reject,
    // Label 98: @551890
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7388*/ GIMT_Encode4(552137),
    /*GILLT_s32*//*Label 7386*/ GIMT_Encode4(551909),
    /*GILLT_s64*//*Label 7387*/ GIMT_Encode4(551971),
    // Label 7386: @551909
    GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(551970),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(551937), // Rule ID 4 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13363),
        // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13363>>  =>  (S_BREV_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4,
        GIR_Done,
      // Label 7390: @551937
      GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(551969), // Rule ID 681 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_17755),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (bitreverse:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))<<P:Predicate_anonymous_17755>>  =>  (V_BFREV_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 681,
        GIR_EraseRootFromParent_Done,
      // Label 7391: @551969
      GIM_Reject,
    // Label 7389: @551970
    GIM_Reject,
    // Label 7387: @551971
    GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(552136),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(551999), // Rule ID 5 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13363),
        // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13363>>  =>  (S_BREV_B64:{ *:[i64] } i64:{ *:[i64] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_BREV_B64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5,
        GIR_Done,
      // Label 7393: @551999
      GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(552135), // Rule ID 7616 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_17755),
        // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$a)<<P:Predicate_anonymous_17755>>  =>  (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub1:{ *:[i32] })), sub0:{ *:[i32] }, (V_BFREV_B32_e64:{ *:[i16] } (EXTRACT_SUBREG:{ *:[i32] } VReg_64:{ *:[i64] }:$a, sub0:{ *:[i32] })), sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // a
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // a
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_BFREV_B32_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/3,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        // GIR_Coverage, 7616,
        GIR_EraseRootFromParent_Done,
      // Label 7394: @552135
      GIM_Reject,
    // Label 7392: @552136
    GIM_Reject,
    // Label 7388: @552137
    GIM_Reject,
    // Label 99: @552138
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7398*/ GIMT_Encode4(552465),
    /*GILLT_s16*//*Label 7395*/ GIMT_Encode4(552161),
    /*GILLT_s32*//*Label 7396*/ GIMT_Encode4(552335),
    /*GILLT_s64*//*Label 7397*/ GIMT_Encode4(552415),
    // Label 7395: @552161
    GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(552334),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(552196), // Rule ID 37 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13376),
        // (fceil:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13376>>  =>  (S_CEIL_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 37,
        GIR_Done,
      // Label 7400: @552196
      GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(552242), // Rule ID 769 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 769,
        GIR_EraseRootFromParent_Done,
      // Label 7401: @552242
      GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(552288), // Rule ID 771 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fceil:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 771,
        GIR_EraseRootFromParent_Done,
      // Label 7402: @552288
      GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(552333), // Rule ID 770 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fceil:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_CEIL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 770,
        GIR_EraseRootFromParent_Done,
      // Label 7403: @552333
      GIM_Reject,
    // Label 7399: @552334
    GIM_Reject,
    // Label 7396: @552335
    GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(552414),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(552370), // Rule ID 32 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13376),
        // (fceil:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13376>>  =>  (S_CEIL_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_CEIL_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 32,
        GIR_Done,
      // Label 7405: @552370
      GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(552413), // Rule ID 659 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fceil:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 659,
        GIR_EraseRootFromParent_Done,
      // Label 7406: @552413
      GIM_Reject,
    // Label 7404: @552414
    GIM_Reject,
    // Label 7397: @552415
    GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(552464), // Rule ID 703 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fceil:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CEIL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CEIL_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 703,
      GIR_EraseRootFromParent_Done,
    // Label 7407: @552464
    GIM_Reject,
    // Label 7398: @552465
    GIM_Reject,
    // Label 100: @552466
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7410*/ GIMT_Encode4(552757),
    /*GILLT_s16*//*Label 7408*/ GIMT_Encode4(552485),
    /*GILLT_s32*//*Label 7409*/ GIMT_Encode4(552703),
    // Label 7408: @552485
    GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(552702),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(552564), // Rule ID 2618 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20842),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20842>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (V_S_SQRT_F16_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), SReg_32_XEXEC:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F16_e64),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
        // GIR_Coverage, 2618,
        GIR_EraseRootFromParent_Done,
      // Label 7412: @552564
      GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(552610), // Rule ID 724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 724,
        GIR_EraseRootFromParent_Done,
      // Label 7413: @552610
      GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(552656), // Rule ID 728 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (fsqrt:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_SQRT_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 728,
        GIR_EraseRootFromParent_Done,
      // Label 7414: @552656
      GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(552701), // Rule ID 726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (fsqrt:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_SQRT_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SQRT_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 726,
        GIR_EraseRootFromParent_Done,
      // Label 7415: @552701
      GIM_Reject,
    // Label 7411: @552702
    GIM_Reject,
    // Label 7409: @552703
    GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(552756), // Rule ID 1080 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPseudoScalarTrans),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XEXECRegClassID),
      GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_20842),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (fsqrt:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))<<P:Predicate_anonymous_20842>>  =>  (V_S_SQRT_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_S_SQRT_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1080,
      GIR_EraseRootFromParent_Done,
    // Label 7416: @552756
    GIM_Reject,
    // Label 7410: @552757
    GIM_Reject,
    // Label 101: @552758
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7420*/ GIMT_Encode4(553271),
    /*GILLT_s16*//*Label 7417*/ GIMT_Encode4(552781),
    /*GILLT_s32*//*Label 7418*/ GIMT_Encode4(552955),
    /*GILLT_s64*//*Label 7419*/ GIMT_Encode4(553035),
    // Label 7417: @552781
    GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(552954),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(552816), // Rule ID 38 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13377),
        // (ffloor:{ *:[f16] } f16:{ *:[f16] }:$src0)<<P:Predicate_anonymous_13377>>  =>  (S_FLOOR_F16:{ *:[f16] } f16:{ *:[f16] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 38,
        GIR_Done,
      // Label 7422: @552816
      GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(552862), // Rule ID 766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 766,
        GIR_EraseRootFromParent_Done,
      // Label 7423: @552862
      GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(552908), // Rule ID 768 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ffloor:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 768,
        GIR_EraseRootFromParent_Done,
      // Label 7424: @552908
      GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(552953), // Rule ID 767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (ffloor:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_FLOOR_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 767,
        GIR_EraseRootFromParent_Done,
      // Label 7425: @552953
      GIM_Reject,
    // Label 7421: @552954
    GIM_Reject,
    // Label 7418: @552955
    GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(553034),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(552990), // Rule ID 33 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13377),
        // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$src0)<<P:Predicate_anonymous_13377>>  =>  (S_FLOOR_F32:{ *:[f32] } f32:{ *:[f32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLOOR_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 33,
        GIR_Done,
      // Label 7427: @552990
      GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(553033), // Rule ID 661 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ffloor:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 661,
        GIR_EraseRootFromParent_Done,
      // Label 7428: @553033
      GIM_Reject,
    // Label 7426: @553034
    GIM_Reject,
    // Label 7419: @553035
    GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(553270),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(553227), // Rule ID 7704 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (ffloor:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$x, i32:{ *:[i32] }:$mods))  =>  (V_ADD_F64_e64:{ *:[f64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x, 1:{ *:[i32] }, (V_CNDMASK_B64_PSEUDO:{ *:[i64] } (V_MIN_F64_e64:{ *:[i64] } 0:{ *:[i32] }, (V_FRACT_F64_e64:{ *:[i64] } ?:{ *:[i32] }:$mods, ?:{ *:[f64] }:$x), 0:{ *:[i32] }, (V_MOV_B64_PSEUDO:{ *:[i64] } 4607182418800017407:{ *:[i64] })), ?:{ *:[f64] }:$x, (V_CMP_CLASS_F64_e64:{ *:[i1] } 0:{ *:[i32] }, ?:{ *:[f64] }:$x, 3:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s1,
        GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AMDGPU::V_CMP_CLASS_F64_e64),
        GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/5, /*Imm*/0,
        GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
        GIR_AddImm8, /*InsnID*/5, /*Imm*/3,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
        GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AMDGPU::V_MOV_B64_PSEUDO),
        GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm, /*InsnID*/4, /*Imm*/GIMT_Encode8(4607182418800017407),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AMDGPU::V_FRACT_F64_e64),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_F64_e64),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_CNDMASK_B64_PSEUDO),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // x
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7704,
        GIR_EraseRootFromParent_Done,
      // Label 7430: @553227
      GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(553269), // Rule ID 705 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (ffloor:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_FLOOR_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FLOOR_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 705,
        GIR_EraseRootFromParent_Done,
      // Label 7431: @553269
      GIM_Reject,
    // Label 7429: @553270
    GIM_Reject,
    // Label 7420: @553271
    GIM_Reject,
    // Label 102: @553272
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7437*/ GIMT_Encode4(554233),
    /*GILLT_s16*//*Label 7432*/ GIMT_Encode4(553303),
    /*GILLT_s32*//*Label 7433*/ GIMT_Encode4(553665),
    /*GILLT_s64*//*Label 7434*/ GIMT_Encode4(553833),
    /*GILLT_v2s16*//*Label 7435*/ GIMT_Encode4(554086),
    /*GILLT_v2s32*//*Label 7436*/ GIMT_Encode4(554158),
    // Label 7432: @553303
    GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(553664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(553349), // Rule ID 96 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13402),
        // (strict_fadd:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13402>>  =>  (S_ADD_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 96,
        GIR_Done,
      // Label 7439: @553349
      GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(553412), // Rule ID 859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 859,
        GIR_EraseRootFromParent_Done,
      // Label 7440: @553412
      GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(553475), // Rule ID 863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fadd:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 863,
        GIR_EraseRootFromParent_Done,
      // Label 7441: @553475
      GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(553538), // Rule ID 8519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8519,
        GIR_EraseRootFromParent_Done,
      // Label 7442: @553538
      GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(553601), // Rule ID 8521 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fadd:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8521,
        GIR_EraseRootFromParent_Done,
      // Label 7443: @553601
      GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(553663), // Rule ID 861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (strict_fadd:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 861,
        GIR_EraseRootFromParent_Done,
      // Label 7444: @553663
      GIM_Reject,
    // Label 7438: @553664
    GIM_Reject,
    // Label 7433: @553665
    GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(553832),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(553711), // Rule ID 88 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13402),
        // (strict_fadd:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13402>>  =>  (S_ADD_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_ADD_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 88,
        GIR_Done,
      // Label 7446: @553711
      GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(553771), // Rule ID 785 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fadd:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 785,
        GIR_EraseRootFromParent_Done,
      // Label 7447: @553771
      GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(553831), // Rule ID 8508 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fadd:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8508,
        GIR_EraseRootFromParent_Done,
      // Label 7448: @553831
      GIM_Reject,
    // Label 7445: @553832
    GIM_Reject,
    // Label 7434: @553833
    GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(554085),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(553907), // Rule ID 913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 913,
        GIR_EraseRootFromParent_Done,
      // Label 7450: @553907
      GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(553966), // Rule ID 931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fadd:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 931,
        GIR_EraseRootFromParent_Done,
      // Label 7451: @553966
      GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(554025), // Rule ID 8537 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_pseudo_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_pseudo_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8537,
        GIR_EraseRootFromParent_Done,
      // Label 7452: @554025
      GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(554084), // Rule ID 8550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fadd:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_ADD_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_ADD_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8550,
        GIR_EraseRootFromParent_Done,
      // Label 7453: @554084
      GIM_Reject,
    // Label 7449: @554085
    GIM_Reject,
    // Label 7435: @554086
    GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(554157), // Rule ID 1087 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fadd:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1087,
      GIR_EraseRootFromParent_Done,
    // Label 7454: @554157
    GIM_Reject,
    // Label 7436: @554158
    GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(554232), // Rule ID 1313 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fadd:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_ADD_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_ADD_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1313,
      GIR_EraseRootFromParent_Done,
    // Label 7455: @554232
    GIM_Reject,
    // Label 7437: @554233
    GIM_Reject,
    // Label 103: @554234
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 7458*/ GIMT_Encode4(554597),
    /*GILLT_s16*//*Label 7456*/ GIMT_Encode4(554253),
    /*GILLT_s32*//*Label 7457*/ GIMT_Encode4(554489),
    // Label 7456: @554253
    GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(554488),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(554299), // Rule ID 104 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13406),
        // (strict_fsub:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13406>>  =>  (S_SUB_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 104,
        GIR_Done,
      // Label 7460: @554299
      GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(554362), // Rule ID 865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 865,
        GIR_EraseRootFromParent_Done,
      // Label 7461: @554362
      GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(554425), // Rule ID 869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fsub:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 869,
        GIR_EraseRootFromParent_Done,
      // Label 7462: @554425
      GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(554487), // Rule ID 867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (strict_fsub:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 867,
        GIR_EraseRootFromParent_Done,
      // Label 7463: @554487
      GIM_Reject,
    // Label 7459: @554488
    GIM_Reject,
    // Label 7457: @554489
    GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(554596),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(554535), // Rule ID 106 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13406),
        // (strict_fsub:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13406>>  =>  (S_SUB_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_SUB_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 106,
        GIR_Done,
      // Label 7465: @554535
      GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(554595), // Rule ID 787 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fsub:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_SUB_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_SUB_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 787,
        GIR_EraseRootFromParent_Done,
      // Label 7466: @554595
      GIM_Reject,
    // Label 7464: @554596
    GIM_Reject,
    // Label 7458: @554597
    GIM_Reject,
    // Label 104: @554598
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7472*/ GIMT_Encode4(555865),
    /*GILLT_s16*//*Label 7467*/ GIMT_Encode4(554629),
    /*GILLT_s32*//*Label 7468*/ GIMT_Encode4(554991),
    /*GILLT_s64*//*Label 7469*/ GIMT_Encode4(555159),
    /*GILLT_v2s16*//*Label 7470*/ GIMT_Encode4(555718),
    /*GILLT_v2s32*//*Label 7471*/ GIMT_Encode4(555790),
    // Label 7467: @554629
    GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(554990),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(554675), // Rule ID 98 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13405),
        // (strict_fmul:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)<<P:Predicate_anonymous_13405>>  =>  (S_MUL_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 98,
        GIR_Done,
      // Label 7474: @554675
      GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(554738), // Rule ID 871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 871,
        GIR_EraseRootFromParent_Done,
      // Label 7475: @554738
      GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(554801), // Rule ID 875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 875,
        GIR_EraseRootFromParent_Done,
      // Label 7476: @554801
      GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(554864), // Rule ID 8523 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8523,
        GIR_EraseRootFromParent_Done,
      // Label 7477: @554864
      GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(554927), // Rule ID 8525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fmul:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8525,
        GIR_EraseRootFromParent_Done,
      // Label 7478: @554927
      GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(554989), // Rule ID 873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (strict_fmul:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 873,
        GIR_EraseRootFromParent_Done,
      // Label 7479: @554989
      GIM_Reject,
    // Label 7473: @554990
    GIM_Reject,
    // Label 7468: @554991
    GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(555158),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(555037), // Rule ID 94 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13405),
        // (strict_fmul:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)<<P:Predicate_anonymous_13405>>  =>  (S_MUL_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_MUL_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 94,
        GIR_Done,
      // Label 7481: @555037
      GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(555097), // Rule ID 791 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 791,
        GIR_EraseRootFromParent_Done,
      // Label 7482: @555097
      GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(555157), // Rule ID 8512 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fmul:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8512,
        GIR_EraseRootFromParent_Done,
      // Label 7483: @555157
      GIM_Reject,
    // Label 7480: @555158
    GIM_Reject,
    // Label 7469: @555159
    GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(555717),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(555248), // Rule ID 7867 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7867,
        GIR_EraseRootFromParent_Done,
      // Label 7485: @555248
      GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(555322), // Rule ID 12925 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_pos_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_pos_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_mods))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_mods, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_mods
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12925,
        GIR_EraseRootFromParent_Done,
      // Label 7486: @555322
      GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(555398), // Rule ID 7871 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[2] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0), (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7871,
        GIR_EraseRootFromParent_Done,
      // Label 7487: @555398
      GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(555474), // Rule ID 12929 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
        GIM_CheckIsSafeToFold, /*NumInsns*/2,
        // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, (fabs:{ *:[f64] } f64:{ *:[f64] }:$src0))  =>  (V_LDEXP_F64_e64:{ *:[f64] } 3:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12929,
        GIR_EraseRootFromParent_Done,
      // Label 7488: @555474
      GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(555536), // Rule ID 12927 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1, f64:{ *:[f64] }:$src0)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/2, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 12927,
        GIR_EraseRootFromParent_Done,
      // Label 7489: @555536
      GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(555598), // Rule ID 7869 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
        GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_neg_pow2_prefer_ldexp_f64),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$src0, (fpimm:{ *:[f64] })<<P:Predicate_fpimm_neg_pow2_prefer_ldexp_f64>><<X:FPPow2ToExponentXForm>>:$src1)  =>  (V_LDEXP_F64_e64:{ *:[f64] } 1:{ *:[i32] }, VSrc_b64:{ *:[f64] }:$src0, 0:{ *:[i32] }, (S_MOV_B32:{ *:[i16] } (FPPow2ToExponentXForm:{ *:[i32] } ?:{ *:[f64] }:$src1)))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::S_MOV_B32),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPPow2ToExponent), // src1
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_RootToRootCopy, /*OpIdx*/1, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7869,
        GIR_EraseRootFromParent_Done,
      // Label 7490: @555598
      GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(555657), // Rule ID 933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fmul:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 933,
        GIR_EraseRootFromParent_Done,
      // Label 7491: @555657
      GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(555716), // Rule ID 8552 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fmul:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_MUL_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MUL_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8552,
        GIR_EraseRootFromParent_Done,
      // Label 7492: @555716
      GIM_Reject,
    // Label 7484: @555717
    GIM_Reject,
    // Label 7470: @555718
    GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(555789), // Rule ID 1089 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fmul:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1089,
      GIR_EraseRootFromParent_Done,
    // Label 7493: @555789
    GIM_Reject,
    // Label 7471: @555790
    GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(555864), // Rule ID 1311 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fmul:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_PK_MUL_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MUL_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1311,
      GIR_EraseRootFromParent_Done,
    // Label 7494: @555864
    GIM_Reject,
    // Label 7472: @555865
    GIM_Reject,
    // Label 105: @555866
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 7500*/ GIMT_Encode4(556753),
    /*GILLT_s16*//*Label 7495*/ GIMT_Encode4(555897),
    /*GILLT_s32*//*Label 7496*/ GIMT_Encode4(556191),
    /*GILLT_s64*//*Label 7497*/ GIMT_Encode4(556400),
    /*GILLT_v2s16*//*Label 7498*/ GIMT_Encode4(556566),
    /*GILLT_v2s32*//*Label 7499*/ GIMT_Encode4(556658),
    // Label 7495: @555897
    GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(556190),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(555950), // Rule ID 112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13408),
        // (strict_fma:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)<<P:Predicate_anonymous_13408>>  =>  (S_FMAC_F16:{ *:[f16] } SSrc_f16:{ *:[f16] }:$src0, SSrc_f16:{ *:[f16] }:$src1, SReg_32:{ *:[f16] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F16),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 112,
        GIR_Done,
      // Label 7502: @555950
      GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(556030), // Rule ID 995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 995,
        GIR_EraseRootFromParent_Done,
      // Label 7503: @556030
      GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(556110), // Rule ID 8567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_isGFX8Only),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8567,
        GIR_EraseRootFromParent_Done,
      // Label 7504: @556110
      GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(556189), // Rule ID 1003 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (strict_fma:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F16_gfx9_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F16_gfx9_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1003,
        GIR_EraseRootFromParent_Done,
      // Label 7505: @556189
      GIM_Reject,
    // Label 7501: @556190
    GIM_Reject,
    // Label 7496: @556191
    GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(556399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(556244), // Rule ID 110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSALUFloatInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13408),
        // (strict_fma:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)<<P:Predicate_anonymous_13408>>  =>  (S_FMAC_F32:{ *:[f32] } SSrc_f32:{ *:[f32] }:$src0, SSrc_f32:{ *:[f32] }:$src1, SReg_32:{ *:[f32] }:$src2)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FMAC_F32),
        GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::MODE),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 110,
        GIR_Done,
      // Label 7507: @556244
      GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(556321), // Rule ID 926 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 926,
        GIR_EraseRootFromParent_Done,
      // Label 7508: @556321
      GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(556398), // Rule ID 8546 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8546,
        GIR_EraseRootFromParent_Done,
      // Label 7509: @556398
      GIM_Reject,
    // Label 7506: @556399
    GIM_Reject,
    // Label 7497: @556400
    GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(556565),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(556491), // Rule ID 929 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 929,
        GIR_EraseRootFromParent_Done,
      // Label 7511: @556491
      GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(556564), // Rule ID 8548 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
        // (strict_fma:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_FMA_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f64:{ *:[f64] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f64:{ *:[f64] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 8548,
        GIR_EraseRootFromParent_Done,
      // Label 7512: @556564
      GIM_Reject,
    // Label 7510: @556565
    GIM_Reject,
    // Label 7498: @556566
    GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(556657), // Rule ID 1085 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fma:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F16:{ *:[v2f16] } i32:{ *:[i32] }:$src0_modifiers, v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f16:{ *:[v2f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f16:{ *:[v2f16] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F16),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1085,
      GIR_EraseRootFromParent_Done,
    // Label 7513: @556657
    GIM_Reject,
    // Label 7499: @556658
    GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(556752), // Rule ID 1309 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedFP32Ops),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3pmods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3pmods),
      // (strict_fma:{ *:[v2f32] } (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3PMods:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_PK_FMA_F32:{ *:[v2f32] } i32:{ *:[i32] }:$src0_modifiers, v2f32:{ *:[v2f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, v2f32:{ *:[v2f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, v2f32:{ *:[v2f32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_FMA_F32),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 1309,
      GIR_EraseRootFromParent_Done,
    // Label 7514: @556752
    GIM_Reject,
    // Label 7500: @556753
    GIM_Reject,
    // Label 106: @556754
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(11), /*)*//*default:*//*Label 7518*/ GIMT_Encode4(557116),
    /*GILLT_s16*//*Label 7515*/ GIMT_Encode4(556777),
    /*GILLT_s32*//*Label 7516*/ GIMT_Encode4(556982),
    /*GILLT_s64*//*Label 7517*/ GIMT_Encode4(557049),
    // Label 7515: @556777
    GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(556981),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(556851), // Rule ID 2415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2415,
        GIR_EraseRootFromParent_Done,
      // Label 7520: @556851
      GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(556917), // Rule ID 2417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_t16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2417,
        GIR_EraseRootFromParent_Done,
      // Label 7521: @556917
      GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(556980), // Rule ID 2419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods0),
        // (strict_fldexp:{ *:[f16] } (VOP3Mods0:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods0:{ *:[i16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F16_fake16_e64:{ *:[f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[f16] }:$src0, ?:{ *:[i32] }:$src1_modifiers, ?:{ *:[f16] }:$src1, ?:{ *:[i1] }:$clamp, ?:{ *:[i32] }:$omod)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2419,
        GIR_EraseRootFromParent_Done,
      // Label 7522: @556980
      GIM_Reject,
    // Label 7519: @556981
    GIM_Reject,
    // Label 7516: @556982
    GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(557048), // Rule ID 821 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (strict_fldexp:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 821,
      GIR_EraseRootFromParent_Done,
    // Label 7523: @557048
    GIM_Reject,
    // Label 7517: @557049
    GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(557115), // Rule ID 976 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (strict_fldexp:{ *:[f64] } (VOP3Mods0:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[i32] } i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_LDEXP_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i32:{ *:[i32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_LDEXP_F64_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 976,
      GIR_EraseRootFromParent_Done,
    // Label 7524: @557115
    GIM_Reject,
    // Label 7518: @557116
    GIM_Reject,
    // Label 107: @557117
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7527*/ GIMT_Encode4(559420),
    /*GILLT_s32*//*Label 7525*/ GIMT_Encode4(557136),
    /*GILLT_s64*//*Label 7526*/ GIMT_Encode4(558278),
    // Label 7525: @557136
    GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(558277),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
      GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(557206), // Rule ID 5831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5831,
        GIR_EraseRootFromParent_Done,
      // Label 7529: @557206
      GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(557265), // Rule ID 5835 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64 VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5835,
        GIR_EraseRootFromParent_Done,
      // Label 7530: @557265
      GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(557383), // Rule ID 5607 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_ADDR64_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 5607,
        GIR_EraseRootFromParent_Done,
      // Label 7531: @557383
      GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(557498), // Rule ID 5833 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_ADDR64_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 5833,
        GIR_EraseRootFromParent_Done,
      // Label 7532: @557498
      GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(557555), // Rule ID 5830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5830,
        GIR_EraseRootFromParent_Done,
      // Label 7533: @557555
      GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(557609), // Rule ID 5834 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5834,
        GIR_EraseRootFromParent_Done,
      // Label 7534: @557609
      GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(557722), // Rule ID 5606 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 5606,
        GIR_EraseRootFromParent_Done,
      // Label 7535: @557722
      GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(557832), // Rule ID 5832 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (EXTRACT_SUBREG:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } VReg_64:{ *:[v2i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_64:{ *:[i32] }), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        // GIR_Coverage, 5832,
        GIR_EraseRootFromParent_Done,
      // Label 7536: @557832
      GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(557889), // Rule ID 4012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4012,
        GIR_EraseRootFromParent_Done,
      // Label 7537: @557889
      GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(557950), // Rule ID 4014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN:{ *:[i32] } ?:{ *:[i32] }:$voffset, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4014,
        GIR_EraseRootFromParent_Done,
      // Label 7538: @557950
      GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(558002), // Rule ID 4011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4011,
        GIR_EraseRootFromParent_Done,
      // Label 7539: @558002
      GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(558058), // Rule ID 4013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (GLOBAL_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4013,
        GIR_EraseRootFromParent_Done,
      // Label 7540: @558058
      GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(558111), // Rule ID 3658 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3658,
        GIR_EraseRootFromParent_Done,
      // Label 7541: @558111
      GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(558163), // Rule ID 3718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i32>>  =>  (FLAT_ATOMIC_CMPSWAP VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3718,
        GIR_EraseRootFromParent_Done,
      // Label 7542: @558163
      GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(558220), // Rule ID 3657 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3657,
        GIR_EraseRootFromParent_Done,
      // Label 7543: @558220
      GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(558276), // Rule ID 3717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i32] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i32:{ *:[v2i32] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i32>>  =>  (FLAT_ATOMIC_CMPSWAP_RTN:{ *:[i32] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9450:{ *:[v2i32] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3717,
        GIR_EraseRootFromParent_Done,
      // Label 7544: @558276
      GIM_Reject,
    // Label 7528: @558277
    GIM_Reject,
    // Label 7526: @558278
    GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(559419),
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
      GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(558348), // Rule ID 5839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5839,
        GIR_EraseRootFromParent_Done,
      // Label 7546: @558348
      GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(558407), // Rule ID 5843 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64 VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5843,
        GIR_EraseRootFromParent_Done,
      // Label 7547: @558407
      GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(558525), // Rule ID 5837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_ADDR64_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // GIR_Coverage, 5837,
        GIR_EraseRootFromParent_Done,
      // Label 7548: @558525
      GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(558640), // Rule ID 5841 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_addr64),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFAddr64:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, VReg_64:{ *:[i64] }:$vaddr, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_ADDR64_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // vaddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // GIR_Coverage, 5841,
        GIR_EraseRootFromParent_Done,
      // Label 7549: @558640
      GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(558697), // Rule ID 5838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5838,
        GIR_EraseRootFromParent_Done,
      // Label 7550: @558697
      GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(558751), // Rule ID 5842 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5842,
        GIR_EraseRootFromParent_Done,
      // Label 7551: @558751
      GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(558864), // Rule ID 5836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // GIR_Coverage, 5836,
        GIR_EraseRootFromParent_Done,
      // Label 7552: @558864
      GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(558974), // Rule ID 5840 //
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_mubuf_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (MUBUFOffset:{ *:[iPTR] } v4i32:{ *:[v4i32] }:$srsrc, i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$vdata_in)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (EXTRACT_SUBREG:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } VReg_128:{ *:[v2i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$srsrc, SCSrc_b32:{ *:[i32] }:$soffset, Offset:{ *:[i32] }:$offset), VReg_128:{ *:[i32] }), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vdata_in
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // srsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/2, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        // GIR_Coverage, 5840,
        GIR_EraseRootFromParent_Done,
      // Label 7553: @558974
      GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(559031), // Rule ID 4068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4068,
        GIR_EraseRootFromParent_Done,
      // Label 7554: @559031
      GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(559092), // Rule ID 4070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_saddr),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalSAddr:{ *:[iPTR] } SReg_64:{ *:[i64] }:$saddr, VGPR_32:{ *:[i32] }:$voffset, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN:{ *:[i64] } ?:{ *:[i32] }:$voffset, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i64] }:$saddr, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_SADDR_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // saddr
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4070,
        GIR_EraseRootFromParent_Done,
      // Label 7555: @559092
      GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(559144), // Rule ID 4067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4067,
        GIR_EraseRootFromParent_Done,
      // Label 7556: @559144
      GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(559200), // Rule ID 4069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatGlobalInsts),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_global_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (GlobalOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (GLOBAL_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::GLOBAL_ATOMIC_CMPSWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4069,
        GIR_EraseRootFromParent_Done,
      // Label 7557: @559200
      GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(559253), // Rule ID 3684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3684,
        GIR_EraseRootFromParent_Done,
      // Label 7558: @559253
      GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(559305), // Rule ID 3744 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_noret_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2 VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2),
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3744,
        GIR_EraseRootFromParent_Done,
      // Label 7559: @559305
      GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(559362), // Rule ID 3683 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/4, /*AddrSpace*/0, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_flat_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3683,
        GIR_EraseRootFromParent_Done,
      // Label 7560: @559362
      GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(559418), // Rule ID 3743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatAddressSpace),
        GIM_CheckMemoryAddressSpace, /*MI*/0, /*MMO*/0, /*NumAddrSpace*/3, /*AddrSpace*/1, /*AddrSpace*/4, /*AddrSpace*/6,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_flat_offset),
        // (AMDGPUatomic_cmp_swap:{ *:[i64] } (FlatOffset:{ *:[iPTR] } i64:{ *:[i64] }:$vaddr, i32:{ *:[i32] }:$offset), v2i64:{ *:[v2i64] }:$data)<<P:Predicate_AMDGPUatomic_cmp_swap_global_i64>>  =>  (FLAT_ATOMIC_CMPSWAP_X2_RTN:{ *:[i64] } VReg_64:{ *:[i64] }:$vaddr, anonymous_9448:{ *:[v2i64] }:$data, ?:{ *:[i32] }:$offset)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::FLAT_ATOMIC_CMPSWAP_X2_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vaddr
        GIR_RootToRootCopy, /*OpIdx*/2, // data
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3743,
        GIR_EraseRootFromParent_Done,
      // Label 7561: @559418
      GIM_Reject,
    // Label 7545: @559419
    GIM_Reject,
    // Label 7527: @559420
    GIM_Reject,
    // Label 108: @559421
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7564*/ GIMT_Encode4(561804),
    /*GILLT_s32*//*Label 7562*/ GIMT_Encode4(559440),
    /*GILLT_s64*//*Label 7563*/ GIMT_Encode4(560622),
    // Label 7562: @559440
    GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(560621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(559528), // Rule ID 5880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5880,
        GIR_EraseRootFromParent_Done,
      // Label 7566: @559528
      GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(559593), // Rule ID 5888 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5888,
        GIR_EraseRootFromParent_Done,
      // Label 7567: @559593
      GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(559665), // Rule ID 5876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5876,
        GIR_EraseRootFromParent_Done,
      // Label 7568: @559665
      GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(559734), // Rule ID 5884 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5884,
        GIR_EraseRootFromParent_Done,
      // Label 7569: @559734
      GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(559800), // Rule ID 5882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5882,
        GIR_EraseRootFromParent_Done,
      // Label 7570: @559800
      GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(559863), // Rule ID 5890 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5890,
        GIR_EraseRootFromParent_Done,
      // Label 7571: @559863
      GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(559933), // Rule ID 5878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5878,
        GIR_EraseRootFromParent_Done,
      // Label 7572: @559933
      GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(560000), // Rule ID 5886 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5886,
        GIR_EraseRootFromParent_Done,
      // Label 7573: @560000
      GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(560058), // Rule ID 5881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5881,
        GIR_EraseRootFromParent_Done,
      // Label 7574: @560058
      GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(560113), // Rule ID 5889 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5889,
        GIR_EraseRootFromParent_Done,
      // Label 7575: @560113
      GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(560175), // Rule ID 5877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5877,
        GIR_EraseRootFromParent_Done,
      // Label 7576: @560175
      GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(560234), // Rule ID 5885 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5885,
        GIR_EraseRootFromParent_Done,
      // Label 7577: @560234
      GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(560330), // Rule ID 5883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5883,
        GIR_EraseRootFromParent_Done,
      // Label 7578: @560330
      GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(560423), // Rule ID 5891 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5891,
        GIR_EraseRootFromParent_Done,
      // Label 7579: @560423
      GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(560523), // Rule ID 5879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5879,
        GIR_EraseRootFromParent_Done,
      // Label 7580: @560523
      GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(560620), // Rule ID 5887 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5887,
        GIR_EraseRootFromParent_Done,
      // Label 7581: @560620
      GIM_Reject,
    // Label 7565: @560621
    GIM_Reject,
    // Label 7563: @560622
    GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(561803),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(560710), // Rule ID 6080 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6080,
        GIR_EraseRootFromParent_Done,
      // Label 7583: @560710
      GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(560775), // Rule ID 6088 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6088,
        GIR_EraseRootFromParent_Done,
      // Label 7584: @560775
      GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(560847), // Rule ID 6076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6076,
        GIR_EraseRootFromParent_Done,
      // Label 7585: @560847
      GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(560916), // Rule ID 6084 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6084,
        GIR_EraseRootFromParent_Done,
      // Label 7586: @560916
      GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(560982), // Rule ID 6082 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6082,
        GIR_EraseRootFromParent_Done,
      // Label 7587: @560982
      GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(561045), // Rule ID 6090 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6090,
        GIR_EraseRootFromParent_Done,
      // Label 7588: @561045
      GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(561115), // Rule ID 6078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6078,
        GIR_EraseRootFromParent_Done,
      // Label 7589: @561115
      GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(561182), // Rule ID 6086 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6086,
        GIR_EraseRootFromParent_Done,
      // Label 7590: @561182
      GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(561240), // Rule ID 6081 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6081,
        GIR_EraseRootFromParent_Done,
      // Label 7591: @561240
      GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(561295), // Rule ID 6089 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6089,
        GIR_EraseRootFromParent_Done,
      // Label 7592: @561295
      GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(561357), // Rule ID 6077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6077,
        GIR_EraseRootFromParent_Done,
      // Label 7593: @561357
      GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(561416), // Rule ID 6085 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6085,
        GIR_EraseRootFromParent_Done,
      // Label 7594: @561416
      GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(561512), // Rule ID 6083 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6083,
        GIR_EraseRootFromParent_Done,
      // Label 7595: @561512
      GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(561605), // Rule ID 6091 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_add_noret>>  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6091,
        GIR_EraseRootFromParent_Done,
      // Label 7596: @561605
      GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(561705), // Rule ID 6079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6079,
        GIR_EraseRootFromParent_Done,
      // Label 7597: @561705
      GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(561802), // Rule ID 6087 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_add:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6087,
        GIR_EraseRootFromParent_Done,
      // Label 7598: @561802
      GIM_Reject,
    // Label 7582: @561803
    GIM_Reject,
    // Label 7564: @561804
    GIM_Reject,
    // Label 109: @561805
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7601*/ GIMT_Encode4(564188),
    /*GILLT_s32*//*Label 7599*/ GIMT_Encode4(561824),
    /*GILLT_s64*//*Label 7600*/ GIMT_Encode4(563006),
    // Label 7599: @561824
    GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(563005),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(561912), // Rule ID 5976 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5976,
        GIR_EraseRootFromParent_Done,
      // Label 7603: @561912
      GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(561977), // Rule ID 5984 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5984,
        GIR_EraseRootFromParent_Done,
      // Label 7604: @561977
      GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(562049), // Rule ID 5972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5972,
        GIR_EraseRootFromParent_Done,
      // Label 7605: @562049
      GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(562118), // Rule ID 5980 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5980,
        GIR_EraseRootFromParent_Done,
      // Label 7606: @562118
      GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(562184), // Rule ID 5978 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5978,
        GIR_EraseRootFromParent_Done,
      // Label 7607: @562184
      GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(562247), // Rule ID 5986 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5986,
        GIR_EraseRootFromParent_Done,
      // Label 7608: @562247
      GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(562317), // Rule ID 5974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5974,
        GIR_EraseRootFromParent_Done,
      // Label 7609: @562317
      GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(562384), // Rule ID 5982 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5982,
        GIR_EraseRootFromParent_Done,
      // Label 7610: @562384
      GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(562442), // Rule ID 5977 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5977,
        GIR_EraseRootFromParent_Done,
      // Label 7611: @562442
      GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(562497), // Rule ID 5985 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5985,
        GIR_EraseRootFromParent_Done,
      // Label 7612: @562497
      GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(562559), // Rule ID 5973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5973,
        GIR_EraseRootFromParent_Done,
      // Label 7613: @562559
      GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(562618), // Rule ID 5981 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5981,
        GIR_EraseRootFromParent_Done,
      // Label 7614: @562618
      GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(562714), // Rule ID 5979 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5979,
        GIR_EraseRootFromParent_Done,
      // Label 7615: @562714
      GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(562807), // Rule ID 5987 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5987,
        GIR_EraseRootFromParent_Done,
      // Label 7616: @562807
      GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(562907), // Rule ID 5975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5975,
        GIR_EraseRootFromParent_Done,
      // Label 7617: @562907
      GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(563004), // Rule ID 5983 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5983,
        GIR_EraseRootFromParent_Done,
      // Label 7618: @563004
      GIM_Reject,
    // Label 7602: @563005
    GIM_Reject,
    // Label 7600: @563006
    GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(564187),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(563094), // Rule ID 6176 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6176,
        GIR_EraseRootFromParent_Done,
      // Label 7620: @563094
      GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(563159), // Rule ID 6184 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6184,
        GIR_EraseRootFromParent_Done,
      // Label 7621: @563159
      GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(563231), // Rule ID 6172 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6172,
        GIR_EraseRootFromParent_Done,
      // Label 7622: @563231
      GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(563300), // Rule ID 6180 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6180,
        GIR_EraseRootFromParent_Done,
      // Label 7623: @563300
      GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(563366), // Rule ID 6178 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6178,
        GIR_EraseRootFromParent_Done,
      // Label 7624: @563366
      GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(563429), // Rule ID 6186 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6186,
        GIR_EraseRootFromParent_Done,
      // Label 7625: @563429
      GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(563499), // Rule ID 6174 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6174,
        GIR_EraseRootFromParent_Done,
      // Label 7626: @563499
      GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(563566), // Rule ID 6182 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6182,
        GIR_EraseRootFromParent_Done,
      // Label 7627: @563566
      GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(563624), // Rule ID 6177 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6177,
        GIR_EraseRootFromParent_Done,
      // Label 7628: @563624
      GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(563679), // Rule ID 6185 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6185,
        GIR_EraseRootFromParent_Done,
      // Label 7629: @563679
      GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(563741), // Rule ID 6173 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6173,
        GIR_EraseRootFromParent_Done,
      // Label 7630: @563741
      GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(563800), // Rule ID 6181 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6181,
        GIR_EraseRootFromParent_Done,
      // Label 7631: @563800
      GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(563896), // Rule ID 6179 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6179,
        GIR_EraseRootFromParent_Done,
      // Label 7632: @563896
      GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(563989), // Rule ID 6187 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_and_noret>>  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6187,
        GIR_EraseRootFromParent_Done,
      // Label 7633: @563989
      GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(564089), // Rule ID 6175 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6175,
        GIR_EraseRootFromParent_Done,
      // Label 7634: @564089
      GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(564186), // Rule ID 6183 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_and:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_AND_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6183,
        GIR_EraseRootFromParent_Done,
      // Label 7635: @564186
      GIM_Reject,
    // Label 7619: @564187
    GIM_Reject,
    // Label 7601: @564188
    GIM_Reject,
    // Label 110: @564189
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7638*/ GIMT_Encode4(568482),
    /*GILLT_s32*//*Label 7636*/ GIMT_Encode4(564208),
    /*GILLT_s64*//*Label 7637*/ GIMT_Encode4(566345),
    // Label 7636: @564208
    GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(566344),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(564341), // Rule ID 6432 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6432,
        GIR_EraseRootFromParent_Done,
      // Label 7640: @564341
      GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(564448), // Rule ID 6440 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6440,
        GIR_EraseRootFromParent_Done,
      // Label 7641: @564448
      GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(564596), // Rule ID 6428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6428,
        GIR_EraseRootFromParent_Done,
      // Label 7642: @564596
      GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(564741), // Rule ID 6436 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6436,
        GIR_EraseRootFromParent_Done,
      // Label 7643: @564741
      GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(564849), // Rule ID 6434 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6434,
        GIR_EraseRootFromParent_Done,
      // Label 7644: @564849
      GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(564954), // Rule ID 6442 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6442,
        GIR_EraseRootFromParent_Done,
      // Label 7645: @564954
      GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(565102), // Rule ID 6430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_OFFEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6430,
        GIR_EraseRootFromParent_Done,
      // Label 7646: @565102
      GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(565247), // Rule ID 6438 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_OFFEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6438,
        GIR_EraseRootFromParent_Done,
      // Label 7647: @565247
      GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(565347), // Rule ID 6433 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // vindex
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6433,
        GIR_EraseRootFromParent_Done,
      // Label 7648: @565347
      GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(565444), // Rule ID 6441 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // vindex
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6441,
        GIR_EraseRootFromParent_Done,
      // Label 7649: @565444
      GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(565584), // Rule ID 6429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_IDXEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6429,
        GIR_EraseRootFromParent_Done,
      // Label 7650: @565584
      GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(565721), // Rule ID 6437 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_IDXEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6437,
        GIR_EraseRootFromParent_Done,
      // Label 7651: @565721
      GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(565859), // Rule ID 6435 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6435,
        GIR_EraseRootFromParent_Done,
      // Label 7652: @565859
      GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(565994), // Rule ID 6443 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6443,
        GIR_EraseRootFromParent_Done,
      // Label 7653: @565994
      GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(566170), // Rule ID 6431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_BOTHEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6431,
        GIR_EraseRootFromParent_Done,
      // Label 7654: @566170
      GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(566343), // Rule ID 6439 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i32] } i32:{ *:[i32] }:$data, i32:{ *:[i32] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$data, sub0:{ *:[i32] }, anonymous_9451:{ *:[i32] }:$cmp, sub1:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_VBUFFER_BOTHEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // GIR_Coverage, 6439,
        GIR_EraseRootFromParent_Done,
      // Label 7655: @566343
      GIM_Reject,
    // Label 7639: @566344
    GIM_Reject,
    // Label 7637: @566345
    GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(568481),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(566478), // Rule ID 6448 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6448,
        GIR_EraseRootFromParent_Done,
      // Label 7657: @566478
      GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(566585), // Rule ID 6456 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6456,
        GIR_EraseRootFromParent_Done,
      // Label 7658: @566585
      GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(566733), // Rule ID 6444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6444,
        GIR_EraseRootFromParent_Done,
      // Label 7659: @566733
      GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(566878), // Rule ID 6452 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFSET_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6452,
        GIR_EraseRootFromParent_Done,
      // Label 7660: @566878
      GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(566986), // Rule ID 6450 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6450,
        GIR_EraseRootFromParent_Done,
      // Label 7661: @566986
      GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(567091), // Rule ID 6458 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/5, // voffset
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6458,
        GIR_EraseRootFromParent_Done,
      // Label 7662: @567091
      GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(567239), // Rule ID 6446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_OFFEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6446,
        GIR_EraseRootFromParent_Done,
      // Label 7663: @567239
      GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(567384), // Rule ID 6454 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/9, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_OFFEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6454,
        GIR_EraseRootFromParent_Done,
      // Label 7664: @567384
      GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(567484), // Rule ID 6449 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // vindex
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6449,
        GIR_EraseRootFromParent_Done,
      // Label 7665: @567484
      GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(567581), // Rule ID 6457 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/4, // vindex
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6457,
        GIR_EraseRootFromParent_Done,
      // Label 7666: @567581
      GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(567721), // Rule ID 6445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_IDXEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6445,
        GIR_EraseRootFromParent_Done,
      // Label 7667: @567721
      GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(567858), // Rule ID 6453 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_IDXEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6453,
        GIR_EraseRootFromParent_Done,
      // Label 7668: @567858
      GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(567996), // Rule ID 6451 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6451,
        GIR_EraseRootFromParent_Done,
      // Label 7669: @567996
      GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(568131), // Rule ID 6459 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cmpswap_noret>>  =>  (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN),
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
        GIR_RootToRootCopy, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6459,
        GIR_EraseRootFromParent_Done,
      // Label 7670: @568131
      GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(568307), // Rule ID 6447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_BOTHEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6447,
        GIR_EraseRootFromParent_Done,
      // Label 7671: @568307
      GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(568480), // Rule ID 6455 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        // MIs[0] Operand 9
        GIM_CheckIsImm, /*MI*/0, /*Op*/9,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cmpswap:{ *:[i64] } i64:{ *:[i64] }:$data, i64:{ *:[i64] }:$cmp, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (EXTRACT_SUBREG:{ *:[i64] } (BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[v8i16] } VReg_128:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$data, sub0_sub1:{ *:[i32] }, anonymous_9450:{ *:[i64] }:$cmp, sub2_sub3:{ *:[i32] }), (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary)), sub0_sub1:{ *:[i32] })
        GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // vindex
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/5, // voffset
        GIR_AddImm8, /*InsnID*/3, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // data
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/4,
        GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // cmp
        GIR_AddImm8, /*InsnID*/2, /*SubRegIndex*/24,
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_128RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/3, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_CMPSWAP_X2_VBUFFER_BOTHEN_RTN),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/7, // offset
        GIR_CustomOperandRenderer, /*InsnID*/1, /*OldInsnID*/0, /*OpIdx*/8, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
        GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AMDGPU::sub0_sub1),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AMDGPU::AV_128RegClassID),
        // GIR_Coverage, 6455,
        GIR_EraseRootFromParent_Done,
      // Label 7672: @568480
      GIM_Reject,
    // Label 7656: @568481
    GIM_Reject,
    // Label 7638: @568482
    GIM_Reject,
    // Label 111: @568483
    GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(569099),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(568574), // Rule ID 6280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6280,
        GIR_EraseRootFromParent_Done,
      // Label 7674: @568574
      GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(568646), // Rule ID 6276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6276,
        GIR_EraseRootFromParent_Done,
      // Label 7675: @568646
      GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(568712), // Rule ID 6282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6282,
        GIR_EraseRootFromParent_Done,
      // Label 7676: @568712
      GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(568782), // Rule ID 6278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6278,
        GIR_EraseRootFromParent_Done,
      // Label 7677: @568782
      GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(568840), // Rule ID 6281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6281,
        GIR_EraseRootFromParent_Done,
      // Label 7678: @568840
      GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(568902), // Rule ID 6277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6277,
        GIR_EraseRootFromParent_Done,
      // Label 7679: @568902
      GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(568998), // Rule ID 6283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicCSubNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_cond_sub_u32_noret>>  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6283,
        GIR_EraseRootFromParent_Done,
      // Label 7680: @568998
      GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(569098), // Rule ID 6279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_cond_sub_u32:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_COND_SUB_U32_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6279,
        GIR_EraseRootFromParent_Done,
      // Label 7681: @569098
      GIM_Reject,
    // Label 7673: @569099
    GIM_Reject,
    // Label 112: @569100
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7684*/ GIMT_Encode4(571483),
    /*GILLT_s32*//*Label 7682*/ GIMT_Encode4(569119),
    /*GILLT_s64*//*Label 7683*/ GIMT_Encode4(570301),
    // Label 7682: @569119
    GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(570300),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(569207), // Rule ID 6040 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6040,
        GIR_EraseRootFromParent_Done,
      // Label 7686: @569207
      GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(569272), // Rule ID 6048 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6048,
        GIR_EraseRootFromParent_Done,
      // Label 7687: @569272
      GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(569344), // Rule ID 6036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6036,
        GIR_EraseRootFromParent_Done,
      // Label 7688: @569344
      GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(569413), // Rule ID 6044 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6044,
        GIR_EraseRootFromParent_Done,
      // Label 7689: @569413
      GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(569479), // Rule ID 6042 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6042,
        GIR_EraseRootFromParent_Done,
      // Label 7690: @569479
      GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(569542), // Rule ID 6050 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6050,
        GIR_EraseRootFromParent_Done,
      // Label 7691: @569542
      GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(569612), // Rule ID 6038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6038,
        GIR_EraseRootFromParent_Done,
      // Label 7692: @569612
      GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(569679), // Rule ID 6046 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6046,
        GIR_EraseRootFromParent_Done,
      // Label 7693: @569679
      GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(569737), // Rule ID 6041 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6041,
        GIR_EraseRootFromParent_Done,
      // Label 7694: @569737
      GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(569792), // Rule ID 6049 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6049,
        GIR_EraseRootFromParent_Done,
      // Label 7695: @569792
      GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(569854), // Rule ID 6037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6037,
        GIR_EraseRootFromParent_Done,
      // Label 7696: @569854
      GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(569913), // Rule ID 6045 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6045,
        GIR_EraseRootFromParent_Done,
      // Label 7697: @569913
      GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(570009), // Rule ID 6043 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6043,
        GIR_EraseRootFromParent_Done,
      // Label 7698: @570009
      GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(570102), // Rule ID 6051 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6051,
        GIR_EraseRootFromParent_Done,
      // Label 7699: @570102
      GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(570202), // Rule ID 6039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6039,
        GIR_EraseRootFromParent_Done,
      // Label 7700: @570202
      GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(570299), // Rule ID 6047 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6047,
        GIR_EraseRootFromParent_Done,
      // Label 7701: @570299
      GIM_Reject,
    // Label 7685: @570300
    GIM_Reject,
    // Label 7683: @570301
    GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(571482),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(570389), // Rule ID 6240 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6240,
        GIR_EraseRootFromParent_Done,
      // Label 7703: @570389
      GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(570454), // Rule ID 6248 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6248,
        GIR_EraseRootFromParent_Done,
      // Label 7704: @570454
      GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(570526), // Rule ID 6236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6236,
        GIR_EraseRootFromParent_Done,
      // Label 7705: @570526
      GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(570595), // Rule ID 6244 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6244,
        GIR_EraseRootFromParent_Done,
      // Label 7706: @570595
      GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(570661), // Rule ID 6242 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6242,
        GIR_EraseRootFromParent_Done,
      // Label 7707: @570661
      GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(570724), // Rule ID 6250 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6250,
        GIR_EraseRootFromParent_Done,
      // Label 7708: @570724
      GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(570794), // Rule ID 6238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6238,
        GIR_EraseRootFromParent_Done,
      // Label 7709: @570794
      GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(570861), // Rule ID 6246 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6246,
        GIR_EraseRootFromParent_Done,
      // Label 7710: @570861
      GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(570919), // Rule ID 6241 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6241,
        GIR_EraseRootFromParent_Done,
      // Label 7711: @570919
      GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(570974), // Rule ID 6249 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6249,
        GIR_EraseRootFromParent_Done,
      // Label 7712: @570974
      GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(571036), // Rule ID 6237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6237,
        GIR_EraseRootFromParent_Done,
      // Label 7713: @571036
      GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(571095), // Rule ID 6245 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6245,
        GIR_EraseRootFromParent_Done,
      // Label 7714: @571095
      GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(571191), // Rule ID 6243 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6243,
        GIR_EraseRootFromParent_Done,
      // Label 7715: @571191
      GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(571284), // Rule ID 6251 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_dec_noret>>  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6251,
        GIR_EraseRootFromParent_Done,
      // Label 7716: @571284
      GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(571384), // Rule ID 6239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6239,
        GIR_EraseRootFromParent_Done,
      // Label 7717: @571384
      GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(571481), // Rule ID 6247 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_dec:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_DEC_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6247,
        GIR_EraseRootFromParent_Done,
      // Label 7718: @571481
      GIM_Reject,
    // Label 7702: @571482
    GIM_Reject,
    // Label 7684: @571483
    GIM_Reject,
    // Label 113: @571484
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7722*/ GIMT_Encode4(576309),
    /*GILLT_s32*//*Label 7719*/ GIMT_Encode4(571507),
    /*GILLT_s64*//*Label 7720*/ GIMT_Encode4(572713),
    /*GILLT_v2s16*//*Label 7721*/ GIMT_Encode4(573919),
    // Label 7719: @571507
    GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(572712),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(571595), // Rule ID 6348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6348,
        GIR_EraseRootFromParent_Done,
      // Label 7724: @571595
      GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(571663), // Rule ID 6352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6352,
        GIR_EraseRootFromParent_Done,
      // Label 7725: @571663
      GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(571735), // Rule ID 6364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6364,
        GIR_EraseRootFromParent_Done,
      // Label 7726: @571735
      GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(571807), // Rule ID 6368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6368,
        GIR_EraseRootFromParent_Done,
      // Label 7727: @571807
      GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(571873), // Rule ID 6350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6350,
        GIR_EraseRootFromParent_Done,
      // Label 7728: @571873
      GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(571939), // Rule ID 6354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6354,
        GIR_EraseRootFromParent_Done,
      // Label 7729: @571939
      GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(572009), // Rule ID 6366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6366,
        GIR_EraseRootFromParent_Done,
      // Label 7730: @572009
      GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(572079), // Rule ID 6370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6370,
        GIR_EraseRootFromParent_Done,
      // Label 7731: @572079
      GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(572137), // Rule ID 6349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6349,
        GIR_EraseRootFromParent_Done,
      // Label 7732: @572137
      GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(572195), // Rule ID 6353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6353,
        GIR_EraseRootFromParent_Done,
      // Label 7733: @572195
      GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(572257), // Rule ID 6365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6365,
        GIR_EraseRootFromParent_Done,
      // Label 7734: @572257
      GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(572319), // Rule ID 6369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6369,
        GIR_EraseRootFromParent_Done,
      // Label 7735: @572319
      GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(572415), // Rule ID 6351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6351,
        GIR_EraseRootFromParent_Done,
      // Label 7736: @572415
      GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(572511), // Rule ID 6355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddNoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6355,
        GIR_EraseRootFromParent_Done,
      // Label 7737: @572511
      GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(572611), // Rule ID 6367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6367,
        GIR_EraseRootFromParent_Done,
      // Label 7738: @572611
      GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(572711), // Rule ID 6371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFaddRtnInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F32_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6371,
        GIR_EraseRootFromParent_Done,
      // Label 7739: @572711
      GIM_Reject,
    // Label 7723: @572712
    GIM_Reject,
    // Label 7720: @572713
    GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(573918),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(572801), // Rule ID 6384 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6384,
        GIR_EraseRootFromParent_Done,
      // Label 7741: @572801
      GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(572869), // Rule ID 6392 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6392,
        GIR_EraseRootFromParent_Done,
      // Label 7742: @572869
      GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(572941), // Rule ID 6380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6380,
        GIR_EraseRootFromParent_Done,
      // Label 7743: @572941
      GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(573013), // Rule ID 6388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6388,
        GIR_EraseRootFromParent_Done,
      // Label 7744: @573013
      GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(573079), // Rule ID 6386 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6386,
        GIR_EraseRootFromParent_Done,
      // Label 7745: @573079
      GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(573145), // Rule ID 6394 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6394,
        GIR_EraseRootFromParent_Done,
      // Label 7746: @573145
      GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(573215), // Rule ID 6382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6382,
        GIR_EraseRootFromParent_Done,
      // Label 7747: @573215
      GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(573285), // Rule ID 6390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6390,
        GIR_EraseRootFromParent_Done,
      // Label 7748: @573285
      GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(573343), // Rule ID 6385 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6385,
        GIR_EraseRootFromParent_Done,
      // Label 7749: @573343
      GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(573401), // Rule ID 6393 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6393,
        GIR_EraseRootFromParent_Done,
      // Label 7750: @573401
      GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(573463), // Rule ID 6381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6381,
        GIR_EraseRootFromParent_Done,
      // Label 7751: @573463
      GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(573525), // Rule ID 6389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6389,
        GIR_EraseRootFromParent_Done,
      // Label 7752: @573525
      GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(573621), // Rule ID 6387 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6387,
        GIR_EraseRootFromParent_Done,
      // Label 7753: @573621
      GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(573717), // Rule ID 6395 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6395,
        GIR_EraseRootFromParent_Done,
      // Label 7754: @573717
      GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(573817), // Rule ID 6383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6383,
        GIR_EraseRootFromParent_Done,
      // Label 7755: @573817
      GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(573917), // Rule ID 6391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFlatBufferGlobalAtomicFaddF64Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_ADD_F64_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6391,
        GIR_EraseRootFromParent_Done,
      // Label 7756: @573917
      GIM_Reject,
    // Label 7740: @573918
    GIM_Reject,
    // Label 7721: @573919
    GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(576308),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(574007), // Rule ID 6264 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_OFFSET anonymous_9451:{ *:[v2bf16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6264,
        GIR_EraseRootFromParent_Done,
      // Label 7758: @574007
      GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(574075), // Rule ID 6272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFSET anonymous_9451:{ *:[v2bf16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6272,
        GIR_EraseRootFromParent_Done,
      // Label 7759: @574075
      GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(574143), // Rule ID 6356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET anonymous_9451:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6356,
        GIR_EraseRootFromParent_Done,
      // Label 7760: @574143
      GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(574211), // Rule ID 6360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET anonymous_9451:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6360,
        GIR_EraseRootFromParent_Done,
      // Label 7761: @574211
      GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(574283), // Rule ID 6260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_BF16_OFFSET_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6260,
        GIR_EraseRootFromParent_Done,
      // Label 7762: @574283
      GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(574355), // Rule ID 6268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFSET_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6268,
        GIR_EraseRootFromParent_Done,
      // Label 7763: @574355
      GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(574427), // Rule ID 6372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6372,
        GIR_EraseRootFromParent_Done,
      // Label 7764: @574427
      GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(574499), // Rule ID 6376 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6376,
        GIR_EraseRootFromParent_Done,
      // Label 7765: @574499
      GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(574565), // Rule ID 6266 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_OFFEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6266,
        GIR_EraseRootFromParent_Done,
      // Label 7766: @574565
      GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(574631), // Rule ID 6274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6274,
        GIR_EraseRootFromParent_Done,
      // Label 7767: @574631
      GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(574697), // Rule ID 6358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6358,
        GIR_EraseRootFromParent_Done,
      // Label 7768: @574697
      GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(574763), // Rule ID 6362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6362,
        GIR_EraseRootFromParent_Done,
      // Label 7769: @574763
      GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(574833), // Rule ID 6262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_BF16_OFFEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6262,
        GIR_EraseRootFromParent_Done,
      // Label 7770: @574833
      GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(574903), // Rule ID 6270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6270,
        GIR_EraseRootFromParent_Done,
      // Label 7771: @574903
      GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(574973), // Rule ID 6374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6374,
        GIR_EraseRootFromParent_Done,
      // Label 7772: @574973
      GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(575043), // Rule ID 6378 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6378,
        GIR_EraseRootFromParent_Done,
      // Label 7773: @575043
      GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(575101), // Rule ID 6265 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_IDXEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6265,
        GIR_EraseRootFromParent_Done,
      // Label 7774: @575101
      GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(575159), // Rule ID 6273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_IDXEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6273,
        GIR_EraseRootFromParent_Done,
      // Label 7775: @575159
      GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(575217), // Rule ID 6357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6357,
        GIR_EraseRootFromParent_Done,
      // Label 7776: @575217
      GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(575275), // Rule ID 6361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6361,
        GIR_EraseRootFromParent_Done,
      // Label 7777: @575275
      GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(575337), // Rule ID 6261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_BF16_IDXEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6261,
        GIR_EraseRootFromParent_Done,
      // Label 7778: @575337
      GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(575399), // Rule ID 6269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_IDXEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6269,
        GIR_EraseRootFromParent_Done,
      // Label 7779: @575399
      GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(575461), // Rule ID 6373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6373,
        GIR_EraseRootFromParent_Done,
      // Label 7780: @575461
      GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(575523), // Rule ID 6377 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6377,
        GIR_EraseRootFromParent_Done,
      // Label 7781: @575523
      GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(575619), // Rule ID 6267 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_BOTHEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6267,
        GIR_EraseRootFromParent_Done,
      // Label 7782: @575619
      GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(575715), // Rule ID 6275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_BOTHEN anonymous_9451:{ *:[v2bf16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6275,
        GIR_EraseRootFromParent_Done,
      // Label 7783: @575715
      GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(575811), // Rule ID 6359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN anonymous_9451:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6359,
        GIR_EraseRootFromParent_Done,
      // Label 7784: @575811
      GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(575907), // Rule ID 6363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16NoRtnInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fadd_noret>>  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN anonymous_9451:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6363,
        GIR_EraseRootFromParent_Done,
      // Label 7785: @575907
      GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(576007), // Rule ID 6263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_BF16_BOTHEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6263,
        GIR_EraseRootFromParent_Done,
      // Label 7786: @576007
      GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(576107), // Rule ID 6271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferPkAddBF16Inst),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2bf16] } v2bf16:{ *:[v2bf16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_BOTHEN_RTN:{ *:[v2bf16] } anonymous_9451:{ *:[v2bf16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_BF16_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6271,
        GIR_EraseRootFromParent_Done,
      // Label 7787: @576107
      GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(576207), // Rule ID 6375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6375,
        GIR_EraseRootFromParent_Done,
      // Label 7788: @576207
      GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(576307), // Rule ID 6379 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicBufferGlobalPkAddF16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fadd:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN:{ *:[v2f16] } anonymous_9451:{ *:[v2f16] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_PK_ADD_F16_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6379,
        GIR_EraseRootFromParent_Done,
      // Label 7789: @576307
      GIM_Reject,
    // Label 7757: @576308
    GIM_Reject,
    // Label 7722: @576309
    GIM_Reject,
    // Label 114: @576310
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7792*/ GIMT_Encode4(579925),
    /*GILLT_s32*//*Label 7790*/ GIMT_Encode4(576329),
    /*GILLT_s64*//*Label 7791*/ GIMT_Encode4(577535),
    // Label 7790: @576329
    GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(577534),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(576417), // Rule ID 6304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6304,
        GIR_EraseRootFromParent_Done,
      // Label 7794: @576417
      GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(576485), // Rule ID 6312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6312,
        GIR_EraseRootFromParent_Done,
      // Label 7795: @576485
      GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(576557), // Rule ID 6300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6300,
        GIR_EraseRootFromParent_Done,
      // Label 7796: @576557
      GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(576629), // Rule ID 6308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6308,
        GIR_EraseRootFromParent_Done,
      // Label 7797: @576629
      GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(576695), // Rule ID 6306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6306,
        GIR_EraseRootFromParent_Done,
      // Label 7798: @576695
      GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(576761), // Rule ID 6314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6314,
        GIR_EraseRootFromParent_Done,
      // Label 7799: @576761
      GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(576831), // Rule ID 6302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6302,
        GIR_EraseRootFromParent_Done,
      // Label 7800: @576831
      GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(576901), // Rule ID 6310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6310,
        GIR_EraseRootFromParent_Done,
      // Label 7801: @576901
      GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(576959), // Rule ID 6305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6305,
        GIR_EraseRootFromParent_Done,
      // Label 7802: @576959
      GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(577017), // Rule ID 6313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6313,
        GIR_EraseRootFromParent_Done,
      // Label 7803: @577017
      GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(577079), // Rule ID 6301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6301,
        GIR_EraseRootFromParent_Done,
      // Label 7804: @577079
      GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(577141), // Rule ID 6309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6309,
        GIR_EraseRootFromParent_Done,
      // Label 7805: @577141
      GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(577237), // Rule ID 6307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6307,
        GIR_EraseRootFromParent_Done,
      // Label 7806: @577237
      GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(577333), // Rule ID 6315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6315,
        GIR_EraseRootFromParent_Done,
      // Label 7807: @577333
      GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(577433), // Rule ID 6303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6303,
        GIR_EraseRootFromParent_Done,
      // Label 7808: @577433
      GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(577533), // Rule ID 6311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMAX_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6311,
        GIR_EraseRootFromParent_Done,
      // Label 7809: @577533
      GIM_Reject,
    // Label 7793: @577534
    GIM_Reject,
    // Label 7791: @577535
    GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(579924),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(577623), // Rule ID 6336 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6336,
        GIR_EraseRootFromParent_Done,
      // Label 7811: @577623
      GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(577691), // Rule ID 6344 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6344,
        GIR_EraseRootFromParent_Done,
      // Label 7812: @577691
      GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(577759), // Rule ID 6416 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6416,
        GIR_EraseRootFromParent_Done,
      // Label 7813: @577759
      GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(577827), // Rule ID 6424 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6424,
        GIR_EraseRootFromParent_Done,
      // Label 7814: @577827
      GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(577899), // Rule ID 6332 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6332,
        GIR_EraseRootFromParent_Done,
      // Label 7815: @577899
      GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(577971), // Rule ID 6340 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6340,
        GIR_EraseRootFromParent_Done,
      // Label 7816: @577971
      GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(578043), // Rule ID 6412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6412,
        GIR_EraseRootFromParent_Done,
      // Label 7817: @578043
      GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(578115), // Rule ID 6420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6420,
        GIR_EraseRootFromParent_Done,
      // Label 7818: @578115
      GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(578181), // Rule ID 6338 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6338,
        GIR_EraseRootFromParent_Done,
      // Label 7819: @578181
      GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(578247), // Rule ID 6346 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6346,
        GIR_EraseRootFromParent_Done,
      // Label 7820: @578247
      GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(578313), // Rule ID 6418 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6418,
        GIR_EraseRootFromParent_Done,
      // Label 7821: @578313
      GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(578379), // Rule ID 6426 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6426,
        GIR_EraseRootFromParent_Done,
      // Label 7822: @578379
      GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(578449), // Rule ID 6334 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6334,
        GIR_EraseRootFromParent_Done,
      // Label 7823: @578449
      GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(578519), // Rule ID 6342 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6342,
        GIR_EraseRootFromParent_Done,
      // Label 7824: @578519
      GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(578589), // Rule ID 6414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6414,
        GIR_EraseRootFromParent_Done,
      // Label 7825: @578589
      GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(578659), // Rule ID 6422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6422,
        GIR_EraseRootFromParent_Done,
      // Label 7826: @578659
      GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(578717), // Rule ID 6337 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6337,
        GIR_EraseRootFromParent_Done,
      // Label 7827: @578717
      GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(578775), // Rule ID 6345 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6345,
        GIR_EraseRootFromParent_Done,
      // Label 7828: @578775
      GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(578833), // Rule ID 6417 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6417,
        GIR_EraseRootFromParent_Done,
      // Label 7829: @578833
      GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(578891), // Rule ID 6425 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6425,
        GIR_EraseRootFromParent_Done,
      // Label 7830: @578891
      GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(578953), // Rule ID 6333 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6333,
        GIR_EraseRootFromParent_Done,
      // Label 7831: @578953
      GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(579015), // Rule ID 6341 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6341,
        GIR_EraseRootFromParent_Done,
      // Label 7832: @579015
      GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(579077), // Rule ID 6413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6413,
        GIR_EraseRootFromParent_Done,
      // Label 7833: @579077
      GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(579139), // Rule ID 6421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6421,
        GIR_EraseRootFromParent_Done,
      // Label 7834: @579139
      GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(579235), // Rule ID 6339 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6339,
        GIR_EraseRootFromParent_Done,
      // Label 7835: @579235
      GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(579331), // Rule ID 6347 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6347,
        GIR_EraseRootFromParent_Done,
      // Label 7836: @579331
      GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(579427), // Rule ID 6419 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6419,
        GIR_EraseRootFromParent_Done,
      // Label 7837: @579427
      GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(579523), // Rule ID 6427 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmax_noret>>  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6427,
        GIR_EraseRootFromParent_Done,
      // Label 7838: @579523
      GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(579623), // Rule ID 6335 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6335,
        GIR_EraseRootFromParent_Done,
      // Label 7839: @579623
      GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(579723), // Rule ID 6343 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6343,
        GIR_EraseRootFromParent_Done,
      // Label 7840: @579723
      GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(579823), // Rule ID 6415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6415,
        GIR_EraseRootFromParent_Done,
      // Label 7841: @579823
      GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(579923), // Rule ID 6423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmax:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MAX_F64_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6423,
        GIR_EraseRootFromParent_Done,
      // Label 7842: @579923
      GIM_Reject,
    // Label 7810: @579924
    GIM_Reject,
    // Label 7792: @579925
    GIM_Reject,
    // Label 115: @579926
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7845*/ GIMT_Encode4(583541),
    /*GILLT_s32*//*Label 7843*/ GIMT_Encode4(579945),
    /*GILLT_s64*//*Label 7844*/ GIMT_Encode4(581151),
    // Label 7843: @579945
    GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(581150),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(580033), // Rule ID 6288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6288,
        GIR_EraseRootFromParent_Done,
      // Label 7847: @580033
      GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(580101), // Rule ID 6296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6296,
        GIR_EraseRootFromParent_Done,
      // Label 7848: @580101
      GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(580173), // Rule ID 6284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6284,
        GIR_EraseRootFromParent_Done,
      // Label 7849: @580173
      GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(580245), // Rule ID 6292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6292,
        GIR_EraseRootFromParent_Done,
      // Label 7850: @580245
      GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(580311), // Rule ID 6290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6290,
        GIR_EraseRootFromParent_Done,
      // Label 7851: @580311
      GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(580377), // Rule ID 6298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6298,
        GIR_EraseRootFromParent_Done,
      // Label 7852: @580377
      GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(580447), // Rule ID 6286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6286,
        GIR_EraseRootFromParent_Done,
      // Label 7853: @580447
      GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(580517), // Rule ID 6294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6294,
        GIR_EraseRootFromParent_Done,
      // Label 7854: @580517
      GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(580575), // Rule ID 6289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6289,
        GIR_EraseRootFromParent_Done,
      // Label 7855: @580575
      GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(580633), // Rule ID 6297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6297,
        GIR_EraseRootFromParent_Done,
      // Label 7856: @580633
      GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(580695), // Rule ID 6285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6285,
        GIR_EraseRootFromParent_Done,
      // Label 7857: @580695
      GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(580757), // Rule ID 6293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6293,
        GIR_EraseRootFromParent_Done,
      // Label 7858: @580757
      GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(580853), // Rule ID 6291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6291,
        GIR_EraseRootFromParent_Done,
      // Label 7859: @580853
      GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(580949), // Rule ID 6299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6299,
        GIR_EraseRootFromParent_Done,
      // Label 7860: @580949
      GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(581049), // Rule ID 6287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6287,
        GIR_EraseRootFromParent_Done,
      // Label 7861: @581049
      GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(581149), // Rule ID 6295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF32GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_FMIN_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6295,
        GIR_EraseRootFromParent_Done,
      // Label 7862: @581149
      GIM_Reject,
    // Label 7846: @581150
    GIM_Reject,
    // Label 7844: @581151
    GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(583540),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(581239), // Rule ID 6320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6320,
        GIR_EraseRootFromParent_Done,
      // Label 7864: @581239
      GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(581307), // Rule ID 6328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6328,
        GIR_EraseRootFromParent_Done,
      // Label 7865: @581307
      GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(581375), // Rule ID 6400 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6400,
        GIR_EraseRootFromParent_Done,
      // Label 7866: @581375
      GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(581443), // Rule ID 6408 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6408,
        GIR_EraseRootFromParent_Done,
      // Label 7867: @581443
      GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(581515), // Rule ID 6316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6316,
        GIR_EraseRootFromParent_Done,
      // Label 7868: @581515
      GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(581587), // Rule ID 6324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6324,
        GIR_EraseRootFromParent_Done,
      // Label 7869: @581587
      GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(581659), // Rule ID 6396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6396,
        GIR_EraseRootFromParent_Done,
      // Label 7870: @581659
      GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(581731), // Rule ID 6404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6404,
        GIR_EraseRootFromParent_Done,
      // Label 7871: @581731
      GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(581797), // Rule ID 6322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6322,
        GIR_EraseRootFromParent_Done,
      // Label 7872: @581797
      GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(581863), // Rule ID 6330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6330,
        GIR_EraseRootFromParent_Done,
      // Label 7873: @581863
      GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(581929), // Rule ID 6402 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6402,
        GIR_EraseRootFromParent_Done,
      // Label 7874: @581929
      GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(581995), // Rule ID 6410 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6410,
        GIR_EraseRootFromParent_Done,
      // Label 7875: @581995
      GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(582065), // Rule ID 6318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6318,
        GIR_EraseRootFromParent_Done,
      // Label 7876: @582065
      GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(582135), // Rule ID 6326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6326,
        GIR_EraseRootFromParent_Done,
      // Label 7877: @582135
      GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(582205), // Rule ID 6398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6398,
        GIR_EraseRootFromParent_Done,
      // Label 7878: @582205
      GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(582275), // Rule ID 6406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6406,
        GIR_EraseRootFromParent_Done,
      // Label 7879: @582275
      GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(582333), // Rule ID 6321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6321,
        GIR_EraseRootFromParent_Done,
      // Label 7880: @582333
      GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(582391), // Rule ID 6329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6329,
        GIR_EraseRootFromParent_Done,
      // Label 7881: @582391
      GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(582449), // Rule ID 6401 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6401,
        GIR_EraseRootFromParent_Done,
      // Label 7882: @582449
      GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(582507), // Rule ID 6409 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6409,
        GIR_EraseRootFromParent_Done,
      // Label 7883: @582507
      GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(582569), // Rule ID 6317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6317,
        GIR_EraseRootFromParent_Done,
      // Label 7884: @582569
      GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(582631), // Rule ID 6325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6325,
        GIR_EraseRootFromParent_Done,
      // Label 7885: @582631
      GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(582693), // Rule ID 6397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6397,
        GIR_EraseRootFromParent_Done,
      // Label 7886: @582693
      GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(582755), // Rule ID 6405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6405,
        GIR_EraseRootFromParent_Done,
      // Label 7887: @582755
      GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(582851), // Rule ID 6323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6323,
        GIR_EraseRootFromParent_Done,
      // Label 7888: @582851
      GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(582947), // Rule ID 6331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6331,
        GIR_EraseRootFromParent_Done,
      // Label 7889: @582947
      GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(583043), // Rule ID 6403 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6403,
        GIR_EraseRootFromParent_Done,
      // Label 7890: @583043
      GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(583139), // Rule ID 6411 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_fmin_noret>>  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6411,
        GIR_EraseRootFromParent_Done,
      // Label 7891: @583139
      GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(583239), // Rule ID 6319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6319,
        GIR_EraseRootFromParent_Done,
      // Label 7892: @583239
      GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(583339), // Rule ID 6327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6327,
        GIR_EraseRootFromParent_Done,
      // Label 7893: @583339
      GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(583439), // Rule ID 6399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6399,
        GIR_EraseRootFromParent_Done,
      // Label 7894: @583439
      GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(583539), // Rule ID 6407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicFMinFMaxF64GlobalInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_fmin:{ *:[f64] } f64:{ *:[f64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN:{ *:[f64] } anonymous_9450:{ *:[f64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_MIN_F64_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6407,
        GIR_EraseRootFromParent_Done,
      // Label 7895: @583539
      GIM_Reject,
    // Label 7863: @583540
    GIM_Reject,
    // Label 7845: @583541
    GIM_Reject,
    // Label 116: @583542
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7898*/ GIMT_Encode4(585925),
    /*GILLT_s32*//*Label 7896*/ GIMT_Encode4(583561),
    /*GILLT_s64*//*Label 7897*/ GIMT_Encode4(584743),
    // Label 7896: @583561
    GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(584742),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(583649), // Rule ID 6024 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6024,
        GIR_EraseRootFromParent_Done,
      // Label 7900: @583649
      GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(583714), // Rule ID 6032 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6032,
        GIR_EraseRootFromParent_Done,
      // Label 7901: @583714
      GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(583786), // Rule ID 6020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6020,
        GIR_EraseRootFromParent_Done,
      // Label 7902: @583786
      GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(583855), // Rule ID 6028 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6028,
        GIR_EraseRootFromParent_Done,
      // Label 7903: @583855
      GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(583921), // Rule ID 6026 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6026,
        GIR_EraseRootFromParent_Done,
      // Label 7904: @583921
      GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(583984), // Rule ID 6034 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6034,
        GIR_EraseRootFromParent_Done,
      // Label 7905: @583984
      GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(584054), // Rule ID 6022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6022,
        GIR_EraseRootFromParent_Done,
      // Label 7906: @584054
      GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(584121), // Rule ID 6030 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6030,
        GIR_EraseRootFromParent_Done,
      // Label 7907: @584121
      GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(584179), // Rule ID 6025 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6025,
        GIR_EraseRootFromParent_Done,
      // Label 7908: @584179
      GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(584234), // Rule ID 6033 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6033,
        GIR_EraseRootFromParent_Done,
      // Label 7909: @584234
      GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(584296), // Rule ID 6021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6021,
        GIR_EraseRootFromParent_Done,
      // Label 7910: @584296
      GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(584355), // Rule ID 6029 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6029,
        GIR_EraseRootFromParent_Done,
      // Label 7911: @584355
      GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(584451), // Rule ID 6027 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6027,
        GIR_EraseRootFromParent_Done,
      // Label 7912: @584451
      GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(584544), // Rule ID 6035 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6035,
        GIR_EraseRootFromParent_Done,
      // Label 7913: @584544
      GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(584644), // Rule ID 6023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6023,
        GIR_EraseRootFromParent_Done,
      // Label 7914: @584644
      GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(584741), // Rule ID 6031 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6031,
        GIR_EraseRootFromParent_Done,
      // Label 7915: @584741
      GIM_Reject,
    // Label 7899: @584742
    GIM_Reject,
    // Label 7897: @584743
    GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(585924),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(584831), // Rule ID 6224 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6224,
        GIR_EraseRootFromParent_Done,
      // Label 7917: @584831
      GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(584896), // Rule ID 6232 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6232,
        GIR_EraseRootFromParent_Done,
      // Label 7918: @584896
      GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(584968), // Rule ID 6220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6220,
        GIR_EraseRootFromParent_Done,
      // Label 7919: @584968
      GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(585037), // Rule ID 6228 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6228,
        GIR_EraseRootFromParent_Done,
      // Label 7920: @585037
      GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(585103), // Rule ID 6226 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6226,
        GIR_EraseRootFromParent_Done,
      // Label 7921: @585103
      GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(585166), // Rule ID 6234 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6234,
        GIR_EraseRootFromParent_Done,
      // Label 7922: @585166
      GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(585236), // Rule ID 6222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6222,
        GIR_EraseRootFromParent_Done,
      // Label 7923: @585236
      GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(585303), // Rule ID 6230 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6230,
        GIR_EraseRootFromParent_Done,
      // Label 7924: @585303
      GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(585361), // Rule ID 6225 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6225,
        GIR_EraseRootFromParent_Done,
      // Label 7925: @585361
      GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(585416), // Rule ID 6233 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6233,
        GIR_EraseRootFromParent_Done,
      // Label 7926: @585416
      GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(585478), // Rule ID 6221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6221,
        GIR_EraseRootFromParent_Done,
      // Label 7927: @585478
      GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(585537), // Rule ID 6229 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6229,
        GIR_EraseRootFromParent_Done,
      // Label 7928: @585537
      GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(585633), // Rule ID 6227 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6227,
        GIR_EraseRootFromParent_Done,
      // Label 7929: @585633
      GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(585726), // Rule ID 6235 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_inc_noret>>  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6235,
        GIR_EraseRootFromParent_Done,
      // Label 7930: @585726
      GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(585826), // Rule ID 6223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6223,
        GIR_EraseRootFromParent_Done,
      // Label 7931: @585826
      GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(585923), // Rule ID 6231 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_inc:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_INC_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6231,
        GIR_EraseRootFromParent_Done,
      // Label 7932: @585923
      GIM_Reject,
    // Label 7916: @585924
    GIM_Reject,
    // Label 7898: @585925
    GIM_Reject,
    // Label 117: @585926
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7935*/ GIMT_Encode4(588309),
    /*GILLT_s32*//*Label 7933*/ GIMT_Encode4(585945),
    /*GILLT_s64*//*Label 7934*/ GIMT_Encode4(587127),
    // Label 7933: @585945
    GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(587126),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(586033), // Rule ID 5992 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5992,
        GIR_EraseRootFromParent_Done,
      // Label 7937: @586033
      GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(586098), // Rule ID 6000 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6000,
        GIR_EraseRootFromParent_Done,
      // Label 7938: @586098
      GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(586170), // Rule ID 5988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5988,
        GIR_EraseRootFromParent_Done,
      // Label 7939: @586170
      GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(586239), // Rule ID 5996 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5996,
        GIR_EraseRootFromParent_Done,
      // Label 7940: @586239
      GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(586305), // Rule ID 5994 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5994,
        GIR_EraseRootFromParent_Done,
      // Label 7941: @586305
      GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(586368), // Rule ID 6002 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6002,
        GIR_EraseRootFromParent_Done,
      // Label 7942: @586368
      GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(586438), // Rule ID 5990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5990,
        GIR_EraseRootFromParent_Done,
      // Label 7943: @586438
      GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(586505), // Rule ID 5998 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5998,
        GIR_EraseRootFromParent_Done,
      // Label 7944: @586505
      GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(586563), // Rule ID 5993 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5993,
        GIR_EraseRootFromParent_Done,
      // Label 7945: @586563
      GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(586618), // Rule ID 6001 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6001,
        GIR_EraseRootFromParent_Done,
      // Label 7946: @586618
      GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(586680), // Rule ID 5989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5989,
        GIR_EraseRootFromParent_Done,
      // Label 7947: @586680
      GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(586739), // Rule ID 5997 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5997,
        GIR_EraseRootFromParent_Done,
      // Label 7948: @586739
      GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(586835), // Rule ID 5995 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5995,
        GIR_EraseRootFromParent_Done,
      // Label 7949: @586835
      GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(586928), // Rule ID 6003 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6003,
        GIR_EraseRootFromParent_Done,
      // Label 7950: @586928
      GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(587028), // Rule ID 5991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5991,
        GIR_EraseRootFromParent_Done,
      // Label 7951: @587028
      GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(587125), // Rule ID 5999 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5999,
        GIR_EraseRootFromParent_Done,
      // Label 7952: @587125
      GIM_Reject,
    // Label 7936: @587126
    GIM_Reject,
    // Label 7934: @587127
    GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(588308),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(587215), // Rule ID 6192 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6192,
        GIR_EraseRootFromParent_Done,
      // Label 7954: @587215
      GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(587280), // Rule ID 6200 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6200,
        GIR_EraseRootFromParent_Done,
      // Label 7955: @587280
      GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(587352), // Rule ID 6188 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6188,
        GIR_EraseRootFromParent_Done,
      // Label 7956: @587352
      GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(587421), // Rule ID 6196 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6196,
        GIR_EraseRootFromParent_Done,
      // Label 7957: @587421
      GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(587487), // Rule ID 6194 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6194,
        GIR_EraseRootFromParent_Done,
      // Label 7958: @587487
      GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(587550), // Rule ID 6202 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6202,
        GIR_EraseRootFromParent_Done,
      // Label 7959: @587550
      GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(587620), // Rule ID 6190 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6190,
        GIR_EraseRootFromParent_Done,
      // Label 7960: @587620
      GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(587687), // Rule ID 6198 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6198,
        GIR_EraseRootFromParent_Done,
      // Label 7961: @587687
      GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(587745), // Rule ID 6193 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6193,
        GIR_EraseRootFromParent_Done,
      // Label 7962: @587745
      GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(587800), // Rule ID 6201 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6201,
        GIR_EraseRootFromParent_Done,
      // Label 7963: @587800
      GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(587862), // Rule ID 6189 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6189,
        GIR_EraseRootFromParent_Done,
      // Label 7964: @587862
      GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(587921), // Rule ID 6197 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6197,
        GIR_EraseRootFromParent_Done,
      // Label 7965: @587921
      GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(588017), // Rule ID 6195 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6195,
        GIR_EraseRootFromParent_Done,
      // Label 7966: @588017
      GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(588110), // Rule ID 6203 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_or_noret>>  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6203,
        GIR_EraseRootFromParent_Done,
      // Label 7967: @588110
      GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(588210), // Rule ID 6191 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6191,
        GIR_EraseRootFromParent_Done,
      // Label 7968: @588210
      GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(588307), // Rule ID 6199 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_or:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_OR_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6199,
        GIR_EraseRootFromParent_Done,
      // Label 7969: @588307
      GIM_Reject,
    // Label 7953: @588308
    GIM_Reject,
    // Label 7935: @588309
    GIM_Reject,
    // Label 118: @588310
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 7972*/ GIMT_Encode4(590693),
    /*GILLT_s32*//*Label 7970*/ GIMT_Encode4(588329),
    /*GILLT_s64*//*Label 7971*/ GIMT_Encode4(589511),
    // Label 7970: @588329
    GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(589510),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(588417), // Rule ID 5944 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5944,
        GIR_EraseRootFromParent_Done,
      // Label 7974: @588417
      GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(588482), // Rule ID 5952 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5952,
        GIR_EraseRootFromParent_Done,
      // Label 7975: @588482
      GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(588554), // Rule ID 5940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5940,
        GIR_EraseRootFromParent_Done,
      // Label 7976: @588554
      GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(588623), // Rule ID 5948 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5948,
        GIR_EraseRootFromParent_Done,
      // Label 7977: @588623
      GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(588689), // Rule ID 5946 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5946,
        GIR_EraseRootFromParent_Done,
      // Label 7978: @588689
      GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(588752), // Rule ID 5954 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5954,
        GIR_EraseRootFromParent_Done,
      // Label 7979: @588752
      GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(588822), // Rule ID 5942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5942,
        GIR_EraseRootFromParent_Done,
      // Label 7980: @588822
      GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(588889), // Rule ID 5950 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5950,
        GIR_EraseRootFromParent_Done,
      // Label 7981: @588889
      GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(588947), // Rule ID 5945 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5945,
        GIR_EraseRootFromParent_Done,
      // Label 7982: @588947
      GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(589002), // Rule ID 5953 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5953,
        GIR_EraseRootFromParent_Done,
      // Label 7983: @589002
      GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(589064), // Rule ID 5941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5941,
        GIR_EraseRootFromParent_Done,
      // Label 7984: @589064
      GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(589123), // Rule ID 5949 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5949,
        GIR_EraseRootFromParent_Done,
      // Label 7985: @589123
      GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(589219), // Rule ID 5947 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5947,
        GIR_EraseRootFromParent_Done,
      // Label 7986: @589219
      GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(589312), // Rule ID 5955 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5955,
        GIR_EraseRootFromParent_Done,
      // Label 7987: @589312
      GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(589412), // Rule ID 5943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5943,
        GIR_EraseRootFromParent_Done,
      // Label 7988: @589412
      GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(589509), // Rule ID 5951 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5951,
        GIR_EraseRootFromParent_Done,
      // Label 7989: @589509
      GIM_Reject,
    // Label 7973: @589510
    GIM_Reject,
    // Label 7971: @589511
    GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(590692),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(589599), // Rule ID 6144 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6144,
        GIR_EraseRootFromParent_Done,
      // Label 7991: @589599
      GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(589664), // Rule ID 6152 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6152,
        GIR_EraseRootFromParent_Done,
      // Label 7992: @589664
      GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(589736), // Rule ID 6140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6140,
        GIR_EraseRootFromParent_Done,
      // Label 7993: @589736
      GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(589805), // Rule ID 6148 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6148,
        GIR_EraseRootFromParent_Done,
      // Label 7994: @589805
      GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(589871), // Rule ID 6146 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6146,
        GIR_EraseRootFromParent_Done,
      // Label 7995: @589871
      GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(589934), // Rule ID 6154 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6154,
        GIR_EraseRootFromParent_Done,
      // Label 7996: @589934
      GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(590004), // Rule ID 6142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6142,
        GIR_EraseRootFromParent_Done,
      // Label 7997: @590004
      GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(590071), // Rule ID 6150 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6150,
        GIR_EraseRootFromParent_Done,
      // Label 7998: @590071
      GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(590129), // Rule ID 6145 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6145,
        GIR_EraseRootFromParent_Done,
      // Label 7999: @590129
      GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(590184), // Rule ID 6153 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6153,
        GIR_EraseRootFromParent_Done,
      // Label 8000: @590184
      GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(590246), // Rule ID 6141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6141,
        GIR_EraseRootFromParent_Done,
      // Label 8001: @590246
      GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(590305), // Rule ID 6149 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6149,
        GIR_EraseRootFromParent_Done,
      // Label 8002: @590305
      GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(590401), // Rule ID 6147 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6147,
        GIR_EraseRootFromParent_Done,
      // Label 8003: @590401
      GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(590494), // Rule ID 6155 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smax_noret>>  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6155,
        GIR_EraseRootFromParent_Done,
      // Label 8004: @590494
      GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(590594), // Rule ID 6143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6143,
        GIR_EraseRootFromParent_Done,
      // Label 8005: @590594
      GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(590691), // Rule ID 6151 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMAX_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6151,
        GIR_EraseRootFromParent_Done,
      // Label 8006: @590691
      GIM_Reject,
    // Label 7990: @590692
    GIM_Reject,
    // Label 7972: @590693
    GIM_Reject,
    // Label 119: @590694
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8009*/ GIMT_Encode4(593077),
    /*GILLT_s32*//*Label 8007*/ GIMT_Encode4(590713),
    /*GILLT_s64*//*Label 8008*/ GIMT_Encode4(591895),
    // Label 8007: @590713
    GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(591894),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(590801), // Rule ID 5912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5912,
        GIR_EraseRootFromParent_Done,
      // Label 8011: @590801
      GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(590866), // Rule ID 5920 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5920,
        GIR_EraseRootFromParent_Done,
      // Label 8012: @590866
      GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(590938), // Rule ID 5908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5908,
        GIR_EraseRootFromParent_Done,
      // Label 8013: @590938
      GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(591007), // Rule ID 5916 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5916,
        GIR_EraseRootFromParent_Done,
      // Label 8014: @591007
      GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(591073), // Rule ID 5914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5914,
        GIR_EraseRootFromParent_Done,
      // Label 8015: @591073
      GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(591136), // Rule ID 5922 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5922,
        GIR_EraseRootFromParent_Done,
      // Label 8016: @591136
      GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(591206), // Rule ID 5910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5910,
        GIR_EraseRootFromParent_Done,
      // Label 8017: @591206
      GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(591273), // Rule ID 5918 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5918,
        GIR_EraseRootFromParent_Done,
      // Label 8018: @591273
      GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(591331), // Rule ID 5913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5913,
        GIR_EraseRootFromParent_Done,
      // Label 8019: @591331
      GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(591386), // Rule ID 5921 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5921,
        GIR_EraseRootFromParent_Done,
      // Label 8020: @591386
      GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(591448), // Rule ID 5909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5909,
        GIR_EraseRootFromParent_Done,
      // Label 8021: @591448
      GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(591507), // Rule ID 5917 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5917,
        GIR_EraseRootFromParent_Done,
      // Label 8022: @591507
      GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(591603), // Rule ID 5915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5915,
        GIR_EraseRootFromParent_Done,
      // Label 8023: @591603
      GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(591696), // Rule ID 5923 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5923,
        GIR_EraseRootFromParent_Done,
      // Label 8024: @591696
      GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(591796), // Rule ID 5911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5911,
        GIR_EraseRootFromParent_Done,
      // Label 8025: @591796
      GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(591893), // Rule ID 5919 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5919,
        GIR_EraseRootFromParent_Done,
      // Label 8026: @591893
      GIM_Reject,
    // Label 8010: @591894
    GIM_Reject,
    // Label 8008: @591895
    GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(593076),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(591983), // Rule ID 6112 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6112,
        GIR_EraseRootFromParent_Done,
      // Label 8028: @591983
      GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(592048), // Rule ID 6120 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6120,
        GIR_EraseRootFromParent_Done,
      // Label 8029: @592048
      GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(592120), // Rule ID 6108 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6108,
        GIR_EraseRootFromParent_Done,
      // Label 8030: @592120
      GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(592189), // Rule ID 6116 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6116,
        GIR_EraseRootFromParent_Done,
      // Label 8031: @592189
      GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(592255), // Rule ID 6114 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6114,
        GIR_EraseRootFromParent_Done,
      // Label 8032: @592255
      GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(592318), // Rule ID 6122 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6122,
        GIR_EraseRootFromParent_Done,
      // Label 8033: @592318
      GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(592388), // Rule ID 6110 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6110,
        GIR_EraseRootFromParent_Done,
      // Label 8034: @592388
      GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(592455), // Rule ID 6118 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6118,
        GIR_EraseRootFromParent_Done,
      // Label 8035: @592455
      GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(592513), // Rule ID 6113 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6113,
        GIR_EraseRootFromParent_Done,
      // Label 8036: @592513
      GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(592568), // Rule ID 6121 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6121,
        GIR_EraseRootFromParent_Done,
      // Label 8037: @592568
      GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(592630), // Rule ID 6109 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6109,
        GIR_EraseRootFromParent_Done,
      // Label 8038: @592630
      GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(592689), // Rule ID 6117 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6117,
        GIR_EraseRootFromParent_Done,
      // Label 8039: @592689
      GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(592785), // Rule ID 6115 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6115,
        GIR_EraseRootFromParent_Done,
      // Label 8040: @592785
      GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(592878), // Rule ID 6123 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_smin_noret>>  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6123,
        GIR_EraseRootFromParent_Done,
      // Label 8041: @592878
      GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(592978), // Rule ID 6111 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6111,
        GIR_EraseRootFromParent_Done,
      // Label 8042: @592978
      GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(593075), // Rule ID 6119 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_smin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SMIN_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6119,
        GIR_EraseRootFromParent_Done,
      // Label 8043: @593075
      GIM_Reject,
    // Label 8027: @593076
    GIM_Reject,
    // Label 8009: @593077
    GIM_Reject,
    // Label 120: @593078
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8046*/ GIMT_Encode4(595461),
    /*GILLT_s32*//*Label 8044*/ GIMT_Encode4(593097),
    /*GILLT_s64*//*Label 8045*/ GIMT_Encode4(594279),
    // Label 8044: @593097
    GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(594278),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(593185), // Rule ID 5896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5896,
        GIR_EraseRootFromParent_Done,
      // Label 8048: @593185
      GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(593250), // Rule ID 5904 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5904,
        GIR_EraseRootFromParent_Done,
      // Label 8049: @593250
      GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(593322), // Rule ID 5892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5892,
        GIR_EraseRootFromParent_Done,
      // Label 8050: @593322
      GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(593391), // Rule ID 5900 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5900,
        GIR_EraseRootFromParent_Done,
      // Label 8051: @593391
      GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(593457), // Rule ID 5898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5898,
        GIR_EraseRootFromParent_Done,
      // Label 8052: @593457
      GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(593520), // Rule ID 5906 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5906,
        GIR_EraseRootFromParent_Done,
      // Label 8053: @593520
      GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(593590), // Rule ID 5894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5894,
        GIR_EraseRootFromParent_Done,
      // Label 8054: @593590
      GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(593657), // Rule ID 5902 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5902,
        GIR_EraseRootFromParent_Done,
      // Label 8055: @593657
      GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(593715), // Rule ID 5897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5897,
        GIR_EraseRootFromParent_Done,
      // Label 8056: @593715
      GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(593770), // Rule ID 5905 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5905,
        GIR_EraseRootFromParent_Done,
      // Label 8057: @593770
      GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(593832), // Rule ID 5893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5893,
        GIR_EraseRootFromParent_Done,
      // Label 8058: @593832
      GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(593891), // Rule ID 5901 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5901,
        GIR_EraseRootFromParent_Done,
      // Label 8059: @593891
      GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(593987), // Rule ID 5899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5899,
        GIR_EraseRootFromParent_Done,
      // Label 8060: @593987
      GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(594080), // Rule ID 5907 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5907,
        GIR_EraseRootFromParent_Done,
      // Label 8061: @594080
      GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(594180), // Rule ID 5895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5895,
        GIR_EraseRootFromParent_Done,
      // Label 8062: @594180
      GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(594277), // Rule ID 5903 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5903,
        GIR_EraseRootFromParent_Done,
      // Label 8063: @594277
      GIM_Reject,
    // Label 8047: @594278
    GIM_Reject,
    // Label 8045: @594279
    GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(595460),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(594367), // Rule ID 6096 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6096,
        GIR_EraseRootFromParent_Done,
      // Label 8065: @594367
      GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(594432), // Rule ID 6104 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6104,
        GIR_EraseRootFromParent_Done,
      // Label 8066: @594432
      GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(594504), // Rule ID 6092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6092,
        GIR_EraseRootFromParent_Done,
      // Label 8067: @594504
      GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(594573), // Rule ID 6100 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6100,
        GIR_EraseRootFromParent_Done,
      // Label 8068: @594573
      GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(594639), // Rule ID 6098 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6098,
        GIR_EraseRootFromParent_Done,
      // Label 8069: @594639
      GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(594702), // Rule ID 6106 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6106,
        GIR_EraseRootFromParent_Done,
      // Label 8070: @594702
      GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(594772), // Rule ID 6094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6094,
        GIR_EraseRootFromParent_Done,
      // Label 8071: @594772
      GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(594839), // Rule ID 6102 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6102,
        GIR_EraseRootFromParent_Done,
      // Label 8072: @594839
      GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(594897), // Rule ID 6097 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6097,
        GIR_EraseRootFromParent_Done,
      // Label 8073: @594897
      GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(594952), // Rule ID 6105 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6105,
        GIR_EraseRootFromParent_Done,
      // Label 8074: @594952
      GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(595014), // Rule ID 6093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6093,
        GIR_EraseRootFromParent_Done,
      // Label 8075: @595014
      GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(595073), // Rule ID 6101 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6101,
        GIR_EraseRootFromParent_Done,
      // Label 8076: @595073
      GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(595169), // Rule ID 6099 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6099,
        GIR_EraseRootFromParent_Done,
      // Label 8077: @595169
      GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(595262), // Rule ID 6107 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_sub_noret>>  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6107,
        GIR_EraseRootFromParent_Done,
      // Label 8078: @595262
      GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(595362), // Rule ID 6095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6095,
        GIR_EraseRootFromParent_Done,
      // Label 8079: @595362
      GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(595459), // Rule ID 6103 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_sub:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SUB_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6103,
        GIR_EraseRootFromParent_Done,
      // Label 8080: @595459
      GIM_Reject,
    // Label 8064: @595460
    GIM_Reject,
    // Label 8046: @595461
    GIM_Reject,
    // Label 121: @595462
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8083*/ GIMT_Encode4(599005),
    /*GILLT_s32*//*Label 8081*/ GIMT_Encode4(595481),
    /*GILLT_s64*//*Label 8082*/ GIMT_Encode4(597823),
    // Label 8081: @595481
    GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(597822),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(595569), // Rule ID 5848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5848,
        GIR_EraseRootFromParent_Done,
      // Label 8085: @595569
      GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(595634), // Rule ID 5856 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5856,
        GIR_EraseRootFromParent_Done,
      // Label 8086: @595634
      GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(595702), // Rule ID 5864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5864,
        GIR_EraseRootFromParent_Done,
      // Label 8087: @595702
      GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(595767), // Rule ID 5872 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5872,
        GIR_EraseRootFromParent_Done,
      // Label 8088: @595767
      GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(595839), // Rule ID 5844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5844,
        GIR_EraseRootFromParent_Done,
      // Label 8089: @595839
      GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(595908), // Rule ID 5852 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5852,
        GIR_EraseRootFromParent_Done,
      // Label 8090: @595908
      GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(595980), // Rule ID 5860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5860,
        GIR_EraseRootFromParent_Done,
      // Label 8091: @595980
      GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(596049), // Rule ID 5868 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5868,
        GIR_EraseRootFromParent_Done,
      // Label 8092: @596049
      GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(596115), // Rule ID 5850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5850,
        GIR_EraseRootFromParent_Done,
      // Label 8093: @596115
      GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(596178), // Rule ID 5858 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5858,
        GIR_EraseRootFromParent_Done,
      // Label 8094: @596178
      GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(596244), // Rule ID 5866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5866,
        GIR_EraseRootFromParent_Done,
      // Label 8095: @596244
      GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(596307), // Rule ID 5874 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5874,
        GIR_EraseRootFromParent_Done,
      // Label 8096: @596307
      GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(596377), // Rule ID 5846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5846,
        GIR_EraseRootFromParent_Done,
      // Label 8097: @596377
      GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(596444), // Rule ID 5854 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5854,
        GIR_EraseRootFromParent_Done,
      // Label 8098: @596444
      GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(596514), // Rule ID 5862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5862,
        GIR_EraseRootFromParent_Done,
      // Label 8099: @596514
      GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(596581), // Rule ID 5870 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5870,
        GIR_EraseRootFromParent_Done,
      // Label 8100: @596581
      GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(596639), // Rule ID 5849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5849,
        GIR_EraseRootFromParent_Done,
      // Label 8101: @596639
      GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(596694), // Rule ID 5857 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5857,
        GIR_EraseRootFromParent_Done,
      // Label 8102: @596694
      GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(596752), // Rule ID 5865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5865,
        GIR_EraseRootFromParent_Done,
      // Label 8103: @596752
      GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(596807), // Rule ID 5873 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5873,
        GIR_EraseRootFromParent_Done,
      // Label 8104: @596807
      GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(596869), // Rule ID 5845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5845,
        GIR_EraseRootFromParent_Done,
      // Label 8105: @596869
      GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(596928), // Rule ID 5853 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5853,
        GIR_EraseRootFromParent_Done,
      // Label 8106: @596928
      GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(596990), // Rule ID 5861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5861,
        GIR_EraseRootFromParent_Done,
      // Label 8107: @596990
      GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(597049), // Rule ID 5869 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5869,
        GIR_EraseRootFromParent_Done,
      // Label 8108: @597049
      GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(597145), // Rule ID 5851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5851,
        GIR_EraseRootFromParent_Done,
      // Label 8109: @597145
      GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(597238), // Rule ID 5859 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5859,
        GIR_EraseRootFromParent_Done,
      // Label 8110: @597238
      GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(597334), // Rule ID 5867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5867,
        GIR_EraseRootFromParent_Done,
      // Label 8111: @597334
      GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(597427), // Rule ID 5875 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5875,
        GIR_EraseRootFromParent_Done,
      // Label 8112: @597427
      GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(597527), // Rule ID 5847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5847,
        GIR_EraseRootFromParent_Done,
      // Label 8113: @597527
      GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(597624), // Rule ID 5855 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5855,
        GIR_EraseRootFromParent_Done,
      // Label 8114: @597624
      GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(597724), // Rule ID 5863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5863,
        GIR_EraseRootFromParent_Done,
      // Label 8115: @597724
      GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(597821), // Rule ID 5871 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[f32] } f32:{ *:[f32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN:{ *:[f32] } anonymous_9451:{ *:[f32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5871,
        GIR_EraseRootFromParent_Done,
      // Label 8116: @597821
      GIM_Reject,
    // Label 8084: @597822
    GIM_Reject,
    // Label 8082: @597823
    GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(599004),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(597911), // Rule ID 6064 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6064,
        GIR_EraseRootFromParent_Done,
      // Label 8118: @597911
      GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(597976), // Rule ID 6072 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6072,
        GIR_EraseRootFromParent_Done,
      // Label 8119: @597976
      GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(598048), // Rule ID 6060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6060,
        GIR_EraseRootFromParent_Done,
      // Label 8120: @598048
      GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(598117), // Rule ID 6068 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6068,
        GIR_EraseRootFromParent_Done,
      // Label 8121: @598117
      GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(598183), // Rule ID 6066 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6066,
        GIR_EraseRootFromParent_Done,
      // Label 8122: @598183
      GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(598246), // Rule ID 6074 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6074,
        GIR_EraseRootFromParent_Done,
      // Label 8123: @598246
      GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(598316), // Rule ID 6062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6062,
        GIR_EraseRootFromParent_Done,
      // Label 8124: @598316
      GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(598383), // Rule ID 6070 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6070,
        GIR_EraseRootFromParent_Done,
      // Label 8125: @598383
      GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(598441), // Rule ID 6065 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6065,
        GIR_EraseRootFromParent_Done,
      // Label 8126: @598441
      GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(598496), // Rule ID 6073 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6073,
        GIR_EraseRootFromParent_Done,
      // Label 8127: @598496
      GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(598558), // Rule ID 6061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6061,
        GIR_EraseRootFromParent_Done,
      // Label 8128: @598558
      GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(598617), // Rule ID 6069 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6069,
        GIR_EraseRootFromParent_Done,
      // Label 8129: @598617
      GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(598713), // Rule ID 6067 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6067,
        GIR_EraseRootFromParent_Done,
      // Label 8130: @598713
      GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(598806), // Rule ID 6075 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_swap_noret>>  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6075,
        GIR_EraseRootFromParent_Done,
      // Label 8131: @598806
      GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(598906), // Rule ID 6063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6063,
        GIR_EraseRootFromParent_Done,
      // Label 8132: @598906
      GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(599003), // Rule ID 6071 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_swap:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_SWAP_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6071,
        GIR_EraseRootFromParent_Done,
      // Label 8133: @599003
      GIM_Reject,
    // Label 8117: @599004
    GIM_Reject,
    // Label 8083: @599005
    GIM_Reject,
    // Label 122: @599006
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8136*/ GIMT_Encode4(601389),
    /*GILLT_s32*//*Label 8134*/ GIMT_Encode4(599025),
    /*GILLT_s64*//*Label 8135*/ GIMT_Encode4(600207),
    // Label 8134: @599025
    GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(600206),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(599113), // Rule ID 5960 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5960,
        GIR_EraseRootFromParent_Done,
      // Label 8138: @599113
      GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(599178), // Rule ID 5968 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5968,
        GIR_EraseRootFromParent_Done,
      // Label 8139: @599178
      GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(599250), // Rule ID 5956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5956,
        GIR_EraseRootFromParent_Done,
      // Label 8140: @599250
      GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(599319), // Rule ID 5964 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5964,
        GIR_EraseRootFromParent_Done,
      // Label 8141: @599319
      GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(599385), // Rule ID 5962 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5962,
        GIR_EraseRootFromParent_Done,
      // Label 8142: @599385
      GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(599448), // Rule ID 5970 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5970,
        GIR_EraseRootFromParent_Done,
      // Label 8143: @599448
      GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(599518), // Rule ID 5958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5958,
        GIR_EraseRootFromParent_Done,
      // Label 8144: @599518
      GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(599585), // Rule ID 5966 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5966,
        GIR_EraseRootFromParent_Done,
      // Label 8145: @599585
      GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(599643), // Rule ID 5961 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5961,
        GIR_EraseRootFromParent_Done,
      // Label 8146: @599643
      GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(599698), // Rule ID 5969 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5969,
        GIR_EraseRootFromParent_Done,
      // Label 8147: @599698
      GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(599760), // Rule ID 5957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5957,
        GIR_EraseRootFromParent_Done,
      // Label 8148: @599760
      GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(599819), // Rule ID 5965 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5965,
        GIR_EraseRootFromParent_Done,
      // Label 8149: @599819
      GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(599915), // Rule ID 5963 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5963,
        GIR_EraseRootFromParent_Done,
      // Label 8150: @599915
      GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(600008), // Rule ID 5971 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5971,
        GIR_EraseRootFromParent_Done,
      // Label 8151: @600008
      GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(600108), // Rule ID 5959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5959,
        GIR_EraseRootFromParent_Done,
      // Label 8152: @600108
      GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(600205), // Rule ID 5967 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5967,
        GIR_EraseRootFromParent_Done,
      // Label 8153: @600205
      GIM_Reject,
    // Label 8137: @600206
    GIM_Reject,
    // Label 8135: @600207
    GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(601388),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(600295), // Rule ID 6160 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6160,
        GIR_EraseRootFromParent_Done,
      // Label 8155: @600295
      GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(600360), // Rule ID 6168 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6168,
        GIR_EraseRootFromParent_Done,
      // Label 8156: @600360
      GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(600432), // Rule ID 6156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6156,
        GIR_EraseRootFromParent_Done,
      // Label 8157: @600432
      GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(600501), // Rule ID 6164 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6164,
        GIR_EraseRootFromParent_Done,
      // Label 8158: @600501
      GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(600567), // Rule ID 6162 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6162,
        GIR_EraseRootFromParent_Done,
      // Label 8159: @600567
      GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(600630), // Rule ID 6170 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6170,
        GIR_EraseRootFromParent_Done,
      // Label 8160: @600630
      GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(600700), // Rule ID 6158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6158,
        GIR_EraseRootFromParent_Done,
      // Label 8161: @600700
      GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(600767), // Rule ID 6166 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6166,
        GIR_EraseRootFromParent_Done,
      // Label 8162: @600767
      GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(600825), // Rule ID 6161 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6161,
        GIR_EraseRootFromParent_Done,
      // Label 8163: @600825
      GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(600880), // Rule ID 6169 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6169,
        GIR_EraseRootFromParent_Done,
      // Label 8164: @600880
      GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(600942), // Rule ID 6157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6157,
        GIR_EraseRootFromParent_Done,
      // Label 8165: @600942
      GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(601001), // Rule ID 6165 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6165,
        GIR_EraseRootFromParent_Done,
      // Label 8166: @601001
      GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(601097), // Rule ID 6163 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6163,
        GIR_EraseRootFromParent_Done,
      // Label 8167: @601097
      GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(601190), // Rule ID 6171 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umax_noret>>  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6171,
        GIR_EraseRootFromParent_Done,
      // Label 8168: @601190
      GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(601290), // Rule ID 6159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6159,
        GIR_EraseRootFromParent_Done,
      // Label 8169: @601290
      GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(601387), // Rule ID 6167 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umax:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMAX_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6167,
        GIR_EraseRootFromParent_Done,
      // Label 8170: @601387
      GIM_Reject,
    // Label 8154: @601388
    GIM_Reject,
    // Label 8136: @601389
    GIM_Reject,
    // Label 123: @601390
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8173*/ GIMT_Encode4(603773),
    /*GILLT_s32*//*Label 8171*/ GIMT_Encode4(601409),
    /*GILLT_s64*//*Label 8172*/ GIMT_Encode4(602591),
    // Label 8171: @601409
    GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(602590),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(601497), // Rule ID 5928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5928,
        GIR_EraseRootFromParent_Done,
      // Label 8175: @601497
      GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(601562), // Rule ID 5936 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5936,
        GIR_EraseRootFromParent_Done,
      // Label 8176: @601562
      GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(601634), // Rule ID 5924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5924,
        GIR_EraseRootFromParent_Done,
      // Label 8177: @601634
      GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(601703), // Rule ID 5932 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5932,
        GIR_EraseRootFromParent_Done,
      // Label 8178: @601703
      GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(601769), // Rule ID 5930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5930,
        GIR_EraseRootFromParent_Done,
      // Label 8179: @601769
      GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(601832), // Rule ID 5938 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5938,
        GIR_EraseRootFromParent_Done,
      // Label 8180: @601832
      GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(601902), // Rule ID 5926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5926,
        GIR_EraseRootFromParent_Done,
      // Label 8181: @601902
      GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(601969), // Rule ID 5934 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5934,
        GIR_EraseRootFromParent_Done,
      // Label 8182: @601969
      GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(602027), // Rule ID 5929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5929,
        GIR_EraseRootFromParent_Done,
      // Label 8183: @602027
      GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(602082), // Rule ID 5937 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5937,
        GIR_EraseRootFromParent_Done,
      // Label 8184: @602082
      GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(602144), // Rule ID 5925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5925,
        GIR_EraseRootFromParent_Done,
      // Label 8185: @602144
      GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(602203), // Rule ID 5933 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5933,
        GIR_EraseRootFromParent_Done,
      // Label 8186: @602203
      GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(602299), // Rule ID 5931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5931,
        GIR_EraseRootFromParent_Done,
      // Label 8187: @602299
      GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(602392), // Rule ID 5939 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5939,
        GIR_EraseRootFromParent_Done,
      // Label 8188: @602392
      GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(602492), // Rule ID 5927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5927,
        GIR_EraseRootFromParent_Done,
      // Label 8189: @602492
      GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(602589), // Rule ID 5935 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5935,
        GIR_EraseRootFromParent_Done,
      // Label 8190: @602589
      GIM_Reject,
    // Label 8174: @602590
    GIM_Reject,
    // Label 8172: @602591
    GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(603772),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(602679), // Rule ID 6128 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6128,
        GIR_EraseRootFromParent_Done,
      // Label 8192: @602679
      GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(602744), // Rule ID 6136 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6136,
        GIR_EraseRootFromParent_Done,
      // Label 8193: @602744
      GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(602816), // Rule ID 6124 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6124,
        GIR_EraseRootFromParent_Done,
      // Label 8194: @602816
      GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(602885), // Rule ID 6132 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6132,
        GIR_EraseRootFromParent_Done,
      // Label 8195: @602885
      GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(602951), // Rule ID 6130 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6130,
        GIR_EraseRootFromParent_Done,
      // Label 8196: @602951
      GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(603014), // Rule ID 6138 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6138,
        GIR_EraseRootFromParent_Done,
      // Label 8197: @603014
      GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(603084), // Rule ID 6126 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6126,
        GIR_EraseRootFromParent_Done,
      // Label 8198: @603084
      GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(603151), // Rule ID 6134 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6134,
        GIR_EraseRootFromParent_Done,
      // Label 8199: @603151
      GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(603209), // Rule ID 6129 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6129,
        GIR_EraseRootFromParent_Done,
      // Label 8200: @603209
      GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(603264), // Rule ID 6137 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6137,
        GIR_EraseRootFromParent_Done,
      // Label 8201: @603264
      GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(603326), // Rule ID 6125 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6125,
        GIR_EraseRootFromParent_Done,
      // Label 8202: @603326
      GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(603385), // Rule ID 6133 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6133,
        GIR_EraseRootFromParent_Done,
      // Label 8203: @603385
      GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(603481), // Rule ID 6131 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6131,
        GIR_EraseRootFromParent_Done,
      // Label 8204: @603481
      GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(603574), // Rule ID 6139 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_umin_noret>>  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6139,
        GIR_EraseRootFromParent_Done,
      // Label 8205: @603574
      GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(603674), // Rule ID 6127 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6127,
        GIR_EraseRootFromParent_Done,
      // Label 8206: @603674
      GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(603771), // Rule ID 6135 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_umin:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_UMIN_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6135,
        GIR_EraseRootFromParent_Done,
      // Label 8207: @603771
      GIM_Reject,
    // Label 8191: @603772
    GIM_Reject,
    // Label 8173: @603773
    GIM_Reject,
    // Label 124: @603774
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 8210*/ GIMT_Encode4(606157),
    /*GILLT_s32*//*Label 8208*/ GIMT_Encode4(603793),
    /*GILLT_s64*//*Label 8209*/ GIMT_Encode4(604975),
    // Label 8208: @603793
    GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(604974),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(603881), // Rule ID 6008 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6008,
        GIR_EraseRootFromParent_Done,
      // Label 8212: @603881
      GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(603946), // Rule ID 6016 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6016,
        GIR_EraseRootFromParent_Done,
      // Label 8213: @603946
      GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(604018), // Rule ID 6004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6004,
        GIR_EraseRootFromParent_Done,
      // Label 8214: @604018
      GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(604087), // Rule ID 6012 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6012,
        GIR_EraseRootFromParent_Done,
      // Label 8215: @604087
      GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(604153), // Rule ID 6010 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6010,
        GIR_EraseRootFromParent_Done,
      // Label 8216: @604153
      GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(604216), // Rule ID 6018 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6018,
        GIR_EraseRootFromParent_Done,
      // Label 8217: @604216
      GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(604286), // Rule ID 6006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6006,
        GIR_EraseRootFromParent_Done,
      // Label 8218: @604286
      GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(604353), // Rule ID 6014 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6014,
        GIR_EraseRootFromParent_Done,
      // Label 8219: @604353
      GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(604411), // Rule ID 6009 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6009,
        GIR_EraseRootFromParent_Done,
      // Label 8220: @604411
      GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(604466), // Rule ID 6017 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6017,
        GIR_EraseRootFromParent_Done,
      // Label 8221: @604466
      GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(604528), // Rule ID 6005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6005,
        GIR_EraseRootFromParent_Done,
      // Label 8222: @604528
      GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(604587), // Rule ID 6013 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6013,
        GIR_EraseRootFromParent_Done,
      // Label 8223: @604587
      GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(604683), // Rule ID 6011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6011,
        GIR_EraseRootFromParent_Done,
      // Label 8224: @604683
      GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(604776), // Rule ID 6019 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6019,
        GIR_EraseRootFromParent_Done,
      // Label 8225: @604776
      GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(604876), // Rule ID 6007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6007,
        GIR_EraseRootFromParent_Done,
      // Label 8226: @604876
      GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(604973), // Rule ID 6015 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i32] } i32:{ *:[i32] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN:{ *:[i32] } anonymous_9451:{ *:[i32] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6015,
        GIR_EraseRootFromParent_Done,
      // Label 8227: @604973
      GIM_Reject,
    // Label 8211: @604974
    GIM_Reject,
    // Label 8209: @604975
    GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(606156),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(605063), // Rule ID 6208 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6208,
        GIR_EraseRootFromParent_Done,
      // Label 8229: @605063
      GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(605128), // Rule ID 6216 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6216,
        GIR_EraseRootFromParent_Done,
      // Label 8230: @605128
      GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(605200), // Rule ID 6204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6204,
        GIR_EraseRootFromParent_Done,
      // Label 8231: @605200
      GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(605269), // Rule ID 6212 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFSET_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6212,
        GIR_EraseRootFromParent_Done,
      // Label 8232: @605269
      GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(605335), // Rule ID 6210 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6210,
        GIR_EraseRootFromParent_Done,
      // Label 8233: @605335
      GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(605398), // Rule ID 6218 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6218,
        GIR_EraseRootFromParent_Done,
      // Label 8234: @605398
      GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(605468), // Rule ID 6206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6206,
        GIR_EraseRootFromParent_Done,
      // Label 8235: @605468
      GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(605535), // Rule ID 6214 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_OFFEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/4, // voffset
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6214,
        GIR_EraseRootFromParent_Done,
      // Label 8236: @605535
      GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(605593), // Rule ID 6209 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6209,
        GIR_EraseRootFromParent_Done,
      // Label 8237: @605593
      GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(605648), // Rule ID 6217 //
        GIM_CheckHasNoUse, /*MI*/0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6217,
        GIR_EraseRootFromParent_Done,
      // Label 8238: @605648
      GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(605710), // Rule ID 6205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6205,
        GIR_EraseRootFromParent_Done,
      // Label 8239: @605710
      GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(605769), // Rule ID 6213 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_IDXEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_RootToRootCopy, /*OpIdx*/3, // vindex
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6213,
        GIR_EraseRootFromParent_Done,
      // Label 8240: @605769
      GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(605865), // Rule ID 6211 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6211,
        GIR_EraseRootFromParent_Done,
      // Label 8241: @605865
      GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(605958), // Rule ID 6219 //
        GIM_CheckHasNoUse, /*MI*/0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_SIbuffer_atomic_xor_noret>>  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6219,
        GIR_EraseRootFromParent_Done,
      // Label 8242: @605958
      GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(606058), // Rule ID 6207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6207,
        GIR_EraseRootFromParent_Done,
      // Label 8243: @606058
      GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(606155), // Rule ID 6215 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_atomic_xor:{ *:[i64] } i64:{ *:[i64] }:$vdata_in, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN:{ *:[i64] } anonymous_9450:{ *:[i64] }:$vdata_in, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol_set_glc:{ *:[i32] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_ATOMIC_XOR_X2_VBUFFER_BOTHEN_RTN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // vdata_in
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/2, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/6, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCpolSetGLC), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6215,
        GIR_EraseRootFromParent_Done,
      // Label 8244: @606155
      GIM_Reject,
    // Label 8228: @606156
    GIM_Reject,
    // Label 8210: @606157
    GIM_Reject,
    // Label 125: @606158
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 8261*/ GIMT_Encode4(623317),
    /*GILLT_p0s64*//*Label 8245*/ GIMT_Encode4(606261),
    /*GILLT_p1s64*//*Label 8246*/ GIMT_Encode4(606880),
    /*GILLT_p2s32*//*Label 8247*/ GIMT_Encode4(607499),
    /*GILLT_p3s32*//*Label 8248*/ GIMT_Encode4(608118),
    /*GILLT_p4s64*//*Label 8249*/ GIMT_Encode4(608737),
    /*GILLT_p5s32*//*Label 8250*/ GIMT_Encode4(609356),
    /*GILLT_p6s32*//*Label 8251*/ GIMT_Encode4(609975), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_s32*//*Label 8252*/ GIMT_Encode4(610594),
    /*GILLT_s64*//*Label 8253*/ GIMT_Encode4(611809),
    /*GILLT_v2s16*//*Label 8254*/ GIMT_Encode4(613024),
    /*GILLT_v2s32*//*Label 8255*/ GIMT_Encode4(614835),
    /*GILLT_v2s64*//*Label 8256*/ GIMT_Encode4(616050),
    /*GILLT_v3s32*//*Label 8257*/ GIMT_Encode4(617265), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 8258*/ GIMT_Encode4(618480),
    /*GILLT_v4s32*//*Label 8259*/ GIMT_Encode4(620291), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8260*/ GIMT_Encode4(621506),
    // Label 8245: @606261
    GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(606879),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(606354), // Rule ID 4980 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4980,
        GIR_EraseRootFromParent_Done,
      // Label 8263: @606354
      GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(606423), // Rule ID 4984 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4984,
        GIR_EraseRootFromParent_Done,
      // Label 8264: @606423
      GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(606493), // Rule ID 4981 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4981,
        GIR_EraseRootFromParent_Done,
      // Label 8265: @606493
      GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(606560), // Rule ID 4985 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4985,
        GIR_EraseRootFromParent_Done,
      // Label 8266: @606560
      GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(606622), // Rule ID 4982 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4982,
        GIR_EraseRootFromParent_Done,
      // Label 8267: @606622
      GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(606681), // Rule ID 4986 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4986,
        GIR_EraseRootFromParent_Done,
      // Label 8268: @606681
      GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(606781), // Rule ID 4983 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4983,
        GIR_EraseRootFromParent_Done,
      // Label 8269: @606781
      GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(606878), // Rule ID 4987 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4987,
        GIR_EraseRootFromParent_Done,
      // Label 8270: @606878
      GIM_Reject,
    // Label 8262: @606879
    GIM_Reject,
    // Label 8246: @606880
    GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(607498),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(606973), // Rule ID 4988 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4988,
        GIR_EraseRootFromParent_Done,
      // Label 8272: @606973
      GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(607042), // Rule ID 4992 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4992,
        GIR_EraseRootFromParent_Done,
      // Label 8273: @607042
      GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(607112), // Rule ID 4989 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4989,
        GIR_EraseRootFromParent_Done,
      // Label 8274: @607112
      GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(607179), // Rule ID 4993 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4993,
        GIR_EraseRootFromParent_Done,
      // Label 8275: @607179
      GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(607241), // Rule ID 4990 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4990,
        GIR_EraseRootFromParent_Done,
      // Label 8276: @607241
      GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(607300), // Rule ID 4994 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4994,
        GIR_EraseRootFromParent_Done,
      // Label 8277: @607300
      GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(607400), // Rule ID 4991 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4991,
        GIR_EraseRootFromParent_Done,
      // Label 8278: @607400
      GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(607497), // Rule ID 4995 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4995,
        GIR_EraseRootFromParent_Done,
      // Label 8279: @607497
      GIM_Reject,
    // Label 8271: @607498
    GIM_Reject,
    // Label 8247: @607499
    GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(608117),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(607592), // Rule ID 4916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4916,
        GIR_EraseRootFromParent_Done,
      // Label 8281: @607592
      GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(607661), // Rule ID 4920 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4920,
        GIR_EraseRootFromParent_Done,
      // Label 8282: @607661
      GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(607731), // Rule ID 4917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4917,
        GIR_EraseRootFromParent_Done,
      // Label 8283: @607731
      GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(607798), // Rule ID 4921 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4921,
        GIR_EraseRootFromParent_Done,
      // Label 8284: @607798
      GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(607860), // Rule ID 4918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4918,
        GIR_EraseRootFromParent_Done,
      // Label 8285: @607860
      GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(607919), // Rule ID 4922 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4922,
        GIR_EraseRootFromParent_Done,
      // Label 8286: @607919
      GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(608019), // Rule ID 4919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4919,
        GIR_EraseRootFromParent_Done,
      // Label 8287: @608019
      GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(608116), // Rule ID 4923 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4923,
        GIR_EraseRootFromParent_Done,
      // Label 8288: @608116
      GIM_Reject,
    // Label 8280: @608117
    GIM_Reject,
    // Label 8248: @608118
    GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(608736),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(608211), // Rule ID 4924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4924,
        GIR_EraseRootFromParent_Done,
      // Label 8290: @608211
      GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(608280), // Rule ID 4928 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4928,
        GIR_EraseRootFromParent_Done,
      // Label 8291: @608280
      GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(608350), // Rule ID 4925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4925,
        GIR_EraseRootFromParent_Done,
      // Label 8292: @608350
      GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(608417), // Rule ID 4929 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4929,
        GIR_EraseRootFromParent_Done,
      // Label 8293: @608417
      GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(608479), // Rule ID 4926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4926,
        GIR_EraseRootFromParent_Done,
      // Label 8294: @608479
      GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(608538), // Rule ID 4930 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4930,
        GIR_EraseRootFromParent_Done,
      // Label 8295: @608538
      GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(608638), // Rule ID 4927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4927,
        GIR_EraseRootFromParent_Done,
      // Label 8296: @608638
      GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(608735), // Rule ID 4931 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4931,
        GIR_EraseRootFromParent_Done,
      // Label 8297: @608735
      GIM_Reject,
    // Label 8289: @608736
    GIM_Reject,
    // Label 8249: @608737
    GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(609355),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(608830), // Rule ID 4996 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4996,
        GIR_EraseRootFromParent_Done,
      // Label 8299: @608830
      GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(608899), // Rule ID 5000 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5000,
        GIR_EraseRootFromParent_Done,
      // Label 8300: @608899
      GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(608969), // Rule ID 4997 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4997,
        GIR_EraseRootFromParent_Done,
      // Label 8301: @608969
      GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(609036), // Rule ID 5001 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5001,
        GIR_EraseRootFromParent_Done,
      // Label 8302: @609036
      GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(609098), // Rule ID 4998 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4998,
        GIR_EraseRootFromParent_Done,
      // Label 8303: @609098
      GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(609157), // Rule ID 5002 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5002,
        GIR_EraseRootFromParent_Done,
      // Label 8304: @609157
      GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(609257), // Rule ID 4999 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4999,
        GIR_EraseRootFromParent_Done,
      // Label 8305: @609257
      GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(609354), // Rule ID 5003 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5003,
        GIR_EraseRootFromParent_Done,
      // Label 8306: @609354
      GIM_Reject,
    // Label 8298: @609355
    GIM_Reject,
    // Label 8250: @609356
    GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(609974),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(609449), // Rule ID 4932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4932,
        GIR_EraseRootFromParent_Done,
      // Label 8308: @609449
      GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(609518), // Rule ID 4936 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4936,
        GIR_EraseRootFromParent_Done,
      // Label 8309: @609518
      GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(609588), // Rule ID 4933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4933,
        GIR_EraseRootFromParent_Done,
      // Label 8310: @609588
      GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(609655), // Rule ID 4937 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4937,
        GIR_EraseRootFromParent_Done,
      // Label 8311: @609655
      GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(609717), // Rule ID 4934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4934,
        GIR_EraseRootFromParent_Done,
      // Label 8312: @609717
      GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(609776), // Rule ID 4938 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4938,
        GIR_EraseRootFromParent_Done,
      // Label 8313: @609776
      GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(609876), // Rule ID 4935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4935,
        GIR_EraseRootFromParent_Done,
      // Label 8314: @609876
      GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(609973), // Rule ID 4939 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4939,
        GIR_EraseRootFromParent_Done,
      // Label 8315: @609973
      GIM_Reject,
    // Label 8307: @609974
    GIM_Reject,
    // Label 8251: @609975
    GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(610593),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(610068), // Rule ID 4940 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4940,
        GIR_EraseRootFromParent_Done,
      // Label 8317: @610068
      GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(610137), // Rule ID 4944 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4944,
        GIR_EraseRootFromParent_Done,
      // Label 8318: @610137
      GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(610207), // Rule ID 4941 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4941,
        GIR_EraseRootFromParent_Done,
      // Label 8319: @610207
      GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(610274), // Rule ID 4945 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4945,
        GIR_EraseRootFromParent_Done,
      // Label 8320: @610274
      GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(610336), // Rule ID 4942 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4942,
        GIR_EraseRootFromParent_Done,
      // Label 8321: @610336
      GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(610395), // Rule ID 4946 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4946,
        GIR_EraseRootFromParent_Done,
      // Label 8322: @610395
      GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(610495), // Rule ID 4943 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4943,
        GIR_EraseRootFromParent_Done,
      // Label 8323: @610495
      GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(610592), // Rule ID 4947 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4947,
        GIR_EraseRootFromParent_Done,
      // Label 8324: @610592
      GIM_Reject,
    // Label 8316: @610593
    GIM_Reject,
    // Label 8252: @610594
    GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(611808),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(610687), // Rule ID 4876 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4876,
        GIR_EraseRootFromParent_Done,
      // Label 8326: @610687
      GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(610756), // Rule ID 4880 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4880,
        GIR_EraseRootFromParent_Done,
      // Label 8327: @610756
      GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(610828), // Rule ID 4884 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4884,
        GIR_EraseRootFromParent_Done,
      // Label 8328: @610828
      GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(610897), // Rule ID 4888 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4888,
        GIR_EraseRootFromParent_Done,
      // Label 8329: @610897
      GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(610967), // Rule ID 4877 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4877,
        GIR_EraseRootFromParent_Done,
      // Label 8330: @610967
      GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(611034), // Rule ID 4881 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4881,
        GIR_EraseRootFromParent_Done,
      // Label 8331: @611034
      GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(611104), // Rule ID 4885 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4885,
        GIR_EraseRootFromParent_Done,
      // Label 8332: @611104
      GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(611171), // Rule ID 4889 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4889,
        GIR_EraseRootFromParent_Done,
      // Label 8333: @611171
      GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(611233), // Rule ID 4878 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4878,
        GIR_EraseRootFromParent_Done,
      // Label 8334: @611233
      GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(611292), // Rule ID 4882 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4882,
        GIR_EraseRootFromParent_Done,
      // Label 8335: @611292
      GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(611354), // Rule ID 4886 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4886,
        GIR_EraseRootFromParent_Done,
      // Label 8336: @611354
      GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(611413), // Rule ID 4890 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4890,
        GIR_EraseRootFromParent_Done,
      // Label 8337: @611413
      GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(611513), // Rule ID 4879 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4879,
        GIR_EraseRootFromParent_Done,
      // Label 8338: @611513
      GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(611610), // Rule ID 4883 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4883,
        GIR_EraseRootFromParent_Done,
      // Label 8339: @611610
      GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(611710), // Rule ID 4887 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4887,
        GIR_EraseRootFromParent_Done,
      // Label 8340: @611710
      GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(611807), // Rule ID 4891 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4891,
        GIR_EraseRootFromParent_Done,
      // Label 8341: @611807
      GIM_Reject,
    // Label 8325: @611808
    GIM_Reject,
    // Label 8253: @611809
    GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(613023),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(611902), // Rule ID 4948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4948,
        GIR_EraseRootFromParent_Done,
      // Label 8343: @611902
      GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(611971), // Rule ID 4952 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4952,
        GIR_EraseRootFromParent_Done,
      // Label 8344: @611971
      GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(612043), // Rule ID 4956 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4956,
        GIR_EraseRootFromParent_Done,
      // Label 8345: @612043
      GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(612112), // Rule ID 4960 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4960,
        GIR_EraseRootFromParent_Done,
      // Label 8346: @612112
      GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(612182), // Rule ID 4949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4949,
        GIR_EraseRootFromParent_Done,
      // Label 8347: @612182
      GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(612249), // Rule ID 4953 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4953,
        GIR_EraseRootFromParent_Done,
      // Label 8348: @612249
      GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(612319), // Rule ID 4957 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4957,
        GIR_EraseRootFromParent_Done,
      // Label 8349: @612319
      GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(612386), // Rule ID 4961 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4961,
        GIR_EraseRootFromParent_Done,
      // Label 8350: @612386
      GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(612448), // Rule ID 4950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4950,
        GIR_EraseRootFromParent_Done,
      // Label 8351: @612448
      GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(612507), // Rule ID 4954 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4954,
        GIR_EraseRootFromParent_Done,
      // Label 8352: @612507
      GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(612569), // Rule ID 4958 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4958,
        GIR_EraseRootFromParent_Done,
      // Label 8353: @612569
      GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(612628), // Rule ID 4962 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4962,
        GIR_EraseRootFromParent_Done,
      // Label 8354: @612628
      GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(612728), // Rule ID 4951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4951,
        GIR_EraseRootFromParent_Done,
      // Label 8355: @612728
      GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(612825), // Rule ID 4955 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4955,
        GIR_EraseRootFromParent_Done,
      // Label 8356: @612825
      GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(612925), // Rule ID 4959 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4959,
        GIR_EraseRootFromParent_Done,
      // Label 8357: @612925
      GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(613022), // Rule ID 4963 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4963,
        GIR_EraseRootFromParent_Done,
      // Label 8358: @613022
      GIM_Reject,
    // Label 8342: @613023
    GIM_Reject,
    // Label 8254: @613024
    GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(614834),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(613117), // Rule ID 4892 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4892,
        GIR_EraseRootFromParent_Done,
      // Label 8360: @613117
      GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(613186), // Rule ID 4896 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4896,
        GIR_EraseRootFromParent_Done,
      // Label 8361: @613186
      GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(613258), // Rule ID 4900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4900,
        GIR_EraseRootFromParent_Done,
      // Label 8362: @613258
      GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(613327), // Rule ID 4904 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4904,
        GIR_EraseRootFromParent_Done,
      // Label 8363: @613327
      GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(613399), // Rule ID 4908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFSET:{ *:[v2bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4908,
        GIR_EraseRootFromParent_Done,
      // Label 8364: @613399
      GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(613468), // Rule ID 4912 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFSET:{ *:[v2bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4912,
        GIR_EraseRootFromParent_Done,
      // Label 8365: @613468
      GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(613538), // Rule ID 4893 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4893,
        GIR_EraseRootFromParent_Done,
      // Label 8366: @613538
      GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(613605), // Rule ID 4897 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4897,
        GIR_EraseRootFromParent_Done,
      // Label 8367: @613605
      GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(613675), // Rule ID 4901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4901,
        GIR_EraseRootFromParent_Done,
      // Label 8368: @613675
      GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(613742), // Rule ID 4905 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4905,
        GIR_EraseRootFromParent_Done,
      // Label 8369: @613742
      GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(613812), // Rule ID 4909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_OFFEN:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4909,
        GIR_EraseRootFromParent_Done,
      // Label 8370: @613812
      GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(613879), // Rule ID 4913 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_VBUFFER_OFFEN:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4913,
        GIR_EraseRootFromParent_Done,
      // Label 8371: @613879
      GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(613941), // Rule ID 4894 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4894,
        GIR_EraseRootFromParent_Done,
      // Label 8372: @613941
      GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(614000), // Rule ID 4898 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4898,
        GIR_EraseRootFromParent_Done,
      // Label 8373: @614000
      GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(614062), // Rule ID 4902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4902,
        GIR_EraseRootFromParent_Done,
      // Label 8374: @614062
      GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(614121), // Rule ID 4906 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4906,
        GIR_EraseRootFromParent_Done,
      // Label 8375: @614121
      GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(614183), // Rule ID 4910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_IDXEN:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4910,
        GIR_EraseRootFromParent_Done,
      // Label 8376: @614183
      GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(614242), // Rule ID 4914 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_IDXEN:{ *:[v2bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4914,
        GIR_EraseRootFromParent_Done,
      // Label 8377: @614242
      GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(614342), // Rule ID 4895 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4895,
        GIR_EraseRootFromParent_Done,
      // Label 8378: @614342
      GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(614439), // Rule ID 4899 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4899,
        GIR_EraseRootFromParent_Done,
      // Label 8379: @614439
      GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(614539), // Rule ID 4903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4903,
        GIR_EraseRootFromParent_Done,
      // Label 8380: @614539
      GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(614636), // Rule ID 4907 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4907,
        GIR_EraseRootFromParent_Done,
      // Label 8381: @614636
      GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(614736), // Rule ID 4911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_BOTHEN:{ *:[v2bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4911,
        GIR_EraseRootFromParent_Done,
      // Label 8382: @614736
      GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(614833), // Rule ID 4915 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_VBUFFER_BOTHEN:{ *:[v2bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4915,
        GIR_EraseRootFromParent_Done,
      // Label 8383: @614833
      GIM_Reject,
    // Label 8359: @614834
    GIM_Reject,
    // Label 8255: @614835
    GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(616049),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(614928), // Rule ID 4964 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4964,
        GIR_EraseRootFromParent_Done,
      // Label 8385: @614928
      GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(614997), // Rule ID 4968 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4968,
        GIR_EraseRootFromParent_Done,
      // Label 8386: @614997
      GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(615069), // Rule ID 4972 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4972,
        GIR_EraseRootFromParent_Done,
      // Label 8387: @615069
      GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(615138), // Rule ID 4976 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4976,
        GIR_EraseRootFromParent_Done,
      // Label 8388: @615138
      GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(615208), // Rule ID 4965 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4965,
        GIR_EraseRootFromParent_Done,
      // Label 8389: @615208
      GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(615275), // Rule ID 4969 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4969,
        GIR_EraseRootFromParent_Done,
      // Label 8390: @615275
      GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(615345), // Rule ID 4973 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4973,
        GIR_EraseRootFromParent_Done,
      // Label 8391: @615345
      GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(615412), // Rule ID 4977 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4977,
        GIR_EraseRootFromParent_Done,
      // Label 8392: @615412
      GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(615474), // Rule ID 4966 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4966,
        GIR_EraseRootFromParent_Done,
      // Label 8393: @615474
      GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(615533), // Rule ID 4970 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4970,
        GIR_EraseRootFromParent_Done,
      // Label 8394: @615533
      GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(615595), // Rule ID 4974 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4974,
        GIR_EraseRootFromParent_Done,
      // Label 8395: @615595
      GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(615654), // Rule ID 4978 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4978,
        GIR_EraseRootFromParent_Done,
      // Label 8396: @615654
      GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(615754), // Rule ID 4967 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4967,
        GIR_EraseRootFromParent_Done,
      // Label 8397: @615754
      GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(615851), // Rule ID 4971 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4971,
        GIR_EraseRootFromParent_Done,
      // Label 8398: @615851
      GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(615951), // Rule ID 4975 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4975,
        GIR_EraseRootFromParent_Done,
      // Label 8399: @615951
      GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(616048), // Rule ID 4979 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4979,
        GIR_EraseRootFromParent_Done,
      // Label 8400: @616048
      GIM_Reject,
    // Label 8384: @616049
    GIM_Reject,
    // Label 8256: @616050
    GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(617264),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(616143), // Rule ID 5060 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5060,
        GIR_EraseRootFromParent_Done,
      // Label 8402: @616143
      GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(616212), // Rule ID 5064 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2i64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5064,
        GIR_EraseRootFromParent_Done,
      // Label 8403: @616212
      GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(616284), // Rule ID 5068 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5068,
        GIR_EraseRootFromParent_Done,
      // Label 8404: @616284
      GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(616353), // Rule ID 5072 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v2f64] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5072,
        GIR_EraseRootFromParent_Done,
      // Label 8405: @616353
      GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(616423), // Rule ID 5061 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5061,
        GIR_EraseRootFromParent_Done,
      // Label 8406: @616423
      GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(616490), // Rule ID 5065 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5065,
        GIR_EraseRootFromParent_Done,
      // Label 8407: @616490
      GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(616560), // Rule ID 5069 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5069,
        GIR_EraseRootFromParent_Done,
      // Label 8408: @616560
      GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(616627), // Rule ID 5073 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5073,
        GIR_EraseRootFromParent_Done,
      // Label 8409: @616627
      GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(616689), // Rule ID 5062 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5062,
        GIR_EraseRootFromParent_Done,
      // Label 8410: @616689
      GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(616748), // Rule ID 5066 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2i64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5066,
        GIR_EraseRootFromParent_Done,
      // Label 8411: @616748
      GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(616810), // Rule ID 5070 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5070,
        GIR_EraseRootFromParent_Done,
      // Label 8412: @616810
      GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(616869), // Rule ID 5074 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v2f64] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5074,
        GIR_EraseRootFromParent_Done,
      // Label 8413: @616869
      GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(616969), // Rule ID 5063 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5063,
        GIR_EraseRootFromParent_Done,
      // Label 8414: @616969
      GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(617066), // Rule ID 5067 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2i64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5067,
        GIR_EraseRootFromParent_Done,
      // Label 8415: @617066
      GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(617166), // Rule ID 5071 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5071,
        GIR_EraseRootFromParent_Done,
      // Label 8416: @617166
      GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(617263), // Rule ID 5075 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v2f64] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5075,
        GIR_EraseRootFromParent_Done,
      // Label 8417: @617263
      GIM_Reject,
    // Label 8401: @617264
    GIM_Reject,
    // Label 8257: @617265
    GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(618479),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(617358), // Rule ID 5028 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5028,
        GIR_EraseRootFromParent_Done,
      // Label 8419: @617358
      GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(617427), // Rule ID 5032 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5032,
        GIR_EraseRootFromParent_Done,
      // Label 8420: @617427
      GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(617499), // Rule ID 5036 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5036,
        GIR_EraseRootFromParent_Done,
      // Label 8421: @617499
      GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(617568), // Rule ID 5040 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5040,
        GIR_EraseRootFromParent_Done,
      // Label 8422: @617568
      GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(617638), // Rule ID 5029 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5029,
        GIR_EraseRootFromParent_Done,
      // Label 8423: @617638
      GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(617705), // Rule ID 5033 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5033,
        GIR_EraseRootFromParent_Done,
      // Label 8424: @617705
      GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(617775), // Rule ID 5037 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5037,
        GIR_EraseRootFromParent_Done,
      // Label 8425: @617775
      GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(617842), // Rule ID 5041 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5041,
        GIR_EraseRootFromParent_Done,
      // Label 8426: @617842
      GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(617904), // Rule ID 5030 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5030,
        GIR_EraseRootFromParent_Done,
      // Label 8427: @617904
      GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(617963), // Rule ID 5034 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5034,
        GIR_EraseRootFromParent_Done,
      // Label 8428: @617963
      GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(618025), // Rule ID 5038 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5038,
        GIR_EraseRootFromParent_Done,
      // Label 8429: @618025
      GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(618084), // Rule ID 5042 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5042,
        GIR_EraseRootFromParent_Done,
      // Label 8430: @618084
      GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(618184), // Rule ID 5031 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5031,
        GIR_EraseRootFromParent_Done,
      // Label 8431: @618184
      GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(618281), // Rule ID 5035 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5035,
        GIR_EraseRootFromParent_Done,
      // Label 8432: @618281
      GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(618381), // Rule ID 5039 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5039,
        GIR_EraseRootFromParent_Done,
      // Label 8433: @618381
      GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(618478), // Rule ID 5043 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5043,
        GIR_EraseRootFromParent_Done,
      // Label 8434: @618478
      GIM_Reject,
    // Label 8418: @618479
    GIM_Reject,
    // Label 8258: @618480
    GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(620290),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(618573), // Rule ID 5004 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5004,
        GIR_EraseRootFromParent_Done,
      // Label 8436: @618573
      GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(618642), // Rule ID 5008 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5008,
        GIR_EraseRootFromParent_Done,
      // Label 8437: @618642
      GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(618714), // Rule ID 5012 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5012,
        GIR_EraseRootFromParent_Done,
      // Label 8438: @618714
      GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(618783), // Rule ID 5016 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5016,
        GIR_EraseRootFromParent_Done,
      // Label 8439: @618783
      GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(618855), // Rule ID 5020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFSET:{ *:[v4bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5020,
        GIR_EraseRootFromParent_Done,
      // Label 8440: @618855
      GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(618924), // Rule ID 5024 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET:{ *:[v4bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5024,
        GIR_EraseRootFromParent_Done,
      // Label 8441: @618924
      GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(618994), // Rule ID 5005 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5005,
        GIR_EraseRootFromParent_Done,
      // Label 8442: @618994
      GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(619061), // Rule ID 5009 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5009,
        GIR_EraseRootFromParent_Done,
      // Label 8443: @619061
      GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(619131), // Rule ID 5013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5013,
        GIR_EraseRootFromParent_Done,
      // Label 8444: @619131
      GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(619198), // Rule ID 5017 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5017,
        GIR_EraseRootFromParent_Done,
      // Label 8445: @619198
      GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(619268), // Rule ID 5021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_OFFEN:{ *:[v4bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5021,
        GIR_EraseRootFromParent_Done,
      // Label 8446: @619268
      GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(619335), // Rule ID 5025 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN:{ *:[v4bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5025,
        GIR_EraseRootFromParent_Done,
      // Label 8447: @619335
      GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(619397), // Rule ID 5006 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5006,
        GIR_EraseRootFromParent_Done,
      // Label 8448: @619397
      GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(619456), // Rule ID 5010 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5010,
        GIR_EraseRootFromParent_Done,
      // Label 8449: @619456
      GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(619518), // Rule ID 5014 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5014,
        GIR_EraseRootFromParent_Done,
      // Label 8450: @619518
      GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(619577), // Rule ID 5018 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5018,
        GIR_EraseRootFromParent_Done,
      // Label 8451: @619577
      GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(619639), // Rule ID 5022 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_IDXEN:{ *:[v4bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5022,
        GIR_EraseRootFromParent_Done,
      // Label 8452: @619639
      GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(619698), // Rule ID 5026 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN:{ *:[v4bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5026,
        GIR_EraseRootFromParent_Done,
      // Label 8453: @619698
      GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(619798), // Rule ID 5007 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5007,
        GIR_EraseRootFromParent_Done,
      // Label 8454: @619798
      GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(619895), // Rule ID 5011 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5011,
        GIR_EraseRootFromParent_Done,
      // Label 8455: @619895
      GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(619995), // Rule ID 5015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5015,
        GIR_EraseRootFromParent_Done,
      // Label 8456: @619995
      GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(620092), // Rule ID 5019 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5019,
        GIR_EraseRootFromParent_Done,
      // Label 8457: @620092
      GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(620192), // Rule ID 5023 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_BOTHEN:{ *:[v4bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5023,
        GIR_EraseRootFromParent_Done,
      // Label 8458: @620192
      GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(620289), // Rule ID 5027 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN:{ *:[v4bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5027,
        GIR_EraseRootFromParent_Done,
      // Label 8459: @620289
      GIM_Reject,
    // Label 8435: @620290
    GIM_Reject,
    // Label 8259: @620291
    GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(621505),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(620384), // Rule ID 5044 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5044,
        GIR_EraseRootFromParent_Done,
      // Label 8461: @620384
      GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(620453), // Rule ID 5048 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5048,
        GIR_EraseRootFromParent_Done,
      // Label 8462: @620453
      GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(620525), // Rule ID 5052 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5052,
        GIR_EraseRootFromParent_Done,
      // Label 8463: @620525
      GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(620594), // Rule ID 5056 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5056,
        GIR_EraseRootFromParent_Done,
      // Label 8464: @620594
      GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(620664), // Rule ID 5045 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5045,
        GIR_EraseRootFromParent_Done,
      // Label 8465: @620664
      GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(620731), // Rule ID 5049 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5049,
        GIR_EraseRootFromParent_Done,
      // Label 8466: @620731
      GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(620801), // Rule ID 5053 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5053,
        GIR_EraseRootFromParent_Done,
      // Label 8467: @620801
      GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(620868), // Rule ID 5057 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5057,
        GIR_EraseRootFromParent_Done,
      // Label 8468: @620868
      GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(620930), // Rule ID 5046 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5046,
        GIR_EraseRootFromParent_Done,
      // Label 8469: @620930
      GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(620989), // Rule ID 5050 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5050,
        GIR_EraseRootFromParent_Done,
      // Label 8470: @620989
      GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(621051), // Rule ID 5054 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5054,
        GIR_EraseRootFromParent_Done,
      // Label 8471: @621051
      GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(621110), // Rule ID 5058 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5058,
        GIR_EraseRootFromParent_Done,
      // Label 8472: @621110
      GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(621210), // Rule ID 5047 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5047,
        GIR_EraseRootFromParent_Done,
      // Label 8473: @621210
      GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(621307), // Rule ID 5051 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5051,
        GIR_EraseRootFromParent_Done,
      // Label 8474: @621307
      GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(621407), // Rule ID 5055 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5055,
        GIR_EraseRootFromParent_Done,
      // Label 8475: @621407
      GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(621504), // Rule ID 5059 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5059,
        GIR_EraseRootFromParent_Done,
      // Label 8476: @621504
      GIM_Reject,
    // Label 8460: @621505
    GIM_Reject,
    // Label 8260: @621506
    GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(623316),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(621599), // Rule ID 5076 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5076,
        GIR_EraseRootFromParent_Done,
      // Label 8478: @621599
      GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(621668), // Rule ID 5080 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5080,
        GIR_EraseRootFromParent_Done,
      // Label 8479: @621668
      GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(621740), // Rule ID 5084 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5084,
        GIR_EraseRootFromParent_Done,
      // Label 8480: @621740
      GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(621809), // Rule ID 5088 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5088,
        GIR_EraseRootFromParent_Done,
      // Label 8481: @621809
      GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(621881), // Rule ID 5092 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFSET:{ *:[v8bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5092,
        GIR_EraseRootFromParent_Done,
      // Label 8482: @621881
      GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(621950), // Rule ID 5096 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET:{ *:[v8bf16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5096,
        GIR_EraseRootFromParent_Done,
      // Label 8483: @621950
      GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(622020), // Rule ID 5077 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5077,
        GIR_EraseRootFromParent_Done,
      // Label 8484: @622020
      GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(622087), // Rule ID 5081 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5081,
        GIR_EraseRootFromParent_Done,
      // Label 8485: @622087
      GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(622157), // Rule ID 5085 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5085,
        GIR_EraseRootFromParent_Done,
      // Label 8486: @622157
      GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(622224), // Rule ID 5089 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5089,
        GIR_EraseRootFromParent_Done,
      // Label 8487: @622224
      GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(622294), // Rule ID 5093 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_OFFEN:{ *:[v8bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5093,
        GIR_EraseRootFromParent_Done,
      // Label 8488: @622294
      GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(622361), // Rule ID 5097 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN:{ *:[v8bf16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5097,
        GIR_EraseRootFromParent_Done,
      // Label 8489: @622361
      GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(622423), // Rule ID 5078 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5078,
        GIR_EraseRootFromParent_Done,
      // Label 8490: @622423
      GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(622482), // Rule ID 5082 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5082,
        GIR_EraseRootFromParent_Done,
      // Label 8491: @622482
      GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(622544), // Rule ID 5086 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5086,
        GIR_EraseRootFromParent_Done,
      // Label 8492: @622544
      GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(622603), // Rule ID 5090 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5090,
        GIR_EraseRootFromParent_Done,
      // Label 8493: @622603
      GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(622665), // Rule ID 5094 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_IDXEN:{ *:[v8bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5094,
        GIR_EraseRootFromParent_Done,
      // Label 8494: @622665
      GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(622724), // Rule ID 5098 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN:{ *:[v8bf16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5098,
        GIR_EraseRootFromParent_Done,
      // Label 8495: @622724
      GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(622824), // Rule ID 5079 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5079,
        GIR_EraseRootFromParent_Done,
      // Label 8496: @622824
      GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(622921), // Rule ID 5083 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5083,
        GIR_EraseRootFromParent_Done,
      // Label 8497: @622921
      GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(623021), // Rule ID 5087 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5087,
        GIR_EraseRootFromParent_Done,
      // Label 8498: @623021
      GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(623118), // Rule ID 5091 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5091,
        GIR_EraseRootFromParent_Done,
      // Label 8499: @623118
      GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(623218), // Rule ID 5095 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_BOTHEN:{ *:[v8bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5095,
        GIR_EraseRootFromParent_Done,
      // Label 8500: @623218
      GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(623315), // Rule ID 5099 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load:{ *:[v8bf16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN:{ *:[v8bf16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5099,
        GIR_EraseRootFromParent_Done,
      // Label 8501: @623315
      GIM_Reject,
    // Label 8477: @623316
    GIM_Reject,
    // Label 8261: @623317
    GIM_Reject,
    // Label 126: @623318
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 8506*/ GIMT_Encode4(628225),
    /*GILLT_s32*//*Label 8502*/ GIMT_Encode4(623365), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 8503*/ GIMT_Encode4(624580), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 8504*/ GIMT_Encode4(625795), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8505*/ GIMT_Encode4(627010),
    // Label 8502: @623365
    GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(624579),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(623458), // Rule ID 4684 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4684,
        GIR_EraseRootFromParent_Done,
      // Label 8508: @623458
      GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(623527), // Rule ID 4688 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4688,
        GIR_EraseRootFromParent_Done,
      // Label 8509: @623527
      GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(623599), // Rule ID 4692 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4692,
        GIR_EraseRootFromParent_Done,
      // Label 8510: @623599
      GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(623668), // Rule ID 4696 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4696,
        GIR_EraseRootFromParent_Done,
      // Label 8511: @623668
      GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(623738), // Rule ID 4685 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4685,
        GIR_EraseRootFromParent_Done,
      // Label 8512: @623738
      GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(623805), // Rule ID 4689 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4689,
        GIR_EraseRootFromParent_Done,
      // Label 8513: @623805
      GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(623875), // Rule ID 4693 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4693,
        GIR_EraseRootFromParent_Done,
      // Label 8514: @623875
      GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(623942), // Rule ID 4697 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4697,
        GIR_EraseRootFromParent_Done,
      // Label 8515: @623942
      GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(624004), // Rule ID 4686 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4686,
        GIR_EraseRootFromParent_Done,
      // Label 8516: @624004
      GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(624063), // Rule ID 4690 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4690,
        GIR_EraseRootFromParent_Done,
      // Label 8517: @624063
      GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(624125), // Rule ID 4694 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4694,
        GIR_EraseRootFromParent_Done,
      // Label 8518: @624125
      GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(624184), // Rule ID 4698 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4698,
        GIR_EraseRootFromParent_Done,
      // Label 8519: @624184
      GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(624284), // Rule ID 4687 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4687,
        GIR_EraseRootFromParent_Done,
      // Label 8520: @624284
      GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(624381), // Rule ID 4691 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4691,
        GIR_EraseRootFromParent_Done,
      // Label 8521: @624381
      GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(624481), // Rule ID 4695 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4695,
        GIR_EraseRootFromParent_Done,
      // Label 8522: @624481
      GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(624578), // Rule ID 4699 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4699,
        GIR_EraseRootFromParent_Done,
      // Label 8523: @624578
      GIM_Reject,
    // Label 8507: @624579
    GIM_Reject,
    // Label 8503: @624580
    GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(625794),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(624673), // Rule ID 4700 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4700,
        GIR_EraseRootFromParent_Done,
      // Label 8525: @624673
      GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(624742), // Rule ID 4704 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4704,
        GIR_EraseRootFromParent_Done,
      // Label 8526: @624742
      GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(624814), // Rule ID 4708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4708,
        GIR_EraseRootFromParent_Done,
      // Label 8527: @624814
      GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(624883), // Rule ID 4712 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4712,
        GIR_EraseRootFromParent_Done,
      // Label 8528: @624883
      GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(624953), // Rule ID 4701 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4701,
        GIR_EraseRootFromParent_Done,
      // Label 8529: @624953
      GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(625020), // Rule ID 4705 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4705,
        GIR_EraseRootFromParent_Done,
      // Label 8530: @625020
      GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(625090), // Rule ID 4709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4709,
        GIR_EraseRootFromParent_Done,
      // Label 8531: @625090
      GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(625157), // Rule ID 4713 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4713,
        GIR_EraseRootFromParent_Done,
      // Label 8532: @625157
      GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(625219), // Rule ID 4702 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4702,
        GIR_EraseRootFromParent_Done,
      // Label 8533: @625219
      GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(625278), // Rule ID 4706 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4706,
        GIR_EraseRootFromParent_Done,
      // Label 8534: @625278
      GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(625340), // Rule ID 4710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4710,
        GIR_EraseRootFromParent_Done,
      // Label 8535: @625340
      GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(625399), // Rule ID 4714 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4714,
        GIR_EraseRootFromParent_Done,
      // Label 8536: @625399
      GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(625499), // Rule ID 4703 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4703,
        GIR_EraseRootFromParent_Done,
      // Label 8537: @625499
      GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(625596), // Rule ID 4707 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4707,
        GIR_EraseRootFromParent_Done,
      // Label 8538: @625596
      GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(625696), // Rule ID 4711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4711,
        GIR_EraseRootFromParent_Done,
      // Label 8539: @625696
      GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(625793), // Rule ID 4715 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4715,
        GIR_EraseRootFromParent_Done,
      // Label 8540: @625793
      GIM_Reject,
    // Label 8524: @625794
    GIM_Reject,
    // Label 8504: @625795
    GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(627009),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(625888), // Rule ID 4716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4716,
        GIR_EraseRootFromParent_Done,
      // Label 8542: @625888
      GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(625957), // Rule ID 4720 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4720,
        GIR_EraseRootFromParent_Done,
      // Label 8543: @625957
      GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(626029), // Rule ID 4724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4724,
        GIR_EraseRootFromParent_Done,
      // Label 8544: @626029
      GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(626098), // Rule ID 4728 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4728,
        GIR_EraseRootFromParent_Done,
      // Label 8545: @626098
      GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(626168), // Rule ID 4717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4717,
        GIR_EraseRootFromParent_Done,
      // Label 8546: @626168
      GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(626235), // Rule ID 4721 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4721,
        GIR_EraseRootFromParent_Done,
      // Label 8547: @626235
      GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(626305), // Rule ID 4725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4725,
        GIR_EraseRootFromParent_Done,
      // Label 8548: @626305
      GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(626372), // Rule ID 4729 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4729,
        GIR_EraseRootFromParent_Done,
      // Label 8549: @626372
      GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(626434), // Rule ID 4718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4718,
        GIR_EraseRootFromParent_Done,
      // Label 8550: @626434
      GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(626493), // Rule ID 4722 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4722,
        GIR_EraseRootFromParent_Done,
      // Label 8551: @626493
      GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(626555), // Rule ID 4726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4726,
        GIR_EraseRootFromParent_Done,
      // Label 8552: @626555
      GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(626614), // Rule ID 4730 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4730,
        GIR_EraseRootFromParent_Done,
      // Label 8553: @626614
      GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(626714), // Rule ID 4719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4719,
        GIR_EraseRootFromParent_Done,
      // Label 8554: @626714
      GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(626811), // Rule ID 4723 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4723,
        GIR_EraseRootFromParent_Done,
      // Label 8555: @626811
      GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(626911), // Rule ID 4727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4727,
        GIR_EraseRootFromParent_Done,
      // Label 8556: @626911
      GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(627008), // Rule ID 4731 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4731,
        GIR_EraseRootFromParent_Done,
      // Label 8557: @627008
      GIM_Reject,
    // Label 8541: @627009
    GIM_Reject,
    // Label 8505: @627010
    GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(628224),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(627103), // Rule ID 4732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4732,
        GIR_EraseRootFromParent_Done,
      // Label 8559: @627103
      GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(627172), // Rule ID 4736 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4736,
        GIR_EraseRootFromParent_Done,
      // Label 8560: @627172
      GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(627244), // Rule ID 4740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4740,
        GIR_EraseRootFromParent_Done,
      // Label 8561: @627244
      GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(627313), // Rule ID 4744 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4744,
        GIR_EraseRootFromParent_Done,
      // Label 8562: @627313
      GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(627383), // Rule ID 4733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4733,
        GIR_EraseRootFromParent_Done,
      // Label 8563: @627383
      GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(627450), // Rule ID 4737 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4737,
        GIR_EraseRootFromParent_Done,
      // Label 8564: @627450
      GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(627520), // Rule ID 4741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4741,
        GIR_EraseRootFromParent_Done,
      // Label 8565: @627520
      GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(627587), // Rule ID 4745 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4745,
        GIR_EraseRootFromParent_Done,
      // Label 8566: @627587
      GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(627649), // Rule ID 4734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4734,
        GIR_EraseRootFromParent_Done,
      // Label 8567: @627649
      GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(627708), // Rule ID 4738 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4738,
        GIR_EraseRootFromParent_Done,
      // Label 8568: @627708
      GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(627770), // Rule ID 4742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4742,
        GIR_EraseRootFromParent_Done,
      // Label 8569: @627770
      GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(627829), // Rule ID 4746 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4746,
        GIR_EraseRootFromParent_Done,
      // Label 8570: @627829
      GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(627929), // Rule ID 4735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4735,
        GIR_EraseRootFromParent_Done,
      // Label 8571: @627929
      GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(628026), // Rule ID 4739 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4739,
        GIR_EraseRootFromParent_Done,
      // Label 8572: @628026
      GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(628126), // Rule ID 4743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4743,
        GIR_EraseRootFromParent_Done,
      // Label 8573: @628126
      GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(628223), // Rule ID 4747 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4747,
        GIR_EraseRootFromParent_Done,
      // Label 8574: @628223
      GIM_Reject,
    // Label 8558: @628224
    GIM_Reject,
    // Label 8506: @628225
    GIM_Reject,
    // Label 127: @628226
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 8582*/ GIMT_Encode4(635970),
    /*GILLT_s16*//*Label 8575*/ GIMT_Encode4(628277),
    /*GILLT_s32*//*Label 8576*/ GIMT_Encode4(630124), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 8577*/ GIMT_Encode4(631059),
    /*GILLT_v2s32*//*Label 8578*/ GIMT_Encode4(632298), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 8579*/ GIMT_Encode4(632625), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 8580*/ GIMT_Encode4(632952),
    /*GILLT_v4s32*//*Label 8581*/ GIMT_Encode4(635643),
    // Label 8575: @628277
    GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(630123),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(628370), // Rule ID 4780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4780,
        GIR_EraseRootFromParent_Done,
      // Label 8584: @628370
      GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(628442), // Rule ID 4784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4784,
        GIR_EraseRootFromParent_Done,
      // Label 8585: @628442
      GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(628514), // Rule ID 4804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4804,
        GIR_EraseRootFromParent_Done,
      // Label 8586: @628514
      GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(628586), // Rule ID 4808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4808,
        GIR_EraseRootFromParent_Done,
      // Label 8587: @628586
      GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(628658), // Rule ID 4812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4812,
        GIR_EraseRootFromParent_Done,
      // Label 8588: @628658
      GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(628730), // Rule ID 4816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4816,
        GIR_EraseRootFromParent_Done,
      // Label 8589: @628730
      GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(628800), // Rule ID 4781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4781,
        GIR_EraseRootFromParent_Done,
      // Label 8590: @628800
      GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(628870), // Rule ID 4785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4785,
        GIR_EraseRootFromParent_Done,
      // Label 8591: @628870
      GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(628940), // Rule ID 4805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4805,
        GIR_EraseRootFromParent_Done,
      // Label 8592: @628940
      GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(629010), // Rule ID 4809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4809,
        GIR_EraseRootFromParent_Done,
      // Label 8593: @629010
      GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(629080), // Rule ID 4813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4813,
        GIR_EraseRootFromParent_Done,
      // Label 8594: @629080
      GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(629150), // Rule ID 4817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4817,
        GIR_EraseRootFromParent_Done,
      // Label 8595: @629150
      GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(629212), // Rule ID 4782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4782,
        GIR_EraseRootFromParent_Done,
      // Label 8596: @629212
      GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(629274), // Rule ID 4786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4786,
        GIR_EraseRootFromParent_Done,
      // Label 8597: @629274
      GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(629336), // Rule ID 4806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4806,
        GIR_EraseRootFromParent_Done,
      // Label 8598: @629336
      GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(629398), // Rule ID 4810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4810,
        GIR_EraseRootFromParent_Done,
      // Label 8599: @629398
      GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(629460), // Rule ID 4814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4814,
        GIR_EraseRootFromParent_Done,
      // Label 8600: @629460
      GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(629522), // Rule ID 4818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4818,
        GIR_EraseRootFromParent_Done,
      // Label 8601: @629522
      GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(629622), // Rule ID 4783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4783,
        GIR_EraseRootFromParent_Done,
      // Label 8602: @629622
      GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(629722), // Rule ID 4787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4787,
        GIR_EraseRootFromParent_Done,
      // Label 8603: @629722
      GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(629822), // Rule ID 4807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4807,
        GIR_EraseRootFromParent_Done,
      // Label 8604: @629822
      GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(629922), // Rule ID 4811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4811,
        GIR_EraseRootFromParent_Done,
      // Label 8605: @629922
      GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(630022), // Rule ID 4815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4815,
        GIR_EraseRootFromParent_Done,
      // Label 8606: @630022
      GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(630122), // Rule ID 4819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4819,
        GIR_EraseRootFromParent_Done,
      // Label 8607: @630122
      GIM_Reject,
    // Label 8583: @630123
    GIM_Reject,
    // Label 8576: @630124
    GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(631058),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(630217), // Rule ID 4788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4788,
        GIR_EraseRootFromParent_Done,
      // Label 8609: @630217
      GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(630289), // Rule ID 4820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4820,
        GIR_EraseRootFromParent_Done,
      // Label 8610: @630289
      GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(630361), // Rule ID 4824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4824,
        GIR_EraseRootFromParent_Done,
      // Label 8611: @630361
      GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(630431), // Rule ID 4789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4789,
        GIR_EraseRootFromParent_Done,
      // Label 8612: @630431
      GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(630501), // Rule ID 4821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4821,
        GIR_EraseRootFromParent_Done,
      // Label 8613: @630501
      GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(630571), // Rule ID 4825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4825,
        GIR_EraseRootFromParent_Done,
      // Label 8614: @630571
      GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(630633), // Rule ID 4790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4790,
        GIR_EraseRootFromParent_Done,
      // Label 8615: @630633
      GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(630695), // Rule ID 4822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4822,
        GIR_EraseRootFromParent_Done,
      // Label 8616: @630695
      GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(630757), // Rule ID 4826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4826,
        GIR_EraseRootFromParent_Done,
      // Label 8617: @630757
      GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(630857), // Rule ID 4791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4791,
        GIR_EraseRootFromParent_Done,
      // Label 8618: @630857
      GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(630957), // Rule ID 4823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4823,
        GIR_EraseRootFromParent_Done,
      // Label 8619: @630957
      GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(631057), // Rule ID 4827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4827,
        GIR_EraseRootFromParent_Done,
      // Label 8620: @631057
      GIM_Reject,
    // Label 8608: @631058
    GIM_Reject,
    // Label 8577: @631059
    GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(632297),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(631152), // Rule ID 4828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4828,
        GIR_EraseRootFromParent_Done,
      // Label 8622: @631152
      GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(631224), // Rule ID 4832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4832,
        GIR_EraseRootFromParent_Done,
      // Label 8623: @631224
      GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(631296), // Rule ID 4836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4836,
        GIR_EraseRootFromParent_Done,
      // Label 8624: @631296
      GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(631368), // Rule ID 4840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4840,
        GIR_EraseRootFromParent_Done,
      // Label 8625: @631368
      GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(631438), // Rule ID 4829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4829,
        GIR_EraseRootFromParent_Done,
      // Label 8626: @631438
      GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(631508), // Rule ID 4833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4833,
        GIR_EraseRootFromParent_Done,
      // Label 8627: @631508
      GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(631578), // Rule ID 4837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4837,
        GIR_EraseRootFromParent_Done,
      // Label 8628: @631578
      GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(631648), // Rule ID 4841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4841,
        GIR_EraseRootFromParent_Done,
      // Label 8629: @631648
      GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(631710), // Rule ID 4830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4830,
        GIR_EraseRootFromParent_Done,
      // Label 8630: @631710
      GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(631772), // Rule ID 4834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4834,
        GIR_EraseRootFromParent_Done,
      // Label 8631: @631772
      GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(631834), // Rule ID 4838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4838,
        GIR_EraseRootFromParent_Done,
      // Label 8632: @631834
      GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(631896), // Rule ID 4842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4842,
        GIR_EraseRootFromParent_Done,
      // Label 8633: @631896
      GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(631996), // Rule ID 4831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4831,
        GIR_EraseRootFromParent_Done,
      // Label 8634: @631996
      GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(632096), // Rule ID 4835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4835,
        GIR_EraseRootFromParent_Done,
      // Label 8635: @632096
      GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(632196), // Rule ID 4839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4839,
        GIR_EraseRootFromParent_Done,
      // Label 8636: @632196
      GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(632296), // Rule ID 4843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4843,
        GIR_EraseRootFromParent_Done,
      // Label 8637: @632296
      GIM_Reject,
    // Label 8621: @632297
    GIM_Reject,
    // Label 8578: @632298
    GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(632624),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(632391), // Rule ID 4792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4792,
        GIR_EraseRootFromParent_Done,
      // Label 8639: @632391
      GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(632461), // Rule ID 4793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4793,
        GIR_EraseRootFromParent_Done,
      // Label 8640: @632461
      GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(632523), // Rule ID 4794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4794,
        GIR_EraseRootFromParent_Done,
      // Label 8641: @632523
      GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(632623), // Rule ID 4795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4795,
        GIR_EraseRootFromParent_Done,
      // Label 8642: @632623
      GIM_Reject,
    // Label 8638: @632624
    GIM_Reject,
    // Label 8579: @632625
    GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(632951),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(632718), // Rule ID 4796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4796,
        GIR_EraseRootFromParent_Done,
      // Label 8644: @632718
      GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(632788), // Rule ID 4797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4797,
        GIR_EraseRootFromParent_Done,
      // Label 8645: @632788
      GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(632850), // Rule ID 4798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4798,
        GIR_EraseRootFromParent_Done,
      // Label 8646: @632850
      GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(632950), // Rule ID 4799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4799,
        GIR_EraseRootFromParent_Done,
      // Label 8647: @632950
      GIM_Reject,
    // Label 8643: @632951
    GIM_Reject,
    // Label 8580: @632952
    GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(635642),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(633052), // Rule ID 4844 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4844,
        GIR_EraseRootFromParent_Done,
      // Label 8649: @633052
      GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(633135), // Rule ID 4848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4848,
        GIR_EraseRootFromParent_Done,
      // Label 8650: @633135
      GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(633218), // Rule ID 4852 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4852,
        GIR_EraseRootFromParent_Done,
      // Label 8651: @633218
      GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(633301), // Rule ID 4856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4856,
        GIR_EraseRootFromParent_Done,
      // Label 8652: @633301
      GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(633377), // Rule ID 4860 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4860,
        GIR_EraseRootFromParent_Done,
      // Label 8653: @633377
      GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(633453), // Rule ID 4864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4864,
        GIR_EraseRootFromParent_Done,
      // Label 8654: @633453
      GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(633529), // Rule ID 4868 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4868,
        GIR_EraseRootFromParent_Done,
      // Label 8655: @633529
      GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(633605), // Rule ID 4872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4i16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4872,
        GIR_EraseRootFromParent_Done,
      // Label 8656: @633605
      GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(633686), // Rule ID 4845 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4845,
        GIR_EraseRootFromParent_Done,
      // Label 8657: @633686
      GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(633767), // Rule ID 4849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4849,
        GIR_EraseRootFromParent_Done,
      // Label 8658: @633767
      GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(633848), // Rule ID 4853 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4853,
        GIR_EraseRootFromParent_Done,
      // Label 8659: @633848
      GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(633929), // Rule ID 4857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4857,
        GIR_EraseRootFromParent_Done,
      // Label 8660: @633929
      GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(634003), // Rule ID 4861 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4861,
        GIR_EraseRootFromParent_Done,
      // Label 8661: @634003
      GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(634077), // Rule ID 4865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4865,
        GIR_EraseRootFromParent_Done,
      // Label 8662: @634077
      GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(634151), // Rule ID 4869 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4869,
        GIR_EraseRootFromParent_Done,
      // Label 8663: @634151
      GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(634225), // Rule ID 4873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4873,
        GIR_EraseRootFromParent_Done,
      // Label 8664: @634225
      GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(634298), // Rule ID 4846 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4846,
        GIR_EraseRootFromParent_Done,
      // Label 8665: @634298
      GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(634371), // Rule ID 4850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4850,
        GIR_EraseRootFromParent_Done,
      // Label 8666: @634371
      GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(634444), // Rule ID 4854 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4854,
        GIR_EraseRootFromParent_Done,
      // Label 8667: @634444
      GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(634517), // Rule ID 4858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4858,
        GIR_EraseRootFromParent_Done,
      // Label 8668: @634517
      GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(634583), // Rule ID 4862 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4862,
        GIR_EraseRootFromParent_Done,
      // Label 8669: @634583
      GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(634649), // Rule ID 4866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4866,
        GIR_EraseRootFromParent_Done,
      // Label 8670: @634649
      GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(634715), // Rule ID 4870 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4870,
        GIR_EraseRootFromParent_Done,
      // Label 8671: @634715
      GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(634781), // Rule ID 4874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4i16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4874,
        GIR_EraseRootFromParent_Done,
      // Label 8672: @634781
      GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(634892), // Rule ID 4847 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4847,
        GIR_EraseRootFromParent_Done,
      // Label 8673: @634892
      GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(635003), // Rule ID 4851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30632>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4851,
        GIR_EraseRootFromParent_Done,
      // Label 8674: @635003
      GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(635114), // Rule ID 4855 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4855,
        GIR_EraseRootFromParent_Done,
      // Label 8675: @635114
      GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(635225), // Rule ID 4859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_30642>>  =>  (BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4859,
        GIR_EraseRootFromParent_Done,
      // Label 8676: @635225
      GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(635329), // Rule ID 4863 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4863,
        GIR_EraseRootFromParent_Done,
      // Label 8677: @635329
      GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(635433), // Rule ID 4867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4867,
        GIR_EraseRootFromParent_Done,
      // Label 8678: @635433
      GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(635537), // Rule ID 4871 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4871,
        GIR_EraseRootFromParent_Done,
      // Label 8679: @635537
      GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(635641), // Rule ID 4875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4i16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4875,
        GIR_EraseRootFromParent_Done,
      // Label 8680: @635641
      GIM_Reject,
    // Label 8648: @635642
    GIM_Reject,
    // Label 8581: @635643
    GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(635969),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(635736), // Rule ID 4800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4800,
        GIR_EraseRootFromParent_Done,
      // Label 8682: @635736
      GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(635806), // Rule ID 4801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4801,
        GIR_EraseRootFromParent_Done,
      // Label 8683: @635806
      GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(635868), // Rule ID 4802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4802,
        GIR_EraseRootFromParent_Done,
      // Label 8684: @635868
      GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(635968), // Rule ID 4803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4803,
        GIR_EraseRootFromParent_Done,
      // Label 8685: @635968
      GIM_Reject,
    // Label 8681: @635969
    GIM_Reject,
    // Label 8582: @635970
    GIM_Reject,
    // Label 128: @635971
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 8690*/ GIMT_Encode4(638490),
    /*GILLT_v2s32*//*Label 8686*/ GIMT_Encode4(636014), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 8687*/ GIMT_Encode4(636633), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8688*/ GIMT_Encode4(637252), GIMT_Encode4(0),
    /*GILLT_v5s32*//*Label 8689*/ GIMT_Encode4(637871),
    // Label 8686: @636014
    GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(636632),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(636107), // Rule ID 4748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4748,
        GIR_EraseRootFromParent_Done,
      // Label 8692: @636107
      GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(636176), // Rule ID 4752 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4752,
        GIR_EraseRootFromParent_Done,
      // Label 8693: @636176
      GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(636246), // Rule ID 4749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4749,
        GIR_EraseRootFromParent_Done,
      // Label 8694: @636246
      GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(636313), // Rule ID 4753 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4753,
        GIR_EraseRootFromParent_Done,
      // Label 8695: @636313
      GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(636375), // Rule ID 4750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4750,
        GIR_EraseRootFromParent_Done,
      // Label 8696: @636375
      GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(636434), // Rule ID 4754 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4754,
        GIR_EraseRootFromParent_Done,
      // Label 8697: @636434
      GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(636534), // Rule ID 4751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4751,
        GIR_EraseRootFromParent_Done,
      // Label 8698: @636534
      GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(636631), // Rule ID 4755 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_X_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4755,
        GIR_EraseRootFromParent_Done,
      // Label 8699: @636631
      GIM_Reject,
    // Label 8691: @636632
    GIM_Reject,
    // Label 8687: @636633
    GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(637251),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(636726), // Rule ID 4756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4756,
        GIR_EraseRootFromParent_Done,
      // Label 8701: @636726
      GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(636795), // Rule ID 4760 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4760,
        GIR_EraseRootFromParent_Done,
      // Label 8702: @636795
      GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(636865), // Rule ID 4757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4757,
        GIR_EraseRootFromParent_Done,
      // Label 8703: @636865
      GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(636932), // Rule ID 4761 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4761,
        GIR_EraseRootFromParent_Done,
      // Label 8704: @636932
      GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(636994), // Rule ID 4758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4758,
        GIR_EraseRootFromParent_Done,
      // Label 8705: @636994
      GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(637053), // Rule ID 4762 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4762,
        GIR_EraseRootFromParent_Done,
      // Label 8706: @637053
      GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(637153), // Rule ID 4759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4759,
        GIR_EraseRootFromParent_Done,
      // Label 8707: @637153
      GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(637250), // Rule ID 4763 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XY_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4763,
        GIR_EraseRootFromParent_Done,
      // Label 8708: @637250
      GIM_Reject,
    // Label 8700: @637251
    GIM_Reject,
    // Label 8688: @637252
    GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(637870),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(637345), // Rule ID 4764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4764,
        GIR_EraseRootFromParent_Done,
      // Label 8710: @637345
      GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(637414), // Rule ID 4768 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4768,
        GIR_EraseRootFromParent_Done,
      // Label 8711: @637414
      GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(637484), // Rule ID 4765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4765,
        GIR_EraseRootFromParent_Done,
      // Label 8712: @637484
      GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(637551), // Rule ID 4769 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4769,
        GIR_EraseRootFromParent_Done,
      // Label 8713: @637551
      GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(637613), // Rule ID 4766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4766,
        GIR_EraseRootFromParent_Done,
      // Label 8714: @637613
      GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(637672), // Rule ID 4770 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4770,
        GIR_EraseRootFromParent_Done,
      // Label 8715: @637672
      GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(637772), // Rule ID 4767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4767,
        GIR_EraseRootFromParent_Done,
      // Label 8716: @637772
      GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(637869), // Rule ID 4771 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZ_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4771,
        GIR_EraseRootFromParent_Done,
      // Label 8717: @637869
      GIM_Reject,
    // Label 8709: @637870
    GIM_Reject,
    // Label 8689: @637871
    GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(638489),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
      GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(637964), // Rule ID 4772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4772,
        GIR_EraseRootFromParent_Done,
      // Label 8719: @637964
      GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(638033), // Rule ID 4776 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4776,
        GIR_EraseRootFromParent_Done,
      // Label 8720: @638033
      GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(638103), // Rule ID 4773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4773,
        GIR_EraseRootFromParent_Done,
      // Label 8721: @638103
      GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(638170), // Rule ID 4777 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4777,
        GIR_EraseRootFromParent_Done,
      // Label 8722: @638170
      GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(638232), // Rule ID 4774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4774,
        GIR_EraseRootFromParent_Done,
      // Label 8723: @638232
      GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(638291), // Rule ID 4778 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4778,
        GIR_EraseRootFromParent_Done,
      // Label 8724: @638291
      GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(638391), // Rule ID 4775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4775,
        GIR_EraseRootFromParent_Done,
      // Label 8725: @638391
      GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(638488), // Rule ID 4779 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_format_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_FORMAT_XYZW_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 4779,
        GIR_EraseRootFromParent_Done,
      // Label 8726: @638488
      GIM_Reject,
    // Label 8718: @638489
    GIM_Reject,
    // Label 8690: @638490
    GIM_Reject,
    // Label 129: @638491
    GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(639096),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(638787),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(638592), // Rule ID 5100 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5100,
          GIR_EraseRootFromParent_Done,
        // Label 8729: @638592
        GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(638657), // Rule ID 5104 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5104,
          GIR_EraseRootFromParent_Done,
        // Label 8730: @638657
        GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(638723), // Rule ID 5101 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5101,
          GIR_EraseRootFromParent_Done,
        // Label 8731: @638723
        GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(638786), // Rule ID 5105 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5105,
          GIR_EraseRootFromParent_Done,
        // Label 8732: @638786
        GIM_Reject,
      // Label 8728: @638787
      GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(638901),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(638854), // Rule ID 5102 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5102,
          GIR_EraseRootFromParent_Done,
        // Label 8734: @638854
        GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(638900), // Rule ID 5106 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5106,
          GIR_EraseRootFromParent_Done,
        // Label 8735: @638900
        GIM_Reject,
      // Label 8733: @638901
      GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(639095),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(639006), // Rule ID 5103 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5103,
          GIR_EraseRootFromParent_Done,
        // Label 8737: @639006
        GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(639094), // Rule ID 5107 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5107,
          GIR_EraseRootFromParent_Done,
        // Label 8738: @639094
        GIM_Reject,
      // Label 8736: @639095
      GIM_Reject,
    // Label 8727: @639096
    GIM_Reject,
    // Label 130: @639097
    GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(639702),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(639393),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(639198), // Rule ID 5164 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5164,
          GIR_EraseRootFromParent_Done,
        // Label 8741: @639198
        GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(639263), // Rule ID 5168 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5168,
          GIR_EraseRootFromParent_Done,
        // Label 8742: @639263
        GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(639329), // Rule ID 5165 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5165,
          GIR_EraseRootFromParent_Done,
        // Label 8743: @639329
        GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(639392), // Rule ID 5169 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5169,
          GIR_EraseRootFromParent_Done,
        // Label 8744: @639392
        GIM_Reject,
      // Label 8740: @639393
      GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(639507),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(639460), // Rule ID 5166 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5166,
          GIR_EraseRootFromParent_Done,
        // Label 8746: @639460
        GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(639506), // Rule ID 5170 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5170,
          GIR_EraseRootFromParent_Done,
        // Label 8747: @639506
        GIM_Reject,
      // Label 8745: @639507
      GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(639701),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(639612), // Rule ID 5167 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5167,
          GIR_EraseRootFromParent_Done,
        // Label 8749: @639612
        GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(639700), // Rule ID 5171 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_byte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SBYTE_TFE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5171,
          GIR_EraseRootFromParent_Done,
        // Label 8750: @639700
        GIM_Reject,
      // Label 8748: @639701
      GIM_Reject,
    // Label 8739: @639702
    GIM_Reject,
    // Label 131: @639703
    GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(640308),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(639999),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(639804), // Rule ID 5108 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5108,
          GIR_EraseRootFromParent_Done,
        // Label 8753: @639804
        GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(639869), // Rule ID 5112 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5112,
          GIR_EraseRootFromParent_Done,
        // Label 8754: @639869
        GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(639935), // Rule ID 5109 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5109,
          GIR_EraseRootFromParent_Done,
        // Label 8755: @639935
        GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(639998), // Rule ID 5113 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5113,
          GIR_EraseRootFromParent_Done,
        // Label 8756: @639998
        GIM_Reject,
      // Label 8752: @639999
      GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(640113),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(640066), // Rule ID 5110 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5110,
          GIR_EraseRootFromParent_Done,
        // Label 8758: @640066
        GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(640112), // Rule ID 5114 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5114,
          GIR_EraseRootFromParent_Done,
        // Label 8759: @640112
        GIM_Reject,
      // Label 8757: @640113
      GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(640307),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(640218), // Rule ID 5111 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5111,
          GIR_EraseRootFromParent_Done,
        // Label 8761: @640218
        GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(640306), // Rule ID 5115 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5115,
          GIR_EraseRootFromParent_Done,
        // Label 8762: @640306
        GIM_Reject,
      // Label 8760: @640307
      GIM_Reject,
    // Label 8751: @640308
    GIM_Reject,
    // Label 132: @640309
    GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(640914),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(640605),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(640410), // Rule ID 5172 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5172,
          GIR_EraseRootFromParent_Done,
        // Label 8765: @640410
        GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(640475), // Rule ID 5176 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5176,
          GIR_EraseRootFromParent_Done,
        // Label 8766: @640475
        GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(640541), // Rule ID 5173 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5173,
          GIR_EraseRootFromParent_Done,
        // Label 8767: @640541
        GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(640604), // Rule ID 5177 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5177,
          GIR_EraseRootFromParent_Done,
        // Label 8768: @640604
        GIM_Reject,
      // Label 8764: @640605
      GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(640719),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(640672), // Rule ID 5174 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5174,
          GIR_EraseRootFromParent_Done,
        // Label 8770: @640672
        GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(640718), // Rule ID 5178 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5178,
          GIR_EraseRootFromParent_Done,
        // Label 8771: @640718
        GIM_Reject,
      // Label 8769: @640719
      GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(640913),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(640824), // Rule ID 5175 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5175,
          GIR_EraseRootFromParent_Done,
        // Label 8773: @640824
        GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(640912), // Rule ID 5179 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_short_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_SSHORT_TFE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5179,
          GIR_EraseRootFromParent_Done,
        // Label 8774: @640912
        GIM_Reject,
      // Label 8772: @640913
      GIM_Reject,
    // Label 8763: @640914
    GIM_Reject,
    // Label 133: @640915
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(20), /*)*//*default:*//*Label 8779*/ GIMT_Encode4(643434),
    /*GILLT_v2s32*//*Label 8775*/ GIMT_Encode4(640958), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 8776*/ GIMT_Encode4(641577), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 8777*/ GIMT_Encode4(642196), GIMT_Encode4(0),
    /*GILLT_v5s32*//*Label 8778*/ GIMT_Encode4(642815),
    // Label 8775: @640958
    GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(641576),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(641051), // Rule ID 5132 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5132,
        GIR_EraseRootFromParent_Done,
      // Label 8781: @641051
      GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(641120), // Rule ID 5136 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5136,
        GIR_EraseRootFromParent_Done,
      // Label 8782: @641120
      GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(641190), // Rule ID 5133 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5133,
        GIR_EraseRootFromParent_Done,
      // Label 8783: @641190
      GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(641257), // Rule ID 5137 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5137,
        GIR_EraseRootFromParent_Done,
      // Label 8784: @641257
      GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(641319), // Rule ID 5134 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5134,
        GIR_EraseRootFromParent_Done,
      // Label 8785: @641319
      GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(641378), // Rule ID 5138 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5138,
        GIR_EraseRootFromParent_Done,
      // Label 8786: @641378
      GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(641478), // Rule ID 5135 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5135,
        GIR_EraseRootFromParent_Done,
      // Label 8787: @641478
      GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(641575), // Rule ID 5139 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORD_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5139,
        GIR_EraseRootFromParent_Done,
      // Label 8788: @641575
      GIM_Reject,
    // Label 8780: @641576
    GIM_Reject,
    // Label 8776: @641577
    GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(642195),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(641670), // Rule ID 5140 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5140,
        GIR_EraseRootFromParent_Done,
      // Label 8790: @641670
      GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(641739), // Rule ID 5144 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5144,
        GIR_EraseRootFromParent_Done,
      // Label 8791: @641739
      GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(641809), // Rule ID 5141 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5141,
        GIR_EraseRootFromParent_Done,
      // Label 8792: @641809
      GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(641876), // Rule ID 5145 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5145,
        GIR_EraseRootFromParent_Done,
      // Label 8793: @641876
      GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(641938), // Rule ID 5142 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5142,
        GIR_EraseRootFromParent_Done,
      // Label 8794: @641938
      GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(641997), // Rule ID 5146 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5146,
        GIR_EraseRootFromParent_Done,
      // Label 8795: @641997
      GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(642097), // Rule ID 5143 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5143,
        GIR_EraseRootFromParent_Done,
      // Label 8796: @642097
      GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(642194), // Rule ID 5147 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX2_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5147,
        GIR_EraseRootFromParent_Done,
      // Label 8797: @642194
      GIM_Reject,
    // Label 8789: @642195
    GIM_Reject,
    // Label 8777: @642196
    GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(642814),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(642289), // Rule ID 5148 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5148,
        GIR_EraseRootFromParent_Done,
      // Label 8799: @642289
      GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(642358), // Rule ID 5152 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5152,
        GIR_EraseRootFromParent_Done,
      // Label 8800: @642358
      GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(642428), // Rule ID 5149 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5149,
        GIR_EraseRootFromParent_Done,
      // Label 8801: @642428
      GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(642495), // Rule ID 5153 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5153,
        GIR_EraseRootFromParent_Done,
      // Label 8802: @642495
      GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(642557), // Rule ID 5150 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5150,
        GIR_EraseRootFromParent_Done,
      // Label 8803: @642557
      GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(642616), // Rule ID 5154 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5154,
        GIR_EraseRootFromParent_Done,
      // Label 8804: @642616
      GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(642716), // Rule ID 5151 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5151,
        GIR_EraseRootFromParent_Done,
      // Label 8805: @642716
      GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(642813), // Rule ID 5155 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX3_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5155,
        GIR_EraseRootFromParent_Done,
      // Label 8806: @642813
      GIM_Reject,
    // Label 8798: @642814
    GIM_Reject,
    // Label 8778: @642815
    GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(643433),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_160RegClassID),
      GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(642908), // Rule ID 5156 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5156,
        GIR_EraseRootFromParent_Done,
      // Label 8808: @642908
      GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(642977), // Rule ID 5160 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET:{ *:[v5i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5160,
        GIR_EraseRootFromParent_Done,
      // Label 8809: @642977
      GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(643047), // Rule ID 5157 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5157,
        GIR_EraseRootFromParent_Done,
      // Label 8810: @643047
      GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(643114), // Rule ID 5161 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5161,
        GIR_EraseRootFromParent_Done,
      // Label 8811: @643114
      GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(643176), // Rule ID 5158 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5158,
        GIR_EraseRootFromParent_Done,
      // Label 8812: @643176
      GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(643235), // Rule ID 5162 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN:{ *:[v5i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5162,
        GIR_EraseRootFromParent_Done,
      // Label 8813: @643235
      GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(643335), // Rule ID 5159 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5159,
        GIR_EraseRootFromParent_Done,
      // Label 8814: @643335
      GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(643432), // Rule ID 5163 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_load_tfe:{ *:[v5i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN:{ *:[v5i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_DWORDX4_TFE_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5163,
        GIR_EraseRootFromParent_Done,
      // Label 8815: @643432
      GIM_Reject,
    // Label 8807: @643433
    GIM_Reject,
    // Label 8779: @643434
    GIM_Reject,
    // Label 134: @643435
    GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(644040),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(643731),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(643536), // Rule ID 5116 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5116,
          GIR_EraseRootFromParent_Done,
        // Label 8818: @643536
        GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(643601), // Rule ID 5120 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5120,
          GIR_EraseRootFromParent_Done,
        // Label 8819: @643601
        GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(643667), // Rule ID 5117 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5117,
          GIR_EraseRootFromParent_Done,
        // Label 8820: @643667
        GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(643730), // Rule ID 5121 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5121,
          GIR_EraseRootFromParent_Done,
        // Label 8821: @643730
        GIM_Reject,
      // Label 8817: @643731
      GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(643845),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(643798), // Rule ID 5118 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5118,
          GIR_EraseRootFromParent_Done,
        // Label 8823: @643798
        GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(643844), // Rule ID 5122 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5122,
          GIR_EraseRootFromParent_Done,
        // Label 8824: @643844
        GIM_Reject,
      // Label 8822: @643845
      GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(644039),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(643950), // Rule ID 5119 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5119,
          GIR_EraseRootFromParent_Done,
        // Label 8826: @643950
        GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(644038), // Rule ID 5123 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5123,
          GIR_EraseRootFromParent_Done,
        // Label 8827: @644038
        GIM_Reject,
      // Label 8825: @644039
      GIM_Reject,
    // Label 8816: @644040
    GIM_Reject,
    // Label 135: @644041
    GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(644646),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(644337),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(644142), // Rule ID 5180 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5180,
          GIR_EraseRootFromParent_Done,
        // Label 8830: @644142
        GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(644207), // Rule ID 5184 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5184,
          GIR_EraseRootFromParent_Done,
        // Label 8831: @644207
        GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(644273), // Rule ID 5181 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5181,
          GIR_EraseRootFromParent_Done,
        // Label 8832: @644273
        GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(644336), // Rule ID 5185 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5185,
          GIR_EraseRootFromParent_Done,
        // Label 8833: @644336
        GIM_Reject,
      // Label 8829: @644337
      GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(644451),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(644404), // Rule ID 5182 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5182,
          GIR_EraseRootFromParent_Done,
        // Label 8835: @644404
        GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(644450), // Rule ID 5186 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5186,
          GIR_EraseRootFromParent_Done,
        // Label 8836: @644450
        GIM_Reject,
      // Label 8834: @644451
      GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(644645),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(644556), // Rule ID 5183 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5183,
          GIR_EraseRootFromParent_Done,
        // Label 8838: @644556
        GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(644644), // Rule ID 5187 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ubyte_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_UBYTE_TFE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5187,
          GIR_EraseRootFromParent_Done,
        // Label 8839: @644644
        GIM_Reject,
      // Label 8837: @644645
      GIM_Reject,
    // Label 8828: @644646
    GIM_Reject,
    // Label 136: @644647
    GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(645252),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(644943),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(644748), // Rule ID 5124 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5124,
          GIR_EraseRootFromParent_Done,
        // Label 8842: @644748
        GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(644813), // Rule ID 5128 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5128,
          GIR_EraseRootFromParent_Done,
        // Label 8843: @644813
        GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(644879), // Rule ID 5125 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5125,
          GIR_EraseRootFromParent_Done,
        // Label 8844: @644879
        GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(644942), // Rule ID 5129 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5129,
          GIR_EraseRootFromParent_Done,
        // Label 8845: @644942
        GIM_Reject,
      // Label 8841: @644943
      GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(645057),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(645010), // Rule ID 5126 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5126,
          GIR_EraseRootFromParent_Done,
        // Label 8847: @645010
        GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(645056), // Rule ID 5130 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5130,
          GIR_EraseRootFromParent_Done,
        // Label 8848: @645056
        GIM_Reject,
      // Label 8846: @645057
      GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(645251),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(645162), // Rule ID 5127 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5127,
          GIR_EraseRootFromParent_Done,
        // Label 8850: @645162
        GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(645250), // Rule ID 5131 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5131,
          GIR_EraseRootFromParent_Done,
        // Label 8851: @645250
        GIM_Reject,
      // Label 8849: @645251
      GIM_Reject,
    // Label 8840: @645252
    GIM_Reject,
    // Label 137: @645253
    GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(645858),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(645549),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(645354), // Rule ID 5188 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5188,
          GIR_EraseRootFromParent_Done,
        // Label 8854: @645354
        GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(645419), // Rule ID 5192 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFSET),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5192,
          GIR_EraseRootFromParent_Done,
        // Label 8855: @645419
        GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(645485), // Rule ID 5189 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5189,
          GIR_EraseRootFromParent_Done,
        // Label 8856: @645485
        GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(645548), // Rule ID 5193 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_OFFEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5193,
          GIR_EraseRootFromParent_Done,
        // Label 8857: @645548
        GIM_Reject,
      // Label 8853: @645549
      GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(645663),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(645616), // Rule ID 5190 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5190,
          GIR_EraseRootFromParent_Done,
        // Label 8859: @645616
        GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(645662), // Rule ID 5194 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_IDXEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5194,
          GIR_EraseRootFromParent_Done,
        // Label 8860: @645662
        GIM_Reject,
      // Label 8858: @645663
      GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(645857),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(645768), // Rule ID 5191 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5191,
          GIR_EraseRootFromParent_Done,
        // Label 8862: @645768
        GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(645856), // Rule ID 5195 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_load_ushort_tfe:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_LOAD_USHORT_TFE_VBUFFER_BOTHEN),
          GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5195,
          GIR_EraseRootFromParent_Done,
        // Label 8863: @645856
        GIM_Reject,
      // Label 8861: @645857
      GIM_Reject,
    // Label 8852: @645858
    GIM_Reject,
    // Label 138: @645859
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(23), /*)*//*default:*//*Label 8880*/ GIMT_Encode4(662954),
    /*GILLT_p0s64*//*Label 8864*/ GIMT_Encode4(645962),
    /*GILLT_p1s64*//*Label 8865*/ GIMT_Encode4(646577),
    /*GILLT_p2s32*//*Label 8866*/ GIMT_Encode4(647192),
    /*GILLT_p3s32*//*Label 8867*/ GIMT_Encode4(647807),
    /*GILLT_p4s64*//*Label 8868*/ GIMT_Encode4(648422),
    /*GILLT_p5s32*//*Label 8869*/ GIMT_Encode4(649037),
    /*GILLT_p6s32*//*Label 8870*/ GIMT_Encode4(649652), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_s32*//*Label 8871*/ GIMT_Encode4(650267),
    /*GILLT_s64*//*Label 8872*/ GIMT_Encode4(651478),
    /*GILLT_v2s16*//*Label 8873*/ GIMT_Encode4(652689),
    /*GILLT_v2s32*//*Label 8874*/ GIMT_Encode4(654496),
    /*GILLT_v2s64*//*Label 8875*/ GIMT_Encode4(655707),
    /*GILLT_v3s32*//*Label 8876*/ GIMT_Encode4(656918), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 8877*/ GIMT_Encode4(658129),
    /*GILLT_v4s32*//*Label 8878*/ GIMT_Encode4(659936), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s16*//*Label 8879*/ GIMT_Encode4(661147),
    // Label 8864: @645962
    GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(646576),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(646051), // Rule ID 5468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5468,
        GIR_EraseRootFromParent_Done,
      // Label 8882: @646051
      GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(646120), // Rule ID 5472 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5472,
        GIR_EraseRootFromParent_Done,
      // Label 8883: @646120
      GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(646190), // Rule ID 5469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5469,
        GIR_EraseRootFromParent_Done,
      // Label 8884: @646190
      GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(646257), // Rule ID 5473 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5473,
        GIR_EraseRootFromParent_Done,
      // Label 8885: @646257
      GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(646319), // Rule ID 5470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5470,
        GIR_EraseRootFromParent_Done,
      // Label 8886: @646319
      GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(646378), // Rule ID 5474 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5474,
        GIR_EraseRootFromParent_Done,
      // Label 8887: @646378
      GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(646478), // Rule ID 5471 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5471,
        GIR_EraseRootFromParent_Done,
      // Label 8888: @646478
      GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(646575), // Rule ID 5475 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p0:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5475,
        GIR_EraseRootFromParent_Done,
      // Label 8889: @646575
      GIM_Reject,
    // Label 8881: @646576
    GIM_Reject,
    // Label 8865: @646577
    GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(647191),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(646666), // Rule ID 5476 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5476,
        GIR_EraseRootFromParent_Done,
      // Label 8891: @646666
      GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(646735), // Rule ID 5480 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5480,
        GIR_EraseRootFromParent_Done,
      // Label 8892: @646735
      GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(646805), // Rule ID 5477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5477,
        GIR_EraseRootFromParent_Done,
      // Label 8893: @646805
      GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(646872), // Rule ID 5481 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5481,
        GIR_EraseRootFromParent_Done,
      // Label 8894: @646872
      GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(646934), // Rule ID 5478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5478,
        GIR_EraseRootFromParent_Done,
      // Label 8895: @646934
      GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(646993), // Rule ID 5482 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5482,
        GIR_EraseRootFromParent_Done,
      // Label 8896: @646993
      GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(647093), // Rule ID 5479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5479,
        GIR_EraseRootFromParent_Done,
      // Label 8897: @647093
      GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(647190), // Rule ID 5483 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p1:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5483,
        GIR_EraseRootFromParent_Done,
      // Label 8898: @647190
      GIM_Reject,
    // Label 8890: @647191
    GIM_Reject,
    // Label 8866: @647192
    GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(647806),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(647281), // Rule ID 5404 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5404,
        GIR_EraseRootFromParent_Done,
      // Label 8900: @647281
      GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(647350), // Rule ID 5408 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5408,
        GIR_EraseRootFromParent_Done,
      // Label 8901: @647350
      GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(647420), // Rule ID 5405 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5405,
        GIR_EraseRootFromParent_Done,
      // Label 8902: @647420
      GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(647487), // Rule ID 5409 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5409,
        GIR_EraseRootFromParent_Done,
      // Label 8903: @647487
      GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(647549), // Rule ID 5406 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5406,
        GIR_EraseRootFromParent_Done,
      // Label 8904: @647549
      GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(647608), // Rule ID 5410 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5410,
        GIR_EraseRootFromParent_Done,
      // Label 8905: @647608
      GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(647708), // Rule ID 5407 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5407,
        GIR_EraseRootFromParent_Done,
      // Label 8906: @647708
      GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(647805), // Rule ID 5411 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p2:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5411,
        GIR_EraseRootFromParent_Done,
      // Label 8907: @647805
      GIM_Reject,
    // Label 8899: @647806
    GIM_Reject,
    // Label 8867: @647807
    GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(648421),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(647896), // Rule ID 5412 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5412,
        GIR_EraseRootFromParent_Done,
      // Label 8909: @647896
      GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(647965), // Rule ID 5416 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5416,
        GIR_EraseRootFromParent_Done,
      // Label 8910: @647965
      GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(648035), // Rule ID 5413 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5413,
        GIR_EraseRootFromParent_Done,
      // Label 8911: @648035
      GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(648102), // Rule ID 5417 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5417,
        GIR_EraseRootFromParent_Done,
      // Label 8912: @648102
      GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(648164), // Rule ID 5414 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5414,
        GIR_EraseRootFromParent_Done,
      // Label 8913: @648164
      GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(648223), // Rule ID 5418 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5418,
        GIR_EraseRootFromParent_Done,
      // Label 8914: @648223
      GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(648323), // Rule ID 5415 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5415,
        GIR_EraseRootFromParent_Done,
      // Label 8915: @648323
      GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(648420), // Rule ID 5419 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p3:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5419,
        GIR_EraseRootFromParent_Done,
      // Label 8916: @648420
      GIM_Reject,
    // Label 8908: @648421
    GIM_Reject,
    // Label 8868: @648422
    GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(649036),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(648511), // Rule ID 5484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5484,
        GIR_EraseRootFromParent_Done,
      // Label 8918: @648511
      GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(648580), // Rule ID 5488 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5488,
        GIR_EraseRootFromParent_Done,
      // Label 8919: @648580
      GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(648650), // Rule ID 5485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5485,
        GIR_EraseRootFromParent_Done,
      // Label 8920: @648650
      GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(648717), // Rule ID 5489 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5489,
        GIR_EraseRootFromParent_Done,
      // Label 8921: @648717
      GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(648779), // Rule ID 5486 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5486,
        GIR_EraseRootFromParent_Done,
      // Label 8922: @648779
      GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(648838), // Rule ID 5490 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5490,
        GIR_EraseRootFromParent_Done,
      // Label 8923: @648838
      GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(648938), // Rule ID 5487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5487,
        GIR_EraseRootFromParent_Done,
      // Label 8924: @648938
      GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(649035), // Rule ID 5491 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p4:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5491,
        GIR_EraseRootFromParent_Done,
      // Label 8925: @649035
      GIM_Reject,
    // Label 8917: @649036
    GIM_Reject,
    // Label 8869: @649037
    GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(649651),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(649126), // Rule ID 5420 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5420,
        GIR_EraseRootFromParent_Done,
      // Label 8927: @649126
      GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(649195), // Rule ID 5424 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5424,
        GIR_EraseRootFromParent_Done,
      // Label 8928: @649195
      GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(649265), // Rule ID 5421 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5421,
        GIR_EraseRootFromParent_Done,
      // Label 8929: @649265
      GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(649332), // Rule ID 5425 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5425,
        GIR_EraseRootFromParent_Done,
      // Label 8930: @649332
      GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(649394), // Rule ID 5422 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5422,
        GIR_EraseRootFromParent_Done,
      // Label 8931: @649394
      GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(649453), // Rule ID 5426 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5426,
        GIR_EraseRootFromParent_Done,
      // Label 8932: @649453
      GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(649553), // Rule ID 5423 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5423,
        GIR_EraseRootFromParent_Done,
      // Label 8933: @649553
      GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(649650), // Rule ID 5427 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p5:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5427,
        GIR_EraseRootFromParent_Done,
      // Label 8934: @649650
      GIM_Reject,
    // Label 8926: @649651
    GIM_Reject,
    // Label 8870: @649652
    GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(650266),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(649741), // Rule ID 5428 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5428,
        GIR_EraseRootFromParent_Done,
      // Label 8936: @649741
      GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(649810), // Rule ID 5432 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5432,
        GIR_EraseRootFromParent_Done,
      // Label 8937: @649810
      GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(649880), // Rule ID 5429 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5429,
        GIR_EraseRootFromParent_Done,
      // Label 8938: @649880
      GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(649947), // Rule ID 5433 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5433,
        GIR_EraseRootFromParent_Done,
      // Label 8939: @649947
      GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(650009), // Rule ID 5430 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5430,
        GIR_EraseRootFromParent_Done,
      // Label 8940: @650009
      GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(650068), // Rule ID 5434 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5434,
        GIR_EraseRootFromParent_Done,
      // Label 8941: @650068
      GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(650168), // Rule ID 5431 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5431,
        GIR_EraseRootFromParent_Done,
      // Label 8942: @650168
      GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(650265), // Rule ID 5435 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store p6:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5435,
        GIR_EraseRootFromParent_Done,
      // Label 8943: @650265
      GIM_Reject,
    // Label 8935: @650266
    GIM_Reject,
    // Label 8871: @650267
    GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(651477),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(650356), // Rule ID 5364 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5364,
        GIR_EraseRootFromParent_Done,
      // Label 8945: @650356
      GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(650425), // Rule ID 5368 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5368,
        GIR_EraseRootFromParent_Done,
      // Label 8946: @650425
      GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(650497), // Rule ID 5372 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5372,
        GIR_EraseRootFromParent_Done,
      // Label 8947: @650497
      GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(650566), // Rule ID 5376 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5376,
        GIR_EraseRootFromParent_Done,
      // Label 8948: @650566
      GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(650636), // Rule ID 5365 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5365,
        GIR_EraseRootFromParent_Done,
      // Label 8949: @650636
      GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(650703), // Rule ID 5369 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5369,
        GIR_EraseRootFromParent_Done,
      // Label 8950: @650703
      GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(650773), // Rule ID 5373 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5373,
        GIR_EraseRootFromParent_Done,
      // Label 8951: @650773
      GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(650840), // Rule ID 5377 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5377,
        GIR_EraseRootFromParent_Done,
      // Label 8952: @650840
      GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(650902), // Rule ID 5366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5366,
        GIR_EraseRootFromParent_Done,
      // Label 8953: @650902
      GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(650961), // Rule ID 5370 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5370,
        GIR_EraseRootFromParent_Done,
      // Label 8954: @650961
      GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(651023), // Rule ID 5374 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5374,
        GIR_EraseRootFromParent_Done,
      // Label 8955: @651023
      GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(651082), // Rule ID 5378 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5378,
        GIR_EraseRootFromParent_Done,
      // Label 8956: @651082
      GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(651182), // Rule ID 5367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5367,
        GIR_EraseRootFromParent_Done,
      // Label 8957: @651182
      GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(651279), // Rule ID 5371 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5371,
        GIR_EraseRootFromParent_Done,
      // Label 8958: @651279
      GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(651379), // Rule ID 5375 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5375,
        GIR_EraseRootFromParent_Done,
      // Label 8959: @651379
      GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(651476), // Rule ID 5379 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5379,
        GIR_EraseRootFromParent_Done,
      // Label 8960: @651476
      GIM_Reject,
    // Label 8944: @651477
    GIM_Reject,
    // Label 8872: @651478
    GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(652688),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(651567), // Rule ID 5436 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5436,
        GIR_EraseRootFromParent_Done,
      // Label 8962: @651567
      GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(651636), // Rule ID 5440 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5440,
        GIR_EraseRootFromParent_Done,
      // Label 8963: @651636
      GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(651708), // Rule ID 5444 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5444,
        GIR_EraseRootFromParent_Done,
      // Label 8964: @651708
      GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(651777), // Rule ID 5448 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5448,
        GIR_EraseRootFromParent_Done,
      // Label 8965: @651777
      GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(651847), // Rule ID 5437 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5437,
        GIR_EraseRootFromParent_Done,
      // Label 8966: @651847
      GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(651914), // Rule ID 5441 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5441,
        GIR_EraseRootFromParent_Done,
      // Label 8967: @651914
      GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(651984), // Rule ID 5445 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5445,
        GIR_EraseRootFromParent_Done,
      // Label 8968: @651984
      GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(652051), // Rule ID 5449 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5449,
        GIR_EraseRootFromParent_Done,
      // Label 8969: @652051
      GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(652113), // Rule ID 5438 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5438,
        GIR_EraseRootFromParent_Done,
      // Label 8970: @652113
      GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(652172), // Rule ID 5442 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5442,
        GIR_EraseRootFromParent_Done,
      // Label 8971: @652172
      GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(652234), // Rule ID 5446 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5446,
        GIR_EraseRootFromParent_Done,
      // Label 8972: @652234
      GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(652293), // Rule ID 5450 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5450,
        GIR_EraseRootFromParent_Done,
      // Label 8973: @652293
      GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(652393), // Rule ID 5439 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5439,
        GIR_EraseRootFromParent_Done,
      // Label 8974: @652393
      GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(652490), // Rule ID 5443 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store i64:{ *:[i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5443,
        GIR_EraseRootFromParent_Done,
      // Label 8975: @652490
      GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(652590), // Rule ID 5447 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5447,
        GIR_EraseRootFromParent_Done,
      // Label 8976: @652590
      GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(652687), // Rule ID 5451 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store f64:{ *:[f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5451,
        GIR_EraseRootFromParent_Done,
      // Label 8977: @652687
      GIM_Reject,
    // Label 8961: @652688
    GIM_Reject,
    // Label 8873: @652689
    GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(654495),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(652778), // Rule ID 5380 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5380,
        GIR_EraseRootFromParent_Done,
      // Label 8979: @652778
      GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(652847), // Rule ID 5384 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5384,
        GIR_EraseRootFromParent_Done,
      // Label 8980: @652847
      GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(652919), // Rule ID 5388 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5388,
        GIR_EraseRootFromParent_Done,
      // Label 8981: @652919
      GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(652988), // Rule ID 5392 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5392,
        GIR_EraseRootFromParent_Done,
      // Label 8982: @652988
      GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(653060), // Rule ID 5396 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFSET_exact anonymous_9451:{ *:[v2bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5396,
        GIR_EraseRootFromParent_Done,
      // Label 8983: @653060
      GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(653129), // Rule ID 5400 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5400,
        GIR_EraseRootFromParent_Done,
      // Label 8984: @653129
      GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(653199), // Rule ID 5381 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5381,
        GIR_EraseRootFromParent_Done,
      // Label 8985: @653199
      GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(653266), // Rule ID 5385 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5385,
        GIR_EraseRootFromParent_Done,
      // Label 8986: @653266
      GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(653336), // Rule ID 5389 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5389,
        GIR_EraseRootFromParent_Done,
      // Label 8987: @653336
      GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(653403), // Rule ID 5393 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5393,
        GIR_EraseRootFromParent_Done,
      // Label 8988: @653403
      GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(653473), // Rule ID 5397 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_OFFEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5397,
        GIR_EraseRootFromParent_Done,
      // Label 8989: @653473
      GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(653540), // Rule ID 5401 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5401,
        GIR_EraseRootFromParent_Done,
      // Label 8990: @653540
      GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(653602), // Rule ID 5382 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5382,
        GIR_EraseRootFromParent_Done,
      // Label 8991: @653602
      GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(653661), // Rule ID 5386 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5386,
        GIR_EraseRootFromParent_Done,
      // Label 8992: @653661
      GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(653723), // Rule ID 5390 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5390,
        GIR_EraseRootFromParent_Done,
      // Label 8993: @653723
      GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(653782), // Rule ID 5394 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5394,
        GIR_EraseRootFromParent_Done,
      // Label 8994: @653782
      GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(653844), // Rule ID 5398 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_IDXEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5398,
        GIR_EraseRootFromParent_Done,
      // Label 8995: @653844
      GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(653903), // Rule ID 5402 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5402,
        GIR_EraseRootFromParent_Done,
      // Label 8996: @653903
      GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(654003), // Rule ID 5383 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5383,
        GIR_EraseRootFromParent_Done,
      // Label 8997: @654003
      GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(654100), // Rule ID 5387 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5387,
        GIR_EraseRootFromParent_Done,
      // Label 8998: @654100
      GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(654200), // Rule ID 5391 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5391,
        GIR_EraseRootFromParent_Done,
      // Label 8999: @654200
      GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(654297), // Rule ID 5395 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5395,
        GIR_EraseRootFromParent_Done,
      // Label 9000: @654297
      GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(654397), // Rule ID 5399 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_BOTHEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5399,
        GIR_EraseRootFromParent_Done,
      // Label 9001: @654397
      GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(654494), // Rule ID 5403 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2bf16:{ *:[v2bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORD_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5403,
        GIR_EraseRootFromParent_Done,
      // Label 9002: @654494
      GIM_Reject,
    // Label 8978: @654495
    GIM_Reject,
    // Label 8874: @654496
    GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(655706),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(654585), // Rule ID 5452 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5452,
        GIR_EraseRootFromParent_Done,
      // Label 9004: @654585
      GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(654654), // Rule ID 5456 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5456,
        GIR_EraseRootFromParent_Done,
      // Label 9005: @654654
      GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(654726), // Rule ID 5460 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5460,
        GIR_EraseRootFromParent_Done,
      // Label 9006: @654726
      GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(654795), // Rule ID 5464 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5464,
        GIR_EraseRootFromParent_Done,
      // Label 9007: @654795
      GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(654865), // Rule ID 5453 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5453,
        GIR_EraseRootFromParent_Done,
      // Label 9008: @654865
      GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(654932), // Rule ID 5457 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5457,
        GIR_EraseRootFromParent_Done,
      // Label 9009: @654932
      GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(655002), // Rule ID 5461 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5461,
        GIR_EraseRootFromParent_Done,
      // Label 9010: @655002
      GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(655069), // Rule ID 5465 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5465,
        GIR_EraseRootFromParent_Done,
      // Label 9011: @655069
      GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(655131), // Rule ID 5454 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5454,
        GIR_EraseRootFromParent_Done,
      // Label 9012: @655131
      GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(655190), // Rule ID 5458 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5458,
        GIR_EraseRootFromParent_Done,
      // Label 9013: @655190
      GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(655252), // Rule ID 5462 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5462,
        GIR_EraseRootFromParent_Done,
      // Label 9014: @655252
      GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(655311), // Rule ID 5466 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5466,
        GIR_EraseRootFromParent_Done,
      // Label 9015: @655311
      GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(655411), // Rule ID 5455 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5455,
        GIR_EraseRootFromParent_Done,
      // Label 9016: @655411
      GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(655508), // Rule ID 5459 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5459,
        GIR_EraseRootFromParent_Done,
      // Label 9017: @655508
      GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(655608), // Rule ID 5463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5463,
        GIR_EraseRootFromParent_Done,
      // Label 9018: @655608
      GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(655705), // Rule ID 5467 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5467,
        GIR_EraseRootFromParent_Done,
      // Label 9019: @655705
      GIM_Reject,
    // Label 9003: @655706
    GIM_Reject,
    // Label 8875: @655707
    GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(656917),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(655796), // Rule ID 5548 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5548,
        GIR_EraseRootFromParent_Done,
      // Label 9021: @655796
      GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(655865), // Rule ID 5552 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v2i64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5552,
        GIR_EraseRootFromParent_Done,
      // Label 9022: @655865
      GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(655937), // Rule ID 5556 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5556,
        GIR_EraseRootFromParent_Done,
      // Label 9023: @655937
      GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(656006), // Rule ID 5560 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v2f64] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5560,
        GIR_EraseRootFromParent_Done,
      // Label 9024: @656006
      GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(656076), // Rule ID 5549 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5549,
        GIR_EraseRootFromParent_Done,
      // Label 9025: @656076
      GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(656143), // Rule ID 5553 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5553,
        GIR_EraseRootFromParent_Done,
      // Label 9026: @656143
      GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(656213), // Rule ID 5557 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5557,
        GIR_EraseRootFromParent_Done,
      // Label 9027: @656213
      GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(656280), // Rule ID 5561 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5561,
        GIR_EraseRootFromParent_Done,
      // Label 9028: @656280
      GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(656342), // Rule ID 5550 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5550,
        GIR_EraseRootFromParent_Done,
      // Label 9029: @656342
      GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(656401), // Rule ID 5554 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5554,
        GIR_EraseRootFromParent_Done,
      // Label 9030: @656401
      GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(656463), // Rule ID 5558 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5558,
        GIR_EraseRootFromParent_Done,
      // Label 9031: @656463
      GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(656522), // Rule ID 5562 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5562,
        GIR_EraseRootFromParent_Done,
      // Label 9032: @656522
      GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(656622), // Rule ID 5551 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5551,
        GIR_EraseRootFromParent_Done,
      // Label 9033: @656622
      GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(656719), // Rule ID 5555 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2i64:{ *:[v2i64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v2i64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5555,
        GIR_EraseRootFromParent_Done,
      // Label 9034: @656719
      GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(656819), // Rule ID 5559 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5559,
        GIR_EraseRootFromParent_Done,
      // Label 9035: @656819
      GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(656916), // Rule ID 5563 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v2f64:{ *:[v2f64] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v2f64] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5563,
        GIR_EraseRootFromParent_Done,
      // Label 9036: @656916
      GIM_Reject,
    // Label 9020: @656917
    GIM_Reject,
    // Label 8876: @656918
    GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(658128),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(657007), // Rule ID 5516 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5516,
        GIR_EraseRootFromParent_Done,
      // Label 9038: @657007
      GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(657076), // Rule ID 5520 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5520,
        GIR_EraseRootFromParent_Done,
      // Label 9039: @657076
      GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(657148), // Rule ID 5524 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5524,
        GIR_EraseRootFromParent_Done,
      // Label 9040: @657148
      GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(657217), // Rule ID 5528 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5528,
        GIR_EraseRootFromParent_Done,
      // Label 9041: @657217
      GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(657287), // Rule ID 5517 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5517,
        GIR_EraseRootFromParent_Done,
      // Label 9042: @657287
      GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(657354), // Rule ID 5521 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5521,
        GIR_EraseRootFromParent_Done,
      // Label 9043: @657354
      GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(657424), // Rule ID 5525 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5525,
        GIR_EraseRootFromParent_Done,
      // Label 9044: @657424
      GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(657491), // Rule ID 5529 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5529,
        GIR_EraseRootFromParent_Done,
      // Label 9045: @657491
      GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(657553), // Rule ID 5518 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5518,
        GIR_EraseRootFromParent_Done,
      // Label 9046: @657553
      GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(657612), // Rule ID 5522 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5522,
        GIR_EraseRootFromParent_Done,
      // Label 9047: @657612
      GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(657674), // Rule ID 5526 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5526,
        GIR_EraseRootFromParent_Done,
      // Label 9048: @657674
      GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(657733), // Rule ID 5530 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5530,
        GIR_EraseRootFromParent_Done,
      // Label 9049: @657733
      GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(657833), // Rule ID 5519 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5519,
        GIR_EraseRootFromParent_Done,
      // Label 9050: @657833
      GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(657930), // Rule ID 5523 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5523,
        GIR_EraseRootFromParent_Done,
      // Label 9051: @657930
      GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(658030), // Rule ID 5527 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5527,
        GIR_EraseRootFromParent_Done,
      // Label 9052: @658030
      GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(658127), // Rule ID 5531 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX3_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5531,
        GIR_EraseRootFromParent_Done,
      // Label 9053: @658127
      GIM_Reject,
    // Label 9037: @658128
    GIM_Reject,
    // Label 8877: @658129
    GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(659935),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(658218), // Rule ID 5492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5492,
        GIR_EraseRootFromParent_Done,
      // Label 9055: @658218
      GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(658287), // Rule ID 5496 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5496,
        GIR_EraseRootFromParent_Done,
      // Label 9056: @658287
      GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(658359), // Rule ID 5500 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5500,
        GIR_EraseRootFromParent_Done,
      // Label 9057: @658359
      GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(658428), // Rule ID 5504 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5504,
        GIR_EraseRootFromParent_Done,
      // Label 9058: @658428
      GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(658500), // Rule ID 5508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFSET_exact anonymous_9450:{ *:[v4bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5508,
        GIR_EraseRootFromParent_Done,
      // Label 9059: @658500
      GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(658569), // Rule ID 5512 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5512,
        GIR_EraseRootFromParent_Done,
      // Label 9060: @658569
      GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(658639), // Rule ID 5493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5493,
        GIR_EraseRootFromParent_Done,
      // Label 9061: @658639
      GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(658706), // Rule ID 5497 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5497,
        GIR_EraseRootFromParent_Done,
      // Label 9062: @658706
      GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(658776), // Rule ID 5501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5501,
        GIR_EraseRootFromParent_Done,
      // Label 9063: @658776
      GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(658843), // Rule ID 5505 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5505,
        GIR_EraseRootFromParent_Done,
      // Label 9064: @658843
      GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(658913), // Rule ID 5509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_OFFEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5509,
        GIR_EraseRootFromParent_Done,
      // Label 9065: @658913
      GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(658980), // Rule ID 5513 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5513,
        GIR_EraseRootFromParent_Done,
      // Label 9066: @658980
      GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(659042), // Rule ID 5494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5494,
        GIR_EraseRootFromParent_Done,
      // Label 9067: @659042
      GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(659101), // Rule ID 5498 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5498,
        GIR_EraseRootFromParent_Done,
      // Label 9068: @659101
      GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(659163), // Rule ID 5502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5502,
        GIR_EraseRootFromParent_Done,
      // Label 9069: @659163
      GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(659222), // Rule ID 5506 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5506,
        GIR_EraseRootFromParent_Done,
      // Label 9070: @659222
      GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(659284), // Rule ID 5510 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_IDXEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5510,
        GIR_EraseRootFromParent_Done,
      // Label 9071: @659284
      GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(659343), // Rule ID 5514 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5514,
        GIR_EraseRootFromParent_Done,
      // Label 9072: @659343
      GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(659443), // Rule ID 5495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5495,
        GIR_EraseRootFromParent_Done,
      // Label 9073: @659443
      GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(659540), // Rule ID 5499 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5499,
        GIR_EraseRootFromParent_Done,
      // Label 9074: @659540
      GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(659640), // Rule ID 5503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5503,
        GIR_EraseRootFromParent_Done,
      // Label 9075: @659640
      GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(659737), // Rule ID 5507 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5507,
        GIR_EraseRootFromParent_Done,
      // Label 9076: @659737
      GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(659837), // Rule ID 5511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_BOTHEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5511,
        GIR_EraseRootFromParent_Done,
      // Label 9077: @659837
      GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(659934), // Rule ID 5515 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4bf16:{ *:[v4bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX2_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5515,
        GIR_EraseRootFromParent_Done,
      // Label 9078: @659934
      GIM_Reject,
    // Label 9054: @659935
    GIM_Reject,
    // Label 8878: @659936
    GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(661146),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(660025), // Rule ID 5532 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5532,
        GIR_EraseRootFromParent_Done,
      // Label 9080: @660025
      GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(660094), // Rule ID 5536 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5536,
        GIR_EraseRootFromParent_Done,
      // Label 9081: @660094
      GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(660166), // Rule ID 5540 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5540,
        GIR_EraseRootFromParent_Done,
      // Label 9082: @660166
      GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(660235), // Rule ID 5544 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5544,
        GIR_EraseRootFromParent_Done,
      // Label 9083: @660235
      GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(660305), // Rule ID 5533 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5533,
        GIR_EraseRootFromParent_Done,
      // Label 9084: @660305
      GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(660372), // Rule ID 5537 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5537,
        GIR_EraseRootFromParent_Done,
      // Label 9085: @660372
      GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(660442), // Rule ID 5541 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5541,
        GIR_EraseRootFromParent_Done,
      // Label 9086: @660442
      GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(660509), // Rule ID 5545 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5545,
        GIR_EraseRootFromParent_Done,
      // Label 9087: @660509
      GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(660571), // Rule ID 5534 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5534,
        GIR_EraseRootFromParent_Done,
      // Label 9088: @660571
      GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(660630), // Rule ID 5538 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5538,
        GIR_EraseRootFromParent_Done,
      // Label 9089: @660630
      GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(660692), // Rule ID 5542 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5542,
        GIR_EraseRootFromParent_Done,
      // Label 9090: @660692
      GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(660751), // Rule ID 5546 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5546,
        GIR_EraseRootFromParent_Done,
      // Label 9091: @660751
      GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(660851), // Rule ID 5535 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5535,
        GIR_EraseRootFromParent_Done,
      // Label 9092: @660851
      GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(660948), // Rule ID 5539 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5539,
        GIR_EraseRootFromParent_Done,
      // Label 9093: @660948
      GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(661048), // Rule ID 5543 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5543,
        GIR_EraseRootFromParent_Done,
      // Label 9094: @661048
      GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(661145), // Rule ID 5547 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5547,
        GIR_EraseRootFromParent_Done,
      // Label 9095: @661145
      GIM_Reject,
    // Label 9079: @661146
    GIM_Reject,
    // Label 8879: @661147
    GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(662953),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(661236), // Rule ID 5564 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5564,
        GIR_EraseRootFromParent_Done,
      // Label 9097: @661236
      GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(661305), // Rule ID 5568 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v8i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5568,
        GIR_EraseRootFromParent_Done,
      // Label 9098: @661305
      GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(661377), // Rule ID 5572 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5572,
        GIR_EraseRootFromParent_Done,
      // Label 9099: @661377
      GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(661446), // Rule ID 5576 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v8f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5576,
        GIR_EraseRootFromParent_Done,
      // Label 9100: @661446
      GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(661518), // Rule ID 5580 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFSET_exact anonymous_9448:{ *:[v8bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5580,
        GIR_EraseRootFromParent_Done,
      // Label 9101: @661518
      GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(661587), // Rule ID 5584 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v8bf16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5584,
        GIR_EraseRootFromParent_Done,
      // Label 9102: @661587
      GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(661657), // Rule ID 5565 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5565,
        GIR_EraseRootFromParent_Done,
      // Label 9103: @661657
      GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(661724), // Rule ID 5569 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5569,
        GIR_EraseRootFromParent_Done,
      // Label 9104: @661724
      GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(661794), // Rule ID 5573 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5573,
        GIR_EraseRootFromParent_Done,
      // Label 9105: @661794
      GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(661861), // Rule ID 5577 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5577,
        GIR_EraseRootFromParent_Done,
      // Label 9106: @661861
      GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(661931), // Rule ID 5581 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_OFFEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5581,
        GIR_EraseRootFromParent_Done,
      // Label 9107: @661931
      GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(661998), // Rule ID 5585 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5585,
        GIR_EraseRootFromParent_Done,
      // Label 9108: @661998
      GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(662060), // Rule ID 5566 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5566,
        GIR_EraseRootFromParent_Done,
      // Label 9109: @662060
      GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(662119), // Rule ID 5570 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5570,
        GIR_EraseRootFromParent_Done,
      // Label 9110: @662119
      GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(662181), // Rule ID 5574 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5574,
        GIR_EraseRootFromParent_Done,
      // Label 9111: @662181
      GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(662240), // Rule ID 5578 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5578,
        GIR_EraseRootFromParent_Done,
      // Label 9112: @662240
      GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(662302), // Rule ID 5582 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_IDXEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5582,
        GIR_EraseRootFromParent_Done,
      // Label 9113: @662302
      GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(662361), // Rule ID 5586 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5586,
        GIR_EraseRootFromParent_Done,
      // Label 9114: @662361
      GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(662461), // Rule ID 5567 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5567,
        GIR_EraseRootFromParent_Done,
      // Label 9115: @662461
      GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(662558), // Rule ID 5571 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8i16:{ *:[v8i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v8i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5571,
        GIR_EraseRootFromParent_Done,
      // Label 9116: @662558
      GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(662658), // Rule ID 5575 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5575,
        GIR_EraseRootFromParent_Done,
      // Label 9117: @662658
      GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(662755), // Rule ID 5579 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8f16:{ *:[v8f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v8f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5579,
        GIR_EraseRootFromParent_Done,
      // Label 9118: @662755
      GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(662855), // Rule ID 5583 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_BOTHEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5583,
        GIR_EraseRootFromParent_Done,
      // Label 9119: @662855
      GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(662952), // Rule ID 5587 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store v8bf16:{ *:[v8bf16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v8bf16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_DWORDX4_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5587,
        GIR_EraseRootFromParent_Done,
      // Label 9120: @662952
      GIM_Reject,
    // Label 9096: @662953
    GIM_Reject,
    // Label 8880: @662954
    GIM_Reject,
    // Label 139: @662955
    GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(663556),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(663247),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(663052), // Rule ID 5588 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFSET_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5588,
          GIR_EraseRootFromParent_Done,
        // Label 9123: @663052
        GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(663117), // Rule ID 5592 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFSET_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5592,
          GIR_EraseRootFromParent_Done,
        // Label 9124: @663117
        GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(663183), // Rule ID 5589 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_OFFEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5589,
          GIR_EraseRootFromParent_Done,
        // Label 9125: @663183
        GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(663246), // Rule ID 5593 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_OFFEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5593,
          GIR_EraseRootFromParent_Done,
        // Label 9126: @663246
        GIM_Reject,
      // Label 9122: @663247
      GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(663361),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(663314), // Rule ID 5590 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_IDXEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5590,
          GIR_EraseRootFromParent_Done,
        // Label 9128: @663314
        GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(663360), // Rule ID 5594 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_IDXEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5594,
          GIR_EraseRootFromParent_Done,
        // Label 9129: @663360
        GIM_Reject,
      // Label 9127: @663361
      GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(663555),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(663466), // Rule ID 5591 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_BOTHEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5591,
          GIR_EraseRootFromParent_Done,
        // Label 9131: @663466
        GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(663554), // Rule ID 5595 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_byte i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_BYTE_VBUFFER_BOTHEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5595,
          GIR_EraseRootFromParent_Done,
        // Label 9132: @663554
        GIM_Reject,
      // Label 9130: @663555
      GIM_Reject,
    // Label 9121: @663556
    GIM_Reject,
    // Label 140: @663557
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9137*/ GIMT_Encode4(669044),
    /*GILLT_s32*//*Label 9133*/ GIMT_Encode4(663604), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 9134*/ GIMT_Encode4(664815), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9135*/ GIMT_Encode4(666622), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 9136*/ GIMT_Encode4(667833),
    // Label 9133: @663604
    GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(664814),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(663693), // Rule ID 5196 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5196,
        GIR_EraseRootFromParent_Done,
      // Label 9139: @663693
      GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(663762), // Rule ID 5200 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5200,
        GIR_EraseRootFromParent_Done,
      // Label 9140: @663762
      GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(663834), // Rule ID 5204 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5204,
        GIR_EraseRootFromParent_Done,
      // Label 9141: @663834
      GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(663903), // Rule ID 5208 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5208,
        GIR_EraseRootFromParent_Done,
      // Label 9142: @663903
      GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(663973), // Rule ID 5197 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5197,
        GIR_EraseRootFromParent_Done,
      // Label 9143: @663973
      GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(664040), // Rule ID 5201 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5201,
        GIR_EraseRootFromParent_Done,
      // Label 9144: @664040
      GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(664110), // Rule ID 5205 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5205,
        GIR_EraseRootFromParent_Done,
      // Label 9145: @664110
      GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(664177), // Rule ID 5209 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5209,
        GIR_EraseRootFromParent_Done,
      // Label 9146: @664177
      GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(664239), // Rule ID 5198 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5198,
        GIR_EraseRootFromParent_Done,
      // Label 9147: @664239
      GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(664298), // Rule ID 5202 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5202,
        GIR_EraseRootFromParent_Done,
      // Label 9148: @664298
      GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(664360), // Rule ID 5206 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5206,
        GIR_EraseRootFromParent_Done,
      // Label 9149: @664360
      GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(664419), // Rule ID 5210 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5210,
        GIR_EraseRootFromParent_Done,
      // Label 9150: @664419
      GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(664519), // Rule ID 5199 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5199,
        GIR_EraseRootFromParent_Done,
      // Label 9151: @664519
      GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(664616), // Rule ID 5203 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5203,
        GIR_EraseRootFromParent_Done,
      // Label 9152: @664616
      GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(664716), // Rule ID 5207 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5207,
        GIR_EraseRootFromParent_Done,
      // Label 9153: @664716
      GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(664813), // Rule ID 5211 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5211,
        GIR_EraseRootFromParent_Done,
      // Label 9154: @664813
      GIM_Reject,
    // Label 9138: @664814
    GIM_Reject,
    // Label 9134: @664815
    GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(666621),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(664904), // Rule ID 5212 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5212,
        GIR_EraseRootFromParent_Done,
      // Label 9156: @664904
      GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(664973), // Rule ID 5216 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5216,
        GIR_EraseRootFromParent_Done,
      // Label 9157: @664973
      GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(665045), // Rule ID 5220 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5220,
        GIR_EraseRootFromParent_Done,
      // Label 9158: @665045
      GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(665114), // Rule ID 5224 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5224,
        GIR_EraseRootFromParent_Done,
      // Label 9159: @665114
      GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(665186), // Rule ID 5228 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5228,
        GIR_EraseRootFromParent_Done,
      // Label 9160: @665186
      GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(665255), // Rule ID 5232 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5232,
        GIR_EraseRootFromParent_Done,
      // Label 9161: @665255
      GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(665325), // Rule ID 5213 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5213,
        GIR_EraseRootFromParent_Done,
      // Label 9162: @665325
      GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(665392), // Rule ID 5217 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5217,
        GIR_EraseRootFromParent_Done,
      // Label 9163: @665392
      GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(665462), // Rule ID 5221 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5221,
        GIR_EraseRootFromParent_Done,
      // Label 9164: @665462
      GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(665529), // Rule ID 5225 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5225,
        GIR_EraseRootFromParent_Done,
      // Label 9165: @665529
      GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(665599), // Rule ID 5229 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5229,
        GIR_EraseRootFromParent_Done,
      // Label 9166: @665599
      GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(665666), // Rule ID 5233 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5233,
        GIR_EraseRootFromParent_Done,
      // Label 9167: @665666
      GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(665728), // Rule ID 5214 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5214,
        GIR_EraseRootFromParent_Done,
      // Label 9168: @665728
      GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(665787), // Rule ID 5218 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5218,
        GIR_EraseRootFromParent_Done,
      // Label 9169: @665787
      GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(665849), // Rule ID 5222 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5222,
        GIR_EraseRootFromParent_Done,
      // Label 9170: @665849
      GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(665908), // Rule ID 5226 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5226,
        GIR_EraseRootFromParent_Done,
      // Label 9171: @665908
      GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(665970), // Rule ID 5230 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5230,
        GIR_EraseRootFromParent_Done,
      // Label 9172: @665970
      GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(666029), // Rule ID 5234 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5234,
        GIR_EraseRootFromParent_Done,
      // Label 9173: @666029
      GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(666129), // Rule ID 5215 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5215,
        GIR_EraseRootFromParent_Done,
      // Label 9174: @666129
      GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(666226), // Rule ID 5219 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5219,
        GIR_EraseRootFromParent_Done,
      // Label 9175: @666226
      GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(666326), // Rule ID 5223 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5223,
        GIR_EraseRootFromParent_Done,
      // Label 9176: @666326
      GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(666423), // Rule ID 5227 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5227,
        GIR_EraseRootFromParent_Done,
      // Label 9177: @666423
      GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(666523), // Rule ID 5231 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5231,
        GIR_EraseRootFromParent_Done,
      // Label 9178: @666523
      GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(666620), // Rule ID 5235 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5235,
        GIR_EraseRootFromParent_Done,
      // Label 9179: @666620
      GIM_Reject,
    // Label 9155: @666621
    GIM_Reject,
    // Label 9135: @666622
    GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(667832),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(666711), // Rule ID 5236 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5236,
        GIR_EraseRootFromParent_Done,
      // Label 9181: @666711
      GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(666780), // Rule ID 5240 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5240,
        GIR_EraseRootFromParent_Done,
      // Label 9182: @666780
      GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(666852), // Rule ID 5244 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5244,
        GIR_EraseRootFromParent_Done,
      // Label 9183: @666852
      GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(666921), // Rule ID 5248 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5248,
        GIR_EraseRootFromParent_Done,
      // Label 9184: @666921
      GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(666991), // Rule ID 5237 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5237,
        GIR_EraseRootFromParent_Done,
      // Label 9185: @666991
      GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(667058), // Rule ID 5241 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5241,
        GIR_EraseRootFromParent_Done,
      // Label 9186: @667058
      GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(667128), // Rule ID 5245 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5245,
        GIR_EraseRootFromParent_Done,
      // Label 9187: @667128
      GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(667195), // Rule ID 5249 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5249,
        GIR_EraseRootFromParent_Done,
      // Label 9188: @667195
      GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(667257), // Rule ID 5238 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5238,
        GIR_EraseRootFromParent_Done,
      // Label 9189: @667257
      GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(667316), // Rule ID 5242 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5242,
        GIR_EraseRootFromParent_Done,
      // Label 9190: @667316
      GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(667378), // Rule ID 5246 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5246,
        GIR_EraseRootFromParent_Done,
      // Label 9191: @667378
      GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(667437), // Rule ID 5250 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5250,
        GIR_EraseRootFromParent_Done,
      // Label 9192: @667437
      GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(667537), // Rule ID 5239 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5239,
        GIR_EraseRootFromParent_Done,
      // Label 9193: @667537
      GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(667634), // Rule ID 5243 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5243,
        GIR_EraseRootFromParent_Done,
      // Label 9194: @667634
      GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(667734), // Rule ID 5247 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5247,
        GIR_EraseRootFromParent_Done,
      // Label 9195: @667734
      GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(667831), // Rule ID 5251 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5251,
        GIR_EraseRootFromParent_Done,
      // Label 9196: @667831
      GIM_Reject,
    // Label 9180: @667832
    GIM_Reject,
    // Label 9136: @667833
    GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(669043),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(667922), // Rule ID 5252 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5252,
        GIR_EraseRootFromParent_Done,
      // Label 9198: @667922
      GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(667991), // Rule ID 5256 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5256,
        GIR_EraseRootFromParent_Done,
      // Label 9199: @667991
      GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(668063), // Rule ID 5260 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5260,
        GIR_EraseRootFromParent_Done,
      // Label 9200: @668063
      GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(668132), // Rule ID 5264 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5264,
        GIR_EraseRootFromParent_Done,
      // Label 9201: @668132
      GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(668202), // Rule ID 5253 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5253,
        GIR_EraseRootFromParent_Done,
      // Label 9202: @668202
      GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(668269), // Rule ID 5257 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5257,
        GIR_EraseRootFromParent_Done,
      // Label 9203: @668269
      GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(668339), // Rule ID 5261 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5261,
        GIR_EraseRootFromParent_Done,
      // Label 9204: @668339
      GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(668406), // Rule ID 5265 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5265,
        GIR_EraseRootFromParent_Done,
      // Label 9205: @668406
      GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(668468), // Rule ID 5254 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5254,
        GIR_EraseRootFromParent_Done,
      // Label 9206: @668468
      GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(668527), // Rule ID 5258 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5258,
        GIR_EraseRootFromParent_Done,
      // Label 9207: @668527
      GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(668589), // Rule ID 5262 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5262,
        GIR_EraseRootFromParent_Done,
      // Label 9208: @668589
      GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(668648), // Rule ID 5266 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5266,
        GIR_EraseRootFromParent_Done,
      // Label 9209: @668648
      GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(668748), // Rule ID 5255 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5255,
        GIR_EraseRootFromParent_Done,
      // Label 9210: @668748
      GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(668845), // Rule ID 5259 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5259,
        GIR_EraseRootFromParent_Done,
      // Label 9211: @668845
      GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(668945), // Rule ID 5263 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5263,
        GIR_EraseRootFromParent_Done,
      // Label 9212: @668945
      GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(669042), // Rule ID 5267 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5267,
        GIR_EraseRootFromParent_Done,
      // Label 9213: @669042
      GIM_Reject,
    // Label 9197: @669043
    GIM_Reject,
    // Label 9137: @669044
    GIM_Reject,
    // Label 141: @669045
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9221*/ GIMT_Encode4(675309),
    /*GILLT_s16*//*Label 9214*/ GIMT_Encode4(669096),
    /*GILLT_s32*//*Label 9215*/ GIMT_Encode4(670939), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 9216*/ GIMT_Encode4(671870),
    /*GILLT_v2s32*//*Label 9217*/ GIMT_Encode4(673105), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9218*/ GIMT_Encode4(673428), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 9219*/ GIMT_Encode4(673751),
    /*GILLT_v4s32*//*Label 9220*/ GIMT_Encode4(674986),
    // Label 9214: @669096
    GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(670938),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(669185), // Rule ID 5268 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5268,
        GIR_EraseRootFromParent_Done,
      // Label 9223: @669185
      GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(669257), // Rule ID 5272 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9451:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5272,
        GIR_EraseRootFromParent_Done,
      // Label 9224: @669257
      GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(669329), // Rule ID 5292 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5292,
        GIR_EraseRootFromParent_Done,
      // Label 9225: @669329
      GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(669401), // Rule ID 5296 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5296,
        GIR_EraseRootFromParent_Done,
      // Label 9226: @669401
      GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(669473), // Rule ID 5300 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9451:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5300,
        GIR_EraseRootFromParent_Done,
      // Label 9227: @669473
      GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(669545), // Rule ID 5304 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5304,
        GIR_EraseRootFromParent_Done,
      // Label 9228: @669545
      GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(669615), // Rule ID 5269 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5269,
        GIR_EraseRootFromParent_Done,
      // Label 9229: @669615
      GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(669685), // Rule ID 5273 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5273,
        GIR_EraseRootFromParent_Done,
      // Label 9230: @669685
      GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(669755), // Rule ID 5293 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5293,
        GIR_EraseRootFromParent_Done,
      // Label 9231: @669755
      GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(669825), // Rule ID 5297 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5297,
        GIR_EraseRootFromParent_Done,
      // Label 9232: @669825
      GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(669895), // Rule ID 5301 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5301,
        GIR_EraseRootFromParent_Done,
      // Label 9233: @669895
      GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(669965), // Rule ID 5305 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5305,
        GIR_EraseRootFromParent_Done,
      // Label 9234: @669965
      GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(670027), // Rule ID 5270 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5270,
        GIR_EraseRootFromParent_Done,
      // Label 9235: @670027
      GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(670089), // Rule ID 5274 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5274,
        GIR_EraseRootFromParent_Done,
      // Label 9236: @670089
      GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(670151), // Rule ID 5294 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5294,
        GIR_EraseRootFromParent_Done,
      // Label 9237: @670151
      GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(670213), // Rule ID 5298 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5298,
        GIR_EraseRootFromParent_Done,
      // Label 9238: @670213
      GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(670275), // Rule ID 5302 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5302,
        GIR_EraseRootFromParent_Done,
      // Label 9239: @670275
      GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(670337), // Rule ID 5306 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5306,
        GIR_EraseRootFromParent_Done,
      // Label 9240: @670337
      GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(670437), // Rule ID 5271 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5271,
        GIR_EraseRootFromParent_Done,
      // Label 9241: @670437
      GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(670537), // Rule ID 5275 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9451:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5275,
        GIR_EraseRootFromParent_Done,
      // Label 9242: @670537
      GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(670637), // Rule ID 5295 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5295,
        GIR_EraseRootFromParent_Done,
      // Label 9243: @670637
      GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(670737), // Rule ID 5299 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5299,
        GIR_EraseRootFromParent_Done,
      // Label 9244: @670737
      GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(670837), // Rule ID 5303 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9451:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5303,
        GIR_EraseRootFromParent_Done,
      // Label 9245: @670837
      GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(670937), // Rule ID 5307 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i16:{ *:[i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5307,
        GIR_EraseRootFromParent_Done,
      // Label 9246: @670937
      GIM_Reject,
    // Label 9222: @670938
    GIM_Reject,
    // Label 9215: @670939
    GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(671869),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(671028), // Rule ID 5276 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5276,
        GIR_EraseRootFromParent_Done,
      // Label 9248: @671028
      GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(671100), // Rule ID 5308 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5308,
        GIR_EraseRootFromParent_Done,
      // Label 9249: @671100
      GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(671172), // Rule ID 5312 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5312,
        GIR_EraseRootFromParent_Done,
      // Label 9250: @671172
      GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(671242), // Rule ID 5277 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5277,
        GIR_EraseRootFromParent_Done,
      // Label 9251: @671242
      GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(671312), // Rule ID 5309 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5309,
        GIR_EraseRootFromParent_Done,
      // Label 9252: @671312
      GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(671382), // Rule ID 5313 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5313,
        GIR_EraseRootFromParent_Done,
      // Label 9253: @671382
      GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(671444), // Rule ID 5278 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5278,
        GIR_EraseRootFromParent_Done,
      // Label 9254: @671444
      GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(671506), // Rule ID 5310 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5310,
        GIR_EraseRootFromParent_Done,
      // Label 9255: @671506
      GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(671568), // Rule ID 5314 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5314,
        GIR_EraseRootFromParent_Done,
      // Label 9256: @671568
      GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(671668), // Rule ID 5279 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5279,
        GIR_EraseRootFromParent_Done,
      // Label 9257: @671668
      GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(671768), // Rule ID 5311 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5311,
        GIR_EraseRootFromParent_Done,
      // Label 9258: @671768
      GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(671868), // Rule ID 5315 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5315,
        GIR_EraseRootFromParent_Done,
      // Label 9259: @671868
      GIM_Reject,
    // Label 9247: @671869
    GIM_Reject,
    // Label 9216: @671870
    GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(673104),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(671959), // Rule ID 5316 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5316,
        GIR_EraseRootFromParent_Done,
      // Label 9261: @671959
      GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(672031), // Rule ID 5320 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5320,
        GIR_EraseRootFromParent_Done,
      // Label 9262: @672031
      GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(672103), // Rule ID 5324 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9451:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5324,
        GIR_EraseRootFromParent_Done,
      // Label 9263: @672103
      GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(672175), // Rule ID 5328 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5328,
        GIR_EraseRootFromParent_Done,
      // Label 9264: @672175
      GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(672245), // Rule ID 5317 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5317,
        GIR_EraseRootFromParent_Done,
      // Label 9265: @672245
      GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(672315), // Rule ID 5321 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5321,
        GIR_EraseRootFromParent_Done,
      // Label 9266: @672315
      GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(672385), // Rule ID 5325 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5325,
        GIR_EraseRootFromParent_Done,
      // Label 9267: @672385
      GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(672455), // Rule ID 5329 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5329,
        GIR_EraseRootFromParent_Done,
      // Label 9268: @672455
      GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(672517), // Rule ID 5318 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5318,
        GIR_EraseRootFromParent_Done,
      // Label 9269: @672517
      GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(672579), // Rule ID 5322 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5322,
        GIR_EraseRootFromParent_Done,
      // Label 9270: @672579
      GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(672641), // Rule ID 5326 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5326,
        GIR_EraseRootFromParent_Done,
      // Label 9271: @672641
      GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(672703), // Rule ID 5330 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5330,
        GIR_EraseRootFromParent_Done,
      // Label 9272: @672703
      GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(672803), // Rule ID 5319 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5319,
        GIR_EraseRootFromParent_Done,
      // Label 9273: @672803
      GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(672903), // Rule ID 5323 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5323,
        GIR_EraseRootFromParent_Done,
      // Label 9274: @672903
      GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(673003), // Rule ID 5327 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5327,
        GIR_EraseRootFromParent_Done,
      // Label 9275: @673003
      GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(673103), // Rule ID 5331 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i16:{ *:[v2i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5331,
        GIR_EraseRootFromParent_Done,
      // Label 9276: @673103
      GIM_Reject,
    // Label 9260: @673104
    GIM_Reject,
    // Label 9217: @673105
    GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(673427),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(673194), // Rule ID 5280 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5280,
        GIR_EraseRootFromParent_Done,
      // Label 9278: @673194
      GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(673264), // Rule ID 5281 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5281,
        GIR_EraseRootFromParent_Done,
      // Label 9279: @673264
      GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(673326), // Rule ID 5282 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5282,
        GIR_EraseRootFromParent_Done,
      // Label 9280: @673326
      GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(673426), // Rule ID 5283 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5283,
        GIR_EraseRootFromParent_Done,
      // Label 9281: @673426
      GIM_Reject,
    // Label 9277: @673427
    GIM_Reject,
    // Label 9218: @673428
    GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(673750),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(673517), // Rule ID 5284 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5284,
        GIR_EraseRootFromParent_Done,
      // Label 9283: @673517
      GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(673587), // Rule ID 5285 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5285,
        GIR_EraseRootFromParent_Done,
      // Label 9284: @673587
      GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(673649), // Rule ID 5286 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5286,
        GIR_EraseRootFromParent_Done,
      // Label 9285: @673649
      GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(673749), // Rule ID 5287 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5287,
        GIR_EraseRootFromParent_Done,
      // Label 9286: @673749
      GIM_Reject,
    // Label 9282: @673750
    GIM_Reject,
    // Label 9219: @673751
    GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(674985),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(673840), // Rule ID 5348 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5348,
        GIR_EraseRootFromParent_Done,
      // Label 9288: @673840
      GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(673912), // Rule ID 5352 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5352,
        GIR_EraseRootFromParent_Done,
      // Label 9289: @673912
      GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(673984), // Rule ID 5356 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9450:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5356,
        GIR_EraseRootFromParent_Done,
      // Label 9290: @673984
      GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(674056), // Rule ID 5360 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4i16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5360,
        GIR_EraseRootFromParent_Done,
      // Label 9291: @674056
      GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(674126), // Rule ID 5349 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5349,
        GIR_EraseRootFromParent_Done,
      // Label 9292: @674126
      GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(674196), // Rule ID 5353 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5353,
        GIR_EraseRootFromParent_Done,
      // Label 9293: @674196
      GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(674266), // Rule ID 5357 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5357,
        GIR_EraseRootFromParent_Done,
      // Label 9294: @674266
      GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(674336), // Rule ID 5361 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5361,
        GIR_EraseRootFromParent_Done,
      // Label 9295: @674336
      GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(674398), // Rule ID 5350 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5350,
        GIR_EraseRootFromParent_Done,
      // Label 9296: @674398
      GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(674460), // Rule ID 5354 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5354,
        GIR_EraseRootFromParent_Done,
      // Label 9297: @674460
      GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(674522), // Rule ID 5358 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5358,
        GIR_EraseRootFromParent_Done,
      // Label 9298: @674522
      GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(674584), // Rule ID 5362 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5362,
        GIR_EraseRootFromParent_Done,
      // Label 9299: @674584
      GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(674684), // Rule ID 5351 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5351,
        GIR_EraseRootFromParent_Done,
      // Label 9300: @674684
      GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(674784), // Rule ID 5355 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5355,
        GIR_EraseRootFromParent_Done,
      // Label 9301: @674784
      GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(674884), // Rule ID 5359 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5359,
        GIR_EraseRootFromParent_Done,
      // Label 9302: @674884
      GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(674984), // Rule ID 5363 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i16:{ *:[v4i16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4i16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5363,
        GIR_EraseRootFromParent_Done,
      // Label 9303: @674984
      GIM_Reject,
    // Label 9287: @674985
    GIM_Reject,
    // Label 9220: @674986
    GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(675308),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(675075), // Rule ID 5288 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5288,
        GIR_EraseRootFromParent_Done,
      // Label 9305: @675075
      GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(675145), // Rule ID 5289 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5289,
        GIR_EraseRootFromParent_Done,
      // Label 9306: @675145
      GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(675207), // Rule ID 5290 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5290,
        GIR_EraseRootFromParent_Done,
      // Label 9307: @675207
      GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(675307), // Rule ID 5291 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] Operand 7
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SIbuffer_store_format_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 5291,
        GIR_EraseRootFromParent_Done,
      // Label 9308: @675307
      GIM_Reject,
    // Label 9304: @675308
    GIM_Reject,
    // Label 9221: @675309
    GIM_Reject,
    // Label 142: @675310
    GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(675911),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(675602),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(675407), // Rule ID 5596 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFSET_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5596,
          GIR_EraseRootFromParent_Done,
        // Label 9311: @675407
        GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(675472), // Rule ID 5600 //
          GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFSET_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5600,
          GIR_EraseRootFromParent_Done,
        // Label 9312: @675472
        GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(675538), // Rule ID 5597 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_OFFEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5597,
          GIR_EraseRootFromParent_Done,
        // Label 9313: @675538
        GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(675601), // Rule ID 5601 //
          // MIs[0] offset
          GIM_CheckIsImm, /*MI*/0, /*Op*/5,
          // MIs[0] auxiliary
          GIM_CheckIsImm, /*MI*/0, /*Op*/6,
          // MIs[0] Operand 7
          GIM_CheckLiteralInt, /*MI*/0, /*Op*/7, GIMT_Encode8(0),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_OFFEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/3, // voffset
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5601,
          GIR_EraseRootFromParent_Done,
        // Label 9314: @675601
        GIM_Reject,
      // Label 9310: @675602
      GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(675716),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(675669), // Rule ID 5598 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_IDXEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5598,
          GIR_EraseRootFromParent_Done,
        // Label 9316: @675669
        GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(675715), // Rule ID 5602 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_IDXEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_RootToRootCopy, /*OpIdx*/2, // vindex
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5602,
          GIR_EraseRootFromParent_Done,
        // Label 9317: @675715
        GIM_Reject,
      // Label 9315: @675716
      GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(675910),
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(675821), // Rule ID 5599 //
          GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_BOTHEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5599,
          GIR_EraseRootFromParent_Done,
        // Label 9319: @675821
        GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(675909), // Rule ID 5603 //
          GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
          // (SIbuffer_store_short i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
          GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
          GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
          GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
          GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
          GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
          GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::BUFFER_STORE_SHORT_VBUFFER_BOTHEN_exact),
          GIR_RootToRootCopy, /*OpIdx*/0, // vdata
          GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
          GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
          GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
          GIR_RootToRootCopy, /*OpIdx*/5, // offset
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
          GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
          GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
          GIR_RootConstrainSelectedInstOperands,
          // GIR_Coverage, 5603,
          GIR_EraseRootFromParent_Done,
        // Label 9320: @675909
        GIM_Reject,
      // Label 9318: @675910
      GIM_Reject,
    // Label 9309: @675911
    GIM_Reject,
    // Label 143: @675912
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(12), /*)*//*default:*//*Label 9325*/ GIMT_Encode4(676850),
    /*GILLT_s16*//*Label 9321*/ GIMT_Encode4(675939),
    /*GILLT_s32*//*Label 9322*/ GIMT_Encode4(676108),
    /*GILLT_s64*//*Label 9323*/ GIMT_Encode4(676161),
    /*GILLT_v2s16*//*Label 9324*/ GIMT_Encode4(676271),
    // Label 9321: @675939
    GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(676107),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(675999), // Rule ID 7368 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7368,
        GIR_EraseRootFromParent_Done,
      // Label 9327: @675999
      GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(676054), // Rule ID 7369 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7369,
        GIR_EraseRootFromParent_Done,
      // Label 9328: @676054
      GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(676106), // Rule ID 7370 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (AMDGPUclamp:{ *:[f16] } (VOP3Mods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7370,
        GIR_EraseRootFromParent_Done,
      // Label 9329: @676106
      GIM_Reject,
    // Label 9326: @676107
    GIM_Reject,
    // Label 9322: @676108
    GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(676160), // Rule ID 7365 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
      // (AMDGPUclamp:{ *:[f32] } (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
      GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 7365,
      GIR_EraseRootFromParent_Done,
    // Label 9330: @676160
    GIM_Reject,
    // Label 9323: @676161
    GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(676270),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VReg_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(676221), // Rule ID 7366 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7366,
        GIR_EraseRootFromParent_Done,
      // Label 9332: @676221
      GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(676269), // Rule ID 7367 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods),
        // (AMDGPUclamp:{ *:[f64] } (VOP3Mods:{ *:[f64] } f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_MAX_NUM_F64_e64:{ *:[f64] } i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, i32:{ *:[i32] }:$src0_modifiers, f64:{ *:[f64] }:$src0, 1:{ *:[i1] }, 0:{ *:[i32] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_NUM_F64_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7367,
        GIR_EraseRootFromParent_Done,
      // Label 9333: @676269
      GIM_Reject,
    // Label 9331: @676270
    GIM_Reject,
    // Label 9324: @676271
    GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(676849),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(676537), // Rule ID 2654 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFmaMixInsts),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMA),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fma:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_FMA_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_FMA_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXLO_F16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FMA_MIXHI_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2654,
        GIR_EraseRootFromParent_Done,
      // Label 9335: @676537
      GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(676791), // Rule ID 2643 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadMixInsts_NoFP32Denormals),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
        GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
        GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
        GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
        GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
        GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
        GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FMAD),
        GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/3, /*Op*/3, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
        GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
        GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
        GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_FMAD),
        GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
        GIM_CheckType, /*MI*/5, /*Op*/3, /*Type*/GILLT_s32,
        GIM_CheckIsSafeToFold, /*NumInsns*/5,
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/3, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/2, /*Renderer*/GIMT_Encode2(4), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        GIM_CheckComplexPattern, /*MI*/5, /*Op*/3, /*Renderer*/GIMT_Encode2(5), GIMT_Encode2(GICP_gi_vop3_mad_mix_mods),
        // (AMDGPUclamp:{ *:[v2f16] } (build_vector:{ *:[v2f16] } (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src0, i32:{ *:[i32] }:$lo_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src1, i32:{ *:[i32] }:$lo_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$lo_src2, i32:{ *:[i32] }:$lo_src2_modifiers))), (fpround:{ *:[f16] } (fmad:{ *:[f32] } (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src0, i32:{ *:[i32] }:$hi_src0_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src1, i32:{ *:[i32] }:$hi_src1_modifiers), (VOP3PMadMixMods:{ *:[f32] } f16:{ *:[f16] }:$hi_src2, i32:{ *:[i32] }:$hi_src2_modifiers)))))  =>  (V_MAD_MIXHI_F16:{ *:[v2f16] } ?:{ *:[i32] }:$hi_src0_modifiers, ?:{ *:[f16] }:$hi_src0, ?:{ *:[i32] }:$hi_src1_modifiers, ?:{ *:[f16] }:$hi_src1, ?:{ *:[i32] }:$hi_src2_modifiers, ?:{ *:[f16] }:$hi_src2, 1:{ *:[i1] }, (V_MAD_MIXLO_F16:{ *:[i16] } ?:{ *:[i32] }:$lo_src0_modifiers, ?:{ *:[f16] }:$lo_src0, ?:{ *:[i32] }:$lo_src1_modifiers, ?:{ *:[f16] }:$lo_src1, ?:{ *:[i32] }:$lo_src2_modifiers, ?:{ *:[f16] }:$lo_src2, 1:{ *:[i1] }, (IMPLICIT_DEF:{ *:[i32] })))
        GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
        GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
        GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXLO_F16),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // lo_src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // lo_src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // lo_src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // lo_src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // lo_src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // lo_src2
        GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAD_MIXHI_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/1, // hi_src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // hi_src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/1, // hi_src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(4), /*SubOperand*/0, // hi_src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/1, // hi_src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(5), /*SubOperand*/0, // hi_src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2643,
        GIR_EraseRootFromParent_Done,
      // Label 9336: @676791
      GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(676848), // Rule ID 7371 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVOP3PInsts),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3pmods),
        // (AMDGPUclamp:{ *:[v2f16] } (VOP3PMods:{ *:[v2f16] } v2f16:{ *:[v2f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers))  =>  (V_PK_MAX_F16:{ *:[v2f16] } ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, ?:{ *:[i32] }:$src0_modifiers, ?:{ *:[v2f16] }:$src0, 1:{ *:[i1] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_PK_MAX_F16),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 7371,
        GIR_EraseRootFromParent_Done,
      // Label 9337: @676848
      GIM_Reject,
    // Label 9334: @676849
    GIM_Reject,
    // Label 9325: @676850
    GIM_Reject,
    // Label 144: @676851
    GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(676895), // Rule ID 652 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUcvt_f32_ubyte0:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE0_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE0_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 652,
      GIR_EraseRootFromParent_Done,
    // Label 9338: @676895
    GIM_Reject,
    // Label 145: @676896
    GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(676940), // Rule ID 653 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUcvt_f32_ubyte1:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE1_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE1_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 653,
      GIR_EraseRootFromParent_Done,
    // Label 9339: @676940
    GIM_Reject,
    // Label 146: @676941
    GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(676985), // Rule ID 654 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUcvt_f32_ubyte2:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE2_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE2_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 654,
      GIR_EraseRootFromParent_Done,
    // Label 9340: @676985
    GIM_Reject,
    // Label 147: @676986
    GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(677030), // Rule ID 655 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUcvt_f32_ubyte3:{ *:[f32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_CVT_F32_UBYTE3_e64:{ *:[f32] } i32:{ *:[i32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_F32_UBYTE3_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 655,
      GIR_EraseRootFromParent_Done,
    // Label 9341: @677030
    GIM_Reject,
    // Label 148: @677031
    GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(677060), // Rule ID 832 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      // (AMDGPUpk_i16_i32_impl:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)  =>  (V_CVT_PK_I16_I32_e64:{ *:[v2i16] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1)
      GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::V_CVT_PK_I16_I32_e64),
      GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AMDGPU::EXEC),
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 832,
      GIR_Done,
    // Label 9342: @677060
    GIM_Reject,
    // Label 149: @677061
    GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(677162),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9346*/ GIMT_Encode4(677130),
      /*GILLT_s32*//*Label 9344*/ GIMT_Encode4(677088),
      /*GILLT_s64*//*Label 9345*/ GIMT_Encode4(677109),
      // Label 9344: @677088
      GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(677108), // Rule ID 13 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13366),
        // (AMDGPUffbh_u32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13366>>  =>  (S_FLBIT_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 13,
        GIR_Done,
      // Label 9347: @677108
      GIM_Reject,
      // Label 9345: @677109
      GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(677129), // Rule ID 15 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13366),
        // (AMDGPUffbh_u32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13366>>  =>  (S_FLBIT_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FLBIT_I32_B64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 15,
        GIR_Done,
      // Label 9348: @677129
      GIM_Reject,
      // Label 9346: @677130
      GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(677161), // Rule ID 683 //
        GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (AMDGPUffbh_u32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBH_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBH_U32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 683,
        GIR_EraseRootFromParent_Done,
      // Label 9349: @677161
      GIM_Reject,
    // Label 9343: @677162
    GIM_Reject,
    // Label 150: @677163
    GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(677261),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(9), GIMT_Encode2(11), /*)*//*default:*//*Label 9353*/ GIMT_Encode4(677260),
      /*GILLT_s32*//*Label 9351*/ GIMT_Encode4(677190),
      /*GILLT_s64*//*Label 9352*/ GIMT_Encode4(677239),
      // Label 9351: @677190
      GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(677210), // Rule ID 11 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13365),
        // (AMDGPUffbl_b32_impl:{ *:[i32] } i32:{ *:[i32] }:$src0)<<P:Predicate_anonymous_13365>>  =>  (S_FF1_I32_B32:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B32),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 11,
        GIR_Done,
      // Label 9354: @677210
      GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(677238), // Rule ID 685 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
        // (AMDGPUffbl_b32_impl:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0))  =>  (V_FFBL_B32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_FFBL_B32_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 685,
        GIR_EraseRootFromParent_Done,
      // Label 9355: @677238
      GIM_Reject,
      // Label 9352: @677239
      GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(677259), // Rule ID 9 //
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_13365),
        // (AMDGPUffbl_b32_impl:{ *:[i32] } i64:{ *:[i64] }:$src0)<<P:Predicate_anonymous_13365>>  =>  (S_FF1_I32_B64:{ *:[i32] } i64:{ *:[i64] }:$src0)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AMDGPU::S_FF1_I32_B64),
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 9,
        GIR_Done,
      // Label 9356: @677259
      GIM_Reject,
      // Label 9353: @677260
      GIM_Reject,
    // Label 9350: @677261
    GIM_Reject,
    // Label 151: @677262
    GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(677334), // Rule ID 834 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (AMDGPUfmax_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MAX_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MAX_LEGACY_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 834,
      GIR_EraseRootFromParent_Done,
    // Label 9357: @677334
    GIM_Reject,
    // Label 152: @677335
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9360*/ GIMT_Encode4(677694),
    /*GILLT_s16*//*Label 9358*/ GIMT_Encode4(677354),
    /*GILLT_s32*//*Label 9359*/ GIMT_Encode4(677607),
    // Label 9358: @677354
    GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(677606),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(677447), // Rule ID 1011 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1011,
        GIR_EraseRootFromParent_Done,
      // Label 9362: @677447
      GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(677526), // Rule ID 1013 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_t16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1013,
        GIR_EraseRootFromParent_Done,
      // Label 9363: @677526
      GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(677605), // Rule ID 1015 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUfmed3_impl:{ *:[f16] } (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[f16] } f16:{ *:[f16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F16_fake16_e64:{ *:[f16] } i32:{ *:[i32] }:$src0_modifiers, f16:{ *:[f16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f16:{ *:[f16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f16:{ *:[f16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1015,
        GIR_EraseRootFromParent_Done,
      // Label 9364: @677605
      GIM_Reject,
    // Label 9361: @677606
    GIM_Reject,
    // Label 9359: @677607
    GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(677693), // Rule ID 968 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3mods),
      // (AMDGPUfmed3_impl:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src2_modifiers, f32:{ *:[f32] }:$src2, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 968,
      GIR_EraseRootFromParent_Done,
    // Label 9365: @677693
    GIM_Reject,
    // Label 9360: @677694
    GIM_Reject,
    // Label 153: @677695
    GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(677767), // Rule ID 833 //
      GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX6GFX7),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3mods),
      // (AMDGPUfmin_legacy:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod), (VOP3Mods:{ *:[f32] } f32:{ *:[f32] }:$src1, i32:{ *:[i32] }:$src1_modifiers))  =>  (V_MIN_LEGACY_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src1_modifiers, f32:{ *:[f32] }:$src1, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MIN_LEGACY_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 833,
      GIR_EraseRootFromParent_Done,
    // Label 9366: @677767
    GIM_Reject,
    // Label 154: @677768
    GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(677817), // Rule ID 668 //
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUrcp_iflag:{ *:[f32] } (VOP3Mods0:{ *:[f32] } f32:{ *:[f32] }:$src0, i32:{ *:[i32] }:$src0_modifiers, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod))  =>  (V_RCP_IFLAG_F32_e64:{ *:[f32] } i32:{ *:[i32] }:$src0_modifiers, f32:{ *:[f32] }:$src0, i1:{ *:[i1] }:$clamp, i32:{ *:[i32] }:$omod)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_RCP_IFLAG_F32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // clamp
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/3, // omod
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 668,
      GIR_EraseRootFromParent_Done,
    // Label 9367: @677817
    GIM_Reject,
    // Label 155: @677818
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9370*/ GIMT_Encode4(678123),
    /*GILLT_s16*//*Label 9368*/ GIMT_Encode4(677837),
    /*GILLT_s32*//*Label 9369*/ GIMT_Encode4(678081),
    // Label 9368: @677837
    GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(678080),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(677927), // Rule ID 1016 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1016,
        GIR_EraseRootFromParent_Done,
      // Label 9372: @677927
      GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(678003), // Rule ID 1017 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1017,
        GIR_EraseRootFromParent_Done,
      // Label 9373: @678003
      GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(678079), // Rule ID 1018 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUsmed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_I16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1018,
        GIR_EraseRootFromParent_Done,
      // Label 9374: @678079
      GIM_Reject,
    // Label 9371: @678080
    GIM_Reject,
    // Label 9369: @678081
    GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(678122), // Rule ID 963 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUsmed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_I32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_I32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_RootToRootCopy, /*OpIdx*/3, // src2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 963,
      GIR_EraseRootFromParent_Done,
    // Label 9375: @678122
    GIM_Reject,
    // Label 9370: @678123
    GIM_Reject,
    // Label 156: @678124
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(31), /*)*//*default:*//*Label 9382*/ GIMT_Encode4(680425),
    /*GILLT_s32*//*Label 9376*/ GIMT_Encode4(678223), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 9377*/ GIMT_Encode4(678603), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9378*/ GIMT_Encode4(678983), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 9379*/ GIMT_Encode4(679285), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v8s32*//*Label 9380*/ GIMT_Encode4(679665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v16s32*//*Label 9381*/ GIMT_Encode4(680045),
    // Label 9376: @678223
    GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(678602),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(678285), // Rule ID 2805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2805,
        GIR_EraseRootFromParent_Done,
      // Label 9384: @678285
      GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(678329), // Rule ID 3490 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3490,
        GIR_EraseRootFromParent_Done,
      // Label 9385: @678329
      GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(678365), // Rule ID 2801 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2801,
        GIR_EraseRootFromParent_Done,
      // Label 9386: @678365
      GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(678401), // Rule ID 3486 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3486,
        GIR_EraseRootFromParent_Done,
      // Label 9387: @678401
      GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(678440), // Rule ID 2802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2802,
        GIR_EraseRootFromParent_Done,
      // Label 9388: @678440
      GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(678479), // Rule ID 3487 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_IMM_ci:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3487,
        GIR_EraseRootFromParent_Done,
      // Label 9389: @678479
      GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(678508), // Rule ID 2803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2803,
        GIR_EraseRootFromParent_Done,
      // Label 9390: @678508
      GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(678540), // Rule ID 2804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2804,
        GIR_EraseRootFromParent_Done,
      // Label 9391: @678540
      GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(678569), // Rule ID 3488 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3488,
        GIR_EraseRootFromParent_Done,
      // Label 9392: @678569
      GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(678601), // Rule ID 3489 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORD_SGPR_IMM:{ *:[f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORD_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3489,
        GIR_EraseRootFromParent_Done,
      // Label 9393: @678601
      GIM_Reject,
    // Label 9383: @678602
    GIM_Reject,
    // Label 9377: @678603
    GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(678982),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_64_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(678665), // Rule ID 3466 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3466,
        GIR_EraseRootFromParent_Done,
      // Label 9395: @678665
      GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(678709), // Rule ID 3495 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3495,
        GIR_EraseRootFromParent_Done,
      // Label 9396: @678709
      GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(678745), // Rule ID 3462 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3462,
        GIR_EraseRootFromParent_Done,
      // Label 9397: @678745
      GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(678781), // Rule ID 3491 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3491,
        GIR_EraseRootFromParent_Done,
      // Label 9398: @678781
      GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(678820), // Rule ID 3463 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3463,
        GIR_EraseRootFromParent_Done,
      // Label 9399: @678820
      GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(678859), // Rule ID 3492 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_IMM_ci:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3492,
        GIR_EraseRootFromParent_Done,
      // Label 9400: @678859
      GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(678888), // Rule ID 3464 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3464,
        GIR_EraseRootFromParent_Done,
      // Label 9401: @678888
      GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(678920), // Rule ID 3465 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3465,
        GIR_EraseRootFromParent_Done,
      // Label 9402: @678920
      GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(678949), // Rule ID 3493 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3493,
        GIR_EraseRootFromParent_Done,
      // Label 9403: @678949
      GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(678981), // Rule ID 3494 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX2_SGPR_IMM:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX2_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3494,
        GIR_EraseRootFromParent_Done,
      // Label 9404: @678981
      GIM_Reject,
    // Label 9394: @678982
    GIM_Reject,
    // Label 9378: @678983
    GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(679284),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_96RegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(679045), // Rule ID 3470 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3470,
        GIR_EraseRootFromParent_Done,
      // Label 9406: @679045
      GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(679089), // Rule ID 3499 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3499,
        GIR_EraseRootFromParent_Done,
      // Label 9407: @679089
      GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(679125), // Rule ID 3467 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3467,
        GIR_EraseRootFromParent_Done,
      // Label 9408: @679125
      GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(679161), // Rule ID 3496 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3496,
        GIR_EraseRootFromParent_Done,
      // Label 9409: @679161
      GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(679190), // Rule ID 3468 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3468,
        GIR_EraseRootFromParent_Done,
      // Label 9410: @679190
      GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(679222), // Rule ID 3469 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3469,
        GIR_EraseRootFromParent_Done,
      // Label 9411: @679222
      GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(679251), // Rule ID 3497 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3497,
        GIR_EraseRootFromParent_Done,
      // Label 9412: @679251
      GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(679283), // Rule ID 3498 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX3_SGPR_IMM:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX3_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3498,
        GIR_EraseRootFromParent_Done,
      // Label 9413: @679283
      GIM_Reject,
    // Label 9405: @679284
    GIM_Reject,
    // Label 9379: @679285
    GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(679664),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_128RegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(679347), // Rule ID 3475 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3475,
        GIR_EraseRootFromParent_Done,
      // Label 9415: @679347
      GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(679391), // Rule ID 3504 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3504,
        GIR_EraseRootFromParent_Done,
      // Label 9416: @679391
      GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(679427), // Rule ID 3471 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3471,
        GIR_EraseRootFromParent_Done,
      // Label 9417: @679427
      GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(679463), // Rule ID 3500 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3500,
        GIR_EraseRootFromParent_Done,
      // Label 9418: @679463
      GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(679502), // Rule ID 3472 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3472,
        GIR_EraseRootFromParent_Done,
      // Label 9419: @679502
      GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(679541), // Rule ID 3501 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_IMM_ci:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3501,
        GIR_EraseRootFromParent_Done,
      // Label 9420: @679541
      GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(679570), // Rule ID 3473 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3473,
        GIR_EraseRootFromParent_Done,
      // Label 9421: @679570
      GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(679602), // Rule ID 3474 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3474,
        GIR_EraseRootFromParent_Done,
      // Label 9422: @679602
      GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(679631), // Rule ID 3502 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3502,
        GIR_EraseRootFromParent_Done,
      // Label 9423: @679631
      GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(679663), // Rule ID 3503 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX4_SGPR_IMM:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX4_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3503,
        GIR_EraseRootFromParent_Done,
      // Label 9424: @679663
      GIM_Reject,
    // Label 9414: @679664
    GIM_Reject,
    // Label 9380: @679665
    GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(680044),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_256RegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(679727), // Rule ID 3480 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3480,
        GIR_EraseRootFromParent_Done,
      // Label 9426: @679727
      GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(679771), // Rule ID 3509 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3509,
        GIR_EraseRootFromParent_Done,
      // Label 9427: @679771
      GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(679807), // Rule ID 3476 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3476,
        GIR_EraseRootFromParent_Done,
      // Label 9428: @679807
      GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(679843), // Rule ID 3505 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3505,
        GIR_EraseRootFromParent_Done,
      // Label 9429: @679843
      GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(679882), // Rule ID 3477 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3477,
        GIR_EraseRootFromParent_Done,
      // Label 9430: @679882
      GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(679921), // Rule ID 3506 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_IMM_ci:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3506,
        GIR_EraseRootFromParent_Done,
      // Label 9431: @679921
      GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(679950), // Rule ID 3478 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3478,
        GIR_EraseRootFromParent_Done,
      // Label 9432: @679950
      GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(679982), // Rule ID 3479 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v8i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3479,
        GIR_EraseRootFromParent_Done,
      // Label 9433: @679982
      GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(680011), // Rule ID 3507 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3507,
        GIR_EraseRootFromParent_Done,
      // Label 9434: @680011
      GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(680043), // Rule ID 3508 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v8f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX8_SGPR_IMM:{ *:[v8f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3508,
        GIR_EraseRootFromParent_Done,
      // Label 9435: @680043
      GIM_Reject,
    // Label 9425: @680044
    GIM_Reject,
    // Label 9381: @680045
    GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(680424),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_512RegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(680107), // Rule ID 3485 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3485,
        GIR_EraseRootFromParent_Done,
      // Label 9437: @680107
      GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(680151), // Rule ID 3514 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3514,
        GIR_EraseRootFromParent_Done,
      // Label 9438: @680151
      GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(680187), // Rule ID 3481 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3481,
        GIR_EraseRootFromParent_Done,
      // Label 9439: @680187
      GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(680223), // Rule ID 3510 //
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3510,
        GIR_EraseRootFromParent_Done,
      // Label 9440: @680223
      GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(680262), // Rule ID 3482 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3482,
        GIR_EraseRootFromParent_Done,
      // Label 9441: @680262
      GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(680301), // Rule ID 3511 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX7Only),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm32),
        // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm32:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_IMM_ci:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, smrd_literal_offset:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_IMM_ci),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3511,
        GIR_EraseRootFromParent_Done,
      // Label 9442: @680301
      GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(680330), // Rule ID 3483 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3483,
        GIR_EraseRootFromParent_Done,
      // Label 9443: @680330
      GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(680362), // Rule ID 3484 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v16i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3484,
        GIR_EraseRootFromParent_Done,
      // Label 9444: @680362
      GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(680391), // Rule ID 3512 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isNotGFX9Plus),
        // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3512,
        GIR_EraseRootFromParent_Done,
      // Label 9445: @680391
      GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(680423), // Rule ID 3513 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX9Plus),
        // (SIsbuffer_load:{ *:[v16f32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_DWORDX16_SGPR_IMM:{ *:[v16f32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_DWORDX16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3513,
        GIR_EraseRootFromParent_Done,
      // Label 9446: @680423
      GIM_Reject,
    // Label 9436: @680424
    GIM_Reject,
    // Label 9382: @680425
    GIM_Reject,
    // Label 157: @680426
    GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(680563),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(680491), // Rule ID 2812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2812,
        GIR_EraseRootFromParent_Done,
      // Label 9448: @680491
      GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(680530), // Rule ID 2810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2810,
        GIR_EraseRootFromParent_Done,
      // Label 9449: @680530
      GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(680562), // Rule ID 2811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        // (SIsbuffer_load_byte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2811,
        GIR_EraseRootFromParent_Done,
      // Label 9450: @680562
      GIM_Reject,
    // Label 9447: @680563
    GIM_Reject,
    // Label 158: @680564
    GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(680701),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(680629), // Rule ID 2838 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2838,
        GIR_EraseRootFromParent_Done,
      // Label 9452: @680629
      GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(680668), // Rule ID 2836 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2836,
        GIR_EraseRootFromParent_Done,
      // Label 9453: @680668
      GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(680700), // Rule ID 2837 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        // (SIsbuffer_load_short:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_I16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_I16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2837,
        GIR_EraseRootFromParent_Done,
      // Label 9454: @680700
      GIM_Reject,
    // Label 9451: @680701
    GIM_Reject,
    // Label 159: @680702
    GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(680839),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(680767), // Rule ID 2835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2835,
        GIR_EraseRootFromParent_Done,
      // Label 9456: @680767
      GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(680806), // Rule ID 2833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2833,
        GIR_EraseRootFromParent_Done,
      // Label 9457: @680806
      GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(680838), // Rule ID 2834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        // (SIsbuffer_load_ubyte:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U8_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U8_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2834,
        GIR_EraseRootFromParent_Done,
      // Label 9458: @680838
      GIM_Reject,
    // Label 9455: @680839
    GIM_Reject,
    // Label 160: @680840
    GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(680977),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::SReg_32_XM0_XEXECRegClassID),
      GIM_CheckIsImm, /*MI*/0, /*Op*/3,
      GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(680905), // Rule ID 2841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_sgpr_imm),
        // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferSgprImm:{ *:[i32] } i32:{ *:[i32] }:$soffset, i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2841,
        GIR_EraseRootFromParent_Done,
      // Label 9460: @680905
      GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(680944), // Rule ID 2839 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2839,
        GIR_EraseRootFromParent_Done,
      // Label 9461: @680944
      GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(680976), // Rule ID 2840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        // (SIsbuffer_load_ushort:{ *:[i32] } v4i32:{ *:[v4i32] }:$sbase, i32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$cachepolicy)  =>  (S_BUFFER_LOAD_U16_SGPR_IMM:{ *:[i32] } SReg_128:{ *:[v4i32] }:$sbase, SReg_32:{ *:[i32] }:$soffset, 0:{ *:[i32] }, (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$cachepolicy))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_LOAD_U16_SGPR_IMM),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[sdst]
        GIR_RootToRootCopy, /*OpIdx*/1, // sbase
        GIR_RootToRootCopy, /*OpIdx*/2, // soffset
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/3, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // cachepolicy
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 2840,
        GIR_EraseRootFromParent_Done,
      // Label 9462: @680976
      GIM_Reject,
    // Label 9459: @680977
    GIM_Reject,
    // Label 161: @680978
    GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(681084),
      GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(681043), // Rule ID 3530 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*NumInsns*/1,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), (imm:{ *:[i32] }):$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, SGPR_NULL:{ *:[i32] }, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$len))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
        GIR_RootToRootCopy, /*OpIdx*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AMDGPU::SGPR_NULL), /*AddRegisterRegFlags*/GIMT_Encode2(0),
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // len
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3530,
        GIR_EraseRootFromParent_Done,
      // Label 9464: @681043
      GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(681083), // Rule ID 3529 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_isGFX12Plus),
        GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AMDGPU::SReg_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_smrd_buffer_imm),
        // (SIsbuffer_prefetch v4i32:{ *:[v4i32] }:$sbase, (SMRDBufferImm:{ *:[i32] } i32:{ *:[i32] }:$offset), SReg_32:{ *:[i32] }:$len)  =>  (S_BUFFER_PREFETCH_DATA SReg_128:{ *:[v4i32] }:$sbase, i32imm:{ *:[i32] }:$offset, ?:{ *:[i32] }:$len, 0:{ *:[i8] })
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::S_BUFFER_PREFETCH_DATA),
        GIR_RootToRootCopy, /*OpIdx*/0, // sbase
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // offset
        GIR_RootToRootCopy, /*OpIdx*/2, // len
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 3529,
        GIR_EraseRootFromParent_Done,
      // Label 9465: @681083
      GIM_Reject,
    // Label 9463: @681084
    GIM_Reject,
    // Label 162: @681085
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9470*/ GIMT_Encode4(686568),
    /*GILLT_s32*//*Label 9466*/ GIMT_Encode4(681132), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 9467*/ GIMT_Encode4(682491), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9468*/ GIMT_Encode4(683850), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 9469*/ GIMT_Encode4(685209),
    // Label 9466: @681132
    GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(682490),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(681234), // Rule ID 6708 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6708,
        GIR_EraseRootFromParent_Done,
      // Label 9472: @681234
      GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(681312), // Rule ID 6712 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6712,
        GIR_EraseRootFromParent_Done,
      // Label 9473: @681312
      GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(681393), // Rule ID 6740 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6740,
        GIR_EraseRootFromParent_Done,
      // Label 9474: @681393
      GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(681471), // Rule ID 6744 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET:{ *:[f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6744,
        GIR_EraseRootFromParent_Done,
      // Label 9475: @681471
      GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(681550), // Rule ID 6710 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6710,
        GIR_EraseRootFromParent_Done,
      // Label 9476: @681550
      GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(681626), // Rule ID 6714 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6714,
        GIR_EraseRootFromParent_Done,
      // Label 9477: @681626
      GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(681705), // Rule ID 6742 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6742,
        GIR_EraseRootFromParent_Done,
      // Label 9478: @681705
      GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(681781), // Rule ID 6746 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6746,
        GIR_EraseRootFromParent_Done,
      // Label 9479: @681781
      GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(681852), // Rule ID 6709 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6709,
        GIR_EraseRootFromParent_Done,
      // Label 9480: @681852
      GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(681920), // Rule ID 6713 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6713,
        GIR_EraseRootFromParent_Done,
      // Label 9481: @681920
      GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(681991), // Rule ID 6741 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6741,
        GIR_EraseRootFromParent_Done,
      // Label 9482: @681991
      GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(682059), // Rule ID 6745 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN:{ *:[f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6745,
        GIR_EraseRootFromParent_Done,
      // Label 9483: @682059
      GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(682168), // Rule ID 6711 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6711,
        GIR_EraseRootFromParent_Done,
      // Label 9484: @682168
      GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(682274), // Rule ID 6715 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6715,
        GIR_EraseRootFromParent_Done,
      // Label 9485: @682274
      GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(682383), // Rule ID 6743 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6743,
        GIR_EraseRootFromParent_Done,
      // Label 9486: @682383
      GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(682489), // Rule ID 6747 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN:{ *:[f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6747,
        GIR_EraseRootFromParent_Done,
      // Label 9487: @682489
      GIM_Reject,
    // Label 9471: @682490
    GIM_Reject,
    // Label 9467: @682491
    GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(683849),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(682593), // Rule ID 6716 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6716,
        GIR_EraseRootFromParent_Done,
      // Label 9489: @682593
      GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(682671), // Rule ID 6720 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6720,
        GIR_EraseRootFromParent_Done,
      // Label 9490: @682671
      GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(682752), // Rule ID 6748 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6748,
        GIR_EraseRootFromParent_Done,
      // Label 9491: @682752
      GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(682830), // Rule ID 6752 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET:{ *:[v2f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6752,
        GIR_EraseRootFromParent_Done,
      // Label 9492: @682830
      GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(682909), // Rule ID 6718 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6718,
        GIR_EraseRootFromParent_Done,
      // Label 9493: @682909
      GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(682985), // Rule ID 6722 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6722,
        GIR_EraseRootFromParent_Done,
      // Label 9494: @682985
      GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(683064), // Rule ID 6750 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6750,
        GIR_EraseRootFromParent_Done,
      // Label 9495: @683064
      GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(683140), // Rule ID 6754 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6754,
        GIR_EraseRootFromParent_Done,
      // Label 9496: @683140
      GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(683211), // Rule ID 6717 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6717,
        GIR_EraseRootFromParent_Done,
      // Label 9497: @683211
      GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(683279), // Rule ID 6721 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6721,
        GIR_EraseRootFromParent_Done,
      // Label 9498: @683279
      GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(683350), // Rule ID 6749 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6749,
        GIR_EraseRootFromParent_Done,
      // Label 9499: @683350
      GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(683418), // Rule ID 6753 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN:{ *:[v2f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6753,
        GIR_EraseRootFromParent_Done,
      // Label 9500: @683418
      GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(683527), // Rule ID 6719 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6719,
        GIR_EraseRootFromParent_Done,
      // Label 9501: @683527
      GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(683633), // Rule ID 6723 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6723,
        GIR_EraseRootFromParent_Done,
      // Label 9502: @683633
      GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(683742), // Rule ID 6751 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6751,
        GIR_EraseRootFromParent_Done,
      // Label 9503: @683742
      GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(683848), // Rule ID 6755 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v2f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN:{ *:[v2f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6755,
        GIR_EraseRootFromParent_Done,
      // Label 9504: @683848
      GIM_Reject,
    // Label 9488: @683849
    GIM_Reject,
    // Label 9468: @683850
    GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(685208),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(683952), // Rule ID 6724 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6724,
        GIR_EraseRootFromParent_Done,
      // Label 9506: @683952
      GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(684030), // Rule ID 6728 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6728,
        GIR_EraseRootFromParent_Done,
      // Label 9507: @684030
      GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(684111), // Rule ID 6756 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6756,
        GIR_EraseRootFromParent_Done,
      // Label 9508: @684111
      GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(684189), // Rule ID 6760 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET:{ *:[v3f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6760,
        GIR_EraseRootFromParent_Done,
      // Label 9509: @684189
      GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(684268), // Rule ID 6726 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6726,
        GIR_EraseRootFromParent_Done,
      // Label 9510: @684268
      GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(684344), // Rule ID 6730 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6730,
        GIR_EraseRootFromParent_Done,
      // Label 9511: @684344
      GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(684423), // Rule ID 6758 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6758,
        GIR_EraseRootFromParent_Done,
      // Label 9512: @684423
      GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(684499), // Rule ID 6762 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6762,
        GIR_EraseRootFromParent_Done,
      // Label 9513: @684499
      GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(684570), // Rule ID 6725 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6725,
        GIR_EraseRootFromParent_Done,
      // Label 9514: @684570
      GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(684638), // Rule ID 6729 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6729,
        GIR_EraseRootFromParent_Done,
      // Label 9515: @684638
      GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(684709), // Rule ID 6757 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6757,
        GIR_EraseRootFromParent_Done,
      // Label 9516: @684709
      GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(684777), // Rule ID 6761 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN:{ *:[v3f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6761,
        GIR_EraseRootFromParent_Done,
      // Label 9517: @684777
      GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(684886), // Rule ID 6727 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6727,
        GIR_EraseRootFromParent_Done,
      // Label 9518: @684886
      GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(684992), // Rule ID 6731 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6731,
        GIR_EraseRootFromParent_Done,
      // Label 9519: @684992
      GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(685101), // Rule ID 6759 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6759,
        GIR_EraseRootFromParent_Done,
      // Label 9520: @685101
      GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(685207), // Rule ID 6763 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v3f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN:{ *:[v3f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6763,
        GIR_EraseRootFromParent_Done,
      // Label 9521: @685207
      GIM_Reject,
    // Label 9505: @685208
    GIM_Reject,
    // Label 9469: @685209
    GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(686567),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(685311), // Rule ID 6732 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6732,
        GIR_EraseRootFromParent_Done,
      // Label 9523: @685311
      GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(685389), // Rule ID 6736 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6736,
        GIR_EraseRootFromParent_Done,
      // Label 9524: @685389
      GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(685470), // Rule ID 6764 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6764,
        GIR_EraseRootFromParent_Done,
      // Label 9525: @685470
      GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(685548), // Rule ID 6768 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET:{ *:[v4f32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6768,
        GIR_EraseRootFromParent_Done,
      // Label 9526: @685548
      GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(685627), // Rule ID 6734 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6734,
        GIR_EraseRootFromParent_Done,
      // Label 9527: @685627
      GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(685703), // Rule ID 6738 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6738,
        GIR_EraseRootFromParent_Done,
      // Label 9528: @685703
      GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(685782), // Rule ID 6766 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6766,
        GIR_EraseRootFromParent_Done,
      // Label 9529: @685782
      GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(685858), // Rule ID 6770 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6770,
        GIR_EraseRootFromParent_Done,
      // Label 9530: @685858
      GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(685929), // Rule ID 6733 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6733,
        GIR_EraseRootFromParent_Done,
      // Label 9531: @685929
      GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(685997), // Rule ID 6737 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6737,
        GIR_EraseRootFromParent_Done,
      // Label 9532: @685997
      GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(686068), // Rule ID 6765 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6765,
        GIR_EraseRootFromParent_Done,
      // Label 9533: @686068
      GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(686136), // Rule ID 6769 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN:{ *:[v4f32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6769,
        GIR_EraseRootFromParent_Done,
      // Label 9534: @686136
      GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(686245), // Rule ID 6735 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6735,
        GIR_EraseRootFromParent_Done,
      // Label 9535: @686245
      GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(686351), // Rule ID 6739 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6739,
        GIR_EraseRootFromParent_Done,
      // Label 9536: @686351
      GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(686460), // Rule ID 6767 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6767,
        GIR_EraseRootFromParent_Done,
      // Label 9537: @686460
      GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(686566), // Rule ID 6771 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN:{ *:[v4f32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6771,
        GIR_EraseRootFromParent_Done,
      // Label 9538: @686566
      GIM_Reject,
    // Label 9522: @686567
    GIM_Reject,
    // Label 9470: @686568
    GIM_Reject,
    // Label 163: @686569
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9546*/ GIMT_Encode4(691997),
    /*GILLT_s16*//*Label 9539*/ GIMT_Encode4(686620),
    /*GILLT_s32*//*Label 9540*/ GIMT_Encode4(687663), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 9541*/ GIMT_Encode4(688706),
    /*GILLT_v2s32*//*Label 9542*/ GIMT_Encode4(689409), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9543*/ GIMT_Encode4(689772), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 9544*/ GIMT_Encode4(690135),
    /*GILLT_v4s32*//*Label 9545*/ GIMT_Encode4(691634),
    // Label 9539: @686620
    GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(687662),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(686722), // Rule ID 6772 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6772,
        GIR_EraseRootFromParent_Done,
      // Label 9548: @686722
      GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(686803), // Rule ID 6792 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6792,
        GIR_EraseRootFromParent_Done,
      // Label 9549: @686803
      GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(686884), // Rule ID 6796 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6796,
        GIR_EraseRootFromParent_Done,
      // Label 9550: @686884
      GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(686963), // Rule ID 6774 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6774,
        GIR_EraseRootFromParent_Done,
      // Label 9551: @686963
      GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(687042), // Rule ID 6794 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6794,
        GIR_EraseRootFromParent_Done,
      // Label 9552: @687042
      GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(687121), // Rule ID 6798 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6798,
        GIR_EraseRootFromParent_Done,
      // Label 9553: @687121
      GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(687192), // Rule ID 6773 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6773,
        GIR_EraseRootFromParent_Done,
      // Label 9554: @687192
      GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(687263), // Rule ID 6793 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6793,
        GIR_EraseRootFromParent_Done,
      // Label 9555: @687263
      GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(687334), // Rule ID 6797 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6797,
        GIR_EraseRootFromParent_Done,
      // Label 9556: @687334
      GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(687443), // Rule ID 6775 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6775,
        GIR_EraseRootFromParent_Done,
      // Label 9557: @687443
      GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(687552), // Rule ID 6795 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6795,
        GIR_EraseRootFromParent_Done,
      // Label 9558: @687552
      GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(687661), // Rule ID 6799 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6799,
        GIR_EraseRootFromParent_Done,
      // Label 9559: @687661
      GIM_Reject,
    // Label 9547: @687662
    GIM_Reject,
    // Label 9540: @687663
    GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(688705),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(687765), // Rule ID 6776 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6776,
        GIR_EraseRootFromParent_Done,
      // Label 9561: @687765
      GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(687846), // Rule ID 6800 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6800,
        GIR_EraseRootFromParent_Done,
      // Label 9562: @687846
      GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(687927), // Rule ID 6804 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET:{ *:[i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6804,
        GIR_EraseRootFromParent_Done,
      // Label 9563: @687927
      GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(688006), // Rule ID 6778 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6778,
        GIR_EraseRootFromParent_Done,
      // Label 9564: @688006
      GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(688085), // Rule ID 6802 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6802,
        GIR_EraseRootFromParent_Done,
      // Label 9565: @688085
      GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(688164), // Rule ID 6806 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6806,
        GIR_EraseRootFromParent_Done,
      // Label 9566: @688164
      GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(688235), // Rule ID 6777 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6777,
        GIR_EraseRootFromParent_Done,
      // Label 9567: @688235
      GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(688306), // Rule ID 6801 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6801,
        GIR_EraseRootFromParent_Done,
      // Label 9568: @688306
      GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(688377), // Rule ID 6805 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN:{ *:[i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6805,
        GIR_EraseRootFromParent_Done,
      // Label 9569: @688377
      GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(688486), // Rule ID 6779 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6779,
        GIR_EraseRootFromParent_Done,
      // Label 9570: @688486
      GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(688595), // Rule ID 6803 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6803,
        GIR_EraseRootFromParent_Done,
      // Label 9571: @688595
      GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(688704), // Rule ID 6807 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN:{ *:[i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_X_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6807,
        GIR_EraseRootFromParent_Done,
      // Label 9572: @688704
      GIM_Reject,
    // Label 9560: @688705
    GIM_Reject,
    // Label 9541: @688706
    GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(689408),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_32RegClassID),
      GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(688808), // Rule ID 6808 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6808,
        GIR_EraseRootFromParent_Done,
      // Label 9574: @688808
      GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(688889), // Rule ID 6812 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET:{ *:[v2f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6812,
        GIR_EraseRootFromParent_Done,
      // Label 9575: @688889
      GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(688968), // Rule ID 6810 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6810,
        GIR_EraseRootFromParent_Done,
      // Label 9576: @688968
      GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(689047), // Rule ID 6814 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6814,
        GIR_EraseRootFromParent_Done,
      // Label 9577: @689047
      GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(689118), // Rule ID 6809 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6809,
        GIR_EraseRootFromParent_Done,
      // Label 9578: @689118
      GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(689189), // Rule ID 6813 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN:{ *:[v2f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6813,
        GIR_EraseRootFromParent_Done,
      // Label 9579: @689189
      GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(689298), // Rule ID 6811 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6811,
        GIR_EraseRootFromParent_Done,
      // Label 9580: @689298
      GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(689407), // Rule ID 6815 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN:{ *:[v2f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6815,
        GIR_EraseRootFromParent_Done,
      // Label 9581: @689407
      GIM_Reject,
    // Label 9573: @689408
    GIM_Reject,
    // Label 9542: @689409
    GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(689771),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
      GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(689511), // Rule ID 6780 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET:{ *:[v2i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6780,
        GIR_EraseRootFromParent_Done,
      // Label 9583: @689511
      GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(689590), // Rule ID 6782 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6782,
        GIR_EraseRootFromParent_Done,
      // Label 9584: @689590
      GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(689661), // Rule ID 6781 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN:{ *:[v2i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6781,
        GIR_EraseRootFromParent_Done,
      // Label 9585: @689661
      GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(689770), // Rule ID 6783 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v2i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN:{ *:[v2i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XY_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6783,
        GIR_EraseRootFromParent_Done,
      // Label 9586: @689770
      GIM_Reject,
    // Label 9582: @689771
    GIM_Reject,
    // Label 9543: @689772
    GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(690134),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_96RegClassID),
      GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(689874), // Rule ID 6784 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET:{ *:[v3i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6784,
        GIR_EraseRootFromParent_Done,
      // Label 9588: @689874
      GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(689953), // Rule ID 6786 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6786,
        GIR_EraseRootFromParent_Done,
      // Label 9589: @689953
      GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(690024), // Rule ID 6785 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN:{ *:[v3i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6785,
        GIR_EraseRootFromParent_Done,
      // Label 9590: @690024
      GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(690133), // Rule ID 6787 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v3i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN:{ *:[v3i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6787,
        GIR_EraseRootFromParent_Done,
      // Label 9591: @690133
      GIM_Reject,
    // Label 9587: @690134
    GIM_Reject,
    // Label 9544: @690135
    GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(691633),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(690244), // Rule ID 6816 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6816,
        GIR_EraseRootFromParent_Done,
      // Label 9593: @690244
      GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(690336), // Rule ID 6820 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6820,
        GIR_EraseRootFromParent_Done,
      // Label 9594: @690336
      GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(690421), // Rule ID 6824 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6824,
        GIR_EraseRootFromParent_Done,
      // Label 9595: @690421
      GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(690506), // Rule ID 6828 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET:{ *:[v4f16] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6828,
        GIR_EraseRootFromParent_Done,
      // Label 9596: @690506
      GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(690596), // Rule ID 6818 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6818,
        GIR_EraseRootFromParent_Done,
      // Label 9597: @690596
      GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(690686), // Rule ID 6822 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6822,
        GIR_EraseRootFromParent_Done,
      // Label 9598: @690686
      GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(690769), // Rule ID 6826 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6826,
        GIR_EraseRootFromParent_Done,
      // Label 9599: @690769
      GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(690852), // Rule ID 6830 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6830,
        GIR_EraseRootFromParent_Done,
      // Label 9600: @690852
      GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(690934), // Rule ID 6817 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6817,
        GIR_EraseRootFromParent_Done,
      // Label 9601: @690934
      GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(691016), // Rule ID 6821 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6821,
        GIR_EraseRootFromParent_Done,
      // Label 9602: @691016
      GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(691091), // Rule ID 6825 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6825,
        GIR_EraseRootFromParent_Done,
      // Label 9603: @691091
      GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(691166), // Rule ID 6829 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN:{ *:[v4f16] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6829,
        GIR_EraseRootFromParent_Done,
      // Label 9604: @691166
      GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(691286), // Rule ID 6819 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6819,
        GIR_EraseRootFromParent_Done,
      // Label 9605: @691286
      GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(691406), // Rule ID 6823 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(6),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))<<P:Predicate_anonymous_32816>>  =>  (TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZ_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6823,
        GIR_EraseRootFromParent_Done,
      // Label 9606: @691406
      GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(691519), // Rule ID 6827 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6827,
        GIR_EraseRootFromParent_Done,
      // Label 9607: @691519
      GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(691632), // Rule ID 6831 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_64RegClassID),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4f16] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN:{ *:[v4f16] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_VBUFFER_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6831,
        GIR_EraseRootFromParent_Done,
      // Label 9608: @691632
      GIM_Reject,
    // Label 9592: @691633
    GIM_Reject,
    // Label 9545: @691634
    GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(691996),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::AV_128RegClassID),
      GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(691736), // Rule ID 6788 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET:{ *:[v4i32] } SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFSET),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6788,
        GIR_EraseRootFromParent_Done,
      // Label 9610: @691736
      GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(691815), // Rule ID 6790 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_OFFEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6790,
        GIR_EraseRootFromParent_Done,
      // Label 9611: @691815
      GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(691886), // Rule ID 6789 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN:{ *:[v4i32] } VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_IDXEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6789,
        GIR_EraseRootFromParent_Done,
      // Label 9612: @691886
      GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(691995), // Rule ID 6791 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_load_d16:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN:{ *:[v4i32] } (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_LOAD_FORMAT_D16_XYZW_gfx80_BOTHEN),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdata]
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6791,
        GIR_EraseRootFromParent_Done,
      // Label 9613: @691995
      GIM_Reject,
    // Label 9609: @691996
    GIM_Reject,
    // Label 9546: @691997
    GIM_Reject,
    // Label 164: @691998
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(18), /*)*//*default:*//*Label 9618*/ GIMT_Encode4(697465),
    /*GILLT_s32*//*Label 9614*/ GIMT_Encode4(692045), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v2s32*//*Label 9615*/ GIMT_Encode4(693400), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9616*/ GIMT_Encode4(694755), GIMT_Encode4(0), GIMT_Encode4(0),
    /*GILLT_v4s32*//*Label 9617*/ GIMT_Encode4(696110),
    // Label 9614: @692045
    GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(693399),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(692143), // Rule ID 6832 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6832,
        GIR_EraseRootFromParent_Done,
      // Label 9620: @692143
      GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(692221), // Rule ID 6836 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6836,
        GIR_EraseRootFromParent_Done,
      // Label 9621: @692221
      GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(692302), // Rule ID 6864 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6864,
        GIR_EraseRootFromParent_Done,
      // Label 9622: @692302
      GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(692380), // Rule ID 6868 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6868,
        GIR_EraseRootFromParent_Done,
      // Label 9623: @692380
      GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(692459), // Rule ID 6834 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6834,
        GIR_EraseRootFromParent_Done,
      // Label 9624: @692459
      GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(692535), // Rule ID 6838 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6838,
        GIR_EraseRootFromParent_Done,
      // Label 9625: @692535
      GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(692614), // Rule ID 6866 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6866,
        GIR_EraseRootFromParent_Done,
      // Label 9626: @692614
      GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(692690), // Rule ID 6870 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6870,
        GIR_EraseRootFromParent_Done,
      // Label 9627: @692690
      GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(692761), // Rule ID 6833 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6833,
        GIR_EraseRootFromParent_Done,
      // Label 9628: @692761
      GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(692829), // Rule ID 6837 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6837,
        GIR_EraseRootFromParent_Done,
      // Label 9629: @692829
      GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(692900), // Rule ID 6865 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6865,
        GIR_EraseRootFromParent_Done,
      // Label 9630: @692900
      GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(692968), // Rule ID 6869 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6869,
        GIR_EraseRootFromParent_Done,
      // Label 9631: @692968
      GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(693077), // Rule ID 6835 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6835,
        GIR_EraseRootFromParent_Done,
      // Label 9632: @693077
      GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(693183), // Rule ID 6839 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6839,
        GIR_EraseRootFromParent_Done,
      // Label 9633: @693183
      GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(693292), // Rule ID 6867 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6867,
        GIR_EraseRootFromParent_Done,
      // Label 9634: @693292
      GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(693398), // Rule ID 6871 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store f32:{ *:[f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6871,
        GIR_EraseRootFromParent_Done,
      // Label 9635: @693398
      GIM_Reject,
    // Label 9619: @693399
    GIM_Reject,
    // Label 9615: @693400
    GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(694754),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(693498), // Rule ID 6840 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6840,
        GIR_EraseRootFromParent_Done,
      // Label 9637: @693498
      GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(693576), // Rule ID 6844 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6844,
        GIR_EraseRootFromParent_Done,
      // Label 9638: @693576
      GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(693657), // Rule ID 6872 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6872,
        GIR_EraseRootFromParent_Done,
      // Label 9639: @693657
      GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(693735), // Rule ID 6876 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v2f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6876,
        GIR_EraseRootFromParent_Done,
      // Label 9640: @693735
      GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(693814), // Rule ID 6842 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6842,
        GIR_EraseRootFromParent_Done,
      // Label 9641: @693814
      GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(693890), // Rule ID 6846 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6846,
        GIR_EraseRootFromParent_Done,
      // Label 9642: @693890
      GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(693969), // Rule ID 6874 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6874,
        GIR_EraseRootFromParent_Done,
      // Label 9643: @693969
      GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(694045), // Rule ID 6878 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6878,
        GIR_EraseRootFromParent_Done,
      // Label 9644: @694045
      GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(694116), // Rule ID 6841 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6841,
        GIR_EraseRootFromParent_Done,
      // Label 9645: @694116
      GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(694184), // Rule ID 6845 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6845,
        GIR_EraseRootFromParent_Done,
      // Label 9646: @694184
      GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(694255), // Rule ID 6873 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6873,
        GIR_EraseRootFromParent_Done,
      // Label 9647: @694255
      GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(694323), // Rule ID 6877 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6877,
        GIR_EraseRootFromParent_Done,
      // Label 9648: @694323
      GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(694432), // Rule ID 6843 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6843,
        GIR_EraseRootFromParent_Done,
      // Label 9649: @694432
      GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(694538), // Rule ID 6847 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6847,
        GIR_EraseRootFromParent_Done,
      // Label 9650: @694538
      GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(694647), // Rule ID 6875 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6875,
        GIR_EraseRootFromParent_Done,
      // Label 9651: @694647
      GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(694753), // Rule ID 6879 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v2f32:{ *:[v2f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v2f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6879,
        GIR_EraseRootFromParent_Done,
      // Label 9652: @694753
      GIM_Reject,
    // Label 9636: @694754
    GIM_Reject,
    // Label 9616: @694755
    GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(696109),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(694853), // Rule ID 6848 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6848,
        GIR_EraseRootFromParent_Done,
      // Label 9654: @694853
      GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(694931), // Rule ID 6852 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6852,
        GIR_EraseRootFromParent_Done,
      // Label 9655: @694931
      GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(695012), // Rule ID 6880 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6880,
        GIR_EraseRootFromParent_Done,
      // Label 9656: @695012
      GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(695090), // Rule ID 6884 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact anonymous_9449:{ *:[v3f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6884,
        GIR_EraseRootFromParent_Done,
      // Label 9657: @695090
      GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(695169), // Rule ID 6850 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6850,
        GIR_EraseRootFromParent_Done,
      // Label 9658: @695169
      GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(695245), // Rule ID 6854 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6854,
        GIR_EraseRootFromParent_Done,
      // Label 9659: @695245
      GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(695324), // Rule ID 6882 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6882,
        GIR_EraseRootFromParent_Done,
      // Label 9660: @695324
      GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(695400), // Rule ID 6886 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6886,
        GIR_EraseRootFromParent_Done,
      // Label 9661: @695400
      GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(695471), // Rule ID 6849 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6849,
        GIR_EraseRootFromParent_Done,
      // Label 9662: @695471
      GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(695539), // Rule ID 6853 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6853,
        GIR_EraseRootFromParent_Done,
      // Label 9663: @695539
      GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(695610), // Rule ID 6881 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6881,
        GIR_EraseRootFromParent_Done,
      // Label 9664: @695610
      GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(695678), // Rule ID 6885 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6885,
        GIR_EraseRootFromParent_Done,
      // Label 9665: @695678
      GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(695787), // Rule ID 6851 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6851,
        GIR_EraseRootFromParent_Done,
      // Label 9666: @695787
      GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(695893), // Rule ID 6855 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6855,
        GIR_EraseRootFromParent_Done,
      // Label 9667: @695893
      GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(696002), // Rule ID 6883 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6883,
        GIR_EraseRootFromParent_Done,
      // Label 9668: @696002
      GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(696108), // Rule ID 6887 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v3f32:{ *:[v3f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact anonymous_9449:{ *:[v3f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZ_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6887,
        GIR_EraseRootFromParent_Done,
      // Label 9669: @696108
      GIM_Reject,
    // Label 9653: @696109
    GIM_Reject,
    // Label 9617: @696110
    GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(697464),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(696208), // Rule ID 6856 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6856,
        GIR_EraseRootFromParent_Done,
      // Label 9671: @696208
      GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(696286), // Rule ID 6860 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6860,
        GIR_EraseRootFromParent_Done,
      // Label 9672: @696286
      GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(696367), // Rule ID 6888 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6888,
        GIR_EraseRootFromParent_Done,
      // Label 9673: @696367
      GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(696445), // Rule ID 6892 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact anonymous_9448:{ *:[v4f32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6892,
        GIR_EraseRootFromParent_Done,
      // Label 9674: @696445
      GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(696524), // Rule ID 6858 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6858,
        GIR_EraseRootFromParent_Done,
      // Label 9675: @696524
      GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(696600), // Rule ID 6862 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6862,
        GIR_EraseRootFromParent_Done,
      // Label 9676: @696600
      GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(696679), // Rule ID 6890 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6890,
        GIR_EraseRootFromParent_Done,
      // Label 9677: @696679
      GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(696755), // Rule ID 6894 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6894,
        GIR_EraseRootFromParent_Done,
      // Label 9678: @696755
      GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(696826), // Rule ID 6857 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6857,
        GIR_EraseRootFromParent_Done,
      // Label 9679: @696826
      GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(696894), // Rule ID 6861 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6861,
        GIR_EraseRootFromParent_Done,
      // Label 9680: @696894
      GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(696965), // Rule ID 6889 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6889,
        GIR_EraseRootFromParent_Done,
      // Label 9681: @696965
      GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(697033), // Rule ID 6893 //
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6893,
        GIR_EraseRootFromParent_Done,
      // Label 9682: @697033
      GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(697142), // Rule ID 6859 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6859,
        GIR_EraseRootFromParent_Done,
      // Label 9683: @697142
      GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(697248), // Rule ID 6863 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6863,
        GIR_EraseRootFromParent_Done,
      // Label 9684: @697248
      GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(697357), // Rule ID 6891 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6891,
        GIR_EraseRootFromParent_Done,
      // Label 9685: @697357
      GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(697463), // Rule ID 6895 //
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store v4f32:{ *:[v4f32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact anonymous_9448:{ *:[v4f32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6895,
        GIR_EraseRootFromParent_Done,
      // Label 9686: @697463
      GIM_Reject,
    // Label 9670: @697464
    GIM_Reject,
    // Label 9618: @697465
    GIM_Reject,
    // Label 165: @697466
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(18), /*)*//*default:*//*Label 9694*/ GIMT_Encode4(702070),
    /*GILLT_s16*//*Label 9687*/ GIMT_Encode4(697517),
    /*GILLT_s32*//*Label 9688*/ GIMT_Encode4(698556), GIMT_Encode4(0),
    /*GILLT_v2s16*//*Label 9689*/ GIMT_Encode4(699595),
    /*GILLT_v2s32*//*Label 9690*/ GIMT_Encode4(700294), GIMT_Encode4(0),
    /*GILLT_v3s32*//*Label 9691*/ GIMT_Encode4(700653), GIMT_Encode4(0),
    /*GILLT_v4s16*//*Label 9692*/ GIMT_Encode4(701012),
    /*GILLT_v4s32*//*Label 9693*/ GIMT_Encode4(701711),
    // Label 9687: @697517
    GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(698555),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(697615), // Rule ID 6896 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6896,
        GIR_EraseRootFromParent_Done,
      // Label 9696: @697615
      GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(697696), // Rule ID 6916 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6916,
        GIR_EraseRootFromParent_Done,
      // Label 9697: @697696
      GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(697777), // Rule ID 6920 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6920,
        GIR_EraseRootFromParent_Done,
      // Label 9698: @697777
      GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(697856), // Rule ID 6898 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6898,
        GIR_EraseRootFromParent_Done,
      // Label 9699: @697856
      GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(697935), // Rule ID 6918 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6918,
        GIR_EraseRootFromParent_Done,
      // Label 9700: @697935
      GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(698014), // Rule ID 6922 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6922,
        GIR_EraseRootFromParent_Done,
      // Label 9701: @698014
      GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(698085), // Rule ID 6897 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6897,
        GIR_EraseRootFromParent_Done,
      // Label 9702: @698085
      GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(698156), // Rule ID 6917 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6917,
        GIR_EraseRootFromParent_Done,
      // Label 9703: @698156
      GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(698227), // Rule ID 6921 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6921,
        GIR_EraseRootFromParent_Done,
      // Label 9704: @698227
      GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(698336), // Rule ID 6899 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6899,
        GIR_EraseRootFromParent_Done,
      // Label 9705: @698336
      GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(698445), // Rule ID 6919 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6919,
        GIR_EraseRootFromParent_Done,
      // Label 9706: @698445
      GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(698554), // Rule ID 6923 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 f16:{ *:[f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6923,
        GIR_EraseRootFromParent_Done,
      // Label 9707: @698554
      GIM_Reject,
    // Label 9695: @698555
    GIM_Reject,
    // Label 9688: @698556
    GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(699594),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(698654), // Rule ID 6900 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6900,
        GIR_EraseRootFromParent_Done,
      // Label 9709: @698654
      GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(698735), // Rule ID 6924 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6924,
        GIR_EraseRootFromParent_Done,
      // Label 9710: @698735
      GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(698816), // Rule ID 6928 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact anonymous_9451:{ *:[i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6928,
        GIR_EraseRootFromParent_Done,
      // Label 9711: @698816
      GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(698895), // Rule ID 6902 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6902,
        GIR_EraseRootFromParent_Done,
      // Label 9712: @698895
      GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(698974), // Rule ID 6926 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6926,
        GIR_EraseRootFromParent_Done,
      // Label 9713: @698974
      GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(699053), // Rule ID 6930 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6930,
        GIR_EraseRootFromParent_Done,
      // Label 9714: @699053
      GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(699124), // Rule ID 6901 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6901,
        GIR_EraseRootFromParent_Done,
      // Label 9715: @699124
      GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(699195), // Rule ID 6925 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6925,
        GIR_EraseRootFromParent_Done,
      // Label 9716: @699195
      GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(699266), // Rule ID 6929 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact anonymous_9451:{ *:[i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6929,
        GIR_EraseRootFromParent_Done,
      // Label 9717: @699266
      GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(699375), // Rule ID 6903 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6903,
        GIR_EraseRootFromParent_Done,
      // Label 9718: @699375
      GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(699484), // Rule ID 6927 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6927,
        GIR_EraseRootFromParent_Done,
      // Label 9719: @699484
      GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(699593), // Rule ID 6931 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 i32:{ *:[i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_X_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6931,
        GIR_EraseRootFromParent_Done,
      // Label 9720: @699593
      GIM_Reject,
    // Label 9708: @699594
    GIM_Reject,
    // Label 9689: @699595
    GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(700293),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(699693), // Rule ID 6932 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6932,
        GIR_EraseRootFromParent_Done,
      // Label 9722: @699693
      GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(699774), // Rule ID 6936 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact anonymous_9451:{ *:[v2f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6936,
        GIR_EraseRootFromParent_Done,
      // Label 9723: @699774
      GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(699853), // Rule ID 6934 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6934,
        GIR_EraseRootFromParent_Done,
      // Label 9724: @699853
      GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(699932), // Rule ID 6938 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6938,
        GIR_EraseRootFromParent_Done,
      // Label 9725: @699932
      GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(700003), // Rule ID 6933 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6933,
        GIR_EraseRootFromParent_Done,
      // Label 9726: @700003
      GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(700074), // Rule ID 6937 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6937,
        GIR_EraseRootFromParent_Done,
      // Label 9727: @700074
      GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(700183), // Rule ID 6935 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6935,
        GIR_EraseRootFromParent_Done,
      // Label 9728: @700183
      GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(700292), // Rule ID 6939 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2f16:{ *:[v2f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact anonymous_9451:{ *:[v2f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6939,
        GIR_EraseRootFromParent_Done,
      // Label 9729: @700292
      GIM_Reject,
    // Label 9721: @700293
    GIM_Reject,
    // Label 9690: @700294
    GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(700652),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(700392), // Rule ID 6904 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact anonymous_9450:{ *:[v2i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6904,
        GIR_EraseRootFromParent_Done,
      // Label 9731: @700392
      GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(700471), // Rule ID 6906 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6906,
        GIR_EraseRootFromParent_Done,
      // Label 9732: @700471
      GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(700542), // Rule ID 6905 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6905,
        GIR_EraseRootFromParent_Done,
      // Label 9733: @700542
      GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(700651), // Rule ID 6907 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v2i32:{ *:[v2i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact anonymous_9450:{ *:[v2i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XY_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6907,
        GIR_EraseRootFromParent_Done,
      // Label 9734: @700651
      GIM_Reject,
    // Label 9730: @700652
    GIM_Reject,
    // Label 9691: @700653
    GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(701011),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(700751), // Rule ID 6908 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact anonymous_9449:{ *:[v3i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6908,
        GIR_EraseRootFromParent_Done,
      // Label 9736: @700751
      GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(700830), // Rule ID 6910 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6910,
        GIR_EraseRootFromParent_Done,
      // Label 9737: @700830
      GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(700901), // Rule ID 6909 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6909,
        GIR_EraseRootFromParent_Done,
      // Label 9738: @700901
      GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(701010), // Rule ID 6911 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v3i32:{ *:[v3i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact anonymous_9449:{ *:[v3i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZ_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6911,
        GIR_EraseRootFromParent_Done,
      // Label 9739: @701010
      GIM_Reject,
    // Label 9735: @701011
    GIM_Reject,
    // Label 9692: @701012
    GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(701710),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(701110), // Rule ID 6948 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6948,
        GIR_EraseRootFromParent_Done,
      // Label 9741: @701110
      GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(701191), // Rule ID 6952 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact anonymous_9450:{ *:[v4f16] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6952,
        GIR_EraseRootFromParent_Done,
      // Label 9742: @701191
      GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(701270), // Rule ID 6950 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6950,
        GIR_EraseRootFromParent_Done,
      // Label 9743: @701270
      GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(701349), // Rule ID 6954 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6954,
        GIR_EraseRootFromParent_Done,
      // Label 9744: @701349
      GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(701420), // Rule ID 6949 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6949,
        GIR_EraseRootFromParent_Done,
      // Label 9745: @701420
      GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(701491), // Rule ID 6953 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6953,
        GIR_EraseRootFromParent_Done,
      // Label 9746: @701491
      GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(701600), // Rule ID 6951 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem_HasUnrestrictedSOffset),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6951,
        GIR_EraseRootFromParent_Done,
      // Label 9747: @701600
      GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(701709), // Rule ID 6955 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4f16:{ *:[v4f16] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact anonymous_9450:{ *:[v4f16] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_VBUFFER_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6955,
        GIR_EraseRootFromParent_Done,
      // Label 9748: @701709
      GIM_Reject,
    // Label 9740: @701710
    GIM_Reject,
    // Label 9693: @701711
    GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(702069),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
      GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(701809), // Rule ID 6912 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact anonymous_9448:{ *:[v4i32] }:$vdata, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFSET_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6912,
        GIR_EraseRootFromParent_Done,
      // Label 9750: @701809
      GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(701888), // Rule ID 6914 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckLiteralInt, /*MI*/0, /*Op*/8, GIMT_Encode8(0),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, 0:{ *:[i32] }, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, 0:{ *:[i1] })  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$voffset, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_OFFEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/3, // voffset
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6914,
        GIR_EraseRootFromParent_Done,
      // Label 9751: @701888
      GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(701959), // Rule ID 6913 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, 0:{ *:[i32] }, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, VGPR_32:{ *:[i32] }:$vindex, SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_IDXEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_RootToRootCopy, /*OpIdx*/2, // vindex
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6913,
        GIR_EraseRootFromParent_Done,
      // Label 9752: @701959
      GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(702068), // Rule ID 6915 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUnpackedD16VMem),
        // MIs[0] offset
        GIM_CheckIsImm, /*MI*/0, /*Op*/5,
        // MIs[0] format
        GIM_CheckIsImm, /*MI*/0, /*Op*/6,
        // MIs[0] auxiliary
        GIM_CheckIsImm, /*MI*/0, /*Op*/7,
        // MIs[0] Operand 8
        GIM_CheckIsImm, /*MI*/0, /*Op*/8,
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_buf_soffset),
        // (SItbuffer_store_d16 v4i32:{ *:[v4i32] }:$vdata, v4i32:{ *:[v4i32] }:$rsrc, i32:{ *:[i32] }:$vindex, i32:{ *:[i32] }:$voffset, (BUFSOffset:{ *:[i32] } i32:{ *:[i32] }:$soffset), (timm:{ *:[i32] }):$offset, (timm:{ *:[i32] }):$format, (timm:{ *:[i32] }):$auxiliary, (timm:{ *:[i1] }))  =>  (TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact anonymous_9448:{ *:[v4i32] }:$vdata, (REG_SEQUENCE:{ *:[i64] } VReg_64:{ *:[i32] }, VGPR_32:{ *:[i32] }:$vindex, sub0:{ *:[i32] }, VGPR_32:{ *:[i32] }:$voffset, sub1:{ *:[i32] }), SReg_128:{ *:[v4i32] }:$rsrc, SCSrc_b32:{ *:[i32] }:$soffset, (timm:{ *:[i32] }):$offset, (as_i8timm:{ *:[i8] } ?:{ *:[i32] }:$format), (extract_cpol:{ *:[i32] } ?:{ *:[i32] }:$auxiliary), (extract_swz:{ *:[i1] } ?:{ *:[i32] }:$auxiliary))
        GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
        GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
        GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vindex
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
        GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // voffset
        GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/11,
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AMDGPU::VReg_64RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::TBUFFER_STORE_FORMAT_D16_XYZW_gfx80_BOTHEN_exact),
        GIR_RootToRootCopy, /*OpIdx*/0, // vdata
        GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
        GIR_RootToRootCopy, /*OpIdx*/1, // rsrc
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // soffset
        GIR_RootToRootCopy, /*OpIdx*/5, // offset
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/6, /*OperandRenderer*/GIMT_Encode2(GICR_renderTruncTImm), // format
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractCPol), // auxiliary
        GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/7, /*OperandRenderer*/GIMT_Encode2(GICR_renderExtractSWZ), // auxiliary
        GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 6915,
        GIR_EraseRootFromParent_Done,
      // Label 9753: @702068
      GIM_Reject,
    // Label 9749: @702069
    GIM_Reject,
    // Label 9694: @702070
    GIM_Reject,
    // Label 166: @702071
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(10), /*)*//*default:*//*Label 9756*/ GIMT_Encode4(702376),
    /*GILLT_s16*//*Label 9754*/ GIMT_Encode4(702090),
    /*GILLT_s32*//*Label 9755*/ GIMT_Encode4(702334),
    // Label 9754: @702090
    GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(702333),
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
      GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(702180), // Rule ID 1019 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotHasTrue16BitInsts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1019,
        GIR_EraseRootFromParent_Done,
      // Label 9758: @702180
      GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(702256), // Rule ID 1020 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseRealTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_16RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_t16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_t16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1020,
        GIR_EraseRootFromParent_Done,
      // Label 9759: @702256
      GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(702332), // Rule ID 1021 //
        GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseFakeTrue16Insts_isGFX9Plus),
        GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_vop3opselmods),
        GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_vop3opselmods),
        // (AMDGPUumed3:{ *:[i16] } (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src0_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src1_modifiers), (VOP3OpSelMods:{ *:[i16] } i16:{ *:[i16] }:$src2, i32:{ *:[i32] }:$src2_modifiers))  =>  (V_MED3_U16_fake16_e64:{ *:[i16] } i32:{ *:[i32] }:$src0_modifiers, i16:{ *:[i16] }:$src0, i32:{ *:[i32] }:$src1_modifiers, i16:{ *:[i16] }:$src1, i32:{ *:[i32] }:$src2_modifiers, i16:{ *:[i16] }:$src2)
        GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U16_fake16_e64),
        GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // src0_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/1, // src1_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // src1
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/1, // src2_modifiers
        GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // src2
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
        GIR_RootConstrainSelectedInstOperands,
        // GIR_Coverage, 1021,
        GIR_EraseRootFromParent_Done,
      // Label 9760: @702332
      GIM_Reject,
    // Label 9757: @702333
    GIM_Reject,
    // Label 9755: @702334
    GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(702375), // Rule ID 964 //
      GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
      GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
      GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AMDGPU::VGPR_32RegClassID),
      GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_vop3mods0),
      // (AMDGPUumed3:{ *:[i32] } (VOP3Mods0:{ *:[i32] } i32:{ *:[i32] }:$src0), i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)  =>  (V_MED3_U32_e64:{ *:[i32] } i32:{ *:[i32] }:$src0, i32:{ *:[i32] }:$src1, i32:{ *:[i32] }:$src2)
      GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AMDGPU::V_MED3_U32_e64),
      GIR_RootToRootCopy, /*OpIdx*/0, // DstI[vdst]
      GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // src0
      GIR_RootToRootCopy, /*OpIdx*/2, // src1
      GIR_RootToRootCopy, /*OpIdx*/3, // src2
      GIR_RootConstrainSelectedInstOperands,
      // GIR_Coverage, 964,
      GIR_EraseRootFromParent_Done,
    // Label 9761: @702375
    GIM_Reject,
    // Label 9756: @702376
    GIM_Reject,
    // Label 167: @702377
    GIM_Reject,
    }; // Size: 702378 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
